-- already in pmo_sqlprep.h : #include "pmodefines.h"

-- already in stdafx.h : #include <math.h>

--#define NUMBER_OF_YEARS  20

Prompt == FUNCTION isZero ==
CREATE OR REPLACE FUNCTION isZero
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   i PLS_INTEGER;
BEGIN
   i := 0;
   WHILE i < count001 LOOP
      If cf(i + 1) <> 0.00 Then
         RETURN 0;
      End If;
         i := i + 1;
   END LOOP;
   
   RETURN 1;
END;
/
SHOW ERRORS FUNCTION isZero;
ALTER FUNCTION isZero COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION isNeg ==
CREATE OR REPLACE FUNCTION isNeg
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   i PLS_INTEGER;
BEGIN
   If cf(1) < 0.00 Then
      i := 1;
      WHILE i < count001 LOOP
         If cf(i + 1) > 0.00 Then
            RETURN 0;
         End If;
               i := i + 1;
      END LOOP;
   End If;
   
   RETURN 1;
END;
/
SHOW ERRORS FUNCTION isNeg;
ALTER FUNCTION isNeg COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION npv ==
CREATE OR REPLACE FUNCTION npv
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
   , rate NUMBER
) RETURN NUMBER
AS
   i PLS_INTEGER;
   r NUMBER NOT NULL := 0.0;
BEGIN
   i := 0;
   WHILE i < count001 LOOP
      r := r + cf(i + 1) / Power((1 + rate), i);
         i := i + 1;
   END LOOP;
   
   RETURN r;
END;
/
SHOW ERRORS FUNCTION npv;
ALTER FUNCTION npv COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION irr ==
CREATE OR REPLACE FUNCTION irr
(
     cf PMO_ARRAYS.NUMBER_M20
   , count001 PLS_INTEGER
) RETURN NUMBER
AS
   i PLS_INTEGER NOT NULL := 0;
   rate NUMBER NOT NULL := 0.10;
   inc NUMBER NOT NULL := 0.01;
   v NUMBER NOT NULL := 0.00;
BEGIN
   --10%
   --1%
   
   If isZero(cf, count001) <> 0 Then
      RETURN 0.00;
   End If;
   
   If isNeg(cf, count001) <> 0 Then
      RETURN 0.00;
   End If;
   
   --get the npv at 10%
   v := npv(cf, count001, rate);
   
   If (v < 0.00) AND (v > npv(cf, count001, 0.11)) Then
      inc := -inc;
   End If;
   
   i := 50;
   WHILE i > 0 LOOP
      rate := rate + inc;
      
      v := npv(cf, count001, rate);
      
      If v > 0.0 AND v < 0.005 Then
         EXIT;
      ElsIf (inc > 0.0 AND v < 0.0) OR (inc < 0.0 AND v > 0.0) Then
         rate := rate - inc;
         inc := inc * 0.5;
      Else
         inc := inc * 2.0;
      End If;
         i := i - 1;
   END LOOP;
   
   RETURN rate;
END;
/
SHOW ERRORS FUNCTION irr;
ALTER FUNCTION irr COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION roi ==
CREATE OR REPLACE FUNCTION roi
(
     cost NUMBER
   , revenue NUMBER
) RETURN NUMBER
AS
BEGIN
   If cost <> 0.00 Then
      RETURN (revenue - cost) / cost;
   Else
      RETURN 0.00;
   End If;
END;
/
SHOW ERRORS FUNCTION roi;
ALTER FUNCTION roi COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_INIT_PROJECTS
(
     h_ids IN OUT NOCOPY VARCHAR2
   , sh_h_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_id VARCHAR2(32);
   h_p_id VARCHAR2(32);
   h_p_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_discount_rate PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CRPT1 IS
         SELECT ELEMENT_ID, RANK
         FROM PMO_FINANCIAL_PORTFOLIOS
         ORDER BY RANK;

      CURSOR CIFP IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_FINANCIAL_TMP_PROJECTS
         ORDER BY RANK;

      CURSOR CDDD1 IS
         SELECT DISCOUNT_PERCENT
         FROM TMT_WBS W
         JOIN PROJECT_DISCOUNT PD
         ON PD.PROJECT_ID = W.ELEMENT_ID
         AND PMO_ORASTD.YEAR(PD.DISCOUNT_DATE) = PMO_ORASTD.YEAR(W.START_DT)
         WHERE W.ELEMENT_ID = h_p_id
         ORDER BY PD.DISCOUNT_DATE;

      CURSOR C_TP_PROJECT IS
         SELECT P.PROJECT_ID
         FROM TIMEPHASED_PROJECT P
         WHERE P.PROJECT_ID IN (SELECT PROJECT_ID FROM PMO_FINANCIAL_PROJECTS)
         AND P.FLAG = 'X';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PROJECTS(' || 
       '''' || h_ids || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PROJECTS', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PROJECTS(56) : views_financial.sql(215) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_PORTFOLIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_TMP_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --PROJECT
   If Coalesce(h_type, 0) = 5 Then
      --This is only use for version 6+
      NULL;
   Else
      If (Coalesce(h_type, 0) = 1) OR (Coalesce(h_type, 0) = 3) OR (h_ids IS NULL) Then
         If h_ids IS NULL Then
            h_id := NULL;
            h_rank := '0000';
            PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_rec_user, h_id, h_rank, h_type);
            
            BEGIN
               INSERT INTO PMO_FINANCIAL_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
               SELECT RANK, ELEMENT_ID, ELEMENT_NAME
               FROM PMO_TMP_PROJECTS_01;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 106+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(107) : views_financial.sql(266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PMO_FINANCIAL_TMP_PROJECTS (ELEMENT_ID, RANK, ELEMENT_NAME)
               SELECT P.ELEMENT_ID, RTRIM(P.RANK), RTRIM(P.ELEMENT_NAME)
               FROM RESOURCES R 
               JOIN TMT_WBS_ATTRIBUTES RA 
               ON RA.ELEMENT_ID = R.RESOURCE_ID
               AND RA.TYPE_ID = PMO_CNST.SC_RESOURCE
               AND RA.LOCAL = 'N'
               JOIN TMT_WBS_ATTRIBUTES A 
               ON A.ELEMENT_ID = RA.PARENT_ID 
               AND A.LOCAL = 'N'
               JOIN TMT_WBS_ATTRIBUTES PA 
               ON PA.RANK > A.RANK
               AND LENGTH(PA.RANK) > LENGTH(A.RANK) 
               AND PMO_ORASTD.LEFT(PA.RANK, LENGTH(A.RANK)) = A.RANK 
               AND PA.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) 
               AND PA.LOCAL = 'N'
               JOIN TMT_WBS P 
               ON P.ELEMENT_ID = PA.ELEMENT_ID 
               AND P.REC_STATUS <> 'D' 
               WHERE R.RESOURCE_ID = h_rec_user 
               AND R.EXECUTIVE_SECURITY IS NOT NULL
               GROUP BY P.ELEMENT_ID, RTRIM(P.RANK), RTRIM(P.ELEMENT_NAME);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 144+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(145) : views_financial.sql(304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --Bring all the projects from TMT_PORTFOLIOS folder
            BEGIN
               SELECT RTRIM(RANK) INTO h_res_rank
               FROM TMT_PORTFOLIOS
               WHERE ELEMENT_ID = h_rec_user;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 160+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(161) : views_financial.sql(320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_total := 0;
            h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
            If Coalesce(h_total, 0) < 1 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PROJECTS', 169+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PROJECTS(170) : views_financial.sql(329) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.INVALID_PARAMS;
            End If;
            
            h_count := 0;
            WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
               h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
               
               BEGIN
                  SELECT RTRIM(RANK) INTO h_rank
                  FROM TMT_PORTFOLIOS
                  WHERE RANK LIKE h_res_rank || '%'
                  AND ELEMENT_ID = h_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 189+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(190) : views_financial.sql(349) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  INSERT INTO PMO_FINANCIAL_PORTFOLIOS( ELEMENT_ID, RANK )
                  SELECT ELEMENT_ID, RTRIM(RANK)
                  FROM TMT_PORTFOLIOS
                  WHERE RANK LIKE h_rank || '%'
                  AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
                  AND REC_STATUS <> 'D';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 211+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(212) : views_financial.sql(371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               h_count := Coalesce(h_count, 0) + 1;
            END LOOP;
            
            --Finding the matching project rank from TMT_WBS
            
            OPEN CRPT1;
            
            LOOP
               FETCH CRPT1 INTO h_p_id, h_p_rank;
               IF CRPT1%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               BEGIN
                  INSERT INTO PMO_FINANCIAL_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
                  SELECT RTRIM(W.RANK), W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME)
                  FROM TMT_PORTFOLIOS P
                  JOIN TMT_WBS W
                  ON W.ELEMENT_ID = P.ELEMENT_ID
                  WHERE P.RANK = h_p_rank
                  AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
                  AND P.REC_STATUS <> 'D';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 252+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(253) : views_financial.sql(412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            END LOOP;
            
            BEGIN
               CLOSE CRPT1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 266+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(267) : views_financial.sql(426) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      ElsIf (Coalesce(h_type, 0) = 2) OR (Coalesce(h_type, 0) = 4) Then
         --PROJECT Type
         h_total := 0;
         h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
         If Coalesce(h_total, 0) < 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PROJECTS', 277+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PROJECTS(278) : views_financial.sql(437) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_PARAMS;
         End If;
         
         h_count := 0;
         WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
            h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
            
            BEGIN
               INSERT INTO PMO_FINANCIAL_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
               SELECT RTRIM(RANK), ELEMENT_ID, RTRIM(ELEMENT_NAME)
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 301+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(302) : views_financial.sql(461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_count := Coalesce(h_count, 0) + 1;
         END LOOP;
      End If;
      
      --Cleaning----------------------------------------------------
      --Leave only the root projects from different project branches
      BEGIN
         DELETE FROM PMO_FINANCIAL_TMP_PROJECTS
         WHERE ELEMENT_ID IN (
         SELECT B.ELEMENT_ID
         FROM PMO_FINANCIAL_TMP_PROJECTS A, PMO_FINANCIAL_TMP_PROJECTS B
         WHERE A.RANK < B.RANK
         AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
         AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 329+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(330) : views_financial.sql(489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --Cleaning----------------------------------------------------
      
      OPEN CIFP;
      
      LOOP
         FETCH CIFP INTO h_p_id, h_p_rank;
         IF CIFP%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         OPEN CDDD1;
         
         FETCH CDDD1 INTO h_discount_rate;
         IF CDDD1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
            h_discount_rate := 0;
         End If;
         
         BEGIN
            CLOSE CDDD1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 369+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(370) : views_financial.sql(529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_FINANCIAL_PROJECTS
            SELECT  DISTINCT
            W.ELEMENT_ID,
            RTRIM(W.RANK),
            W.ELEMENT_NAME,
            TO_DATE(SubStr(W.START_DT, 1, 10)),
            TO_DATE(SubStr(W.FINISH_DT, 1, 10)),
            TO_DATE(SubStr(W.PROPOSED_START, 1, 10)),
            TO_DATE(SubStr(W.PROPOSED_FINISH, 1, 10)),
            TO_DATE(SubStr(W.PROPOSED_START, 1, 10)),
            TO_DATE(SubStr(W.PROPOSED_FINISH, 1, 10)),
            TO_DATE(SubStr(W.UNRESOLVED_START, 1, 10)),
            TO_DATE(SubStr(W.UNRESOLVED_FINISH, 1, 10)),
            TO_DATE(SubStr(W.BASELINE1_START, 1, 10)),
            TO_DATE(SubStr(W.BASELINE1_FINISH, 1, 10)),
            TO_DATE(SubStr(W.BASELINE3_START, 1, 10)),
            TO_DATE(SubStr(W.BASELINE3_FINISH, 1, 10)),
            TO_DATE(SubStr(W.ACTUAL_START, 1, 10)),
            TO_DATE(SubStr(W.ACTUAL_FINISH, 1, 10)),
            h_discount_rate
            FROM TMT_WBS W
            WHERE W.RANK LIKE h_p_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND W.REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 409+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(410) : views_financial.sql(569) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE CIFP ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 423+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(424) : views_financial.sql(583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      UPDATE TIMEPHASED_PROJECT P
      SET P.FLAG = 'X'
      WHERE P.PROJECT_ID IN (SELECT PROJECT_ID FROM PMO_FINANCIAL_PROJECTS)
      AND P.FLAG = 'I';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 444+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(445) : views_financial.sql(604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TP_PROJECT;
   
   LOOP
      FETCH C_TP_PROJECT INTO h_id;
      IF C_TP_PROJECT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         EXIT;
      End If;
      
      PMO_DB2M.SC_STATE := FC_Rollup_Timephase(h_id);
      PMO_DB2M.SC_STATE := FC_Timephase_CRI_Task(h_id);
      
      COMMIT;
   END LOOP;
   BEGIN
      CLOSE C_TP_PROJECT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 476+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(477) : views_financial.sql(636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM TIMEPHASED_PROJECT WHERE FLAG = 'X';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PROJECTS', 493+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PROJECTS(494) : views_financial.sql(653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PROJECTS', 500+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PROJECTS(501) : views_financial.sql(660) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PROJECTS;
ALTER FUNCTION FC_INIT_PROJECTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_CHARGECODES ==
CREATE OR REPLACE FUNCTION FC_INIT_CHARGECODES RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_p_id VARCHAR2(32);
   h_p_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_CHARGECODES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_CHARGECODES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_CHARGECODES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CHARGECODES', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_CHARGECODES(15) : views_financial.sql(685) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_CC';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Populate the list of chargecodes
   --EXPECTED
   BEGIN
      INSERT INTO PMO_FINANCIAL_CC (
      PROJECT_ID,
      ELEMENT_ID,
      ELEMENT_TYPE,
      START_DATE,
      FINISH_DATE,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      LABOR_FLAG,
      BILLABLE,
      STATE_TYPE,
      STATE_DAYS,
      STATE_TOTAL_COST,
      STATE_DAILY_COST,
      STATE_TOTAL_REVENUE,
      STATE_DAILY_REVENUE )
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_PROJECT_TYPE,
      P.START_DATE,
      P.FINISH_DATE,
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_EXPECTED_TYPE,
      ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1),
      B.ESTIMATED_BUDGET,
      (B.ESTIMATED_BUDGET / ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1)),
      COALESCE(AB.ESTIMATED_BUDGET, 0.00),
      COALESCE((AB.ESTIMATED_BUDGET / ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ELEMENT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      LEFT JOIN BUDGETS AB
      ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
      UNION ALL
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_PROJECT_TYPE,
      P.START_DATE,
      P.FINISH_DATE,
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_EXPECTED_TYPE,
      ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1),
      0.00,
      0.00,
      COALESCE(B.ESTIMATED_BUDGET, 0.00),
      COALESCE((B.ESTIMATED_BUDGET / ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ELEMENT_ID = P.ELEMENT_ID
      AND B.ASSOCIATE_BUDGET_ID IS NULL
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_BENEFIT);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CHARGECODES', 107+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CHARGECODES(108) : views_financial.sql(778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --BASELINE
   BEGIN
      INSERT INTO PMO_FINANCIAL_CC (
      PROJECT_ID,
      ELEMENT_ID,
      ELEMENT_TYPE,
      START_DATE,
      FINISH_DATE,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      LABOR_FLAG,
      BILLABLE,
      STATE_TYPE,
      STATE_DAYS,
      STATE_TOTAL_COST,
      STATE_DAILY_COST,
      STATE_TOTAL_REVENUE,
      STATE_DAILY_REVENUE )
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_PROJECT_TYPE,
      P.START_DATE,
      P.FINISH_DATE,
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_ESTIMATED_BASELINE1,
      ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1),
      B.BUDGET_BASELINE1,
      (B.BUDGET_BASELINE1 / ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1)),
      COALESCE(AB.BUDGET_BASELINE1, 0.00),
      COALESCE((AB.BUDGET_BASELINE1 / ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ELEMENT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      LEFT JOIN BUDGETS AB
      ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
      UNION ALL
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_PROJECT_TYPE,
      P.START_DATE,
      P.FINISH_DATE,
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_ESTIMATED_BASELINE1,
      ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1),
      0.00,
      0.00,
      COALESCE(B.BUDGET_BASELINE1, 0.00),
      COALESCE((B.BUDGET_BASELINE1 / ((PMO_ORASTD.DAYS(P.FINISH_DATE) - PMO_ORASTD.DAYS(P.START_DATE)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ELEMENT_ID = P.ELEMENT_ID
      AND B.ASSOCIATE_BUDGET_ID IS NULL
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_BENEFIT);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CHARGECODES', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CHARGECODES(194) : views_financial.sql(864) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --ESTIMATED
   BEGIN
      INSERT INTO PMO_FINANCIAL_CC (
      PROJECT_ID,
      ELEMENT_ID,
      ELEMENT_TYPE,
      START_DATE,
      FINISH_DATE,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      LABOR_FLAG,
      BILLABLE,
      STATE_TYPE,
      STATE_DAYS,
      STATE_TOTAL_COST,
      STATE_DAILY_COST,
      STATE_TOTAL_REVENUE,
      STATE_DAILY_REVENUE )
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_DELIVERABLE_TYPE,
      TO_DATE(SubStr(W.START_DT, 1, 10)),
      TO_DATE(SubStr(W.FINISH_DT, 1, 10)),
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_ESTIMATED_BUDGET,
      ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1),
      B.ESTIMATED_BUDGET,
      (B.ESTIMATED_BUDGET / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)),
      COALESCE(AB.ESTIMATED_BUDGET, 0.00),
      COALESCE((AB.ESTIMATED_BUDGET / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      JOIN TMT_WBS W
      ON W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      AND W.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM)
      LEFT JOIN BUDGETS AB
      ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
      UNION ALL
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_DELIVERABLE_TYPE,
      TO_DATE(SubStr(W.START_DT, 1, 10)),
      TO_DATE(SubStr(W.FINISH_DT, 1, 10)),
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_ESTIMATED_BUDGET,
      ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1),
      0.00,
      0.00,
      COALESCE(B.ESTIMATED_BUDGET, 0.00),
      COALESCE((B.ESTIMATED_BUDGET / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ASSOCIATE_BUDGET_ID IS NULL
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_BENEFIT)
      JOIN TMT_WBS W
      ON W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      AND W.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CHARGECODES', 285+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CHARGECODES(286) : views_financial.sql(956) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --PLANNED
   BEGIN
      INSERT INTO PMO_FINANCIAL_CC (
      PROJECT_ID,
      ELEMENT_ID,
      ELEMENT_TYPE,
      START_DATE,
      FINISH_DATE,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      LABOR_FLAG,
      BILLABLE,
      STATE_TYPE,
      STATE_DAYS,
      STATE_TOTAL_COST,
      STATE_DAILY_COST,
      STATE_TOTAL_REVENUE,
      STATE_DAILY_REVENUE )
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_TASK_TYPE,
      TO_DATE(SubStr(W.START_DT, 1, 10)),
      TO_DATE(SubStr(W.FINISH_DT, 1, 10)),
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_PLANNED_TYPE,
      ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1),
      B.BUDGET,
      (B.BUDGET / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)),
      COALESCE(AB.BUDGET, 0.00),
      COALESCE((AB.BUDGET / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      JOIN TMT_WBS W
      ON W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      LEFT JOIN BUDGETS AB
      ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
      UNION ALL
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_TASK_TYPE,
      TO_DATE(SubStr(W.START_DT, 1, 10)),
      TO_DATE(SubStr(W.FINISH_DT, 1, 10)),
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_PLANNED_TYPE,
      ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1),
      0.00,
      0.00,
      COALESCE(B.BUDGET, 0.00),
      COALESCE((B.BUDGET / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ASSOCIATE_BUDGET_ID IS NULL
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_BENEFIT)
      JOIN TMT_WBS W
      ON W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CHARGECODES', 377+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CHARGECODES(378) : views_financial.sql(1048) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   /***********************************************************************/
   --IMPORTANT:
   --  Actual values for the query below contains all the invoices that
   --  are issued at a specific days.
   --
   --  To contour properly, it is necessary to filter them out!
   /***********************************************************************/
   --ACTUAL
   BEGIN
      INSERT INTO PMO_FINANCIAL_CC (
      PROJECT_ID,
      ELEMENT_ID,
      ELEMENT_TYPE,
      START_DATE,
      FINISH_DATE,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      LABOR_FLAG,
      BILLABLE,
      STATE_TYPE,
      STATE_DAYS,
      STATE_TOTAL_COST,
      STATE_DAILY_COST,
      STATE_TOTAL_REVENUE,
      STATE_DAILY_REVENUE )
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_TASK_TYPE,
      TO_DATE(SubStr(W.START_DT, 1, 10)),
      TO_DATE(SubStr(W.FINISH_DT, 1, 10)),
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_PLANNED_TYPE,
      ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1),
      (B.ACTUAL - COALESCE((I.ACTUAL_AMOUNT + I.TAX1_AMOUNT + I.TAX2_AMOUNT), 0.00)),
      ((B.ACTUAL - COALESCE((I.ACTUAL_AMOUNT + I.TAX1_AMOUNT + I.TAX2_AMOUNT), 0.00)) / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)),
      COALESCE(AB.ACTUAL, 0.00),
      COALESCE((AB.ACTUAL / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1)), 0.00)
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_EXPENSE, PMO_CNST.SC_CAPITAL)
      JOIN TMT_WBS W
      ON W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      LEFT JOIN TMT_COSTS I
      ON I.PROJECT_ID = B.PROJECT_ID
      AND I.CHARGECODE_ID = B.CHARGECODE_ID
      AND I.BUDGET_ID = B.BUDGET_ID
      LEFT JOIN BUDGETS AB
      ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
      UNION ALL
      SELECT
      P.ELEMENT_ID,
      B.ELEMENT_ID,
      PMO_CNST.SC_TASK_TYPE,
      TO_DATE(SubStr(W.START_DT, 1, 10)),
      TO_DATE(SubStr(W.FINISH_DT, 1, 10)),
      B.CHARGECODE_ID,
      CC.ELEMENT_NAME,
      CC.CAPITAL_EXPENSE,
      CASE WHEN InStr(CC.ELEMENT_ID, 'LABOR') > 0 THEN 1 ELSE 0 END,
      CC.BILLABLE,
      PMO_CNST.SC_PLANNED_TYPE,
      ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1),
      0.00,
      0.00,
      (B.ACTUAL - COALESCE((I.ACTUAL_AMOUNT + I.TAX1_AMOUNT + I.TAX2_AMOUNT), 0.00)),
      ((B.ACTUAL - COALESCE((I.ACTUAL_AMOUNT + I.TAX1_AMOUNT + I.TAX2_AMOUNT), 0.00)) / ((PMO_ORASTD.DAYS(W.FINISH_DT) - PMO_ORASTD.DAYS(W.START_DT)) + 1))
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ASSOCIATE_BUDGET_ID IS NULL
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = B.CHARGECODE_ID
      AND CC.CAPITAL_EXPENSE IN (PMO_CNST.SC_BENEFIT)
      JOIN TMT_WBS W
      ON W.PROJECT_ID = B.PROJECT_ID
      AND W.ELEMENT_ID = B.ELEMENT_ID
      AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      LEFT JOIN TMT_COSTS I
      ON I.PROJECT_ID = B.PROJECT_ID
      AND I.CHARGECODE_ID = B.CHARGECODE_ID
      AND I.BUDGET_ID = B.BUDGET_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CHARGECODES', 484+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CHARGECODES(485) : views_financial.sql(1155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CHARGECODES', 491+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_CHARGECODES(492) : views_financial.sql(1162) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_CHARGECODES;
ALTER FUNCTION FC_INIT_CHARGECODES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_EXCEPTIONS ==
CREATE OR REPLACE FUNCTION FC_INIT_EXCEPTIONS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_EXCEPTIONS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_EXCEPTIONS'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_EXCEPTIONS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_EXCEPTIONS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_EXCEPTIONS(9) : views_financial.sql(1181) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_EXC';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Populate the list of chargecodes
   --EXPECTED
   BEGIN
      INSERT INTO PMO_FINANCIAL_EXC (
      PROJECT_ID,
      EXCEPTION_ID,
      EXCEPTION_TYPE,
      EXCEPTION_COST,
      EXCEPTION_REVENUE,
      EXCEPTION_EFFORT,
      EXCEPTION_SCHEDULE_RANK,
      EXCEPTION_CLOSED_DATE,
      EXCEPTION_WBS_ID )
      SELECT
      C.PROJECT_ID,
      C.ELEMENT_ID,
      C.TYPE_ID,
      C.CURRENT_BUDGET,
      (C.R_CURRENT_BUDGET + C.S_CURRENT_BUDGET),
      C.PLANNED_EFFORT + C.SCHED_EFFORT,
      SCHEDULE_RANK_ID,
      TO_DATE(SubStr(C.CLOSED_DATETIME, 1, 10)),
      C.WBS_ID
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN TMT_CRI C
      ON C.PROJECT_ID = P.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_EXCEPTIONS', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_EXCEPTIONS(56) : views_financial.sql(1228) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_EXCEPTIONS', 61+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_EXCEPTIONS(62) : views_financial.sql(1234) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_EXCEPTIONS;
ALTER FUNCTION FC_INIT_EXCEPTIONS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_SCORECARDS ==
CREATE OR REPLACE FUNCTION FC_INIT_SCORECARDS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_SCORECARDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_SCORECARDS'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_SCORECARDS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_SCORECARDS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_SCORECARDS(9) : views_financial.sql(1253) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_SC';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --EXPECTED
   BEGIN
      INSERT INTO PMO_FINANCIAL_SC (
      PROJECT_ID,
      SCORECARD_ID,
      CONVERTED_SCORE,
      CONVERTED_WEIGHT )
      SELECT
      S.PROJECT_ID,
      S.ELEMENT_ID,
      S.CONVERTED_SCORE,
      S.CONVERTED_WEIGHT
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN TMT_ASSIGNED_SCORECARDS S
      ON S.PROJECT_ID = P.ELEMENT_ID
      AND S.PARENT_RANK = 'WBS#' || P.RANK
      AND S.TYPE_ID = PMO_CNST.SC_SCORECARD
      AND S.PUBLISHED_DT IS NOT NULL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_SCORECARDS', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_SCORECARDS(48) : views_financial.sql(1292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_SCORECARDS', 53+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_SCORECARDS(54) : views_financial.sql(1298) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_SCORECARDS;
ALTER FUNCTION FC_INIT_SCORECARDS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION FC_INIT_ATTRIBUTES RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_ATTRIBUTES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_ATTRIBUTES', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_ATTRIBUTES(9) : views_financial.sql(1317) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_AT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_FINANCIAL_AT (
      PROJECT_ID,
      PROJECT_ATTRIBUTES )
      SELECT  PRJ.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13)
      FROM PMO_FINANCIAL_PROJECTS PRJ
      JOIN TMT_WBS_ATTRIBUTES P
      ON P.ELEMENT_ID = PRJ.ELEMENT_ID
      JOIN TMT_WBS_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_ATTRIBUTES', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_ATTRIBUTES(54) : views_financial.sql(1362) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_ATTRIBUTES', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_ATTRIBUTES(60) : views_financial.sql(1368) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_ATTRIBUTES;
ALTER FUNCTION FC_INIT_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_SINGLE_ATTR ==
CREATE OR REPLACE FUNCTION FC_INIT_SINGLE_ATTR RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_SINGLE_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_SINGLE_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_SINGLE_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_SINGLE_ATTR', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_SINGLE_ATTR(9) : views_financial.sql(1387) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_AT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_FINANCIAL_AT (
      PROJECT_ID,
      PROJECT_ATTRIBUTES )
      SELECT  PRJ.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13)
      FROM PMO_FINANCIAL_PROJECTS PRJ
      JOIN TMT_WBS_ATTRIBUTES P
      ON P.ELEMENT_ID = PRJ.ELEMENT_ID
      JOIN TMT_WBS_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      AND A.TYPE_ID = 144
      JOIN TMT_WBS_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_SINGLE_ATTR', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_SINGLE_ATTR(53) : views_financial.sql(1431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_SINGLE_ATTR', 58+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_SINGLE_ATTR(59) : views_financial.sql(1437) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_SINGLE_ATTR;
ALTER FUNCTION FC_INIT_SINGLE_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION FC_PIVOT_ATTRIBUTES RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPAT IS
         SELECT ELEMENT_ID
         FROM PMO_FINANCIAL_PROJECTS
         ORDER BY RANK;

      CURSOR CPAT_A IS
         SELECT RTRIM(PROJECT_ATTRIBUTES)
         FROM PMO_FINANCIAL_AT
         WHERE PROJECT_ID = h_p_id
         AND LENGTH(PROJECT_ATTRIBUTES) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_ATTRIBUTES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_ATTRIBUTES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_ATTRIBUTES(24) : views_financial.sql(1471) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_PAT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPAT;
   
   LOOP
      FETCH CPAT INTO h_p_id;
      IF CPAT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPAT_A;
      
      LOOP
         FETCH CPAT_A INTO h_c_attr;
         IF CPAT_A%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPAT_A ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_ATTRIBUTES', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_ATTRIBUTES(74) : views_financial.sql(1521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_FINANCIAL_PAT (
         PROJECT_ID,
         PROJECT_ATTRIBUTES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_ATTRIBUTES', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_ATTRIBUTES(96) : views_financial.sql(1543) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPAT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_ATTRIBUTES', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_ATTRIBUTES(110) : views_financial.sql(1557) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_ATTRIBUTES', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_ATTRIBUTES(116) : views_financial.sql(1563) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_ATTRIBUTES;
ALTER FUNCTION FC_PIVOT_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_ATTR_EX ==
CREATE OR REPLACE FUNCTION FC_INIT_ATTR_EX RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_ATTR_EX') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_ATTR_EX'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_ATTR_EX();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_ATTR_EX', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_ATTR_EX(9) : views_financial.sql(1582) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_AT1';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_AT2';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_FINANCIAL_AT1 (
      PROJECT_ID,
      ATTR_TYPE,
      ATTR_ID,
      RANK,
      LEVEL_ID,
      ELEMENT_NAME )
      SELECT  PRJ.ELEMENT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S'
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS'
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M'
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM'
      END,
      A.ELEMENT_ID,
      RTRIM(P.RANK),
      P.LEVEL_ID,
      RTRIM(COALESCE(P.DESCRIPTION,''))
      FROM PMO_FINANCIAL_PROJECTS PRJ
      JOIN TMT_WBS_ATTRIBUTES P
      ON P.ELEMENT_ID = PRJ.ELEMENT_ID
      AND P.RANK < 'qqqqqqqq'
      JOIN TMT_WBS_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_ATTR_EX', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_ATTR_EX(59) : views_financial.sql(1632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_FINANCIAL_AT2 (
      PROJECT_ID,
      ATTR_TYPE,
      RANK,
      LEVEL_ID,
      ELEMENT_NAME )
      SELECT  C.PROJECT_ID,
      C.ATTR_TYPE,
      C.PROJECT_ID || C.ATTR_ID || P.RANK,
      P.LEVEL_ID,
      CASE
      WHEN P.PARENT_ID IS NULL THEN (C.ATTR_TYPE || CHR(10) || P.ELEMENT_ID || RTRIM(COALESCE(P.ELEMENT_NAME,'')) || CHR(10))
      WHEN P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN (P.ELEMENT_ID || RTRIM(COALESCE(C.ELEMENT_NAME,'')) || CHR(13))
      ELSE (P.ELEMENT_ID || RTRIM(COALESCE(P.ELEMENT_NAME,'')) || CHR(10))
      END
      FROM TMT_WBS_ATTRIBUTES P, PMO_FINANCIAL_AT1 C
      WHERE P.RANK > '0000'
      AND P.RANK <= C.RANK
      AND C.LEVEL_ID >= P.LEVEL_ID
      AND (RTRIM(P.RANK) || SUBSTR(C.RANK, 13+(P.LEVEL_ID*4), (C.LEVEL_ID-P.LEVEL_ID)*4)) = RTRIM(C.RANK);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_ATTR_EX', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_ATTR_EX(95) : views_financial.sql(1668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_ATTR_EX', 100+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_ATTR_EX(101) : views_financial.sql(1674) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_ATTR_EX;
ALTER FUNCTION FC_INIT_ATTR_EX COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_ATTR_EX ==
CREATE OR REPLACE FUNCTION FC_PIVOT_ATTR_EX RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(2047);
   h_level_id PLS_INTEGER := 0;
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPAT_1 IS
         SELECT ELEMENT_ID
         FROM PMO_FINANCIAL_PROJECTS
         ORDER BY RANK;

      CURSOR CPAT_2 IS
         SELECT LEVEL_ID, RTRIM(ELEMENT_NAME)
         FROM PMO_FINANCIAL_AT2
         WHERE PROJECT_ID = h_p_id
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_ATTR_EX') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_ATTR_EX'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_ATTR_EX();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_ATTR_EX', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_ATTR_EX(25) : views_financial.sql(1709) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_PAT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPAT_1;
   
   LOOP
      FETCH CPAT_1 INTO h_p_id;
      IF CPAT_1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPAT_2;
      
      LOOP
         FETCH CPAT_2 INTO h_level_id, h_c_attr;
         IF CPAT_2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPAT_2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_ATTR_EX', 74+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_ATTR_EX(75) : views_financial.sql(1759) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_FINANCIAL_PAT (
         PROJECT_ID,
         PROJECT_ATTRIBUTES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_ATTR_EX', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_ATTR_EX(97) : views_financial.sql(1781) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPAT_1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_ATTR_EX', 110+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_ATTR_EX(111) : views_financial.sql(1795) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_ATTR_EX', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_ATTR_EX(117) : views_financial.sql(1801) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_ATTR_EX;
ALTER FUNCTION FC_PIVOT_ATTR_EX COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_SCORECARDS ==
CREATE OR REPLACE FUNCTION FC_PIVOT_SCORECARDS RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_sc_score PLS_INTEGER := 0;
   h_sc_weight PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CPSC IS
         SELECT ELEMENT_ID
         FROM PMO_FINANCIAL_PROJECTS
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_SCORECARDS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_SCORECARDS'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_SCORECARDS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_SCORECARDS', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_SCORECARDS(18) : views_financial.sql(1829) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_PSC';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPSC;
   
   LOOP
      FETCH CPSC INTO h_p_id;
      IF CPSC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         SELECT  SUM(CONVERTED_SCORE),
         SUM(CONVERTED_WEIGHT)
         INTO    h_sc_score,
         h_sc_weight
         FROM PMO_FINANCIAL_SC
         WHERE PROJECT_ID = h_p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_SCORECARDS', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_SCORECARDS(55) : views_financial.sql(1866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_FINANCIAL_PSC (
         PROJECT_ID,
         SCORECARD_SCORE,
         SCORECARD_WEIGHT )
         VALUES (
         h_p_id,
         h_sc_score,
         h_sc_weight );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_SCORECARDS', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_SCORECARDS(79) : views_financial.sql(1890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPSC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_SCORECARDS', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_SCORECARDS(93) : views_financial.sql(1904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_SCORECARDS', 98+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_SCORECARDS(99) : views_financial.sql(1910) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_SCORECARDS;
ALTER FUNCTION FC_PIVOT_SCORECARDS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_EXCEPTIONS ==
CREATE OR REPLACE FUNCTION FC_PIVOT_EXCEPTIONS RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_cr_cost NUMBER := 0;
   h_cr_revenue NUMBER := 0;
   h_cr_effort PLS_INTEGER := 0;
   h_cr_sched_rank PLS_INTEGER := 0;
   h_cr_total_count PLS_INTEGER := 0;
   h_cr_closed_count PLS_INTEGER := 0;
   h_cr_transfer_count PLS_INTEGER := 0;
   h_rs_cost NUMBER := 0;
   h_rs_revenue NUMBER := 0;
   h_rs_effort PLS_INTEGER := 0;
   h_rs_sched_rank PLS_INTEGER := 0;
   h_rs_total_count PLS_INTEGER := 0;
   h_rs_closed_count PLS_INTEGER := 0;
   h_rs_transfer_count PLS_INTEGER := 0;
   h_is_cost NUMBER := 0;
   h_is_revenue NUMBER := 0;
   h_is_effort PLS_INTEGER := 0;
   h_is_sched_rank PLS_INTEGER := 0;
   h_is_total_count PLS_INTEGER := 0;
   h_is_closed_count PLS_INTEGER := 0;
   h_is_transfer_count PLS_INTEGER := 0;
   h_rq_cost NUMBER := 0;
   h_rq_revenue NUMBER := 0;
   h_rq_effort PLS_INTEGER := 0;
   h_rq_sched_rank PLS_INTEGER := 0;
   h_rq_total_count PLS_INTEGER := 0;
   h_rq_closed_count PLS_INTEGER := 0;
   h_rq_transfer_count PLS_INTEGER := 0;
   h_df_cost NUMBER := 0;
   h_df_revenue NUMBER := 0;
   h_df_effort PLS_INTEGER := 0;
   h_df_sched_rank PLS_INTEGER := 0;
   h_df_total_count PLS_INTEGER := 0;
   h_df_closed_count PLS_INTEGER := 0;
   h_df_transfer_count PLS_INTEGER := 0;
   h_sq_cost NUMBER := 0;
   h_sq_revenue NUMBER := 0;
   h_sq_effort PLS_INTEGER := 0;
   h_sq_sched_rank PLS_INTEGER := 0;
   h_sq_total_count PLS_INTEGER := 0;
   h_sq_closed_count PLS_INTEGER := 0;
   h_sq_transfer_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CPEXC IS
         SELECT ELEMENT_ID
         FROM PMO_FINANCIAL_PROJECTS
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_EXCEPTIONS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_EXCEPTIONS'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_EXCEPTIONS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_EXCEPTIONS', 57+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_EXCEPTIONS(58) : views_financial.sql(1978) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_PEXC';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPEXC;
   
   LOOP
      FETCH CPEXC INTO h_p_id;
      IF CPEXC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         SELECT  SUM(EXCEPTION_COST),
         SUM(EXCEPTION_REVENUE),
         SUM(EXCEPTION_EFFORT),
         AVG(EXCEPTION_SCHEDULE_RANK),
         COUNT(EXCEPTION_ID)
         INTO    h_cr_cost,
         h_cr_revenue,
         h_cr_effort,
         h_cr_sched_rank,
         h_cr_total_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_CHANGE_REQUEST;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(102) : views_financial.sql(2022) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_cr_closed_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_CHANGE_REQUEST
         AND EXCEPTION_CLOSED_DATE IS NOT NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 119+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(120) : views_financial.sql(2040) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_cr_transfer_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_CHANGE_REQUEST
         AND EXCEPTION_WBS_ID = EXCEPTION_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(138) : views_financial.sql(2058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(EXCEPTION_COST),
         SUM(EXCEPTION_REVENUE),
         SUM(EXCEPTION_EFFORT),
         AVG(EXCEPTION_SCHEDULE_RANK),
         COUNT(EXCEPTION_ID)
         INTO    h_rs_cost,
         h_rs_revenue,
         h_rs_effort,
         h_rs_sched_rank,
         h_rs_total_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_RISK;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 162+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(163) : views_financial.sql(2083) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_rs_closed_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_RISK
         AND EXCEPTION_CLOSED_DATE IS NOT NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 180+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(181) : views_financial.sql(2101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_rs_transfer_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_RISK
         AND EXCEPTION_WBS_ID = EXCEPTION_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 198+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(199) : views_financial.sql(2119) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(EXCEPTION_COST),
         SUM(EXCEPTION_REVENUE),
         SUM(EXCEPTION_EFFORT),
         AVG(EXCEPTION_SCHEDULE_RANK),
         COUNT(EXCEPTION_ID)
         INTO    h_is_cost,
         h_is_revenue,
         h_is_effort,
         h_is_sched_rank,
         h_is_total_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_ISSUE;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 223+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(224) : views_financial.sql(2144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_is_closed_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_ISSUE
         AND EXCEPTION_CLOSED_DATE IS NOT NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 241+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(242) : views_financial.sql(2162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_is_transfer_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_ISSUE
         AND EXCEPTION_WBS_ID = EXCEPTION_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 259+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(260) : views_financial.sql(2180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(EXCEPTION_COST),
         SUM(EXCEPTION_REVENUE),
         SUM(EXCEPTION_EFFORT),
         AVG(EXCEPTION_SCHEDULE_RANK),
         COUNT(EXCEPTION_ID)
         INTO    h_rq_cost,
         h_rq_revenue,
         h_rq_effort,
         h_rq_sched_rank,
         h_rq_total_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_REQUIREMENT;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 284+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(285) : views_financial.sql(2205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_rq_closed_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_REQUIREMENT
         AND EXCEPTION_CLOSED_DATE IS NOT NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 302+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(303) : views_financial.sql(2223) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_rq_transfer_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_REQUIREMENT
         AND EXCEPTION_WBS_ID = EXCEPTION_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 320+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(321) : views_financial.sql(2241) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(EXCEPTION_COST),
         SUM(EXCEPTION_REVENUE),
         SUM(EXCEPTION_EFFORT),
         AVG(EXCEPTION_SCHEDULE_RANK),
         COUNT(EXCEPTION_ID)
         INTO    h_df_cost,
         h_df_revenue,
         h_df_effort,
         h_df_sched_rank,
         h_df_total_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_DEFECT;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 345+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(346) : views_financial.sql(2266) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_df_closed_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_DEFECT
         AND EXCEPTION_CLOSED_DATE IS NOT NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 363+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(364) : views_financial.sql(2284) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_df_transfer_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_DEFECT
         AND EXCEPTION_WBS_ID = EXCEPTION_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 381+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(382) : views_financial.sql(2302) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(EXCEPTION_COST),
         SUM(EXCEPTION_REVENUE),
         SUM(EXCEPTION_EFFORT),
         AVG(EXCEPTION_SCHEDULE_RANK),
         COUNT(EXCEPTION_ID)
         INTO    h_sq_cost,
         h_sq_revenue,
         h_sq_effort,
         h_sq_sched_rank,
         h_sq_total_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_SERVICE_REQUEST;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 406+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(407) : views_financial.sql(2327) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_sq_closed_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_SERVICE_REQUEST
         AND EXCEPTION_CLOSED_DATE IS NOT NULL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 424+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(425) : views_financial.sql(2345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  COUNT(EXCEPTION_ID)
         INTO    h_sq_transfer_count
         FROM PMO_FINANCIAL_EXC
         WHERE PROJECT_ID = h_p_id
         AND EXCEPTION_TYPE = PMO_CNST.SC_SERVICE_REQUEST
         AND EXCEPTION_WBS_ID = EXCEPTION_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 442+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(443) : views_financial.sql(2363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_FINANCIAL_PEXC (
         PROJECT_ID,
         CR_PRIORITY_COST,
         CR_PRIORITY_REVENUE,
         CR_PRIORITY_EFFORT,
         CR_SCHED_IMPACT,
         CR_TOTAL_COUNT,
         CR_CLOSED_COUNT,
         CR_TRANSFERRED_COUNT,
         RS_PRIORITY_COST,
         RS_PRIORITY_REVENUE,
         RS_PRIORITY_EFFORT,
         RS_SCHED_IMPACT,
         RS_TOTAL_COUNT,
         RS_CLOSED_COUNT,
         RS_TRANSFERRED_COUNT,
         IS_PRIORITY_COST,
         IS_PRIORITY_REVENUE,
         IS_PRIORITY_EFFORT,
         IS_SCHED_IMPACT,
         IS_TOTAL_COUNT,
         IS_CLOSED_COUNT,
         IS_TRANSFERRED_COUNT,
         RQ_PRIORITY_COST,
         RQ_PRIORITY_REVENUE,
         RQ_PRIORITY_EFFORT,
         RQ_SCHED_IMPACT,
         RQ_TOTAL_COUNT,
         RQ_CLOSED_COUNT,
         RQ_TRANSFERRED_COUNT,
         DF_PRIORITY_COST,
         DF_PRIORITY_REVENUE,
         DF_PRIORITY_EFFORT,
         DF_SCHED_IMPACT,
         DF_TOTAL_COUNT,
         DF_CLOSED_COUNT,
         DF_TRANSFERRED_COUNT,
         SQ_PRIORITY_COST,
         SQ_PRIORITY_REVENUE,
         SQ_PRIORITY_EFFORT,
         SQ_SCHED_IMPACT,
         SQ_TOTAL_COUNT,
         SQ_CLOSED_COUNT,
         SQ_TRANSFERRED_COUNT )
         VALUES (
         h_p_id,
         h_cr_cost,
         h_cr_revenue,
         h_cr_effort,
         h_cr_sched_rank,
         h_cr_total_count,
         h_cr_closed_count,
         h_cr_transfer_count,
         h_rs_cost,
         h_rs_revenue,
         h_rs_effort,
         h_rs_sched_rank,
         h_rs_total_count,
         h_rs_closed_count,
         h_rs_transfer_count,
         h_is_cost,
         h_is_revenue,
         h_is_effort,
         h_is_sched_rank,
         h_is_total_count,
         h_is_closed_count,
         h_is_transfer_count,
         h_rq_cost,
         h_rq_revenue,
         h_rq_effort,
         h_rq_sched_rank,
         h_rq_total_count,
         h_rq_closed_count,
         h_rq_transfer_count,
         h_df_cost,
         h_df_revenue,
         h_df_effort,
         h_df_sched_rank,
         h_df_total_count,
         h_df_closed_count,
         h_df_transfer_count,
         h_sq_cost,
         h_sq_revenue,
         h_sq_effort,
         h_sq_sched_rank,
         h_sq_total_count,
         h_sq_closed_count,
         h_sq_transfer_count );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 546+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(547) : views_financial.sql(2467) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPEXC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_EXCEPTIONS', 560+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_EXCEPTIONS(561) : views_financial.sql(2481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_EXCEPTIONS', 566+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_EXCEPTIONS(567) : views_financial.sql(2487) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_EXCEPTIONS;
ALTER FUNCTION FC_PIVOT_EXCEPTIONS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_PROJECT_MONTHLY ==
CREATE OR REPLACE FUNCTION FC_PIVOT_PROJECT_MONTHLY RETURN PLS_INTEGER
AS
   h_p_actual_finish DATE;
   h_p_actual_start DATE;
   h_p_est_bl1_finish DATE;
   h_p_est_bl1_start DATE;
   h_p_est_bl3_finish DATE;
   h_p_est_bl3_start DATE;
   h_p_est_finish DATE;
   h_p_est_start DATE;
   h_p_expected_finish DATE;
   h_p_expected_start DATE;
   h_p_finish DATE;
   h_p_id VARCHAR2(32);
   h_p_plnd_finish DATE;
   h_p_plnd_start DATE;
   h_p_rank VARCHAR2(200);
   h_p_start DATE;
   h_p_actual_days PLS_INTEGER := 0;
   h_p_est_bl1_days PLS_INTEGER := 0;
   h_p_est_bl3_days PLS_INTEGER := 0;
   h_p_days PLS_INTEGER := 0;
   h_p_est_days PLS_INTEGER := 0;
   h_p_expected_days PLS_INTEGER := 0;
   h_p_payback_month PLS_INTEGER := 0;
   h_p_period_count PLS_INTEGER := 0;
   h_p_plnd_days PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_PROJECT_MONTHLY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_PROJECT_MONTHLY'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_PROJECT_MONTHLY();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_PROJECT_MONTHLY', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_PROJECT_MONTHLY(34) : views_financial.sql(2531) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare LOCAL Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_RESULTSET_EX';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_FINANCIAL_RESULTSET_EX
      SELECT
      RANK,
      PROJECT_ID,
      PROJECT_NAME,
      PROJECT_MANAGER,
      PROJECT_PRIORITY,
      PROJECT_HEALTH,
      STAGE_ID,
      REFERNCE_CODE,
      PROJECT_CURRENCY_ID,
      PROJECT_START,
      PROJECT_FINISH,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      LABOR_FLAG,
      BILLABLE,
      CASE WHEN MIN(COALESCE(EXPECTED_START, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MIN(EXPECTED_START) END,
      CASE WHEN MAX(COALESCE(EXPECTED_FINISH, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MAX(EXPECTED_FINISH) END,
      SUM(EXPECTED_COST),
      SUM(EXPECTED_REVENUE),
      SUM(EXPECTED_NPV),
      SUM(EXPECTED_COST_NPV),
      SUM(EXPECTED_REVENUE_NPV),
      SUM(EXPECTED_CF),
      SUM(EXPECTED_GP),
      SUM(EXPECTED_COST_YTD),
      SUM(EXPECTED_REVENUE_YTD),
      SUM(EXPECTED_COST_TODATE),
      SUM(EXPECTED_REVENUE_TODATE),
      CASE WHEN MIN(COALESCE(ESTIMATED_START, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MIN(ESTIMATED_START) END,
      CASE WHEN MAX(COALESCE(ESTIMATED_FINISH, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MAX(ESTIMATED_FINISH) END,
      SUM(ESTIMATED_COST),
      SUM(ESTIMATED_REVENUE),
      SUM(ESTIMATED_NPV),
      SUM(ESTIMATED_COST_NPV),
      SUM(ESTIMATED_REVENUE_NPV),
      SUM(ESTIMATED_CF),
      SUM(ESTIMATED_GP),
      SUM(ESTIMATED_COST_YTD),
      SUM(ESTIMATED_REVENUE_YTD),
      SUM(ESTIMATED_COST_TODATE),
      SUM(ESTIMATED_REVENUE_TODATE),
      CASE WHEN MIN(COALESCE(PLANNED_START, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MIN(PLANNED_START) END,
      CASE WHEN MAX(COALESCE(PLANNED_FINISH, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MAX(PLANNED_FINISH) END,
      SUM(PLANNED_COST),
      SUM(PLANNED_REVENUE),
      SUM(PLANNED_NPV),
      SUM(PLANNED_COST_NPV),
      SUM(PLANNED_REVENUE_NPV),
      SUM(PLANNED_CF),
      SUM(PLANNED_GP),
      SUM(PLANNED_COST_YTD),
      SUM(PLANNED_REVENUE_YTD),
      SUM(PLANNED_COST_TODATE),
      SUM(PLANNED_REVENUE_TODATE),
      CASE WHEN MIN(COALESCE(BASELINE1_START, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MIN(BASELINE1_START) END,
      CASE WHEN MAX(COALESCE(BASELINE1_FINISH, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MAX(BASELINE1_FINISH) END,
      SUM(BASELINE1_COST),
      SUM(BASELINE1_REVENUE),
      SUM(BASELINE1_NPV),
      SUM(BASELINE1_COST_NPV),
      SUM(BASELINE1_REVENUE_NPV),
      SUM(BASELINE1_CF),
      SUM(BASELINE1_GP),
      SUM(BASELINE1_COST_YTD),
      SUM(BASELINE1_REVENUE_YTD),
      SUM(BASELINE1_COST_TODATE),
      SUM(BASELINE1_REVENUE_TODATE),
      CASE WHEN MIN(COALESCE(BASELINE3_START, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MIN(BASELINE3_START) END,
      CASE WHEN MAX(COALESCE(BASELINE3_FINISH, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MAX(BASELINE3_FINISH) END,
      SUM(BASELINE3_COST),
      SUM(BASELINE3_REVENUE),
      SUM(BASELINE3_NPV),
      SUM(BASELINE3_COST_NPV),
      SUM(BASELINE3_REVENUE_NPV),
      SUM(BASELINE3_CF),
      SUM(BASELINE3_GP),
      SUM(BASELINE3_COST_YTD),
      SUM(BASELINE3_REVENUE_YTD),
      SUM(BASELINE3_COST_TODATE),
      SUM(BASELINE3_REVENUE_TODATE),
      CASE WHEN MIN(COALESCE(ACTUAL_START, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MIN(ACTUAL_START) END,
      CASE WHEN MAX(COALESCE(ACTUAL_FINISH, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL ELSE MAX(ACTUAL_FINISH) END,
      SUM(ACTUAL_COST),
      SUM(ACTUAL_REVENUE),
      SUM(ACTUAL_NPV),
      SUM(ACTUAL_COST_NPV),
      SUM(ACTUAL_REVENUE_NPV),
      SUM(ACTUAL_CF),
      SUM(ACTUAL_GP),
      SUM(ACTUAL_COST_YTD),
      SUM(ACTUAL_REVENUE_YTD),
      SUM(ACTUAL_COST_TODATE),
      SUM(ACTUAL_REVENUE_TODATE)
      FROM PMO_FINANCIAL_RESULTSET
      GROUP BY    RANK,
      PROJECT_ID,
      PROJECT_NAME,
      PROJECT_MANAGER,
      PROJECT_PRIORITY,
      PROJECT_HEALTH,
      STAGE_ID,
      REFERNCE_CODE,
      PROJECT_CURRENCY_ID,
      PROJECT_START,
      PROJECT_FINISH,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      LABOR_FLAG,
      BILLABLE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_PROJECT_MONTHLY', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_PROJECT_MONTHLY(169) : views_financial.sql(2666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_PROJECT_MONTHLY', 174+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_PROJECT_MONTHLY(175) : views_financial.sql(2672) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_PROJECT_MONTHLY;
ALTER FUNCTION FC_PIVOT_PROJECT_MONTHLY COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PARSE_PERIODS ==
CREATE OR REPLACE FUNCTION FC_PARSE_PERIODS
(
     h_p_id IN OUT NOCOPY VARCHAR2
   , sh_h_period_type PLS_INTEGER
   , sh_h_p_period_count PLS_INTEGER
   , h_p_rank IN OUT NOCOPY VARCHAR2
   , h_p_start IN OUT NOCOPY DATE
   , h_p_finish IN OUT NOCOPY DATE
   , h_p_expected_start IN OUT NOCOPY DATE
   , h_p_expected_finish IN OUT NOCOPY DATE
   , sh_h_p_expected_days PLS_INTEGER
   , h_p_est_start IN OUT NOCOPY DATE
   , h_p_est_finish IN OUT NOCOPY DATE
   , sh_h_p_est_days PLS_INTEGER
   , h_p_plnd_start IN OUT NOCOPY DATE
   , h_p_plnd_finish IN OUT NOCOPY DATE
   , sh_h_p_plnd_days PLS_INTEGER
   , h_p_est_bl1_start IN OUT NOCOPY DATE
   , h_p_est_bl1_finish IN OUT NOCOPY DATE
   , sh_h_p_est_bl1_days PLS_INTEGER
   , h_p_est_bl3_start IN OUT NOCOPY DATE
   , h_p_est_bl3_finish IN OUT NOCOPY DATE
   , sh_h_p_est_bl3_days PLS_INTEGER
   , h_p_actual_start IN OUT NOCOPY DATE
   , h_p_actual_finish IN OUT NOCOPY DATE
   , sh_h_p_actual_days PLS_INTEGER
   , h_cc_id IN OUT NOCOPY VARCHAR2
   , h_cc_name IN OUT NOCOPY VARCHAR2
   , sh_h_cc_type PLS_INTEGER
   , sh_h_cc_labor_flag PLS_INTEGER
   , sh_h_cc_billable PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_period_type PLS_INTEGER := sh_h_period_type;
   h_p_period_count PLS_INTEGER := sh_h_p_period_count;
   h_p_expected_days PLS_INTEGER := sh_h_p_expected_days;
   h_p_est_days PLS_INTEGER := sh_h_p_est_days;
   h_p_plnd_days PLS_INTEGER := sh_h_p_plnd_days;
   h_p_est_bl1_days PLS_INTEGER := sh_h_p_est_bl1_days;
   h_p_est_bl3_days PLS_INTEGER := sh_h_p_est_bl3_days;
   h_p_actual_days PLS_INTEGER := sh_h_p_actual_days;
   h_cc_type PLS_INTEGER := sh_h_cc_type;
   h_cc_labor_flag PLS_INTEGER := sh_h_cc_labor_flag;
   h_cc_billable PLS_INTEGER := sh_h_cc_billable;
   h_cc_actual_finish DATE;
   h_cc_actual_start DATE;
   h_cc_bl1_finish DATE;
   h_cc_bl1_start DATE;
   h_cc_bl3_finish DATE;
   h_cc_bl3_start DATE;
   h_cc_estimated_finish DATE;
   h_cc_estimated_start DATE;
   h_cc_expected_finish DATE;
   h_cc_expected_start DATE;
   h_cc_finish DATE;
   h_cc_planned_finish DATE;
   h_cc_planned_start DATE;
   h_cc_start DATE;
   h_period_actual_finish DATE;
   h_period_actual_start DATE;
   h_period_bl1_finish DATE;
   h_period_bl1_start DATE;
   h_period_bl3_finish DATE;
   h_period_bl3_start DATE;
   h_period_estimated_finish DATE;
   h_period_estimated_start DATE;
   h_period_expected_finish DATE;
   h_period_expected_start DATE;
   h_period_finish DATE;
   h_period_planned_finish DATE;
   h_period_planned_start DATE;
   h_period_start DATE;
   h_cc_actual_cf_td NUMBER := 0;
   h_cc_actual_cost NUMBER := 0;
   h_cc_actual_cost_pd NUMBER := 0;
   h_cc_actual_cost_td NUMBER := 0;
   h_cc_actual_cost_ytd NUMBER := 0;
   h_cc_actual_gp NUMBER := 0;
   h_cc_actual_revenue NUMBER := 0;
   h_cc_actual_revenue_pd NUMBER := 0;
   h_cc_actual_revenue_td NUMBER := 0;
   h_cc_actual_revenue_ytd NUMBER := 0;
   h_cc_bl1_cf_td NUMBER := 0;
   h_cc_bl1_cost NUMBER := 0;
   h_cc_bl1_cost_pd NUMBER := 0;
   h_cc_bl1_cost_td NUMBER := 0;
   h_cc_bl1_cost_ytd NUMBER := 0;
   h_cc_bl1_gp NUMBER := 0;
   h_cc_bl1_revenue NUMBER := 0;
   h_cc_bl1_revenue_pd NUMBER := 0;
   h_cc_bl1_revenue_td NUMBER := 0;
   h_cc_bl1_revenue_ytd NUMBER := 0;
   h_cc_bl3_cf_td NUMBER := 0;
   h_cc_bl3_cost NUMBER := 0;
   h_cc_bl3_cost_pd NUMBER := 0;
   h_cc_bl3_cost_td NUMBER := 0;
   h_cc_bl3_cost_ytd NUMBER := 0;
   h_cc_bl3_gp NUMBER := 0;
   h_cc_bl3_revenue NUMBER := 0;
   h_cc_bl3_revenue_pd NUMBER := 0;
   h_cc_bl3_revenue_td NUMBER := 0;
   h_cc_bl3_revenue_ytd NUMBER := 0;
   h_cc_estimated_cf_td NUMBER := 0;
   h_cc_estimated_cost NUMBER := 0;
   h_cc_estimated_cost_pd NUMBER := 0;
   h_cc_estimated_cost_td NUMBER := 0;
   h_cc_estimated_cost_ytd NUMBER := 0;
   h_cc_estimated_gp NUMBER := 0;
   h_cc_estimated_revenue NUMBER := 0;
   h_cc_estimated_revenue_pd NUMBER := 0;
   h_cc_estimated_revenue_td NUMBER := 0;
   h_cc_estimated_revenue_ytd NUMBER := 0;
   h_cc_expected_cf_td NUMBER := 0;
   h_cc_expected_cost NUMBER := 0;
   h_cc_expected_cost_pd NUMBER := 0;
   h_cc_expected_cost_td NUMBER := 0;
   h_cc_expected_cost_ytd NUMBER := 0;
   h_cc_expected_gp NUMBER := 0;
   h_cc_expected_revenue NUMBER := 0;
   h_cc_expected_revenue_pd NUMBER := 0;
   h_cc_expected_revenue_td NUMBER := 0;
   h_cc_expected_revenue_ytd NUMBER := 0;
   h_cc_planned_cf_td NUMBER := 0;
   h_cc_planned_cost NUMBER := 0;
   h_cc_planned_cost_pd NUMBER := 0;
   h_cc_planned_cost_td NUMBER := 0;
   h_cc_planned_cost_ytd NUMBER := 0;
   h_cc_planned_gp NUMBER := 0;
   h_cc_planned_revenue NUMBER := 0;
   h_cc_planned_revenue_pd NUMBER := 0;
   h_cc_planned_revenue_td NUMBER := 0;
   h_cc_planned_revenue_ytd NUMBER := 0;
   h_month_01_cost NUMBER := 0;
   h_month_02_cost NUMBER := 0;
   h_month_02_revenue NUMBER := 0;
   h_month_03_cost NUMBER := 0;
   h_month_03_revenue NUMBER := 0;
   h_month_04_cost NUMBER := 0;
   h_month_04_revenue NUMBER := 0;
   h_month_05_cost NUMBER := 0;
   h_month_05_revenue NUMBER := 0;
   h_month_06_cost NUMBER := 0;
   h_month_06_revenue NUMBER := 0;
   h_month_07_cost NUMBER := 0;
   h_month_07_revenue NUMBER := 0;
   h_month_08_cost NUMBER := 0;
   h_month_08_revenue NUMBER := 0;
   h_month_09_cost NUMBER := 0;
   h_month_09_revenue NUMBER := 0;
   h_month_10_cost NUMBER := 0;
   h_month_10_revenue NUMBER := 0;
   h_month_11_cost NUMBER := 0;
   h_month_11_revenue NUMBER := 0;
   h_month_12_cost NUMBER := 0;
   h_month_12_revenue NUMBER := 0;
   h_period_actual_cost NUMBER := 0;
   h_period_actual_npv NUMBER := 0;
   h_period_actual_cost_npv NUMBER := 0;
   h_period_actual_revenue_npv NUMBER := 0;
   h_period_actual_revenue NUMBER := 0;
   h_period_bl1_cost NUMBER := 0;
   h_period_bl1_npv NUMBER := 0;
   h_period_bl1_cost_npv NUMBER := 0;
   h_period_bl1_revenue_npv NUMBER := 0;
   h_period_bl1_revenue NUMBER := 0;
   h_period_bl3_cost NUMBER := 0;
   h_period_bl3_npv NUMBER := 0;
   h_period_bl3_cost_npv NUMBER := 0;
   h_period_bl3_revenue_npv NUMBER := 0;
   h_period_bl3_revenue NUMBER := 0;
   h_period_estimated_cost NUMBER := 0;
   h_period_estimated_npv NUMBER := 0;
   h_period_estimated_cost_npv NUMBER := 0;
   h_period_estimated_revenue_npv NUMBER := 0;
   h_period_estimated_revenue NUMBER := 0;
   h_period_expected_cost NUMBER := 0;
   h_period_expected_npv NUMBER := 0;
   h_period_expected_cost_npv NUMBER := 0;
   h_period_expected_revenue_npv NUMBER := 0;
   h_period_expected_revenue NUMBER := 0;
   h_period_planned_cost NUMBER := 0;
   h_period_planned_npv NUMBER := 0;
   h_period_planned_cost_npv NUMBER := 0;
   h_period_planned_revenue_npv NUMBER := 0;
   h_period_planned_revenue NUMBER := 0;
   h_period_rate NUMBER := 0;
   h_year_cost NUMBER := 0;
   h_year_revenue NUMBER := 0;
   h_current_period PLS_INTEGER := 0;
   h_diff PLS_INTEGER := 0;
   h_last_period_month PLS_INTEGER := 0;
   h_last_period_year PLS_INTEGER := 0;
   h_period_actual_days PLS_INTEGER := 0;
   h_period_bl1_days PLS_INTEGER := 0;
   h_period_bl3_days PLS_INTEGER := 0;
   h_period_days PLS_INTEGER := 0;
   h_period_estimated_days PLS_INTEGER := 0;
   h_period_expected_days PLS_INTEGER := 0;
   h_period_month PLS_INTEGER := 0;
   h_period_planned_days PLS_INTEGER := 0;
   h_period_year PLS_INTEGER := 0;
   last_period_rate NUMBER NOT NULL := 0.0;
   h_month_01_revenue NUMBER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_timephased PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_PRJ_CC1 IS
         SELECT  START_DATE,
         FINISH_DATE,
         STATE_DAILY_COST,
         STATE_DAILY_REVENUE
         FROM PMO_FINANCIAL_CC
         WHERE PROJECT_ID = h_p_id
         AND CHARGECODE_ID = h_cc_id
         AND ELEMENT_TYPE = PMO_CNST.SC_DELIVERABLE_TYPE
         AND STATE_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
         AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
         AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10))
         ORDER BY START_DATE;

      CURSOR C_PRJ_CC2 IS
         SELECT  START_DATE,
         FINISH_DATE,
         STATE_DAILY_COST,
         STATE_DAILY_REVENUE
         FROM PMO_FINANCIAL_CC
         WHERE PROJECT_ID = h_p_id
         AND CHARGECODE_ID = h_cc_id
         AND ELEMENT_TYPE = PMO_CNST.SC_TASK_TYPE
         AND STATE_TYPE = PMO_CNST.SC_PLANNED_TYPE
         AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
         AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10))
         ORDER BY START_DATE;

      CURSOR C_PRJ_CC3 IS
         SELECT  START_DATE,
         FINISH_DATE,
         STATE_DAILY_COST,
         STATE_DAILY_REVENUE
         FROM PMO_FINANCIAL_CC
         WHERE PROJECT_ID = h_p_id
         AND CHARGECODE_ID = h_cc_id
         AND ELEMENT_TYPE = PMO_CNST.SC_TASK_TYPE
         AND STATE_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
         AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
         AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10))
         ORDER BY START_DATE;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PARSE_PERIODS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PARSE_PERIODS'), '-- ' || SYSTIMESTAMP, ':r := FC_PARSE_PERIODS(' || 
       '''' || h_p_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_period_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_period_count), 'NULL')
          || ', ' || '''' || h_p_rank || ''''
          || ', ' || COALESCE(NULLIF('''' || h_p_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_expected_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_expected_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_expected_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_est_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_plnd_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_plnd_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_plnd_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl1_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl1_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_est_bl1_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl3_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl3_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_est_bl3_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_actual_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_actual_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_actual_days), 'NULL')
          || ', ' || '''' || h_cc_id || ''''
          || ', ' || '''' || h_cc_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_cc_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_cc_labor_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_cc_billable), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_PERIODS', 284+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PARSE_PERIODS(285) : views_financial.sql(2967) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare host variables
   
   If Coalesce(h_period_type, 0) = PMO_CNST.SC_YEARLY Then
      --initilize period dates
      BEGIN
         SELECT (TO_DATE(SubStr((h_p_start), 1, 10)))
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 301+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(302) : views_financial.sql(2984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --initilize period dates
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 5) || '01-01', 1, 10)), 1 * 12) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 317+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(318) : views_financial.sql(3000) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_period_type, 0) = PMO_CNST.SC_MONTHLY Then
      --initilize period dates
      BEGIN
         SELECT (TO_DATE(SubStr((h_p_start), 1, 10)))
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 333+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(334) : views_financial.sql(3016) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --initilize period dates
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 349+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(350) : views_financial.sql(3032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --limit the period finish date
   If PMO_ORASTD.strcmp(h_p_finish, h_period_finish) < 0 Then
      h_p_finish := h_period_finish;
   End If;
   
   --Initialize all variables
   h_current_period := 1;
   
   BEGIN
      SELECT  MAX(BUDGET_YEAR),
      MIN(BUDGET_YEAR),
      CASE WHEN SUM(TOTAL_AMOUNT) > 0 THEN 1 ELSE 0 END
      INTO    h_max_year, h_min_year, h_timephased
      FROM PROJECT_BUDGET_BREAKDOWN PBB
      WHERE PBB.PROJECT_ID = h_p_id
      AND PBB.CHARGECODE_ID = h_cc_id
      AND PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 378+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(379) : views_financial.sql(3061) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If (h_timephased IS NOT NULL) AND (Coalesce(h_timephased, 0) > 0) Then
      If Coalesce(h_period_type, 0) = PMO_CNST.SC_YEARLY Then
         If ((Coalesce(h_max_year, 0) - Coalesce(h_min_year, 0)) + 1) > Coalesce(h_p_period_count, 0) Then
            h_p_period_count := (Coalesce(h_max_year, 0) - Coalesce(h_min_year, 0)) + 1;
         End If;
      ElsIf Coalesce(h_period_type, 0) = PMO_CNST.SC_MONTHLY Then
         If (((Coalesce(h_max_year, 0) - Coalesce(h_min_year, 0)) + 1) * 12) > Coalesce(
               h_p_period_count, 0) Then
            h_p_period_count := ((Coalesce(h_max_year, 0) - Coalesce(h_min_year, 0)) + 1) * 12;
         End If;
      End If;
   End If;
   
   WHILE Coalesce(h_current_period, 0) <= Coalesce(h_p_period_count, 0) LOOP
      h_period_days := 0;
      
      --get the number of days in the period
      BEGIN
         SELECT ( (PMO_ORASTD.DAYS(h_period_finish) - PMO_ORASTD.DAYS(h_period_start)) + 1 )
         INTO h_period_days
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 410+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(411) : views_financial.sql(3093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --get the period year, and month
      BEGIN
         SELECT PMO_ORASTD.YEAR(h_period_start), PMO_ORASTD.MONTH(h_period_start)
         INTO h_period_year, h_period_month
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 426+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(427) : views_financial.sql(3109) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_period_year, 0) <> Coalesce(h_last_period_year, 0) Then
         h_last_period_year := h_period_year;
         h_cc_actual_cost_ytd := 0.00;
         h_cc_actual_revenue_ytd := 0.00;
      End If;
      
      If Coalesce(h_period_month, 0) <> Coalesce(h_last_period_month, 0) Then
         h_last_period_month := h_period_month;
         h_cc_actual_cost_td := 0.00;
         h_cc_actual_revenue_td := 0.00;
      End If;
      
      --get the rate for the period
      BEGIN
         SELECT AVG(DISCOUNT_PERCENT)/100 INTO h_period_rate
         FROM PROJECT_DISCOUNT
         WHERE PROJECT_ID = h_p_id AND PMO_ORASTD.YEAR(DISCOUNT_DATE) = h_period_year;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 454+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(455) : views_financial.sql(3137) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_period_rate IS NULL Then
         h_period_rate := last_period_rate;
      Else
         last_period_rate := Coalesce(h_period_rate, 0);
      End If;
      
      --Temp hack
      If Coalesce(h_period_rate, 0) = 0.00 Then
         h_period_rate := 1.00;
      End If;
      
      If (h_timephased IS NOT NULL) AND (Coalesce(h_timephased, 0) > 0) Then
         h_year_cost := 0.00;
         h_year_revenue := 0.00;
         
         h_period_expected_start := h_period_start;
         h_period_expected_finish := h_period_finish;
         h_period_bl1_start := h_period_start;
         h_period_bl1_finish := h_period_finish;
         h_period_bl3_start := h_period_start;
         h_period_bl3_finish := h_period_finish;
         
         If Coalesce(h_period_type, 0) = PMO_CNST.SC_YEARLY Then
            BEGIN
               SELECT  PBB.TOTAL_AMOUNT,
               APBB.TOTAL_AMOUNT
               INTO    h_year_cost,
               h_year_revenue
               FROM PROJECT_BUDGET_BREAKDOWN PBB
               JOIN TMT_CHARGECODES CC
               ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
               JOIN BUDGETS B
               ON B.PROJECT_ID = PBB.PROJECT_ID
               AND B.ELEMENT_ID = PBB.PROJECT_ID
               AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
               LEFT JOIN BUDGETS AB
               ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
               LEFT JOIN PROJECT_BUDGET_BREAKDOWN APBB
               ON APBB.PROJECT_ID = AB.PROJECT_ID
               AND APBB.CHARGECODE_ID = AB.CHARGECODE_ID
               AND APBB.BUDGET_YEAR = PBB.BUDGET_YEAR
               AND APBB.BUDGET_TYPE = PBB.BUDGET_TYPE
               LEFT JOIN TMT_CHARGECODES ACC
               ON CC.ELEMENT_ID = APBB.CHARGECODE_ID
               WHERE PBB.PROJECT_ID = h_p_id
               AND PBB.CHARGECODE_ID = h_cc_id
               AND PBB.BUDGET_YEAR = h_period_year
               AND PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATE;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 513+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(514) : views_financial.sql(3196) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_year_cost, 0) + Coalesce(h_year_revenue, 0)) > 0.00 Then
               h_period_expected_cost := Coalesce(h_year_cost, 0);
               h_period_expected_revenue := Coalesce(h_year_revenue, 0);
            End If;
            
            h_year_cost := 0.00;
            h_year_revenue := 0.00;
            
            BEGIN
               SELECT  PBB.TOTAL_AMOUNT,
               APBB.TOTAL_AMOUNT
               INTO    h_year_cost,
               h_year_revenue
               FROM PROJECT_BUDGET_BREAKDOWN PBB
               JOIN TMT_CHARGECODES CC
               ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
               JOIN BUDGETS B
               ON B.PROJECT_ID = PBB.PROJECT_ID
               AND B.ELEMENT_ID = PBB.PROJECT_ID
               AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
               LEFT JOIN BUDGETS AB
               ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
               LEFT JOIN PROJECT_BUDGET_BREAKDOWN APBB
               ON APBB.PROJECT_ID = AB.PROJECT_ID
               AND APBB.CHARGECODE_ID = AB.CHARGECODE_ID
               AND APBB.BUDGET_YEAR = PBB.BUDGET_YEAR
               AND APBB.BUDGET_TYPE = PBB.BUDGET_TYPE
               LEFT JOIN TMT_CHARGECODES ACC
               ON CC.ELEMENT_ID = APBB.CHARGECODE_ID
               WHERE PBB.PROJECT_ID = h_p_id
               AND PBB.CHARGECODE_ID = h_cc_id
               AND PBB.BUDGET_YEAR = h_period_year
               AND PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE1;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 557+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(558) : views_financial.sql(3240) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_year_cost, 0) + Coalesce(h_year_revenue, 0)) > 0.00 Then
               h_period_bl1_cost := Coalesce(h_year_cost, 0);
               h_period_bl1_revenue := Coalesce(h_year_revenue, 0);
            End If;
            
            BEGIN
               SELECT  PBB.TOTAL_AMOUNT,
               APBB.TOTAL_AMOUNT
               INTO    h_year_cost,
               h_year_revenue
               FROM PROJECT_BUDGET_BREAKDOWN PBB
               JOIN TMT_CHARGECODES CC
               ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
               JOIN BUDGETS B
               ON B.PROJECT_ID = PBB.PROJECT_ID
               AND B.ELEMENT_ID = PBB.PROJECT_ID
               AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
               LEFT JOIN BUDGETS AB
               ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
               LEFT JOIN PROJECT_BUDGET_BREAKDOWN APBB
               ON APBB.PROJECT_ID = AB.PROJECT_ID
               AND APBB.CHARGECODE_ID = AB.CHARGECODE_ID
               AND APBB.BUDGET_YEAR = PBB.BUDGET_YEAR
               AND APBB.BUDGET_TYPE = PBB.BUDGET_TYPE
               LEFT JOIN TMT_CHARGECODES ACC
               ON CC.ELEMENT_ID = APBB.CHARGECODE_ID
               WHERE PBB.PROJECT_ID = h_p_id
               AND PBB.CHARGECODE_ID = h_cc_id
               AND PBB.BUDGET_YEAR = h_period_year
               AND PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE3;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 598+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(599) : views_financial.sql(3281) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_year_cost, 0) + Coalesce(h_year_revenue, 0)) > 0.00 Then
               h_period_bl3_cost := Coalesce(h_year_cost, 0);
               h_period_bl3_revenue := Coalesce(h_year_revenue, 0);
            End If;
         ElsIf Coalesce(h_period_type, 0) = PMO_CNST.SC_MONTHLY Then
            BEGIN
               SELECT  PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT, PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT,
               PBB.MONTH_06_AMOUNT, PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT, PBB.MONTH_10_AMOUNT,
               PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT, PBB.TOTAL_AMOUNT,
               APBB.MONTH_01_AMOUNT, APBB.MONTH_02_AMOUNT, APBB.MONTH_03_AMOUNT, APBB.MONTH_04_AMOUNT, APBB.MONTH_05_AMOUNT,
               APBB.MONTH_06_AMOUNT, APBB.MONTH_07_AMOUNT, APBB.MONTH_08_AMOUNT, APBB.MONTH_09_AMOUNT, APBB.MONTH_10_AMOUNT,
               APBB.MONTH_11_AMOUNT, APBB.MONTH_12_AMOUNT, APBB.TOTAL_AMOUNT
               INTO
               h_month_01_cost, h_month_02_cost, h_month_03_cost, h_month_04_cost, h_month_05_cost,
               h_month_06_cost, h_month_07_cost, h_month_08_cost, h_month_09_cost, h_month_10_cost,
               h_month_11_cost, h_month_12_cost, h_year_cost,
               h_month_01_revenue, h_month_02_revenue, h_month_03_revenue, h_month_04_revenue, h_month_05_revenue,
               h_month_06_revenue, h_month_07_revenue, h_month_08_revenue, h_month_09_revenue, h_month_10_revenue,
               h_month_11_revenue, h_month_12_revenue, h_year_revenue
               FROM PROJECT_BUDGET_BREAKDOWN PBB
               JOIN TMT_CHARGECODES CC
               ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
               JOIN BUDGETS B
               ON B.PROJECT_ID = PBB.PROJECT_ID
               AND B.ELEMENT_ID = PBB.PROJECT_ID
               AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
               LEFT JOIN BUDGETS AB
               ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
               LEFT JOIN PROJECT_BUDGET_BREAKDOWN APBB
               ON APBB.PROJECT_ID = AB.PROJECT_ID
               AND APBB.CHARGECODE_ID = AB.CHARGECODE_ID
               AND APBB.BUDGET_YEAR = PBB.BUDGET_YEAR
               AND APBB.BUDGET_TYPE = PBB.BUDGET_TYPE
               LEFT JOIN TMT_CHARGECODES ACC
               ON CC.ELEMENT_ID = APBB.CHARGECODE_ID
               WHERE PBB.PROJECT_ID = h_p_id
               AND PBB.CHARGECODE_ID = h_cc_id
               AND PBB.BUDGET_YEAR = h_period_year
               AND PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATE;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 648+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(649) : views_financial.sql(3331) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_year_cost, 0) + Coalesce(h_year_revenue, 0)) > 0.00 Then
               If Coalesce(h_period_month, 0) = 1 Then
                  h_period_expected_cost := Coalesce(h_month_01_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_01_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 2 Then
                  h_period_expected_cost := Coalesce(h_month_02_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_02_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 3 Then
                  h_period_expected_cost := Coalesce(h_month_03_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_03_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 4 Then
                  h_period_expected_cost := Coalesce(h_month_04_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_04_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 5 Then
                  h_period_expected_cost := Coalesce(h_month_05_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_05_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 6 Then
                  h_period_expected_cost := Coalesce(h_month_06_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_06_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 7 Then
                  h_period_expected_cost := Coalesce(h_month_07_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_07_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 8 Then
                  h_period_expected_cost := Coalesce(h_month_08_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_08_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 9 Then
                  h_period_expected_cost := Coalesce(h_month_09_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_09_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 10 Then
                  h_period_expected_cost := Coalesce(h_month_10_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_10_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 11 Then
                  h_period_expected_cost := Coalesce(h_month_11_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_11_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 12 Then
                  h_period_expected_cost := Coalesce(h_month_12_cost, 0);
                  h_period_expected_revenue := Coalesce(h_month_12_revenue, 0);
               End If;
               
               If Coalesce(h_period_month, 0) = 1 Then
                  h_period_estimated_cost := Coalesce(h_month_01_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_01_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 2 Then
                  h_period_estimated_cost := Coalesce(h_month_02_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_02_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 3 Then
                  h_period_estimated_cost := Coalesce(h_month_03_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_03_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 4 Then
                  h_period_estimated_cost := Coalesce(h_month_04_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_04_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 5 Then
                  h_period_estimated_cost := Coalesce(h_month_05_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_05_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 6 Then
                  h_period_estimated_cost := Coalesce(h_month_06_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_06_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 7 Then
                  h_period_estimated_cost := Coalesce(h_month_07_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_07_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 8 Then
                  h_period_estimated_cost := Coalesce(h_month_08_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_08_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 9 Then
                  h_period_estimated_cost := Coalesce(h_month_09_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_09_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 10 Then
                  h_period_estimated_cost := Coalesce(h_month_10_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_10_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 11 Then
                  h_period_estimated_cost := Coalesce(h_month_11_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_11_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 12 Then
                  h_period_estimated_cost := Coalesce(h_month_12_cost, 0);
                  h_period_estimated_revenue := Coalesce(h_month_12_revenue, 0);
               End If;
            End If;
            
            h_year_cost := 0.00;
            h_year_revenue := 0.00;
            
            BEGIN
               SELECT  PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT, PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT,
               PBB.MONTH_06_AMOUNT, PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT, PBB.MONTH_10_AMOUNT,
               PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT, PBB.TOTAL_AMOUNT,
               APBB.MONTH_01_AMOUNT, APBB.MONTH_02_AMOUNT, APBB.MONTH_03_AMOUNT, APBB.MONTH_04_AMOUNT, APBB.MONTH_05_AMOUNT,
               APBB.MONTH_06_AMOUNT, APBB.MONTH_07_AMOUNT, APBB.MONTH_08_AMOUNT, APBB.MONTH_09_AMOUNT, APBB.MONTH_10_AMOUNT,
               APBB.MONTH_11_AMOUNT, APBB.MONTH_12_AMOUNT, APBB.TOTAL_AMOUNT
               INTO
               h_month_01_cost, h_month_02_cost, h_month_03_cost, h_month_04_cost, h_month_05_cost,
               h_month_06_cost, h_month_07_cost, h_month_08_cost, h_month_09_cost, h_month_10_cost,
               h_month_11_cost, h_month_12_cost, h_year_cost,
               h_month_01_revenue, h_month_02_revenue, h_month_03_revenue, h_month_04_revenue, h_month_05_revenue,
               h_month_06_revenue, h_month_07_revenue, h_month_08_revenue, h_month_09_revenue, h_month_10_revenue,
               h_month_11_revenue, h_month_12_revenue, h_year_revenue
               FROM PROJECT_BUDGET_BREAKDOWN PBB
               JOIN TMT_CHARGECODES CC
               ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
               JOIN BUDGETS B
               ON B.PROJECT_ID = PBB.PROJECT_ID
               AND B.ELEMENT_ID = PBB.PROJECT_ID
               AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
               LEFT JOIN BUDGETS AB
               ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
               LEFT JOIN PROJECT_BUDGET_BREAKDOWN APBB
               ON APBB.PROJECT_ID = AB.PROJECT_ID
               AND APBB.CHARGECODE_ID = AB.CHARGECODE_ID
               AND APBB.BUDGET_YEAR = PBB.BUDGET_YEAR
               AND APBB.BUDGET_TYPE = PBB.BUDGET_TYPE
               LEFT JOIN TMT_CHARGECODES ACC
               ON CC.ELEMENT_ID = APBB.CHARGECODE_ID
               WHERE PBB.PROJECT_ID = h_p_id
               AND PBB.CHARGECODE_ID = h_cc_id
               AND PBB.BUDGET_YEAR = h_period_year
               AND PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE1;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 774+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(775) : views_financial.sql(3457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_year_cost, 0) + Coalesce(h_year_revenue, 0)) > 0.00 Then
               If Coalesce(h_period_month, 0) = 1 Then
                  h_period_bl1_cost := Coalesce(h_month_01_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_01_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 2 Then
                  h_period_bl1_cost := Coalesce(h_month_02_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_02_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 3 Then
                  h_period_bl1_cost := Coalesce(h_month_03_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_03_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 4 Then
                  h_period_bl1_cost := Coalesce(h_month_04_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_04_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 5 Then
                  h_period_bl1_cost := Coalesce(h_month_05_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_05_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 6 Then
                  h_period_bl1_cost := Coalesce(h_month_06_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_06_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 7 Then
                  h_period_bl1_cost := Coalesce(h_month_07_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_07_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 8 Then
                  h_period_bl1_cost := Coalesce(h_month_08_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_08_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 9 Then
                  h_period_bl1_cost := Coalesce(h_month_09_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_09_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 10 Then
                  h_period_bl1_cost := Coalesce(h_month_10_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_10_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 11 Then
                  h_period_bl1_cost := Coalesce(h_month_11_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_11_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 12 Then
                  h_period_bl1_cost := Coalesce(h_month_12_cost, 0);
                  h_period_bl1_revenue := Coalesce(h_month_12_revenue, 0);
               End If;
            End If;
            
            h_year_cost := 0.00;
            h_year_revenue := 0.00;
            
            BEGIN
               SELECT  PBB.MONTH_01_AMOUNT, PBB.MONTH_02_AMOUNT, PBB.MONTH_03_AMOUNT, PBB.MONTH_04_AMOUNT, PBB.MONTH_05_AMOUNT,
               PBB.MONTH_06_AMOUNT, PBB.MONTH_07_AMOUNT, PBB.MONTH_08_AMOUNT, PBB.MONTH_09_AMOUNT, PBB.MONTH_10_AMOUNT,
               PBB.MONTH_11_AMOUNT, PBB.MONTH_12_AMOUNT, PBB.TOTAL_AMOUNT,
               APBB.MONTH_01_AMOUNT, APBB.MONTH_02_AMOUNT, APBB.MONTH_03_AMOUNT, APBB.MONTH_04_AMOUNT, APBB.MONTH_05_AMOUNT,
               APBB.MONTH_06_AMOUNT, APBB.MONTH_07_AMOUNT, APBB.MONTH_08_AMOUNT, APBB.MONTH_09_AMOUNT, APBB.MONTH_10_AMOUNT,
               APBB.MONTH_11_AMOUNT, APBB.MONTH_12_AMOUNT, APBB.TOTAL_AMOUNT
               INTO
               h_month_01_cost, h_month_02_cost, h_month_03_cost, h_month_04_cost, h_month_05_cost,
               h_month_06_cost, h_month_07_cost, h_month_08_cost, h_month_09_cost, h_month_10_cost,
               h_month_11_cost, h_month_12_cost, h_year_cost,
               h_month_01_revenue, h_month_02_revenue, h_month_03_revenue, h_month_04_revenue, h_month_05_revenue,
               h_month_06_revenue, h_month_07_revenue, h_month_08_revenue, h_month_09_revenue, h_month_10_revenue,
               h_month_11_revenue, h_month_12_revenue, h_year_revenue
               FROM PROJECT_BUDGET_BREAKDOWN PBB
               JOIN TMT_CHARGECODES CC
               ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
               JOIN BUDGETS B
               ON B.PROJECT_ID = PBB.PROJECT_ID
               AND B.ELEMENT_ID = PBB.PROJECT_ID
               AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
               LEFT JOIN BUDGETS AB
               ON AB.BUDGET_ID = B.ASSOCIATE_BUDGET_ID
               LEFT JOIN PROJECT_BUDGET_BREAKDOWN APBB
               ON APBB.PROJECT_ID = AB.PROJECT_ID
               AND APBB.CHARGECODE_ID = AB.CHARGECODE_ID
               AND APBB.BUDGET_YEAR = PBB.BUDGET_YEAR
               AND APBB.BUDGET_TYPE = PBB.BUDGET_TYPE
               LEFT JOIN TMT_CHARGECODES ACC
               ON CC.ELEMENT_ID = APBB.CHARGECODE_ID
               WHERE PBB.PROJECT_ID = h_p_id
               AND PBB.CHARGECODE_ID = h_cc_id
               AND PBB.BUDGET_YEAR = h_period_year
               AND PBB.BUDGET_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE3;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 862+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(863) : views_financial.sql(3545) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_year_cost, 0) + Coalesce(h_year_revenue, 0)) > 0.00 Then
               If Coalesce(h_period_month, 0) = 1 Then
                  h_period_bl3_cost := Coalesce(h_month_01_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_01_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 2 Then
                  h_period_bl3_cost := Coalesce(h_month_02_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_02_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 3 Then
                  h_period_bl3_cost := Coalesce(h_month_03_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_03_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 4 Then
                  h_period_bl3_cost := Coalesce(h_month_04_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_04_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 5 Then
                  h_period_bl3_cost := Coalesce(h_month_05_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_05_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 6 Then
                  h_period_bl3_cost := Coalesce(h_month_06_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_06_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 7 Then
                  h_period_bl3_cost := Coalesce(h_month_07_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_07_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 8 Then
                  h_period_bl3_cost := Coalesce(h_month_08_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_08_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 9 Then
                  h_period_bl3_cost := Coalesce(h_month_09_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_09_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 10 Then
                  h_period_bl3_cost := Coalesce(h_month_10_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_10_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 11 Then
                  h_period_bl3_cost := Coalesce(h_month_11_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_11_revenue, 0);
               ElsIf Coalesce(h_period_month, 0) = 12 Then
                  h_period_bl3_cost := Coalesce(h_month_12_cost, 0);
                  h_period_bl3_revenue := Coalesce(h_month_12_revenue, 0);
               End If;
            End If;
         End If;
      Else
         --EXPECTED ********************************************************************
         BEGIN
            SELECT  START_DATE,
            FINISH_DATE,
            STATE_DAILY_COST,
            STATE_DAILY_REVENUE
            INTO    h_cc_expected_start,
            h_cc_expected_finish,
            h_cc_expected_cost_pd,
            h_cc_expected_revenue_pd
            FROM PMO_FINANCIAL_CC
            WHERE PROJECT_ID = h_p_id
            AND CHARGECODE_ID = h_cc_id
            AND ELEMENT_TYPE = PMO_CNST.SC_PROJECT_TYPE
            AND STATE_TYPE = PMO_CNST.SC_EXPECTED_TYPE
            AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
            AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 931+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(932) : views_financial.sql(3614) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (h_cc_expected_start IS NOT NULL) AND (h_cc_expected_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
               h_cc_expected_start, h_cc_expected_finish) <= 0) Then
            If (PMO_ORASTD.strcmp(h_period_start, h_cc_expected_start) >= 0) AND (PMO_ORASTD.strcmp(
                  h_period_start, h_cc_expected_finish) <= 0) Then
               If PMO_ORASTD.strcmp(h_cc_expected_start, h_period_start) > 0 Then
                  h_period_expected_start := h_cc_expected_start;
               Else
                  h_period_expected_start := h_period_start;
               End If;
               
               If PMO_ORASTD.strcmp(h_cc_expected_finish, h_period_finish) < 0 Then
                  h_period_expected_finish := h_cc_expected_finish;
               Else
                  h_period_expected_finish := h_period_finish;
               End If;
               
               BEGIN
                  SELECT ( (PMO_ORASTD.DAYS(h_period_expected_finish) - PMO_ORASTD.DAYS(h_period_expected_start)) + 1 )
                  INTO h_period_expected_days
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 962+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(963) : views_financial.sql(3645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_period_expected_start := NULL;
               h_period_expected_finish := NULL;
               h_period_expected_days := 0;
            End If;
            
            h_period_expected_cost := Coalesce(h_cc_expected_cost_pd, 0) * Coalesce(h_period_expected_days, 0);
            h_period_expected_revenue := Coalesce(h_cc_expected_revenue_pd, 0) * Coalesce(
                                      h_period_expected_days, 0);
         Else
            h_period_expected_start := NULL;
            h_period_expected_finish := NULL;
            h_period_expected_days := 0;
            h_period_expected_cost := 0.00;
            h_period_expected_revenue := 0.00;
            h_period_expected_npv := 0.00;
            h_period_expected_cost_npv := 0.00;
            h_period_expected_revenue_npv := 0.00;
         End If;
         
         --BASELINE1 ********************************************************************
         BEGIN
            SELECT  START_DATE,
            FINISH_DATE,
            STATE_DAILY_COST,
            STATE_DAILY_REVENUE
            INTO    h_cc_bl1_start,
            h_cc_bl1_finish,
            h_cc_bl1_cost_pd,
            h_cc_bl1_revenue_pd
            FROM PMO_FINANCIAL_CC
            WHERE PROJECT_ID = h_p_id
            AND CHARGECODE_ID = h_cc_id
            AND ELEMENT_TYPE = PMO_CNST.SC_PROJECT_TYPE
            AND STATE_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE1
            AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
            AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1009+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1010) : views_financial.sql(3692) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (h_cc_bl1_start IS NOT NULL) AND (h_cc_bl1_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
               h_cc_bl1_start, h_cc_bl1_finish) <= 0) Then
            If (PMO_ORASTD.strcmp(h_period_start, h_cc_bl1_start) >= 0) AND (PMO_ORASTD.strcmp(h_period_start
                  , h_cc_bl1_finish) <= 0) Then
               If PMO_ORASTD.strcmp(h_cc_bl1_start, h_period_start) > 0 Then
                  h_period_bl1_start := h_cc_bl1_start;
               Else
                  h_period_bl1_start := h_period_start;
               End If;
               
               If PMO_ORASTD.strcmp(h_cc_bl1_finish, h_period_finish) < 0 Then
                  h_period_bl1_finish := h_cc_bl1_finish;
               Else
                  h_period_bl1_finish := h_period_finish;
               End If;
               
               BEGIN
                  SELECT ( (PMO_ORASTD.DAYS(h_period_bl1_finish) - PMO_ORASTD.DAYS(h_period_bl1_start)) + 1 )
                  INTO h_period_bl1_days
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1040+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1041) : views_financial.sql(3723) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_period_bl1_start := NULL;
               h_period_bl1_finish := NULL;
               h_period_bl1_days := 0;
            End If;
            
            h_period_bl1_cost := Coalesce(h_cc_bl1_cost_pd, 0) * Coalesce(h_period_bl1_days, 0);
            h_period_bl1_revenue := Coalesce(h_cc_bl1_revenue_pd, 0) * Coalesce(h_period_bl1_days, 0);
         Else
            h_period_bl1_start := NULL;
            h_period_bl1_finish := NULL;
            h_period_bl1_days := 0;
            h_period_bl1_cost := 0.00;
            h_period_bl1_revenue := 0.00;
            h_period_bl1_npv := 0.00;
            h_period_bl1_cost_npv := 0.00;
            h_period_bl1_revenue_npv := 0.00;
         End If;
         
         --BASELINE3 ********************************************************************
         BEGIN
            SELECT  START_DATE,
            FINISH_DATE,
            STATE_DAILY_COST,
            STATE_DAILY_REVENUE
            INTO    h_cc_bl3_start,
            h_cc_bl3_finish,
            h_cc_bl3_cost_pd,
            h_cc_bl3_revenue_pd
            FROM PMO_FINANCIAL_CC
            WHERE PROJECT_ID = h_p_id
            AND CHARGECODE_ID = h_cc_id
            AND ELEMENT_TYPE = PMO_CNST.SC_PROJECT_TYPE
            AND STATE_TYPE = PMO_CNST.SC_ESTIMATED_BASELINE1
            AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
            AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1086+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1087) : views_financial.sql(3769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If (h_cc_bl3_start IS NOT NULL) AND (h_cc_bl3_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
               h_cc_bl3_start, h_cc_bl3_finish) <= 0) Then
            If (PMO_ORASTD.strcmp(h_period_start, h_cc_bl3_start) >= 0) AND (PMO_ORASTD.strcmp(h_period_start
                  , h_cc_bl3_finish) <= 0) Then
               If PMO_ORASTD.strcmp(h_cc_bl3_start, h_period_start) > 0 Then
                  h_period_bl3_start := h_cc_bl3_start;
               Else
                  h_period_bl3_start := h_period_start;
               End If;
               
               If PMO_ORASTD.strcmp(h_cc_bl3_finish, h_period_finish) < 0 Then
                  h_period_bl3_finish := h_cc_bl3_finish;
               Else
                  h_period_bl3_finish := h_period_finish;
               End If;
               
               BEGIN
                  SELECT ( (PMO_ORASTD.DAYS(h_period_bl3_finish) - PMO_ORASTD.DAYS(h_period_bl3_start)) + 1 )
                  INTO h_period_bl3_days
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1117+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1118) : views_financial.sql(3800) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_period_bl3_start := NULL;
               h_period_bl3_finish := NULL;
               h_period_bl3_days := 0;
            End If;
            
            h_period_bl3_cost := Coalesce(h_cc_bl3_cost_pd, 0) * Coalesce(h_period_bl3_days, 0);
            h_period_bl3_revenue := Coalesce(h_cc_bl3_revenue_pd, 0) * Coalesce(h_period_bl3_days, 0);
         Else
            h_period_bl3_start := NULL;
            h_period_bl3_finish := NULL;
            h_period_bl3_days := 0;
            h_period_bl3_cost := 0.00;
            h_period_bl3_revenue := 0.00;
            h_period_bl3_npv := 0.00;
            h_period_bl3_cost_npv := 0.00;
            h_period_bl3_revenue_npv := 0.00;
         End If;
      End If;
      
      --ESTIMATED ********************************************************************
      
      OPEN C_PRJ_CC1;
      
      LOOP
         FETCH C_PRJ_CC1 INTO    h_cc_estimated_start,
         h_cc_estimated_finish,
         h_cc_estimated_cost_pd,
         h_cc_estimated_revenue_pd;
         IF C_PRJ_CC1%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_cc_estimated_start IS NOT NULL) AND (h_cc_estimated_finish IS NOT NULL) 
               AND (PMO_ORASTD.strcmp(h_cc_estimated_start, h_cc_estimated_finish) <= 0) Then
            If (PMO_ORASTD.strcmp(h_period_start, h_cc_estimated_start) >= 0) AND (PMO_ORASTD.strcmp(
                  h_period_start, h_cc_estimated_finish) <= 0) Then
               If PMO_ORASTD.strcmp(h_cc_estimated_start, h_period_start) > 0 Then
                  h_period_estimated_start := h_cc_estimated_start;
               Else
                  h_period_estimated_start := h_period_start;
               End If;
               
               If PMO_ORASTD.strcmp(h_cc_estimated_finish, h_period_finish) < 0 Then
                  h_period_estimated_finish := h_cc_estimated_finish;
               Else
                  h_period_estimated_finish := h_period_finish;
               End If;
               
               BEGIN
                  SELECT ( (PMO_ORASTD.DAYS(h_period_estimated_finish) - PMO_ORASTD.DAYS(h_period_estimated_start)) + 1 )
                  INTO h_period_estimated_days
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1185+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1186) : views_financial.sql(3868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_period_estimated_days := 0;
            End If;
            
            h_period_estimated_cost := Coalesce(h_period_estimated_cost, 0) + (Coalesce(
                                    h_cc_estimated_cost_pd, 0) * Coalesce(
                                    h_period_estimated_days, 0));
            h_period_estimated_revenue := Coalesce(h_period_estimated_revenue, 0) + (Coalesce(
                                       h_cc_estimated_revenue_pd, 0) * Coalesce(
                                       h_period_estimated_days, 0));
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_PRJ_CC1 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1210+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1211) : views_financial.sql(3893) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  CASE
         WHEN MIN(COALESCE(START_DATE, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL
         ELSE MIN(START_DATE)
         END,
         CASE
         WHEN MAX(COALESCE(FINISH_DATE, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL
         ELSE MAX(FINISH_DATE)
         END
         INTO    h_period_estimated_start,
         h_period_estimated_finish
         FROM PMO_FINANCIAL_CC
         WHERE PROJECT_ID = h_p_id
         AND CHARGECODE_ID = h_cc_id
         AND ELEMENT_TYPE = PMO_CNST.SC_DELIVERABLE_TYPE
         AND STATE_TYPE = PMO_CNST.SC_ESTIMATED_BUDGET
         AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
         AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1239+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1240) : views_financial.sql(3922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --PLANNED ********************************************************************
      
      OPEN C_PRJ_CC2;
      
      LOOP
         FETCH C_PRJ_CC2 INTO    h_cc_planned_start,
         h_cc_planned_finish,
         h_cc_planned_cost_pd,
         h_cc_planned_revenue_pd;
         IF C_PRJ_CC2%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_cc_planned_start IS NOT NULL) AND (h_cc_planned_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
               h_cc_planned_start, h_cc_planned_finish) <= 0) Then
            If (PMO_ORASTD.strcmp(h_period_start, h_cc_planned_start) >= 0) AND (PMO_ORASTD.strcmp(
                  h_period_start, h_cc_planned_finish) <= 0) Then
               If PMO_ORASTD.strcmp(h_cc_planned_start, h_period_start) > 0 Then
                  h_period_planned_start := h_cc_planned_start;
               Else
                  h_period_planned_start := h_period_start;
               End If;
               
               If PMO_ORASTD.strcmp(h_cc_planned_finish, h_period_finish) < 0 Then
                  h_period_planned_finish := h_cc_planned_finish;
               Else
                  h_period_planned_finish := h_period_finish;
               End If;
               
               BEGIN
                  SELECT ( (PMO_ORASTD.DAYS(h_period_planned_finish) - PMO_ORASTD.DAYS(h_period_planned_start)) + 1 )
                  INTO h_period_planned_days
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1288+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1289) : views_financial.sql(3971) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_period_planned_days := 0;
            End If;
            
            h_period_planned_cost := Coalesce(h_period_planned_cost, 0) + (Coalesce(h_cc_planned_cost_pd, 0) 
                                  * Coalesce(h_period_planned_days, 0));
            h_period_planned_revenue := Coalesce(h_period_planned_revenue, 0) + (Coalesce(
                                     h_cc_planned_revenue_pd, 0) * Coalesce(
                                     h_period_planned_days, 0));
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_PRJ_CC2 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1312+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1313) : views_financial.sql(3995) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  CASE
         WHEN MIN(COALESCE(START_DATE, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL
         ELSE MIN(START_DATE)
         END,
         CASE
         WHEN MAX(COALESCE(FINISH_DATE, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL
         ELSE MAX(FINISH_DATE)
         END
         INTO    h_period_planned_start,
         h_period_planned_finish
         FROM PMO_FINANCIAL_CC
         WHERE PROJECT_ID = h_p_id
         AND CHARGECODE_ID = h_cc_id
         AND ELEMENT_TYPE = PMO_CNST.SC_TASK_TYPE
         AND STATE_TYPE = PMO_CNST.SC_PLANNED_TYPE
         AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
         AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1341+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1342) : views_financial.sql(4024) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --ACTUAL ********************************************************************
      
      OPEN C_PRJ_CC3;
      
      LOOP
         FETCH C_PRJ_CC3 INTO    h_cc_actual_start,
         h_cc_actual_finish,
         h_cc_actual_cost_pd,
         h_cc_actual_revenue_pd;
         IF C_PRJ_CC3%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If (h_cc_actual_start IS NOT NULL) AND (h_cc_actual_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
               h_cc_actual_start, h_cc_actual_finish) <= 0) Then
            If (PMO_ORASTD.strcmp(h_period_start, h_cc_actual_start) >= 0) AND (PMO_ORASTD.strcmp(h_period_start
                  , h_cc_actual_finish) <= 0) Then
               If PMO_ORASTD.strcmp(h_cc_actual_start, h_period_start) > 0 Then
                  h_period_actual_start := h_cc_actual_start;
               Else
                  h_period_actual_start := h_period_start;
               End If;
               
               If PMO_ORASTD.strcmp(h_cc_actual_finish, h_period_finish) < 0 Then
                  h_period_actual_finish := h_cc_actual_finish;
               Else
                  h_period_actual_finish := h_period_finish;
               End If;
               
               BEGIN
                  SELECT ( (PMO_ORASTD.DAYS(h_period_actual_finish) - PMO_ORASTD.DAYS(h_period_actual_start)) + 1 )
                  INTO h_period_actual_days
                  FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1390+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1391) : views_financial.sql(4073) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               h_period_actual_days := 0;
            End If;
            
            h_period_actual_cost := Coalesce(h_period_actual_cost, 0) + (Coalesce(h_cc_actual_cost_pd, 0) 
                                 * Coalesce(h_period_actual_days, 0));
            
            --initilize period dates
            BEGIN
               SELECT COALESCE(SUM((ACTUAL_AMOUNT + TAX1_AMOUNT + TAX2_AMOUNT)), 0.00) + h_period_actual_cost
               INTO h_period_actual_cost
               FROM TMT_COSTS
               WHERE PROJECT_ID = h_p_id
               AND CHARGECODE_ID = h_cc_id
               AND TO_DATE(SubStr(INVOICE_DATETIME, 1, 10)) BETWEEN h_period_actual_start AND h_period_actual_finish
               AND TYPE_ID = PMO_CNST.SC_COST;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1416+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1417) : views_financial.sql(4099) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_period_actual_revenue := Coalesce(h_period_actual_revenue, 0) + (Coalesce(
                                    h_cc_actual_revenue_pd, 0) * Coalesce(h_period_actual_days, 0));
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_PRJ_CC3 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1434+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1435) : views_financial.sql(4117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  CASE
         WHEN MIN(COALESCE(START_DATE, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL
         ELSE MIN(START_DATE)
         END,
         CASE
         WHEN MAX(COALESCE(FINISH_DATE, TO_DATE('1899-01-01'))) = TO_DATE(SubStr(TO_DATE('1899-01-01'), 1, 10)) THEN NULL
         ELSE MAX(FINISH_DATE)
         END
         INTO    h_period_actual_start,
         h_period_actual_finish
         FROM PMO_FINANCIAL_CC
         WHERE PROJECT_ID = h_p_id
         AND CHARGECODE_ID = h_cc_id
         AND ELEMENT_TYPE = PMO_CNST.SC_TASK_TYPE
         AND STATE_TYPE = PMO_CNST.SC_ACTUAL_BUDGET
         AND TO_DATE(SubStr(FINISH_DATE, 1, 10)) >= TO_DATE(SubStr(h_period_start, 1, 10))
         AND TO_DATE(SubStr(START_DATE, 1, 10)) <= TO_DATE(SubStr(h_period_finish, 1, 10));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1463+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1464) : views_financial.sql(4146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_cc_type, 0) = 2 Then
         h_period_expected_revenue := Coalesce(h_period_expected_cost, 0);
         h_period_estimated_revenue := Coalesce(h_period_estimated_cost, 0);
         h_period_bl1_revenue := Coalesce(h_period_bl1_cost, 0);
         h_period_bl3_revenue := Coalesce(h_period_bl3_cost, 0);
         h_period_planned_revenue := Coalesce(h_period_planned_cost, 0);
         h_period_actual_revenue := Coalesce(h_period_actual_cost, 0);
         
         h_period_expected_cost := 0.00;
         h_period_estimated_cost := 0.00;
         h_period_bl1_cost := 0.00;
         h_period_bl3_cost := 0.00;
         h_period_planned_cost := 0.00;
         h_period_actual_cost := 0.00;
      End If;
      
      h_cc_actual_cost_td := Coalesce(h_cc_actual_cost_td, 0) + Coalesce(h_period_actual_cost, 0);
      h_cc_actual_cost_ytd := Coalesce(h_cc_actual_cost_ytd, 0) + Coalesce(h_period_actual_cost, 0);
      h_cc_actual_revenue_td := Coalesce(h_cc_actual_revenue_td, 0) + Coalesce(h_period_actual_revenue, 0);
      h_cc_actual_revenue_ytd := Coalesce(h_cc_actual_revenue_ytd, 0) + Coalesce(
                                    h_period_actual_revenue, 0);
      
      h_cc_expected_gp := (Coalesce(h_period_expected_revenue, 0) - Coalesce(h_period_expected_cost, 0));
      h_cc_estimated_gp := (Coalesce(h_period_estimated_revenue, 0) - Coalesce(
                               h_period_estimated_cost, 0));
      h_cc_bl1_gp := (Coalesce(h_period_bl1_revenue, 0) - Coalesce(h_period_bl1_cost, 0));
      h_cc_bl3_gp := (Coalesce(h_period_bl3_revenue, 0) - Coalesce(h_period_bl3_cost, 0));
      h_cc_planned_gp := (Coalesce(h_period_planned_revenue, 0) - Coalesce(h_period_planned_cost, 0));
      h_cc_actual_gp := (Coalesce(h_period_actual_revenue, 0) - Coalesce(h_period_actual_cost, 0));
      
      h_period_expected_npv := Coalesce(h_cc_expected_gp, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                  , (Coalesce(h_current_period, 0) - 1));
      h_period_expected_cost_npv := Coalesce(h_cc_expected_cost, 0) / Power((1 + Coalesce(
                                       h_period_rate, 0)), (Coalesce(h_current_period, 0) - 1));
      h_period_expected_revenue_npv := Coalesce(h_cc_expected_revenue, 0) / Power((1 + Coalesce(
                                          h_period_rate, 0)), (Coalesce(h_current_period, 0) - 1));
      
      h_period_estimated_npv := Coalesce(h_cc_estimated_gp, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                   , (Coalesce(h_current_period, 0) - 1));
      h_period_estimated_cost_npv := Coalesce(h_cc_estimated_cost, 0) / Power((1 + Coalesce(
                                        h_period_rate, 0)), (Coalesce(h_current_period, 0) - 1));
      h_period_estimated_revenue_npv := Coalesce(h_cc_estimated_revenue, 0) / Power((1 + Coalesce(
                                           h_period_rate, 0)), (Coalesce(h_current_period, 0) - 1));
      
      h_period_bl1_npv := Coalesce(h_cc_bl1_gp, 0) / Power((1 + Coalesce(h_period_rate, 0)), (Coalesce(
                             h_current_period, 0) - 1));
      h_period_bl1_cost_npv := Coalesce(h_cc_bl1_cost, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                  , (Coalesce(h_current_period, 0) - 1));
      h_period_bl1_revenue_npv := Coalesce(h_cc_bl1_revenue, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                     , (Coalesce(h_current_period, 0) - 1));
      
      h_period_bl3_npv := Coalesce(h_cc_bl3_gp, 0) / Power((1 + Coalesce(h_period_rate, 0)), (Coalesce(
                             h_current_period, 0) - 1));
      h_period_bl3_cost_npv := Coalesce(h_cc_bl3_cost, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                  , (Coalesce(h_current_period, 0) - 1));
      h_period_bl3_revenue_npv := Coalesce(h_cc_bl3_revenue, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                     , (Coalesce(h_current_period, 0) - 1));
      
      h_period_planned_npv := Coalesce(h_cc_planned_gp, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                 , (Coalesce(h_current_period, 0) - 1));
      h_period_planned_cost_npv := Coalesce(h_cc_planned_cost, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                      , (Coalesce(h_current_period, 0) - 1));
      h_period_planned_revenue_npv := Coalesce(h_cc_planned_revenue, 0) / Power((1 + Coalesce(
                                         h_period_rate, 0)), (Coalesce(h_current_period, 0) - 1));
      
      h_period_actual_npv := Coalesce(h_cc_actual_gp, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                , (Coalesce(h_current_period, 0) - 1));
      h_period_actual_cost_npv := Coalesce(h_cc_actual_cost, 0) / Power((1 + Coalesce(h_period_rate, 0))
                                     , (Coalesce(h_current_period, 0) - 1));
      h_period_actual_revenue_npv := Coalesce(h_cc_actual_revenue, 0) / Power((1 + Coalesce(
                                        h_period_rate, 0)), (Coalesce(h_current_period, 0) - 1));
      
      h_cc_expected_cf_td := Coalesce(h_cc_expected_cf_td, 0) + Coalesce(h_cc_expected_gp, 0);
      h_cc_estimated_cf_td := Coalesce(h_cc_estimated_cf_td, 0) + Coalesce(h_cc_estimated_gp, 0);
      h_cc_bl1_cf_td := Coalesce(h_cc_bl1_cf_td, 0) + Coalesce(h_cc_bl1_gp, 0);
      h_cc_bl3_cf_td := Coalesce(h_cc_bl3_cf_td, 0) + Coalesce(h_cc_bl3_gp, 0);
      h_cc_planned_cf_td := Coalesce(h_cc_planned_cf_td, 0) + Coalesce(h_cc_planned_gp, 0);
      h_cc_actual_cf_td := Coalesce(h_cc_actual_cf_td, 0) + Coalesce(h_cc_actual_gp, 0);
      
      --POPULATE RESULTSET **********************************************************
      BEGIN
         INSERT INTO PMO_FINANCIAL_RESULTSET (
         RANK,
         PROJECT_ID,
         PROJECT_NAME,
         PROJECT_MANAGER,
         PROJECT_PRIORITY,
         PROJECT_HEALTH,
         STAGE_ID,
         REFERNCE_CODE,
         PROJECT_CURRENCY_ID,
         PROJECT_START,
         PROJECT_FINISH,
         CHARGECODE_ID,
         CHARGECODE_NAME,
         CHARGECODE_TYPE,
         LABOR_FLAG,
         BILLABLE,
         PROJECT_YEAR,
         YEAR_MONTH,
         PERIOD,
         EXPECTED_START,
         EXPECTED_FINISH,
         EXPECTED_COST,
         EXPECTED_REVENUE,
         EXPECTED_NPV,
         EXPECTED_COST_NPV,
         EXPECTED_REVENUE_NPV,
         EXPECTED_CF,
         EXPECTED_GP,
         ESTIMATED_START,
         ESTIMATED_FINISH,
         ESTIMATED_COST,
         ESTIMATED_REVENUE,
         ESTIMATED_NPV,
         ESTIMATED_COST_NPV,
         ESTIMATED_REVENUE_NPV,
         ESTIMATED_CF,
         ESTIMATED_GP,
         PLANNED_START,
         PLANNED_FINISH,
         PLANNED_COST,
         PLANNED_REVENUE,
         PLANNED_NPV,
         PLANNED_COST_NPV,
         PLANNED_REVENUE_NPV,
         PLANNED_CF,
         PLANNED_GP,
         BASELINE1_START,
         BASELINE1_FINISH,
         BASELINE1_COST,
         BASELINE1_REVENUE,
         BASELINE1_NPV,
         BASELINE1_COST_NPV,
         BASELINE1_REVENUE_NPV,
         BASELINE1_CF,
         BASELINE1_GP,
         BASELINE3_START,
         BASELINE3_FINISH,
         BASELINE3_COST,
         BASELINE3_REVENUE,
         BASELINE3_NPV,
         BASELINE3_COST_NPV,
         BASELINE3_REVENUE_NPV,
         BASELINE3_CF,
         BASELINE3_GP,
         ACTUAL_START,
         ACTUAL_FINISH,
         ACTUAL_COST,
         ACTUAL_REVENUE,
         ACTUAL_NPV,
         ACTUAL_COST_NPV,
         ACTUAL_REVENUE_NPV,
         ACTUAL_CF,
         ACTUAL_GP,
         ACTUAL_COST_YTD,
         ACTUAL_REVENUE_YTD,
         ACTUAL_COST_TODATE,
         ACTUAL_REVENUE_TODATE)
         SELECT
         h_p_rank AS RANK,
         h_p_id AS PROJECT_ID,
         P.ELEMENT_NAME AS PROJECT_NAME,
         R.FULL_NAME AS PROJECT_MANAGER,
         P.PRIORITY AS PROJECT_PRIORITY,
         P.BUBBLE_COLOR AS PROJECT_HEALTH,
         P.STAGE_ID,
         P.REF_CODE AS REFERNCE_CODE,
         P.CURRENCY_ID AS PROJECT_CURRENCY_ID,
         h_p_start AS PROJECT_START,
         h_p_finish AS PROJECT_FINISH,
         h_cc_id AS CHARGECODE_ID,
         h_cc_name AS CHARGECODE_NAME,
         h_cc_type AS CHARGECODE_TYPE,
         h_cc_labor_flag AS LABOR_FLAG,
         h_cc_billable AS BILLABLE,
         h_period_year AS PROJECT_YEAR,
         h_period_month AS YEAR_MONTH,
         h_current_period AS PERIOD,
         h_period_expected_start AS EXPECTED_START,
         h_period_expected_finish AS EXPECTED_FINISH,
         h_period_expected_cost AS EXPECTED_COST,
         h_period_expected_revenue AS EXPECTED_REVENUE,
         h_period_expected_npv AS EXPECTED_NPV,
         h_period_expected_cost_npv AS EXPECTED_COST_NPV,
         h_period_expected_revenue_npv AS EXPECTED_REVENUE_NPV,
         h_cc_expected_cf_td AS EXPECTED_CF,
         h_cc_expected_gp AS EXPECTED_GP,
         h_period_estimated_start AS ESTIMATED_START,
         h_period_estimated_finish AS ESTIMATED_FINISH,
         h_period_estimated_cost AS ESTIMATED_COST,
         h_period_estimated_revenue AS ESTIMATED_REVENUE,
         h_period_estimated_npv AS ESTIMATED_NPV,
         h_period_estimated_cost_npv AS ESTIMATED_COST_NPV,
         h_period_estimated_revenue_npv AS ESTIMATED_REVENUE_NPV,
         h_cc_estimated_cf_td AS ESTIMATED_CF,
         h_cc_estimated_gp AS ESTIMATED_GP,
         h_period_estimated_start AS PLANNED_START,
         h_period_estimated_finish AS PLANNED_FINISH,
         h_period_estimated_cost AS PLANNED_COST,
         h_period_estimated_revenue AS PLANNED_REVENUE,
         h_period_estimated_npv AS PLANNED_NPV,
         h_period_estimated_cost_npv AS PLANNED_COST_NPV,
         h_period_estimated_revenue_npv AS PLANNED_REVENUE_NPV,
         h_cc_planned_cf_td AS PLANNED_CF,
         h_cc_planned_gp AS PLANNED_GP,
         h_period_bl1_start AS BASELINE1_START,
         h_period_bl1_finish AS BASELINE1_FINISH,
         h_period_bl1_cost AS BASELINE1_COST,
         h_period_bl1_revenue AS BASELINE1_REVENUE,
         h_period_bl1_npv AS BASELINE1_NPV,
         h_period_bl1_cost_npv AS BASELINE1_COST_NPV,
         h_period_bl1_revenue_npv AS BASELINE1_REVENUE_NPV,
         h_cc_bl1_cf_td AS BASELINE1_CF,
         h_cc_bl1_gp AS BASELINE1_GP,
         h_period_bl3_start AS BASELINE3_START,
         h_period_bl3_finish AS BASELINE3_FINISH,
         h_period_bl3_cost AS BASELINE3_COST,
         h_period_bl3_revenue AS BASELINE3_REVENUE,
         h_period_bl3_npv AS BASELINE3_NPV,
         h_period_bl3_cost_npv AS BASELINE3_COST_NPV,
         h_period_bl3_revenue_npv AS BASELINE3_REVENUE_NPV,
         h_cc_bl3_cf_td AS BASELINE3_CF,
         h_cc_bl3_gp AS BASELINE3_GP,
         h_period_actual_start AS ACTUAL_START,
         h_period_actual_finish AS ACTUAL_FINISH,
         h_period_actual_cost AS ACTUAL_COST,
         h_period_actual_revenue AS ACTUAL_REVENUE,
         h_period_actual_npv AS ACTUAL_NPV,
         h_period_actual_cost_npv AS ACTUAL_COST_NPV,
         h_period_actual_revenue_npv AS ACTUAL_REVENUE_NPV,
         h_cc_actual_cf_td AS ACTUAL_CF,
         h_cc_actual_gp AS ACTUAL_GP,
         h_cc_actual_cost_ytd AS ACTUAL_COST_YTD,
         h_cc_actual_revenue_ytd AS ACTUAL_REVENUE_YTD,
         h_cc_actual_cost_td AS ACTUAL_COST_TODATE,
         h_cc_actual_revenue_td AS ACTUAL_REVENUE_TODATE
         FROM TMT_WBS P
         JOIN RESOURCE_ASSIGNMENTS RA
         ON RA.PROJECT_ID = P.PROJECT_ID
         AND RA.ELEMENT_ID = P.ELEMENT_ID
         AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER
         JOIN RESOURCES R
         ON R.RESOURCE_ID = RA.RESOURCE_ID
         WHERE P.PROJECT_ID = h_p_id
         AND P.ELEMENT_ID = h_p_id
         AND P.RANK = h_p_rank;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1725+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1726) : views_financial.sql(4408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_period_type, 0) = PMO_CNST.SC_YEARLY Then
         --move to the next period
         BEGIN
            SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1    )
            INTO h_period_start
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1742+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1743) : views_financial.sql(4425) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --initilize period dates
         BEGIN
            SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 5) || '01-01', 1, 10)), 1 * 12) - 1     )
            INTO h_period_finish
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1758+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1759) : views_financial.sql(4441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_period_type, 0) = PMO_CNST.SC_MONTHLY Then
         --move to the next period
         BEGIN
            SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1    )
            INTO h_period_start
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1774+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1775) : views_financial.sql(4457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --initilize period dates
         BEGIN
            SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
            INTO h_period_finish
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PERIODS', 1790+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PERIODS(1791) : views_financial.sql(4473) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_current_period := Coalesce(h_current_period, 0) + 1;
   END LOOP;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_PERIODS', 1800+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_PERIODS(1801) : views_financial.sql(4483) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PARSE_PERIODS;
ALTER FUNCTION FC_PARSE_PERIODS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PARSE_CHARGECODES ==
CREATE OR REPLACE FUNCTION FC_PARSE_CHARGECODES
(
     h_p_id IN OUT NOCOPY VARCHAR2
   , sh_h_period_type PLS_INTEGER
   , sh_h_p_period_count PLS_INTEGER
   , h_p_rank IN OUT NOCOPY VARCHAR2
   , h_p_start IN OUT NOCOPY DATE
   , h_p_finish IN OUT NOCOPY DATE
   , h_p_expected_start IN OUT NOCOPY DATE
   , h_p_expected_finish IN OUT NOCOPY DATE
   , sh_h_p_expected_days PLS_INTEGER
   , h_p_est_start IN OUT NOCOPY DATE
   , h_p_est_finish IN OUT NOCOPY DATE
   , sh_h_p_est_days PLS_INTEGER
   , h_p_plnd_start IN OUT NOCOPY DATE
   , h_p_plnd_finish IN OUT NOCOPY DATE
   , sh_h_p_plnd_days PLS_INTEGER
   , h_p_est_bl1_start IN OUT NOCOPY DATE
   , h_p_est_bl1_finish IN OUT NOCOPY DATE
   , sh_h_p_est_bl1_days PLS_INTEGER
   , h_p_est_bl3_start IN OUT NOCOPY DATE
   , h_p_est_bl3_finish IN OUT NOCOPY DATE
   , sh_h_p_est_bl3_days PLS_INTEGER
   , h_p_actual_start IN OUT NOCOPY DATE
   , h_p_actual_finish IN OUT NOCOPY DATE
   , sh_h_p_actual_days PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_period_type PLS_INTEGER := sh_h_period_type;
   h_p_period_count PLS_INTEGER := sh_h_p_period_count;
   h_p_expected_days PLS_INTEGER := sh_h_p_expected_days;
   h_p_est_days PLS_INTEGER := sh_h_p_est_days;
   h_p_plnd_days PLS_INTEGER := sh_h_p_plnd_days;
   h_p_est_bl1_days PLS_INTEGER := sh_h_p_est_bl1_days;
   h_p_est_bl3_days PLS_INTEGER := sh_h_p_est_bl3_days;
   h_p_actual_days PLS_INTEGER := sh_h_p_actual_days;
   h_cc_id VARCHAR2(32);
   h_cc_name VARCHAR2(100);
   h_cc_type PLS_INTEGER := 0;
   h_cc_labor_flag PLS_INTEGER := 0;
   h_cc_billable PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      CURSOR C_PRJ_CC IS
         SELECT DISTINCT
         CHARGECODE_ID,
         CHARGECODE_NAME,
         CHARGECODE_TYPE,
         LABOR_FLAG,
         BILLABLE
         FROM PMO_FINANCIAL_CC
         WHERE PROJECT_ID = h_p_id
         ORDER BY CHARGECODE_NAME;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PARSE_CHARGECODES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PARSE_CHARGECODES'), '-- ' || SYSTIMESTAMP, ':r := FC_PARSE_CHARGECODES(' || 
       '''' || h_p_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_period_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_period_count), 'NULL')
          || ', ' || '''' || h_p_rank || ''''
          || ', ' || COALESCE(NULLIF('''' || h_p_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_expected_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_expected_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_expected_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_est_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_plnd_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_plnd_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_plnd_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl1_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl1_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_est_bl1_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl3_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_est_bl3_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_est_bl3_days), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_actual_start || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_p_actual_finish || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_p_actual_days), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_CHARGECODES', 84+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PARSE_CHARGECODES(85) : views_financial.sql(4578) : ' || SYSTIMESTAMP);
   END IF; 

   --Declare host variables
   
   --Declare and walk the cursor to process each charge code
   
   OPEN C_PRJ_CC;
   
   --for each project
   LOOP
      FETCH C_PRJ_CC INTO     h_cc_id,
      h_cc_name,
      h_cc_type,
      h_cc_labor_flag,
      h_cc_billable;
      IF C_PRJ_CC%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_temp_sc_state := FC_PARSE_PERIODS(h_p_id, h_period_type, h_p_period_count, h_p_rank, h_p_start
                                    , h_p_finish, h_p_expected_start, h_p_expected_finish
                                    , h_p_expected_days, h_p_est_start, h_p_est_finish, h_p_est_days
                                    , h_p_plnd_start, h_p_plnd_finish, h_p_plnd_days
                                    , h_p_est_bl1_start, h_p_est_bl1_finish, h_p_est_bl1_days
                                    , h_p_est_bl3_start, h_p_est_bl3_finish, h_p_est_bl3_days
                                    , h_p_actual_start, h_p_actual_finish, h_p_actual_days, h_cc_id
                                    , h_cc_name, h_cc_type, h_cc_labor_flag, h_cc_billable);
   END LOOP;
   
   BEGIN
      CLOSE C_PRJ_CC ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_CHARGECODES', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_CHARGECODES(128) : views_financial.sql(4621) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_CHARGECODES', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_CHARGECODES(134) : views_financial.sql(4627) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PARSE_CHARGECODES;
ALTER FUNCTION FC_PARSE_CHARGECODES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PARSE_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_PARSE_PROJECTS
(
     sh_h_period_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_period_type PLS_INTEGER := sh_h_period_type;
   h_p_actual_finish DATE;
   h_p_actual_start DATE;
   h_p_est_bl1_finish DATE;
   h_p_est_bl1_start DATE;
   h_p_est_bl3_finish DATE;
   h_p_est_bl3_start DATE;
   h_p_est_finish DATE;
   h_p_est_start DATE;
   h_p_expected_finish DATE;
   h_p_expected_start DATE;
   h_p_finish DATE;
   h_p_id VARCHAR2(32);
   h_p_plnd_finish DATE;
   h_p_plnd_start DATE;
   h_p_rank VARCHAR2(200);
   h_p_start DATE;
   h_p_actual_days PLS_INTEGER := 0;
   h_p_est_bl1_days PLS_INTEGER := 0;
   h_p_est_bl3_days PLS_INTEGER := 0;
   h_p_days PLS_INTEGER := 0;
   h_p_est_days PLS_INTEGER := 0;
   h_p_expected_days PLS_INTEGER := 0;
   h_p_payback_month PLS_INTEGER := 0;
   h_p_period_count PLS_INTEGER := 0;
   h_p_plnd_days PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      CURSOR C_PRJS IS
         SELECT  RANK,
         ELEMENT_ID,
         START_DATE,
         FINISH_DATE,
         TO_DATE(SubStr(EXPECTED_START, 1, 10)),
         TO_DATE(SubStr(EXPECTED_FINISH, 1, 10)),
         TO_DATE(SubStr(ESTIMATED_START, 1, 10)),
         TO_DATE(SubStr(ESTIMATED_FINISH, 1, 10)),
         TO_DATE(SubStr(PLANNED_START, 1, 10)),
         TO_DATE(SubStr(PLANNED_FINISH, 1, 10)),
         TO_DATE(SubStr(BASELINE1_START, 1, 10)),
         TO_DATE(SubStr(BASELINE1_FINISH, 1, 10)),
         TO_DATE(SubStr(BASELINE3_START, 1, 10)),
         TO_DATE(SubStr(BASELINE3_FINISH, 1, 10)),
         TO_DATE(SubStr(START_DATE, 1, 10)),
         TO_DATE(SubStr(FINISH_DATE, 1, 10)),
         CASE
         WHEN h_period_type = PMO_CNST.SC_YEARLY THEN (PMO_ORASTD.YEAR(FINISH_DATE)-PMO_ORASTD.YEAR(START_DATE)) + 1
         WHEN h_period_type = PMO_CNST.SC_MONTHLY THEN (PMO_ORASTD.DB2TIMESTAMPDIFF(64, FINISH_DATE, START_DATE) + 1)
         ELSE 0
         END
         FROM PMO_FINANCIAL_PROJECTS
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PARSE_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PARSE_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_PARSE_PROJECTS(' || 
       COALESCE(TO_CHAR(sh_h_period_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_PROJECTS', 65+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PARSE_PROJECTS(66) : views_financial.sql(4703) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare LOCAL Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_RESULTSET';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Declare and walk the cursor to process each project
   
   OPEN C_PRJS;
   
   --for each project
   LOOP
      FETCH C_PRJS INTO   h_p_rank,
      h_p_id,
      h_p_start,
      h_p_finish,
      h_p_expected_start,
      h_p_expected_finish,
      h_p_est_start,
      h_p_est_finish,
      h_p_plnd_start,
      h_p_plnd_finish,
      h_p_est_bl1_start,
      h_p_est_bl1_finish,
      h_p_est_bl3_start,
      h_p_est_bl3_finish,
      h_p_actual_start,
      h_p_actual_finish,
      h_p_period_count;
      IF C_PRJS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If (h_p_start IS NOT NULL) AND (h_p_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(h_p_start
            , h_p_finish) <= 0) Then
         BEGIN
            SELECT ( (PMO_ORASTD.DAYS(h_p_finish) - PMO_ORASTD.DAYS(h_p_start)) + 1 )
            INTO h_p_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(121) : views_financial.sql(4758) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_p_days := 0;
      End If;
      
      If (h_p_expected_start IS NOT NULL) AND (h_p_expected_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            h_p_expected_start, h_p_expected_finish) <= 0) Then
         BEGIN
            SELECT ( (PMO_ORASTD.DAYS(h_p_expected_finish) - PMO_ORASTD.DAYS(h_p_expected_start)) + 1 )
            INTO h_p_expected_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 140+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(141) : views_financial.sql(4778) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_p_expected_days := 0;
      End If;
      
      If (h_p_est_start IS NOT NULL) AND (h_p_est_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(h_p_est_start
            , h_p_est_finish) <= 0) Then
         BEGIN
            SELECT ( (PMO_ORASTD.DAYS(h_p_est_finish) - PMO_ORASTD.DAYS(h_p_est_start)) + 1 )
            INTO h_p_est_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 160+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(161) : views_financial.sql(4798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_p_est_days := 0;
      End If;
      
      If (h_p_plnd_start IS NOT NULL) AND (h_p_plnd_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            h_p_plnd_start, h_p_plnd_finish) <= 0) Then
         BEGIN
            SELECT ( (PMO_ORASTD.DAYS(h_p_plnd_finish) - PMO_ORASTD.DAYS(h_p_plnd_start)) + 1 )
            INTO h_p_plnd_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 180+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(181) : views_financial.sql(4818) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_p_plnd_days := 0;
      End If;
      
      If (h_p_est_bl1_start IS NOT NULL) AND (h_p_est_bl1_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            h_p_est_bl1_start, h_p_est_bl1_finish) <= 0) Then
         BEGIN
            SELECT ( (PMO_ORASTD.DAYS(h_p_est_bl1_finish) - PMO_ORASTD.DAYS(h_p_est_bl1_start)) + 1 )
            INTO h_p_est_bl1_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(201) : views_financial.sql(4838) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_p_est_bl1_days := 0;
      End If;
      
      If (h_p_est_bl3_start IS NOT NULL) AND (h_p_est_bl3_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            h_p_est_bl3_start, h_p_est_bl3_finish) <= 0) Then
         BEGIN
            SELECT ( (PMO_ORASTD.DAYS(h_p_est_bl3_finish) - PMO_ORASTD.DAYS(h_p_est_bl3_start)) + 1 )
            INTO h_p_est_bl3_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 220+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(221) : views_financial.sql(4858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_p_est_bl3_days := 0;
      End If;
      
      If (h_p_actual_start IS NOT NULL) AND (h_p_actual_finish IS NOT NULL) AND (PMO_ORASTD.strcmp(
            h_p_actual_start, h_p_actual_finish) <= 0) Then
         BEGIN
            SELECT ( (PMO_ORASTD.DAYS(h_p_actual_finish) - PMO_ORASTD.DAYS(h_p_actual_start)) + 1 )
            INTO h_p_actual_days
            FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 240+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(241) : views_financial.sql(4878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_p_actual_days := 0;
      End If;
      
      h_temp_sc_state := FC_PARSE_CHARGECODES(h_p_id, h_period_type, h_p_period_count, h_p_rank, h_p_start
                                        , h_p_finish, h_p_expected_start, h_p_expected_finish
                                        , h_p_expected_days, h_p_est_start, h_p_est_finish
                                        , h_p_est_days, h_p_plnd_start, h_p_plnd_finish
                                        , h_p_plnd_days, h_p_est_bl1_start, h_p_est_bl1_finish
                                        , h_p_est_bl1_days, h_p_est_bl3_start, h_p_est_bl3_finish
                                        , h_p_est_bl3_days, h_p_actual_start, h_p_actual_finish
                                        , h_p_actual_days);
   END LOOP;
   
   BEGIN
      CLOSE C_PRJS ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PARSE_PROJECTS', 266+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PARSE_PROJECTS(267) : views_financial.sql(4904) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PARSE_PROJECTS', 272+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PARSE_PROJECTS(273) : views_financial.sql(4910) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PARSE_PROJECTS;
ALTER FUNCTION FC_PARSE_PROJECTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_IS_TIMEPHASED ==
CREATE OR REPLACE FUNCTION FC_IS_TIMEPHASED
(
     h_e_id IN OUT NOCOPY VARCHAR2
   , sh_h_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_temp_expected_sum NUMBER := 0;
   h_temp_estimation_sum NUMBER := 0;
   h_temp_planned_sum NUMBER := 0;
   h_temp_sched_sum NUMBER := 0;
   h_temp_actual_sum NUMBER := 0;
   h_temp_forecast_sum NUMBER := 0;
   h_temp_bl1_sum NUMBER := 0;
   h_temp_bl2_sum NUMBER := 0;
   h_temp_bl3_sum NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_IS_TIMEPHASED') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_IS_TIMEPHASED'), '-- ' || SYSTIMESTAMP, ':r := FC_IS_TIMEPHASED(' || 
       '''' || h_e_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_TIMEPHASED', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_IS_TIMEPHASED(25) : views_financial.sql(4945) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT
      SUM(ESTIMATED_BUDGET),
      SUM(ESTIMATED_BUDGET),
      SUM(BUDGET),
      SUM(BUDGET),
      SUM(ACTUAL),
      SUM(ACTUAL + ETC),
      SUM(BUDGET_BASELINE1),
      SUM(BUDGET_BASELINE2),
      SUM(BUDGET_BASELINE3)
      INTO
      h_temp_expected_sum,
      h_temp_estimation_sum,
      h_temp_planned_sum,
      h_temp_sched_sum,
      h_temp_actual_sum,
      h_temp_forecast_sum,
      h_temp_bl1_sum,
      h_temp_bl2_sum,
      h_temp_bl3_sum
      FROM BUDGETS B
      WHERE B.ELEMENT_ID = h_e_id
      AND B.TIMEPHASED_FLAG <> 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_IS_TIMEPHASED', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_IS_TIMEPHASED(58) : views_financial.sql(4978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If ((Coalesce(h_type, 0) = PMO_CNST.SC_EXPECTED_TYPE) AND (Coalesce(h_temp_expected_sum, 0) = 0.0)) 
              OR ((Coalesce(h_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET) AND (Coalesce(
              h_temp_estimation_sum, 0) = 0.0)) OR ((Coalesce(
              h_type, 0) = PMO_CNST.SC_PLANNED_TYPE) AND (Coalesce(h_temp_planned_sum, 0) = 0.0)) 
              OR ((Coalesce(h_type, 0) = PMO_CNST.SC_SCHED_BUDGET) AND (Coalesce(
              h_temp_sched_sum, 0) = 0.0)) OR ((Coalesce(h_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET) 
              AND (Coalesce(h_temp_actual_sum, 0) = 0.0)) OR ((Coalesce(
              h_type, 0) = PMO_CNST.SC_FORECAST_TYPE) AND (Coalesce(h_temp_forecast_sum, 0) = 0.0)) 
              OR ((Coalesce(h_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE1) AND (Coalesce(
              h_temp_bl1_sum, 0) = 0.0)) OR ((Coalesce(
              h_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE2) AND (Coalesce(
              h_temp_bl2_sum, 0) = 0.0)) OR ((Coalesce(
              h_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE3) AND (Coalesce(
              h_temp_bl3_sum, 0) = 0.0)) Then
      PMO_DB2M.SC_STATE := 0;
   Else
      PMO_DB2M.SC_STATE := 1;
   End If;
   
   --Question:
   --What if under an element, there are some charge codes timephased, and some not timephased...?
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_IS_TIMEPHASED', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_IS_TIMEPHASED(86) : views_financial.sql(5006) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_IS_TIMEPHASED;
ALTER FUNCTION FC_IS_TIMEPHASED COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_BUDGET_ENTRIES ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_BUDGET_ENTRIES
(
     h_e_id IN OUT NOCOPY VARCHAR2
   , sh_h_type PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_chargecode_id VARCHAR2(32);
   h_chargecode_name VARCHAR2(100);
   h_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_period_finish DATE;
   h_period_start VARCHAR2(10);
   h_project_id VARCHAR2(32);
   h_project_name VARCHAR2(255);
   h_project_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_month_01_cost NUMBER := 0;
   h_month_02_cost NUMBER := 0;
   h_month_03_cost NUMBER := 0;
   h_month_04_cost NUMBER := 0;
   h_month_05_cost NUMBER := 0;
   h_month_06_cost NUMBER := 0;
   h_month_07_cost NUMBER := 0;
   h_month_08_cost NUMBER := 0;
   h_month_09_cost NUMBER := 0;
   h_month_10_cost NUMBER := 0;
   h_month_11_cost NUMBER := 0;
   h_month_12_cost NUMBER := 0;
   h_month_01_revenue NUMBER := 0;
   h_month_02_revenue NUMBER := 0;
   h_month_03_revenue NUMBER := 0;
   h_month_04_revenue NUMBER := 0;
   h_month_05_revenue NUMBER := 0;
   h_month_06_revenue NUMBER := 0;
   h_month_07_revenue NUMBER := 0;
   h_month_08_revenue NUMBER := 0;
   h_month_09_revenue NUMBER := 0;
   h_month_10_revenue NUMBER := 0;
   h_month_11_revenue NUMBER := 0;
   h_month_12_revenue NUMBER := 0;
   h_budget_year PLS_INTEGER := 0;
   h_budget_year_str VARCHAR2(4);
   h_capital_expense PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TBE_INSERT IS
         SELECT
         PBB.CHARGECODE_ID,
         CC.CAPITAL_EXPENSE,
         PBB.BUDGET_YEAR,
         PBB.MONTH_01_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_02_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_03_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_04_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_05_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_06_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_07_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_08_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_09_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_10_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_11_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_12_AMOUNT * (ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_01_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_02_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_03_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_04_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_05_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_06_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_07_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_08_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_09_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_10_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_11_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2))),
         PBB.MONTH_12_AMOUNT * (1-ABS(SIGN(CC.CAPITAL_EXPENSE - 2)))
         FROM PROJECT_BUDGET_BREAKDOWN PBB
         JOIN TMT_CHARGECODES CC
         ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
         JOIN BUDGETS B
         ON B.PROJECT_ID = PBB.PROJECT_ID
         AND B.ELEMENT_ID = PBB.PROJECT_ID
         AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
         WHERE PBB.PROJECT_ID = h_e_id
         AND PBB.BUDGET_TYPE = h_type
         AND PBB.CHARGECODE_ID NOT IN (  'EXPENSE_HOURS',
         'EXPENSE_AVERAGE_COST',
         'EXPENSE_FULL_TIME_EQUIVALENT',
         'CAPITAL_HOURS',
         'CAPITAL_AVERAGE_COST',
         'CAPITAL_FULL_TIME_EQUIVALENT',
         'BENEFIT_HOURS',
         'BENEFIT_AVERAGE_RATE',
         'BENEFIT_FULL_TIME_EQUIVALENT',
         'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
         AND PBB.BUDGET_TYPE NOT IN (PMO_CNST.SC_PAID_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
         ORDER BY PBB.BUDGET_YEAR, CC.CAPITAL_EXPENSE, CC.ELEMENT_NAME;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_BUDGET_ENTRIES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_BUDGET_ENTRIES'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_BUDGET_ENTRIES(' || 
       '''' || h_e_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_BUDGET_ENTRIES', 109+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_BUDGET_ENTRIES(110) : views_financial.sql(5126) : ' || SYSTIMESTAMP);
   END IF; 

   
   --consider the fiscal month
   BEGIN
      SELECT SETTING_VALUE + 1
      INTO h_fiscal_month
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'FISCAL_PERIOD';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 125+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(126) : views_financial.sql(5142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TBE_INSERT;
   
   LOOP
      FETCH C_TBE_INSERT INTO
      h_chargecode_id,
      h_capital_expense,
      h_budget_year,
      h_month_01_cost,
      h_month_02_cost,
      h_month_03_cost,
      h_month_04_cost,
      h_month_05_cost,
      h_month_06_cost,
      h_month_07_cost,
      h_month_08_cost,
      h_month_09_cost,
      h_month_10_cost,
      h_month_11_cost,
      h_month_12_cost,
      h_month_01_revenue,
      h_month_02_revenue,
      h_month_03_revenue,
      h_month_04_revenue,
      h_month_05_revenue,
      h_month_06_revenue,
      h_month_07_revenue,
      h_month_08_revenue,
      h_month_09_revenue,
      h_month_10_revenue,
      h_month_11_revenue,
      h_month_12_revenue;
      IF C_TBE_INSERT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_period_start := LPad(TO_CHAR(Coalesce(h_budget_year, 0)), 4) || '-' || LPad(TO_CHAR(Coalesce(
                  h_fiscal_month, 0)), 2, '0') || '-01';
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 183+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(184) : views_financial.sql(5200) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --1st Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_01_cost,
         h_month_01_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_01_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_01_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 220+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(221) : views_financial.sql(5237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 235+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(236) : views_financial.sql(5252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 250+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(251) : views_financial.sql(5267) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --2nd Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_02_cost,
         h_month_02_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_02_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_02_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 287+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(288) : views_financial.sql(5304) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 302+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(303) : views_financial.sql(5319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1)  - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 317+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(318) : views_financial.sql(5334) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --3rd Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_03_cost,
         h_month_03_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_03_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_03_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 354+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(355) : views_financial.sql(5371) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 369+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(370) : views_financial.sql(5386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1)  - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 384+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(385) : views_financial.sql(5401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --4th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_04_cost,
         h_month_04_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_04_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_04_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 421+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(422) : views_financial.sql(5438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 436+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(437) : views_financial.sql(5453) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1)  - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 451+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(452) : views_financial.sql(5468) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --5th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_05_cost,
         h_month_05_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_05_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_05_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 488+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(489) : views_financial.sql(5505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 503+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(504) : views_financial.sql(5520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 518+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(519) : views_financial.sql(5535) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --6th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_06_cost,
         h_month_06_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_06_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_06_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 555+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(556) : views_financial.sql(5572) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 570+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(571) : views_financial.sql(5587) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 585+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(586) : views_financial.sql(5602) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --7th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_07_cost,
         h_month_07_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_07_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_07_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 622+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(623) : views_financial.sql(5639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 637+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(638) : views_financial.sql(5654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1)  - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 652+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(653) : views_financial.sql(5669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --8th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_08_cost,
         h_month_08_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_08_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_08_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 689+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(690) : views_financial.sql(5706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 704+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(705) : views_financial.sql(5721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 719+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(720) : views_financial.sql(5736) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --9th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_09_cost,
         h_month_09_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_09_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_09_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 756+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(757) : views_financial.sql(5773) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 771+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(772) : views_financial.sql(5788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1) - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 786+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(787) : views_financial.sql(5803) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --10th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_10_cost,
         h_month_10_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_10_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_10_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 823+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(824) : views_financial.sql(5840) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 838+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(839) : views_financial.sql(5855) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1)  - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 853+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(854) : views_financial.sql(5870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --11th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_11_cost,
         h_month_11_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_11_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_11_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 890+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(891) : views_financial.sql(5907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( TO_DATE(SubStr(h_period_finish, 1, 10)) + 1     )
         INTO h_period_start
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 905+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(906) : views_financial.sql(5922) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT ( Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(h_period_start), 1, 8) || '01', 1, 10)), 1)  - 1     )
         INTO h_period_finish
         FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 920+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(921) : views_financial.sql(5937) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --12th Month
      BEGIN
         INSERT INTO PMO_BUDGET_ENTRY (
         ENTRY_ID,
         ENTRY_TYPE,
         ENTRY_START,
         ENTRY_FINISH,
         ENTRY_COST,
         ENTRY_REVENUE,
         ENTRY_DAYS,
         ENTRY_DAY_COST,
         ENTRY_DAY_REVENUE )
         VALUES (
         h_chargecode_id,
         h_type,
         h_period_start,
         h_period_finish,
         h_month_12_cost,
         h_month_12_revenue,
         (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_12_cost / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1),
         h_month_12_revenue / (PMO_ORASTD.DAY(h_period_finish) - PMO_ORASTD.DAY(h_period_start) + 1) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 957+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(958) : views_financial.sql(5974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE C_TBE_INSERT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_BUDGET_ENTRIES', 971+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_BUDGET_ENTRIES(972) : views_financial.sql(5988) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_BUDGET_ENTRIES', 977+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_BUDGET_ENTRIES(978) : views_financial.sql(5994) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_BUDGET_ENTRIES;
ALTER FUNCTION FC_TIMEPHASE_BUDGET_ENTRIES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_BUDGET_ENTRIES ==
CREATE OR REPLACE FUNCTION FC_INIT_BUDGET_ENTRIES
(
     h_e_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_temp_type PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_BUDGET_ENTRIES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_BUDGET_ENTRIES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_BUDGET_ENTRIES(' || 
       '''' || h_e_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BUDGET_ENTRIES', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_BUDGET_ENTRIES(14) : views_financial.sql(6018) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_BUDGET_ENTRY';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_temp_type := PMO_CNST.SC_ESTIMATED_BUDGET;
   PMO_DB2M.SC_STATE := FC_TIMEPHASE_BUDGET_ENTRIES(h_e_id, h_temp_type);
   
   h_temp_type := PMO_CNST.SC_SCHED_BUDGET;
   PMO_DB2M.SC_STATE := FC_TIMEPHASE_BUDGET_ENTRIES(h_e_id, h_temp_type);
   
   h_temp_type := PMO_CNST.SC_ACTUAL_BUDGET;
   PMO_DB2M.SC_STATE := FC_TIMEPHASE_BUDGET_ENTRIES(h_e_id, h_temp_type);
   
   h_temp_type := PMO_CNST.SC_ESTIMATED_BASELINE1;
   PMO_DB2M.SC_STATE := FC_TIMEPHASE_BUDGET_ENTRIES(h_e_id, h_temp_type);
   
   h_temp_type := PMO_CNST.SC_ESTIMATED_BASELINE3;
   PMO_DB2M.SC_STATE := FC_TIMEPHASE_BUDGET_ENTRIES(h_e_id, h_temp_type);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BUDGET_ENTRIES', 40+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_BUDGET_ENTRIES(41) : views_financial.sql(6045) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_BUDGET_ENTRIES;
ALTER FUNCTION FC_INIT_BUDGET_ENTRIES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PORTFOLIO_ROI ==
CREATE OR REPLACE FUNCTION SP_PORTFOLIO_ROI
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_current_date DATE;
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_p_actual_finish DATE;
   h_p_actual_payback_date DATE;
   h_p_actual_start DATE;
   h_p_est_actual_finish DATE;
   h_p_est_actual_payback_date DATE;
   h_p_est_actual_start DATE;
   h_p_est_bl1_finish DATE;
   h_p_est_bl1_payback_date DATE;
   h_p_est_bl1_start DATE;
   h_p_est_bl3_finish DATE;
   h_p_est_bl3_payback_date DATE;
   h_p_est_bl3_start DATE;
   h_p_est_finish DATE;
   h_p_est_payback_date DATE;
   h_p_est_start DATE;
   h_p_finish DATE;
   h_p_id VARCHAR2(32);
   h_p_payback_start_date DATE;
   h_p_plnd_bl1_finish DATE;
   h_p_plnd_bl1_payback_date DATE;
   h_p_plnd_bl1_start DATE;
   h_p_plnd_bl3_finish DATE;
   h_p_plnd_bl3_payback_date DATE;
   h_p_plnd_bl3_start DATE;
   h_p_plnd_finish DATE;
   h_p_plnd_payback_date DATE;
   h_p_plnd_start DATE;
   h_p_start VARCHAR2(10);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_c_month_01_cost NUMBER := 0;
   h_c_month_01_revenue NUMBER := 0;
   h_c_month_02_cost NUMBER := 0;
   h_c_month_02_revenue NUMBER := 0;
   h_c_month_03_cost NUMBER := 0;
   h_c_month_03_revenue NUMBER := 0;
   h_c_month_04_cost NUMBER := 0;
   h_c_month_04_revenue NUMBER := 0;
   h_c_month_05_cost NUMBER := 0;
   h_c_month_05_revenue NUMBER := 0;
   h_c_month_06_cost NUMBER := 0;
   h_c_month_06_revenue NUMBER := 0;
   h_c_month_07_cost NUMBER := 0;
   h_c_month_07_revenue NUMBER := 0;
   h_c_month_08_cost NUMBER := 0;
   h_c_month_08_revenue NUMBER := 0;
   h_c_month_09_cost NUMBER := 0;
   h_c_month_09_revenue NUMBER := 0;
   h_c_month_10_cost NUMBER := 0;
   h_c_month_10_revenue NUMBER := 0;
   h_c_month_11_cost NUMBER := 0;
   h_c_month_11_revenue NUMBER := 0;
   h_c_month_12_cost NUMBER := 0;
   h_c_month_12_revenue NUMBER := 0;
   h_p_actual_cost NUMBER := 0;
   h_p_actual_cost_td NUMBER := 0;
   h_p_actual_cost_ytd NUMBER := 0;
   h_p_actual_gp NUMBER := 0;
   h_p_actual_irr NUMBER := 0;
   h_p_actual_npv NUMBER := 0;
   h_p_actual_cost_npv NUMBER := 0;
   h_p_actual_revenue_npv NUMBER := 0;
   h_p_actual_revenue NUMBER := 0;
   h_p_actual_revenue_td NUMBER := 0;
   h_p_actual_revenue_ytd NUMBER := 0;
   h_p_actual_roi NUMBER := 0;
   h_p_cost NUMBER := 0;
   h_p_cost_td NUMBER := 0;
   h_p_cost_year NUMBER := 0;
   h_p_cost_ytd NUMBER := 0;
   h_p_est_actual_cost NUMBER := 0;
   h_p_est_actual_cost_td NUMBER := 0;
   h_p_est_actual_cost_ytd NUMBER := 0;
   h_p_est_actual_gp NUMBER := 0;
   h_p_est_actual_irr NUMBER := 0;
   h_p_est_actual_npv NUMBER := 0;
   h_p_est_actual_cost_npv NUMBER := 0;
   h_p_est_actual_revenue_npv NUMBER := 0;
   h_p_est_actual_revenue NUMBER := 0;
   h_p_est_actual_revenue_td NUMBER := 0;
   h_p_est_actual_revenue_ytd NUMBER := 0;
   h_p_est_actual_roi NUMBER := 0;
   h_p_est_bl1_cost NUMBER := 0;
   h_p_est_bl1_cost_td NUMBER := 0;
   h_p_est_bl1_cost_ytd NUMBER := 0;
   h_p_est_bl1_gp NUMBER := 0;
   h_p_est_bl1_irr NUMBER := 0;
   h_p_est_bl1_npv NUMBER := 0;
   h_p_est_bl1_cost_npv NUMBER := 0;
   h_p_est_bl1_revenue_npv NUMBER := 0;
   h_p_est_bl1_revenue NUMBER := 0;
   h_p_est_bl1_revenue_td NUMBER := 0;
   h_p_est_bl1_revenue_ytd NUMBER := 0;
   h_p_est_bl1_roi NUMBER := 0;
   h_p_est_bl3_cost NUMBER := 0;
   h_p_est_bl3_cost_td NUMBER := 0;
   h_p_est_bl3_cost_ytd NUMBER := 0;
   h_p_est_bl3_gp NUMBER := 0;
   h_p_est_bl3_irr NUMBER := 0;
   h_p_est_bl3_npv NUMBER := 0;
   h_p_est_bl3_cost_npv NUMBER := 0;
   h_p_est_bl3_revenue_npv NUMBER := 0;
   h_p_est_bl3_revenue NUMBER := 0;
   h_p_est_bl3_revenue_td NUMBER := 0;
   h_p_est_bl3_revenue_ytd NUMBER := 0;
   h_p_est_bl3_roi NUMBER := 0;
   h_p_est_cost NUMBER := 0;
   h_p_est_cost_td NUMBER := 0;
   h_p_est_cost_ytd NUMBER := 0;
   h_p_est_gp NUMBER := 0;
   h_p_est_irr NUMBER := 0;
   h_p_est_npv NUMBER := 0;
   h_p_est_cost_npv NUMBER := 0;
   h_p_est_revenue_npv NUMBER := 0;
   h_p_est_revenue NUMBER := 0;
   h_p_est_revenue_td NUMBER := 0;
   h_p_est_revenue_ytd NUMBER := 0;
   h_p_est_roi NUMBER := 0;
   h_p_gp NUMBER := 0;
   h_p_irr NUMBER := 0;
   h_p_npv NUMBER := 0;
   h_p_cost_npv NUMBER := 0;
   h_p_revenue_npv NUMBER := 0;
   h_p_plnd_bl1_cost NUMBER := 0;
   h_p_plnd_bl1_cost_td NUMBER := 0;
   h_p_plnd_bl1_cost_ytd NUMBER := 0;
   h_p_plnd_bl1_gp NUMBER := 0;
   h_p_plnd_bl1_irr NUMBER := 0;
   h_p_plnd_bl1_npv NUMBER := 0;
   h_p_plnd_bl1_cost_npv NUMBER := 0;
   h_p_plnd_bl1_revenue_npv NUMBER := 0;
   h_p_plnd_bl1_revenue NUMBER := 0;
   h_p_plnd_bl1_revenue_td NUMBER := 0;
   h_p_plnd_bl1_revenue_ytd NUMBER := 0;
   h_p_plnd_bl1_roi NUMBER := 0;
   h_p_plnd_bl3_cost NUMBER := 0;
   h_p_plnd_bl3_cost_td NUMBER := 0;
   h_p_plnd_bl3_cost_ytd NUMBER := 0;
   h_p_plnd_bl3_gp NUMBER := 0;
   h_p_plnd_bl3_irr NUMBER := 0;
   h_p_plnd_bl3_npv NUMBER := 0;
   h_p_plnd_bl3_cost_npv NUMBER := 0;
   h_p_plnd_bl3_revenue_npv NUMBER := 0;
   h_p_plnd_bl3_revenue NUMBER := 0;
   h_p_plnd_bl3_revenue_td NUMBER := 0;
   h_p_plnd_bl3_revenue_ytd NUMBER := 0;
   h_p_plnd_bl3_roi NUMBER := 0;
   h_p_plnd_cost NUMBER := 0;
   h_p_plnd_cost_td NUMBER := 0;
   h_p_plnd_cost_ytd NUMBER := 0;
   h_p_plnd_gp NUMBER := 0;
   h_p_plnd_irr NUMBER := 0;
   h_p_plnd_npv NUMBER := 0;
   h_p_plnd_cost_npv NUMBER := 0;
   h_p_plnd_revenue_npv NUMBER := 0;
   h_p_plnd_revenue NUMBER := 0;
   h_p_plnd_revenue_td NUMBER := 0;
   h_p_plnd_revenue_ytd NUMBER := 0;
   h_p_plnd_roi NUMBER := 0;
   h_p_rate NUMBER := 0;
   h_p_revenue NUMBER := 0;
   h_p_revenue_td NUMBER := 0;
   h_p_revenue_year NUMBER := 0;
   h_p_revenue_ytd NUMBER := 0;
   h_p_roi NUMBER := 0;
   h_p_total_irr NUMBER := 0;
   h_p_total_bl1_irr NUMBER := 0;
   h_p_total_bl3_irr NUMBER := 0;
   h_p_budget_setting_bits PLS_INTEGER := 0;
   h_c_budget_type PLS_INTEGER := 0;
   h_c_budget_year PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_current_year PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_p_actual_payback PLS_INTEGER := 0;
   h_p_budget_type PLS_INTEGER := 0;
   h_p_est_actual_payback PLS_INTEGER := 0;
   h_p_est_bl1_payback PLS_INTEGER := 0;
   h_p_est_bl3_payback PLS_INTEGER := 0;
   h_p_est_payback PLS_INTEGER := 0;
   h_p_plnd_bl1_payback PLS_INTEGER := 0;
   h_p_plnd_bl3_payback PLS_INTEGER := 0;
   h_p_plnd_payback PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   last_rate NUMBER;
   payback_month_count PLS_INTEGER;
   total_month_count PLS_INTEGER;
   year_count PLS_INTEGER;
   h_temp_sc_state PLS_INTEGER;
   cf_planned PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_estimated PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_estimated_a PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_estimated_b1 PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_estimated_b3 PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_planned_b1 PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_planned_b3 PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_total PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_total_b1 PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
   cf_total_b3 PMO_ARRAYS.NUMBER_M20 := PMO_ARRAYS.NUMBER_M20_Zeros;
-- Declare Cursors
      CURSOR CFIN30 IS
         SELECT P.PROJECT_ID, PD.BUDGET_SETTING_BITS
         FROM PMO_PORTFOLIO P
         JOIN PROJECT_DETAILS PD
         ON PD.PROJECT_ID = P.PROJECT_ID
         ORDER BY RANK;

      CURSOR CFIN50 IS
         SELECT  BUDGET_YEAR, BUDGET_TYPE,
         MONTH_01_COST, MONTH_02_COST, MONTH_03_COST,
         MONTH_04_COST, MONTH_05_COST, MONTH_06_COST,
         MONTH_07_COST, MONTH_08_COST, MONTH_09_COST,
         MONTH_10_COST, MONTH_11_COST, MONTH_12_COST,
         MONTH_01_REVENUE, MONTH_02_REVENUE, MONTH_03_REVENUE,
         MONTH_04_REVENUE, MONTH_05_REVENUE, MONTH_06_REVENUE,
         MONTH_07_REVENUE, MONTH_08_REVENUE, MONTH_09_REVENUE,
         MONTH_10_REVENUE, MONTH_11_REVENUE, MONTH_12_REVENUE
         FROM PMO_PROJECT_ROI
         WHERE PROJECT_ID = h_p_id
         ORDER BY BUDGET_TYPE, BUDGET_YEAR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PORTFOLIO_ROI') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PORTFOLIO_ROI'), '-- ' || SYSTIMESTAMP, ':r := SP_PORTFOLIO_ROI(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PORTFOLIO_ROI', 246+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PORTFOLIO_ROI(247) : views_financial.sql(6302) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PORTFOLIO_ROI', 251+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PORTFOLIO_ROI(252) : views_financial.sql(6307) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PORTFOLIO';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PROJECT_DISCOUNT';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PROJECT_ROI';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   --consider the fiscal month
   BEGIN
      SELECT SETTING_VALUE + 1 INTO h_fiscal_month FROM TMT_SETTINGS WHERE ELEMENT_ID = 'FISCAL_PERIOD';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 289+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(290) : views_financial.sql(6345) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Project Summary Info
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   
   --Collect project discount rate
   BEGIN
      INSERT INTO PMO_PROJECT_DISCOUNT
      SELECT	D.PROJECT_ID,
      CASE WHEN PMO_ORASTD.MONTH(D.DISCOUNT_DATE) < h_fiscal_month THEN PMO_ORASTD.YEAR(D.DISCOUNT_DATE) - 1 ELSE PMO_ORASTD.YEAR(D.DISCOUNT_DATE) END,
      D.DISCOUNT_PERCENT
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN PROJECT_DISCOUNT D
      ON D.PROJECT_ID = P.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 316+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(317) : views_financial.sql(6372) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Collect project fiscal year cost and revenue
   BEGIN
      INSERT INTO PMO_PROJECT_ROI
      SELECT  PBB.PROJECT_ID,
      PBB.BUDGET_YEAR,
      PBB.BUDGET_TYPE,
      SUM(PBB.MONTH_01_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_01_COST,
      SUM(PBB.MONTH_02_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_02_COST,
      SUM(PBB.MONTH_03_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_03_COST,
      SUM(PBB.MONTH_04_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_04_COST,
      SUM(PBB.MONTH_05_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_05_COST,
      SUM(PBB.MONTH_06_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_06_COST,
      SUM(PBB.MONTH_07_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_07_COST,
      SUM(PBB.MONTH_08_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_08_COST,
      SUM(PBB.MONTH_09_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_09_COST,
      SUM(PBB.MONTH_10_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_10_COST,
      SUM(PBB.MONTH_11_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_11_COST,
      SUM(PBB.MONTH_12_AMOUNT*(ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_12_COST,
      SUM(PBB.MONTH_01_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_01_REVENUE,
      SUM(PBB.MONTH_02_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_02_REVENUE,
      SUM(PBB.MONTH_03_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_03_REVENUE,
      SUM(PBB.MONTH_04_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_04_REVENUE,
      SUM(PBB.MONTH_05_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_05_REVENUE,
      SUM(PBB.MONTH_06_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_06_REVENUE,
      SUM(PBB.MONTH_07_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_07_REVENUE,
      SUM(PBB.MONTH_08_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_08_REVENUE,
      SUM(PBB.MONTH_09_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_09_REVENUE,
      SUM(PBB.MONTH_10_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_10_REVENUE,
      SUM(PBB.MONTH_11_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_11_REVENUE,
      SUM(PBB.MONTH_12_AMOUNT*(1-ABS(SIGN(CC.CAPITAL_EXPENSE-2)))) AS MONTH_12_REVENUE
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN PROJECT_BUDGET_BREAKDOWN PBB
      ON PBB.PROJECT_ID = P.ELEMENT_ID
      AND PBB.ELEMENT_ID = P.ELEMENT_ID
      AND PBB.CHARGECODE_ID NOT IN (  'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
      AND PBB.BUDGET_TYPE NOT IN (PMO_CNST.SC_PAID_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
      JOIN BUDGETS B
      ON B.PROJECT_ID = PBB.PROJECT_ID
      AND B.ELEMENT_ID = PBB.PROJECT_ID
      AND B.CHARGECODE_ID = PBB.CHARGECODE_ID
      GROUP BY PBB.PROJECT_ID, PBB.BUDGET_YEAR, PBB.BUDGET_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 383+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(384) : views_financial.sql(6439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Populate the list of project we will process in the final resultset
   BEGIN
      INSERT INTO PMO_PORTFOLIO (
      RANK, 
      PROJECT_ID, 
      PROJECT_NAME, 
      PROJECT_MANAGER, 
      PROJECT_PRIORITY,
      PROJECT_BUDGET_SETTING_BITS,
      PROJECT_QUICK_START, 
      PROJECT_QUICK_FINISH, 
      PROJECT_SCHED_START, 
      PROJECT_SCHED_FINISH, 
      PROJECT_ACTUAL_START, 
      PROJECT_ACTUAL_FINISH, 
      PROJECT_EST_HOURS, 
      PROJECT_EST_ACTUAL_HOURS, 
      PROJECT_EST_HOURS_ETC, 
      SCOPE_SCORE,
      SCOPE_WEIGHT,
      SCHEDULE_SCORE,
      SCHEDULE_WEIGHT,
      QUALITY_SCORE,
      QUALITY_WEIGHT,
      BENEFIT_SCORE,
      BENEFIT_WEIGHT,
      COST_SCORE,
      COST_WEIGHT,
      PROJECT_AVG_RATE,
      ACTUAL_START )
      SELECT	W.RANK, 
      W.ELEMENT_ID, 
      W.ELEMENT_NAME, 
      R.FULL_NAME, 
      W.PRIORITY,
      PD.BUDGET_SETTING_BITS,
      W.START_DT, 
      W.FINISH_DT, 
      W.UNRESOLVED_START, 
      W.UNRESOLVED_FINISH, 
      W.ACTUAL_START, 
      W.ACTUAL_FINISH, 
      W.ESTIMATED_HOURS, 
      W.ESTIMATED_ACTUAL_HOURS, 
      W.ESTIMATED_HOURS_ETC, 
      PD.SCOPE_SCORE,
      PD.SCOPE_WEIGHT,
      PD.SCHEDULE_SCORE,
      PD.SCHEDULE_WEIGHT,
      PD.QUALITY_SCORE,
      PD.QUALITY_WEIGHT,
      PD.BENEFIT_SCORE,
      PD.BENEFIT_WEIGHT,
      PD.COST_SCORE,
      PD.COST_WEIGHT,
      (SELECT AVG(COALESCE(DISCOUNT_PERCENT,0))/100 FROM PROJECT_DISCOUNT WHERE PROJECT_ID = W.ELEMENT_ID),
      TO_DATE(SubStr(W.ACTUAL_START, 1, 10))
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN TMT_WBS W
      ON W.ELEMENT_ID = P.ELEMENT_ID
      JOIN PROJECT_DETAILS PD
      ON PD.PROJECT_ID = W.ELEMENT_ID
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = W.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER
      JOIN RESOURCES R
      ON R.RESOURCE_ID = RA.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 465+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(466) : views_financial.sql(6521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Update project's ETC Budgets
   BEGIN
      UPDATE PMO_PORTFOLIO P SET
      (PLANNED_ETC_COST, PLANNED_ETC_REVENUE, ESTIMATED_ETC_COST, ESTIMATED_ETC_REVENUE) =
      (   SELECT
      SUM(B.ETC*(ABS(SIGN(C.CAPITAL_EXPENSE-2)))),
      SUM(B.ETC*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))),
      SUM((CASE WHEN (B.ESTIMATED_ETC = 0) AND (B.ESTIMATED_BUDGET = 0) THEN B.ESTIMATED_ETC_TOTAL * PD.ROLLUP_PROJECT_ESTIMATED ELSE B.ESTIMATED_ETC END) * (ABS(SIGN(C.CAPITAL_EXPENSE-2)))),
      SUM((CASE WHEN (B.ESTIMATED_ETC = 0) AND (B.ESTIMATED_BUDGET = 0) THEN B.ESTIMATED_ETC_TOTAL * PD.ROLLUP_PROJECT_ESTIMATED ELSE B.ESTIMATED_ETC END) * (1-ABS(SIGN(C.CAPITAL_EXPENSE-2))))
      FROM BUDGETS B
      JOIN TMT_CHARGECODES C
      ON C.ELEMENT_ID = B.CHARGECODE_ID
      JOIN PROJECT_DETAILS PD
      ON PD.PROJECT_ID = B.PROJECT_ID
      WHERE B.PROJECT_ID = P.PROJECT_ID
      AND B.ELEMENT_ID = P.PROJECT_ID
      AND B.CHARGECODE_ID NOT IN (
      'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' ) );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 507+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(508) : views_financial.sql(6563) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --get the current dates
   BEGIN
      SELECT  (TO_DATE(SubStr(SUBSTR(TO_CHAR(TO_DATE(SYSDATE)), 1, 8) || '01', 1, 10)) - 1    ),
      CASE WHEN PMO_ORASTD.MONTH(TO_DATE(SYSDATE)) < h_fiscal_month THEN PMO_ORASTD.YEAR(TO_DATE(SYSDATE)) - 1 ELSE PMO_ORASTD.YEAR(TO_DATE(SYSDATE)) END
      INTO h_current_date, h_current_year
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 524+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(525) : views_financial.sql(6580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Declare and walk the cursor to process each project
   
   OPEN CFIN30;
   
   --for each project
   LOOP
      FETCH CFIN30 INTO h_p_id, h_p_budget_setting_bits;
      IF CFIN30%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_budget_type := -1;
      h_p_payback_start_date := NULL;
      
      h_p_actual_start := NULL;
      h_p_actual_finish := NULL;
      h_p_actual_cost := 0.00;
      h_p_actual_cost_td := 0.00;
      h_p_actual_cost_ytd := 0.00;
      h_p_actual_revenue := 0.00;
      h_p_actual_revenue_td := 0.00;
      h_p_actual_revenue_ytd := 0.00;
      h_p_actual_gp := 0.00;
      h_p_actual_npv := 0.00;
      h_p_actual_cost_npv := 0.00;
      h_p_actual_revenue_npv := 0.00;
      h_p_actual_irr := 0.00;
      h_p_actual_roi := 0.00;
      h_p_actual_payback := 0;
      h_p_actual_payback_date := NULL;
      
      h_p_plnd_start := NULL;
      h_p_plnd_finish := NULL;
      h_p_plnd_cost := 0.00;
      h_p_plnd_cost_td := 0.00;
      h_p_plnd_cost_ytd := 0.00;
      h_p_plnd_revenue := 0.00;
      h_p_plnd_revenue_td := 0.00;
      h_p_plnd_revenue_ytd := 0.00;
      h_p_plnd_gp := 0.00;
      h_p_plnd_npv := 0.00;
      h_p_plnd_cost_npv := 0.00;
      h_p_plnd_revenue_npv := 0.00;
      h_p_plnd_irr := 0.00;
      h_p_plnd_roi := 0.00;
      h_p_plnd_payback := 0;
      h_p_plnd_payback_date := NULL;
      
      h_p_est_start := NULL;
      h_p_est_finish := NULL;
      h_p_est_cost := 0.00;
      h_p_est_cost_td := 0.00;
      h_p_est_cost_ytd := 0.00;
      h_p_est_revenue := 0.00;
      h_p_est_revenue_td := 0.00;
      h_p_est_revenue_ytd := 0.00;
      h_p_est_gp := 0.00;
      h_p_est_npv := 0.00;
      h_p_est_cost_npv := 0.00;
      h_p_est_revenue_npv := 0.00;
      h_p_est_irr := 0.00;
      h_p_est_roi := 0.00;
      h_p_est_payback := 0;
      h_p_est_payback_date := NULL;
      
      h_p_est_actual_start := NULL;
      h_p_est_actual_finish := NULL;
      h_p_est_actual_cost := 0.00;
      h_p_est_actual_cost_td := 0.00;
      h_p_est_actual_cost_ytd := 0.00;
      h_p_est_actual_revenue := 0.00;
      h_p_est_actual_revenue_td := 0.00;
      h_p_est_actual_revenue_ytd := 0.00;
      h_p_est_actual_gp := 0.00;
      h_p_est_actual_npv := 0.00;
      h_p_est_actual_cost_npv := 0.00;
      h_p_est_actual_revenue_npv := 0.00;
      h_p_est_actual_irr := 0.00;
      h_p_est_actual_roi := 0.00;
      h_p_est_actual_payback := 0;
      h_p_est_actual_payback_date := NULL;
      
      h_p_est_bl1_start := NULL;
      h_p_est_bl1_finish := NULL;
      h_p_est_bl1_cost := 0.00;
      h_p_est_bl1_cost_td := 0.00;
      h_p_est_bl1_cost_ytd := 0.00;
      h_p_est_bl1_revenue := 0.00;
      h_p_est_bl1_revenue_td := 0.00;
      h_p_est_bl1_revenue_ytd := 0.00;
      h_p_est_bl1_gp := 0.00;
      h_p_est_bl1_npv := 0.00;
      h_p_est_bl1_cost_npv := 0.00;
      h_p_est_bl1_revenue_npv := 0.00;
      h_p_est_bl1_irr := 0.00;
      h_p_est_bl1_roi := 0.00;
      h_p_est_bl1_payback := 0;
      h_p_est_bl1_payback_date := NULL;
      
      h_p_est_bl3_start := NULL;
      h_p_est_bl3_finish := NULL;
      h_p_est_bl3_cost := 0.00;
      h_p_est_bl3_cost_td := 0.00;
      h_p_est_bl3_cost_ytd := 0.00;
      h_p_est_bl3_revenue := 0.00;
      h_p_est_bl3_revenue_td := 0.00;
      h_p_est_bl3_revenue_ytd := 0.00;
      h_p_est_bl3_gp := 0.00;
      h_p_est_bl3_npv := 0.00;
      h_p_est_bl3_cost_npv := 0.00;
      h_p_est_bl3_revenue_npv := 0.00;
      h_p_est_bl3_irr := 0.00;
      h_p_est_bl3_roi := 0.00;
      h_p_est_bl3_payback := 0;
      h_p_est_bl3_payback_date := NULL;
      
      h_p_plnd_bl1_start := NULL;
      h_p_plnd_bl1_finish := NULL;
      h_p_plnd_bl1_cost := 0.00;
      h_p_plnd_bl1_cost_td := 0.00;
      h_p_plnd_bl1_cost_ytd := 0.00;
      h_p_plnd_bl1_revenue := 0.00;
      h_p_plnd_bl1_revenue_td := 0.00;
      h_p_plnd_bl1_revenue_ytd := 0.00;
      h_p_plnd_bl1_gp := 0.00;
      h_p_plnd_bl1_npv := 0.00;
      h_p_plnd_bl1_cost_npv := 0.00;
      h_p_plnd_bl1_revenue_npv := 0.00;
      h_p_plnd_bl1_irr := 0.00;
      h_p_plnd_bl1_roi := 0.00;
      h_p_plnd_bl1_payback := 0;
      h_p_plnd_bl1_payback_date := NULL;
      
      h_p_plnd_bl3_start := NULL;
      h_p_plnd_bl3_finish := NULL;
      h_p_plnd_bl3_cost := 0.00;
      h_p_plnd_bl3_cost_td := 0.00;
      h_p_plnd_bl3_cost_ytd := 0.00;
      h_p_plnd_bl3_revenue := 0.00;
      h_p_plnd_bl3_revenue_td := 0.00;
      h_p_plnd_bl3_revenue_ytd := 0.00;
      h_p_plnd_bl3_gp := 0.00;
      h_p_plnd_bl3_npv := 0.00;
      h_p_plnd_bl3_cost_npv := 0.00;
      h_p_plnd_bl3_revenue_npv := 0.00;
      h_p_plnd_bl3_irr := 0.00;
      h_p_plnd_bl3_roi := 0.00;
      h_p_plnd_bl3_payback := 0;
      h_p_plnd_bl3_payback_date := NULL;
      
      h_p_total_irr := 0.00;
      h_p_total_bl1_irr := 0.00;
      h_p_total_bl3_irr := 0.00;
      
      cf_planned := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_estimated := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_estimated_a := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_estimated_b1 := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_estimated_b3 := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_planned_b1 := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_planned_b3 := PMO_ARRAYS.NUMBER_M20_Zeros;
      
      cf_total := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_total_b1 := PMO_ARRAYS.NUMBER_M20_Zeros;
      cf_total_b3 := PMO_ARRAYS.NUMBER_M20_Zeros;
      
      --Do Timephase Check
      BEGIN
         SELECT COUNT(BUDGET_YEAR)
         INTO h_c_budget_year
         FROM PMO_PROJECT_ROI
         WHERE PROJECT_ID = h_p_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 712+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(713) : views_financial.sql(6768) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_c_budget_year, 0) = 0 Then
         BEGIN
            SELECT  START_FINISH_DATE,
            TO_DATE(SubStr(ACTUAL_START, 1, 10)),
            TO_DATE(SubStr(ACTUAL_FINISH, 1, 10)),
            ACTUAL_BUDGET,
            R_ACTUAL_BUDGET+S_ACTUAL_BUDGET,
            TO_DATE(SubStr(SCHED_START, 1, 10)),
            TO_DATE(SubStr(SCHED_FINISH, 1, 10)),
            CURRENT_BUDGET,
            R_CURRENT_BUDGET+S_CURRENT_BUDGET,
            START_FINISH_DATE,
            FINISH_START_DATE,
            ESTIMATION_BUDGET,
            R_ESTIMATION_BUDGET+S_ESTIMATION_BUDGET,
            ESTIMATED_ACTUAL,
            R_ESTIMATED_ACTUAL+S_ESTIMATED_ACTUAL,
            TO_DATE(SubStr(ESTIMATED_BASELINE1_START, 1, 10)),
            TO_DATE(SubStr(ESTIMATED_BASELINE1_FINISH, 1, 10)),
            ESTIMATED_BASELINE1_BUDGET,
            R_ESTIMATED_BASELINE1_BUDGET+S_ESTIMATED_BASELINE1_BUDGET,
            TO_DATE(SubStr(ESTIMATED_BASELINE3_START, 1, 10)),
            TO_DATE(SubStr(ESTIMATED_BASELINE3_FINISH, 1, 10)),
            ESTIMATED_BASELINE3_BUDGET,
            R_ESTIMATED_BASELINE3_BUDGET+S_ESTIMATED_BASELINE3_BUDGET,
            TO_DATE(SubStr(BASELINE1_START, 1, 10)),
            TO_DATE(SubStr(BASELINE1_FINISH, 1, 10)),
            BASELINE1_BUDGET,
            R_BASELINE1_BUDGET+S_BASELINE1_BUDGET,
            TO_DATE(SubStr(BASELINE3_START, 1, 10)),
            TO_DATE(SubStr(BASELINE3_FINISH, 1, 10)),
            BASELINE3_BUDGET,
            R_BASELINE3_BUDGET+S_BASELINE3_BUDGET
            INTO    h_p_payback_start_date,
            h_p_actual_start,
            h_p_actual_finish,
            h_p_actual_cost,
            h_p_actual_revenue,
            h_p_plnd_start,
            h_p_plnd_finish,
            h_p_plnd_cost,
            h_p_plnd_revenue,
            h_p_est_start,
            h_p_est_finish,
            h_p_est_cost,
            h_p_est_revenue,
            h_p_est_actual_cost,
            h_p_est_actual_revenue,
            h_p_est_bl1_start,
            h_p_est_bl1_finish,
            h_p_est_bl1_cost,
            h_p_est_bl1_revenue,
            h_p_est_bl3_start,
            h_p_est_bl3_finish,
            h_p_est_bl3_cost,
            h_p_est_bl3_revenue,
            h_p_plnd_bl1_start,
            h_p_plnd_bl1_finish,
            h_p_plnd_bl1_cost,
            h_p_plnd_bl1_revenue,
            h_p_plnd_bl3_start,
            h_p_plnd_bl3_finish,
            h_p_plnd_bl3_cost,
            h_p_plnd_bl3_revenue
            FROM TMT_WBS
            WHERE PROJECT_ID = h_p_id
            AND ELEMENT_ID = h_p_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 790+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(791) : views_financial.sql(6846) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         year_count := 0;
         
         --Fetch from PROJECT ROI
         
         OPEN CFIN50;
         
         LOOP
            FETCH CFIN50 INTO   h_c_budget_year, h_c_budget_type,
            h_c_month_01_cost, h_c_month_02_cost, h_c_month_03_cost,
            h_c_month_04_cost, h_c_month_05_cost, h_c_month_06_cost,
            h_c_month_07_cost, h_c_month_08_cost, h_c_month_09_cost,
            h_c_month_10_cost, h_c_month_11_cost, h_c_month_12_cost,
            h_c_month_01_revenue, h_c_month_02_revenue, h_c_month_03_revenue,
            h_c_month_04_revenue, h_c_month_05_revenue, h_c_month_06_revenue,
            h_c_month_07_revenue, h_c_month_08_revenue, h_c_month_09_revenue,
            h_c_month_10_revenue, h_c_month_11_revenue, h_c_month_12_revenue;
            IF CFIN50%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            If year_count >= PMO_CNST.NUMBER_OF_YEARS Then
               EXIT;
            End If;
            
            --Type Switch Checking
            If Coalesce(h_p_budget_type, 0) <> Coalesce(h_c_budget_type, 0) Then
               --Reset type
               h_p_budget_type := h_c_budget_type;
               --Reset start date
               
               h_p_start := LPad(TO_CHAR(Coalesce(h_c_budget_year, 0)), 4) || '-' || LPad(TO_CHAR(Coalesce(
                     h_fiscal_month, 0)), 2, '0') || '-01';
               --Reset finish date (1 day before start date)
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_start),1,8) || '01', 1, 10)) - 1    )
                  INTO h_p_finish FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 842+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(843) : views_financial.sql(6898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               --Reset budget buffer
               h_p_cost := 0.00;
               h_p_cost_td := 0.00;
               h_p_cost_ytd := 0.00;
               h_p_revenue := 0.00;
               h_p_revenue_td := 0.00;
               h_p_revenue_ytd := 0.00;
               h_p_gp := 0.00;
               h_p_npv := 0.00;
               h_p_cost_npv := 0.00;
               h_p_revenue_npv := 0.00;
               h_p_irr := 0.00;
               h_p_roi := 0.00;
               --Reset counters
               year_count := 0;
               total_month_count := 0;
               payback_month_count := 0;
               last_rate := 0.00000;
            End If;
            
            --Get the rate for the period
            BEGIN
               SELECT AVG(DISCOUNT_PERCENT)/100, COUNT(PROJECT_ID)
               INTO h_p_rate, h_count
               FROM PMO_PROJECT_DISCOUNT
               WHERE PROJECT_ID = h_p_id
               AND DISCOUNT_YEAR = h_c_budget_year;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 879+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(880) : views_financial.sql(6935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) = 0 Then
               h_p_rate := last_rate;
            Else
               last_rate := Coalesce(h_p_rate, 0);
            End If;
            
            --Accumulate td, ytd, and payback period
            h_p_cost_year := 0.00;
            h_p_revenue_year := 0.00;
            h_p_cost_ytd := 0.00;
            h_p_revenue_ytd := 0.00;
            
            --month 1
            BEGIN
               SELECT Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 905+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(906) : views_financial.sql(6961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_01_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_01_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_01_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_01_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_01_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_01_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_01_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_01_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_01_revenue, 0) - Coalesce(h_c_month_01_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 933+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(934) : views_financial.sql(6989) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 2
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) ) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 957+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(958) : views_financial.sql(7013) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_02_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_02_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_02_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_02_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_02_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_02_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_02_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_02_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_02_revenue, 0) - Coalesce(h_c_month_02_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 985+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(986) : views_financial.sql(7041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 3
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1)) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1009+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1010) : views_financial.sql(7065) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_03_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_03_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_03_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_03_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_03_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_03_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_03_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_03_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_03_revenue, 0) - Coalesce(h_c_month_03_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1037+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1038) : views_financial.sql(7093) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 4
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) ) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1061+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1062) : views_financial.sql(7117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_04_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_04_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_04_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_04_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_04_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_04_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_04_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_04_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_04_revenue, 0) - Coalesce(h_c_month_04_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1089+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1090) : views_financial.sql(7145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 5
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) ) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1113+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1114) : views_financial.sql(7169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_05_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_05_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_05_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_05_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_05_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_05_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_05_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_05_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_05_revenue, 0) - Coalesce(h_c_month_05_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1141+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1142) : views_financial.sql(7197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 6
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) ) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1165+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1166) : views_financial.sql(7221) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_06_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_06_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_06_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_06_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_06_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_06_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_06_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_06_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_06_revenue, 0) - Coalesce(h_c_month_06_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1193+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1194) : views_financial.sql(7249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 7
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1)) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1217+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1218) : views_financial.sql(7273) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_07_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_07_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_07_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_07_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_07_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_07_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_07_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_07_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_07_revenue, 0) - Coalesce(h_c_month_07_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1245+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1246) : views_financial.sql(7301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 8
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) ) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1269+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1270) : views_financial.sql(7325) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_08_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_08_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_08_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_08_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_08_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_08_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_08_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_08_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_08_revenue, 0) - Coalesce(h_c_month_08_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1297+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1298) : views_financial.sql(7353) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 9
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) ) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1321+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1322) : views_financial.sql(7377) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_09_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_09_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_09_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_09_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_09_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_09_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_09_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_09_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_09_revenue, 0) - Coalesce(h_c_month_09_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1349+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1350) : views_financial.sql(7405) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 10
            BEGIN
               SELECT (Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) ) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1373+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1374) : views_financial.sql(7429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_10_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_10_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_10_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_10_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_10_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_10_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_10_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_10_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_10_revenue, 0) - Coalesce(h_c_month_10_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1401+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1402) : views_financial.sql(7457) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 11
            BEGIN
               SELECT Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1425+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1426) : views_financial.sql(7481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_11_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_11_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_11_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_11_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_11_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_11_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_11_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_11_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_11_revenue, 0) - Coalesce(h_c_month_11_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1453+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1454) : views_financial.sql(7509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --month 12
            BEGIN
               SELECT Add_Months(TO_DATE(SubStr(h_p_finish, 1, 10)), 1) INTO h_p_finish FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1477+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1478) : views_financial.sql(7533) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_p_cost := Coalesce(h_p_cost, 0) + Coalesce(h_c_month_12_cost, 0);
            h_p_revenue := Coalesce(h_p_revenue, 0) + Coalesce(h_c_month_12_revenue, 0);
            h_p_cost_year := Coalesce(h_p_cost_year, 0) + Coalesce(h_c_month_12_cost, 0);
            h_p_revenue_year := Coalesce(h_p_revenue_year, 0) + Coalesce(h_c_month_12_revenue, 0);
            If PMO_ORASTD.strcmp(h_p_finish, h_current_date) <= 0 Then
               h_p_cost_ytd := Coalesce(h_p_cost_ytd, 0) + Coalesce(h_c_month_12_cost, 0);
               h_p_revenue_ytd := Coalesce(h_p_revenue_ytd, 0) + Coalesce(h_c_month_12_revenue, 0);
               h_p_cost_td := Coalesce(h_p_cost_td, 0) + Coalesce(h_c_month_12_cost, 0);
               h_p_revenue_td := Coalesce(h_p_revenue_td, 0) + Coalesce(h_c_month_12_revenue, 0);
            End If;
            h_p_gp := Coalesce(h_p_gp, 0) + (Coalesce(h_c_month_12_revenue, 0) - Coalesce(h_c_month_12_cost, 0));
            
            If ((Coalesce(h_p_cost, 0) <> 0.00) OR (Coalesce(h_p_revenue, 0) <> 0.00)) 
                  AND (total_month_count = 0) Then
               total_month_count := 1;
               BEGIN
                  SELECT (TO_DATE(SubStr(SUBSTR(TO_CHAR(h_p_finish),1,8) || '01', 1, 10)))
                  INTO h_p_payback_start_date FROM DUAL;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1505+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1506) : views_financial.sql(7561) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            ElsIf total_month_count > 0 Then
               total_month_count := total_month_count + 1;
            End If;
            
            If (Coalesce(h_p_cost, 0) > 0.00) AND (Coalesce(h_p_gp, 0) >= 0.00) 
                  AND (payback_month_count = 0) Then
               payback_month_count := total_month_count;
            ElsIf Coalesce(h_p_gp, 0) < 0.00 Then
               payback_month_count := 0;
            End If;
            
            --Summarize
            If Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ACTUAL_BUDGET Then
               h_p_actual_start := h_p_start;
               h_p_actual_finish := h_p_finish;
               h_p_actual_cost := h_p_cost;
               h_p_actual_revenue := h_p_revenue;
               h_p_actual_cost_td := h_p_cost_td;
               h_p_actual_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_actual_cost_ytd := h_p_cost_ytd;
                  h_p_actual_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_actual_gp := h_p_gp;
               h_p_actual_payback := payback_month_count;
               h_p_actual_npv := Coalesce(h_p_actual_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                           h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_actual_cost_npv := Coalesce(h_p_actual_cost_npv, 0) + Coalesce(h_p_cost_year, 0) / Power((1 
                                + Coalesce(h_p_rate, 0)), year_count);
               h_p_actual_revenue_npv := Coalesce(h_p_actual_revenue_npv, 0) + Coalesce(h_p_revenue_year, 0) 
                                   / Power((1 + Coalesce(h_p_rate, 0)), year_count);
            ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET Then
               h_p_plnd_start := h_p_start;
               h_p_plnd_finish := h_p_finish;
               h_p_plnd_cost := h_p_cost;
               h_p_plnd_revenue := h_p_revenue;
               h_p_plnd_cost_td := h_p_cost_td;
               h_p_plnd_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_plnd_cost_ytd := h_p_cost_ytd;
                  h_p_plnd_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_plnd_gp := h_p_gp;
               h_p_plnd_payback := payback_month_count;
               cf_planned(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               h_p_plnd_npv := Coalesce(h_p_plnd_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                         h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_plnd_cost_npv := Coalesce(h_p_plnd_cost_npv, 0) + Coalesce(h_p_cost_year, 0) / Power((1 
                              + Coalesce(h_p_rate, 0)), year_count);
               h_p_plnd_revenue_npv := Coalesce(h_p_plnd_revenue_npv, 0) + Coalesce(h_p_revenue_year, 0) / Power(
                                 (1 + Coalesce(h_p_rate, 0)), year_count);
            ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET Then
               h_p_est_start := h_p_start;
               h_p_est_finish := h_p_finish;
               h_p_est_cost := h_p_cost;
               h_p_est_revenue := h_p_revenue;
               h_p_est_cost_td := h_p_cost_td;
               h_p_est_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_est_cost_ytd := h_p_cost_ytd;
                  h_p_est_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_est_gp := h_p_gp;
               h_p_est_payback := payback_month_count;
               cf_estimated(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               h_p_est_npv := Coalesce(h_p_est_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                        h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_cost_npv := Coalesce(h_p_est_cost_npv, 0) + Coalesce(h_p_cost_year, 0) / Power((1 
                             + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_revenue_npv := Coalesce(h_p_est_revenue_npv, 0) + Coalesce(h_p_revenue_year, 0) / Power((1 
                                + Coalesce(h_p_rate, 0)), year_count);
            ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_ACTUAL_BUDGET Then
               h_p_est_actual_start := h_p_start;
               h_p_est_actual_finish := h_p_finish;
               h_p_est_actual_cost := h_p_cost;
               h_p_est_actual_revenue := h_p_revenue;
               h_p_est_actual_cost_td := h_p_cost_td;
               h_p_est_actual_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_est_actual_cost_ytd := h_p_cost_ytd;
                  h_p_est_actual_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_est_actual_gp := h_p_gp;
               h_p_est_actual_payback := payback_month_count;
               cf_estimated_a(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               h_p_est_actual_npv := Coalesce(h_p_est_actual_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                               h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_actual_cost_npv := Coalesce(h_p_est_actual_cost_npv, 0) + Coalesce(h_p_cost_year, 0) 
                                    / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_actual_revenue_npv := Coalesce(h_p_est_actual_revenue_npv, 0) + Coalesce(
                                       h_p_revenue_year, 0) / Power((1 + Coalesce(h_p_rate, 0))
                                       , year_count);
            ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE1 Then
               h_p_est_bl1_start := h_p_start;
               h_p_est_bl1_finish := h_p_finish;
               h_p_est_bl1_cost := h_p_cost;
               h_p_est_bl1_revenue := h_p_revenue;
               h_p_est_bl1_cost_td := h_p_cost_td;
               h_p_est_bl1_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_est_bl1_cost_ytd := h_p_cost_ytd;
                  h_p_est_bl1_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_est_bl1_gp := h_p_gp;
               h_p_est_bl1_payback := payback_month_count;
               cf_estimated_b1(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               h_p_est_bl1_npv := Coalesce(h_p_est_bl1_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                            h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_bl1_cost_npv := Coalesce(h_p_est_bl1_cost_npv, 0) + Coalesce(h_p_cost_year, 0) / Power((1 
                                 + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_bl1_revenue_npv := Coalesce(h_p_est_bl1_revenue_npv, 0) + Coalesce(h_p_revenue_year, 0) 
                                    / Power((1 + Coalesce(h_p_rate, 0)), year_count);
            ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE3 Then
               h_p_est_bl3_start := h_p_start;
               h_p_est_bl3_finish := h_p_finish;
               h_p_est_bl3_cost := h_p_cost;
               h_p_est_bl3_revenue := h_p_revenue;
               h_p_est_bl3_cost_td := h_p_cost_td;
               h_p_est_bl3_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_est_bl3_cost_ytd := h_p_cost_ytd;
                  h_p_est_bl3_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_est_bl3_gp := h_p_gp;
               h_p_est_bl3_payback := payback_month_count;
               cf_estimated_b3(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               h_p_est_bl3_npv := Coalesce(h_p_est_bl3_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                            h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_bl3_cost_npv := Coalesce(h_p_est_bl3_cost_npv, 0) + Coalesce(h_p_cost_year, 0) / Power((1 
                                 + Coalesce(h_p_rate, 0)), year_count);
               h_p_est_bl3_revenue_npv := Coalesce(h_p_est_bl3_revenue_npv, 0) + Coalesce(h_p_revenue_year, 0) 
                                    / Power((1 + Coalesce(h_p_rate, 0)), year_count);
            ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BASELINE1 Then
               h_p_plnd_bl1_start := h_p_start;
               h_p_plnd_bl1_finish := h_p_finish;
               h_p_plnd_bl1_cost := h_p_cost;
               h_p_plnd_bl1_revenue := h_p_revenue;
               h_p_plnd_bl1_cost_td := h_p_cost_td;
               h_p_plnd_bl1_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_plnd_bl1_cost_ytd := h_p_cost_ytd;
                  h_p_plnd_bl1_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_plnd_bl1_gp := h_p_gp;
               h_p_plnd_bl1_payback := payback_month_count;
               cf_planned_b1(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               h_p_plnd_bl1_npv := Coalesce(h_p_plnd_bl1_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                             h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_plnd_bl1_cost_npv := Coalesce(h_p_plnd_bl1_cost_npv, 0) + (Coalesce(h_p_revenue_year, 0) 
                                  - Coalesce(h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0))
                                  , year_count);
               h_p_plnd_bl1_revenue_npv := Coalesce(h_p_plnd_bl1_revenue_npv, 0) + (Coalesce(h_p_revenue_year, 0) 
                                     - Coalesce(h_p_cost_year, 0)) / Power((1 + Coalesce(
                                     h_p_rate, 0)), year_count);
            ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BASELINE3 Then
               h_p_plnd_bl3_start := h_p_start;
               h_p_plnd_bl3_finish := h_p_finish;
               h_p_plnd_bl3_cost := h_p_cost;
               h_p_plnd_bl3_revenue := h_p_revenue;
               h_p_plnd_bl3_cost_td := h_p_cost_td;
               h_p_plnd_bl3_revenue_td := h_p_revenue_td;
               If Coalesce(h_c_budget_year, 0) = Coalesce(h_current_year, 0) Then
                  h_p_plnd_bl3_cost_ytd := h_p_cost_ytd;
                  h_p_plnd_bl3_revenue_ytd := h_p_revenue_ytd;
               End If;
               h_p_plnd_bl3_gp := h_p_gp;
               h_p_plnd_bl3_payback := payback_month_count;
               cf_planned_b1(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               h_p_plnd_bl3_npv := Coalesce(h_p_plnd_bl3_npv, 0) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                             h_p_cost_year, 0)) / Power((1 + Coalesce(h_p_rate, 0)), year_count);
               h_p_plnd_bl3_cost_npv := Coalesce(h_p_plnd_bl3_cost_npv, 0) + Coalesce(h_p_cost_year, 0) / Power((1 
                                  + Coalesce(h_p_rate, 0)), year_count);
               h_p_plnd_bl3_revenue_npv := Coalesce(h_p_plnd_bl3_revenue_npv, 0) + Coalesce(h_p_revenue_year, 0) 
                                     / Power((1 + Coalesce(h_p_rate, 0)), year_count);
            End If;
            
            --total arrays
            If (Coalesce(h_p_budget_setting_bits, 0) = 0) OR (Coalesce(h_p_budget_setting_bits, 0) = 2) Then
               --(Estimated Only)
               If Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET Then
                  cf_total(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE1 Then
                  cf_total_b1(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE3 Then
                  cf_total_b3(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               End If;
            ElsIf Coalesce(h_p_budget_setting_bits, 0) = 1 Then
               --(Schedule Only)
               If Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET Then
                  cf_total(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BASELINE1 Then
                  cf_total_b1(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               ElsIf Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BASELINE3 Then
                  cf_total_b3(year_count + 1) := (Coalesce(h_p_revenue_year, 0) - Coalesce(h_p_cost_year, 0));
               End If;
            ElsIf Coalesce(h_p_budget_setting_bits, 0) = 3 Then
               --(Estimated + Schedule)
               If (Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BUDGET) OR (Coalesce(
                     h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BUDGET) Then
                  cf_total(year_count + 1) := cf_total(year_count + 1) + (Coalesce(h_p_revenue_year, 0) - Coalesce(
                                                     h_p_cost_year, 0));
               ElsIf (Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE1) OR (Coalesce(
                     h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BASELINE1) Then
                  cf_total_b1(year_count + 1) := cf_total_b1(year_count + 1) + (Coalesce(h_p_revenue_year, 0) 
                                                           - Coalesce(h_p_cost_year, 0));
               ElsIf (Coalesce(h_c_budget_type, 0) = PMO_CNST.SC_ESTIMATED_BASELINE3) OR (Coalesce(
                     h_c_budget_type, 0) = PMO_CNST.SC_SCHED_BASELINE3) Then
                  cf_total_b3(year_count + 1) := cf_total_b3(year_count + 1) + (Coalesce(h_p_revenue_year, 0) 
                                                           - Coalesce(h_p_cost_year, 0));
               End If;
            End If;
            
            year_count := year_count + 1;
         END LOOP;
         
         BEGIN
            CLOSE CFIN50 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1732+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1733) : views_financial.sql(7788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_p_plnd_irr := irr(cf_planned, year_count);
         If ((Coalesce(h_p_plnd_npv, 0) > 0.0) AND (Coalesce(h_p_plnd_irr, 0) < 0.0)) OR ((Coalesce(
               h_p_plnd_npv, 0) < 0.0) AND (Coalesce(h_p_plnd_irr, 0) > 0.0)) Then
            h_p_plnd_irr := 0.0;
         End If;
         
         h_p_est_irr := irr(cf_estimated, year_count);
         If ((Coalesce(h_p_est_npv, 0) > 0.0) AND (Coalesce(h_p_est_irr, 0) < 0.0)) OR ((Coalesce(
               h_p_est_npv, 0) < 0.0) AND (Coalesce(h_p_est_irr, 0) > 0.0)) Then
            h_p_est_irr := 0.0;
         End If;
         
         h_p_est_actual_irr := irr(cf_estimated_a, year_count);
         If ((Coalesce(h_p_est_actual_npv, 0) > 0.0) AND (Coalesce(h_p_est_actual_irr, 0) < 0.0)) 
               OR ((Coalesce(h_p_est_actual_npv, 0) < 0.0) AND (Coalesce(
               h_p_est_actual_irr, 0) > 0.0)) Then
            h_p_est_actual_irr := 0.0;
         End If;
         
         h_p_est_bl1_irr := irr(cf_estimated_b1, year_count);
         If ((Coalesce(h_p_est_bl1_npv, 0) > 0.0) AND (Coalesce(h_p_est_bl1_irr, 0) < 0.0)) OR ((Coalesce(
               h_p_est_bl1_npv, 0) < 0.0) AND (Coalesce(h_p_est_bl1_irr, 0) > 0.0)) Then
            h_p_est_bl1_irr := 0.0;
         End If;
         
         h_p_est_bl3_irr := irr(cf_estimated_b3, year_count);
         If ((Coalesce(h_p_est_bl3_npv, 0) > 0.0) AND (Coalesce(h_p_est_bl3_irr, 0) < 0.0)) OR ((Coalesce(
               h_p_est_bl3_npv, 0) < 0.0) AND (Coalesce(h_p_est_bl3_irr, 0) > 0.0)) Then
            h_p_est_bl3_irr := 0.0;
         End If;
         
         h_p_plnd_bl1_irr := irr(cf_estimated_b1, year_count);
         If ((Coalesce(h_p_plnd_bl1_npv, 0) > 0.0) AND (Coalesce(h_p_plnd_bl1_irr, 0) < 0.0)) OR ((Coalesce(
               h_p_plnd_bl1_npv, 0) < 0.0) AND (Coalesce(h_p_plnd_bl1_irr, 0) > 0.0)) Then
            h_p_plnd_bl1_irr := 0.0;
         End If;
         
         h_p_plnd_bl3_irr := irr(cf_estimated_b3, year_count);
         If ((Coalesce(h_p_plnd_bl3_npv, 0) > 0.0) AND (Coalesce(h_p_plnd_bl3_irr, 0) < 0.0)) OR ((Coalesce(
               h_p_plnd_bl3_npv, 0) < 0.0) AND (Coalesce(h_p_plnd_bl3_irr, 0) > 0.0)) Then
            h_p_plnd_bl3_irr := 0.0;
         End If;
         
         h_p_total_irr := irr(cf_total, year_count);
         
         h_p_total_bl1_irr := irr(cf_total_b1, year_count);
         
         h_p_total_bl3_irr := irr(cf_total_b3, year_count);
         
         --roi
         h_p_plnd_roi := roi(Coalesce(h_p_plnd_cost, 0), Coalesce(h_p_plnd_revenue, 0));
         h_p_est_roi := roi(Coalesce(h_p_est_cost, 0), Coalesce(h_p_est_revenue, 0));
         h_p_est_actual_roi := roi(Coalesce(h_p_est_actual_cost, 0), Coalesce(h_p_est_actual_revenue, 0));
         h_p_est_bl1_roi := roi(Coalesce(h_p_est_bl1_cost, 0), Coalesce(h_p_est_bl1_revenue, 0));
         h_p_est_bl3_roi := roi(Coalesce(h_p_est_bl3_cost, 0), Coalesce(h_p_est_bl3_revenue, 0));
         h_p_plnd_bl1_roi := roi(Coalesce(h_p_plnd_bl1_cost, 0), Coalesce(h_p_plnd_bl1_revenue, 0));
         h_p_plnd_bl3_roi := roi(Coalesce(h_p_plnd_bl3_cost, 0), Coalesce(h_p_plnd_bl3_revenue, 0));
         
         --Release array objects
         --free(cf_planned);
         --free(cf_estimated);
         --free(cf_estimated_a);
         --free(cf_estimated_b1);
         --free(cf_estimated_b3);
         --free(cf_planned_b1);
         --free(cf_planned_b3);
         
         --payback dates
         If Coalesce(h_p_actual_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_actual_payback) - 1    ) INTO h_p_actual_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1814+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1815) : views_financial.sql(7870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_actual_payback_date := NULL;
            NULL;
         End If;
         
         If Coalesce(h_p_plnd_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_plnd_payback) - 1    ) INTO h_p_plnd_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1832+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1833) : views_financial.sql(7888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_plnd_payback_date := NULL;
            NULL;
         End If;
         
         If Coalesce(h_p_est_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_est_payback) - 1    ) INTO h_p_est_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1850+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1851) : views_financial.sql(7906) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_est_payback_date := NULL;
            NULL;
         End If;
         
         If Coalesce(h_p_est_actual_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_est_actual_payback) - 1    ) INTO h_p_est_actual_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1868+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1869) : views_financial.sql(7924) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_est_actual_payback_date := NULL;
            NULL;
         End If;
         
         If Coalesce(h_p_est_bl1_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_est_bl1_payback) - 1    ) INTO h_p_est_bl1_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1886+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1887) : views_financial.sql(7942) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_est_bl1_payback_date := NULL;
            NULL;
         End If;
         
         If Coalesce(h_p_est_bl3_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_est_bl3_payback) - 1    ) INTO h_p_est_bl3_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1904+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1905) : views_financial.sql(7960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_est_bl3_payback_date := NULL;
            NULL;
         End If;
         
         If Coalesce(h_p_plnd_bl1_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_plnd_bl1_payback) - 1    ) INTO h_p_plnd_bl1_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1922+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1923) : views_financial.sql(7978) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_plnd_bl1_payback_date := NULL;
            NULL;
         End If;
         
         If Coalesce(h_p_plnd_bl3_payback, 0) > 0 Then
            BEGIN
               SELECT ( Add_Months(TO_DATE(SubStr(h_p_payback_start_date, 1, 10)), h_p_plnd_bl3_payback) - 1    ) INTO h_p_plnd_bl3_payback_date FROM DUAL;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 1940+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(1941) : views_financial.sql(7996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            h_p_plnd_bl3_payback_date := NULL;
            NULL;
         End If;
      End If;
      
      --UPDATE
      BEGIN
         UPDATE PMO_PORTFOLIO SET
         ACTUAL_COST_TD          = h_p_actual_cost,
         ACTUAL_COST_YTD         = h_p_actual_cost_ytd,
         ACTUAL_REVENUE_TD       = h_p_actual_revenue,
         ACTUAL_REVENUE_YTD      = h_p_actual_revenue_ytd,
         ACTUAL_NPV          = h_p_actual_npv,
         ACTUAL_COST_NPV         = h_p_actual_cost_npv,
         ACTUAL_REVENUE_NPV      = h_p_actual_revenue_npv,
         PLANNED_START           = h_p_plnd_start,
         PLANNED_FINISH          = h_p_plnd_finish,
         PLANNED_COST            = h_p_plnd_cost,
         PLANNED_COST_TD         = h_p_plnd_cost_td,
         PLANNED_COST_YTD        = h_p_plnd_cost_ytd,
         PLANNED_REVENUE         = h_p_plnd_revenue,
         PLANNED_REVENUE_TD      = h_p_plnd_revenue_td,
         PLANNED_REVENUE_YTD     = h_p_plnd_revenue_ytd,
         PLANNED_GP          = h_p_plnd_gp,
         PLANNED_NPV         = h_p_plnd_npv,
         PLANNED_COST_NPV        = h_p_plnd_cost_npv,
         PLANNED_REVENUE_NPV     = h_p_plnd_revenue_npv,
         PLANNED_IRR         = h_p_plnd_irr,
         PLANNED_ROI         = h_p_plnd_roi,
         PLANNED_PAYBACK         = h_p_plnd_payback_date,
         PLANNED_PAYBACK_MONTHS      = h_p_plnd_payback,
         ESTIMATED_START         = h_p_est_start,
         ESTIMATED_FINISH        = h_p_est_finish,
         ESTIMATED_COST          = h_p_est_cost,
         ESTIMATED_COST_TD       = h_p_est_cost_td,
         ESTIMATED_COST_YTD      = h_p_est_cost_ytd,
         ESTIMATED_REVENUE       = h_p_est_revenue,
         ESTIMATED_REVENUE_TD        = h_p_est_revenue_td,
         ESTIMATED_REVENUE_YTD       = h_p_est_revenue_ytd,
         ESTIMATED_GP            = h_p_est_gp,
         ESTIMATED_NPV           = h_p_est_npv,
         ESTIMATED_COST_NPV      = h_p_est_cost_npv,
         ESTIMATED_REVENUE_NPV       = h_p_est_revenue_npv,
         ESTIMATED_IRR           = h_p_est_irr,
         ESTIMATED_ROI           = h_p_est_roi,
         ESTIMATED_PAYBACK       = h_p_est_payback_date,
         ESTIMATED_PAYBACK_MONTHS    = h_p_est_payback,
         ESTIMATED_A_START       = h_p_est_actual_start,
         ESTIMATED_A_FINISH      = h_p_est_actual_finish,
         ESTIMATED_A_COST        = h_p_est_actual_cost,
         ESTIMATED_A_COST_TD     = h_p_est_actual_cost_td,
         ESTIMATED_A_COST_YTD        = h_p_est_actual_cost_ytd,
         ESTIMATED_A_REVENUE     = h_p_est_actual_revenue,
         ESTIMATED_A_REVENUE_TD      = h_p_est_actual_revenue_td,
         ESTIMATED_A_REVENUE_YTD     = h_p_est_actual_revenue_ytd,
         ESTIMATED_A_GP          = h_p_est_actual_gp,
         ESTIMATED_A_NPV         = h_p_est_actual_npv,
         ESTIMATED_A_COST_NPV        = h_p_est_actual_cost_npv,
         ESTIMATED_A_REVENUE_NPV     = h_p_est_actual_revenue_npv,
         ESTIMATED_A_IRR         = h_p_est_actual_irr,
         ESTIMATED_A_ROI         = h_p_est_actual_roi,
         ESTIMATED_A_PAYBACK     = h_p_est_actual_payback_date,
         ESTIMATED_A_PAYBACK_MONTHS  = h_p_est_actual_payback,
         ESTIMATED_B1_START      = h_p_est_bl1_start,
         ESTIMATED_B1_FINISH         = h_p_est_bl1_finish,
         ESTIMATED_B1_COST       = h_p_est_bl1_cost,
         ESTIMATED_B1_COST_TD        = h_p_est_bl1_cost_td,
         ESTIMATED_B1_COST_YTD       = h_p_est_bl1_cost_ytd,
         ESTIMATED_B1_REVENUE        = h_p_est_bl1_revenue,
         ESTIMATED_B1_REVENUE_TD     = h_p_est_bl1_revenue_td,
         ESTIMATED_B1_REVENUE_YTD    = h_p_est_bl1_revenue_ytd,
         ESTIMATED_B1_GP         = h_p_est_bl1_gp,
         ESTIMATED_B1_NPV        = h_p_est_bl1_npv,
         ESTIMATED_B1_COST_NPV       = h_p_est_bl1_cost_npv,
         ESTIMATED_B1_REVENUE_NPV    = h_p_est_bl1_revenue_npv,
         ESTIMATED_B1_IRR        = h_p_est_bl1_irr,
         ESTIMATED_B1_ROI        = h_p_est_bl1_roi,
         ESTIMATED_B1_PAYBACK        = h_p_est_bl1_payback_date,
         ESTIMATED_B1_PAYBACK_MONTHS = h_p_est_bl1_payback,
         ESTIMATED_B3_START      = h_p_est_bl3_start,
         ESTIMATED_B3_FINISH         = h_p_est_bl3_finish,
         ESTIMATED_B3_COST       = h_p_est_bl3_cost,
         ESTIMATED_B3_COST_TD        = h_p_est_bl3_cost_td,
         ESTIMATED_B3_COST_YTD       = h_p_est_bl3_cost_ytd,
         ESTIMATED_B3_REVENUE        = h_p_est_bl3_revenue,
         ESTIMATED_B3_REVENUE_TD     = h_p_est_bl3_revenue_td,
         ESTIMATED_B3_REVENUE_YTD    = h_p_est_bl3_revenue_ytd,
         ESTIMATED_B3_GP         = h_p_est_bl3_gp,
         ESTIMATED_B3_NPV        = h_p_est_bl3_npv,
         ESTIMATED_B3_COST_NPV       = h_p_est_bl3_cost_npv,
         ESTIMATED_B3_REVENUE_NPV    = h_p_est_bl3_revenue_npv,
         ESTIMATED_B3_IRR        = h_p_est_bl3_irr,
         ESTIMATED_B3_ROI        = h_p_est_bl3_roi,
         ESTIMATED_B3_PAYBACK        = h_p_est_bl3_payback_date,
         ESTIMATED_B3_PAYBACK_MONTHS = h_p_est_bl3_payback,
         PLANNED_B1_START        = h_p_plnd_bl1_start,
         PLANNED_B1_FINISH       = h_p_plnd_bl1_finish,
         PLANNED_B1_COST         = h_p_plnd_bl1_cost,
         PLANNED_B1_COST_TD      = h_p_plnd_bl1_cost_td,
         PLANNED_B1_COST_YTD     = h_p_plnd_bl1_cost_ytd,
         PLANNED_B1_REVENUE      = h_p_plnd_bl1_revenue,
         PLANNED_B1_REVENUE_TD       = h_p_plnd_bl1_revenue_td,
         PLANNED_B1_REVENUE_YTD      = h_p_plnd_bl1_revenue_ytd,
         PLANNED_B1_GP           = h_p_plnd_bl1_gp,
         PLANNED_B1_NPV          = h_p_plnd_bl1_npv,
         PLANNED_B1_COST_NPV     = h_p_plnd_bl1_cost_npv,
         PLANNED_B1_REVENUE_NPV      = h_p_plnd_bl1_revenue_npv,
         PLANNED_B1_IRR          = h_p_plnd_bl1_irr,
         PLANNED_B1_ROI          = h_p_plnd_bl1_roi,
         PLANNED_B1_PAYBACK      = h_p_plnd_bl1_payback_date,
         PLANNED_B1_PAYBACK_MONTHS   = h_p_plnd_bl1_payback,
         PLANNED_B3_START        = h_p_plnd_bl3_start,
         PLANNED_B3_FINISH       = h_p_plnd_bl3_finish,
         PLANNED_B3_COST         = h_p_plnd_bl3_cost,
         PLANNED_B3_COST_TD      = h_p_plnd_bl3_cost_td,
         PLANNED_B3_COST_YTD     = h_p_plnd_bl3_cost_ytd,
         PLANNED_B3_REVENUE      = h_p_plnd_bl3_revenue,
         PLANNED_B3_REVENUE_TD       = h_p_plnd_bl3_revenue_td,
         PLANNED_B3_REVENUE_YTD      = h_p_plnd_bl3_revenue_ytd,
         PLANNED_B3_GP           = h_p_plnd_bl3_gp,
         PLANNED_B3_NPV          = h_p_plnd_bl3_npv,
         PLANNED_B3_COST_NPV     = h_p_plnd_bl3_cost_npv,
         PLANNED_B3_REVENUE_NPV      = h_p_plnd_bl3_revenue_npv,
         PLANNED_B3_IRR          = h_p_plnd_bl3_irr,
         PLANNED_B3_ROI          = h_p_plnd_bl3_roi,
         PLANNED_B3_PAYBACK      = h_p_plnd_bl3_payback_date,
         PLANNED_B3_PAYBACK_MONTHS   = h_p_plnd_bl3_payback,
         TOTAL_IRR           = h_p_total_irr,
         TOTAL_B1_IRR            = h_p_total_bl1_irr,
         TOTAL_B3_IRR            = h_p_total_bl3_irr
         WHERE PROJECT_ID = h_p_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 2086+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(2087) : views_financial.sql(8142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CFIN30 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 2100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(2101) : views_financial.sql(8156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   
   h_temp_sc_state := FC_INIT_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_ATTRIBUTES();
   
   h_xsql := 'SELECT '
          || ''''' AS ELEMENT_ID, '
          || ''''' AS ELEMENT_NAME, '
          || '1 AS TYPE_ID, '
          || 'P.PROJECT_NAME AS DEFAULT0_PROJECT__T, '
          || 'P.PROJECT_ID AS PROJECT_ID, '
          || 'P.PROJECT_MANAGER, '
          || 'W.REF_CODE AS DEFAULT0_REF_NUMBER__T, '
          || 'W.CURRENCY_ID AS PROJECT_CURRENCY_37_DF, '
          || 'W.PROBABILITY AS PURSUIT_PROBABILITY, '
          || 'W.START_FINISH_DATE AS PROJECT_START_DT, '
          || 'COALESCE(W.FINISH_START_DATE, TO_DATE(''1899-01-01'')) AS PROJECT_FINISH_DT, '
          || 'P.PROJECT_BUDGET_SETTING_BITS AS PROJECT_BUDGET_SETTING_BITS_T, '
          || 'P.PROJECT_QUICK_START, '
          || 'P.PROJECT_QUICK_FINISH, '
          || 'P.PROJECT_SCHED_START, '
          || 'P.PROJECT_SCHED_FINISH, '
          || 'P.PROJECT_ACTUAL_START, '
          || 'P.PROJECT_ACTUAL_FINISH, '
          || 'P.PROJECT_EST_HOURS, '
          || 'P.PROJECT_EST_ACTUAL_HOURS, '
          || 'P.PROJECT_EST_HOURS_ETC, '
          || 'P.SCOPE_SCORE  , '
          || 'P.SCOPE_WEIGHT  , '
          || 'P.SCHEDULE_SCORE  , '
          || 'P.SCHEDULE_WEIGHT  , '
          || 'P.QUALITY_SCORE  , '
          || 'P.QUALITY_WEIGHT  , '
          || 'P.BENEFIT_SCORE  , '
          || 'P.BENEFIT_WEIGHT  , '
          || 'P.COST_SCORE  , '
          || 'P.COST_WEIGHT  , '
          || 'W.PROBABILITY*100 AS PROJECT_PROBABILITY, '
          || 'W.OPPORTUNITY_NAME AS PROJECT_CLIENT, '
          || 'W.EXPECTED_PAYBACK_PERIOD, '
          || 'W.EXPECTED_PAYBACK_MONTH, '
          || 'AT.PROJECT_ATTRIBUTES AS ATTRIBUTES_ATTRIBUTES_AT, '
          || 'P.PROJECT_PRIORITY AS STATUS_PRIORITY__T, '
          || 'W.STAGE_ID AS STATUS_STAGE_12_DF,'
          || '(CASE WHEN W.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(W.CONVERTED_SCORE,18,2)/W.CONVERTED_WEIGHT)*10000) ELSE 0 END) AS STATUS_SCORECARD_RATING__T, '
          || 'W.BUBBLE_COLOR AS STATUS_SCORECARD_COLOR__T, '
          || 'W.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE__P, '
          || '(CASE WHEN W.BASELINE1_EFFORT > 0 THEN ((W.WORK_TODATE*10000)/W.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT__P, '
          || 'P.PROJECT_AVG_RATE AS NPV_AVG_DISCOUNT_RATE__P, '
          || 'P.PLANNED_B3_NPV AS NPV_SCHED_BASELINE_I__M, '
          || 'P.PLANNED_B3_COST_NPV AS NPV_SCHED_C_BASELINE_I__M, '
          || 'P.PLANNED_B3_REVENUE_NPV AS NPV_SCHED_R_BASELINE_I__M, '
          || 'P.PLANNED_B1_NPV AS NPV_SCHED_BASELINE_L__M, '
          || 'P.PLANNED_B1_COST_NPV AS NPV_SCHED_C_BASELINE_L__M, '
          || 'P.PLANNED_B1_REVENUE_NPV AS NPV_SCHED_R_BASELINE_L__M, '
          || 'P.PLANNED_NPV AS NPV_SCHED_SCHEDULE__M, '
          || 'P.PLANNED_COST_NPV AS NPV_SCHED_C_SCHEDULE__M, '
          || 'P.PLANNED_REVENUE_NPV AS NPV_SCHED_R_SCHEDULE__M, '
          || 'P.ACTUAL_NPV AS NPV_SCHED_ACTUAL__M, '
          || 'P.ACTUAL_COST_NPV AS NPV_SCHED_C_ACTUAL__M, '
          || 'P.ACTUAL_REVENUE_NPV AS NPV_SCHED_R_ACTUAL__M, '
          || 'P.ESTIMATED_B3_NPV AS NPV_EST_BASELINE_I__M, '
          || 'P.ESTIMATED_B3_COST_NPV AS NPV_EST_C_BASELINE_I__M, '
          || 'P.ESTIMATED_B3_REVENUE_NPV AS NPV_EST_R_BASELINE_I__M, '
          || 'P.ESTIMATED_B1_NPV AS NPV_EST_BASELINE_L__M, '
          || 'P.ESTIMATED_B1_COST_NPV AS NPV_EST_C_BASELINE_L__M, '
          || 'P.ESTIMATED_B1_REVENUE_NPV AS NPV_EST_R_BASELINE_L__M, '
          || 'P.ESTIMATED_NPV AS NPV_EST_ESTIMATED__M, '
          || 'P.ESTIMATED_COST_NPV AS NPV_EST_C_ESTIMATED__M, '
          || 'P.ESTIMATED_REVENUE_NPV AS NPV_EST_R_ESTIMATED__M, '
          || 'P.ESTIMATED_A_NPV AS NPV_EST_ACTUAL__M, '
          || 'P.ESTIMATED_A_COST_NPV AS NPV_EST_C_ACTUAL__M, '
          || 'P.ESTIMATED_A_REVENUE_NPV AS NPV_EST_R_ACTUAL__M, '
          || 'P.PLANNED_B3_IRR * 10000 AS IRR_SCHED_BASELINE_I__P, '
          || 'P.PLANNED_B1_IRR * 10000 AS IRR_SCHED_BASELINE_L__P, '
          || 'P.PLANNED_IRR * 10000 AS IRR_SCHED_SCHEDULE__P,    '
          || 'P.ESTIMATED_B3_IRR * 10000 AS IRR_EST_BASELINE_I__P, '
          || 'P.ESTIMATED_B1_IRR * 10000 AS IRR_EST_BASELINE_L__P, '
          || 'P.ESTIMATED_IRR * 10000 AS IRR_EST_ESTIMATED__P, '
          || 'P.TOTAL_B3_IRR * 10000 AS IRR_TOTAL_BASELINE_I__P, '
          || 'P.TOTAL_B1_IRR * 10000 AS IRR_TOTAL_BASELINE_L__P, '
          || 'P.TOTAL_IRR * 10000 AS IRR_TOTAL_ESTIMATED__P, '
          || 'W.EXPECTED_COST AS COST_BALLPARK__M, '
          || 'P.PLANNED_B3_COST AS COST_SCHED_BASELINE_I__M, '
          || 'P.PLANNED_B1_COST AS COST_SCHED_BASELINE_L__M, '
          || 'P.PLANNED_COST AS COST_SCHED_SCHEDULE__M, '
          || 'P.ACTUAL_COST_TD AS COST_SCHED_ACTUAL__M, '
          || 'P.PLANNED_ETC_COST AS COST_SCHED_ETC__M, '
          || 'P.ESTIMATED_B3_COST AS COST_EST_BASELINE_I__M, '
          || 'P.ESTIMATED_B1_COST AS COST_EST_BASELINE_L__M, '
          || 'P.ESTIMATED_COST AS COST_EST_ESTIMATED__M, '
          || 'P.ESTIMATED_A_COST AS COST_EST_ACTUAL__M, '
          || 'P.ESTIMATED_ETC_COST AS COST_EST_ETC__M, '
          || 'W.EXPECTED_REVENUE AS REVENUE_BALLPARK__M, '
          || 'P.PLANNED_B3_REVENUE AS REVENUE_SCHED_BASELINE_I__M, '
          || 'P.PLANNED_B1_REVENUE AS REVENUE_SCHED_BASELINE_L__M, '
          || 'P.PLANNED_REVENUE AS REVENUE_SCHED_SCHEDULE__M, '
          || 'P.ACTUAL_REVENUE_TD AS REVENUE_SCHED_ACTUAL__M, '
          || 'P.PLANNED_ETC_REVENUE AS REVENUE_SCHED_ETC__M, '
          || 'P.ESTIMATED_B3_REVENUE AS REVENUE_EST_BASELINE_I__M, '
          || 'P.ESTIMATED_B1_REVENUE AS REVENUE_EST_BASELINE_L__M, '
          || 'P.ESTIMATED_REVENUE AS REVENUE_EST_ESTIMATED__M, '
          || 'P.ESTIMATED_A_REVENUE AS REVENUE_EST_ACTUAL__M, '
          || 'P.ESTIMATED_ETC_REVENUE AS REVENUE_EST_ETC__M, '
          || 'P.PLANNED_B3_COST_YTD AS COSTYTD_SCHED_BASELINE_I__M, '
          || 'P.PLANNED_B1_COST_YTD AS COSTYTD_SCHED_BASELINE_L__M, '
          || 'P.PLANNED_COST_YTD AS COSTYTD_SCHED_SCHEDULE__M, '
          || 'P.ACTUAL_COST_YTD AS COSTYTD_SCHED_ACTUAL__M, '
          || 'P.ESTIMATED_B3_COST_YTD AS COSTYTD_EST_BASELINE_I__M, '
          || 'P.ESTIMATED_B1_COST_YTD AS COSTYTD_EST_BASELINE_L__M, '
          || 'P.ESTIMATED_COST_YTD AS COSTYTD_EST_ESTIMATED__M, '
          || 'P.ESTIMATED_A_COST_YTD AS COSTYTD_EST_ACTUAL__M, '
          || 'P.PLANNED_B3_REVENUE_YTD AS REVENUEYTD_SCHED_BASELINE_I__M, '
          || 'P.PLANNED_B1_REVENUE_YTD AS REVENUEYTD_SCHED_BASELINE_L__M, '
          || 'P.PLANNED_REVENUE_YTD AS REVENUEYTD_SCHED_SCHEDULE__M, '
          || 'P.ACTUAL_REVENUE_YTD AS REVENUEYTD_SCHED_ACTUAL__M, '
          || 'P.ESTIMATED_B3_REVENUE_YTD AS REVENUEYTD_EST_BASELINE_I__M, '
          || 'P.ESTIMATED_B1_REVENUE_YTD AS REVENUEYTD_EST_BASELINE_L__M, '
          || 'P.ESTIMATED_REVENUE_YTD AS REVENUEYTD_EST_ESTIMATED__M, '
          || 'P.ESTIMATED_A_REVENUE_YTD AS REVENUEYTD_EST_ACTUAL__M, '
          || 'P.PLANNED_B3_COST_TD AS COSTTD_SCHED_BASELINE_I__M, '
          || 'P.PLANNED_B1_COST_TD AS COSTTD_SCHED_BASELINE_L__M, '
          || 'P.PLANNED_COST_TD AS COSTTD_SCHED_SCHEDULE__M, '
          || 'P.ACTUAL_COST_TD AS COSTTD_SCHED_ACTUAL__M, '
          || 'P.ESTIMATED_B3_COST_TD AS COSTTD_EST_BASELINE_I__M, '
          || 'P.ESTIMATED_B1_COST_TD AS COSTTD_EST_BASELINE_L__M, '
          || 'P.ESTIMATED_COST_TD AS COSTTD_EST_ESTIMATED__M, '
          || 'P.ESTIMATED_A_COST_TD AS COSTTD_EST_ACTUAL__M, '
          || 'P.PLANNED_B3_REVENUE_TD AS REVENUETD_SCHED_BASELINE_I__M, '
          || 'P.PLANNED_B1_REVENUE_TD AS REVENUETD_SCHED_BASELINE_L__M, '
          || 'P.PLANNED_REVENUE_TD AS REVENUETD_SCHED_SCHEDULE__M, '
          || 'P.ACTUAL_REVENUE_TD AS REVENUETD_SCHED_ACTUAL__M, '
          || 'P.ESTIMATED_B3_REVENUE_TD AS REVENUETD_EST_BASELINE_I__M, '
          || 'P.ESTIMATED_B1_REVENUE_TD AS REVENUETD_EST_BASELINE_L__M, '
          || 'P.ESTIMATED_REVENUE_TD AS REVENUETD_EST_ESTIMATED__M, '
          || 'P.ESTIMATED_A_REVENUE_TD AS REVENUETD_EST_ACTUAL__M, '
          || 'P.PLANNED_B3_PAYBACK AS PAYBACKDATE_SCHED_BL_I_DA, '
          || 'P.PLANNED_B1_PAYBACK AS PAYBACKDATE_SCHED_BL_L_DA, '
          || 'P.PLANNED_PAYBACK AS PAYBACKDATE_SCHED_SCHED_DA, '
          || 'P.ESTIMATED_B3_PAYBACK AS PAYBACKDATE_EST_BL_I_DA, '
          || 'P.ESTIMATED_B1_PAYBACK AS PAYBACKDATE_EST_BL_L_DA, '
          || 'P.ESTIMATED_PAYBACK AS PAYBACKDATE_EST_ESTIMATED_DA, '
          || 'P.PLANNED_B3_PAYBACK_MONTHS AS PAYBACKPERIOD_SCHED_BL_I__T, '
          || 'P.PLANNED_B1_PAYBACK_MONTHS AS PAYBACKPERIOD_SCHED_BL_L__T, '
          || 'P.PLANNED_PAYBACK_MONTHS AS PAYBACKPERIOD_SCHED_SCHED__T, '
          || 'P.ESTIMATED_B3_PAYBACK_MONTHS AS PAYBACKPERIOD_EST_BL_I__T, '
          || 'P.ESTIMATED_B1_PAYBACK_MONTHS AS PAYBACKPERIOD_EST_BL_L__T, '
          || 'P.ESTIMATED_PAYBACK_MONTHS AS PAYBACKPERIOD_EST_ESTIMATED__T, '
          || 'CASE WHEN PMO_ORASTD.MONTH(TO_DATE(SubStr(P.ESTIMATED_PAYBACK, 1, 10)) - TO_DATE(SubStr(P.ESTIMATED_START, 1, 10))) > 0 THEN (PMO_ORASTD.MONTH(TO_DATE(SubStr(P.ESTIMATED_PAYBACK, 1, 10)) - TO_DATE(SubStr(P.ESTIMATED_START, 1, 10)))) - PMO_ORASTD.MONTH(TO_DATE(SubStr(P.ESTIMATED_PAYBACK, 1, 10)) - TO_DATE(SubStr(P.ESTIMATED_START, 1, 10))) + 1 ELSE 0 END AS PAYBACKPERIODVAR_ESTIMATED__T, '
          || 'CASE WHEN PMO_ORASTD.MONTH(TO_DATE(SubStr(P.PLANNED_PAYBACK, 1, 10)) - TO_DATE(SubStr(P.PLANNED_START, 1, 10))) > 0 THEN (PMO_ORASTD.MONTH(TO_DATE(SubStr(P.PLANNED_PAYBACK, 1, 10)) - TO_DATE(SubStr(P.PLANNED_START, 1, 10)))) - PMO_ORASTD.MONTH(TO_DATE(SubStr(P.PLANNED_PAYBACK, 1, 10)) - TO_DATE(SubStr(P.PLANNED_START, 1, 10))) + 1 ELSE 0 END AS PAYBACKPERIODVAR_SCHEDULE__T, '
          || '(PMO_ORASTD.DAYS(W.BASELINE1_FINISH) - PMO_ORASTD.DAYS(W.BASELINE1_START))/7.0 AS LENGTH_SCHED_BASELINE_L__T, '
          || '(PMO_ORASTD.DAYS(W.BASELINE3_FINISH) - PMO_ORASTD.DAYS(W.BASELINE1_START))/7.0 AS LENGTH_SCHED_BASELINE_I__T, '
          || '(PMO_ORASTD.DAYS(W.SCHED_FINISH) - PMO_ORASTD.DAYS(W.SCHED_START))/7.0 AS LENGTH_SCHED_SCHEDULE__T, '
          || '(PMO_ORASTD.DAYS(W.ESTIMATED_BASELINE1_FINISH) - PMO_ORASTD.DAYS(W.ESTIMATED_BASELINE1_START))/7.0 AS LENGTH_EST_BASELINE_L__T, '
          || '(PMO_ORASTD.DAYS(W.ESTIMATED_BASELINE3_FINISH) - PMO_ORASTD.DAYS(W.ESTIMATED_BASELINE3_START))/7.0 AS LENGTH_EST_BASELINE_I__T, '
          || '(PMO_ORASTD.DAYS(W.FINISH_START_DATE) - PMO_ORASTD.DAYS(W.START_FINISH_DATE))/7.0 AS LENGTH_EST_ESTIMATED__T, '
          || 'W.ACTUAL_DURATION/PMO_ORASTD.TODECIMAL(W.MINUTE_PER_WEEK,18,2) AS LENGTH_EST_ACTUAL__T, '
          || 'COALESCE(RTF01.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01, '
          || 'COALESCE(RTF02.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02, '
          || 'COALESCE(RTF03.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03, '
          || 'COALESCE(RTF04.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04, '
          || 'COALESCE(RTF05.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05, '
          || 'COALESCE(RTF06.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06, '
          || 'COALESCE(RTF07.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07, '
          || 'COALESCE(RTF08.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08, '
          || 'COALESCE(RTF09.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09, '
          || 'COALESCE(RTF10.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10, '
          || 'COALESCE(RTF11.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF11, '
          || 'COALESCE(RTF12.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF12, '
          || 'COALESCE(RTF13.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF13, '
          || 'COALESCE(RTF14.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF14, '
          || 'COALESCE(RTF15.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF15, '
          || 'COALESCE(RTF16.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF16, '
          || 'COALESCE(RTF17.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF17, '
          || 'COALESCE(RTF18.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF18, '
          || 'COALESCE(RTF19.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF19, '
          || 'COALESCE(RTF20.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF20 '
          || 'FROM PMO_PORTFOLIO P '
          || 'JOIN TMT_WBS W ON W.ELEMENT_ID = P.PROJECT_ID '
          || 'LEFT JOIN PMO_FINANCIAL_PAT AT ON AT.PROJECT_ID = P.PROJECT_ID '
          || 'LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = W.ELEMENT_ID AND RTF01.ELEMENT_ID = W.ELEMENT_ID AND RTF01.BIT_FLAG = 1 '
          || 'LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = W.ELEMENT_ID AND RTF02.ELEMENT_ID = W.ELEMENT_ID AND RTF02.BIT_FLAG = 2 '
          || 'LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = W.ELEMENT_ID AND RTF03.ELEMENT_ID = W.ELEMENT_ID AND RTF03.BIT_FLAG = 4 '
          || 'LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = W.ELEMENT_ID AND RTF04.ELEMENT_ID = W.ELEMENT_ID AND RTF04.BIT_FLAG = 8 '
          || 'LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = W.ELEMENT_ID AND RTF05.ELEMENT_ID = W.ELEMENT_ID AND RTF05.BIT_FLAG = 16 '
          || 'LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = W.ELEMENT_ID AND RTF06.ELEMENT_ID = W.ELEMENT_ID AND RTF06.BIT_FLAG = 32 '
          || 'LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = W.ELEMENT_ID AND RTF07.ELEMENT_ID = W.ELEMENT_ID AND RTF07.BIT_FLAG = 64 '
          || 'LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = W.ELEMENT_ID AND RTF08.ELEMENT_ID = W.ELEMENT_ID AND RTF08.BIT_FLAG = 128 '
          || 'LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = W.ELEMENT_ID AND RTF09.ELEMENT_ID = W.ELEMENT_ID AND RTF09.BIT_FLAG = 256 '
          || 'LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = W.ELEMENT_ID AND RTF10.ELEMENT_ID = W.ELEMENT_ID AND RTF10.BIT_FLAG = 512 '
          || 'LEFT JOIN WBS_RTF RTF11 ON RTF11.PARENT_ID = W.ELEMENT_ID AND RTF11.ELEMENT_ID = W.ELEMENT_ID AND RTF11.BIT_FLAG = 1024 '
          || 'LEFT JOIN WBS_RTF RTF12 ON RTF12.PARENT_ID = W.ELEMENT_ID AND RTF12.ELEMENT_ID = W.ELEMENT_ID AND RTF12.BIT_FLAG = 2048 '
          || 'LEFT JOIN WBS_RTF RTF13 ON RTF13.PARENT_ID = W.ELEMENT_ID AND RTF13.ELEMENT_ID = W.ELEMENT_ID AND RTF13.BIT_FLAG = 4096 '
          || 'LEFT JOIN WBS_RTF RTF14 ON RTF14.PARENT_ID = W.ELEMENT_ID AND RTF14.ELEMENT_ID = W.ELEMENT_ID AND RTF14.BIT_FLAG = 8192 '
          || 'LEFT JOIN WBS_RTF RTF15 ON RTF15.PARENT_ID = W.ELEMENT_ID AND RTF15.ELEMENT_ID = W.ELEMENT_ID AND RTF15.BIT_FLAG = 16384 '
          || 'LEFT JOIN WBS_RTF RTF16 ON RTF16.PARENT_ID = W.ELEMENT_ID AND RTF16.ELEMENT_ID = W.ELEMENT_ID AND RTF16.BIT_FLAG = 32768 '
          || 'LEFT JOIN WBS_RTF RTF17 ON RTF17.PARENT_ID = W.ELEMENT_ID AND RTF17.ELEMENT_ID = W.ELEMENT_ID AND RTF17.BIT_FLAG = 65536 '
          || 'LEFT JOIN WBS_RTF RTF18 ON RTF18.PARENT_ID = W.ELEMENT_ID AND RTF18.ELEMENT_ID = W.ELEMENT_ID AND RTF18.BIT_FLAG = 131072 '
          || 'LEFT JOIN WBS_RTF RTF19 ON RTF19.PARENT_ID = W.ELEMENT_ID AND RTF19.ELEMENT_ID = W.ELEMENT_ID AND RTF19.BIT_FLAG = 262144 '
          || 'LEFT JOIN WBS_RTF RTF20 ON RTF20.PARENT_ID = W.ELEMENT_ID AND RTF20.ELEMENT_ID = W.ELEMENT_ID AND RTF20.BIT_FLAG = 524288 ';
   --Return a resultset
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PORTFOLIO_ROI', 2309+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PORTFOLIO_ROI(2310) : views_financial.sql(8365) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PORTFOLIO_ROI', 2312+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PORTFOLIO_ROI(2313) : views_financial.sql(8368) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 2319+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(2320) : views_financial.sql(8375) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PORTFOLIO_ROI', 2331+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PORTFOLIO_ROI(2332) : views_financial.sql(8387) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PORTFOLIO_ROI;
ALTER FUNCTION SP_PORTFOLIO_ROI COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_BB_YEAR_VIEW ==
CREATE OR REPLACE FUNCTION SP_BB_YEAR_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER;
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_type PLS_INTEGER := 0;
   h_temp_type PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BB_YEAR_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BB_YEAR_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_BB_YEAR_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_YEAR_VIEW', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BB_YEAR_VIEW(31) : views_financial.sql(8438) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BB_YEAR_VIEW', 35+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BB_YEAR_VIEW(36) : views_financial.sql(8443) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_CHARGECODES();
   
   h_temp_type := PMO_CNST.SC_YEARLY;
   
   h_temp_sc_state := FC_PARSE_PROJECTS(h_temp_type);
   h_temp_sc_state := FC_INIT_SCORECARDS();
   h_temp_sc_state := FC_PIVOT_SCORECARDS();
   h_temp_sc_state := FC_INIT_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_ATTRIBUTES();
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   h_xsql := '';
   h_xsql := 'SELECT '
          || ''''' AS ELEMENT_ID, '
          || ''''' AS ELEMENT_NAME, '
          || '0 AS TYPE_ID, '
          || 'P.PROJECT_NAME AS DEFAULT0_PROJECT__T, '
          || 'P.REFERNCE_CODE AS DEFAULT0_REF_NUMBER__T,'
          || 'P.PROJECT_MANAGER AS PROJECT_MANAGER__T,'
          || 'P.PROJECT_CURRENCY_ID AS PROJECT_CURRENCY_37_DF, '
          || 'P.PROJECT_START AS PROJECT_START_DA, '
          || 'P.PROJECT_FINISH AS PROJECT_FINISH_DA, '
          || 'P.PERIOD AS PROJECT_PERIOD__T, '
          || 'AT.PROJECT_ATTRIBUTES AS ATTRIBUTES_ATTRIBUTES_AT, '
          || 'P.PROJECT_YEAR AS YEAR_YEAR__T, '
          || 'P.PROJECT_PRIORITY AS STATUS_PRIORITY__T,'
          || 'P.STAGE_ID AS STATUS_STAGE_12_DF,'
          || '(CASE WHEN SC.SCORECARD_WEIGHT > 0 THEN PMO_ORASTD.TODECIMAL(((SC.SCORECARD_SCORE/SC.SCORECARD_WEIGHT)*100), 5, 2) ELSE 0 END) AS STATUS_SCORECARD_RATING__T, '
          || 'P.PROJECT_HEALTH AS STATUS_SCORECARD_COLOR__T, '
          || 'P.CHARGECODE_NAME AS CHARGECODE_NAME__T, '
          || 'CASE WHEN P.CHARGECODE_TYPE = 0 THEN ''Expense'' WHEN P.CHARGECODE_TYPE = 1 THEN ''Capital'' WHEN P.BILLABLE = 1 THEN ''Revenue'' ELSE ''Non-Billable Benefit'' END AS CHARGECODE_TYPE__T, '
          || 'CASE WHEN P.LABOR_FLAG = 0 THEN ''Non-labor'' ELSE ''Labor'' END AS CHARGECODE_LABOR__T, '
          || 'CASE WHEN P.ACTUAL_COST > 0 THEN P.ACTUAL_COST WHEN P.PLANNED_COST > 0 THEN P.PLANNED_COST ELSE P.EXPECTED_COST END AS COST_PRIORITY__M, '
          || 'P.EXPECTED_COST AS COST_ESTIMATED__M, '
          || 'P.PLANNED_COST AS COST_PLANNED__M, '
          || 'P.BASELINE1_COST AS COST_BASELINE_L__M, '
          || 'P.BASELINE3_COST AS COST_BASELINE_I__M, '
          || 'P.ACTUAL_COST AS COST_ACTUAL__M, '
          || '(P.PLANNED_COST - P.ACTUAL_COST) AS COST_REMAINING__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE > 0 THEN P.ACTUAL_REVENUE WHEN P.PLANNED_REVENUE > 0 THEN P.PLANNED_REVENUE ELSE P.EXPECTED_REVENUE END AS REVENUE_PRIORITY__M, '
          || 'P.EXPECTED_REVENUE AS REVENUE_ESTIMATED__M,'
          || 'P.PLANNED_REVENUE AS REVENUE_PLANNED__M, '
          || 'P.BASELINE1_REVENUE AS REVENUE_BASELINE_L__M, '
          || 'P.BASELINE3_REVENUE AS REVENUE_BASELINE_I__M, '
          || 'P.ACTUAL_REVENUE AS REVENUE_ACTUAL__M, '
          || '(P.PLANNED_REVENUE - P.ACTUAL_REVENUE) AS REVENUE_REMAINING__M, '
          || 'CASE WHEN P.ACTUAL_GP > 0 THEN P.ACTUAL_GP WHEN P.PLANNED_GP > 0 THEN P.PLANNED_GP ELSE P.EXPECTED_GP END AS GP_PRIORITY__M, '
          || 'P.EXPECTED_GP AS GP_ESTIMATED__M, '
          || 'P.PLANNED_GP AS GP_PLANNED__M, '
          || 'P.BASELINE1_GP AS GP_BASELINE_L__M, '
          || 'P.BASELINE3_GP AS GP_BASELINE_I__M, '
          || 'P.ACTUAL_GP AS GP_ACTUAL__M, '
          || '(P.PLANNED_GP - P.ACTUAL_GP) AS GP_REMAINING__M, '
          || 'CASE WHEN P.ACTUAL_COST_YTD > 0 THEN P.ACTUAL_COST_YTD WHEN P.PLANNED_COST_YTD > 0 THEN P.PLANNED_COST_YTD ELSE P.EXPECTED_COST_YTD END AS COSTYTD_PRIORITY__M, '
          || 'P.EXPECTED_COST_YTD AS COSTYTD_ESTIMATED__M, '
          || 'P.PLANNED_COST_YTD AS COSTYTD_PLANNED__M, '
          || 'P.BASELINE1_COST_YTD AS COSTYTD_BASELINE_L__M, '
          || 'P.BASELINE3_COST_YTD AS COSTYTD_BASELINE_I__M, '
          || 'P.ACTUAL_COST_YTD AS COSTYTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_YTD > 0 THEN P.ACTUAL_REVENUE_YTD WHEN P.PLANNED_REVENUE_YTD > 0 THEN P.PLANNED_REVENUE_YTD ELSE P.EXPECTED_REVENUE_YTD END AS REVENUEYTD_PRIORITY__M, '
          || 'P.EXPECTED_REVENUE_YTD AS REVENUEYTD_ESTIMATED__M, '
          || 'P.PLANNED_REVENUE_YTD AS REVENUEYTD_PLANNED__M, '
          || 'P.BASELINE1_REVENUE_YTD AS REVENUEYTD_BASELINE_L__M, '
          || 'P.BASELINE3_REVENUE_YTD AS REVENUEYTD_BASELINE_I__M, '
          || 'P.ACTUAL_REVENUE_YTD AS REVENUEYTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_YTD > 0 THEN (P.ACTUAL_REVENUE_YTD - P.ACTUAL_COST_YTD) WHEN P.PLANNED_REVENUE_YTD > 0 THEN (P.PLANNED_REVENUE_YTD - P.PLANNED_COST_YTD) ELSE (P.EXPECTED_REVENUE_YTD - P.EXPECTED_REVENUE_YTD) END AS GPYTD_PRIORITY__M, '
          || '(P.EXPECTED_REVENUE_YTD - P.EXPECTED_COST_YTD) AS GPYTD_ESTIMATED__M, '
          || '(P.PLANNED_REVENUE_YTD - P.PLANNED_COST_YTD) AS GPYTD_PLANNED__M, '
          || '(P.BASELINE1_REVENUE_YTD - P.BASELINE1_COST_YTD) AS GPYTD_BASELINE_L__M, '
          || '(P.BASELINE3_REVENUE_YTD - P.BASELINE3_COST_YTD) AS GPYTD_BASELINE_I__M, '
          || '(P.ACTUAL_REVENUE_YTD - P.ACTUAL_REVENUE_YTD) AS GPYTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_COST_TODATE > 0 THEN P.ACTUAL_COST_TODATE WHEN P.PLANNED_COST_TODATE > 0 THEN P.PLANNED_COST_TODATE ELSE P.EXPECTED_COST_TODATE END AS COSTTD_PRIORITY__M, '
          || 'P.EXPECTED_COST_TODATE AS COSTTD_ESTIMATED__M, '
          || 'P.PLANNED_COST_TODATE AS COSTTD_PLANNED__M, '
          || 'P.BASELINE1_COST_TODATE AS COSTTD_BASELINE_L__M, '
          || 'P.BASELINE3_COST_TODATE AS COSTTD_BASELINE_I__M, '
          || 'P.ACTUAL_COST_TODATE AS COSTTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_TODATE > 0 THEN P.ACTUAL_REVENUE_TODATE WHEN P.PLANNED_REVENUE_TODATE > 0 THEN P.PLANNED_REVENUE_TODATE ELSE P.EXPECTED_REVENUE_TODATE END AS REVENUETD_PRIORITY__M, '
          || 'P.EXPECTED_REVENUE_TODATE AS REVENUETD_ESTIMATED__M, '
          || 'P.PLANNED_REVENUE_TODATE AS REVENUETD_PLANNED__M, '
          || 'P.BASELINE1_REVENUE_TODATE AS REVENUETD_BASELINE_L__M, '
          || 'P.BASELINE3_REVENUE_TODATE AS REVENUETD_BASELINE_I__M, '
          || 'P.ACTUAL_REVENUE_TODATE AS REVENUETD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_TODATE > 0 THEN (P.ACTUAL_REVENUE_TODATE - P.ACTUAL_COST_TODATE) WHEN P.PLANNED_REVENUE_TODATE > 0 THEN (P.PLANNED_REVENUE_TODATE - P.PLANNED_COST_TODATE) ELSE (P.EXPECTED_REVENUE_TODATE - P.EXPECTED_REVENUE_TODATE) END AS GPTD_PRIORITY__M, '
          || '(P.EXPECTED_REVENUE_TODATE - P.EXPECTED_COST_TODATE) AS GPTD_ESTIMATED__M, '
          || '(P.PLANNED_REVENUE_TODATE - P.PLANNED_COST_TODATE) AS GPTD_PLANNED__M, '
          || '(P.BASELINE1_REVENUE_TODATE - P.BASELINE1_COST_TODATE) AS GPTD_BASELINE_L__M, '
          || '(P.BASELINE3_REVENUE_TODATE - P.BASELINE3_COST_TODATE) AS GPTD_BASELINE_I__M, '
          || '(P.ACTUAL_REVENUE_TODATE - P.ACTUAL_REVENUE_TODATE) AS GPTD_ACTUAL__M, '
          || '(CASE WHEN P.BASELINE1_COST > 0.00 THEN P.EXPECTED_COST - P.BASELINE1_COST ELSE 0.00 END) AS COSTVAR_EST_COST__M, '
          || '(CASE WHEN P.BASELINE1_COST > 0.00 THEN ((P.EXPECTED_COST - P.BASELINE1_COST)/P.BASELINE1_COST)*10000 ELSE 0 END) AS COSTVAR_EST_COST_P__P, '
          || '(CASE WHEN P.EXPECTED_COST > 0.00 THEN P.PLANNED_COST - P.EXPECTED_COST ELSE 0.00 END) AS COSTVAR_PLAN_COST__M, '
          || '(CASE WHEN P.EXPECTED_COST > 0.00 THEN ((P.PLANNED_COST - P.EXPECTED_COST)/P.EXPECTED_COST)*10000 ELSE 0 END) AS COSTVAR_PLAN_COST_P__P, '
          || '(CASE WHEN P.BASELINE1_REVENUE > 0.00 THEN P.EXPECTED_REVENUE - P.BASELINE1_REVENUE ELSE 0.00 END) AS REVVAR_EST_REV__M, '
          || '(CASE WHEN P.BASELINE1_REVENUE > 0.00 THEN ((P.EXPECTED_REVENUE - P.BASELINE1_REVENUE)/P.BASELINE1_REVENUE)*10000 ELSE 0 END) AS REVVAR_EST_REV_P__P, '
          || '(CASE WHEN P.EXPECTED_REVENUE > 0.00 THEN P.PLANNED_REVENUE - P.EXPECTED_REVENUE ELSE 0.00 END) AS REVVAR_PLAN_REV__M, '
          || '(CASE WHEN P.EXPECTED_REVENUE > 0.00 THEN ((P.PLANNED_REVENUE - P.EXPECTED_REVENUE)/P.EXPECTED_REVENUE)*10000 ELSE 0 END) AS REVVAR_PLAN_REV_P__P, '
          || '(P.EXPECTED_GP - P.BASELINE_GP) AS GPVAR_EST_GP__M, '
          || '(P.PLANNED_GP - P.EXPECTED_GP) AS GPVAR_PLAN_GP__M,  '
          || '(CASE WHEN P.BASELINE1_COST_YTD > 0.00 THEN P.EXPECTED_COST_YTD - P.BASELINE1_COST_YTD ELSE 0.00 END) AS COSTYTDVAR_EST_COST__M, '
          || '(CASE WHEN P.BASELINE1_COST_YTD > 0.00 THEN ((P.EXPECTED_COST_YTD - P.BASELINE1_COST_YTD)/P.BASELINE1_COST_YTD)*10000 ELSE 0 END) AS COSTYTDVAR_EST_COST_P__P, '
          || '(CASE WHEN P.EXPECTED_COST_YTD > 0.00 THEN P.PLANNED_COST_YTD - P.EXPECTED_COST_YTD ELSE 0.00 END) AS COSTYTDVAR_PLAN_COST__M, '
          || '(CASE WHEN P.EXPECTED_COST_YTD > 0.00 THEN ((P.PLANNED_COST_YTD - P.EXPECTED_COST_YTD)/P.EXPECTED_COST_YTD)*10000 ELSE 0 END) AS COSTYTDVAR_PLAN_COST_P__P, '
          || '(CASE WHEN P.BASELINE1_REVENUE_YTD > 0.00 THEN P.EXPECTED_REVENUE_YTD - P.BASELINE1_REVENUE_YTD ELSE 0.00 END) AS REVYTDVAR_EST_REV__M, '
          || '(CASE WHEN P.BASELINE1_REVENUE_YTD > 0.00 THEN ((P.EXPECTED_REVENUE_YTD - P.BASELINE1_REVENUE_YTD)/P.BASELINE1_REVENUE_YTD)*10000 ELSE 0 END) AS REVYTDVAR_EST_REV_P__P, '
          || '(CASE WHEN P.EXPECTED_REVENUE_YTD > 0.00 THEN P.PLANNED_REVENUE_YTD - P.EXPECTED_REVENUE_YTD ELSE 0.00 END) AS REVYTDVAR_PLAN_REV__M, '
          || '(CASE WHEN P.EXPECTED_REVENUE_YTD > 0.00 THEN ((P.PLANNED_REVENUE_YTD - P.EXPECTED_REVENUE_YTD)/P.EXPECTED_REVENUE_YTD)*10000 ELSE 0 END) AS REVYTDVAR_PLAN_REV_P__P, '
          || '((P.EXPECTED_REVENUE_YTD - P.EXPECTED_COST_YTD) - (P.BASELINE1_REVENUE_YTD - P.BASELINE1_COST_YTD)) AS GPYTDVAR_EST_GP__M, '
          || '((P.PLANNED_REVENUE_YTD - P.PLANNED_COST_YTD) - (P.EXPECTED_REVENUE_YTD - P.EXPECTED_COST_YTD)) AS GPYTDVAR_PLAN_GP__M, '
          || '(CASE WHEN P.BASELINE1_COST_TODATE > 0.00 THEN P.EXPECTED_COST_TODATE - P.BASELINE1_COST_TODATE ELSE 0.00 END) AS COSTTDVAR_EST_COST__M, '
          || '(CASE WHEN P.BASELINE1_COST_TODATE > 0.00 THEN ((P.EXPECTED_COST_TODATE - P.BASELINE1_COST_TODATE)/P.BASELINE1_COST_TODATE)*10000 ELSE 0 END) AS COSTTDVAR_EST_COST_P__P, '
          || '(CASE WHEN P.EXPECTED_COST_TODATE > 0.00 THEN P.PLANNED_COST_TODATE - P.EXPECTED_COST_TODATE ELSE 0.00 END) AS COSTTDVAR_PLAN_COST__M, '
          || '(CASE WHEN P.EXPECTED_COST_TODATE > 0.00 THEN ((P.PLANNED_COST_TODATE - P.EXPECTED_COST_TODATE)/P.EXPECTED_COST_TODATE)*10000 ELSE 0 END) AS COSTTDVAR_PLAN_COST_P__P, '
          || '(CASE WHEN P.BASELINE1_REVENUE_TODATE > 0.00 THEN P.EXPECTED_REVENUE_TODATE - P.BASELINE1_REVENUE_TODATE ELSE 0.00 END) AS REVTDVAR_EST_REV__M, '
          || '(CASE WHEN P.BASELINE1_REVENUE_TODATE > 0.00 THEN ((P.EXPECTED_REVENUE_TODATE - P.BASELINE1_REVENUE_TODATE)/P.BASELINE1_REVENUE_TODATE)*10000 ELSE 0 END) AS REVTDVAR_EST_REV_P__P, '
          || '(CASE WHEN P.EXPECTED_REVENUE_TODATE > 0.00 THEN P.PLANNED_REVENUE_TODATE - P.EXPECTED_REVENUE_TODATE ELSE 0.00 END) AS REVTDVAR_PLAN_REV__M, '
          || '(CASE WHEN P.EXPECTED_REVENUE_TODATE > 0.00 THEN ((P.PLANNED_REVENUE_TODATE - P.EXPECTED_REVENUE_TODATE)/P.EXPECTED_REVENUE_TODATE)*10000 ELSE 0 END) AS REVTDVAR_PLAN_REV_P__P, '
          || '((P.EXPECTED_REVENUE_TODATE - P.EXPECTED_COST_TODATE) - (P.BASELINE1_REVENUE_TODATE - P.BASELINE1_COST_TODATE)) AS GPTDVAR_EST_GP__M, '
          || '((P.PLANNED_REVENUE_TODATE - P.PLANNED_COST_TODATE) - (P.EXPECTED_REVENUE_TODATE - P.EXPECTED_COST_TODATE)) AS GPTDVAR_PLAN_GP__M '
          || 'FROM PMO_FINANCIAL_RESULTSET P '
          || 'LEFT JOIN PMO_FINANCIAL_PSC SC ON SC.PROJECT_ID = P.PROJECT_ID '
          || 'LEFT JOIN PMO_FINANCIAL_PAT AT ON AT.PROJECT_ID = P.PROJECT_ID '
          || 'ORDER BY P.RANK, P.PROJECT_YEAR, P.PERIOD, P.CHARGECODE_TYPE, P.CHARGECODE_NAME, P.EXPECTED_START ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_YEAR_VIEW', 176+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_YEAR_VIEW(177) : views_financial.sql(8584) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_YEAR_VIEW', 179+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_YEAR_VIEW(180) : views_financial.sql(8587) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_YEAR_VIEW', 186+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_YEAR_VIEW(187) : views_financial.sql(8594) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_YEAR_VIEW', 198+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_YEAR_VIEW(199) : views_financial.sql(8606) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BB_YEAR_VIEW;
ALTER FUNCTION SP_BB_YEAR_VIEW COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_BB_MONTH_VIEW ==
CREATE OR REPLACE FUNCTION SP_BB_MONTH_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
   h_temp_type PLS_INTEGER := 0;
   i PLS_INTEGER;
   j PLS_INTEGER;
   k PLS_INTEGER NOT NULL := 1;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BB_MONTH_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BB_MONTH_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_BB_MONTH_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_MONTH_VIEW', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BB_MONTH_VIEW(38) : views_financial.sql(8664) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BB_MONTH_VIEW', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BB_MONTH_VIEW(43) : views_financial.sql(8669) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_CHARGECODES();
   
   h_temp_type := PMO_CNST.SC_MONTHLY;
   h_temp_sc_state := FC_PARSE_PROJECTS(h_temp_type);
   
   h_temp_sc_state := FC_PIVOT_PROJECT_MONTHLY();
   h_temp_sc_state := FC_INIT_SCORECARDS();
   h_temp_sc_state := FC_PIVOT_SCORECARDS();
   h_temp_sc_state := FC_INIT_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_ATTRIBUTES();
   
   --=====================================================================
   -- Build Query
   --=====================================================================
   --count the number of periods in the final result
   BEGIN
      SELECT MAX(PERIOD) INTO h_period_count
      FROM PMO_FINANCIAL_RESULTSET;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_MONTH_VIEW', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_MONTH_VIEW(81) : views_financial.sql(8707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.YEAR(MIN(COALESCE(PROJECT_START, TO_DATE(SYSDATE)))) INTO h_min_year
      FROM PMO_FINANCIAL_RESULTSET_EX;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_MONTH_VIEW', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_MONTH_VIEW(95) : views_financial.sql(8721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT PMO_ORASTD.YEAR(MAX(COALESCE(PROJECT_FINISH, TO_DATE(SYSDATE)))) INTO h_max_year
      FROM PMO_FINANCIAL_RESULTSET_EX;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_MONTH_VIEW', 108+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_MONTH_VIEW(109) : views_financial.sql(8735) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_year_count := Coalesce(h_max_year, 0) - Coalesce(h_min_year, 0) + 1;
   
   h_xsql := '';
   h_xsql := 'SELECT '
          || ''''' AS ELEMENT_ID, '
          || ''''' AS ELEMENT_NAME, '
          || '0 AS TYPE_ID, '
          || 'P.PROJECT_NAME AS DEFAULT0_PROJECT__T, '
          || 'P.REFERNCE_CODE AS DEFAULT0_REF_NUMBER__T,'
          || 'P.PROJECT_MANAGER AS PROJECT_MANAGER__T,'
          || 'P.PROJECT_CURRENCY_ID AS PROJECT_CURRENCY_37_DF, '
          || 'P.PROJECT_START AS PROJECT_START_DA, '
          || 'P.PROJECT_FINISH AS PROJECT_FINISH_DA, '
          || 'AT.PROJECT_ATTRIBUTES AS ATTRIBUTES_ATTRIBUTES_AT, '
          || 'P.PROJECT_PRIORITY AS STATUS_PRIORITY__T,'
          || 'P.STAGE_ID AS STATUS_STAGE_12_DF,'
          || '(CASE WHEN SC.SCORECARD_WEIGHT > 0 THEN PMO_ORASTD.TODECIMAL(((SC.SCORECARD_SCORE/SC.SCORECARD_WEIGHT)*100), 5, 2) ELSE 0 END) AS STATUS_SCORECARD_RATING__T, '
          || 'P.PROJECT_HEALTH AS STATUS_SCORECARD_COLOR__T, '
          || 'P.CHARGECODE_NAME AS CHARGECODE_NAME__T, '
          || 'CASE WHEN P.CHARGECODE_TYPE = 0 THEN ''Expense'' WHEN P.CHARGECODE_TYPE = 1 THEN ''Capital'' WHEN P.BILLABLE = 1 THEN ''Revenue'' ELSE ''Non-Billable Benefit'' END AS CHARGECODE_TYPE__T, '
          || 'CASE WHEN P.LABOR_FLAG = 0 THEN ''Non-labor'' ELSE ''Labor'' END AS CHARGECODE_LABOR__T, '
          || 'CASE WHEN P.ACTUAL_COST > 0 THEN P.ACTUAL_COST WHEN P.PLANNED_COST > 0 THEN P.PLANNED_COST ELSE P.EXPECTED_COST END AS COST_PRIORITY__M, '
          || 'P.EXPECTED_COST AS COST_ESTIMATED__M, '
          || 'P.PLANNED_COST AS COST_PLANNED__M, '
          || 'P.BASELINE1_COST AS COST_BASELINE_L__M, '
          || 'P.BASELINE3_COST AS COST_BASELINE_I__M, '
          || 'P.ACTUAL_COST AS COST_ACTUAL__M, '
          || '(P.PLANNED_COST - P.ACTUAL_COST) AS COST_REMAINING__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE > 0 THEN P.ACTUAL_REVENUE WHEN P.PLANNED_REVENUE > 0 THEN P.PLANNED_REVENUE ELSE P.EXPECTED_REVENUE END AS REVENUE_PRIORITY__M, '
          || 'P.EXPECTED_REVENUE AS REVENUE_ESTIMATED__M,'
          || 'P.PLANNED_REVENUE AS REVENUE_PLANNED__M, '
          || 'P.BASELINE1_REVENUE AS REVENUE_BASELINE_L__M, '
          || 'P.BASELINE3_REVENUE AS REVENUE_BASELINE_I__M, '
          || 'P.ACTUAL_REVENUE AS REVENUE_ACTUAL__M, '
          || '(P.PLANNED_REVENUE - P.ACTUAL_REVENUE) AS REVENUE_REMAINING__M, '
          || 'CASE WHEN P.ACTUAL_GP > 0 THEN P.ACTUAL_GP WHEN P.PLANNED_GP > 0 THEN P.PLANNED_GP ELSE P.EXPECTED_GP END AS GP_PRIORITY__M, '
          || 'P.EXPECTED_GP AS GP_ESTIMATED__M, '
          || 'P.PLANNED_GP AS GP_PLANNED__M, '
          || 'P.BASELINE1_GP AS GP_BASELINE_L__M, '
          || 'P.BASELINE3_GP AS GP_BASELINE_I__M, '
          || 'P.ACTUAL_GP AS GP_ACTUAL__M, '
          || '(P.PLANNED_GP - P.ACTUAL_GP) AS GP_REMAINING__M, '
          || 'CASE WHEN P.ACTUAL_COST_YTD > 0 THEN P.ACTUAL_COST_YTD WHEN P.PLANNED_COST_YTD > 0 THEN P.PLANNED_COST_YTD ELSE P.EXPECTED_COST_YTD END AS COSTYTD_PRIORITY__M, '
          || 'P.EXPECTED_COST_YTD AS COSTYTD_ESTIMATED__M, '
          || 'P.PLANNED_COST_YTD AS COSTYTD_PLANNED__M, '
          || 'P.BASELINE1_COST_YTD AS COSTYTD_BASELINE_L__M, '
          || 'P.BASELINE3_COST_YTD AS COSTYTD_BASELINE_I__M, '
          || 'P.ACTUAL_COST_YTD AS COSTYTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_YTD > 0 THEN P.ACTUAL_REVENUE_YTD WHEN P.PLANNED_REVENUE_YTD > 0 THEN P.PLANNED_REVENUE_YTD ELSE P.EXPECTED_REVENUE_YTD END AS REVENUEYTD_PRIORITY__M, '
          || 'P.EXPECTED_REVENUE_YTD AS REVENUEYTD_ESTIMATED__M, '
          || 'P.PLANNED_REVENUE_YTD AS REVENUEYTD_PLANNED__M, '
          || 'P.BASELINE1_REVENUE_YTD AS REVENUEYTD_BASELINE_L__M, '
          || 'P.BASELINE3_REVENUE_YTD AS REVENUEYTD_BASELINE_I__M, '
          || 'P.ACTUAL_REVENUE_YTD AS REVENUEYTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_YTD > 0 THEN (P.ACTUAL_REVENUE_YTD - P.ACTUAL_COST_YTD) WHEN P.PLANNED_REVENUE_YTD > 0 THEN (P.PLANNED_REVENUE_YTD - P.PLANNED_COST_YTD) ELSE (P.EXPECTED_REVENUE_YTD - P.EXPECTED_REVENUE_YTD) END AS GPYTD_PRIORITY__M, '
          || '(P.EXPECTED_REVENUE_YTD - P.EXPECTED_COST_YTD) AS GPYTD_ESTIMATED__M, '
          || '(P.PLANNED_REVENUE_YTD - P.PLANNED_COST_YTD) AS GPYTD_PLANNED__M, '
          || '(P.BASELINE1_REVENUE_YTD - P.BASELINE1_COST_YTD) AS GPYTD_BASELINE_L__M, '
          || '(P.BASELINE3_REVENUE_YTD - P.BASELINE3_COST_YTD) AS GPYTD_BASELINE_I__M, '
          || '(P.ACTUAL_REVENUE_YTD - P.ACTUAL_REVENUE_YTD) AS GPYTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_COST_TODATE > 0 THEN P.ACTUAL_COST_TODATE WHEN P.PLANNED_COST_TODATE > 0 THEN P.PLANNED_COST_TODATE ELSE P.EXPECTED_COST_TODATE END AS COSTTD_PRIORITY__M, '
          || 'P.EXPECTED_COST_TODATE AS COSTTD_ESTIMATED__M, '
          || 'P.PLANNED_COST_TODATE AS COSTTD_PLANNED__M, '
          || 'P.BASELINE1_COST_TODATE AS COSTTD_BASELINE_L__M, '
          || 'P.BASELINE3_COST_TODATE AS COSTTD_BASELINE_I__M, '
          || 'P.ACTUAL_COST_TODATE AS COSTTD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_TODATE > 0 THEN P.ACTUAL_REVENUE_TODATE WHEN P.PLANNED_REVENUE_TODATE > 0 THEN P.PLANNED_REVENUE_TODATE ELSE P.EXPECTED_REVENUE_TODATE END AS REVENUETD_PRIORITY__M, '
          || 'P.EXPECTED_REVENUE_TODATE AS REVENUETD_ESTIMATED__M, '
          || 'P.PLANNED_REVENUE_TODATE AS REVENUETD_PLANNED__M, '
          || 'P.BASELINE1_REVENUE_TODATE AS REVENUETD_BASELINE_L__M, '
          || 'P.BASELINE3_REVENUE_TODATE AS REVENUETD_BASELINE_I__M, '
          || 'P.ACTUAL_REVENUE_TODATE AS REVENUETD_ACTUAL__M, '
          || 'CASE WHEN P.ACTUAL_REVENUE_TODATE > 0 THEN (P.ACTUAL_REVENUE_TODATE - P.ACTUAL_COST_TODATE) WHEN P.PLANNED_REVENUE_TODATE > 0 THEN (P.PLANNED_REVENUE_TODATE - P.PLANNED_COST_TODATE) ELSE (P.EXPECTED_REVENUE_TODATE - P.EXPECTED_REVENUE_TODATE) END AS GPTD_PRIORITY__M, '
          || '(P.EXPECTED_REVENUE_TODATE - P.EXPECTED_COST_TODATE) AS GPTD_ESTIMATED__M, '
          || '(P.PLANNED_REVENUE_TODATE - P.PLANNED_COST_TODATE) AS GPTD_PLANNED__M, '
          || '(P.BASELINE1_REVENUE_TODATE - P.BASELINE3_COST_TODATE) AS GPTD_BASELINE_L__M, '
          || '(P.BASELINE1_REVENUE_TODATE - P.BASELINE3_COST_TODATE) AS GPTD_BASELINE_I__M, '
          || '(P.ACTUAL_REVENUE_TODATE - P.ACTUAL_REVENUE_TODATE) AS GPTD_ACTUAL__M, '
          || '(CASE WHEN P.BASELINE1_COST > 0.00 THEN P.EXPECTED_COST - P.BASELINE1_COST ELSE 0.00 END) AS VARESTCOST_COST__M, '
          || '(CASE WHEN P.BASELINE1_COST > 0.00 THEN ((P.EXPECTED_COST - P.BASELINE1_COST)/P.BASELINE1_COST)*10000 ELSE 0 END) AS VARESTCOST_COST_P__P, '
          || '(CASE WHEN P.EXPECTED_COST > 0.00 THEN P.PLANNED_COST - P.EXPECTED_COST ELSE 0.00 END) AS VARPLANCOST_COST__M, '
          || '(CASE WHEN P.EXPECTED_COST > 0.00 THEN ((P.PLANNED_COST - P.EXPECTED_COST)/P.EXPECTED_COST)*10000 ELSE 0 END) AS VARPLANCOST_COST_P__P, '
          || '(CASE WHEN P.BASELINE1_REVENUE > 0.00 THEN P.EXPECTED_REVENUE - P.BASELINE1_REVENUE ELSE 0.00 END) AS VARESTREV_REV__M, '
          || '(CASE WHEN P.BASELINE1_REVENUE > 0.00 THEN ((P.EXPECTED_REVENUE - P.BASELINE1_REVENUE)/P.BASELINE1_REVENUE)*10000 ELSE 0 END) AS VARESTREV_REV_P__P, '
          || '(CASE WHEN P.EXPECTED_REVENUE > 0.00 THEN P.PLANNED_REVENUE - P.EXPECTED_REVENUE ELSE 0.00 END) AS VARPLANREV_REV__M, '
          || '(CASE WHEN P.EXPECTED_REVENUE > 0.00 THEN ((P.PLANNED_REVENUE - P.EXPECTED_REVENUE)/P.EXPECTED_REVENUE)*10000 ELSE 0 END) AS VARPLANREV_REV_P__P, '
          || '(P.EXPECTED_GP - P.BASELINE1_GP) AS VARESTGP_GP__M, '
          || '(P.PLANNED_GP - P.EXPECTED_GP) AS VARPLANGP_GP__M, ';
   
   --Year Counter
   i := 0;
   WHILE i < Coalesce(h_year_count, 0) LOOP
      j := 1;
      WHILE j < 13 LOOP
         If k <= Coalesce(h_period_count, 0) Then
            h_xsql := h_xsql || 'SUM(PFR.EXPECTED_COST * (1-ABS(SIGN(PFR.PERIOD - ';
            h_xsql := h_xsql || TO_CHAR(k);
            h_xsql := h_xsql || ')))) AS CF_';
            h_xsql := h_xsql || TO_CHAR(Coalesce(h_min_year, 0) + i);
            h_xsql := h_xsql || '_';
            h_xsql := h_xsql || TO_CHAR(j);
            
            If k = Coalesce(h_period_count, 0) Then
               h_xsql := h_xsql || '__M ';
            Else
               h_xsql := h_xsql || '__M, ';
            End If;
            
            k := k + 1;
         Else
            EXIT;
            NULL;
         End If;
               j := j + 1;
      END LOOP;
      i := i + 1;
   END LOOP;
   
   h_xsql := h_xsql || 'FROM PMO_FINANCIAL_RESULTSET_EX P ';
   h_xsql := h_xsql || 'LEFT JOIN PMO_FINANCIAL_RESULTSET PFR '
          || 'ON PFR.PROJECT_ID = P.PROJECT_ID '
          || 'AND PFR.CHARGECODE_ID = P.CHARGECODE_ID ';
   h_xsql := h_xsql || 'LEFT JOIN PMO_FINANCIAL_PSC SC ON SC.PROJECT_ID = P.PROJECT_ID ';
   h_xsql := h_xsql || 'LEFT JOIN PMO_FINANCIAL_PAT AT ON AT.PROJECT_ID = P.PROJECT_ID ';
   
   h_xsql := h_xsql || 'GROUP BY P.RANK, '
          || 'P.PROJECT_NAME, '
          || 'P.REFERNCE_CODE,'
          || 'P.PROJECT_MANAGER,'
          || 'P.PROJECT_CURRENCY_ID, '
          || 'P.PROJECT_START, '
          || 'P.PROJECT_FINISH, '
          || 'AT.PROJECT_ATTRIBUTES, '
          || 'P.PROJECT_PRIORITY,'
          || 'P.STAGE_ID,'
          || 'SC.SCORECARD_SCORE, SC.SCORECARD_WEIGHT, '
          || 'P.PROJECT_HEALTH, '
          || 'P.CHARGECODE_NAME, '
          || 'P.CHARGECODE_TYPE, P.LABOR_FLAG, P.BILLABLE, '
          || 'P.ACTUAL_COST, P.PLANNED_COST, P.EXPECTED_COST, P.BASELINE1_COST, P.BASELINE3_COST, '
          || 'P.ACTUAL_REVENUE, P.PLANNED_REVENUE, P.EXPECTED_REVENUE, P.BASELINE1_REVENUE, P.BASELINE3_REVENUE, '
          || 'P.ACTUAL_GP, P.PLANNED_GP, P.EXPECTED_GP, P.BASELINE1_GP, P.BASELINE3_GP, '
          || 'P.ACTUAL_COST_YTD, P.PLANNED_COST_YTD, P.EXPECTED_COST_YTD, P.BASELINE1_COST_YTD, P.BASELINE3_COST_YTD, '
          || 'P.ACTUAL_COST_TODATE, P.PLANNED_COST_TODATE, P.EXPECTED_COST_TODATE, P.BASELINE1_COST_TODATE, P.BASELINE3_COST_TODATE, '
          || 'P.ACTUAL_REVENUE_YTD, P.PLANNED_REVENUE_YTD, P.EXPECTED_REVENUE_YTD, P.BASELINE1_REVENUE_YTD, P.BASELINE3_REVENUE_YTD, '
          || 'P.ACTUAL_REVENUE_TODATE, P.PLANNED_REVENUE_TODATE, P.EXPECTED_REVENUE_TODATE, P.BASELINE1_REVENUE_TODATE, P.BASELINE3_REVENUE_TODATE ';
   
   h_xsql := h_xsql || 'ORDER BY P.RANK, P.CHARGECODE_TYPE, P.CHARGECODE_NAME ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_MONTH_VIEW', 263+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_MONTH_VIEW(264) : views_financial.sql(8890) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_MONTH_VIEW', 266+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_MONTH_VIEW(267) : views_financial.sql(8893) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_MONTH_VIEW', 273+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_MONTH_VIEW(274) : views_financial.sql(8900) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_MONTH_VIEW', 285+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_MONTH_VIEW(286) : views_financial.sql(8912) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BB_MONTH_VIEW;
ALTER FUNCTION SP_BB_MONTH_VIEW COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_BB_PIVOT ==
CREATE OR REPLACE FUNCTION SP_BB_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BB_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BB_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_BB_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_PIVOT', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BB_PIVOT(33) : views_financial.sql(8965) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BB_PIVOT', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BB_PIVOT(38) : views_financial.sql(8970) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_SCORECARDS();
   h_temp_sc_state := FC_PIVOT_SCORECARDS();
   h_temp_sc_state := FC_INIT_EXCEPTIONS();
   h_temp_sc_state := FC_PIVOT_EXCEPTIONS();
   h_temp_sc_state := FC_INIT_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_ATTRIBUTES();
   
   h_xsql := '';
   h_xsql := 'SELECT '
          || ''''' AS ELEMENT_ID, '
          || ''''' AS ELEMENT_NAME, '
          || '0 AS TYPE_ID, '
          || 'W.ELEMENT_NAME AS PROJECT_NAME, '
          || 'R.FULL_NAME AS PROJECT_MANAGER,'
          || 'W.REF_CODE AS PROJECT_REF_NUMBER,'
          || 'W.CURRENCY_ID AS PROJECT_CURRENCY_37_DF, '
          || 'TO_DATE(SubStr(W.START_DT, 1, 10)) AS PROJECT_START, '
          || 'TO_DATE(SubStr(W.FINISH_DT, 1, 10)) AS PROJECT_FINISH, '
          || 'AT.PROJECT_ATTRIBUTES AS ATTRIBUTES_ATTRIBUTES, '
          || 'W.PRIORITY AS PRIORITY,'
          || 'W.STAGE_ID AS STAGE_ID,'
          || '(CASE WHEN SC.SCORECARD_WEIGHT > 0 THEN ((SC.SCORECARD_SCORE/SC.SCORECARD_WEIGHT)*10000) ELSE 0 END) AS STATUS_SCORECARD_RATING, '
          || 'W.BUBBLE_COLOR AS STATUS_SCORECARD_COLOR, '
          || '0 AS STATUS_RISK_EXPOSURE, '
          || 'TO_DATE(SubStr(W.START_DT, 1, 10)) AS START_PRIORITY, '
          || 'P.EXPECTED_START AS START_ESTIMATED, '
          || 'P.PLANNED_START AS START_PLANNED,'
          || 'P.BASELINE1_START AS START_BASELINE1, '
          || 'P.BASELINE3_START AS START_BASELINE3, '
          || 'P.ACTUAL_START AS START_ACTUAL, '
          || 'TO_DATE(SubStr(W.FINISH_DT, 1, 10)) AS FINISH_PRIORITY, '
          || 'P.EXPECTED_FINISH AS FINISH_ESTIMATED, '
          || 'P.PLANNED_FINISH AS FINISH_PLANNED, '
          || 'P.BASELINE1_FINISH AS FINISH_BASELINE1, '
          || 'P.BASELINE3_FINISH AS FINISH_BASELINE3, '
          || 'P.ACTUAL_FINISH AS FINISH_ACTUAL, '
          || 'W.DURATION AS DAYS_PRIORITY, '
          || 'W.DURATION AS DAYS_ESTIMATED, '
          || 'W.BASELINE1_DURATION AS DAYS_BASELINE, '
          || 'W.UNRESOLVED_DURATION AS DAYS_SCHEDULE, '
          || 'W.ACTUAL_DURATION AS DAYS_ACTUAL, '
          || '(PMO_ORASTD.MONTH(W.FINISH_DT) - PMO_ORASTD.MONTH(W.START_DT)) AS MONTHS_PRIORITY, '
          || '(PMO_ORASTD.MONTH(W.FINISH_DT) - PMO_ORASTD.MONTH(W.START_DT)) AS MONTHS_ESTIMATED, '
          || 'CASE WHEN W.BASELINE1_DURATION > 0 THEN (PMO_ORASTD.MONTH(W.BASELINE1_FINISH) - PMO_ORASTD.MONTH(W.BASELINE1_START)) ELSE 0 END AS MONTHS_BASELINE, '
          || 'CASE WHEN W.SCHED_DURATION > 0 THEN (PMO_ORASTD.MONTH(W.SCHED_FINISH) - PMO_ORASTD.MONTH(W.SCHED_START)) ELSE 0 END AS MONTHS_SCHEDULE, '
          || 'CASE WHEN W.ACTUAL_DURATION > 0 THEN (PMO_ORASTD.MONTH(W.ACTUAL_FINISH) - PMO_ORASTD.MONTH(W.ACTUAL_START)) ELSE 0 END AS MONTHS_ACTUAL, '
          || '(W.SCHED_EFFORT+W.PLANNED_EFFORT) AS EFFORT_PRIORITY, '
          || '(W.SCHED_EFFORT+W.PLANNED_EFFORT) AS EFFORT_ESTIMATED, '
          || 'W.BASELINE1_EFFORT AS EFFORT_BASELINE, '
          || 'W.SCHED_EFFORT AS EFFORT_SCHEDULE, '
          || 'W.ACTUAL_EFFORT AS EFFORT_ACTUAL, '
          || 'CASE WHEN W.ACTUAL_BUDGET > 0 THEN W.ACTUAL_BUDGET '
          || 'WHEN W.CURRENT_BUDGET > 0 THEN W.CURRENT_BUDGET '
          || 'ELSE W.ESTIMATION_BUDGET END AS COST_PRIORITY, '
          || 'W.ESTIMATION_BUDGET AS COST_ESTIMATED, '
          || 'W.CURRENT_BUDGET AS COST_PLANNED, '
          || 'W.BASELINE1_BUDGET AS COST_BASELINE, '
          || 'W.ACTUAL_BUDGET AS COST_ACTUAL, '
          || '(W.CURRENT_BUDGET - W.ACTUAL_BUDGET) AS COST_REMAINING, '
          || 'CASE WHEN (W.R_ACTUAL_BUDGET + W.S_ACTUAL_BUDGET) > 0 THEN (W.R_ACTUAL_BUDGET + W.S_ACTUAL_BUDGET) '
          || 'WHEN (W.R_CURRENT_BUDGET + W.S_CURRENT_BUDGET) > 0 THEN (W.R_CURRENT_BUDGET + W.S_CURRENT_BUDGET) '
          || 'ELSE (W.R_ESTIMATION_BUDGET + W.S_ESTIMATION_BUDGET) END AS REVENUE_PRIORITY, '
          || '(W.R_ESTIMATION_BUDGET + W.S_ESTIMATION_BUDGET) AS REVENUE_ESTIMATED,'
          || '(W.R_CURRENT_BUDGET + W.S_CURRENT_BUDGET) AS REVENUE_PLANNED, '
          || '(W.R_BASELINE1_BUDGET + W.S_BASELINE1_BUDGET) AS REVENUE_BASELINE, '
          || '(W.R_ACTUAL_BUDGET + W.S_ACTUAL_BUDGET) AS REVENUE_ACTUAL, '
          || 'EXC.CR_PRIORITY_COST, '
          || 'EXC.CR_PRIORITY_REVENUE, '
          || 'EXC.CR_PRIORITY_EFFORT, '
          || 'EXC.CR_SCHED_IMPACT, '
          || 'EXC.CR_TOTAL_COUNT, '
          || 'EXC.CR_CLOSED_COUNT, '
          || 'EXC.CR_TRANSFERRED_COUNT, '
          || 'EXC.RS_PRIORITY_COST, '
          || 'EXC.RS_PRIORITY_REVENUE, '
          || 'EXC.RS_PRIORITY_EFFORT, '
          || 'EXC.RS_SCHED_IMPACT, '
          || 'EXC.RS_TOTAL_COUNT, '
          || 'EXC.RS_CLOSED_COUNT, '
          || 'EXC.RS_TRANSFERRED_COUNT, '
          || 'EXC.IS_PRIORITY_COST, '
          || 'EXC.IS_PRIORITY_REVENUE, '
          || 'EXC.IS_PRIORITY_EFFORT, '
          || 'EXC.IS_SCHED_IMPACT, '
          || 'EXC.IS_TOTAL_COUNT, '
          || 'EXC.IS_CLOSED_COUNT, '
          || 'EXC.IS_TRANSFERRED_COUNT, '
          || 'EXC.RQ_PRIORITY_COST, '
          || 'EXC.RQ_PRIORITY_REVENUE, '
          || 'EXC.RQ_PRIORITY_EFFORT, '
          || 'EXC.RQ_SCHED_IMPACT, '
          || 'EXC.RQ_TOTAL_COUNT, '
          || 'EXC.RQ_CLOSED_COUNT, '
          || 'EXC.RQ_TRANSFERRED_COUNT, '
          || 'EXC.DF_PRIORITY_COST, '
          || 'EXC.DF_PRIORITY_REVENUE, '
          || 'EXC.DF_PRIORITY_EFFORT, '
          || 'EXC.DF_SCHED_IMPACT, '
          || 'EXC.DF_TOTAL_COUNT, '
          || 'EXC.DF_CLOSED_COUNT, '
          || 'EXC.DF_TRANSFERRED_COUNT, '
          || 'EXC.SQ_PRIORITY_COST, '
          || 'EXC.SQ_PRIORITY_REVENUE, '
          || 'EXC.SQ_PRIORITY_EFFORT, '
          || 'EXC.SQ_SCHED_IMPACT, '
          || 'EXC.SQ_TOTAL_COUNT, '
          || 'EXC.SQ_CLOSED_COUNT, '
          || 'EXC.SQ_TRANSFERRED_COUNT, '
          || 'COALESCE(RTF01.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF01, '
          || 'COALESCE(RTF02.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF02, '
          || 'COALESCE(RTF03.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF03, '
          || 'COALESCE(RTF04.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF04, '
          || 'COALESCE(RTF05.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF05, '
          || 'COALESCE(RTF06.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF06, '
          || 'COALESCE(RTF07.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF07, '
          || 'COALESCE(RTF08.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF08, '
          || 'COALESCE(RTF09.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF09, '
          || 'COALESCE(RTF10.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF10, '
          || 'COALESCE(RTF11.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF11, '
          || 'COALESCE(RTF12.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF12, '
          || 'COALESCE(RTF13.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF13, '
          || 'COALESCE(RTF14.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF14, '
          || 'COALESCE(RTF15.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF15, '
          || 'COALESCE(RTF16.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF16, '
          || 'COALESCE(RTF17.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF17, '
          || 'COALESCE(RTF18.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF18, '
          || 'COALESCE(RTF19.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF19, '
          || 'COALESCE(RTF20.CLOB_DATA,(SELECT CLOB_DATA FROM EMPTYLOB)) AS RTF20 '
          || 'FROM PMO_FINANCIAL_PROJECTS P '
          || 'JOIN TMT_WBS W ON W.ELEMENT_ID = P.ELEMENT_ID '
          || 'JOIN RESOURCE_ASSIGNMENTS RA ON RA.PROJECT_ID = W.ELEMENT_ID AND RA.ELEMENT_ID = W.ELEMENT_ID AND BITAND(RA.PARTICIPANT,1) = 1 '
          || 'JOIN RESOURCES R ON R.RESOURCE_ID = RA.RESOURCE_ID '
          || 'LEFT JOIN PMO_FINANCIAL_PSC SC ON SC.PROJECT_ID = P.ELEMENT_ID '
          || 'LEFT JOIN PMO_FINANCIAL_PEXC EXC ON EXC.PROJECT_ID = P.ELEMENT_ID '
          || 'LEFT JOIN PMO_FINANCIAL_PAT AT ON AT.PROJECT_ID = P.ELEMENT_ID '
          || 'LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = W.ELEMENT_ID AND RTF01.ELEMENT_ID = W.ELEMENT_ID AND RTF01.BIT_FLAG = 1 '
          || 'LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = W.ELEMENT_ID AND RTF02.ELEMENT_ID = W.ELEMENT_ID AND RTF02.BIT_FLAG = 2 '
          || 'LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = W.ELEMENT_ID AND RTF03.ELEMENT_ID = W.ELEMENT_ID AND RTF03.BIT_FLAG = 4 '
          || 'LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = W.ELEMENT_ID AND RTF04.ELEMENT_ID = W.ELEMENT_ID AND RTF04.BIT_FLAG = 8 '
          || 'LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = W.ELEMENT_ID AND RTF05.ELEMENT_ID = W.ELEMENT_ID AND RTF05.BIT_FLAG = 16 '
          || 'LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = W.ELEMENT_ID AND RTF06.ELEMENT_ID = W.ELEMENT_ID AND RTF06.BIT_FLAG = 32 '
          || 'LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = W.ELEMENT_ID AND RTF07.ELEMENT_ID = W.ELEMENT_ID AND RTF07.BIT_FLAG = 64 '
          || 'LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = W.ELEMENT_ID AND RTF08.ELEMENT_ID = W.ELEMENT_ID AND RTF08.BIT_FLAG = 128 '
          || 'LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = W.ELEMENT_ID AND RTF09.ELEMENT_ID = W.ELEMENT_ID AND RTF09.BIT_FLAG = 256 '
          || 'LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = W.ELEMENT_ID AND RTF10.ELEMENT_ID = W.ELEMENT_ID AND RTF10.BIT_FLAG = 512 '
          || 'LEFT JOIN WBS_RTF RTF11 ON RTF11.PARENT_ID = W.ELEMENT_ID AND RTF11.ELEMENT_ID = W.ELEMENT_ID AND RTF11.BIT_FLAG = 1024 '
          || 'LEFT JOIN WBS_RTF RTF12 ON RTF12.PARENT_ID = W.ELEMENT_ID AND RTF12.ELEMENT_ID = W.ELEMENT_ID AND RTF12.BIT_FLAG = 2048 '
          || 'LEFT JOIN WBS_RTF RTF13 ON RTF13.PARENT_ID = W.ELEMENT_ID AND RTF13.ELEMENT_ID = W.ELEMENT_ID AND RTF13.BIT_FLAG = 4096 '
          || 'LEFT JOIN WBS_RTF RTF14 ON RTF14.PARENT_ID = W.ELEMENT_ID AND RTF14.ELEMENT_ID = W.ELEMENT_ID AND RTF14.BIT_FLAG = 8192 '
          || 'LEFT JOIN WBS_RTF RTF15 ON RTF15.PARENT_ID = W.ELEMENT_ID AND RTF15.ELEMENT_ID = W.ELEMENT_ID AND RTF15.BIT_FLAG = 16384 '
          || 'LEFT JOIN WBS_RTF RTF16 ON RTF16.PARENT_ID = W.ELEMENT_ID AND RTF16.ELEMENT_ID = W.ELEMENT_ID AND RTF16.BIT_FLAG = 32768 '
          || 'LEFT JOIN WBS_RTF RTF17 ON RTF17.PARENT_ID = W.ELEMENT_ID AND RTF17.ELEMENT_ID = W.ELEMENT_ID AND RTF17.BIT_FLAG = 65536 '
          || 'LEFT JOIN WBS_RTF RTF18 ON RTF18.PARENT_ID = W.ELEMENT_ID AND RTF18.ELEMENT_ID = W.ELEMENT_ID AND RTF18.BIT_FLAG = 131072 '
          || 'LEFT JOIN WBS_RTF RTF19 ON RTF19.PARENT_ID = W.ELEMENT_ID AND RTF19.ELEMENT_ID = W.ELEMENT_ID AND RTF19.BIT_FLAG = 262144 '
          || 'LEFT JOIN WBS_RTF RTF20 ON RTF20.PARENT_ID = W.ELEMENT_ID AND RTF20.ELEMENT_ID = W.ELEMENT_ID AND RTF20.BIT_FLAG = 524288 '
          || 'ORDER BY P.RANK ';
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_PIVOT', 209+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_PIVOT(210) : views_financial.sql(9142) : ' || SYSTIMESTAMP);
   END IF; 
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_PIVOT', 212+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_PIVOT(213) : views_financial.sql(9145) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMODEFINES.PMO_SELECT_READ(h_xsql);
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_PIVOT', 219+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_PIVOT(220) : views_financial.sql(9152) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_PIVOT', 231+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_PIVOT(232) : views_financial.sql(9164) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BB_PIVOT;
ALTER FUNCTION SP_BB_PIVOT COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_FINANCIAL_VIEW ==
CREATE OR REPLACE FUNCTION SP_FINANCIAL_VIEW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_FINANCIAL_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_FINANCIAL_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_FINANCIAL_VIEW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_FINANCIAL_VIEW', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_FINANCIAL_VIEW(23) : views_financial.sql(9207) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FINANCIAL_VIEW', 30+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FINANCIAL_VIEW(31) : views_financial.sql(9215) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_FINANCIAL_VIEW', 42+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_FINANCIAL_VIEW(43) : views_financial.sql(9227) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_FINANCIAL_VIEW;
ALTER FUNCTION SP_FINANCIAL_VIEW COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_CUBE_BUDGETBREAKDOWN ==
CREATE OR REPLACE FUNCTION SP_CUBE_BUDGETBREAKDOWN
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CUBE_BUDGETBREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CUBE_BUDGETBREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := SP_CUBE_BUDGETBREAKDOWN(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CUBE_BUDGETBREAKDOWN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CUBE_BUDGETBREAKDOWN(23) : views_financial.sql(9270) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUDGETBREAKDOWN', 30+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUDGETBREAKDOWN(31) : views_financial.sql(9278) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CUBE_BUDGETBREAKDOWN', 42+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CUBE_BUDGETBREAKDOWN(43) : views_financial.sql(9290) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CUBE_BUDGETBREAKDOWN;
ALTER FUNCTION SP_CUBE_BUDGETBREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION SP_BB_CASHFLOW ==
CREATE OR REPLACE FUNCTION SP_BB_CASHFLOW
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CBBMONTH PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BB_CASHFLOW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BB_CASHFLOW'), '-- ' || SYSTIMESTAMP, ':r := SP_BB_CASHFLOW(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_CASHFLOW', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BB_CASHFLOW(37) : views_financial.sql(9347) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BB_CASHFLOW', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BB_CASHFLOW(42) : views_financial.sql(9352) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If p_start_date IS NULL Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   If p_finish_date IS NULL Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_ATTRIBUTES();
   h_temp_sc_state := FC_PIVOT_ATTRIBUTES();
   
   If (p_start_date IS NULL) AND (p_finish_date IS NULL) Then
      BEGIN
         SELECT  TO_DATE(SubStr(TO_CHAR(TO_CHAR(COALESCE(MIN(PBB.BUDGET_YEAR),1899))) || '-01-01', 1, 10)),
         TO_DATE(SubStr(TO_CHAR(TO_CHAR(COALESCE(MAX(PBB.BUDGET_YEAR),2100))) || '-12-31', 1, 10))
         INTO    h_start_date,
         h_finish_date
         FROM PMO_FINANCIAL_PROJECTS P
         JOIN PROJECT_BUDGET_BREAKDOWN PBB
         ON PBB.PROJECT_ID = P.ELEMENT_ID
         AND PBB.ELEMENT_ID = P.ELEMENT_ID;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_CASHFLOW', 82+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_CASHFLOW(83) : views_financial.sql(9393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   OPEN CBBMONTH FOR SELECT
   0 AS LEVEL_ID, W.TYPE_ID, P.RANK, W.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   W.CHILD_COUNT, W.DELETED_COUNT, W.REC_STATUS, W.REC_USER, W.REC_DATETIME,
   W.REF_CODE AS REFERNCE_CODE,
   W.PROBABILITY AS PURSUIT_PROBABILITY,
   R.FULL_NAME AS PROJECT_MANAGER,
   W.CURRENCY_ID AS PROJECT_CURRENCY_ID,
   PD.BUDGET_SETTING_BITS AS PROJECT_BUDGET_SETTING_BITS,
   PD.SCOPE_SCORE  ,
   PD.SCOPE_WEIGHT  ,
   PD.SCHEDULE_SCORE  ,
   PD.SCHEDULE_WEIGHT  ,
   PD.QUALITY_SCORE  ,
   PD.QUALITY_WEIGHT  ,
   PD.BENEFIT_SCORE  ,
   PD.BENEFIT_WEIGHT  ,
   PD.COST_SCORE  ,
   PD.COST_WEIGHT  ,
   W.START_FINISH_DATE AS PROJECT_START,
   W.FINISH_START_DATE AS PROJECT_FINISH,
   W.PRIORITY AS PROJECT_PRIORITY,
   W.STAGE_ID AS STAGE_ID,
   W.MILESTONE_PERCENT AS PROJECT_PERCENT_COMPLETE,
   CASE WHEN W.BASELINE1_EFFORT > 0 THEN ((W.WORK_TODATE*10000)/W.BASELINE1_EFFORT) ELSE 0 END AS PROJECT_PERCENT_SPENT,
   (CASE WHEN W.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(W.CONVERTED_SCORE,18,2)/W.CONVERTED_WEIGHT)*10000) ELSE 0 END) AS PROJECT_PUBLISHED_RATING,
   W.BUBBLE_COLOR AS PROJECT_PUBLISHED_COLOR,
   W.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   W.EXPECTED_PAYBACK_PERIOD,
   W.EXPECTED_PAYBACK_MONTH,
   W.ASSIGN_NAMES AS PROJECT_RESOURCES,
   (SELECT COUNT(C.ELEMENT_ID) FROM PROJECT_ASSIGNMENTS PA JOIN TMT_COMPETENCIES C ON C.RESOURCE_ID = PA.RESOURCE_ID AND C.STRATEGIC_FLAG = '1' WHERE PA.PROJECT_ID = W.ELEMENT_ID) AS PROJECT_STRATEGIC_RES,
   '' AS PROJECT_FISCAL_START,
   '' AS PROJECT_FISCAL_SHIFT,
   PMO_ORASTD.YEAR(h_finish_date) AS PROJECT_YEAR,
   0 AS PROJECT_YEAR_DISCOUNT_RATE,
   '' AS ASSOCIATED_CHARGECODE_NAME,
   '' AS CHARGECODE_ID,
   '' AS CHARGECODE_NAME,
   0 AS CHARGECODE_TYPE,
   '' AS CHARGECODE_DESCRIPTION, 
   0 AS BUDGET_TYPE,
   0 AS TIMEPHASED_FLAG,
   W.ESTIMATED_BASELINE1_BUDGET AS ESTIMATED_BASELINE1,
   W.ESTIMATED_BASELINE3_BUDGET AS ESTIMATED_BASELINE3,
   W.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   W.ESTIMATED_ACTUAL AS ESTIMATED_ACTUAL,
   W.ESTIMATED_ETC AS ESTIMATED_ETC,
   0.00 AS ESTIMATED_ETC_TOTAL,
   W.BASELINE1_BUDGET AS BUDGET_BASELINE1,
   W.BASELINE3_BUDGET AS BUDGET_BASELINE3,
   W.CURRENT_BUDGET AS BUDGET,
   W.ACTUAL_BUDGET AS ACTUAL,
   0.00 AS ETC,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES,
   '' AS EXPENSE_DATAFIELD1,
   '' AS EXPENSE_DATAFIELD2,
   '' AS CAPITAL_DATAFIELD1,
   '' AS CAPITAL_DATAFIELD2,
   '' AS EXP_CAP_DATAFIELD1,
   '' AS EXP_CAP_DATAFIELD2,
   '' AS BENEFIT_DATAFIELD1,
   '' AS BENEFIT_DATAFIELD2,
   0 AS BENEFIT_CC_PROBABILITY
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN PROJECT_DETAILS PD
   ON PD.PROJECT_ID = W.ELEMENT_ID
   JOIN RESOURCE_ASSIGNMENTS RA
   ON RA.PROJECT_ID = P.ELEMENT_ID
   AND RA.ELEMENT_ID = P.ELEMENT_ID
   AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER
   JOIN RESOURCES R
   ON R.RESOURCE_ID = RA.RESOURCE_ID
   LEFT JOIN PMO_FINANCIAL_PAT AT
   ON AT.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT
   1 AS LEVEL_ID, 31 AS TYPE_ID, RTRIM(P.RANK) || RTRIM(C.RANK) || '0000' AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   '' AS REFERNCE_CODE,
   0 AS PURSUIT_PROBABILITY,
   '' AS PROJECT_MANAGER,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING_BITS,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT  ,
   TO_DATE('1899-12-30') AS PROJECT_START,
   TO_DATE('1899-12-30') AS PROJECT_FINISH,
   0 AS PROJECT_PRIORITY,
   0 AS STAGE_ID,
   0 AS PROJECT_PERCENT_COMPLETE,
   0 AS PROJECT_PERCENT_SPENT,
   0 AS PROJECT_PUBLISHED_RATING,
   0 AS PROJECT_PUBLISHED_COLOR,
   '' AS PROJECT_CLIENT,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   '' AS PROJECT_RESOURCES,
   0 AS PROJECT_STRATEGIC_RES,
   '' AS PROJECT_FISCAL_START,
   '' AS PROJECT_FISCAL_SHIFT,
   0 AS PROJECT_YEAR,
   0 AS PROJECT_YEAR_DISCOUNT_RATE,
   '' AS ASSOCIATED_CHARGECODE_NAME,
   C.ELEMENT_ID AS CHARGECODE_ID,
   C.ELEMENT_NAME AS CHARGECODE_NAME,
   CASE WHEN C.CAPITAL_EXPENSE = 2 AND C.BILLABLE = 1 THEN 2 WHEN C.CAPITAL_EXPENSE = 2 AND C.BILLABLE = 0 THEN 3 ELSE C.CAPITAL_EXPENSE END AS CHARGECODE_TYPE,
   C.DESCRIPTION AS CHARGECODE_DESCRIPTION, 
   0 AS BUDGET_TYPE,
   CASE WHEN (SELECT COUNT(*) FROM PROJECT_BUDGET_BREAKDOWN WHERE PROJECT_ID = B.PROJECT_ID AND ELEMENT_ID = B.ELEMENT_ID AND CHARGECODE_ID = B.CHARGECODE_ID) > 0 THEN 1 ELSE 0 END AS TIMEPHASED_FLAG,
   B.ESTIMATED_BASELINE1,
   B.ESTIMATED_BASELINE3,
   B.ESTIMATED_BUDGET AS ESTIMATED_BUDGET,
   B.ESTIMATED_ACTUAL AS ESTIMATED_ACTUAL,
   B.ESTIMATED_ETC AS ESTIMATED_ETC,
   B.ESTIMATED_ETC_TOTAL,
   B.BUDGET_BASELINE1,
   B.BUDGET_BASELINE3,
   B.BUDGET,
   B.ACTUAL,
   B.ETC,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   CASE WHEN C.CAPITAL_EXPENSE = 0 THEN TO_CHAR(B.DATAFIELD_1) ELSE '' END AS EXPENSE_DATAFIELD1,
   CASE WHEN C.CAPITAL_EXPENSE = 0 THEN TO_CHAR(B.DATAFIELD_2) ELSE '' END AS EXPENSE_DATAFIELD2,
   CASE WHEN C.CAPITAL_EXPENSE = 1 THEN TO_CHAR(B.DATAFIELD_1) ELSE '' END AS CAPITAL_DATAFIELD1,
   CASE WHEN C.CAPITAL_EXPENSE = 1 THEN TO_CHAR(B.DATAFIELD_2) ELSE '' END AS CAPITAL_DATAFIELD2,
   CASE WHEN C.CAPITAL_EXPENSE < 2 THEN TO_CHAR(B.DATAFIELD_3) ELSE '' END AS EXP_CAP_DATAFIELD1,
   CASE WHEN C.CAPITAL_EXPENSE < 2 THEN TO_CHAR(B.DATAFIELD_4) ELSE '' END AS EXP_CAP_DATAFIELD2,
   CASE WHEN C.CAPITAL_EXPENSE = 2 THEN TO_CHAR(B.DATAFIELD_1) ELSE '' END AS BENEFIT_DATAFIELD1,
   CASE WHEN C.CAPITAL_EXPENSE = 2 THEN TO_CHAR(B.DATAFIELD_2) ELSE '' END AS BENEFIT_DATAFIELD2,
   CASE WHEN C.CAPITAL_EXPENSE = 2 THEN B.PROB_PERCENT ELSE 0 END AS BENEFIT_CC_PROBABILITY
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN BUDGETS B
   ON B.PROJECT_ID = P.ELEMENT_ID
   AND B.ELEMENT_ID = P.ELEMENT_ID
   AND B.CHARGECODE_ID NOT IN (
   'EXPENSE_HOURS',
   'EXPENSE_AVERAGE_COST',
   'EXPENSE_FULL_TIME_EQUIVALENT',
   'CAPITAL_HOURS',
   'CAPITAL_AVERAGE_COST',
   'CAPITAL_FULL_TIME_EQUIVALENT',
   'BENEFIT_HOURS',
   'BENEFIT_AVERAGE_RATE',
   'BENEFIT_FULL_TIME_EQUIVALENT',
   'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
   JOIN TMT_CHARGECODES C
   ON C.ELEMENT_ID = B.CHARGECODE_ID
   JOIN PROJECT_DETAILS PD
   ON PD.PROJECT_ID = B.PROJECT_ID
   
   UNION ALL
   
   SELECT
   1 AS LEVEL_ID, 31 AS TYPE_ID, RTRIM(P.RANK) || RTRIM(C.RANK) || TO_CHAR(PBB.BUDGET_YEAR) AS RANK, P.ELEMENT_ID AS PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, '' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-12-30 01:01:00') AS REC_DATETIME,
   '' AS REFERNCE_CODE,
   0 AS PURSUIT_PROBABILITY,
   '' AS PROJECT_MANAGER,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING_BITS,
   0 AS SCOPE_SCORE  ,
   0 AS SCOPE_WEIGHT  ,
   0 AS SCHEDULE_SCORE  ,
   0 AS SCHEDULE_WEIGHT  ,
   0 AS QUALITY_SCORE  ,
   0 AS QUALITY_WEIGHT  ,
   0 AS BENEFIT_SCORE  ,
   0 AS BENEFIT_WEIGHT  ,
   0 AS COST_SCORE  ,
   0 AS COST_WEIGHT  ,
   TO_DATE('1899-12-30') AS PROJECT_START,
   TO_DATE('1899-12-30') AS PROJECT_FINISH,
   0 AS PROJECT_PRIORITY,
   0 AS STAGE_ID,
   0 AS PROJECT_PERCENT_COMPLETE,
   0 AS PROJECT_PERCENT_SPENT,
   0 AS PROJECT_PUBLISHED_RATING,
   0 AS PROJECT_PUBLISHED_COLOR,
   '' AS PROJECT_CLIENT,
   0 AS EXPECTED_PAYBACK_PERIOD,
   0 AS EXPECTED_PAYBACK_MONTH,
   '' AS PROJECT_RESOURCES,
   0 AS PROJECT_STRATEGIC_RES,
   '' AS PROJECT_FISCAL_START,
   '' AS PROJECT_FISCAL_SHIFT,
   PBB.BUDGET_YEAR AS PROJECT_YEAR,
   COALESCE(PD.DISCOUNT_PERCENT, P.INIT_DISCOUNT_RATE) AS PROJECT_YEAR_DISCOUNT_RATE,
   AC.ELEMENT_NAME AS ASSOCIATED_CHARGECODE_NAME,
   C.ELEMENT_ID AS CHARGECODE_ID,
   C.ELEMENT_NAME AS CHARGECODE_NAME,
   CASE WHEN C.CAPITAL_EXPENSE = 2 AND C.BILLABLE = 1 THEN 2 WHEN C.CAPITAL_EXPENSE = 2 AND C.BILLABLE = 0 THEN 3 ELSE C.CAPITAL_EXPENSE END AS CHARGECODE_TYPE,
   C.DESCRIPTION AS CHARGECODE_DESCRIPTION, 
   PBB.BUDGET_TYPE,
   0 AS TIMEPHASED_FLAG,
   0.00 AS ESTIMATED_BASELINE1,
   0.00 AS ESTIMATED_BASELINE3,
   0.00 AS ESTIMATED_BUDGET,
   0.00 AS ESTIMATED_ACTUAL,
   0.00 AS ESTIMATED_ETC,
   0.00 AS ESTIMATED_ETC_TOTAL,
   0.00 AS BUDGET_BASELINE1,
   0.00 AS BUDGET_BASELINE3,
   0.00 AS BUDGET,
   0.00 AS ACTUAL,
   0.00 AS ETC,
   PBB.MONTH_01_AMOUNT AS AMOUNT_01,
   PBB.MONTH_02_AMOUNT AS AMOUNT_02,
   PBB.MONTH_03_AMOUNT AS AMOUNT_03,
   PBB.MONTH_04_AMOUNT AS AMOUNT_04,
   PBB.MONTH_05_AMOUNT AS AMOUNT_05,
   PBB.MONTH_06_AMOUNT AS AMOUNT_06,
   PBB.MONTH_07_AMOUNT AS AMOUNT_07,
   PBB.MONTH_08_AMOUNT AS AMOUNT_08,
   PBB.MONTH_09_AMOUNT AS AMOUNT_09,
   PBB.MONTH_10_AMOUNT AS AMOUNT_10,
   PBB.MONTH_11_AMOUNT AS AMOUNT_11,
   PBB.MONTH_12_AMOUNT AS AMOUNT_12,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES,
   '' AS EXPENSE_DATAFIELD1,
   '' AS EXPENSE_DATAFIELD2,
   '' AS CAPITAL_DATAFIELD1,
   '' AS CAPITAL_DATAFIELD2,
   '' AS EXP_CAP_DATAFIELD1,
   '' AS EXP_CAP_DATAFIELD2,
   '' AS BENEFIT_DATAFIELD1,
   '' AS BENEFIT_DATAFIELD2,
   0 AS BENEFIT_CC_PROBABILITY
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN BUDGETS B
   ON B.PROJECT_ID = P.ELEMENT_ID
   AND B.ELEMENT_ID = P.ELEMENT_ID
   AND B.CHARGECODE_ID NOT IN (
   'EXPENSE_HOURS',
   'EXPENSE_AVERAGE_COST',
   'EXPENSE_FULL_TIME_EQUIVALENT',
   'CAPITAL_HOURS',
   'CAPITAL_AVERAGE_COST',
   'CAPITAL_FULL_TIME_EQUIVALENT',
   'BENEFIT_HOURS',
   'BENEFIT_AVERAGE_RATE',
   'BENEFIT_FULL_TIME_EQUIVALENT',
   'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
   AND ( (B.BUDGET+B.ESTIMATED_BUDGET+B.ESTIMATED_ACTUAL+B.ESTIMATED_ETC) > 0.00 OR B.TIMEPHASED_FLAG <> 0 )
   JOIN PROJECT_BUDGET_BREAKDOWN PBB
   ON PBB.PROJECT_ID = B.PROJECT_ID
   AND PBB.ELEMENT_ID = B.ELEMENT_ID
   AND PBB.CHARGECODE_ID = B.CHARGECODE_ID
   AND PBB.BUDGET_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10))) AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
   AND PBB.BUDGET_TYPE NOT IN (PMO_CNST.SC_PAID_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
   JOIN TMT_CHARGECODES C
   ON C.ELEMENT_ID = PBB.CHARGECODE_ID
   LEFT JOIN TMT_CHARGECODES AC
   ON AC.ELEMENT_ID = C.ASSOCIATE_CHARGECODE_ID
   LEFT JOIN PROJECT_DISCOUNT PD
   ON PD.PROJECT_ID = P.ELEMENT_ID
   AND PMO_ORASTD.YEAR(PD.DISCOUNT_DATE) = PBB.BUDGET_YEAR
   
   ORDER BY RANK, CHARGECODE_NAME, CHARGECODE_TYPE, PROJECT_YEAR, BUDGET_TYPE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_CASHFLOW', 383+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_CASHFLOW(384) : views_financial.sql(9694) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CBBMONTH;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_CASHFLOW', 391+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_CASHFLOW(392) : views_financial.sql(9702) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_CASHFLOW', 403+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_CASHFLOW(404) : views_financial.sql(9714) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BB_CASHFLOW;
ALTER FUNCTION SP_BB_CASHFLOW COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_RESOURCES ==
CREATE OR REPLACE FUNCTION FC_INIT_RESOURCES RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_RESOURCES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RESOURCES', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_RESOURCES(9) : views_financial.sql(9739) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_RES';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_FINANCIAL_RES (
      PROJECT_ID,
      RESOURCE_NAME,
      RESOURCE_ROLE )
      SELECT  RA.PROJECT_ID,
      R.FULL_NAME,
      GS.ELEMENT_NAME
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = P.ELEMENT_ID
      AND RA.ELEMENT_ID = P.ELEMENT_ID
      AND RA.RESOURCE_TYPE = '0'
      JOIN RESOURCES R
      ON R.RESOURCE_ID = RA.RESOURCE_ID
      JOIN TMT_GLOBAL_SECURITY GS
      ON GS.ELEMENT_ID = RTRIM(RA.SECURITY_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RESOURCES', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RESOURCES(47) : views_financial.sql(9777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RESOURCES', 52+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RESOURCES(53) : views_financial.sql(9783) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_RESOURCES;
ALTER FUNCTION FC_INIT_RESOURCES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PIVOT_RESOURCES ==
CREATE OR REPLACE FUNCTION FC_PIVOT_RESOURCES RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPRES IS
         SELECT ELEMENT_ID
         FROM PMO_FINANCIAL_PROJECTS
         ORDER BY RANK;

      CURSOR CRES IS
         SELECT RTRIM(RESOURCE_NAME) || ' [' || RTRIM(RESOURCE_ROLE) || ']; '
         FROM PMO_FINANCIAL_RES
         WHERE PROJECT_ID = h_p_id
         AND LENGTH(RESOURCE_NAME) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PIVOT_RESOURCES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PIVOT_RESOURCES'), '-- ' || SYSTIMESTAMP, ':r := FC_PIVOT_RESOURCES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_RESOURCES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PIVOT_RESOURCES(24) : views_financial.sql(9817) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_FINANCIAL_AR';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPRES;
   
   LOOP
      FETCH CPRES INTO h_p_id;
      IF CPRES%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CRES;
      
      LOOP
         FETCH CRES INTO h_c_attr;
         IF CRES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CRES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RESOURCES', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RESOURCES(74) : views_financial.sql(9867) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_FINANCIAL_AR (
         PROJECT_ID,
         RESOURCES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RESOURCES', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RESOURCES(96) : views_financial.sql(9889) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPRES ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PIVOT_RESOURCES', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PIVOT_RESOURCES(110) : views_financial.sql(9903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PIVOT_RESOURCES', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PIVOT_RESOURCES(116) : views_financial.sql(9909) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PIVOT_RESOURCES;
ALTER FUNCTION FC_PIVOT_RESOURCES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PBB ==
CREATE OR REPLACE FUNCTION FC_INIT_PBB RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PBB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PBB'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PBB();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PBB', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PBB(9) : views_financial.sql(9928) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PROJECT_BB';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_PROJECT_BB
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      P.RANK,
      BB.BUDGET_YEAR,
      CASE
      WHEN CC.CAPITAL_EXPENSE = 2 AND CC.BILLABLE = 1 THEN 2
      WHEN CC.CAPITAL_EXPENSE = 2 AND CC.BILLABLE = 0 THEN 3
      ELSE CC.CAPITAL_EXPENSE
      END AS CAPITAL_EXPENSE,
      BB.BUDGET_TYPE,
      BB.MONTH_01_AMOUNT,
      BB.MONTH_02_AMOUNT,
      BB.MONTH_03_AMOUNT,
      BB.MONTH_04_AMOUNT,
      BB.MONTH_05_AMOUNT,
      BB.MONTH_06_AMOUNT,
      BB.MONTH_07_AMOUNT,
      BB.MONTH_08_AMOUNT,
      BB.MONTH_09_AMOUNT,
      BB.MONTH_10_AMOUNT,
      BB.MONTH_11_AMOUNT,
      BB.MONTH_12_AMOUNT
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN PROJECT_BUDGET_BREAKDOWN BB
      ON BB.PROJECT_ID = P.ELEMENT_ID
      AND BB.ELEMENT_ID = P.ELEMENT_ID
      AND BB.BUDGET_TYPE NOT IN (PMO_CNST.SC_PAID_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = BB.CHARGECODE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PBB', 59+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PBB(60) : views_financial.sql(9979) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PBB', 65+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PBB(66) : views_financial.sql(9985) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PBB;
ALTER FUNCTION FC_INIT_PBB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_SUM_PBB ==
CREATE OR REPLACE FUNCTION FC_SUM_PBB RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_SUM_PBB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_SUM_PBB'), '-- ' || SYSTIMESTAMP, ':r := FC_SUM_PBB();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SUM_PBB', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_SUM_PBB(9) : views_financial.sql(10004) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PROJECT_SBB';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --MONTH 01
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0001' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      1 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_01_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(80) : views_financial.sql(10075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 02
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0002' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      2 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_02_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(145) : views_financial.sql(10140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 03
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0003' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      3 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_03_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 209+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(210) : views_financial.sql(10205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 04
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0004' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      4 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_04_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 274+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(275) : views_financial.sql(10270) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 05
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0005' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      5 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_05_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 339+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(340) : views_financial.sql(10335) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 06
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0006' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      6 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_06_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 404+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(405) : views_financial.sql(10400) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 07
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0007' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      7 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_07_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 469+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(470) : views_financial.sql(10465) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 08
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0008' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      8 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_08_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 534+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(535) : views_financial.sql(10530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 09
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0009' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      9 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_09_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 599+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(600) : views_financial.sql(10595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 10
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0010' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      10 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_10_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 664+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(665) : views_financial.sql(10660) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 11
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0011' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      11 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_11_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 729+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(730) : views_financial.sql(10725) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --MONTH 12
   BEGIN
      INSERT INTO PMO_PROJECT_SBB
      SELECT
      BB.PROJECT_ID,
      BB.RANK || 'qqq1' || RTRIM(TO_CHAR(BB.BUDGET_YEAR)) || '0012' AS RANK,
      BB.BUDGET_YEAR AS BUDGET_YEAR,
      12 AS BUDGET_MONTH,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 1 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS C_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 0 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS E_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 2 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS B_SCHED_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 1 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 2 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_SCHED_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 3 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_EST_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 4 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_EST_ACTUAL_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 5 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 6 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 7 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_EST_BASELINE3_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 8 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE1_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 9 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE2_AMOUNT,
      SUM(CASE WHEN BB.CAPITAL_EXPENSE = 3 AND BB.BUDGET_TYPE = 10 THEN BB.MONTH_12_AMOUNT ELSE 0.00 END) AS S_SCHED_BASELINE3_AMOUNT
      FROM PMO_PROJECT_BB BB
      GROUP BY BB.RANK, BB.PROJECT_ID, BB.BUDGET_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_SUM_PBB', 794+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_SUM_PBB(795) : views_financial.sql(10790) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_SUM_PBB', 800+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_SUM_PBB(801) : views_financial.sql(10796) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_SUM_PBB;
ALTER FUNCTION FC_SUM_PBB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_ISS ==
CREATE OR REPLACE FUNCTION FC_INIT_ISS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_ISS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_ISS'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_ISS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_ISS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_ISS(9) : views_financial.sql(10815) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PROJECT_ISS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_PROJECT_ISS
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      COUNT(C.ELEMENT_ID) AS ISSUE_COUNT
      FROM PMO_FINANCIAL_PROJECTS P
      LEFT JOIN TMT_CRI C
      ON C.PROJECT_ID = P.ELEMENT_ID
      AND C.TYPE_ID = PMO_CNST.SC_ISSUE
      AND C.WBS_ID IS NULL
      AND C.CLOSED_DATETIME IS NULL
      GROUP BY P.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_ISS', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_ISS(41) : views_financial.sql(10847) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_ISS', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_ISS(47) : views_financial.sql(10853) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_ISS;
ALTER FUNCTION FC_INIT_ISS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_BB_MONTHLY_STATUS ==
CREATE OR REPLACE FUNCTION SP_BB_MONTHLY_STATUS
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CMSTATUS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_BB_MONTHLY_STATUS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_BB_MONTHLY_STATUS'), '-- ' || SYSTIMESTAMP, ':r := SP_BB_MONTHLY_STATUS(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_MONTHLY_STATUS', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_BB_MONTHLY_STATUS(37) : views_financial.sql(10900) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_BB_MONTHLY_STATUS', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_BB_MONTHLY_STATUS(42) : views_financial.sql(10905) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   
   h_temp_sc_state := FC_INIT_RESOURCES();
   h_temp_sc_state := FC_PIVOT_RESOURCES();
   
   h_temp_sc_state := FC_INIT_ISS();
   
   h_temp_sc_state := FC_INIT_PBB();
   h_temp_sc_state := FC_SUM_PBB();
   
   OPEN CMSTATUS FOR SELECT
   0 AS LEVEL_ID, 1 AS TYPE_ID, W.RANK, W.PARENT_ID, W.ELEMENT_ID, W.ELEMENT_NAME,
   W.CHILD_COUNT, W.DELETED_COUNT, W.REC_STATUS, W.REC_USER, W.REC_DATETIME,
   W.ELEMENT_ID AS PROJECT_ID,
   W.ELEMENT_NAME AS PROJECT_NAME,
   W.REF_CODE AS PROJECT_REFERENCE,
   RTRIM(AR.RESOURCES) AS PROJECT_RESOURCES,
   COALESCE(RTF01.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF01,
   COALESCE(RTF02.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF02,
   COALESCE(RTF03.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF03,
   COALESCE(RTF04.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF04,
   COALESCE(RTF05.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF05,
   COALESCE(RTF06.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF06,
   COALESCE(RTF07.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF07,
   COALESCE(RTF08.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF08,
   COALESCE(RTF09.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF09,
   COALESCE(RTF10.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF10,
   COALESCE(RTF11.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF11,
   COALESCE(RTF12.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF12,
   COALESCE(RTF13.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF13,
   COALESCE(RTF14.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF14,
   COALESCE(RTF15.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF15,
   COALESCE(RTF16.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF16,
   COALESCE(RTF17.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF17,
   COALESCE(RTF18.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF18,
   COALESCE(RTF19.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF19,
   COALESCE(RTF20.CLOB_DATA, (SELECT CLOB_DATA FROM EMPTYLOB)) AS PROJECT_RTF20,
   PIS.ISSUE_COUNT AS PENDING_ISSUES,
   W.VARIANCE AS SCHED_VARIANCE,
   CASE WHEN W.BASELINE1_BUDGET > 0 THEN (W.CURRENT_BUDGET - W.BASELINE1_BUDGET) ELSE 0 END AS ESTIMATED_BUDGET_VARIANCE,
   CASE WHEN W.ESTIMATED_BASELINE1_BUDGET > 0 THEN (W.ESTIMATION_BUDGET - W.ESTIMATED_BASELINE1_BUDGET) ELSE 0 END AS SCHEDULED_BUDGET_VARIANCE,
   '' AS PHASE_ID,
   '' AS PHASE_NAME,
   COALESCE(W.BASELINE1_START, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_BASELINE_START,
   COALESCE(W.BASELINE1_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_BASELINE_FINISH,
   COALESCE(W.UNRESOLVED_START, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_UNRESOLVED_START,
   COALESCE(W.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_UNRESOLVED_FINISH,
   W.MILESTONE_PERCENT AS PHASE_PERCENT_COMPLETE,
   (W.VARIANCE/W.MINUTE_PER_DAY) AS PHASE_VARIANCE_DAYS,
   0 AS BUDGET_YEAR,
   0 AS BUDGET_MONTH,
   0.00 AS C_ACTUAL_AMOUNT,
   0.00 AS C_SCHED_AMOUNT,
   0.00 AS C_EST_AMOUNT,
   0.00 AS C_EST_ACTUAL_AMOUNT,
   0.00 AS C_EST_BASELINE1_AMOUNT,
   0.00 AS C_EST_BASELINE2_AMOUNT,
   0.00 AS C_EST_BASELINE3_AMOUNT,
   0.00 AS C_SCHED_BASELINE1_AMOUNT,
   0.00 AS C_SCHED_BASELINE2_AMOUNT,
   0.00 AS C_SCHED_BASELINE3_AMOUNT,
   0.00 AS E_ACTUAL_AMOUNT,
   0.00 AS E_SCHED_AMOUNT,
   0.00 AS E_EST_AMOUNT,
   0.00 AS E_EST_ACTUAL_AMOUNT,
   0.00 AS E_EST_BASELINE1_AMOUNT,
   0.00 AS E_EST_BASELINE2_AMOUNT,
   0.00 AS E_EST_BASELINE3_AMOUNT,
   0.00 AS E_SCHED_BASELINE1_AMOUNT,
   0.00 AS E_SCHED_BASELINE2_AMOUNT,
   0.00 AS E_SCHED_BASELINE3_AMOUNT,
   0.00 AS B_ACTUAL_AMOUNT,
   0.00 AS B_SCHED_AMOUNT,
   0.00 AS B_EST_AMOUNT,
   0.00 AS B_EST_ACTUAL_AMOUNT,
   0.00 AS B_EST_BASELINE1_AMOUNT,
   0.00 AS B_EST_BASELINE2_AMOUNT,
   0.00 AS B_EST_BASELINE3_AMOUNT,
   0.00 AS B_SCHED_BASELINE1_AMOUNT,
   0.00 AS B_SCHED_BASELINE2_AMOUNT,
   0.00 AS B_SCHED_BASELINE3_AMOUNT,
   0.00 AS S_ACTUAL_AMOUNT,
   0.00 AS S_SCHED_AMOUNT,
   0.00 AS S_EST_AMOUNT,
   0.00 AS S_EST_ACTUAL_AMOUNT,
   0.00 AS S_EST_BASELINE1_AMOUNT,
   0.00 AS S_EST_BASELINE2_AMOUNT,
   0.00 AS S_EST_BASELINE3_AMOUNT,
   0.00 AS S_SCHED_BASELINE1_AMOUNT,
   0.00 AS S_SCHED_BASELINE2_AMOUNT,
   0.00 AS S_SCHED_BASELINE3_AMOUNT,
   '' AS SCORECARD_ID,
   0 AS SCORECARD_TYPE,
   '' AS SCORECARD_NAME,
   '' AS SCORECARD_VALUE,
   0 AS SCORECARD_SCORE,
   '' AS SCORECARD_COMMENT
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN PMO_FINANCIAL_AR AR ON AR.PROJECT_ID = P.ELEMENT_ID
   JOIN PMO_PROJECT_ISS PIS ON PIS.PROJECT_ID = P.ELEMENT_ID
   LEFT JOIN WBS_RTF RTF01 ON RTF01.PARENT_ID = W.ELEMENT_ID AND RTF01.ELEMENT_ID = W.ELEMENT_ID AND RTF01.BIT_FLAG = 1
   LEFT JOIN WBS_RTF RTF02 ON RTF02.PARENT_ID = W.ELEMENT_ID AND RTF02.ELEMENT_ID = W.ELEMENT_ID AND RTF02.BIT_FLAG = 2
   LEFT JOIN WBS_RTF RTF03 ON RTF03.PARENT_ID = W.ELEMENT_ID AND RTF03.ELEMENT_ID = W.ELEMENT_ID AND RTF03.BIT_FLAG = 4
   LEFT JOIN WBS_RTF RTF04 ON RTF04.PARENT_ID = W.ELEMENT_ID AND RTF04.ELEMENT_ID = W.ELEMENT_ID AND RTF04.BIT_FLAG = 8
   LEFT JOIN WBS_RTF RTF05 ON RTF05.PARENT_ID = W.ELEMENT_ID AND RTF05.ELEMENT_ID = W.ELEMENT_ID AND RTF05.BIT_FLAG = 16
   LEFT JOIN WBS_RTF RTF06 ON RTF06.PARENT_ID = W.ELEMENT_ID AND RTF06.ELEMENT_ID = W.ELEMENT_ID AND RTF06.BIT_FLAG = 32
   LEFT JOIN WBS_RTF RTF07 ON RTF07.PARENT_ID = W.ELEMENT_ID AND RTF07.ELEMENT_ID = W.ELEMENT_ID AND RTF07.BIT_FLAG = 64
   LEFT JOIN WBS_RTF RTF08 ON RTF08.PARENT_ID = W.ELEMENT_ID AND RTF08.ELEMENT_ID = W.ELEMENT_ID AND RTF08.BIT_FLAG = 128
   LEFT JOIN WBS_RTF RTF09 ON RTF09.PARENT_ID = W.ELEMENT_ID AND RTF09.ELEMENT_ID = W.ELEMENT_ID AND RTF09.BIT_FLAG = 256
   LEFT JOIN WBS_RTF RTF10 ON RTF10.PARENT_ID = W.ELEMENT_ID AND RTF10.ELEMENT_ID = W.ELEMENT_ID AND RTF10.BIT_FLAG = 512
   LEFT JOIN WBS_RTF RTF11 ON RTF11.PARENT_ID = W.ELEMENT_ID AND RTF11.ELEMENT_ID = W.ELEMENT_ID AND RTF11.BIT_FLAG = 1024
   LEFT JOIN WBS_RTF RTF12 ON RTF12.PARENT_ID = W.ELEMENT_ID AND RTF12.ELEMENT_ID = W.ELEMENT_ID AND RTF12.BIT_FLAG = 2048
   LEFT JOIN WBS_RTF RTF13 ON RTF13.PARENT_ID = W.ELEMENT_ID AND RTF13.ELEMENT_ID = W.ELEMENT_ID AND RTF13.BIT_FLAG = 4096
   LEFT JOIN WBS_RTF RTF14 ON RTF14.PARENT_ID = W.ELEMENT_ID AND RTF14.ELEMENT_ID = W.ELEMENT_ID AND RTF14.BIT_FLAG = 8192
   LEFT JOIN WBS_RTF RTF15 ON RTF15.PARENT_ID = W.ELEMENT_ID AND RTF15.ELEMENT_ID = W.ELEMENT_ID AND RTF15.BIT_FLAG = 16384
   LEFT JOIN WBS_RTF RTF16 ON RTF16.PARENT_ID = W.ELEMENT_ID AND RTF16.ELEMENT_ID = W.ELEMENT_ID AND RTF16.BIT_FLAG = 32768
   LEFT JOIN WBS_RTF RTF17 ON RTF17.PARENT_ID = W.ELEMENT_ID AND RTF17.ELEMENT_ID = W.ELEMENT_ID AND RTF17.BIT_FLAG = 65536
   LEFT JOIN WBS_RTF RTF18 ON RTF18.PARENT_ID = W.ELEMENT_ID AND RTF18.ELEMENT_ID = W.ELEMENT_ID AND RTF18.BIT_FLAG = 131072
   LEFT JOIN WBS_RTF RTF19 ON RTF19.PARENT_ID = W.ELEMENT_ID AND RTF19.ELEMENT_ID = W.ELEMENT_ID AND RTF19.BIT_FLAG = 262144
   LEFT JOIN WBS_RTF RTF20 ON RTF20.PARENT_ID = W.ELEMENT_ID AND RTF20.ELEMENT_ID = W.ELEMENT_ID AND RTF20.BIT_FLAG = 524288
   
   UNION ALL
   
   SELECT
   1 AS LEVEL_ID,
   CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_WORK_PRODUCT ELSE W.TYPE_ID END AS TYPE_ID,
   CASE WHEN W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN W.RANK || '0000' ELSE W.RANK END AS RANK,
   W.PARENT_ID, W.ELEMENT_ID, W.ELEMENT_NAME,
   W.CHILD_COUNT, W.DELETED_COUNT, W.REC_STATUS, W.REC_USER, W.REC_DATETIME,
   W.PROJECT_ID AS PROJECT_ID,
   '' AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF01,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF02,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF03,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF04,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF05,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF06,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF07,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF08,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF09,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF10,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF11,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF12,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF13,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF14,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF15,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF16,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF17,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF18,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF19,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF20,
   0 AS PENDING_ISSUES,
   0 AS SCHED_VARIANCE,
   0.00 AS ESTIMATED_BUDGET_VARIANCE,
   0.00 AS SCHEDULED_BUDGET_VARIANCE,
   W.ELEMENT_ID AS PHASE_ID,
   W.ELEMENT_NAME AS PHASE_NAME,
   COALESCE(W.BASELINE1_START, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_BASELINE_START,
   COALESCE(W.BASELINE1_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_BASELINE_FINISH,
   COALESCE(W.UNRESOLVED_START, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_UNRESOLVED_START,
   COALESCE(W.UNRESOLVED_FINISH, TO_TIMESTAMP('1899-01-01 12:00:00')) AS PHASE_UNRESOLVED_FINISH,
   W.MILESTONE_PERCENT AS PHASE_PERCENT_COMPLETE,
   (W.VARIANCE/W.MINUTE_PER_DAY) AS PHASE_VARIANCE_DAYS,
   0 AS BUDGET_YEAR,
   0 AS BUDGET_MONTH,
   0.00 AS C_ACTUAL_AMOUNT,
   0.00 AS C_SCHED_AMOUNT,
   0.00 AS C_EST_AMOUNT,
   0.00 AS C_EST_ACTUAL_AMOUNT,
   0.00 AS C_EST_BASELINE1_AMOUNT,
   0.00 AS C_EST_BASELINE2_AMOUNT,
   0.00 AS C_EST_BASELINE3_AMOUNT,
   0.00 AS C_SCHED_BASELINE1_AMOUNT,
   0.00 AS C_SCHED_BASELINE2_AMOUNT,
   0.00 AS C_SCHED_BASELINE3_AMOUNT,
   0.00 AS E_ACTUAL_AMOUNT,
   0.00 AS E_SCHED_AMOUNT,
   0.00 AS E_EST_AMOUNT,
   0.00 AS E_EST_ACTUAL_AMOUNT,
   0.00 AS E_EST_BASELINE1_AMOUNT,
   0.00 AS E_EST_BASELINE2_AMOUNT,
   0.00 AS E_EST_BASELINE3_AMOUNT,
   0.00 AS E_SCHED_BASELINE1_AMOUNT,
   0.00 AS E_SCHED_BASELINE2_AMOUNT,
   0.00 AS E_SCHED_BASELINE3_AMOUNT,
   0.00 AS B_ACTUAL_AMOUNT,
   0.00 AS B_SCHED_AMOUNT,
   0.00 AS B_EST_AMOUNT,
   0.00 AS B_EST_ACTUAL_AMOUNT,
   0.00 AS B_EST_BASELINE1_AMOUNT,
   0.00 AS B_EST_BASELINE2_AMOUNT,
   0.00 AS B_EST_BASELINE3_AMOUNT,
   0.00 AS B_SCHED_BASELINE1_AMOUNT,
   0.00 AS B_SCHED_BASELINE2_AMOUNT,
   0.00 AS B_SCHED_BASELINE3_AMOUNT,
   0.00 AS S_ACTUAL_AMOUNT,
   0.00 AS S_SCHED_AMOUNT,
   0.00 AS S_EST_AMOUNT,
   0.00 AS S_EST_ACTUAL_AMOUNT,
   0.00 AS S_EST_BASELINE1_AMOUNT,
   0.00 AS S_EST_BASELINE2_AMOUNT,
   0.00 AS S_EST_BASELINE3_AMOUNT,
   0.00 AS S_SCHED_BASELINE1_AMOUNT,
   0.00 AS S_SCHED_BASELINE2_AMOUNT,
   0.00 AS S_SCHED_BASELINE3_AMOUNT,
   '' AS SCORECARD_ID,
   0 AS SCORECARD_TYPE,
   '' AS SCORECARD_NAME,
   '' AS SCORECARD_VALUE,
   0 AS SCORECARD_SCORE,
   '' AS SCORECARD_COMMENT
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.PROJECT_ID = P.ELEMENT_ID
   AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_WORK_PRODUCT, PMO_CNST.SC_MILESTONE)
   AND W.MILESTONE_PERCENT < 10000
   
   UNION ALL
   
   SELECT
   1 AS LEVEL_ID, 8 AS TYPE_ID,
   BB.RANK,
   BB.PROJECT_ID AS PARENT_ID, BB.PROJECT_ID AS ELEMENT_ID, '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT, 0 AS DELETED_COUNT, 'U' AS REC_STATUS, '' AS REC_USER, TO_TIMESTAMP('1899-01-01 12:00:00') AS REC_DATETIME,
   BB.PROJECT_ID,
   '' AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF01,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF02,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF03,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF04,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF05,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF06,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF07,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF08,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF09,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF10,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF11,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF12,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF13,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF14,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF15,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF16,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF17,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF18,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF19,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF20,
   0 AS PENDING_ISSUES,
   0 AS SCHED_VARIANCE,
   0.00 AS ESTIMATED_BUDGET_VARIANCE,
   0.00 AS SCHEDULED_BUDGET_VARIANCE,
   '' AS PHASE_ID,
   '' AS PHASE_NAME,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_BASELINE_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_BASELINE_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_UNRESOLVED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_UNRESOLVED_FINISH,
   0 AS PHASE_PERCENT_COMPLETE,
   0 AS PHASE_VARIANCE_DAYS,
   
   BB.BUDGET_YEAR,
   BB.BUDGET_MONTH,
   BB.C_ACTUAL_AMOUNT,
   BB.C_SCHED_AMOUNT,
   BB.C_EST_AMOUNT,
   BB.C_EST_ACTUAL_AMOUNT,
   BB.C_EST_BASELINE1_AMOUNT,
   BB.C_EST_BASELINE2_AMOUNT,
   BB.C_EST_BASELINE3_AMOUNT,
   BB.C_SCHED_BASELINE1_AMOUNT,
   BB.C_SCHED_BASELINE2_AMOUNT,
   BB.C_SCHED_BASELINE3_AMOUNT,
   BB.E_ACTUAL_AMOUNT,
   BB.E_SCHED_AMOUNT,
   BB.E_EST_AMOUNT,
   BB.E_EST_ACTUAL_AMOUNT,
   BB.E_EST_BASELINE1_AMOUNT,
   BB.E_EST_BASELINE2_AMOUNT,
   BB.E_EST_BASELINE3_AMOUNT,
   BB.E_SCHED_BASELINE1_AMOUNT,
   BB.E_SCHED_BASELINE2_AMOUNT,
   BB.E_SCHED_BASELINE3_AMOUNT,
   BB.B_ACTUAL_AMOUNT,
   BB.B_SCHED_AMOUNT,
   BB.B_EST_AMOUNT,
   BB.B_EST_ACTUAL_AMOUNT,
   BB.B_EST_BASELINE1_AMOUNT,
   BB.B_EST_BASELINE2_AMOUNT,
   BB.B_EST_BASELINE3_AMOUNT,
   BB.B_SCHED_BASELINE1_AMOUNT,
   BB.B_SCHED_BASELINE2_AMOUNT,
   BB.B_SCHED_BASELINE3_AMOUNT,
   BB.S_ACTUAL_AMOUNT,
   BB.S_SCHED_AMOUNT,
   BB.S_EST_AMOUNT,
   BB.S_EST_ACTUAL_AMOUNT,
   BB.S_EST_BASELINE1_AMOUNT,
   BB.S_EST_BASELINE2_AMOUNT,
   BB.S_EST_BASELINE3_AMOUNT,
   BB.S_SCHED_BASELINE1_AMOUNT,
   BB.S_SCHED_BASELINE2_AMOUNT,
   BB.S_SCHED_BASELINE3_AMOUNT,
   '' AS SCORECARD_ID,
   0 AS SCORECARD_TYPE,
   '' AS SCORECARD_NAME,
   '' AS SCORECARD_VALUE,
   0 AS SCORECARD_SCORE,
   '' AS SCORECARD_COMMENT
   FROM PMO_PROJECT_SBB BB
   
   UNION ALL
   
   SELECT
   1 AS LEVEL_ID, S.TYPE_ID,
   RTRIM(W.RANK) || 'qqq2' || RTRIM(C.RANK) AS RANK,
   P.ELEMENT_ID AS PARENT_ID, S.ELEMENT_ID, S.ELEMENT_NAME,
   S.CHILD_COUNT, S.DELETED_COUNT, S.REC_STATUS, S.REC_USER, S.REC_DATETIME,
   P.ELEMENT_ID AS PROJECT_ID,
   '' AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF01,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF02,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF03,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF04,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF05,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF06,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF07,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF08,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF09,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF10,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF11,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF12,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF13,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF14,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF15,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF16,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF17,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF18,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF19,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF20,
   0 AS PENDING_ISSUES,
   0 AS SCHED_VARIANCE,
   0.00 AS ESTIMATED_BUDGET_VARIANCE,
   0.00 AS SCHEDULED_BUDGET_VARIANCE,
   '' AS PHASE_ID,
   '' AS PHASE_NAME,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_BASELINE_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_BASELINE_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_UNRESOLVED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_UNRESOLVED_FINISH,
   0 AS PHASE_PERCENT_COMPLETE,
   0 AS PHASE_VARIANCE_DAYS,
   0 AS BUDGET_YEAR,
   0 AS BUDGET_MONTH,
   0.00 AS C_ACTUAL_AMOUNT,
   0.00 AS C_SCHED_AMOUNT,
   0.00 AS C_EST_AMOUNT,
   0.00 AS C_EST_ACTUAL_AMOUNT,
   0.00 AS C_EST_BASELINE1_AMOUNT,
   0.00 AS C_EST_BASELINE2_AMOUNT,
   0.00 AS C_EST_BASELINE3_AMOUNT,
   0.00 AS C_SCHED_BASELINE1_AMOUNT,
   0.00 AS C_SCHED_BASELINE2_AMOUNT,
   0.00 AS C_SCHED_BASELINE3_AMOUNT,
   0.00 AS E_ACTUAL_AMOUNT,
   0.00 AS E_SCHED_AMOUNT,
   0.00 AS E_EST_AMOUNT,
   0.00 AS E_EST_ACTUAL_AMOUNT,
   0.00 AS E_EST_BASELINE1_AMOUNT,
   0.00 AS E_EST_BASELINE2_AMOUNT,
   0.00 AS E_EST_BASELINE3_AMOUNT,
   0.00 AS E_SCHED_BASELINE1_AMOUNT,
   0.00 AS E_SCHED_BASELINE2_AMOUNT,
   0.00 AS E_SCHED_BASELINE3_AMOUNT,
   0.00 AS B_ACTUAL_AMOUNT,
   0.00 AS B_SCHED_AMOUNT,
   0.00 AS B_EST_AMOUNT,
   0.00 AS B_EST_ACTUAL_AMOUNT,
   0.00 AS B_EST_BASELINE1_AMOUNT,
   0.00 AS B_EST_BASELINE2_AMOUNT,
   0.00 AS B_EST_BASELINE3_AMOUNT,
   0.00 AS B_SCHED_BASELINE1_AMOUNT,
   0.00 AS B_SCHED_BASELINE2_AMOUNT,
   0.00 AS B_SCHED_BASELINE3_AMOUNT,
   0.00 AS S_ACTUAL_AMOUNT,
   0.00 AS S_SCHED_AMOUNT,
   0.00 AS S_EST_AMOUNT,
   0.00 AS S_EST_ACTUAL_AMOUNT,
   0.00 AS S_EST_BASELINE1_AMOUNT,
   0.00 AS S_EST_BASELINE2_AMOUNT,
   0.00 AS S_EST_BASELINE3_AMOUNT,
   0.00 AS S_SCHED_BASELINE1_AMOUNT,
   0.00 AS S_SCHED_BASELINE2_AMOUNT,
   0.00 AS S_SCHED_BASELINE3_AMOUNT,
   C.ELEMENT_ID AS SCORECARD_ID,
   C.TYPE_ID AS SCORECARD_TYPE,
   C.ELEMENT_NAME AS SCORECARD_NAME,
   A.ELEMENT_NAME AS SCORECARD_VALUE,
   CASE WHEN C.CONVERTED_WEIGHT = 0 THEN 0 ELSE PMO_ORASTD.TODECIMAL(((PMO_ORASTD.TODECIMAL(C.CONVERTED_SCORE,18,2)/C.CONVERTED_WEIGHT)*100),18,2) END AS SCORECARD_SCORE,
   A.DESCRIPTION AS SCORECARD_COMMENT
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_ASSIGNED_SCORECARDS S
   ON S.PROJECT_ID = P.ELEMENT_ID
   AND S.PUBLISHED_DT IS NOT NULL
   AND S.TYPE_ID = PMO_CNST.SC_SCORECARD
   AND S.ACTIVE = '1'
   JOIN TMT_PUBLISHED_SCORECARDS C
   ON C.PROJECT_ID = S.PROJECT_ID
   AND C.SCORECARD_ID = S.ELEMENT_ID
   AND C.TYPE_ID NOT IN (145, 15)
   LEFT JOIN TMT_PUBLISHED_SCORECARDS A
   ON A.PROJECT_ID = C.PROJECT_ID
   AND A.SCORECARD_ID = C.SCORECARD_ID
   AND A.PARENT_ID = C.ELEMENT_ID
   AND A.SELECTED_ANSWER = 'Y'
   
   UNION ALL
   
   SELECT
   1 AS LEVEL_ID, A.TYPE_ID,
   RTRIM(W.RANK) || 'qqq3' || RTRIM(A.RANK) AS RANK,
   A.ELEMENT_ID AS PARENT_ID, A.ELEMENT_ID,
   CASE
   WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
   WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
   END || 
   RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
   GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
   RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13) AS ELEMENT_NAME,
   A.CHILD_COUNT, A.DELETED_COUNT, A.REC_STATUS, A.REC_USER, A.REC_DATETIME,
   PRJ.ELEMENT_ID AS PROJECT_ID,
   '' AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RESOURCES,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF01,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF02,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF03,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF04,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF05,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF06,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF07,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF08,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF09,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF10,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF11,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF12,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF13,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF14,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF15,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF16,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF17,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF18,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF19,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS PROJECT_RTF20,
   0 AS PENDING_ISSUES,
   0 AS SCHED_VARIANCE,
   0.00 AS ESTIMATED_BUDGET_VARIANCE,
   0.00 AS SCHEDULED_BUDGET_VARIANCE,
   '' AS PHASE_ID,
   '' AS PHASE_NAME,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_BASELINE_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_BASELINE_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_UNRESOLVED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS PHASE_UNRESOLVED_FINISH,
   0 AS PHASE_PERCENT_COMPLETE,
   0 AS PHASE_VARIANCE_DAYS,
   0 AS BUDGET_YEAR,
   0 AS BUDGET_MONTH,
   0.00 AS C_ACTUAL_AMOUNT,
   0.00 AS C_SCHED_AMOUNT,
   0.00 AS C_EST_AMOUNT,
   0.00 AS C_EST_ACTUAL_AMOUNT,
   0.00 AS C_EST_BASELINE1_AMOUNT,
   0.00 AS C_EST_BASELINE2_AMOUNT,
   0.00 AS C_EST_BASELINE3_AMOUNT,
   0.00 AS C_SCHED_BASELINE1_AMOUNT,
   0.00 AS C_SCHED_BASELINE2_AMOUNT,
   0.00 AS C_SCHED_BASELINE3_AMOUNT,
   0.00 AS E_ACTUAL_AMOUNT,
   0.00 AS E_SCHED_AMOUNT,
   0.00 AS E_EST_AMOUNT,
   0.00 AS E_EST_ACTUAL_AMOUNT,
   0.00 AS E_EST_BASELINE1_AMOUNT,
   0.00 AS E_EST_BASELINE2_AMOUNT,
   0.00 AS E_EST_BASELINE3_AMOUNT,
   0.00 AS E_SCHED_BASELINE1_AMOUNT,
   0.00 AS E_SCHED_BASELINE2_AMOUNT,
   0.00 AS E_SCHED_BASELINE3_AMOUNT,
   0.00 AS B_ACTUAL_AMOUNT,
   0.00 AS B_SCHED_AMOUNT,
   0.00 AS B_EST_AMOUNT,
   0.00 AS B_EST_ACTUAL_AMOUNT,
   0.00 AS B_EST_BASELINE1_AMOUNT,
   0.00 AS B_EST_BASELINE2_AMOUNT,
   0.00 AS B_EST_BASELINE3_AMOUNT,
   0.00 AS B_SCHED_BASELINE1_AMOUNT,
   0.00 AS B_SCHED_BASELINE2_AMOUNT,
   0.00 AS B_SCHED_BASELINE3_AMOUNT,
   0.00 AS S_ACTUAL_AMOUNT,
   0.00 AS S_SCHED_AMOUNT,
   0.00 AS S_EST_AMOUNT,
   0.00 AS S_EST_ACTUAL_AMOUNT,
   0.00 AS S_EST_BASELINE1_AMOUNT,
   0.00 AS S_EST_BASELINE2_AMOUNT,
   0.00 AS S_EST_BASELINE3_AMOUNT,
   0.00 AS S_SCHED_BASELINE1_AMOUNT,
   0.00 AS S_SCHED_BASELINE2_AMOUNT,
   0.00 AS S_SCHED_BASELINE3_AMOUNT,
   '' AS SCORECARD_ID,
   0 AS SCORECARD_TYPE,
   '' AS SCORECARD_NAME,
   '' AS SCORECARD_VALUE,
   0 AS SCORECARD_SCORE,
   '' AS SCORECARD_COMMENT
   FROM PMO_FINANCIAL_PROJECTS PRJ
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = PRJ.ELEMENT_ID
   JOIN TMT_WBS_ATTRIBUTES P
   ON P.ELEMENT_ID = W.ELEMENT_ID
   JOIN TMT_WBS_ATTRIBUTES A
   ON A.ELEMENT_ID = P.PARENT_ID
   AND A.TYPE_ID = 144
   JOIN TMT_WBS_ATTRIBUTES PA
   ON PA.ELEMENT_ID = A.PARENT_ID
   JOIN TMT_WBS_ATTRIBUTES GPA
   ON GPA.ELEMENT_ID = PA.PARENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_BB_MONTHLY_STATUS', 591+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_BB_MONTHLY_STATUS(592) : views_financial.sql(11455) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CMSTATUS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_MONTHLY_STATUS', 599+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_MONTHLY_STATUS(600) : views_financial.sql(11463) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_BB_MONTHLY_STATUS', 611+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_BB_MONTHLY_STATUS(612) : views_financial.sql(11475) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_BB_MONTHLY_STATUS;
ALTER FUNCTION SP_BB_MONTHLY_STATUS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_TASK_SCHEDULE ==
CREATE OR REPLACE FUNCTION SP_TASK_SCHEDULE
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CTSCHERESULT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TASK_SCHEDULE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TASK_SCHEDULE'), '-- ' || SYSTIMESTAMP, ':r := SP_TASK_SCHEDULE(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TASK_SCHEDULE', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TASK_SCHEDULE(38) : views_financial.sql(11529) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TASK_SCHEDULE', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TASK_SCHEDULE(43) : views_financial.sql(11534) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_SINGLE_ATTR();
   h_temp_sc_state := FC_PIVOT_ATTRIBUTES();
   
   --=====================================================================
   --Temporary code
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --  BEGIN_SQL
   --      DECLARE GLOBAL TEMPORARY TABLE PMO_PORTFOLIO_ATTR (
   --          PROJECT_ID      CHAR(32),
   --          ATTRIBUTE_ID        CHAR(32),
   --          ATTRIBUTE_NAME      VARCHAR(255)
   --      ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED IN USRTS32K;
   --  END_SQL;
   --=====================================================================
   
   --obtain "Portfolio" category' rank
   --  BEGIN_SQL
   --      SELECT RTRIM(RANK) INTO HOST(h_rank)
   --      FROM TMT_WBS_ATTRIBUTES
   --      WHERE UPPER(ELEMENT_NAME) = 'PORTFOLIO';
   --  END_SQL_CHECK;
   
   --  if( SC_SUCCESS )
   --  {
   --      //get project_id, attribute_id pair under the rank
   --      BEGIN_SQL
   --          INSERT INTO session.PMO_PORTFOLIO_ATTR (PROJECT_ID, ATTRIBUTE_ID, ATTRIBUTE_NAME)
   --          SELECT PA.ELEMENT_ID, PAP.PARENT_ID, PAP.ELEMENT_NAME
   --          FROM session.PMO_FINANCIAL_PROJECTS P
   --          JOIN TMT_WBS_ATTRIBUTES PA
   --              ON PA.ELEMENT_ID = P.PROJECT_ID
   --              AND PA.RANK LIKE HOST(h_rank) || '%'
   --          JOIN TMT_WBS_ATTRIBUTES PAP
   --              ON PAP.ELEMENT_ID = PA.PARENT_ID;
   --      END_SQL_CHECK;
   --  }
   
   OPEN CTSCHERESULT FOR SELECT  0 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   '' AS PORTFOLIO_ID,
   '' AS PORTFOLIO_NAME,
   W.ELEMENT_ID AS PROJECT_ID,
   W.ELEMENT_NAME AS PROJECT_NAME,
   W.REF_CODE AS PROJECT_REFERENCE,
   SUBSTR( W.ASSIGN_NAMES, 1, InStr( W.ASSIGN_NAMES, ';' ) - 1 ) AS PROJECT_MANAGER,
   T.BASELINE1_START AS START_BASELINE_L,
   T.UNRESOLVED_START AS START_UNRESOLVED,
   T.ACTUAL_START AS START_ACTUAL,
   T.BASELINE1_FINISH AS FINISH_BASELINE_L,
   T.UNRESOLVED_FINISH AS FINISH_UNRESOLVED,
   T.ACTUAL_FINISH AS FINISH_ACTUAL,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_WBS T
   ON T.PROJECT_ID = P.ELEMENT_ID
   AND T.TYPE_ID IN (  PMO_CNST.SC_TASK,
   PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,
   PMO_CNST.SC_WBS_ACTION_ITEM_TASK,
   PMO_CNST.SC_WBS_RISK_TASK,
   PMO_CNST.SC_WBS_ISSUE_TASK,
   PMO_CNST.SC_WBS_REQUIREMENT_TASK,
   PMO_CNST.SC_WBS_DEFECT_TASK,
   PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK )
   LEFT JOIN PMO_FINANCIAL_PAT AT
   ON AT.PROJECT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TASK_SCHEDULE', 129+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TASK_SCHEDULE(130) : views_financial.sql(11621) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CTSCHERESULT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_SCHEDULE', 137+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_SCHEDULE(138) : views_financial.sql(11629) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TASK_SCHEDULE', 149+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TASK_SCHEDULE(150) : views_financial.sql(11641) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TASK_SCHEDULE;
ALTER FUNCTION SP_TASK_SCHEDULE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_MILESTONE_SCHEDULE ==
CREATE OR REPLACE FUNCTION SP_MILESTONE_SCHEDULE
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CMSCHERESULT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_MILESTONE_SCHEDULE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_MILESTONE_SCHEDULE'), '-- ' || SYSTIMESTAMP, ':r := SP_MILESTONE_SCHEDULE(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MILESTONE_SCHEDULE', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_MILESTONE_SCHEDULE(38) : views_financial.sql(11695) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_MILESTONE_SCHEDULE', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_MILESTONE_SCHEDULE(43) : views_financial.sql(11700) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_SINGLE_ATTR();
   h_temp_sc_state := FC_PIVOT_ATTRIBUTES();
   
   --Temporary code
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   --  BEGIN_SQL
   --      DECLARE GLOBAL TEMPORARY TABLE PMO_PORTFOLIO_ATTR (
   --          PROJECT_ID      CHAR(32),
   --          ATTRIBUTE_ID        CHAR(32),
   --          ATTRIBUTE_NAME      VARCHAR(255)
   --      ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED IN USRTS32K;
   --  END_SQL;
   --=====================================================================
   
   --obtain "Portfolio" category' rank
   --  BEGIN_SQL
   --      SELECT RTRIM(RANK) INTO HOST(h_rank)
   --      FROM TMT_WBS_ATTRIBUTES
   --      WHERE UPPER(ELEMENT_NAME) = 'PORTFOLIO';
   --  END_SQL_CHECK;
   
   --  if( SC_SUCCESS )
   --  {
   --      //get project_id, attribute_id pair under the rank
   --      BEGIN_SQL
   --          INSERT INTO session.PMO_PORTFOLIO_ATTR (PROJECT_ID, ATTRIBUTE_ID, ATTRIBUTE_NAME)
   --          SELECT PA.ELEMENT_ID, PAP.PARENT_ID, PAP.ELEMENT_NAME
   --          FROM session.PMO_FINANCIAL_PROJECTS P
   --          JOIN TMT_WBS_ATTRIBUTES PA
   --              ON PA.ELEMENT_ID = P.PROJECT_ID
   --              AND PA.RANK LIKE HOST(h_rank) || '%'
   --          JOIN TMT_WBS_ATTRIBUTES PAP
   --              ON PAP.ELEMENT_ID = PA.PARENT_ID;
   --      END_SQL_CHECK;
   --  }
   
   OPEN CMSCHERESULT FOR SELECT
   0 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER, T.REC_DATETIME,
   '' AS PORTFOLIO_ID,
   '' AS PORTFOLIO_NAME,
   W.ELEMENT_ID AS PROJECT_ID,
   W.ELEMENT_NAME AS PROJECT_NAME,
   W.REF_CODE AS PROJECT_REFERENCE,
   SUBSTR( W.ASSIGN_NAMES, 1, InStr( W.ASSIGN_NAMES, ';' ) - 1 ) AS PROJECT_MANAGER,
   T.BASELINE1_START AS START_BASELINE_L,
   T.UNRESOLVED_START AS START_UNRESOLVED,
   T.ACTUAL_START AS START_ACTUAL,
   T.BASELINE1_FINISH AS FINISH_BASELINE_L,
   T.UNRESOLVED_FINISH AS FINISH_UNRESOLVED,
   T.ACTUAL_FINISH AS FINISH_ACTUAL,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN TMT_WBS T
   ON T.PROJECT_ID = P.ELEMENT_ID
   AND T.TYPE_ID = PMO_CNST.SC_MILESTONE
   LEFT JOIN PMO_FINANCIAL_PAT AT
   ON AT.PROJECT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_MILESTONE_SCHEDULE', 122+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_MILESTONE_SCHEDULE(123) : views_financial.sql(11780) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CMSCHERESULT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MILESTONE_SCHEDULE', 130+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MILESTONE_SCHEDULE(131) : views_financial.sql(11788) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_MILESTONE_SCHEDULE', 142+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_MILESTONE_SCHEDULE(143) : views_financial.sql(11800) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_MILESTONE_SCHEDULE;
ALTER FUNCTION SP_MILESTONE_SCHEDULE COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_COSTS ==
CREATE OR REPLACE FUNCTION FC_INIT_COSTS RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_COSTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_COSTS'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_COSTS();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_COSTS', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_COSTS(9) : views_financial.sql(11825) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_COSTS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Populate the list of chargecodes
   BEGIN
      INSERT INTO PMO_COSTS (
      PROJECT_ID,
      RANK,
      CHARGECODE_ID,
      CHARGECODE_NAME,
      CHARGECODE_TYPE,
      TIMEPHASED_FLAG,
      ESTIMATED_BASELINE1,
      ESTIMATED_BASELINE3,
      ESTIMATED_BUDGET,
      ESTIMATED_ACTUAL,
      ESTIMATED_ETC,
      BUDGET_BASELINE1,
      BUDGET_BASELINE3,
      BUDGET,
      ACTUAL,
      ETC,
      DATAFIELD_1,
      DATAFIELD_2,
      DATAFIELD_3,
      DATAFIELD_4 )
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      C.RANK,
      C.ELEMENT_ID AS CHARGECODE_ID,
      C.ELEMENT_NAME AS CHARGECODE_NAME,
      C.CAPITAL_EXPENSE AS CHARGECODE_TYPE,
      CASE WHEN (SELECT COUNT(*) FROM PROJECT_BUDGET_BREAKDOWN WHERE PROJECT_ID = B.PROJECT_ID AND ELEMENT_ID = B.ELEMENT_ID AND CHARGECODE_ID = B.CHARGECODE_ID) > 0 THEN 1 ELSE 0 END AS TIMEPHASED_FLAG,
      B.ESTIMATED_BASELINE1,
      B.ESTIMATED_BASELINE3,
      B.ESTIMATED_BUDGET,
      B.ESTIMATED_ACTUAL,
      B.ESTIMATED_ETC,
      B.BUDGET_BASELINE1,
      B.BUDGET_BASELINE3,
      B.BUDGET,
      B.ACTUAL,
      B.ETC,
      B.DATAFIELD_1,
      B.DATAFIELD_2,
      B.DATAFIELD_3,
      B.DATAFIELD_4
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ELEMENT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES C
      ON C.ELEMENT_ID = B.CHARGECODE_ID
      AND C.RANK > '0000'
      AND C.CAPITAL_EXPENSE < 2
      WHERE EXISTS(SELECT PROJECT_ID FROM PROJECT_COSTBACK WHERE PROJECT_ID = P.ELEMENT_ID)
      
      UNION ALL
      
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      C.RANK,
      C.ELEMENT_ID AS CHARGECODE_ID,
      C.ELEMENT_NAME AS CHARGECODE_NAME,
      2 AS CHARGECODE_TYPE,
      CASE WHEN (SELECT COUNT(*) FROM PROJECT_BUDGET_BREAKDOWN WHERE PROJECT_ID = B.PROJECT_ID AND ELEMENT_ID = B.ELEMENT_ID AND CHARGECODE_ID = B.CHARGECODE_ID) > 0 THEN 1 ELSE 0 END AS TIMEPHASED_FLAG,
      B.ESTIMATED_BASELINE1,
      B.ESTIMATED_BASELINE3,
      B.ESTIMATED_BUDGET,
      B.ESTIMATED_ACTUAL,
      B.ESTIMATED_ETC,
      B.BUDGET_BASELINE1,
      B.BUDGET_BASELINE3,
      B.BUDGET,
      B.ACTUAL,
      B.ETC,
      B.DATAFIELD_1,
      B.DATAFIELD_2,
      B.DATAFIELD_3,
      B.DATAFIELD_4
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ELEMENT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES C
      ON C.ELEMENT_ID = B.CHARGECODE_ID
      AND C.RANK < '0000'
      AND C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR')
      WHERE EXISTS(SELECT PROJECT_ID FROM PROJECT_COSTBACK WHERE PROJECT_ID = P.ELEMENT_ID);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_COSTS', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_COSTS(114) : views_financial.sql(11930) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_COSTS', 120+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_COSTS(121) : views_financial.sql(11937) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_COSTS;
ALTER FUNCTION FC_INIT_COSTS COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PROJECT_COST ==
CREATE OR REPLACE FUNCTION FC_PROJECT_COST RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PROJECT_COST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PROJECT_COST'), '-- ' || SYSTIMESTAMP, ':r := FC_PROJECT_COST();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PROJECT_COST', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PROJECT_COST(9) : views_financial.sql(11956) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PROJECT_COSTS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --Populate the list of chargecodes
   BEGIN
      INSERT INTO PMO_PROJECT_COSTS (
      PROJECT_ID,
      ESTIMATED_EXPENSE,
      SCHEDULED_EXPENSE,
      ESTIMATED_CAPITAL,
      SCHEDULED_CAPITAL,
      ESTIMATED_LABOR,
      SCHEDULED_LABOR,
      B1_ESTIMATED_EXPENSE,
      B1_SCHEDULED_EXPENSE,
      B1_ESTIMATED_CAPITAL,
      B1_SCHEDULED_CAPITAL,
      B1_ESTIMATED_LABOR,
      B1_SCHEDULED_LABOR,
      B3_ESTIMATED_EXPENSE,
      B3_SCHEDULED_EXPENSE,
      B3_ESTIMATED_CAPITAL,
      B3_SCHEDULED_CAPITAL,
      B3_ESTIMATED_LABOR,
      B3_SCHEDULED_LABOR )
      SELECT  PROJECT_ID,
      SUM(ESTIMATED_BUDGET*(CASE WHEN CHARGECODE_TYPE = 0 THEN 1 ELSE 0 END)) AS ESTIMATED_EXPENSE,
      SUM(BUDGET*(CASE WHEN CHARGECODE_TYPE = 0 THEN 1 ELSE 0 END)) AS SCHEDULED_EXPENSE,
      SUM(ESTIMATED_BUDGET*(CASE WHEN CHARGECODE_TYPE = 1 THEN 1 ELSE 0 END)) AS ESTIMATED_CAPITAL,
      SUM(BUDGET*(CASE WHEN CHARGECODE_TYPE = 1 THEN 1 ELSE 0 END)) AS SCHEDULED_CAPITAL,
      SUM(ESTIMATED_BUDGET*(CASE WHEN CHARGECODE_TYPE = 2 THEN 1 ELSE 0 END)) AS ESTIMATED_LABOR,
      SUM(BUDGET*(CASE WHEN CHARGECODE_TYPE = 2 THEN 1 ELSE 0 END)) AS SCHEDULED_LABOR,
      SUM(ESTIMATED_BASELINE1*(CASE WHEN CHARGECODE_TYPE = 0 THEN 1 ELSE 0 END)) AS B1_ESTIMATED_EXPENSE,
      SUM(BUDGET_BASELINE1*(CASE WHEN CHARGECODE_TYPE = 0 THEN 1 ELSE 0 END)) AS B1_SCHEDULED_EXPENSE,
      SUM(ESTIMATED_BASELINE1*(CASE WHEN CHARGECODE_TYPE = 1 THEN 1 ELSE 0 END)) AS B1_ESTIMATED_CAPITAL,
      SUM(BUDGET_BASELINE1*(CASE WHEN CHARGECODE_TYPE = 1 THEN 1 ELSE 0 END)) AS B1_SCHEDULED_CAPITAL,
      SUM(ESTIMATED_BASELINE1*(CASE WHEN CHARGECODE_TYPE = 2 THEN 1 ELSE 0 END)) AS B1_ESTIMATED_LABOR,
      SUM(BUDGET_BASELINE1*(CASE WHEN CHARGECODE_TYPE = 2 THEN 1 ELSE 0 END)) AS B1_SCHEDULED_LABOR,
      SUM(ESTIMATED_BASELINE3*(CASE WHEN CHARGECODE_TYPE = 0 THEN 1 ELSE 0 END)) AS B3_ESTIMATED_EXPENSE,
      SUM(BUDGET_BASELINE3*(CASE WHEN CHARGECODE_TYPE = 0 THEN 1 ELSE 0 END)) AS B3_SCHEDULED_EXPENSE,
      SUM(ESTIMATED_BASELINE3*(CASE WHEN CHARGECODE_TYPE = 1 THEN 1 ELSE 0 END)) AS B3_ESTIMATED_CAPITAL,
      SUM(BUDGET_BASELINE3*(CASE WHEN CHARGECODE_TYPE = 1 THEN 1 ELSE 0 END)) AS B3_SCHEDULED_CAPITAL,
      SUM(ESTIMATED_BASELINE3*(CASE WHEN CHARGECODE_TYPE = 2 THEN 1 ELSE 0 END)) AS B3_ESTIMATED_LABOR,
      SUM(BUDGET_BASELINE3*(CASE WHEN CHARGECODE_TYPE = 2 THEN 1 ELSE 0 END)) AS B3_SCHEDULED_LABOR
      FROM PMO_COSTS
      GROUP BY PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PROJECT_COST', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PROJECT_COST(73) : views_financial.sql(12020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PROJECT_COST', 79+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PROJECT_COST(80) : views_financial.sql(12027) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PROJECT_COST;
ALTER FUNCTION FC_PROJECT_COST COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_COST_CENTERS_PIVOT ==
CREATE OR REPLACE FUNCTION SP_COST_CENTERS_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CCPRESULT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_COST_CENTERS_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_COST_CENTERS_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_COST_CENTERS_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_CENTERS_PIVOT', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_COST_CENTERS_PIVOT(38) : views_financial.sql(12075) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_COST_CENTERS_PIVOT', 42+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_COST_CENTERS_PIVOT(43) : views_financial.sql(12080) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   If p_start_date IS NULL Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   If p_finish_date IS NULL Then
      h_finish_date := '2100-12-31';
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_COSTS();
   h_temp_sc_state := FC_PROJECT_COST();
   
   OPEN CCPRESULT FOR SELECT  0 AS LEVEL_ID,
   W.TYPE_ID,
   RTRIM(W.RANK) AS RANK,
   W.PARENT_ID,
   W.ELEMENT_ID,
   W.ELEMENT_NAME,
   W.CHILD_COUNT,
   W.DELETED_COUNT,
   W.REC_STATUS,
   W.REC_USER,
   W.REC_DATETIME,
   
   W.ELEMENT_ID AS PROJECT_ID,
   W.ELEMENT_NAME AS PROJECT_NAME,
   W.REF_CODE AS PROJECT_REFERENCE,
   W.PRIORITY AS PROJECT_PRIORITY,
   W.STAGE_ID AS PROJECT_RANK,
   W.CURRENCY_ID AS PROJECT_CURRENCY_ID,
   PD.BUDGET_SETTING_BITS AS PROJECT_BUDGET_SETTING,
   SUBSTR( W.ASSIGN_NAMES, 1, InStr( W.ASSIGN_NAMES, ';' ) - 1 ) AS PROJECT_MANAGER,
   
   PTC.ESTIMATED_EXPENSE AS SUM_EXPENSE_ESTIMATED,
   PTC.SCHEDULED_EXPENSE AS SUM_EXPENSE_SCHEDULED,
   PTC.ESTIMATED_CAPITAL AS SUM_CAPITAL_ESTIMATED,
   PTC.SCHEDULED_CAPITAL AS SUM_CAPITAL_SCHEDULED,
   PTC.ESTIMATED_LABOR AS SUM_LABOR_ESTIMATED,
   PTC.SCHEDULED_LABOR AS SUM_LABOR_SCHEDULED,
   
   PTC.B3_ESTIMATED_EXPENSE AS SUM_EXPENSE_EST_BASELINE_I,
   PTC.B3_SCHEDULED_EXPENSE AS SUM_EXPENSE_SCH_BASELINE_I,
   PTC.B3_ESTIMATED_CAPITAL AS SUM_CAPITAL_EST_BASELINE_I,
   PTC.B3_SCHEDULED_CAPITAL AS SUM_CAPITAL_SCH_BASELINE_I,
   PTC.B3_ESTIMATED_LABOR AS SUM_LABOR_EST_BASELINE_I,
   PTC.B3_SCHEDULED_LABOR AS SUM_LABOR_SCH_BASELINE_I,
   
   PTC.B1_ESTIMATED_EXPENSE AS SUM_EXPENSE_EST_BASELINE_L,
   PTC.B1_SCHEDULED_EXPENSE AS SUM_EXPENSE_SCH_BASELINE_L,
   PTC.B1_ESTIMATED_CAPITAL AS SUM_CAPITAL_EST_BASELINE_L,
   PTC.B1_SCHEDULED_CAPITAL AS SUM_CAPITAL_SCH_BASELINE_L,
   PTC.B1_ESTIMATED_LABOR AS SUM_LABOR_EST_BASELINE_L,
   PTC.B1_SCHEDULED_LABOR AS SUM_LABOR_SCH_BASELINE_L,
   
   0 AS CC_LABOR_USE_COST,
   0 AS CC_LABOR_PERCENT,
   0.00 AS CC_LABOR_COST,
   0.00 AS CC_LABOR_COST_BASELINE_I,
   0.00 AS CC_LABOR_COST_BASELINE_L,
   0 AS CC_EXPENSE_USE_COST,
   0 AS CC_EXPENSE_PERCENT,
   0.00 AS CC_EXPENSE_COST,
   0.00 AS CC_EXPENSE_COST_BASELINE_I,
   0.00 AS CC_EXPENSE_COST_BASELINE_L,
   0 AS CC_CAPITAL_USE_COST,
   0 AS CC_CAPITAL_PERCENT,
   0.00 AS CC_CAPITAL_COST,
   0.00 AS CC_CAPITAL_COST_BASELINE_I,
   0.00 AS CC_CAPITAL_COST_BASELINE_L,
   
   0 AS CHARGECODE_TYPE,
   0 AS TIMEPHASED_FLAG,
   0.00 AS COST_EST_BASELINE_L,
   0.00 AS COST_EST_BASELINE_I,
   0.00 AS COST_EST_ESTIMATED,
   0.00 AS COST_EST_ACTUAL,
   0.00 AS COST_EST_ETC,
   0.00 AS COST_SCH_BASELINE_L,
   0.00 AS COST_SCH_BASELINE_I,
   0.00 AS COST_SCH_SCHEDULED,
   0.00 AS COST_SCH_ACTUAL,
   0.00 AS COST_SCH_ETC,
   
   0 AS BUDGET_YEAR,
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   
   '' AS EXPENSE_DATAFIELD1,
   '' AS EXPENSE_DATAFIELD2,
   '' AS CAPITAL_DATAFIELD1,
   '' AS CAPITAL_DATAFIELD2,
   '' AS EXP_CAP_DATAFIELD1,
   '' AS EXP_CAP_DATAFIELD2
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN PROJECT_DETAILS PD
   ON PD.PROJECT_ID = W.ELEMENT_ID
   JOIN PMO_PROJECT_COSTS PTC
   ON PTC.PROJECT_ID = W.ELEMENT_ID
   
   UNION ALL
   
   SELECT  1 AS LEVEL_ID,
   264 AS TYPE_ID,
   RTRIM(P.RANK) || '    ' || RTRIM(TCC.RANK) AS RANK,
   P.ELEMENT_ID AS PARENT_ID,
   TCC.ELEMENT_ID,
   TCC.ELEMENT_NAME,
   TCC.CHILD_COUNT,
   TCC.DELETED_COUNT,
   TCC.REC_STATUS,
   TCC.REC_USER,
   TCC.REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   '' AS PROJECT_MANAGER,
   
   0.00 AS SUM_EXPENSE_ESTIMATED,
   0.00 AS SUM_EXPENSE_SCHEDULED,
   0.00 AS SUM_CAPITAL_ESTIMATED,
   0.00 AS SUM_CAPITAL_SCHEDULED,
   0.00 AS SUM_LABOR_ESTIMATED,
   0.00 AS SUM_LABOR_SCHEDULED,
   
   0.00 AS SUM_EXPENSE_EST_BASELINE_I,
   0.00 AS SUM_EXPENSE_SCH_BASELINE_I,
   0.00 AS SUM_CAPITAL_EST_BASELINE_I,
   0.00 AS SUM_CAPITAL_SCH_BASELINE_I,
   0.00 AS SUM_LABOR_EST_BASELINE_I,
   0.00 AS SUM_LABOR_SCH_BASELINE_I,
   
   0.00 AS SUM_EXPENSE_EST_BASELINE_L,
   0.00 AS SUM_EXPENSE_SCH_BASELINE_L,
   0.00 AS SUM_CAPITAL_EST_BASELINE_L,
   0.00 AS SUM_CAPITAL_SCH_BASELINE_L,
   0.00 AS SUM_LABOR_EST_BASELINE_L,
   0.00 AS SUM_LABOR_SCH_BASELINE_L,
   
   PCB.LABOR_FLAG AS CC_LABOR_USE_COST,
   PCB.LABOR_PERCENT AS CC_LABOR_PERCENT,
   PCB.LABOR_AMOUNT AS CC_LABOR_COST,
   PCB.BASELINE3_LABOR_AMOUNT AS CC_LABOR_COST_BASELINE_I,
   PCB.BASELINE1_LABOR_AMOUNT AS CC_LABOR_COST_BASELINE_L,
   PCB.EXPENSE_FLAG AS CC_EXPENSE_USE_COST,
   PCB.EXPENSE_PERCENT AS CC_EXPENSE_PERCENT,
   PCB.EXPENSE_AMOUNT AS CC_EXPENSE_COST,
   PCB.BASELINE3_EXPENSE_AMOUNT AS CC_EXPENSE_COST_BASELINE_I,
   PCB.BASELINE1_EXPENSE_AMOUNT AS CC_EXPENSE_COST_BASELINE_L,
   PCB.CAPITAL_FLAG AS CC_CAPITAL_USE_COST,
   PCB.CAPITAL_PERCENT AS CC_CAPITAL_PERCENT,
   PCB.CAPITAL_AMOUNT AS CC_CAPITAL_COST,
   PCB.BASELINE3_CAPITAL_AMOUNT AS CC_CAPITAL_COST_BASELINE_I,
   PCB.BASELINE1_CAPITAL_AMOUNT AS CC_CAPITAL_COST_BASELINE_L,
   
   0 AS CHARGECODE_TYPE,
   0 AS TIMEPHASED_FLAG,
   0.00 AS COST_EST_BASELINE_L,
   0.00 AS COST_EST_BASELINE_I,
   0.00 AS COST_EST_ESTIMATED,
   0.00 AS COST_EST_ACTUAL,
   0.00 AS COST_EST_ETC,
   0.00 AS COST_SCH_BASELINE_L,
   0.00 AS COST_SCH_BASELINE_I,
   0.00 AS COST_SCH_SCHEDULED,
   0.00 AS COST_SCH_ACTUAL,
   0.00 AS COST_SCH_ETC,
   
   0 AS BUDGET_YEAR,
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   
   '' AS EXPENSE_DATAFIELD1,
   '' AS EXPENSE_DATAFIELD2,
   '' AS CAPITAL_DATAFIELD1,
   '' AS CAPITAL_DATAFIELD2,
   '' AS EXP_CAP_DATAFIELD1,
   '' AS EXP_CAP_DATAFIELD2
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN PMO_PROJECT_COSTS PTC
   ON PTC.PROJECT_ID = P.ELEMENT_ID
   JOIN PROJECT_COSTBACK PCB
   ON PCB.PROJECT_ID = P.ELEMENT_ID
   JOIN TMT_COST_CENTERS TCC
   ON TCC.ELEMENT_ID = PCB.COST_CENTER_ID
   
   UNION ALL
   
   SELECT  2 AS LEVEL_ID,
   8 AS TYPE_ID,
   RTRIM(P.RANK) || RTRIM(CC.RANK) AS RANK,
   P.ELEMENT_ID AS PARENT_ID,
   CC.CHARGECODE_ID AS ELEMENT_ID,
   CC.CHARGECODE_NAME AS ELEMENT_NAME,
   0 AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   'U' AS REC_STATUS,
   '' AS REC_USER,
   SYSTIMESTAMP AS REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   '' AS PROJECT_MANAGER,
   
   0.00 AS SUM_EXPENSE_ESTIMATED,
   0.00 AS SUM_EXPENSE_SCHEDULED,
   0.00 AS SUM_CAPITAL_ESTIMATED,
   0.00 AS SUM_CAPITAL_SCHEDULED,
   0.00 AS SUM_LABOR_ESTIMATED,
   0.00 AS SUM_LABOR_SCHEDULED,
   
   0.00 AS SUM_EXPENSE_EST_BASELINE_I,
   0.00 AS SUM_EXPENSE_SCH_BASELINE_I,
   0.00 AS SUM_CAPITAL_EST_BASELINE_I,
   0.00 AS SUM_CAPITAL_SCH_BASELINE_I,
   0.00 AS SUM_LABOR_EST_BASELINE_I,
   0.00 AS SUM_LABOR_SCH_BASELINE_I,
   
   0.00 AS SUM_EXPENSE_EST_BASELINE_L,
   0.00 AS SUM_EXPENSE_SCH_BASELINE_L,
   0.00 AS SUM_CAPITAL_EST_BASELINE_L,
   0.00 AS SUM_CAPITAL_SCH_BASELINE_L,
   0.00 AS SUM_LABOR_EST_BASELINE_L,
   0.00 AS SUM_LABOR_SCH_BASELINE_L,
   
   0 AS CC_LABOR_USE_COST,
   0 AS CC_LABOR_PERCENT,
   0.00 AS CC_LABOR_COST,
   0.00 AS CC_LABOR_COST_BASELINE_I,
   0.00 AS CC_LABOR_COST_BASELINE_L,
   0 AS CC_EXPENSE_USE_COST,
   0 AS CC_EXPENSE_PERCENT,
   0.00 AS CC_EXPENSE_COST,
   0.00 AS CC_EXPENSE_COST_BASELINE_I,
   0.00 AS CC_EXPENSE_COST_BASELINE_L,
   0 AS CC_CAPITAL_USE_COST,
   0 AS CC_CAPITAL_PERCENT,
   0.00 AS CC_CAPITAL_COST,
   0.00 AS CC_CAPITAL_COST_BASELINE_I,
   0.00 AS CC_CAPITAL_COST_BASELINE_L,
   
   CC.CHARGECODE_TYPE,
   CC.TIMEPHASED_FLAG,
   CC.ESTIMATED_BASELINE1 AS COST_EST_BASELINE_L,
   CC.ESTIMATED_BASELINE3 AS COST_EST_BASELINE_I,
   CC.ESTIMATED_BUDGET AS COST_EST_ESTIMATED,
   CC.ESTIMATED_ACTUAL AS COST_EST_ACTUAL,
   CC.ESTIMATED_ETC AS COST_EST_ETC,
   CC.BUDGET_BASELINE1 AS COST_SCH_BASELINE_L,
   CC.BUDGET_BASELINE3 AS COST_SCH_BASELINE_I,
   CC.BUDGET AS COST_SCH_SCHEDULED,
   CC.ACTUAL AS COST_SCH_ACTUAL,
   CC.ETC AS COST_SCH_ETC,
   
   -1 AS BUDGET_YEAR,
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   
   CASE WHEN CC.CHARGECODE_TYPE = 0 OR CC.CHARGECODE_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR') THEN TO_CHAR(CC.DATAFIELD_1) ELSE '' END AS EXPENSE_DATAFIELD1,
   CASE WHEN CC.CHARGECODE_TYPE = 0 OR CC.CHARGECODE_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR') THEN TO_CHAR(CC.DATAFIELD_2) ELSE '' END AS EXPENSE_DATAFIELD2,
   CASE WHEN CC.CHARGECODE_TYPE = 1 OR CC.CHARGECODE_ID IN ('CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR') THEN TO_CHAR(CC.DATAFIELD_1) ELSE '' END AS CAPITAL_DATAFIELD1,
   CASE WHEN CC.CHARGECODE_TYPE = 1 OR CC.CHARGECODE_ID IN ('CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR') THEN TO_CHAR(CC.DATAFIELD_2) ELSE '' END AS CAPITAL_DATAFIELD2,
   TO_CHAR(CC.DATAFIELD_3) AS EXP_CAP_DATAFIELD1,
   TO_CHAR(CC.DATAFIELD_4) AS EXP_CAP_DATAFIELD2
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN PMO_COSTS CC
   ON CC.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  3 AS LEVEL_ID,
   31 AS TYPE_ID,
   RTRIM(P.RANK) || RTRIM(CC.RANK) || RTRIM(TO_CHAR(PBB.BUDGET_YEAR)) || RTRIM(TO_CHAR(PBB.BUDGET_TYPE)) AS RANK,
   P.ELEMENT_ID AS PARENT_ID,
   CC.ELEMENT_ID AS ELEMENT_ID,
   CC.ELEMENT_NAME AS ELEMENT_NAME,
   0 AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   'U' AS REC_STATUS,
   '' AS REC_USER,
   SYSTIMESTAMP AS REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   '' AS PROJECT_MANAGER,
   
   0.00 AS SUM_EXPENSE_ESTIMATED,
   0.00 AS SUM_EXPENSE_SCHEDULED,
   0.00 AS SUM_CAPITAL_ESTIMATED,
   0.00 AS SUM_CAPITAL_SCHEDULED,
   0.00 AS SUM_LABOR_ESTIMATED,
   0.00 AS SUM_LABOR_SCHEDULED,
   
   0.00 AS SUM_EXPENSE_EST_BASELINE_I,
   0.00 AS SUM_EXPENSE_SCH_BASELINE_I,
   0.00 AS SUM_CAPITAL_EST_BASELINE_I,
   0.00 AS SUM_CAPITAL_SCH_BASELINE_I,
   0.00 AS SUM_LABOR_EST_BASELINE_I,
   0.00 AS SUM_LABOR_SCH_BASELINE_I,
   
   0.00 AS SUM_EXPENSE_EST_BASELINE_L,
   0.00 AS SUM_EXPENSE_SCH_BASELINE_L,
   0.00 AS SUM_CAPITAL_EST_BASELINE_L,
   0.00 AS SUM_CAPITAL_SCH_BASELINE_L,
   0.00 AS SUM_LABOR_EST_BASELINE_L,
   0.00 AS SUM_LABOR_SCH_BASELINE_L,
   
   0 AS CC_LABOR_USE_COST,
   0 AS CC_LABOR_PERCENT,
   0.00 AS CC_LABOR_COST,
   0.00 AS CC_LABOR_COST_BASELINE_I,
   0.00 AS CC_LABOR_COST_BASELINE_L,
   0 AS CC_EXPENSE_USE_COST,
   0 AS CC_EXPENSE_PERCENT,
   0.00 AS CC_EXPENSE_COST,
   0.00 AS CC_EXPENSE_COST_BASELINE_I,
   0.00 AS CC_EXPENSE_COST_BASELINE_L,
   0 AS CC_CAPITAL_USE_COST,
   0 AS CC_CAPITAL_PERCENT,
   0.00 AS CC_CAPITAL_COST,
   0.00 AS CC_CAPITAL_COST_BASELINE_I,
   0.00 AS CC_CAPITAL_COST_BASELINE_L,
   
   CASE WHEN CC.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR') THEN 2 ELSE CC.CAPITAL_EXPENSE END AS CHARGECODE_TYPE,
   1 AS TIMEPHASED_FLAG,
   0.00 AS COST_EST_BASELINE_L,
   0.00 AS COST_EST_BASELINE_I,
   0.00 AS COST_EST_ESTIMATED,
   0.00 AS COST_EST_ACTUAL,
   0.00 AS COST_EST_ETC,
   0.00 AS COST_SCH_BASELINE_L,
   0.00 AS COST_SCH_BASELINE_I,
   0.00 AS COST_SCH_SCHEDULED,
   0.00 AS COST_SCH_ACTUAL,
   0.00 AS COST_SCH_ETC,
   
   PBB.BUDGET_YEAR,
   PBB.BUDGET_TYPE,
   PBB.MONTH_01_AMOUNT AS AMOUNT_01,
   PBB.MONTH_02_AMOUNT AS AMOUNT_02,
   PBB.MONTH_03_AMOUNT AS AMOUNT_03,
   PBB.MONTH_04_AMOUNT AS AMOUNT_04,
   PBB.MONTH_05_AMOUNT AS AMOUNT_05,
   PBB.MONTH_06_AMOUNT AS AMOUNT_06,
   PBB.MONTH_07_AMOUNT AS AMOUNT_07,
   PBB.MONTH_08_AMOUNT AS AMOUNT_08,
   PBB.MONTH_09_AMOUNT AS AMOUNT_09,
   PBB.MONTH_10_AMOUNT AS AMOUNT_10,
   PBB.MONTH_11_AMOUNT AS AMOUNT_11,
   PBB.MONTH_12_AMOUNT AS AMOUNT_12,
   
   '' AS EXPENSE_DATAFIELD1,
   '' AS EXPENSE_DATAFIELD2,
   '' AS CAPITAL_DATAFIELD1,
   '' AS CAPITAL_DATAFIELD2,
   '' AS EXP_CAP_DATAFIELD1,
   '' AS EXP_CAP_DATAFIELD2
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN PROJECT_BUDGET_BREAKDOWN PBB
   ON PBB.PROJECT_ID = P.ELEMENT_ID
   AND PBB.ELEMENT_ID = P.ELEMENT_ID
   AND PBB.BUDGET_YEAR BETWEEN PMO_ORASTD.YEAR(TO_DATE(SubStr(h_start_date, 1, 10))) AND PMO_ORASTD.YEAR(TO_DATE(SubStr(h_finish_date, 1, 10)))
   AND PBB.BUDGET_TYPE NOT IN (PMO_CNST.SC_PAID_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
   JOIN TMT_CHARGECODES CC
   ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
   AND CC.CAPITAL_EXPENSE < 2
   AND CC.ELEMENT_ID NOT IN (
   'EXPENSE_HOURS',
   'EXPENSE_AVERAGE_COST',
   'EXPENSE_FULL_TIME_EQUIVALENT',
   'CAPITAL_HOURS',
   'CAPITAL_AVERAGE_COST',
   'CAPITAL_FULL_TIME_EQUIVALENT',
   'BENEFIT_HOURS',
   'BENEFIT_AVERAGE_RATE',
   'BENEFIT_FULL_TIME_EQUIVALENT',
   'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_COST_CENTERS_PIVOT', 488+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_COST_CENTERS_PIVOT(489) : views_financial.sql(12526) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CCPRESULT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_CENTERS_PIVOT', 496+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_CENTERS_PIVOT(497) : views_financial.sql(12534) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_COST_CENTERS_PIVOT', 508+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_COST_CENTERS_PIVOT(509) : views_financial.sql(12546) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_COST_CENTERS_PIVOT;
ALTER FUNCTION SP_COST_CENTERS_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_BENEFIT ==
CREATE OR REPLACE FUNCTION FC_INIT_BENEFIT RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_BENEFIT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_BENEFIT'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_BENEFIT();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BENEFIT', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_BENEFIT(9) : views_financial.sql(12571) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_BENEFITS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_BENEFITS (
      PROJECT_ID,
      TOTAL_FORMULA,
      CHARGEBACK_FORMULA,
      ESTIMATED_COST,
      ESTIMATED_REVENUE,
      ESTIMATED_SAVING,
      ESTIMATED_ACTUAL_COST,
      ESTIMATED_ACTUAL_REVENUE,
      ESTIMATED_ACTUAL_SAVING,
      ESTIMATED_ETC_COST,
      ESTIMATED_ETC_REVENUE,
      ESTIMATED_ETC_SAVING,
      SCHEDULED_COST,
      SCHEDULED_REVENUE,
      SCHEDULED_SAVING,
      ACTUAL_COST,
      ACTUAL_REVENUE,
      ACTUAL_SAVING,
      ETC_COST,
      ETC_REVENUE,
      ETC_SAVING )
      SELECT  P.ELEMENT_ID,
      PD.BUDGET_SETTING_BITS,
      PD.CHARGEBACK_FORMULA,
      SUM(B.ESTIMATED_BUDGET*ABS(SIGN(C.CAPITAL_EXPENSE-2))),
      SUM(B.ESTIMATED_BUDGET*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*C.BILLABLE),
      SUM(B.ESTIMATED_BUDGET*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*ABS(SIGN(C.BILLABLE-1))),
      SUM(B.ESTIMATED_ACTUAL*ABS(SIGN(C.CAPITAL_EXPENSE-2))),
      SUM(B.ESTIMATED_ACTUAL*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*C.BILLABLE),
      SUM(B.ESTIMATED_ACTUAL*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*ABS(SIGN(C.BILLABLE-1))),
      SUM(B.ESTIMATED_ETC*ABS(SIGN(C.CAPITAL_EXPENSE-2))),
      SUM(B.ESTIMATED_ETC*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*C.BILLABLE),
      SUM(B.ESTIMATED_ETC*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*ABS(SIGN(C.BILLABLE-1))),
      SUM(B.BUDGET*ABS(SIGN(C.CAPITAL_EXPENSE-2))),
      SUM(B.BUDGET*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*C.BILLABLE),
      SUM(B.BUDGET*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*ABS(SIGN(C.BILLABLE-1))),
      SUM(B.ACTUAL*ABS(SIGN(C.CAPITAL_EXPENSE-2))),
      SUM(B.ACTUAL*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*C.BILLABLE),
      SUM(B.ACTUAL*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*ABS(SIGN(C.BILLABLE-1))),
      SUM(B.ETC*ABS(SIGN(C.CAPITAL_EXPENSE-2))),
      SUM(B.ETC*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*C.BILLABLE),
      SUM(B.ETC*(1-ABS(SIGN(C.CAPITAL_EXPENSE-2)))*ABS(SIGN(C.BILLABLE-1)))
      FROM PMO_FINANCIAL_PROJECTS P
      JOIN PROJECT_DETAILS PD
      ON PD.PROJECT_ID = P.ELEMENT_ID
      JOIN BUDGETS B
      ON B.PROJECT_ID = P.ELEMENT_ID
      AND B.ELEMENT_ID = P.ELEMENT_ID
      JOIN TMT_CHARGECODES C
      ON C.ELEMENT_ID = B.CHARGECODE_ID
      AND C.ELEMENT_ID NOT IN (
      'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' )
      GROUP BY P.ELEMENT_ID, PD.BUDGET_SETTING_BITS, PD.CHARGEBACK_FORMULA;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_BENEFIT', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_BENEFIT(94) : views_financial.sql(12656) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_BENEFIT', 100+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_BENEFIT(101) : views_financial.sql(12663) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_BENEFIT;
ALTER FUNCTION FC_INIT_BENEFIT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_CHARGEBACK_BREAKDOWN ==
CREATE OR REPLACE FUNCTION FC_INIT_CHARGEBACK_BREAKDOWN RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_CHARGEBACK_BREAKDOWN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_CHARGEBACK_BREAKDOWN'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_CHARGEBACK_BREAKDOWN();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CHARGEBACK_BREAKDOWN', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_CHARGEBACK_BREAKDOWN(9) : views_financial.sql(12682) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_CHARGEBACK_BREAKDOWN';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_CHARGEBACK_BREAKDOWN (
      PROJECT_ID,
      CHARGEBACK_FORMULA,
      CLIENT_ID,
      CLIENT_NAME,
      CLIENT_RANK,
      ENTRY_YEAR,
      ENTRY_TYPE,
      CHARGECODE_TYPE,
      AMOUNT_01,
      AMOUNT_02,
      AMOUNT_03,
      AMOUNT_04,
      AMOUNT_05,
      AMOUNT_06,
      AMOUNT_07,
      AMOUNT_08,
      AMOUNT_09,
      AMOUNT_10,
      AMOUNT_11,
      AMOUNT_12 )
      SELECT  PB.PROJECT_ID,
      PB.CHARGEBACK_FORMULA,
      C.ELEMENT_ID,
      C.ELEMENT_NAME,
      C.RANK,
      PCC.ENTRY_YEAR,
      CASE
      WHEN PCC.ENTRY_TYPE = 0 THEN 3
      WHEN PCC.ENTRY_TYPE = 1 THEN 4
      WHEN PCC.ENTRY_TYPE = 2 THEN 5
      WHEN PCC.ENTRY_TYPE = 3 THEN 6
      WHEN PCC.ENTRY_TYPE = 4 THEN 7
      END AS ENTRY_TYPE,
      CASE
      WHEN PB.CHARGEBACK_FORMULA = 3 THEN 0
      WHEN PB.CHARGEBACK_FORMULA = 2 THEN 2
      WHEN PB.CHARGEBACK_FORMULA = 1 THEN 2
      WHEN PB.CHARGEBACK_FORMULA = 0 THEN 3
      END AS CHARGECODE_TYPE,
      SUM(PCC.MONTH_01_AMOUNT) AS AMOUNT_01,
      SUM(PCC.MONTH_02_AMOUNT) AS AMOUNT_02,
      SUM(PCC.MONTH_03_AMOUNT) AS AMOUNT_03,
      SUM(PCC.MONTH_04_AMOUNT) AS AMOUNT_04,
      SUM(PCC.MONTH_05_AMOUNT) AS AMOUNT_05,
      SUM(PCC.MONTH_06_AMOUNT) AS AMOUNT_06,
      SUM(PCC.MONTH_07_AMOUNT) AS AMOUNT_07,
      SUM(PCC.MONTH_08_AMOUNT) AS AMOUNT_08,
      SUM(PCC.MONTH_09_AMOUNT) AS AMOUNT_09,
      SUM(PCC.MONTH_10_AMOUNT) AS AMOUNT_10,
      SUM(PCC.MONTH_11_AMOUNT) AS AMOUNT_11,
      SUM(PCC.MONTH_12_AMOUNT) AS AMOUNT_12
      FROM PMO_BENEFITS PB
      JOIN PROJECT_CHARGEBACK PC
      ON PC.PROJECT_ID = PB.PROJECT_ID
      JOIN TMT_CLIENTS C
      ON C.ELEMENT_ID = PC.CLIENT_ID
      JOIN PROJECT_CHARGEBACK_BREAKDOWN PCC
      ON PCC.PROJECT_ID = PB.PROJECT_ID
      AND PCC.CLIENT_ID = C.ELEMENT_ID
      GROUP BY PB.PROJECT_ID,
      PB.CHARGEBACK_FORMULA,
      C.ELEMENT_ID,
      C.ELEMENT_NAME,
      C.RANK,
      PCC.ENTRY_YEAR,
      PCC.ENTRY_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_CHARGEBACK_BREAKDOWN', 97+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_CHARGEBACK_BREAKDOWN(98) : views_financial.sql(12771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_CHARGEBACK_BREAKDOWN', 104+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_CHARGEBACK_BREAKDOWN(105) : views_financial.sql(12778) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_CHARGEBACK_BREAKDOWN;
ALTER FUNCTION FC_INIT_CHARGEBACK_BREAKDOWN COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_CHARGEBACK_PIVOT ==
CREATE OR REPLACE FUNCTION SP_CHARGEBACK_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_chargeback_formula PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CBPRESULT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_CHARGEBACK_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_CHARGEBACK_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_CHARGEBACK_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHARGEBACK_PIVOT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_CHARGEBACK_PIVOT(39) : views_financial.sql(12827) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_CHARGEBACK_PIVOT', 43+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_CHARGEBACK_PIVOT(44) : views_financial.sql(12832) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   null_return := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   null_return := FC_INIT_BENEFIT();
   null_return := FC_INIT_CHARGEBACK_BREAKDOWN();
   
   /* Fiancial Formula
       0: Non-Billable
       1: Billable
       2: Non-Billable/Billable
       3: By Cost
   */
   /* Budget Type
       0: Capital/Expense
       2: Non-Billable
       3: Billable
       4: Non-Billable/Billable
   */
   
   OPEN CBPRESULT FOR SELECT  0 AS LEVEL_ID,
   W.TYPE_ID,
   RTRIM(W.RANK) AS RANK,
   W.PARENT_ID,
   W.ELEMENT_ID,
   W.ELEMENT_NAME,
   W.CHILD_COUNT,
   W.DELETED_COUNT,
   W.REC_STATUS,
   W.REC_USER,
   W.REC_DATETIME,
   
   W.ELEMENT_ID AS PROJECT_ID,
   W.ELEMENT_NAME AS PROJECT_NAME,
   W.REF_CODE AS PROJECT_REFERENCE,
   W.PRIORITY AS PROJECT_PRIORITY,
   W.STAGE_ID AS PROJECT_RANK,
   W.CURRENCY_ID AS PROJECT_CURRENCY_ID,
   PB.TOTAL_FORMULA AS PROJECT_BUDGET_SETTING,
   PB.CHARGEBACK_FORMULA AS PROJECT_CHARGEBACK_FORMULA,
   SUBSTR( W.ASSIGN_NAMES, 1, InStr( W.ASSIGN_NAMES, ';' ) - 1 ) AS PROJECT_MANAGER,
   
   PB.ESTIMATED_COST,
   PB.ESTIMATED_REVENUE,
   PB.ESTIMATED_SAVING,
   PB.ESTIMATED_ACTUAL_COST,
   PB.ESTIMATED_ACTUAL_REVENUE,
   PB.ESTIMATED_ACTUAL_SAVING,
   PB.ESTIMATED_ETC_COST,
   PB.ESTIMATED_ETC_REVENUE,
   PB.ESTIMATED_ETC_SAVING,
   PB.SCHEDULED_COST,
   PB.SCHEDULED_REVENUE,
   PB.SCHEDULED_SAVING,
   PB.ACTUAL_COST,
   PB.ACTUAL_REVENUE,
   PB.ACTUAL_SAVING,
   PB.ETC_COST,
   PB.ETC_REVENUE,
   PB.ETC_SAVING,
   
   0 AS BENEFIT_FLAG,
   0 AS BENEFIT_PERCENT,
   0.00 AS BENEFIT_AMOUNT,
   0.00 AS BASELINE1_BENEFIT_AMOUNT,
   0.00 AS BASELINE2_BENEFIT_AMOUNT,
   0.00 AS BASELINE3_BENEFIT_AMOUNT,
   0.00 AS PAID_TODATE,
   0 AS TIMEPHASED_FLAG,
   
   0 AS ENTRY_YEAR,
   0 AS ENTRY_TYPE,
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN PMO_BENEFITS PB
   ON PB.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  1 AS LEVEL_ID,
   229 AS TYPE_ID,
   RTRIM(P.RANK) || RTRIM(TCC.RANK) AS RANK,
   P.ELEMENT_ID AS PARENT_ID,
   TCC.ELEMENT_ID,
   TCC.ELEMENT_NAME,
   TCC.CHILD_COUNT,
   TCC.DELETED_COUNT,
   TCC.REC_STATUS,
   TCC.REC_USER,
   TCC.REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   0 AS PROJECT_CHARGEBACK_FORMULA,
   '' AS PROJECT_MANAGER,
   
   0.00 AS ESTIMATED_COST,
   0.00 AS ESTIMATED_REVENUE,
   0.00 AS ESTIMATED_SAVING,
   0.00 AS ESTIMATED_ACTUAL_COST,
   0.00 AS ESTIMATED_ACTUAL_REVENUE,
   0.00 AS ESTIMATED_ACTUAL_SAVING,
   0.00 AS ESTIMATED_ETC_COST,
   0.00 AS ESTIMATED_ETC_REVENUE,
   0.00 AS ESTIMATED_ETC_SAVING,
   0.00 AS SCHEDULED_COST,
   0.00 AS SCHEDULED_REVENUE,
   0.00 AS SCHEDULED_SAVING,
   0.00 AS ACTUAL_COST,
   0.00 AS ACTUAL_REVENUE,
   0.00 AS ACTUAL_SAVING,
   0.00 AS ETC_COST,
   0.00 AS ETC_REVENUE,
   0.00 AS ETC_SAVING,
   
   PCB.BENEFIT_FLAG,
   PCB.BENEFIT_PERCENT,
   CASE
   WHEN PCB.BENEFIT_FLAG = 1 THEN PCB.BENEFIT_AMOUNT
   ELSE
   CASE
   WHEN PB.CHARGEBACK_FORMULA = 0 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN PB.ESTIMATED_SAVING
   WHEN PB.TOTAL_FORMULA = 1 THEN PB.SCHEDULED_SAVING
   WHEN PB.TOTAL_FORMULA = 2 THEN PB.ESTIMATED_SAVING -- (PB.ESTIMATED_SAVING + PB.ACTUAL_SAVING)
   WHEN PB.TOTAL_FORMULA = 3 THEN (PB.ESTIMATED_SAVING + PB.SCHEDULED_SAVING)
   END
   WHEN PB.CHARGEBACK_FORMULA = 1 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN PB.ESTIMATED_REVENUE
   WHEN PB.TOTAL_FORMULA = 1 THEN PB.SCHEDULED_REVENUE
   WHEN PB.TOTAL_FORMULA = 2 THEN PB.ESTIMATED_REVENUE -- (PB.ESTIMATED_REVENUE + PB.ACTUAL_REVENUE)
   WHEN PB.TOTAL_FORMULA = 3 THEN (PB.ESTIMATED_REVENUE + PB.SCHEDULED_REVENUE)
   END
   WHEN PB.CHARGEBACK_FORMULA = 2 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN (PB.ESTIMATED_REVENUE+PB.ESTIMATED_SAVING)
   WHEN PB.TOTAL_FORMULA = 1 THEN (PB.SCHEDULED_REVENUE+PB.SCHEDULED_SAVING)
   WHEN PB.TOTAL_FORMULA = 2 THEN (PB.ESTIMATED_REVENUE+PB.ESTIMATED_SAVING) -- ((PB.ESTIMATED_REVENUE+PB.ESTIMATED_SAVING) + (PB.ACTUAL_REVENUE+PB.ACTUAL_SAVING))
   WHEN PB.TOTAL_FORMULA = 3 THEN ((PB.ESTIMATED_REVENUE+PB.ESTIMATED_SAVING) + (PB.SCHEDULED_REVENUE+PB.SCHEDULED_SAVING))
   END
   WHEN PB.CHARGEBACK_FORMULA = 3 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN PB.ESTIMATED_COST
   WHEN PB.TOTAL_FORMULA = 1 THEN PB.SCHEDULED_COST
   WHEN PB.TOTAL_FORMULA = 2 THEN PB.ESTIMATED_COST -- (PB.ESTIMATED_COST + PB.ACTUAL_COST)
   WHEN PB.TOTAL_FORMULA = 3 THEN (PB.ESTIMATED_COST + PB.SCHEDULED_COST)
   END
   END
   END AS BENEFIT_AMOUNT,
   PCB.BASELINE1_BENEFIT_AMOUNT,
   PCB.BASELINE2_BENEFIT_AMOUNT,
   PCB.BASELINE3_BENEFIT_AMOUNT,
   CASE
   WHEN PCB.BENEFIT_FLAG = 1 THEN PCB.PAID_TODATE
   ELSE
   CASE
   WHEN PB.CHARGEBACK_FORMULA = 0 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN PB.ESTIMATED_ACTUAL_SAVING
   WHEN PB.TOTAL_FORMULA = 1 THEN PB.ACTUAL_SAVING
   WHEN PB.TOTAL_FORMULA = 2 THEN (PB.ESTIMATED_ACTUAL_SAVING + PB.ACTUAL_SAVING)
   WHEN PB.TOTAL_FORMULA = 3 THEN (PB.ESTIMATED_ACTUAL_SAVING + PB.SCHEDULED_SAVING)
   END
   WHEN PB.CHARGEBACK_FORMULA = 1 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN PB.ESTIMATED_ACTUAL_REVENUE
   WHEN PB.TOTAL_FORMULA = 1 THEN PB.ACTUAL_SAVING
   WHEN PB.TOTAL_FORMULA = 2 THEN (PB.ESTIMATED_ACTUAL_REVENUE + PB.ACTUAL_REVENUE)
   WHEN PB.TOTAL_FORMULA = 3 THEN (PB.ESTIMATED_ACTUAL_REVENUE + PB.SCHEDULED_REVENUE)
   END
   WHEN PB.CHARGEBACK_FORMULA = 2 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN (PB.ESTIMATED_ACTUAL_REVENUE+PB.ESTIMATED_ACTUAL_SAVING)
   WHEN PB.TOTAL_FORMULA = 1 THEN (PB.ACTUAL_REVENUE+PB.ACTUAL_SAVING)
   WHEN PB.TOTAL_FORMULA = 2 THEN ((PB.ESTIMATED_ACTUAL_REVENUE+PB.ESTIMATED_ACTUAL_SAVING) + (PB.ACTUAL_REVENUE+PB.ACTUAL_SAVING))
   WHEN PB.TOTAL_FORMULA = 3 THEN ((PB.ESTIMATED_ACTUAL_REVENUE+PB.ESTIMATED_ACTUAL_SAVING) + (PB.SCHEDULED_REVENUE+PB.SCHEDULED_SAVING))
   END
   WHEN PB.CHARGEBACK_FORMULA = 3 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN PB.ESTIMATED_ACTUAL_COST
   WHEN PB.TOTAL_FORMULA = 1 THEN PB.ACTUAL_COST
   WHEN PB.TOTAL_FORMULA = 2 THEN (PB.ESTIMATED_ACTUAL_COST + PB.ACTUAL_COST)
   WHEN PB.TOTAL_FORMULA = 3 THEN (PB.ESTIMATED_ACTUAL_COST + PB.SCHEDULED_COST)
   END
   END
   END AS PAID_TODATE,
   CASE WHEN COALESCE((SELECT SUM(TOTAL_AMOUNT) FROM PROJECT_CHARGEBACK_BREAKDOWN WHERE PROJECT_ID = PCB.PROJECT_ID AND CLIENT_ID = PCB.CLIENT_ID),0) > 0 THEN 1 ELSE 0 END AS TIMEPHASED_FLAG,
   
   0 AS ENTRY_YEAR,
   0 AS ENTRY_TYPE,
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN PMO_BENEFITS PB
   ON PB.PROJECT_ID = P.ELEMENT_ID
   JOIN PROJECT_CHARGEBACK PCB
   ON PCB.PROJECT_ID = P.ELEMENT_ID
   JOIN TMT_CLIENTS TCC
   ON TCC.ELEMENT_ID = PCB.CLIENT_ID
   
   UNION ALL
   
   SELECT  2 AS LEVEL_ID,
   31 AS TYPE_ID,
   RTRIM(P.RANK) || RTRIM(PBB.CLIENT_RANK) || RTRIM(TO_CHAR(PBB.ENTRY_YEAR)) || RTRIM(TO_CHAR(PBB.ENTRY_TYPE)) AS RANK,
   P.ELEMENT_ID AS PARENT_ID,
   PBB.CLIENT_ID AS ELEMENT_ID,
   PBB.CLIENT_NAME AS ELEMENT_NAME,
   0 AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   'U' AS REC_STATUS,
   '' AS REC_USER,
   SYSTIMESTAMP AS REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   0 AS PROJECT_CHARGEBACK_FORMULA,
   '' AS PROJECT_MANAGER,
   
   0.00 AS ESTIMATED_COST,
   0.00 AS ESTIMATED_REVENUE,
   0.00 AS ESTIMATED_SAVING,
   0.00 AS ESTIMATED_ACTUAL_COST,
   0.00 AS ESTIMATED_ACTUAL_REVENUE,
   0.00 AS ESTIMATED_ACTUAL_SAVING,
   0.00 AS ESTIMATED_ETC_COST,
   0.00 AS ESTIMATED_ETC_REVENUE,
   0.00 AS ESTIMATED_ETC_SAVING,
   0.00 AS SCHEDULED_COST,
   0.00 AS SCHEDULED_REVENUE,
   0.00 AS SCHEDULED_SAVING,
   0.00 AS ACTUAL_COST,
   0.00 AS ACTUAL_REVENUE,
   0.00 AS ACTUAL_SAVING,
   0.00 AS ETC_COST,
   0.00 AS ETC_REVENUE,
   0.00 AS ETC_SAVING,
   
   0 AS BENEFIT_FLAG,
   0 AS BENEFIT_PERCENT,
   0.00 AS BENEFIT_AMOUNT,
   0.00 AS BASELINE1_BENEFIT_AMOUNT,
   0.00 AS BASELINE2_BENEFIT_AMOUNT,
   0.00 AS BASELINE3_BENEFIT_AMOUNT,
   0.00 AS PAID_TODATE,
   1 AS TIMEPHASED_FLAG,
   
   PBB.ENTRY_YEAR,
   PBB.ENTRY_TYPE,
   PBB.CHARGECODE_TYPE AS BUDGET_TYPE,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_01 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_01 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_01 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_01 ELSE 0 END
   END AS AMOUNT_01,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_02 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_02 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_02 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_02 ELSE 0 END
   END AS AMOUNT_02,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_03 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_03 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_03 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_03 ELSE 0 END
   END AS AMOUNT_03,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_04 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_04 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_04 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_04 ELSE 0 END
   END AS AMOUNT_04,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_05 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_05 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_05 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_05 ELSE 0 END
   END AS AMOUNT_05,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_06 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_06 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_06 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_06 ELSE 0 END
   END AS AMOUNT_06,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_07 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_07 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_07 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_07 ELSE 0 END
   END AS AMOUNT_07,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_08 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_08 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_08 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_08 ELSE 0 END
   END AS AMOUNT_08,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_09 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_09 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_09 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_09 ELSE 0 END
   END AS AMOUNT_09,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_10 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_10 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_10 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_10 ELSE 0 END
   END AS AMOUNT_10,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_11 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_11 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_11 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_11 ELSE 0 END
   END AS AMOUNT_11,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_12 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_12 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_12 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_12 ELSE 0 END
   END AS AMOUNT_12
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN PMO_CHARGEBACK_BREAKDOWN PBB
   ON PBB.PROJECT_ID = P.ELEMENT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_CHARGEBACK_PIVOT', 480+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_CHARGEBACK_PIVOT(481) : views_financial.sql(13269) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CBPRESULT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHARGEBACK_PIVOT', 488+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHARGEBACK_PIVOT(489) : views_financial.sql(13277) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_CHARGEBACK_PIVOT', 500+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_CHARGEBACK_PIVOT(501) : views_financial.sql(13289) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_CHARGEBACK_PIVOT;
ALTER FUNCTION SP_CHARGEBACK_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_TIMEPHASED_CB ==
CREATE OR REPLACE FUNCTION FC_INIT_TIMEPHASED_CB RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_TIMEPHASED_CB') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_TIMEPHASED_CB'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_TIMEPHASED_CB();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_TIMEPHASED_CB', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_TIMEPHASED_CB(9) : views_financial.sql(13314) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TIMEPHASED_CB';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_TIMEPHASED_CB (
      PROJECT_ID,
      CLIENT_ID,
      CLIENT_NAME,
      CLIENT_RANK,
      ENTRY_YEAR,
      ENTRY_TYPE,
      AMOUNT_01,
      AMOUNT_02,
      AMOUNT_03,
      AMOUNT_04,
      AMOUNT_05,
      AMOUNT_06,
      AMOUNT_07,
      AMOUNT_08,
      AMOUNT_09,
      AMOUNT_10,
      AMOUNT_11,
      AMOUNT_12 )
      SELECT  PB.PROJECT_ID,
      C.ELEMENT_ID,
      C.ELEMENT_NAME,
      C.RANK,
      PCB.ENTRY_YEAR,
      PCB.ENTRY_TYPE,
      SUM(PCB.MONTH_01_AMOUNT) AS AMOUNT_01,
      SUM(PCB.MONTH_02_AMOUNT) AS AMOUNT_02,
      SUM(PCB.MONTH_03_AMOUNT) AS AMOUNT_03,
      SUM(PCB.MONTH_04_AMOUNT) AS AMOUNT_04,
      SUM(PCB.MONTH_05_AMOUNT) AS AMOUNT_05,
      SUM(PCB.MONTH_06_AMOUNT) AS AMOUNT_06,
      SUM(PCB.MONTH_07_AMOUNT) AS AMOUNT_07,
      SUM(PCB.MONTH_08_AMOUNT) AS AMOUNT_08,
      SUM(PCB.MONTH_09_AMOUNT) AS AMOUNT_09,
      SUM(PCB.MONTH_10_AMOUNT) AS AMOUNT_10,
      SUM(PCB.MONTH_11_AMOUNT) AS AMOUNT_11,
      SUM(PCB.MONTH_12_AMOUNT) AS AMOUNT_12
      FROM PMO_BENEFITS PB
      JOIN (PROJECT_CHARGEBACK PC
      JOIN TMT_CLIENTS C
      ON C.ELEMENT_ID = PC.CLIENT_ID)
      ON PC.PROJECT_ID = PB.PROJECT_ID
      JOIN PROJECT_CHARGEBACK_BREAKDOWN PCB
      ON PCB.PROJECT_ID = PCB.PROJECT_ID
      AND PCB.CLIENT_ID = PC.CLIENT_ID
      GROUP BY PB.PROJECT_ID,
      C.ELEMENT_ID,
      C.ELEMENT_NAME,
      C.RANK,
      PCB.ENTRY_YEAR,
      PCB.ENTRY_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_TIMEPHASED_CB', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_TIMEPHASED_CB(82) : views_financial.sql(13387) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_TIMEPHASED_CB', 88+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_TIMEPHASED_CB(89) : views_financial.sql(13394) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_TIMEPHASED_CB;
ALTER FUNCTION FC_INIT_TIMEPHASED_CB COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_TIMEPHASED_CC ==
CREATE OR REPLACE FUNCTION FC_INIT_TIMEPHASED_CC RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_TIMEPHASED_CC') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_TIMEPHASED_CC'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_TIMEPHASED_CC();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_TIMEPHASED_CC', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_TIMEPHASED_CC(9) : views_financial.sql(13413) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TIMEPHASED_CC';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_TIMEPHASED_CC (
      PROJECT_ID,
      CHARGEBACK_FORMULA,
      CHARGECODE_TYPE,
      ENTRY_YEAR,
      ENTRY_TYPE,
      AMOUNT_01,
      AMOUNT_02,
      AMOUNT_03,
      AMOUNT_04,
      AMOUNT_05,
      AMOUNT_06,
      AMOUNT_07,
      AMOUNT_08,
      AMOUNT_09,
      AMOUNT_10,
      AMOUNT_11,
      AMOUNT_12 )
      SELECT  PB.PROJECT_ID,
      PB.CHARGEBACK_FORMULA,
      CASE
      WHEN CC.CAPITAL_EXPENSE = 2 AND BILLABLE = 0 THEN 2
      WHEN CC.CAPITAL_EXPENSE = 2 AND BILLABLE = 1 THEN 3
      ELSE CC.CAPITAL_EXPENSE
      END AS CHARGECODE_TYPE,
      PBB.BUDGET_YEAR,
      PBB.BUDGET_TYPE,
      SUM(PBB.MONTH_01_AMOUNT) AS AMOUNT_01,
      SUM(PBB.MONTH_02_AMOUNT) AS AMOUNT_02,
      SUM(PBB.MONTH_03_AMOUNT) AS AMOUNT_03,
      SUM(PBB.MONTH_04_AMOUNT) AS AMOUNT_04,
      SUM(PBB.MONTH_05_AMOUNT) AS AMOUNT_05,
      SUM(PBB.MONTH_06_AMOUNT) AS AMOUNT_06,
      SUM(PBB.MONTH_07_AMOUNT) AS AMOUNT_07,
      SUM(PBB.MONTH_08_AMOUNT) AS AMOUNT_08,
      SUM(PBB.MONTH_09_AMOUNT) AS AMOUNT_09,
      SUM(PBB.MONTH_10_AMOUNT) AS AMOUNT_10,
      SUM(PBB.MONTH_11_AMOUNT) AS AMOUNT_11,
      SUM(PBB.MONTH_12_AMOUNT) AS AMOUNT_12
      FROM PMO_BENEFITS PB
      JOIN (PROJECT_BUDGET_BREAKDOWN PBB
      JOIN TMT_CHARGECODES CC
      ON CC.ELEMENT_ID = PBB.CHARGECODE_ID
      AND CC.ELEMENT_ID NOT IN (
      'EXPENSE_HOURS',
      'EXPENSE_AVERAGE_COST',
      'EXPENSE_FULL_TIME_EQUIVALENT',
      'CAPITAL_HOURS',
      'CAPITAL_AVERAGE_COST',
      'CAPITAL_FULL_TIME_EQUIVALENT',
      'BENEFIT_HOURS',
      'BENEFIT_AVERAGE_RATE',
      'BENEFIT_FULL_TIME_EQUIVALENT',
      'PMO_PROJECT_TIMEPHASE_CALENDAR__' ) )
      ON PBB.PROJECT_ID = PB.PROJECT_ID
      AND PBB.ELEMENT_ID = PB.PROJECT_ID
      AND PBB.BUDGET_TYPE NOT IN (PMO_CNST.SC_PAID_BUDGET, PMO_CNST.SC_ESTIMATED_PAID_BUDGET)
      GROUP BY PB.PROJECT_ID,
      PB.CHARGEBACK_FORMULA,
      CC.CAPITAL_EXPENSE,
      CC.BILLABLE,
      PBB.BUDGET_YEAR,
      PBB.BUDGET_TYPE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_TIMEPHASED_CC', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_TIMEPHASED_CC(94) : views_financial.sql(13498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_TIMEPHASED_CC', 100+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_TIMEPHASED_CC(101) : views_financial.sql(13505) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_TIMEPHASED_CC;
ALTER FUNCTION FC_INIT_TIMEPHASED_CC COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UNION_PIVOT ==
CREATE OR REPLACE FUNCTION SP_UNION_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_chargeback_formula PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CUPRESULT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UNION_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UNION_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_UNION_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNION_PIVOT', 38+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UNION_PIVOT(39) : views_financial.sql(13554) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UNION_PIVOT', 43+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UNION_PIVOT(44) : views_financial.sql(13559) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_BENEFIT();
   h_temp_sc_state := FC_INIT_TIMEPHASED_CB();
   h_temp_sc_state := FC_INIT_TIMEPHASED_CC();
   
   OPEN CUPRESULT FOR SELECT  0 AS LEVEL_ID,
   W.TYPE_ID,
   RTRIM(W.RANK) AS RANK,
   W.PARENT_ID,
   W.ELEMENT_ID,
   W.ELEMENT_NAME,
   W.CHILD_COUNT,
   W.DELETED_COUNT,
   W.REC_STATUS,
   W.REC_USER,
   W.REC_DATETIME,
   
   W.ELEMENT_ID AS PROJECT_ID,
   W.ELEMENT_NAME AS PROJECT_NAME,
   W.REF_CODE AS PROJECT_REFERENCE,
   W.PRIORITY AS PROJECT_PRIORITY,
   W.STAGE_ID AS PROJECT_RANK,
   W.CURRENCY_ID AS PROJECT_CURRENCY_ID,
   PB.TOTAL_FORMULA AS PROJECT_BUDGET_SETTING,
   PB.CHARGEBACK_FORMULA AS PROJECT_CHARGEBACK_FORMULA,
   SUBSTR( W.ASSIGN_NAMES, 1, InStr( W.ASSIGN_NAMES, ';' ) - 1 ) AS PROJECT_MANAGER,
   
   PB.ESTIMATED_COST,
   PB.ESTIMATED_REVENUE,
   PB.ESTIMATED_SAVING,
   PB.ESTIMATED_ACTUAL_COST,
   PB.ESTIMATED_ACTUAL_REVENUE,
   PB.ESTIMATED_ACTUAL_SAVING,
   PB.ESTIMATED_ETC_COST,
   PB.ESTIMATED_ETC_REVENUE,
   PB.ESTIMATED_ETC_SAVING,
   PB.SCHEDULED_COST,
   PB.SCHEDULED_REVENUE,
   PB.SCHEDULED_SAVING,
   PB.ACTUAL_COST,
   PB.ACTUAL_REVENUE,
   PB.ACTUAL_SAVING,
   PB.ETC_COST,
   PB.ETC_REVENUE,
   PB.ETC_SAVING,
   
   0 AS BENEFIT_FLAG,
   0 AS BENEFIT_PERCENT,
   0.00 AS BENEFIT_AMOUNT,
   0.00 AS BASELINE1_BENEFIT_AMOUNT,
   0.00 AS BASELINE2_BENEFIT_AMOUNT,
   0.00 AS BASELINE3_BENEFIT_AMOUNT,
   0.00 AS PAID_TODATE,
   0 AS TIMEPHASED_FLAG,
   
   0 AS ENTRY_YEAR,
   0 AS ENTRY_TYPE,
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN PMO_BENEFITS PB
   ON PB.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  1 AS LEVEL_ID,
   31 AS TYPE_ID,
   RTRIM(P.RANK) || '###1' || RTRIM(TO_CHAR(PBB.ENTRY_YEAR)) || RTRIM(TO_CHAR(PBB.ENTRY_TYPE)) AS RANK,
   '' AS PARENT_ID,
   '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   'U' AS REC_STATUS,
   '' AS REC_USER,
   SYSTIMESTAMP AS REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   0 AS PROJECT_CHARGEBACK_FORMULA,
   '' AS PROJECT_MANAGER,
   
   0.00 AS ESTIMATED_COST,
   0.00 AS ESTIMATED_REVENUE,
   0.00 AS ESTIMATED_SAVING,
   0.00 AS ESTIMATED_ACTUAL_COST,
   0.00 AS ESTIMATED_ACTUAL_REVENUE,
   0.00 AS ESTIMATED_ACTUAL_SAVING,
   0.00 AS ESTIMATED_ETC_COST,
   0.00 AS ESTIMATED_ETC_REVENUE,
   0.00 AS ESTIMATED_ETC_SAVING,
   0.00 AS SCHEDULED_COST,
   0.00 AS SCHEDULED_REVENUE,
   0.00 AS SCHEDULED_SAVING,
   0.00 AS ACTUAL_COST,
   0.00 AS ACTUAL_REVENUE,
   0.00 AS ACTUAL_SAVING,
   0.00 AS ETC_COST,
   0.00 AS ETC_REVENUE,
   0.00 AS ETC_SAVING,
   
   0 AS BENEFIT_FLAG,
   0 AS BENEFIT_PERCENT,
   0.00 AS BENEFIT_AMOUNT,
   0.00 AS BASELINE1_BENEFIT_AMOUNT,
   0.00 AS BASELINE2_BENEFIT_AMOUNT,
   0.00 AS BASELINE3_BENEFIT_AMOUNT,
   0.00 AS PAID_TODATE,
   1 AS TIMEPHASED_FLAG,
   
   PBB.ENTRY_YEAR,
   PBB.ENTRY_TYPE,
   PBB.CHARGECODE_TYPE AS BUDGET_TYPE,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_01 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_01 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_01 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_01 ELSE 0 END
   END AS AMOUNT_01,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_02 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_02 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_02 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_02 ELSE 0 END
   END AS AMOUNT_02,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_03 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_03 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_03 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_03 ELSE 0 END
   END AS AMOUNT_03,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_04 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_04 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_04 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_04 ELSE 0 END
   END AS AMOUNT_04,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_05 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_05 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_05 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_05 ELSE 0 END
   END AS AMOUNT_05,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_06 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_06 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_06 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_06 ELSE 0 END
   END AS AMOUNT_06,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_07 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_07 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_07 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_07 ELSE 0 END
   END AS AMOUNT_07,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_08 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_08 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_08 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_08 ELSE 0 END
   END AS AMOUNT_08,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_09 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_09 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_09 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_09 ELSE 0 END
   END AS AMOUNT_09,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_10 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_10 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_10 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_10 ELSE 0 END
   END AS AMOUNT_10,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_11 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_11 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_11 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_11 ELSE 0 END
   END AS AMOUNT_11,
   
   CASE
   WHEN PBB.CHARGEBACK_FORMULA = 0 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 3 THEN PBB.AMOUNT_12 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 1 THEN
   CASE WHEN PBB.CHARGECODE_TYPE = 2 THEN PBB.AMOUNT_12 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 2 THEN
   CASE WHEN PBB.CHARGECODE_TYPE IN (2,3) THEN PBB.AMOUNT_12 ELSE 0 END
   WHEN PBB.CHARGEBACK_FORMULA = 3 THEN
   CASE WHEN PBB.CHARGECODE_TYPE < 2 THEN PBB.AMOUNT_12 ELSE 0 END
   END AS AMOUNT_12
   
   FROM PMO_FINANCIAL_PROJECTS P
   LEFT JOIN PMO_TIMEPHASED_CC PBB
   ON PBB.PROJECT_ID = P.ELEMENT_ID
   
   UNION ALL
   
   SELECT  2 AS LEVEL_ID,
   229 AS TYPE_ID,
   RTRIM(P.RANK) || RTRIM(TCC.RANK) AS RANK,
   P.ELEMENT_ID AS PARENT_ID,
   TCC.ELEMENT_ID,
   TCC.ELEMENT_NAME,
   TCC.CHILD_COUNT,
   TCC.DELETED_COUNT,
   TCC.REC_STATUS,
   TCC.REC_USER,
   TCC.REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   0 AS PROJECT_CHARGEBACK_FORMULA,
   '' AS PROJECT_MANAGER,
   
   0.00 AS ESTIMATED_COST,
   0.00 AS ESTIMATED_REVENUE,
   0.00 AS ESTIMATED_SAVING,
   0.00 AS ESTIMATED_ACTUAL_COST,
   0.00 AS ESTIMATED_ACTUAL_REVENUE,
   0.00 AS ESTIMATED_ACTUAL_SAVING,
   0.00 AS ESTIMATED_ETC_COST,
   0.00 AS ESTIMATED_ETC_REVENUE,
   0.00 AS ESTIMATED_ETC_SAVING,
   0.00 AS SCHEDULED_COST,
   0.00 AS SCHEDULED_REVENUE,
   0.00 AS SCHEDULED_SAVING,
   0.00 AS ACTUAL_COST,
   0.00 AS ACTUAL_REVENUE,
   0.00 AS ACTUAL_SAVING,
   0.00 AS ETC_COST,
   0.00 AS ETC_REVENUE,
   0.00 AS ETC_SAVING,
   
   PCB.BENEFIT_FLAG,
   PCB.BENEFIT_PERCENT,
   CASE
   WHEN PCB.BENEFIT_FLAG = 1 THEN PCB.BENEFIT_AMOUNT
   ELSE
   CASE
   WHEN PB.CHARGEBACK_FORMULA = 0 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN (PB.ESTIMATED_SAVING * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 1 THEN (PB.SCHEDULED_SAVING * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 2 THEN ((PB.ESTIMATED_SAVING + PB.ACTUAL_SAVING) * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 3 THEN ((PB.ESTIMATED_SAVING + PB.SCHEDULED_SAVING) * PCB.BENEFIT_PERCENT)/10000
   END
   WHEN PB.CHARGEBACK_FORMULA = 1 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN (PB.ESTIMATED_REVENUE * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 1 THEN (PB.SCHEDULED_REVENUE * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 2 THEN ((PB.ESTIMATED_REVENUE + PB.ACTUAL_REVENUE) * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 3 THEN ((PB.ESTIMATED_REVENUE + PB.SCHEDULED_REVENUE) * PCB.BENEFIT_PERCENT)/10000
   END
   WHEN PB.CHARGEBACK_FORMULA = 2 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN ((PB.ESTIMATED_REVENUE+PB.ESTIMATED_SAVING) * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 1 THEN ((PB.SCHEDULED_REVENUE+PB.SCHEDULED_SAVING) * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 2 THEN (((PB.ESTIMATED_REVENUE+PB.ESTIMATED_SAVING) + (PB.ACTUAL_REVENUE+PB.ACTUAL_SAVING)) * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 3 THEN (((PB.ESTIMATED_REVENUE+PB.ESTIMATED_SAVING) + (PB.SCHEDULED_REVENUE+PB.SCHEDULED_SAVING)) * PCB.BENEFIT_PERCENT)/10000
   END
   WHEN PB.CHARGEBACK_FORMULA = 3 THEN
   CASE
   WHEN PB.TOTAL_FORMULA = 0 THEN (PB.ESTIMATED_COST * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 1 THEN (PB.SCHEDULED_COST * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 2 THEN ((PB.ESTIMATED_COST + PB.ACTUAL_COST) * PCB.BENEFIT_PERCENT)/10000
   WHEN PB.TOTAL_FORMULA = 3 THEN ((PB.ESTIMATED_COST + PB.SCHEDULED_COST) * PCB.BENEFIT_PERCENT)/10000
   END
   END
   END AS BENEFIT_AMOUNT,
   PCB.BASELINE1_BENEFIT_AMOUNT,
   PCB.BASELINE2_BENEFIT_AMOUNT,
   PCB.BASELINE3_BENEFIT_AMOUNT,
   PCB.PAID_TODATE,
   1 AS TIMEPHASED_FLAG,
   
   0 AS ENTRY_YEAR,
   0 AS ENTRY_TYPE,
   0 AS BUDGET_TYPE,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12
   
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN PMO_BENEFITS PB
   ON PB.PROJECT_ID = P.ELEMENT_ID
   JOIN PROJECT_CHARGEBACK PCB
   ON PCB.PROJECT_ID = P.ELEMENT_ID
   JOIN TMT_CLIENTS TCC
   ON TCC.ELEMENT_ID = PCB.CLIENT_ID
   
   UNION ALL
   
   SELECT  3 AS LEVEL_ID,
   999 AS TYPE_ID,
   RTRIM(P.RANK) || RTRIM(TO_CHAR(PCB.CLIENT_RANK)) || RTRIM(TO_CHAR(PCB.ENTRY_YEAR)) || RTRIM(TO_CHAR(PCB.ENTRY_TYPE)) AS RANK,
   P.ELEMENT_ID AS PARENT_ID,
   PCB.CLIENT_ID AS ELEMENT_ID,
   PCB.CLIENT_NAME AS ELEMENT_NAME,
   0 AS CHILD_COUNT,
   0 AS DELETED_COUNT,
   'U' AS REC_STATUS,
   '' AS REC_USER,
   SYSTIMESTAMP AS REC_DATETIME,
   
   P.ELEMENT_ID AS PROJECT_ID,
   P.ELEMENT_NAME AS PROJECT_NAME,
   '' AS PROJECT_REFERENCE,
   0 AS PROJECT_PRIORITY,
   0 AS PROJECT_RANK,
   0 AS PROJECT_CURRENCY_ID,
   0 AS PROJECT_BUDGET_SETTING,
   0 AS PROJECT_CHARGEBACK_FORMULA,
   '' AS PROJECT_MANAGER,
   
   0.00 AS ESTIMATED_COST,
   0.00 AS ESTIMATED_REVENUE,
   0.00 AS ESTIMATED_SAVING,
   0.00 AS ESTIMATED_ACTUAL_COST,
   0.00 AS ESTIMATED_ACTUAL_REVENUE,
   0.00 AS ESTIMATED_ACTUAL_SAVING,
   0.00 AS ESTIMATED_ETC_COST,
   0.00 AS ESTIMATED_ETC_REVENUE,
   0.00 AS ESTIMATED_ETC_SAVING,
   0.00 AS SCHEDULED_COST,
   0.00 AS SCHEDULED_REVENUE,
   0.00 AS SCHEDULED_SAVING,
   0.00 AS ACTUAL_COST,
   0.00 AS ACTUAL_REVENUE,
   0.00 AS ACTUAL_SAVING,
   0.00 AS ETC_COST,
   0.00 AS ETC_REVENUE,
   0.00 AS ETC_SAVING,
   
   0 AS BENEFIT_FLAG,
   0 AS BENEFIT_PERCENT,
   0.00 AS BENEFIT_AMOUNT,
   0.00 AS BASELINE1_BENEFIT_AMOUNT,
   0.00 AS BASELINE2_BENEFIT_AMOUNT,
   0.00 AS BASELINE3_BENEFIT_AMOUNT,
   0.00 AS PAID_TODATE,
   1 AS TIMEPHASED_FLAG,
   
   PCB.ENTRY_YEAR,
   PCB.ENTRY_TYPE,
   5 AS BUDGET_TYPE,
   
   PCB.AMOUNT_01,
   PCB.AMOUNT_02,
   PCB.AMOUNT_03,
   PCB.AMOUNT_04,
   PCB.AMOUNT_05,
   PCB.AMOUNT_06,
   PCB.AMOUNT_07,
   PCB.AMOUNT_08,
   PCB.AMOUNT_09,
   PCB.AMOUNT_10,
   PCB.AMOUNT_11,
   PCB.AMOUNT_12
   
   FROM PMO_FINANCIAL_PROJECTS P
   LEFT JOIN PMO_TIMEPHASED_CB PCB
   ON PCB.PROJECT_ID = P.ELEMENT_ID
   
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UNION_PIVOT', 509+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_UNION_PIVOT(510) : views_financial.sql(14025) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CUPRESULT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNION_PIVOT', 517+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNION_PIVOT(518) : views_financial.sql(14033) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UNION_PIVOT', 529+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UNION_PIVOT(530) : views_financial.sql(14045) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UNION_PIVOT;
ALTER FUNCTION SP_UNION_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_PIVOT_FEATURE_TESTER ==
CREATE OR REPLACE FUNCTION SP_PIVOT_FEATURE_TESTER
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(31999);
   h_finish_date DATE;
   h_ids VARCHAR2(8192);
   h_rec_user VARCHAR2(32);
   h_start_date DATE;
   h_type PLS_INTEGER := 0;
   h_max_year PLS_INTEGER := 0;
   h_min_year PLS_INTEGER := 0;
   h_period_count PLS_INTEGER := 0;
   h_year_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CPFT PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_PIVOT_FEATURE_TESTER') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_PIVOT_FEATURE_TESTER'), '-- ' || SYSTIMESTAMP, ':r := SP_PIVOT_FEATURE_TESTER(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PIVOT_FEATURE_TESTER', 36+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_PIVOT_FEATURE_TESTER(37) : views_financial.sql(14098) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_PIVOT_FEATURE_TESTER', 41+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_PIVOT_FEATURE_TESTER(42) : views_financial.sql(14103) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   --Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   h_temp_sc_state := FC_INIT_PROJECTS(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   h_temp_sc_state := FC_INIT_ATTR_EX();
   h_temp_sc_state := FC_PIVOT_ATTR_EX();
   
   OPEN CPFT FOR SELECT
   0 AS LEVEL_ID, W.TYPE_ID, P.RANK, W.PARENT_ID, P.ELEMENT_ID, P.ELEMENT_NAME,
   W.CHILD_COUNT, W.DELETED_COUNT, W.REC_STATUS, W.REC_USER, W.REC_DATETIME,
   W.REF_CODE AS REFERNCE_CODE,
   W.PROBABILITY AS PURSUIT_PROBABILITY,
   R.FULL_NAME AS PROJECT_MANAGER,
   W.CURRENCY_ID AS PROJECT_CURRENCY_ID,
   PD.BUDGET_SETTING_BITS AS PROJECT_BUDGET_SETTING_BITS,
   PD.SCOPE_SCORE  ,
   PD.SCOPE_WEIGHT  ,
   PD.SCHEDULE_SCORE  ,
   PD.SCHEDULE_WEIGHT  ,
   PD.QUALITY_SCORE  ,
   PD.QUALITY_WEIGHT  ,
   PD.BENEFIT_SCORE  ,
   PD.BENEFIT_WEIGHT  ,
   PD.COST_SCORE  ,
   PD.COST_WEIGHT  ,
   W.START_FINISH_DATE AS PROJECT_START,
   W.FINISH_START_DATE AS PROJECT_FINISH,
   W.PRIORITY AS PROJECT_PRIORITY,
   W.STAGE_ID AS STAGE_ID,
   W.MILESTONE_PERCENT AS PROJECT_PERCENT_COMPLETE,
   CASE WHEN W.BASELINE1_EFFORT > 0 THEN ((W.WORK_TODATE*10000)/W.BASELINE1_EFFORT) ELSE 0 END AS PROJECT_PERCENT_SPENT,
   (CASE WHEN W.CONVERTED_WEIGHT > 0 THEN ((PMO_ORASTD.TODECIMAL(W.CONVERTED_SCORE,18,2)/W.CONVERTED_WEIGHT)*10000) ELSE 0 END) AS PROJECT_PUBLISHED_RATING,
   W.BUBBLE_COLOR AS PROJECT_PUBLISHED_COLOR,
   W.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   W.EXPECTED_PAYBACK_PERIOD,
   W.EXPECTED_PAYBACK_MONTH,
   W.ASSIGN_NAMES AS PROJECT_RESOURCES,
   (SELECT COUNT(C.ELEMENT_ID) FROM PROJECT_ASSIGNMENTS PA JOIN TMT_COMPETENCIES C ON C.RESOURCE_ID = PA.RESOURCE_ID AND C.STRATEGIC_FLAG = '1' WHERE PA.PROJECT_ID = W.ELEMENT_ID) AS PROJECT_STRATEGIC_RES,
   '' AS PROJECT_FISCAL_START,
   '' AS PROJECT_FISCAL_SHIFT,
   COALESCE((SELECT MAX(BUDGET_YEAR) FROM PROJECT_BUDGET_BREAKDOWN WHERE PROJECT_ID = P.ELEMENT_ID AND CHARGECODE_ID <> 'PMO_PROJECT_TIMEPHASE_CALENDAR__'),0) AS PROJECT_YEAR,
   0 AS PROJECT_YEAR_DISCOUNT_RATE,
   '' AS ASSOCIATED_CHARGECODE_NAME,
   '' AS CHARGECODE_ID,
   '' AS CHARGECODE_NAME,
   0 AS CHARGECODE_TYPE,
   0 AS BUDGET_TYPE,
   0 AS TIMEPHASED_FLAG,
   W.ESTIMATED_BASELINE1_BUDGET AS ESTIMATED_BASELINE1,
   W.ESTIMATED_BASELINE3_BUDGET AS ESTIMATED_BASELINE3,
   W.ESTIMATION_BUDGET AS ESTIMATED_BUDGET,
   W.ESTIMATED_ACTUAL AS ESTIMATED_ACTUAL,
   W.ESTIMATED_ETC AS ESTIMATED_ETC,
   0.00 AS ESTIMATED_ETC_TOTAL,
   W.BASELINE1_BUDGET AS BUDGET_BASELINE1,
   W.BASELINE3_BUDGET AS BUDGET_BASELINE3,
   W.CURRENT_BUDGET AS BUDGET,
   W.ACTUAL_BUDGET AS ACTUAL,
   0.00 AS ETC,
   0.00 AS AMOUNT_01,
   0.00 AS AMOUNT_02,
   0.00 AS AMOUNT_03,
   0.00 AS AMOUNT_04,
   0.00 AS AMOUNT_05,
   0.00 AS AMOUNT_06,
   0.00 AS AMOUNT_07,
   0.00 AS AMOUNT_08,
   0.00 AS AMOUNT_09,
   0.00 AS AMOUNT_10,
   0.00 AS AMOUNT_11,
   0.00 AS AMOUNT_12,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES,
   '' AS EXPENSE_DATAFIELD1,
   '' AS EXPENSE_DATAFIELD2,
   '' AS CAPITAL_DATAFIELD1,
   '' AS CAPITAL_DATAFIELD2,
   '' AS EXP_CAP_DATAFIELD1,
   '' AS EXP_CAP_DATAFIELD2,
   '' AS BENEFIT_DATAFIELD1,
   '' AS BENEFIT_DATAFIELD2,
   0 AS BENEFIT_CC_PROBABILITY
   FROM PMO_FINANCIAL_PROJECTS P
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = P.ELEMENT_ID
   JOIN PROJECT_DETAILS PD
   ON PD.PROJECT_ID = W.ELEMENT_ID
   JOIN RESOURCE_ASSIGNMENTS RA
   ON RA.PROJECT_ID = P.ELEMENT_ID
   AND RA.ELEMENT_ID = P.ELEMENT_ID
   AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_MANAGER) = PMO_CNST.SC_MANAGER
   JOIN RESOURCES R
   ON R.RESOURCE_ID = RA.RESOURCE_ID
   LEFT JOIN PMO_FINANCIAL_PAT AT
   ON AT.PROJECT_ID = P.ELEMENT_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_PIVOT_FEATURE_TESTER', 146+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_PIVOT_FEATURE_TESTER(147) : views_financial.sql(14208) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CPFT;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PIVOT_FEATURE_TESTER', 154+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PIVOT_FEATURE_TESTER(155) : views_financial.sql(14216) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_PIVOT_FEATURE_TESTER', 166+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_PIVOT_FEATURE_TESTER(167) : views_financial.sql(14228) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_PIVOT_FEATURE_TESTER;
ALTER FUNCTION SP_PIVOT_FEATURE_TESTER COMPILE DEBUG;

