-- already in pmo_sqlprep.h : #include "pmodefines.h"

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PRJ ==
CREATE OR REPLACE FUNCTION FC_INIT_PRJ
(
     h_ids IN OUT NOCOPY VARCHAR2
   , sh_h_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_id VARCHAR2(32);
   h_p_id VARCHAR2(32);
   h_p_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_res_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_discount_rate PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CRPT1 IS
         SELECT ELEMENT_ID, RANK
         FROM PMO_PIVOT_PORTFOLIOS
         ORDER BY RANK;

      CURSOR CIPP IS
         SELECT DISTINCT ELEMENT_ID, RANK
         FROM PMO_PIVOT_TMP_PROJECTS
         ORDER BY RANK;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PRJ') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PRJ'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PRJ(' || 
       '''' || h_ids || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PRJ(41) : views_pivot.sql(50) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_01';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PORTFOLIOS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   --PROJECT
   If (Coalesce(h_type, 0) = 1) OR (Coalesce(h_type, 0) = 3) OR (h_ids IS NULL) Then
      If h_ids IS NULL Then
         h_id := NULL;
         h_rank := '0000';
         PMO_DB2M.SC_STATE := FC_PORTF_PRJ(h_rec_user, h_id, h_rank, h_type);
         
         BEGIN
            INSERT INTO PMO_PIVOT_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
            SELECT RANK, ELEMENT_ID, ELEMENT_NAME
            FROM PMO_TMP_PROJECTS_01;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 87+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(88) : views_pivot.sql(97) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         --Bring all the projects from TMT_PORTFOLIOS folder
         BEGIN
            SELECT RTRIM(RANK) INTO h_res_rank
            FROM TMT_PORTFOLIOS
            WHERE ELEMENT_ID = h_rec_user;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 103+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(104) : views_pivot.sql(113) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_total := 0;
         h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
         If Coalesce(h_total, 0) < 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ', 112+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PRJ(113) : views_pivot.sql(122) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_PARAMS;
         End If;
         
         h_count := 0;
         WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
            h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
            
            BEGIN
               SELECT RTRIM(RANK) INTO h_rank
               FROM TMT_PORTFOLIOS
               WHERE RANK LIKE h_res_rank || '%'
               AND ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 132+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(133) : views_pivot.sql(142) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PMO_PIVOT_PORTFOLIOS( ELEMENT_ID, RANK )
               SELECT ELEMENT_ID, RTRIM(RANK)
               FROM TMT_PORTFOLIOS
               WHERE RANK LIKE h_rank || '%'
               AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
               AND REC_STATUS <> 'D';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 154+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(155) : views_pivot.sql(164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            h_count := Coalesce(h_count, 0) + 1;
         END LOOP;
         
         --Finding the matching project rank from TMT_WBS
         
         OPEN CRPT1;
         
         LOOP
            FETCH CRPT1 INTO h_p_id, h_p_rank;
            IF CRPT1%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            BEGIN
               INSERT INTO PMO_PIVOT_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
               SELECT RTRIM(W.RANK), W.ELEMENT_ID, RTRIM(W.ELEMENT_NAME)
               FROM TMT_PORTFOLIOS P
               JOIN TMT_WBS W
               ON W.ELEMENT_ID = P.ELEMENT_ID
               WHERE P.RANK = h_p_rank
               AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
               AND P.REC_STATUS <> 'D';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 195+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(196) : views_pivot.sql(205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         
         BEGIN
            CLOSE CRPT1 ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 209+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(210) : views_pivot.sql(219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf (Coalesce(h_type, 0) = 2) OR (Coalesce(h_type, 0) = 4) Then
      --PROJECT Type
      h_total := 0;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ', 220+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PRJ(221) : views_pivot.sql(230) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            INSERT INTO PMO_PIVOT_TMP_PROJECTS( RANK, ELEMENT_ID, ELEMENT_NAME )
            SELECT RTRIM(RANK), ELEMENT_ID, RTRIM(ELEMENT_NAME)
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 244+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(245) : views_pivot.sql(254) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   
   --Cleaning----------------------------------------------------
   --Leave only the root projects from different project branches
   BEGIN
      DELETE FROM PMO_PIVOT_TMP_PROJECTS
      WHERE ELEMENT_ID IN (
      SELECT B.ELEMENT_ID
      FROM PMO_PIVOT_TMP_PROJECTS A, PMO_PIVOT_TMP_PROJECTS B
      WHERE A.RANK < B.RANK
      AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
      AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 272+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(273) : views_pivot.sql(282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --  BEGIN_SQL
   --      DELETE FROM session.PMO_PIVOT_TMP_PROJECTS
   --      WHERE ELEMENT_ID IN (
   --          SELECT B.ELEMENT_ID
   --          FROM (RESOURCE_ASSIGNMENTS RA
   --              JOIN TMT_WBS A
   --                  ON A.PROJECT_ID = RA.PROJECT_ID
   --                  AND A.ELEMENT_ID = RA.ELEMENT_ID
   --          ), session.PMO_PIVOT_TMP_PROJECTS B
   --          WHERE RA.RESOURCE_ID = HOST_DB(p_rec_user,ind_bubble_view)
   --              AND RA.ELEMENT_TYPE IN (SC_PROJECT_GROUP_TYPES)
   --              AND A.RANK < B.RANK
   --              AND PMO_LOCATE(A.RANK, B.RANK));
   --  END_SQL_CHECK;
   --Cleaning----------------------------------------------------
   
   OPEN CIPP;
   
   LOOP
      FETCH CIPP INTO h_p_id, h_p_rank;
      IF CIPP%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      BEGIN
         INSERT INTO PMO_PIVOT_PROJECTS
         SELECT  DISTINCT
         W.ELEMENT_ID,
         RTRIM(W.RANK),
         W.ELEMENT_NAME,
         TO_DATE(SubStr(W.START_DT, 1, 10)),
         TO_DATE(SubStr(W.FINISH_DT, 1, 10)), 
         W.REF_CODE, 
         W.REFERENCE_NUMBER 
         FROM TMT_WBS W
         WHERE W.RANK LIKE h_p_rank || '%'
         AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND W.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 330+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(331) : views_pivot.sql(340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CIPP ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ', 344+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ(345) : views_pivot.sql(354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ', 350+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PRJ(351) : views_pivot.sql(360) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PRJ;
ALTER FUNCTION FC_INIT_PRJ COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_RES ==
CREATE OR REPLACE FUNCTION FC_INIT_RES
(
     h_ids IN OUT NOCOPY VARCHAR2
   , sh_h_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_id VARCHAR2(32);
   h_p_id VARCHAR2(32);
   h_p_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CRMyPools IS
         SELECT RTRIM(T.RANK)
         FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS T
         WHERE T.ELEMENT_ID = RA.ELEMENT_ID
         AND RA.RESOURCE_ID = h_rec_user
         AND BITAND(RA.PARTICIPANT, 2394) > 0
         AND RA.ELEMENT_TYPE = 11
         AND NOT EXISTS(SELECT PP.ELEMENT_ID FROM TMT_POOLS PP, RESOURCE_ASSIGNMENTS RR
         WHERE RR.RESOURCE_ID = h_rec_user
         AND PP.ELEMENT_ID = RR.ELEMENT_ID
         AND BITAND(RR.PARTICIPANT, 2394) > 0 AND RR.ELEMENT_TYPE = 11
         AND PP.LEVEL_ID < T.LEVEL_ID
         AND ((PP.RANK >= SUBSTR(T.RANK, 1, 8) AND PP.RANK <= T.RANK) 
         AND SUBSTR(T.RANK,1, CASE WHEN LENGTH(PP.RANK) > LENGTH(T.RANK) THEN 1 ELSE LENGTH(PP.RANK) END ) = PP.RANK));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_RES(' || 
       '''' || h_ids || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_RES(44) : views_pivot.sql(418) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_CDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_ASSIGNMENTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_TDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_CAL';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_MONTH1';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   If (Coalesce(h_type, 0) = 1) OR (h_ids IS NULL) Then
      --POOL Type
      
      If h_ids IS NULL Then
         OPEN CRMyPools;
         
         LOOP
            FETCH CRMyPools INTO h_rank;
            IF CRMyPools%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               EXIT;
            End If;
            
            BEGIN
               INSERT INTO PMO_PIVOT_TMP_RESOURCES
               (   RESOURCE_ID,
               RESOURCE_NAME,
               RESOURCE_EFFECTIVE_DATE,
               RESOURCE_DISCONTINUE_DATE,
               RESOURCE_WORK_LOCATION,
               RESOURCE_STATUS1,
               RESOURCE_STATUS2,
               RESOURCE_COMPETENCY,
               RESOURCE_PROFICIENCY,
               RESOURCE_GEO,
               RESOURCE_ORG )
               SELECT  P.ELEMENT_ID,
               R.FULL_NAME,
               COALESCE(R.EFFECTIVE_DATE,TO_DATE(SYSDATE)),
               R.DISCONTINUE_DATE,
               R.WORK_LOCATION,
               R.STATUS1_ID,
               R.STATUS2_ID,
               C3.ELEMENT_NAME AS RESOURCE_COMPETENCY,
               C2.ELEMENT_NAME AS RESOURCE_PROFICIENCY,
               G2.ELEMENT_NAME AS RESOURCE_GEO,
               O2.ELEMENT_NAME AS RESOURCE_ORG
               FROM TMT_POOLS P
               JOIN RESOURCES R ON R.RESOURCE_ID = P.ELEMENT_ID
               LEFT JOIN (TMT_COMPETENCIES C1
               JOIN TMT_COMPETENCIES C2 ON C2.ELEMENT_ID = C1.PARENT_ID
               JOIN TMT_COMPETENCIES C3 ON C3.ELEMENT_ID = C2.PARENT_ID)
               ON C1.RESOURCE_ID = R.RESOURCE_ID AND C1.DEFAULT_FLAG = '1'
               LEFT JOIN (TMT_GEOGRAPHIES G1 JOIN TMT_GEOGRAPHIES G2 ON G1.PARENT_ID = G2.ELEMENT_ID)
               ON R.RESOURCE_ID = G1.ELEMENT_ID
               LEFT JOIN (TMT_ORGANIZATIONS O1 JOIN TMT_ORGANIZATIONS O2 ON O1.PARENT_ID = O2.ELEMENT_ID)
               ON R.RESOURCE_ID = O1.ELEMENT_ID
               WHERE P.RANK LIKE h_rank || '%'
               AND P.TYPE_ID IN (PMO_CNST.SC_RESOURCE);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 141+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(142) : views_pivot.sql(516) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         
         BEGIN
            CLOSE CRMyPools ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 155+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(156) : views_pivot.sql(530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         h_total := 0;
         h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
         If Coalesce(h_total, 0) < 1 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES', 164+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES(165) : views_pivot.sql(539) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.INVALID_PARAMS;
         End If;
         
         h_count := 0;
         WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
            --pmo_substr(h_id, h_ids, h_count*32, 32);  //strncpy( h_id, h_ids[h_count*32], 32 );
            --NullifyStrPos(h_id, 32);                  //h_id[32] = '\0';
            h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
            
            BEGIN
               SELECT RTRIM(RANK) INTO h_rank
               FROM TMT_POOLS
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 185+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(186) : views_pivot.sql(560) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               INSERT INTO PMO_PIVOT_TMP_RESOURCES
               SELECT  P.ELEMENT_ID,
               R.FULL_NAME,
               COALESCE(R.EFFECTIVE_DATE,TO_DATE(SYSDATE)),
               R.DISCONTINUE_DATE,
               R.WORK_LOCATION,
               R.STATUS1_ID,
               R.STATUS2_ID,
               C3.ELEMENT_NAME AS RESOURCE_COMPETENCY,
               C2.ELEMENT_NAME AS RESOURCE_PROFICIENCY,
               G2.ELEMENT_NAME AS RESOURCE_GEO,
               O2.ELEMENT_NAME AS RESOURCE_ORG,
               PL.ELEMENT_NAME AS RESOURCE_POOL,
               RM.FULL_NAME AS RESOURCE_POOL_MANAGER
               FROM TMT_POOLS P
               JOIN RESOURCES R ON R.RESOURCE_ID = P.ELEMENT_ID
               JOIN TMT_POOLS PL
               ON PMO_ORASTD.LEFT(P.RANK, LENGTH(PL.RANK)) = PL.RANK
               AND LENGTH(PL.RANK)+4 = LENGTH(P.RANK)
               JOIN RESOURCE_ASSIGNMENTS RA
               ON RA.ELEMENT_ID = PL.ELEMENT_ID
               AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
               JOIN RESOURCES RM
               ON RM.RESOURCE_ID = RA.RESOURCE_ID
               LEFT JOIN (TMT_COMPETENCIES C1
               JOIN TMT_COMPETENCIES C2 ON C2.ELEMENT_ID = C1.PARENT_ID
               JOIN TMT_COMPETENCIES C3 ON C3.ELEMENT_ID = C2.PARENT_ID)
               ON C1.RESOURCE_ID = R.RESOURCE_ID AND C1.DEFAULT_FLAG = '1'
               LEFT JOIN (TMT_GEOGRAPHIES G1 JOIN TMT_GEOGRAPHIES G2 ON G1.PARENT_ID = G2.ELEMENT_ID)
               ON R.RESOURCE_ID = G1.ELEMENT_ID
               LEFT JOIN (TMT_ORGANIZATIONS O1 JOIN TMT_ORGANIZATIONS O2 ON O1.PARENT_ID = O2.ELEMENT_ID)
               ON R.RESOURCE_ID = O1.ELEMENT_ID
               WHERE P.RANK LIKE h_rank || '%'
               AND P.TYPE_ID IN (PMO_CNST.SC_RESOURCE);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 235+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(236) : views_pivot.sql(610) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_count := Coalesce(h_count, 0) + 1;
         END LOOP;
      End If;
   ElsIf Coalesce(h_type, 0) = 2 Then
      --RESOURCE Type
      h_total := 0;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES', 249+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES(250) : views_pivot.sql(624) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);  //   strncpy( h_id, h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                  //h_id[32] = '\0';
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            INSERT INTO PMO_PIVOT_TMP_RESOURCES
            SELECT  P.ELEMENT_ID,
            R.FULL_NAME,
            COALESCE(R.EFFECTIVE_DATE,TO_DATE(SYSDATE)),
            R.DISCONTINUE_DATE,
            R.WORK_LOCATION,
            R.STATUS1_ID,
            R.STATUS2_ID,
            C3.ELEMENT_NAME AS RESOURCE_COMPETENCY,
            C2.ELEMENT_NAME AS RESOURCE_PROFICIENCY,
            G2.ELEMENT_NAME AS RESOURCE_GEO,
            O2.ELEMENT_NAME AS RESOURCE_ORG,
            PL.ELEMENT_NAME AS RESOURCE_POOL,
            RM.FULL_NAME AS RESOURCE_POOL_MANAGER
            FROM TMT_POOLS P
            JOIN RESOURCES R
            ON R.RESOURCE_ID = P.ELEMENT_ID
            JOIN TMT_POOLS PL
            ON PMO_ORASTD.LEFT(P.RANK, LENGTH(PL.RANK)) = PL.RANK
            AND LENGTH(PL.RANK)+4 = LENGTH(P.RANK)
            JOIN RESOURCE_ASSIGNMENTS RA
            ON RA.ELEMENT_ID = PL.ELEMENT_ID
            AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
            JOIN RESOURCES RM
            ON RM.RESOURCE_ID = RA.RESOURCE_ID
            LEFT JOIN (TMT_COMPETENCIES C1
            JOIN TMT_COMPETENCIES C2 ON C2.ELEMENT_ID = C1.PARENT_ID
            JOIN TMT_COMPETENCIES C3 ON C3.ELEMENT_ID = C2.PARENT_ID)
            ON C1.RESOURCE_ID = R.RESOURCE_ID
            AND C1.DEFAULT_FLAG = '1'
            LEFT JOIN (TMT_GEOGRAPHIES G1 JOIN TMT_GEOGRAPHIES G2 ON G1.PARENT_ID = G2.ELEMENT_ID)
            ON R.RESOURCE_ID = G1.ELEMENT_ID
            LEFT JOIN (TMT_ORGANIZATIONS O1 JOIN TMT_ORGANIZATIONS O2 ON O1.PARENT_ID = O2.ELEMENT_ID)
            ON R.RESOURCE_ID = O1.ELEMENT_ID
            WHERE P.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 306+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(307) : views_pivot.sql(681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   --=====================================================================
   
   --POPULATE DATA
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_CDY
      SELECT CDY.*
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN CALENDAR_DAY_OF_YEAR CDY
      ON CDY.ELEMENT_ID = R.RESOURCE_ID
      AND CDY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND CDY.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 335+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(336) : views_pivot.sql(710) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_ASSIGNMENTS
      SELECT  TA.PROJECT_ID,
      TA.TSK_ASSIGNMENT_ID,
      TA.BILLABLE
      FROM TASK_ASSIGNMENTS TA
      JOIN PMO_PIVOT_TMP_RESOURCES R
      ON R.RESOURCE_ID = TA.RESOURCE_ID
      WHERE TA.PROJECT_ID <> TA.TASK_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 359+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(360) : views_pivot.sql(734) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_TDY
      SELECT TDY.*
      FROM TASK_DAY_OF_YEAR TDY
      JOIN PMO_PIVOT_ASSIGNMENTS A
      ON TDY.PROJECT_ID = A.PROJECT_ID
      AND TDY.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
      AND TDY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 382+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(383) : views_pivot.sql(757) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --POPULATE CDY DATA EXISTS IN TDY BUT NOT IN CDY!
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_CDY ( ELEMENT_ID, DAY_YEAR, DAY_WEEK, WEEK_OF, MONTH_OF, YEAR_OF )
      (
      SELECT DISTINCT TDY.RESOURCE_ID, TDY.DAY_YEAR, PMO_ORASTD.DAYOFWEEK(TDY.DAY_YEAR), PMO_ORASTD.WEEK_ISO(TDY.DAY_YEAR), PMO_ORASTD.MONTH(TDY.DAY_YEAR), PMO_ORASTD.YEAR(TDY.DAY_YEAR)
      FROM PMO_PIVOT_TMP_TDY TDY
      MINUS
      SELECT CDY.ELEMENT_ID, CDY.DAY_YEAR, PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR), PMO_ORASTD.WEEK_ISO(CDY.DAY_YEAR), PMO_ORASTD.MONTH(CDY.DAY_YEAR), PMO_ORASTD.YEAR(CDY.DAY_YEAR)
      FROM PMO_PIVOT_TMP_CDY CDY
      );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 407+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(408) : views_pivot.sql(782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_CAL
      SELECT  R.RESOURCE_ID,
      P.ELEMENT_ID AS PROJECT_ID,
      P.ELEMENT_NAME AS PROJECT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.DAY_YEAR AS RESOURCE_DAY,
      SUM(D.SCHED_MIN) AS RESOURCE_CALENDAR,
      SUM(CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END) AS RESOURCE_PROPOSED,
      SUM(CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END) AS RESOURCE_SCHEDULED,
      SUM(D.ACTUAL_MIN) AS RESOURCE_ACTUAL,
      SUM(CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_PROPOSED,
      SUM(CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_SCHEDULED,
      SUM(D.ACTUAL_MIN * A.BILLABLE) AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_PIVOT_TMP_CDY C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      LEFT JOIN (PMO_PIVOT_TMP_TDY D
      JOIN PMO_PIVOT_ASSIGNMENTS A
      ON A.PROJECT_ID = D.PROJECT_ID
      AND A.TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID
      JOIN TMT_WBS P
      ON P.PROJECT_ID = A.PROJECT_ID
      AND P.ELEMENT_ID = A.PROJECT_ID )
      ON D.RESOURCE_ID = C.ELEMENT_ID
      AND D.DAY_YEAR = C.DAY_YEAR
      WHERE R.RESOURCE_ID IS NOT NULL
      GROUP BY R.RESOURCE_ID,
      P.ELEMENT_ID,
      P.ELEMENT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR),
      PMO_ORASTD.MONTH(C.DAY_YEAR),
      C.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 459+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(460) : views_pivot.sql(834) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_MONTH1
      SELECT  R.RESOURCE_ID,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      SUM(C.AVAILABLE_MIN) AS RESOURCE_AVAILABLE
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN CALENDAR_DAY_OF_YEAR C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      GROUP BY R.RESOURCE_ID, PMO_ORASTD.YEAR(C.DAY_YEAR), PMO_ORASTD.MONTH(C.DAY_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES', 487+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES(488) : views_pivot.sql(862) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES', 494+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES(495) : views_pivot.sql(869) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_RES;
ALTER FUNCTION FC_INIT_RES COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_RES_WEEK ==
CREATE OR REPLACE FUNCTION FC_INIT_RES_WEEK
(
     h_ids IN OUT NOCOPY VARCHAR2
   , sh_h_type PLS_INTEGER
   , h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type PLS_INTEGER := sh_h_type;
   h_id VARCHAR2(32);
   h_p_id VARCHAR2(32);
   h_p_rank VARCHAR2(200);
   h_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_RES_WEEK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_RES_WEEK'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_RES_WEEK(' || 
       '''' || h_ids || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_WEEK', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_RES_WEEK(28) : views_pivot.sql(911) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RESOURCES_W';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_CAL_W';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_WEEK1';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   If Coalesce(h_type, 0) = 1 Then
      --POOL Type
      h_total := 0;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_WEEK', 55+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES_WEEK(56) : views_pivot.sql(939) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);  //  strncpy( h_id, h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                  //h_id[32] = '\0';
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            SELECT RTRIM(RANK) INTO h_rank
            FROM TMT_POOLS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES_WEEK', 76+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES_WEEK(77) : views_pivot.sql(960) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            INSERT INTO PMO_PIVOT_TMP_RESOURCES_W
            SELECT  P.ELEMENT_ID,
            R.FULL_NAME,
            COALESCE(R.EFFECTIVE_DATE,TO_DATE(SYSDATE)),
            R.DISCONTINUE_DATE,
            R.WORK_LOCATION,
            R.STATUS1_ID,
            R.STATUS2_ID,
            C3.ELEMENT_NAME AS RESOURCE_COMPETENCY,
            C2.ELEMENT_NAME AS RESOURCE_PROFICIENCY,
            G2.ELEMENT_NAME AS RESOURCE_GEO,
            O2.ELEMENT_NAME AS RESOURCE_ORG
            FROM TMT_POOLS P
            JOIN RESOURCES R
            ON R.RESOURCE_ID = P.ELEMENT_ID
            LEFT JOIN (TMT_COMPETENCIES C1
            JOIN TMT_COMPETENCIES C2 ON C2.ELEMENT_ID = C1.PARENT_ID
            JOIN TMT_COMPETENCIES C3 ON C3.ELEMENT_ID = C2.PARENT_ID)
            ON C1.RESOURCE_ID = R.RESOURCE_ID
            AND C1.DEFAULT_FLAG = '1'
            LEFT JOIN (TMT_GEOGRAPHIES G1 JOIN TMT_GEOGRAPHIES G2 ON G1.PARENT_ID = G2.ELEMENT_ID)
            ON R.RESOURCE_ID = G1.ELEMENT_ID
            LEFT JOIN (TMT_ORGANIZATIONS O1 JOIN TMT_ORGANIZATIONS O2 ON O1.PARENT_ID = O2.ELEMENT_ID)
            ON R.RESOURCE_ID = O1.ELEMENT_ID
            WHERE P.RANK LIKE h_rank || '%'
            AND P.TYPE_ID IN (PMO_CNST.SC_RESOURCE);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES_WEEK', 118+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES_WEEK(119) : views_pivot.sql(1002) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   ElsIf Coalesce(h_type, 0) = 2 Then
      --RESOURCE Type
      h_total := 0;
      h_total := Trunc((Coalesce(Length(h_ids), 0) + 1) / 32);
      If Coalesce(h_total, 0) < 1 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_WEEK', 131+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES_WEEK(132) : views_pivot.sql(1015) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.INVALID_PARAMS;
      End If;
      
      h_count := 0;
      WHILE Coalesce(h_count, 0) < Coalesce(h_total, 0) LOOP
         --pmo_substr(h_id, h_ids, h_count*32, 32);    //strncpy( h_id, h_ids[h_count*32], 32 );
         --NullifyStrPos(h_id, 32);                  //h_id[32] = '\0';
         h_id := SubStr(h_ids, Coalesce(h_count, 0) * 32 + 1, 32);
         
         BEGIN
            INSERT INTO PMO_PIVOT_TMP_RESOURCES_W
            SELECT  P.ELEMENT_ID,
            R.FULL_NAME,
            COALESCE(R.EFFECTIVE_DATE,TO_DATE(SYSDATE)),
            R.DISCONTINUE_DATE,
            R.WORK_LOCATION,
            R.STATUS1_ID,
            R.STATUS2_ID,
            C3.ELEMENT_NAME AS RESOURCE_COMPETENCY,
            C2.ELEMENT_NAME AS RESOURCE_PROFICIENCY,
            G2.ELEMENT_NAME AS RESOURCE_GEO,
            O2.ELEMENT_NAME AS RESOURCE_ORG
            FROM TMT_POOLS P
            JOIN RESOURCES R
            ON R.RESOURCE_ID = P.ELEMENT_ID
            LEFT JOIN (TMT_COMPETENCIES C1
            JOIN TMT_COMPETENCIES C2 ON C2.ELEMENT_ID = C1.PARENT_ID
            JOIN TMT_COMPETENCIES C3 ON C3.ELEMENT_ID = C2.PARENT_ID)
            ON C1.RESOURCE_ID = R.RESOURCE_ID
            AND C1.DEFAULT_FLAG = '1'
            LEFT JOIN (TMT_GEOGRAPHIES G1 JOIN TMT_GEOGRAPHIES G2 ON G1.PARENT_ID = G2.ELEMENT_ID)
            ON R.RESOURCE_ID = G1.ELEMENT_ID
            LEFT JOIN (TMT_ORGANIZATIONS O1 JOIN TMT_ORGANIZATIONS O2 ON O1.PARENT_ID = O2.ELEMENT_ID)
            ON R.RESOURCE_ID = O1.ELEMENT_ID
            WHERE P.ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES_WEEK', 178+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES_WEEK(179) : views_pivot.sql(1062) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_count := Coalesce(h_count, 0) + 1;
      END LOOP;
   End If;
   --=====================================================================
   
   --POPULATE DATA
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_CAL_W
      SELECT  R.RESOURCE_ID,
      P.ELEMENT_ID AS PROJECT_ID,
      P.ELEMENT_NAME AS PROJECT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.WEEK_OF AS RESOURCE_WEEK,
      C.DAY_YEAR AS RESOURCE_DAY,
      SUM(D.SCHED_MIN) AS RESOURCE_CALENDAR,
      SUM(CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END) AS RESOURCE_PROPOSED,
      SUM(CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END) AS RESOURCE_SCHEDULED,
      SUM(D.ACTUAL_MIN) AS RESOURCE_ACTUAL,
      SUM(CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_PROPOSED,
      SUM(CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_SCHEDULED,
      SUM(D.ACTUAL_MIN * A.BILLABLE) AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_TMP_RESOURCES_W R
      JOIN CALENDAR_DAY_OF_YEAR C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      LEFT JOIN (TASK_DAY_OF_YEAR D
      JOIN TASK_ASSIGNMENTS A
      ON A.PROJECT_ID = D.PROJECT_ID
      AND A.TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID
      JOIN TMT_WBS P
      ON P.PROJECT_ID = A.PROJECT_ID
      AND P.ELEMENT_ID = A.PROJECT_ID )
      ON D.RESOURCE_ID = C.ELEMENT_ID
      AND D.DAY_YEAR = C.DAY_YEAR
      GROUP BY R.RESOURCE_ID,
      P.ELEMENT_ID,
      P.ELEMENT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR),
      PMO_ORASTD.MONTH(C.DAY_YEAR),
      C.WEEK_OF,
      C.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES_WEEK', 237+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES_WEEK(238) : views_pivot.sql(1121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_WEEK1
      SELECT  R.RESOURCE_ID,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.WEEK_OF AS RESOURCE_WEEK,
      SUM(C.AVAILABLE_MIN) AS RESOURCE_AVAILABLE
      FROM PMO_PIVOT_TMP_RESOURCES_W R
      JOIN CALENDAR_DAY_OF_YEAR C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      GROUP BY R.RESOURCE_ID, PMO_ORASTD.YEAR(C.DAY_YEAR), PMO_ORASTD.MONTH(C.DAY_YEAR), C.WEEK_OF;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES_WEEK', 266+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES_WEEK(267) : views_pivot.sql(1150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_WEEK', 273+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES_WEEK(274) : views_pivot.sql(1157) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_RES_WEEK;
ALTER FUNCTION FC_INIT_RES_WEEK COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PRJ_RES ==
CREATE OR REPLACE FUNCTION FC_INIT_PRJ_RES
(
     h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PRJ_RES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PRJ_RES'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PRJ_RES(' || 
       COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_RES', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PRJ_RES(15) : views_pivot.sql(1186) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_CDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_ASSIGNMENTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_TDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_CAL';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_MONTH';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --trace_printf("RES_START\n");
   --trace_flush();
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RESOURCES
      SELECT  R.RESOURCE_ID,
      R.FULL_NAME,
      COALESCE(R.EFFECTIVE_DATE,TO_DATE(SYSDATE)),
      R.DISCONTINUE_DATE,
      R.WORK_LOCATION,
      R.STATUS1_ID,
      R.STATUS2_ID,
      C3.ELEMENT_NAME AS RESOURCE_COMPETENCY,
      C2.ELEMENT_NAME AS RESOURCE_PROFICIENCY,
      G2.ELEMENT_NAME AS RESOURCE_GEO,
      O2.ELEMENT_NAME AS RESOURCE_ORG,
      P2.ELEMENT_NAME AS RESOURCE_POOL,
      RM.FULL_NAME AS RESOURCE_POOL_MANAGER
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND (PA.ESTIMATED_SCHED_EFFORT + PA.ESTIMATED_PLANNED_EFFORT + PA.PROPOSED_WORK) > 0
      JOIN RESOURCES R
      ON R.RESOURCE_ID = PA.RESOURCE_ID
      JOIN TMT_POOLS P1
      ON R.RESOURCE_ID = P1.ELEMENT_ID
      JOIN TMT_POOLS P2
      ON P1.PARENT_ID = P2.ELEMENT_ID
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.ELEMENT_ID = P2.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RA.RESOURCE_ID
      LEFT JOIN (TMT_COMPETENCIES C1
      JOIN TMT_COMPETENCIES C2
      ON C2.ELEMENT_ID = C1.PARENT_ID
      JOIN TMT_COMPETENCIES C3
      ON C3.ELEMENT_ID = C2.PARENT_ID)
      ON C1.RESOURCE_ID = R.RESOURCE_ID
      AND C1.DEFAULT_FLAG = '1'
      LEFT JOIN (TMT_GEOGRAPHIES G1
      JOIN TMT_GEOGRAPHIES G2
      ON G1.PARENT_ID = G2.ELEMENT_ID)
      ON R.RESOURCE_ID = G1.ELEMENT_ID
      LEFT JOIN (TMT_ORGANIZATIONS O1
      JOIN TMT_ORGANIZATIONS O2
      ON O1.PARENT_ID = O2.ELEMENT_ID)
      ON R.RESOURCE_ID = O1.ELEMENT_ID
      
      GROUP BY R.RESOURCE_ID,
      R.FULL_NAME,
      R.EFFECTIVE_DATE,
      R.DISCONTINUE_DATE,
      R.WORK_LOCATION,
      R.STATUS1_ID,
      R.STATUS2_ID,
      C3.ELEMENT_NAME,
      C2.ELEMENT_NAME,
      P2.ELEMENT_NAME,
      RM.FULL_NAME,
      G2.ELEMENT_NAME,
      O2.ELEMENT_NAME;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES', 119+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES(120) : views_pivot.sql(1291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END_RES_STEP 1\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_CDY
      SELECT CDY.*
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN CALENDAR_DAY_OF_YEAR CDY
      ON CDY.ELEMENT_ID = R.RESOURCE_ID
      AND CDY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND CDY.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES(145) : views_pivot.sql(1316) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END_RES_STEP 1(A)\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_PIVOT_ASSIGNMENTS
      SELECT  TA.PROJECT_ID,
      TA.TSK_ASSIGNMENT_ID,
      TA.BILLABLE
      FROM TASK_ASSIGNMENTS TA
      JOIN PMO_PIVOT_PROJECTS P
      ON P.PROJECT_ID = TA.PROJECT_ID
      JOIN PMO_PIVOT_TMP_RESOURCES R
      ON R.RESOURCE_ID = TA.RESOURCE_ID
      WHERE TA.PROJECT_ID <> TA.TASK_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES', 172+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES(173) : views_pivot.sql(1344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END_RES_STEP 1(B)\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_TDY
      SELECT TDY.*
      FROM TASK_DAY_OF_YEAR TDY
      JOIN PMO_PIVOT_ASSIGNMENTS A
      ON TDY.PROJECT_ID = A.PROJECT_ID
      AND TDY.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
      AND TDY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES', 197+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES(198) : views_pivot.sql(1369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END_RES_STEP 1(C)\n");
   --trace_flush();
   
   --POPULATE CDY DATA EXISTS IN TDY BUT NOT IN CDY!
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_CDY ( ELEMENT_ID, DAY_YEAR, DAY_WEEK, WEEK_OF, MONTH_OF, YEAR_OF )
      (
      SELECT DISTINCT TDY.RESOURCE_ID, TDY.DAY_YEAR, PMO_ORASTD.DAYOFWEEK(TDY.DAY_YEAR), PMO_ORASTD.WEEK_ISO(TDY.DAY_YEAR), PMO_ORASTD.MONTH(TDY.DAY_YEAR), PMO_ORASTD.YEAR(TDY.DAY_YEAR)
      FROM PMO_PIVOT_TMP_TDY TDY
      MINUS
      SELECT CDY.ELEMENT_ID, CDY.DAY_YEAR, PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR), PMO_ORASTD.WEEK_ISO(CDY.DAY_YEAR), PMO_ORASTD.MONTH(CDY.DAY_YEAR), PMO_ORASTD.YEAR(CDY.DAY_YEAR)
      FROM PMO_PIVOT_TMP_CDY CDY
      );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES(225) : views_pivot.sql(1396) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --POPULATE DATA
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_CAL
      SELECT  PA.RESOURCE_ID,
      P.PROJECT_ID,
      P.PROJECT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.DAY_YEAR AS RESOURCE_DAY,
      SUM(D.SCHED_MIN) AS RESOURCE_CALENDAR,
      SUM(CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END) AS RESOURCE_PROPOSED,
      SUM(CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END) AS RESOURCE_SCHEDULED,
      SUM(D.ACTUAL_MIN) AS RESOURCE_ACTUAL,
      SUM(CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_PROPOSED,
      SUM(CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_SCHEDULED,
      SUM(D.ACTUAL_MIN * A.BILLABLE) AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND (PA.ESTIMATED_SCHED_EFFORT + PA.ESTIMATED_PLANNED_EFFORT + PA.PROPOSED_WORK) > 0
      JOIN PMO_PIVOT_TMP_RESOURCES R
      ON R.RESOURCE_ID = PA.RESOURCE_ID
      JOIN PMO_PIVOT_TMP_CDY C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      LEFT JOIN (PMO_PIVOT_TMP_TDY D
      JOIN PMO_PIVOT_ASSIGNMENTS A
      ON A.PROJECT_ID = D.PROJECT_ID
      AND A.TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID)
      ON D.PROJECT_ID = PA.PROJECT_ID
      AND D.RESOURCE_ID = PA.RESOURCE_ID
      AND D.DAY_YEAR = C.DAY_YEAR
      GROUP BY PA.RESOURCE_ID,
      P.PROJECT_ID,
      P.PROJECT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR),
      PMO_ORASTD.MONTH(C.DAY_YEAR),
      C.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES', 279+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES(280) : views_pivot.sql(1451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END_RES_STEP 2\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_MONTH (
      RESOURCE_ID,
      RESOURCE_YEAR,
      RESOURCE_QUARTER,
      RESOURCE_MONTH,
      RESOURCE_AVAILABLE )
      SELECT  R.RESOURCE_ID,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      SUM(C.AVAILABLE_MIN) AS RESOURCE_AVAILABLE
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_PIVOT_TMP_CDY C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      GROUP BY R.RESOURCE_ID, PMO_ORASTD.YEAR(C.DAY_YEAR), PMO_ORASTD.MONTH(C.DAY_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES', 314+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES(315) : views_pivot.sql(1486) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END_RES_STEP 3\n");
   --trace_flush();
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_RES', 323+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PRJ_RES(324) : views_pivot.sql(1495) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PRJ_RES;
ALTER FUNCTION FC_INIT_PRJ_RES COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PRJ_RES_WEEK ==
CREATE OR REPLACE FUNCTION FC_INIT_PRJ_RES_WEEK
(
     h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PRJ_RES_WEEK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PRJ_RES_WEEK'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PRJ_RES_WEEK(' || 
       COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_RES_WEEK', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PRJ_RES_WEEK(15) : views_pivot.sql(1524) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RESOURCES_W';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_CAL_W';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES_WEEK';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RESOURCES_W
      SELECT  DISTINCT
      R.RESOURCE_ID,
      R.FULL_NAME,
      COALESCE(R.EFFECTIVE_DATE,TO_DATE(SYSDATE)),
      R.DISCONTINUE_DATE,
      R.WORK_LOCATION,
      R.STATUS1_ID,
      R.STATUS2_ID,
      C3.ELEMENT_NAME AS RESOURCE_COMPETENCY,
      C2.ELEMENT_NAME AS RESOURCE_PROFICIENCY,
      G2.ELEMENT_NAME AS RESOURCE_GEO,
      O2.ELEMENT_NAME AS RESOURCE_ORG
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND (PA.ESTIMATED_SCHED_EFFORT + PA.ESTIMATED_PLANNED_EFFORT + PA.PROPOSED_WORK) > 0
      JOIN RESOURCES R
      ON R.RESOURCE_ID = PA.RESOURCE_ID
      LEFT JOIN (TMT_COMPETENCIES C1
      JOIN TMT_COMPETENCIES C2 ON C2.ELEMENT_ID = C1.PARENT_ID
      JOIN TMT_COMPETENCIES C3 ON C3.ELEMENT_ID = C2.PARENT_ID)
      ON C1.RESOURCE_ID = R.RESOURCE_ID
      AND C1.DEFAULT_FLAG = '1'
      LEFT JOIN (TMT_GEOGRAPHIES G1 JOIN TMT_GEOGRAPHIES G2 ON G1.PARENT_ID = G2.ELEMENT_ID)
      ON R.RESOURCE_ID = G1.ELEMENT_ID
      LEFT JOIN (TMT_ORGANIZATIONS O1 JOIN TMT_ORGANIZATIONS O2 ON O1.PARENT_ID = O2.ELEMENT_ID)
      ON R.RESOURCE_ID = O1.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES_WEEK', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES_WEEK(76) : views_pivot.sql(1585) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --POPULATE DATA
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_CAL_W
      SELECT  PA.RESOURCE_ID,
      P.PROJECT_ID,
      P.PROJECT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.WEEK_OF AS RESOURCE_WEEK,
      C.DAY_YEAR AS RESOURCE_DAY,
      SUM(D.SCHED_MIN) AS RESOURCE_CALENDAR,
      CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END AS RESOURCE_PROPOSED,
      CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END AS RESOURCE_SCHEDULED,
      D.ACTUAL_MIN AS RESOURCE_ACTUAL,
      (CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_PROPOSED,
      (CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_SCHEDULED,
      (D.ACTUAL_MIN * A.BILLABLE) AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND (PA.ESTIMATED_SCHED_EFFORT + PA.ESTIMATED_PLANNED_EFFORT + PA.PROPOSED_WORK) > 0
      JOIN PMO_PIVOT_TMP_RESOURCES_W R
      ON R.RESOURCE_ID = PA.RESOURCE_ID
      JOIN CALENDAR_DAY_OF_YEAR C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN (CASE WHEN P.PROJECT_START > TO_DATE(SubStr(h_start_date, 1, 10)) THEN P.PROJECT_START ELSE TO_DATE(SubStr(h_start_date, 1, 10))END) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      LEFT JOIN (TASK_DAY_OF_YEAR D
      JOIN TASK_ASSIGNMENTS A
      ON A.TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID )
      ON D.PROJECT_ID = PA.PROJECT_ID
      AND D.RESOURCE_ID = PA.RESOURCE_ID
      AND D.DAY_YEAR = C.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES_WEEK', 124+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES_WEEK(125) : views_pivot.sql(1634) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES_WEEK (
      RESOURCE_ID,
      RESOURCE_YEAR,
      RESOURCE_QUARTER,
      RESOURCE_MONTH,
      RESOURCE_WEEK,
      RESOURCE_AVAILABLE )
      SELECT  R.RESOURCE_ID,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.WEEK_OF AS RESOURCE_MONTH,
      SUM(C.AVAILABLE_MIN) AS RESOURCE_AVAILABLE
      FROM PMO_PIVOT_TMP_RESOURCES_W R
      JOIN CALENDAR_DAY_OF_YEAR C
      ON C.ELEMENT_ID = R.RESOURCE_ID
      AND C.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      GROUP BY R.RESOURCE_ID, PMO_ORASTD.YEAR(C.DAY_YEAR), PMO_ORASTD.MONTH(C.DAY_YEAR), C.WEEK_OF;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_RES_WEEK', 159+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_RES_WEEK(160) : views_pivot.sql(1669) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_RES_WEEK', 166+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PRJ_RES_WEEK(167) : views_pivot.sql(1676) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PRJ_RES_WEEK;
ALTER FUNCTION FC_INIT_PRJ_RES_WEEK COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PRJ_PRF ==
CREATE OR REPLACE FUNCTION FC_INIT_PRJ_PRF
(
     h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PRJ_PRF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PRJ_PRF'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PRJ_PRF(' || 
       COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_PRF', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PRJ_PRF(15) : views_pivot.sql(1705) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_PROFILES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PF_CDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PF_ASSIGNMENTS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PF_TDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_PRF_CAL';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_PRF_MONTH';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_PROFILES
      SELECT  R.PROFILE_ID,
      R.PROFILE_NAME,
      C2.ELEMENT_NAME AS PROFILE_COMPETENCY,
      C1.ELEMENT_NAME AS PROFILE_PROFICIENCY,
      P.ELEMENT_NAME AS PROFILE_POOL,
      RM.FULL_NAME AS PROFILE_POOL_MANAGER,
      G.ELEMENT_NAME AS PROFILE_GEO,
      O.ELEMENT_NAME AS PROFILE_ORG
      FROM PMO_PIVOT_PROJECTS P1
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P1.PROJECT_ID
      AND PA.RESOURCE_TYPE = '1'
      JOIN PROFILES R
      ON R.PROFILE_ID = PA.RESOURCE_ID
      JOIN TMT_COMPETENCIES C1
      ON C1.ELEMENT_ID = R.ROLE_ID
      JOIN TMT_COMPETENCIES C2
      ON C2.ELEMENT_ID = C1.PARENT_ID
      LEFT JOIN TMT_POOLS P
      ON R.POOL_ID = P.ELEMENT_ID
      LEFT JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.ELEMENT_ID = P.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      LEFT JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RA.RESOURCE_ID
      LEFT JOIN TMT_GEOGRAPHIES G
      ON R.GEO_ID = G.ELEMENT_ID
      LEFT JOIN TMT_ORGANIZATIONS O
      ON R.ORG_ID = O.ELEMENT_ID
      
      GROUP BY R.PROFILE_ID,
      R.PROFILE_NAME,
      C2.ELEMENT_NAME,
      C1.ELEMENT_NAME,
      P.ELEMENT_NAME,
      RM.FULL_NAME,
      G.ELEMENT_NAME,
      O.ELEMENT_NAME;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF(99) : views_pivot.sql(1789) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --POPULATE DATA
   BEGIN
      INSERT INTO PMO_PIVOT_PF_CDY
      SELECT CDY.*
      FROM PMO_PIVOT_PROJECTS P
      JOIN CALENDAR_DAY_OF_YEAR CDY
      ON CDY.ELEMENT_ID = P.PROJECT_ID
      AND CDY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF', 121+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF(122) : views_pivot.sql(1812) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_PF_ASSIGNMENTS
      SELECT  TA.PROJECT_ID,
      TA.TSK_ASSIGNMENT_ID,
      TA.BILLABLE
      FROM TASK_ASSIGNMENTS TA
      JOIN PMO_PIVOT_TMP_PROFILES R
      ON R.PROFILE_ID = TA.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF(145) : views_pivot.sql(1835) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_PF_TDY
      SELECT TDY.*
      FROM TASK_DAY_OF_YEAR TDY
      JOIN PMO_PIVOT_ASSIGNMENTS A
      ON TDY.PROJECT_ID = A.PROJECT_ID
      AND TDY.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
      AND TDY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF', 167+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF(168) : views_pivot.sql(1858) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_PRF_CAL
      SELECT  PA.RESOURCE_ID,
      P.PROJECT_ID,
      P.PROJECT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.DAY_YEAR AS RESOURCE_DAY,
      C.AVAILABLE_MIN AS RESOURCE_CALENDAR,
      CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END AS RESOURCE_PROPOSED,
      CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END AS RESOURCE_SCHEDULED,
      (D.ACTUAL_MIN) AS RESOURCE_ACTUAL,
      (CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_PROPOSED,
      (CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_SCHEDULED,
      (D.ACTUAL_MIN * A.BILLABLE) AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND PA.RESOURCE_TYPE = '1'
      JOIN PMO_PIVOT_PF_CDY C
      ON C.ELEMENT_ID = PA.PROJECT_ID
      AND C.DAY_YEAR BETWEEN (CASE WHEN P.PROJECT_START > TO_DATE(SubStr(h_start_date, 1, 10)) THEN P.PROJECT_START ELSE TO_DATE(SubStr(h_start_date, 1, 10))END) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      LEFT JOIN (PMO_PIVOT_PF_TDY D
      JOIN PMO_PIVOT_PF_ASSIGNMENTS A
      ON A.TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID )
      ON D.PROJECT_ID = PA.PROJECT_ID
      AND D.RESOURCE_ID = PA.RESOURCE_ID
      AND D.DAY_YEAR = C.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF', 211+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF(212) : views_pivot.sql(1902) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_PRF_MONTH
      SELECT  P.PROJECT_ID,
      P.PROJECT_NAME,
      PA.RESOURCE_ID,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      SUM(C.AVAILABLE_MIN) AS RESOURCE_AVAILABLE
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND PA.RESOURCE_TYPE = '1'
      JOIN PMO_PIVOT_PF_CDY C
      ON C.ELEMENT_ID = PA.PROJECT_ID
      AND C.DAY_YEAR BETWEEN (CASE WHEN P.PROJECT_START > TO_DATE(SubStr(h_start_date, 1, 10)) THEN P.PROJECT_START ELSE TO_DATE(SubStr(h_start_date, 1, 10))END) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      GROUP BY P.PROJECT_ID, P.PROJECT_NAME, PA.RESOURCE_ID, PMO_ORASTD.YEAR(C.DAY_YEAR), PMO_ORASTD.MONTH(C.DAY_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF', 243+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF(244) : views_pivot.sql(1934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_PRF', 250+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PRJ_PRF(251) : views_pivot.sql(1941) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PRJ_PRF;
ALTER FUNCTION FC_INIT_PRJ_PRF COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PRJ_PRF_WEEK ==
CREATE OR REPLACE FUNCTION FC_INIT_PRJ_PRF_WEEK
(
     h_start_date IN OUT NOCOPY DATE
   , h_finish_date IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PRJ_PRF_WEEK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PRJ_PRF_WEEK'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PRJ_PRF_WEEK(' || 
       COALESCE(NULLIF('''' || h_start_date || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_finish_date || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_PRF_WEEK', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PRJ_PRF_WEEK(15) : views_pivot.sql(1970) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_PROFILES_W';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_PRF_CAL_W';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_PRF_WEEK';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   --=====================================================================
   -- Populate Temporary Table
   --=====================================================================
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_PROFILES_W
      SELECT  DISTINCT
      R.PROFILE_ID,
      R.PROFILE_NAME,
      C2.ELEMENT_NAME AS PROFILE_COMPETENCY,
      C1.ELEMENT_NAME AS PROFILE_PROFICIENCY
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND (PA.ESTIMATED_SCHED_EFFORT + PA.ESTIMATED_PLANNED_EFFORT + PA.PROPOSED_WORK) > 0
      AND PA.RESOURCE_TYPE = '1'
      JOIN PROFILES R
      ON R.PROFILE_ID = PA.RESOURCE_ID
      JOIN TMT_COMPETENCIES C1
      ON C1.ELEMENT_ID = R.ROLE_ID
      JOIN TMT_COMPETENCIES C2
      ON C2.ELEMENT_ID = C1.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF_WEEK', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF_WEEK(65) : views_pivot.sql(2020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --POPULATE DATA
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_PRF_CAL_W
      SELECT  PA.RESOURCE_ID,
      P.PROJECT_ID,
      P.PROJECT_NAME,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.WEEK_OF AS RESOURCE_WEEK,
      C.DAY_YEAR AS RESOURCE_DAY,
      C.AVAILABLE_MIN AS RESOURCE_CALENDAR,
      CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END AS RESOURCE_PROPOSED,
      CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END AS RESOURCE_SCHEDULED,
      (D.ACTUAL_MIN) AS RESOURCE_ACTUAL,
      (CASE WHEN D.BIT_FLAG = '0' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_PROPOSED,
      (CASE WHEN D.BIT_FLAG = '2' THEN D.SCHED_MIN ELSE 0 END * A.BILLABLE) AS RESOURCE_BILLABLE_SCHEDULED,
      (D.ACTUAL_MIN * A.BILLABLE) AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND (PA.ESTIMATED_SCHED_EFFORT + PA.ESTIMATED_PLANNED_EFFORT + PA.PROPOSED_WORK) > 0
      AND PA.RESOURCE_TYPE = '1'
      JOIN CALENDAR_DAY_OF_YEAR C
      ON C.ELEMENT_ID = PA.PROJECT_ID
      AND C.DAY_YEAR BETWEEN (CASE WHEN P.PROJECT_START > TO_DATE(SubStr(h_start_date, 1, 10)) THEN P.PROJECT_START ELSE TO_DATE(SubStr(h_start_date, 1, 10))END) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      LEFT JOIN (TASK_DAY_OF_YEAR D
      JOIN TASK_ASSIGNMENTS A
      ON A.TSK_ASSIGNMENT_ID = D.TSK_ASSIGNMENT_ID )
      ON D.PROJECT_ID = PA.PROJECT_ID
      AND D.RESOURCE_ID = PA.RESOURCE_ID
      AND D.DAY_YEAR = C.DAY_YEAR;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF_WEEK', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF_WEEK(112) : views_pivot.sql(2067) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_PRF_WEEK
      SELECT  P.PROJECT_ID,
      P.PROJECT_NAME,
      PA.RESOURCE_ID,
      PMO_ORASTD.YEAR(C.DAY_YEAR) AS RESOURCE_YEAR,
      CASE WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) < 4 THEN 1 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 4 AND 6 THEN 2 WHEN PMO_ORASTD.MONTH(C.DAY_YEAR) BETWEEN 7 AND 9 THEN 3 ELSE 4 END AS RESOURCE_QUARTER,
      PMO_ORASTD.MONTH(C.DAY_YEAR) AS RESOURCE_MONTH,
      C.WEEK_OF AS RESOURCE_WEEK,
      SUM(C.AVAILABLE_MIN) AS RESOURCE_AVAILABLE
      FROM PMO_PIVOT_PROJECTS P
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND (PA.ESTIMATED_SCHED_EFFORT + PA.ESTIMATED_PLANNED_EFFORT + PA.PROPOSED_WORK) > 0
      AND PA.RESOURCE_TYPE = '1'
      JOIN CALENDAR_DAY_OF_YEAR C
      ON C.ELEMENT_ID = PA.PROJECT_ID
      AND C.DAY_YEAR BETWEEN (CASE WHEN P.PROJECT_START > TO_DATE(SubStr(h_start_date, 1, 10)) THEN P.PROJECT_START ELSE TO_DATE(SubStr(h_start_date, 1, 10))END) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      GROUP BY P.PROJECT_ID, P.PROJECT_NAME, PA.RESOURCE_ID, PMO_ORASTD.YEAR(C.DAY_YEAR), PMO_ORASTD.MONTH(C.DAY_YEAR), C.WEEK_OF;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PRJ_PRF_WEEK', 145+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PRJ_PRF_WEEK(146) : views_pivot.sql(2101) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 1;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PRJ_PRF_WEEK', 152+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PRJ_PRF_WEEK(153) : views_pivot.sql(2108) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PRJ_PRF_WEEK;
ALTER FUNCTION FC_INIT_PRJ_PRF_WEEK COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_RES_PRJ ==
CREATE OR REPLACE FUNCTION FC_INIT_RES_PRJ RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_RES_PRJ') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_RES_PRJ'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_RES_PRJ();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_PRJ', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_RES_PRJ(9) : views_pivot.sql(2131) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECTS( PROJECT_ID )
      SELECT DISTINCT PROJECT_ID
      FROM PMO_PIVOT_TMP_RES_CAL;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES_PRJ', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES_PRJ(34) : views_pivot.sql(2156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_PRJ', 39+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES_PRJ(40) : views_pivot.sql(2162) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_RES_PRJ;
ALTER FUNCTION FC_INIT_RES_PRJ COMPILE DEBUG;

/****************************************************************************************/

/****************************************************************************************/

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_RES_PRJ_WEEK ==
CREATE OR REPLACE FUNCTION FC_INIT_RES_PRJ_WEEK RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_RES_PRJ_WEEK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_RES_PRJ_WEEK'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_RES_PRJ_WEEK();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_PRJ_WEEK', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_RES_PRJ_WEEK(9) : views_pivot.sql(2185) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECTS';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECTS( PROJECT_ID )
      SELECT DISTINCT PROJECT_ID
      FROM PMO_PIVOT_TMP_RES_CAL_W;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_RES_PRJ_WEEK', 33+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_RES_PRJ_WEEK(34) : views_pivot.sql(2210) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_RES_PRJ_WEEK', 39+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_RES_PRJ_WEEK(40) : views_pivot.sql(2216) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_RES_PRJ_WEEK;
ALTER FUNCTION FC_INIT_RES_PRJ_WEEK COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_INIT_PV_ATTR ==
CREATE OR REPLACE FUNCTION FC_INIT_PV_ATTR RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_INIT_PV_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_INIT_PV_ATTR'), '-- ' || SYSTIMESTAMP, ':r := FC_INIT_PV_ATTR();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PV_ATTR', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_INIT_PV_ATTR(9) : views_pivot.sql(2235) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_AT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO PMO_PIVOT_AT (
      PROJECT_ID,
      PROJECT_ATTRIBUTES )
      SELECT  PRJ.PROJECT_ID,
      CASE
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 144 THEN 'S' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 144 THEN 'LS' || CHR(10)
      WHEN P.LOCAL = 'N' AND A.TYPE_ID = 15 THEN 'M' || CHR(10)
      WHEN P.LOCAL = 'Y' AND A.TYPE_ID = 15 THEN 'LM' || CHR(10)
      END || 
      RTRIM(COALESCE(GPA.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(PA.ELEMENT_NAME,'')) || CHR(10) || 
      GPA.ELEMENT_ID || PA.ELEMENT_ID || A.ELEMENT_ID || RTRIM(COALESCE(A.ELEMENT_NAME,'')) || CHR(10) || 
      RTRIM(COALESCE(P.DESCRIPTION,'')) || CHR(13)
      FROM PMO_PIVOT_PROJECTS PRJ
      JOIN TMT_WBS_ATTRIBUTES P
      ON P.ELEMENT_ID = PRJ.PROJECT_ID
      JOIN TMT_WBS_ATTRIBUTES A
      ON A.ELEMENT_ID = P.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES PA
      ON PA.ELEMENT_ID = A.PARENT_ID
      JOIN TMT_WBS_ATTRIBUTES GPA
      ON GPA.ELEMENT_ID = PA.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_INIT_PV_ATTR', 53+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_INIT_PV_ATTR(54) : views_pivot.sql(2280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_INIT_PV_ATTR', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_INIT_PV_ATTR(60) : views_pivot.sql(2286) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_INIT_PV_ATTR;
ALTER FUNCTION FC_INIT_PV_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_PV_ATTRIBUTES ==
CREATE OR REPLACE FUNCTION FC_PV_ATTRIBUTES RETURN PLS_INTEGER
AS
   h_p_id VARCHAR2(32);
   h_c_attr VARCHAR2(1024);
   h_p_attr VARCHAR2(8192);
-- Declare Cursors
      CURSOR CPAT IS
         SELECT PROJECT_ID
         FROM PMO_PIVOT_PROJECTS
         ORDER BY RANK;

      CURSOR CPAT_A IS
         SELECT RTRIM(PROJECT_ATTRIBUTES)
         FROM PMO_PIVOT_AT
         WHERE PROJECT_ID = h_p_id
         AND LENGTH(PROJECT_ATTRIBUTES) > 0;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PV_ATTRIBUTES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PV_ATTRIBUTES'), '-- ' || SYSTIMESTAMP, ':r := FC_PV_ATTRIBUTES();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PV_ATTRIBUTES', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PV_ATTRIBUTES(24) : views_pivot.sql(2320) : ' || SYSTIMESTAMP);
   END IF; 

   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PAT';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   OPEN CPAT;
   
   LOOP
      FETCH CPAT INTO h_p_id;
      IF CPAT%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_p_attr := '';
      
      OPEN CPAT_A;
      
      LOOP
         FETCH CPAT_A INTO h_c_attr;
         IF CPAT_A%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_p_attr := h_p_attr || h_c_attr;
      END LOOP;
      
      BEGIN
         CLOSE CPAT_A ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PV_ATTRIBUTES', 73+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PV_ATTRIBUTES(74) : views_pivot.sql(2370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_PIVOT_PAT (
         PROJECT_ID,
         PROJECT_ATTRIBUTES )
         VALUES (
         h_p_id,
         h_p_attr);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PV_ATTRIBUTES', 95+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PV_ATTRIBUTES(96) : views_pivot.sql(2392) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   END LOOP;
   
   BEGIN
      CLOSE CPAT ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PV_ATTRIBUTES', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PV_ATTRIBUTES(110) : views_pivot.sql(2406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PV_ATTRIBUTES', 115+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PV_ATTRIBUTES(116) : views_pivot.sql(2412) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PV_ATTRIBUTES;
ALTER FUNCTION FC_PV_ATTRIBUTES COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_RESOURCE_PIVOT_OLD ==
CREATE OR REPLACE FUNCTION SP_RESOURCE_PIVOT_OLD
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_finish_date DATE;
   h_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_rank VARCHAR2(200);
   h_rec_user VARCHAR2(32);
   h_resource_finish DATE;
   h_resource_id VARCHAR2(32);
   h_resource_start DATE;
   h_role_finish DATE;
   h_role_start DATE;
   h_start_date DATE;
   h_temp_str VARCHAR2(100);
   h_count PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_planned PLS_INTEGER := 0;
   h_quarter PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CF_EXTEND_CAL IS
         SELECT RESOURCE_ID, ROLE_FINISH, RESOURCE_FINISH
         FROM PMO_PIVOT_RESOURCES
         WHERE ROLE_FINISH > RESOURCE_FINISH;

      CURSOR CPCTPH2 IS
         SELECT p.PROJECT_ID, p.PROFILE_ID, PMO_ORASTD.YEAR(c.DAY_YEAR), PMO_ORASTD.MONTH(c.DAY_YEAR), SUM(SCHED_MIN) as PLANNED_HOURS
         FROM PMO_PIVOT_COMPETENCIES p
         JOIN TASK_DAY_OF_YEAR c
         ON c.PROJECT_ID = p.PROJECT_ID
         AND p.PROFILE_ID = c.RESOURCE_ID
         AND DAY_YEAR BETWEEN ROLE_PROJECT_START AND ROLE_PROJECT_FINISH
         AND c.BIT_FLAG = '0'
         GROUP BY p.PROJECT_ID,
         p.PROFILE_ID,
         PMO_ORASTD.YEAR(c.DAY_YEAR),
         PMO_ORASTD.MONTH(c.DAY_YEAR);

      -- Resultset Cursor Declaration
      C_UP1 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_RESOURCE_PIVOT_OLD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_RESOURCE_PIVOT_OLD'), '-- ' || SYSTIMESTAMP, ':r := SP_RESOURCE_PIVOT_OLD(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESOURCE_PIVOT_OLD', 66+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_RESOURCE_PIVOT_OLD(67) : views_pivot.sql(2489) : ' || SYSTIMESTAMP);
   END IF; 

   If p_rec_user IS NULL OR p_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_RESOURCE_PIVOT_OLD', 71+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_RESOURCE_PIVOT_OLD(72) : views_pivot.sql(2494) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_COMPETENCIES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_ROLES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RES_ONE';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RES_CDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RES_ASSIGN';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RES_TDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RES_GROUPED_TDY';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_COMPETENCY_TPD';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_RESOURCE_TIMEPHASED';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_POOLS_0001';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_POOLS_0004';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_POOLS_0005';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   h_finish_date := p_finish_date;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_PRJ(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   PMO_DB2M.SC_STATE := FC_INIT_PV_ATTR();
   PMO_DB2M.SC_STATE := FC_PV_ATTRIBUTES();
   
   --trace_printf("RP_START\n");
   --trace_flush();
   -- publish PMO_PIVOT_COMPETENCIES table
   BEGIN
      INSERT INTO PMO_PIVOT_COMPETENCIES (
      PROJECT_ID,
      PROFILE_ID,
      PROFILE_NAME,
      COMPETENCY_ID,
      ROLE_ID,
      GEO_ID,
      ORG_ID,
      POOL_ID,
      POOL_NAME,
      POOL_MANAGER,
      ROLE_PROJECT_START,
      ROLE_PROJECT_FINISH )
      SELECT  P.PROJECT_ID,
      P.PROFILE_ID,
      P.PROFILE_NAME,
      C.PARENT_ID,
      P.ROLE_ID,
      P.GEO_ID,
      P.ORG_ID,
      P.POOL_ID,
      PL.ELEMENT_NAME,
      RM.FULL_NAME,
      TO_DATE(SYSDATE), --TO_DATE(SubStr(MIN(PA.START_DT), 1, 10)),
      CASE WHEN TO_DATE(SYSDATE) > TO_DATE(SubStr(MAX(PA.FINISH_DT), 1, 10)) THEN TO_DATE(SYSDATE) ELSE TO_DATE(SubStr(MAX(PA.FINISH_DT), 1, 10)) END
      FROM PMO_PIVOT_PROJECTS W
      JOIN PROFILES P
      ON P.PROJECT_ID = W.PROJECT_ID
      JOIN TASK_ASSIGNMENTS PA
      ON PA.PROJECT_ID = P.PROJECT_ID
      AND PA.RESOURCE_ID = P.PROFILE_ID
      JOIN TMT_COMPETENCIES C
      ON C.ELEMENT_ID = P.ROLE_ID
      LEFT JOIN TMT_POOLS PL
      ON PL.ELEMENT_ID = P.POOL_ID
      LEFT JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.ELEMENT_ID = PL.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      LEFT JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RA.RESOURCE_ID
      GROUP BY P.PROJECT_ID,
      P.PROFILE_ID,
      P.PROFILE_NAME,
      C.PARENT_ID,
      P.ROLE_ID,
      P.GEO_ID,
      P.ORG_ID,
      P.POOL_ID,
      PL.ELEMENT_NAME,
      RM.FULL_NAME;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 212+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(213) : views_pivot.sql(2635) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 1\n");
   --trace_flush();
   
   BEGIN
      UPDATE PMO_PIVOT_COMPETENCIES P
      SET     COMPETENCY_NAME = (SELECT C.ELEMENT_NAME FROM TMT_COMPETENCIES C WHERE C.ELEMENT_ID = P.COMPETENCY_ID),
      ROLE_NAME = (SELECT C.ELEMENT_NAME FROM TMT_COMPETENCIES C WHERE C.ELEMENT_ID = P.ROLE_ID),
      ORG_NAME = (SELECT C.ELEMENT_NAME FROM TMT_ORGANIZATIONS C WHERE C.ELEMENT_ID = P.ORG_ID),
      GEO_NAME = (SELECT C.ELEMENT_NAME FROM TMT_GEOGRAPHIES C WHERE C.ELEMENT_ID = P.GEO_ID)
      WHERE 1 = 1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 236+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(237) : views_pivot.sql(2659) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 2\n");
   --trace_flush();
   
   -- publish PMO_PIVOT_ROLES table
   BEGIN
      INSERT INTO PMO_PIVOT_ROLES
      SELECT  ROLE_ID,
      ROLE_NAME,
      SUBSTR(TO_CHAR(MIN(ROLE_PROJECT_START)),1,8) || '01',
      Add_Months(TO_DATE(SubStr(SUBSTR(TO_CHAR(MAX(ROLE_PROJECT_FINISH)),1,8) || '01', 1, 10)), 1) - 1    
      FROM PMO_PIVOT_COMPETENCIES
      GROUP BY ROLE_ID,
      ROLE_NAME;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 263+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(264) : views_pivot.sql(2686) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 3\n");
   --trace_flush();
   
   /********************************************************************************************/
   BEGIN
      INSERT INTO PMO_TMP_POOLS_0001
      
      SELECT RANK, ELEMENT_ID
      FROM TMT_POOLS
      WHERE PUBLIC_FLAG = '1'
      
      UNION ALL
      
      SELECT TP.RANK, TP.ELEMENT_ID
      FROM TMT_POOLS TP
      JOIN RESOURCE_ASSIGNMENTS RA
      ON TP.ELEMENT_ID = RA.ELEMENT_ID
      AND RA.ELEMENT_TYPE = PMO_CNST.SC_POOLS
      AND RA.RESOURCE_ID = h_rec_user;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 296+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(297) : views_pivot.sql(2719) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 4\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_TMP_POOLS_0004
      
      SELECT O.RANK, O.ELEMENT_ID
      FROM PMO_TMP_POOLS_0001 O
      WHERE NOT EXISTS (
      SELECT B.ELEMENT_ID
      FROM PMO_TMP_POOLS_0001 A, PMO_TMP_POOLS_0001 B
      WHERE A.RANK < B.RANK
      AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
      AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK)
      AND O.ELEMENT_ID = B.ELEMENT_ID );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 325+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(326) : views_pivot.sql(2748) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 5\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_TMP_POOLS_0005
      
      SELECT DISTINCT P.ELEMENT_ID
      FROM PMO_TMP_POOLS_0004 O, TMT_POOLS P
      WHERE P.RANK > O.RANK
      AND ((O.RANK >= SUBSTR(P.RANK, 1, 8) AND O.RANK <= P.RANK) 
      AND SUBSTR(P.RANK,1, CASE WHEN LENGTH(O.RANK) > LENGTH(P.RANK) THEN 1 ELSE LENGTH(O.RANK) END ) = O.RANK)
      AND P.TYPE_ID = PMO_CNST.SC_RESOURCE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 351+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(352) : views_pivot.sql(2774) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 6\n");
   --trace_flush();
   /********************************************************************************************/
   
   BEGIN
      INSERT INTO PMO_PIVOT_RES (
      COMPETENCY_ID,
      COMPETENCY_NAME,
      ROLE_ID,
      ROLE_NAME,
      ROLE_START,
      ROLE_FINISH,
      RESOURCE_ID)
      SELECT  PPC.COMPETENCY_ID,
      PPC.COMPETENCY_NAME,
      C2.ELEMENT_ID,
      C2.ELEMENT_NAME,
      MIN(PPR.ROLE_START),
      MAX(PPR.ROLE_FINISH),
      C3.RESOURCE_ID
      FROM PMO_PIVOT_COMPETENCIES PPC
      JOIN TMT_COMPETENCIES C
      ON C.ELEMENT_ID = PPC.COMPETENCY_ID
      JOIN TMT_COMPETENCIES C2
      ON C2.PARENT_ID = C.ELEMENT_ID
      JOIN TMT_COMPETENCIES C3
      ON C3.PARENT_ID = C2.ELEMENT_ID
      AND C3.TYPE_ID = PMO_CNST.SC_RESOURCE
      JOIN PMO_PIVOT_ROLES PPR
      ON PPR.ROLE_ID = PPC.ROLE_ID
      
      GROUP BY PPC.COMPETENCY_ID,
      PPC.COMPETENCY_NAME,
      C2.ELEMENT_ID,
      C2.ELEMENT_NAME,
      C3.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 401+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(402) : views_pivot.sql(2824) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 7\n");
   --trace_flush();
   
   -- publish PMO_PIVOT_RESOURCES table
   BEGIN
      INSERT INTO PMO_PIVOT_RESOURCES (
      RESOURCE_ID,
      ROLE_ID,
      RESOURCE_NAME,
      RESOURCE_WORK_LOCATION,
      RESOURCE_STATUS1,
      RESOURCE_STATUS2,
      COMPETENCY_NAME,
      ROLE_NAME,
      ROLE_START,
      ROLE_FINISH,
      GEO_NAME,
      ORG_NAME,
      POOL_NAME,
      POOL_MANAGER)
      SELECT  R.RESOURCE_ID,
      R.ROLE_ID,
      RS.FULL_NAME,
      RS.WORK_LOCATION,
      RS.STATUS1_ID,
      RS.STATUS2_ID,
      R.COMPETENCY_NAME,
      R.ROLE_NAME,
      R.ROLE_START,
      R.ROLE_FINISH,
      G2.ELEMENT_NAME,
      O2.ELEMENT_NAME,
      P2.ELEMENT_NAME,
      RM.FULL_NAME
      FROM PMO_PIVOT_RES R
      JOIN RESOURCES RS
      ON RS.RESOURCE_ID = R.RESOURCE_ID
      AND RS.ACTIVE = '1'
      JOIN PMO_TMP_POOLS_0005 P
      ON R.RESOURCE_ID = P.ELEMENT_ID
      LEFT JOIN TMT_GEOGRAPHIES G1
      ON R.RESOURCE_ID = G1.ELEMENT_ID
      LEFT JOIN TMT_GEOGRAPHIES G2
      ON G1.PARENT_ID = G2.ELEMENT_ID
      LEFT JOIN TMT_ORGANIZATIONS O1
      ON R.RESOURCE_ID = O1.ELEMENT_ID
      LEFT JOIN TMT_ORGANIZATIONS O2
      ON O1.PARENT_ID = O2.ELEMENT_ID
      LEFT JOIN TMT_POOLS P1
      ON R.RESOURCE_ID = P1.ELEMENT_ID
      LEFT JOIN TMT_POOLS P2
      ON P1.PARENT_ID = P2.ELEMENT_ID
      LEFT JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.ELEMENT_ID = P2.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      LEFT JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RA.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 472+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(473) : views_pivot.sql(2895) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 8\n");
   --trace_flush();
   
   BEGIN
      UPDATE PMO_PIVOT_RESOURCES R SET (
      RESOURCE_START,
      RESOURCE_FINISH
      ) = (
      SELECT  MIN(C.DAY_YEAR),
      MAX(C.DAY_YEAR)
      FROM CALENDAR_DAY_OF_YEAR C
      WHERE C.ELEMENT_ID = R.RESOURCE_ID
      GROUP BY C.ELEMENT_ID)
      WHERE 1 = 1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 500+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(501) : views_pivot.sql(2923) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 9\n");
   --trace_flush();
   
   -- Finish date
   
   OPEN CF_EXTEND_CAL;
   
   LOOP
      FETCH CF_EXTEND_CAL INTO h_resource_id, h_role_finish, h_resource_finish;
      IF CF_EXTEND_CAL%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      --trace_printf("h_resource_id: %d:%s, h_role_finish: %d:%s, h_resource_finish = %d:%s\n", h_resource_id_Ind,h_resource_id, h_role_finish_Ind,h_role_finish, h_resource_finish_Ind,h_resource_finish);
      
      BEGIN
         SELECT  CASE
         WHEN DISCONTINUE_DATE IS NuLL THEN h_resource_finish
         WHEN DISCONTINUE_DATE > h_role_finish THEN h_resource_finish
         ELSE DISCONTINUE_DATE
         END
         INTO h_resource_finish
         FROM RESOURCES
         WHERE RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 538+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(539) : views_pivot.sql(2961) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE = %d, h_resource_finish = %d:%s\n", SC_STATE, h_resource_finish_Ind,h_resource_finish);
      
      -- call extend calendar
      If (Coalesce(Length(h_role_finish), 0) = 10) AND (Coalesce(Length(h_resource_finish), 0) = 10) Then
         h_total := 0;
         h_type_id := PMO_CNST.SC_RESOURCE;
         h_planned := POPULATE_CALENDAR(h_resource_id, h_type_id, h_resource_finish, h_role_finish, h_total);
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CF_EXTEND_CAL ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 560+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(561) : views_pivot.sql(2983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 10\n");
   --trace_flush();
   
   /********************************************************************************************/
   BEGIN
      INSERT INTO PMO_PIVOT_RES_ONE (
      RESOURCE_ID,
      ROLE_START,
      ROLE_FINISH )
      SELECT  RESOURCE_ID,
      MIN(ROLE_START),
      MAX(ROLE_FINISH)
      FROM PMO_PIVOT_RESOURCES
      GROUP BY RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 588+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(589) : views_pivot.sql(3011) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 11\n");
   --trace_flush();
   
   /********************************************************************************************/
   /* Populate PMO_PIVOT_RESOURCE_TIMEPHASED ***********************************/
   
   BEGIN
      INSERT INTO PMO_PIVOT_RES_CDY
      SELECT CDY.*
      FROM PMO_PIVOT_RES_ONE R
      JOIN CALENDAR_DAY_OF_YEAR CDY
      ON CDY.ELEMENT_ID = R.RESOURCE_ID
      AND CDY.DAY_YEAR BETWEEN ROLE_START AND ROLE_FINISH;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 615+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(616) : views_pivot.sql(3038) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 11(A)\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_PIVOT_RES_ASSIGN
      SELECT  TA.PROJECT_ID,
      TA.TSK_ASSIGNMENT_ID,
      TA.BILLABLE
      FROM TASK_ASSIGNMENTS TA
      JOIN PMO_PIVOT_RES_ONE R
      ON R.RESOURCE_ID = TA.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 640+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(641) : views_pivot.sql(3063) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 11(B)\n");
   --trace_flush();
   
   BEGIN
      INSERT INTO PMO_PIVOT_RES_TDY
      SELECT TDY.*
      FROM TASK_DAY_OF_YEAR TDY
      JOIN PMO_PIVOT_RES_ASSIGN A
      ON TDY.PROJECT_ID = A.PROJECT_ID
      AND TDY.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 664+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(665) : views_pivot.sql(3087) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 11(C)\n");
   --trace_flush();
   
   --??? need to review the temporay table population
   BEGIN
      DELETE FROM PMO_PIVOT_RES_TDY WHERE SCHED_MIN = 1;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 684+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(685) : views_pivot.sql(3107) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_RES_GROUPED_TDY
      SELECT RESOURCE_ID, DAY_YEAR, BIT_FLAG, SUM(ACTUAL_MIN), SUM(SCHED_MIN)
      FROM PMO_PIVOT_RES_TDY
      GROUP BY RESOURCE_ID, DAY_YEAR, BIT_FLAG;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 704+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(705) : views_pivot.sql(3127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Resources / Roles
   BEGIN
      INSERT INTO PMO_PIVOT_RESOURCE_TIMEPHASED (
      RESOURCE_ID,
      YEAR_ID,
      MONTH_ID,
      QUARTER_ID,
      CALENDAR_HOURS,
      PLANNED_HOURS,
      SCHED_HOURS)
      SELECT  c.ELEMENT_ID,
      PMO_ORASTD.YEAR(c.DAY_YEAR) AS YEAR_ID,
      PMO_ORASTD.MONTH(c.DAY_YEAR) AS MONTH_ID,
      CASE
      WHEN PMO_ORASTD.MONTH(c.DAY_YEAR) < 4 THEN 1
      WHEN PMO_ORASTD.MONTH(c.DAY_YEAR) BETWEEN 4 AND 6 THEN 2
      WHEN PMO_ORASTD.MONTH(c.DAY_YEAR) BETWEEN 7 AND 9 THEN 3
      ELSE 4
      END AS QUARTER_ID,
      (SELECT SUM(COALESCE(AVAILABLE_MIN,0)) FROM PMO_PIVOT_RES_CDY WHERE ELEMENT_ID = c.ELEMENT_ID AND PMO_ORASTD.YEAR(DAY_YEAR) = PMO_ORASTD.YEAR(c.DAY_YEAR) AND PMO_ORASTD.MONTH(DAY_YEAR) = PMO_ORASTD.MONTH(c.DAY_YEAR)) AS CALENDAR_HOURS,
      SUM(COALESCE(CASE WHEN t.BIT_FLAG = '2' THEN 0 ELSE t.SCHED_MIN END,0)) AS PLANNED_HOURS,
      SUM(COALESCE(CASE WHEN t.BIT_FLAG = '2' THEN t.SCHED_MIN ELSE 0 END,0)) AS SCHED_HOURS
      FROM PMO_PIVOT_RES_CDY c
      LEFT JOIN PMO_PIVOT_RES_GROUPED_TDY t
      ON t.RESOURCE_ID = c.ELEMENT_ID
      AND t.DAY_YEAR = c.DAY_YEAR
      GROUP BY c.ELEMENT_ID,PMO_ORASTD.YEAR(c.DAY_YEAR),PMO_ORASTD.MONTH(c.DAY_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 746+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(747) : views_pivot.sql(3169) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 12\n");
   --trace_flush();
   
   /* Populate PMO_PIVOT_COMPETENCY_TPD ***********************************/
   -- Profiles / Roles
   BEGIN
      INSERT INTO PMO_PIVOT_COMPETENCY_TPD (
      PROJECT_ID,
      ROLE_ID,
      YEAR_ID,
      MONTH_ID,
      QUARTER_ID,
      CALENDAR_HOURS )
      SELECT  PROJECT_ID,
      PROFILE_ID,
      PMO_ORASTD.YEAR(DAY_YEAR) AS YEAR_ID,
      PMO_ORASTD.MONTH(DAY_YEAR) AS MONTH_ID,
      CASE
      WHEN PMO_ORASTD.MONTH(DAY_YEAR) < 4 THEN 1
      WHEN PMO_ORASTD.MONTH(DAY_YEAR) BETWEEN 4 AND 6 THEN 2
      WHEN PMO_ORASTD.MONTH(DAY_YEAR) BETWEEN 7 AND 9 THEN 3
      ELSE 4
      END AS QUARTER_ID,
      0 AS CALENDAR_HOURS
      FROM PMO_PIVOT_COMPETENCIES p
      JOIN CALENDAR_DAY_OF_YEAR c
      ON c.ELEMENT_ID = p.PROJECT_ID
      AND DAY_YEAR BETWEEN ROLE_PROJECT_START AND ROLE_PROJECT_FINISH
      GROUP BY PROJECT_ID,
      PROFILE_ID,
      PMO_ORASTD.YEAR(DAY_YEAR),
      PMO_ORASTD.MONTH(DAY_YEAR);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 792+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(793) : views_pivot.sql(3215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 13\n");
   --trace_flush();
   
   -- Profile Plan
   
   OPEN CPCTPH2;
   
   LOOP
      FETCH CPCTPH2 INTO h_c_id, h_resource_id, h_year, h_month, h_planned;
      IF CPCTPH2%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      --trace_printf("h_c_id: %s, h_resource_id: %s, h_year: %d, h_month: %d, h_planned: %d\n",h_c_id,h_resource_id,h_year,h_month,h_planned);
      
      If Coalesce(h_month, 0) < 4 Then
         h_quarter := 1;
      ElsIf (Coalesce(h_month, 0) > 3) AND (Coalesce(h_month, 0) < 7) Then
         h_quarter := 2;
      ElsIf (Coalesce(h_month, 0) > 6) AND (Coalesce(h_month, 0) < 10) Then
         h_quarter := 3;
      Else
         h_quarter := 4;
      End If;
      
      BEGIN
         UPDATE PMO_PIVOT_COMPETENCY_TPD SET
         PLANNED_HOURS = h_planned
         WHERE PROJECT_ID = h_c_id
         AND ROLE_ID = h_resource_id
         AND YEAR_ID = h_year
         AND MONTH_ID = h_month;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 842+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(843) : views_pivot.sql(3265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("SC_STATE: %d\n", SC_STATE);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO PMO_PIVOT_COMPETENCY_TPD (
            PROJECT_ID,
            ROLE_ID,
            YEAR_ID,
            QUARTER_ID,
            MONTH_ID,
            PLANNED_HOURS )
            VALUES (h_c_id,
            h_resource_id,
            h_year,
            h_quarter,
            h_month,
            h_planned);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 873+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(874) : views_pivot.sql(3296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE CPCTPH2 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 888+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(889) : views_pivot.sql(3311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("RP_STEP 14\n");
   --trace_flush();
   
   /********************************************************************************************/
   
   OPEN C_UP1 FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   0 AS RESOURCE_WORK_LOCATION,
   0 AS RESOURCE_STATUS1,
   0 AS RESOURCE_STATUS2,
   C.ROLE_ID AS DEFAULT0_ROLE_ID,
   C.PROFILE_NAME AS DEFAULT_NAME__T,
   C.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   C.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   C.GEO_NAME AS RESOURCE_GEO_NAME__T,
   C.ORG_NAME AS RESOURCE_ORG_NAME__T,
   C.POOL_NAME AS RESOURCE_POOL_NAME__T,
   C.POOL_MANAGER AS RESOURCE_POOL_MANAGER__T,
   P.PROJECT_NAME AS RESOURCE_PROJECT__T,
   W.ELEMENT_ID AS PROJECT_ID,
   W.REF_CODE AS PROJECT_REF_NUMBER,
   W.CURRENCY_ID AS PROJECT_CURRENCY,
   W.START_FINISH_DATE AS PROJECT_START_DT,
   COALESCE(W.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
   W.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   PM.FULL_NAME AS PROJECT_MANAGER,
   TO_CHAR(W.PRIORITY) AS STATUS_PRIORITY,
   W.STAGE_ID AS STATUS_STAGE,
   W.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   (CASE WHEN W.BASELINE1_EFFORT > 0 THEN ((W.WORK_TODATE*10000)/W.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   T.YEAR_ID AS RESOURCE_YEAR_YY,
   T.QUARTER_ID AS RESOURCE_QUARTER_QQ,
   T.MONTH_ID AS RESOURCE_MONTH_MM,
   T.CALENDAR_HOURS/60 AS RESOURCE_CALENDAR_HOURS__D,
   T.PLANNED_HOURS/60 AS RESOURCE_PLANNED_HOURS__D,
   T.SCHED_HOURS/60 AS RESOURCE_SCHED_HOURS__D,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM PMO_PIVOT_COMPETENCY_TPD T
   JOIN PMO_PIVOT_COMPETENCIES C
   ON C.PROFILE_ID = T.ROLE_ID
   JOIN PMO_PIVOT_PROJECTS P
   ON P.PROJECT_ID = T.PROJECT_ID
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCE_ASSIGNMENTS RA
   ON RA.PROJECT_ID = W.ELEMENT_ID
   AND RA.ELEMENT_ID = W.ELEMENT_ID
   AND BITAND(RA.PARTICIPANT,1) = 1
   JOIN RESOURCES PM
   ON PM.RESOURCE_ID = RA.RESOURCE_ID
   LEFT JOIN PMO_PIVOT_PAT AT
   ON AT.PROJECT_ID = P.PROJECT_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   2 AS TYPE_ID,
   R.RESOURCE_WORK_LOCATION,
   R.RESOURCE_STATUS1,
   R.RESOURCE_STATUS2,
   R.RESOURCE_ID AS DEFAULT0_ROLE_ID,
   R.RESOURCE_NAME AS DEFAULT_NAME__T,
   R.COMPETENCY_NAME AS RESOURCE_COMPETENCY__T,
   R.ROLE_NAME AS RESOURCE_PROFICIENCY_LEVEL__T,
   R.GEO_NAME AS RESOURCE_GEO_NAME__T,
   R.ORG_NAME AS RESOURCE_ORG_NAME__T,
   R.POOL_NAME AS RESOURCE_POOL_NAME__T,
   R.POOL_MANAGER AS RESOURCE_POOL_MANAGER__T,
   '' AS RESOURCE_PROJECT__T,
   '' AS PROJECT_ID,
   '' AS PROJECT_REF_NUMBER,
   0 AS PROJECT_CURRENCY,
   TO_DATE('1899-01-01') AS PROJECT_START_DT,
   TO_DATE('1899-01-01') AS PROJECT_FINISH_DT,
   '' AS PROJECT_CLIENT,
   '' AS PROJECT_MANAGER,
   '' AS STATUS_PRIORITY,
   0 AS STATUS_STAGE,
   0 AS STATUS_PERCENT_COMPLETE,
   0 AS STATUS_PERCENT_SPENT,
   T.YEAR_ID AS RESOURCE_YEAR_YY,
   T.QUARTER_ID AS RESOURCE_QUARTER_QQ,
   T.MONTH_ID AS RESOURCE_MONTH_MM,
   T.CALENDAR_HOURS/60 AS RESOURCE_CALENDAR_HOURS__D,
   T.PLANNED_HOURS/60 AS RESOURCE_PLANNED_HOURS__D,
   T.SCHED_HOURS/60 AS RESOURCE_SCHED_HOURS__D,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES
   FROM PMO_PIVOT_RESOURCE_TIMEPHASED T
   JOIN PMO_PIVOT_RESOURCES R
   ON R.RESOURCE_ID = T.RESOURCE_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_RESOURCE_PIVOT_OLD', 985+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_RESOURCE_PIVOT_OLD(986) : views_pivot.sql(3408) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_UP1;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 993+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(994) : views_pivot.sql(3416) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_RESOURCE_PIVOT_OLD', 1005+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_RESOURCE_PIVOT_OLD(1006) : views_pivot.sql(3428) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_RESOURCE_PIVOT_OLD;
ALTER FUNCTION SP_RESOURCE_PIVOT_OLD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTILIZATION_POOL_OLD ==
CREATE OR REPLACE FUNCTION SP_UTILIZATION_POOL_OLD
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_finish_date DATE;
   h_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_rank VARCHAR2(200);
   h_rec_user VARCHAR2(32);
   h_resource_finish DATE;
   h_resource_id VARCHAR2(32);
   h_resource_start DATE;
   h_role_finish DATE;
   h_role_start DATE;
   h_start_date DATE;
   h_temp_str VARCHAR2(100);
   h_count PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_planned PLS_INTEGER := 0;
   h_quarter PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_UPA PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTILIZATION_POOL_OLD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTILIZATION_POOL_OLD'), '-- ' || SYSTIMESTAMP, ':r := SP_UTILIZATION_POOL_OLD(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_POOL_OLD', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTILIZATION_POOL_OLD(48) : views_pivot.sql(3492) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UTILIZATION_POOL_OLD', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UTILIZATION_POOL_OLD(53) : views_pivot.sql(3497) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   
   If p_start_date IS NULL Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If p_finish_date IS NULL Then
      h_finish_date := '2300-12-12';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_RES(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   PMO_DB2M.SC_STATE := FC_INIT_RES_PRJ();
   PMO_DB2M.SC_STATE := FC_INIT_PV_ATTR();
   PMO_DB2M.SC_STATE := FC_PV_ATTRIBUTES();
   
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM UTIL_POOL';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   BEGIN
      INSERT INTO UTIL_POOL
      SELECT  1 AS LEVEL_ID,
      13 AS TYPE_ID,
      2 AS REF_TYPE,
      R.RESOURCE_ID,
      R.RESOURCE_NAME,
      R.RESOURCE_WORK_LOCATION,
      R.RESOURCE_STATUS1,
      R.RESOURCE_STATUS2,
      R.RESOURCE_COMPETENCY,
      R.RESOURCE_PROFICIENCY,
      R.RESOURCE_GEO,
      R.RESOURCE_ORG,
      R.RESOURCE_POOL,
      R.RESOURCE_POOL_MANAGER,
      C.PROJECT_ID,
      C.PROJECT_NAME,
      W.REF_CODE AS PROJECT_REF_NUMBER,
      W.CURRENCY_ID AS PROJECT_CURRENCY,
      W.START_FINISH_DATE AS PROJECT_START_DT,
      COALESCE(W.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
      W.OPPORTUNITY_NAME AS PROJECT_CLIENT,
      '' AS PROJECT_MANAGER,
      TO_CHAR(W.PRIORITY) AS STATUS_PRIORITY,
      W.STAGE_ID AS STATUS_STAGE,
      W.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
      (CASE WHEN W.BASELINE1_EFFORT > 0 THEN ((W.WORK_TODATE*10000)/W.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
      C.RESOURCE_YEAR,
      C.RESOURCE_QUARTER,
      C.RESOURCE_MONTH,
      -(SUM(C.RESOURCE_PROPOSED+C.RESOURCE_SCHEDULED)/60.00) AS RESOURCE_CALENDAR,
      SUM(C.RESOURCE_PROPOSED)/60.00 AS RESOURCE_PROPOSED,
      SUM(C.RESOURCE_SCHEDULED)/60.00 AS RESOURCE_SCHEDULED,
      SUM(C.RESOURCE_ACTUAL)/60.00 AS RESOURCE_ACTUAL,
      SUM(C.RESOURCE_BILLABLE_PROPOSED)/60.00 AS RESOURCE_BILLABLE_PROPOSED,
      SUM(C.RESOURCE_BILLABLE_SCHEDULED)/60.00 AS RESOURCE_BILLABLE_SCHEDULED,
      SUM(C.RESOURCE_BILLABLE_ACTUAL)/60.00 AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_PIVOT_TMP_RES_CAL C
      ON C.RESOURCE_ID = R.RESOURCE_ID
      AND C.RESOURCE_DAY BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.RESOURCE_DAY BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      AND C.PROJECT_ID IS NOT NULL
      JOIN TMT_WBS W
      ON W.ELEMENT_ID = C.PROJECT_ID
      JOIN PMO_PIVOT_PAT AT
      ON AT.PROJECT_ID = C.PROJECT_ID
      
      GROUP BY R.RESOURCE_ID,
      R.RESOURCE_NAME,
      R.RESOURCE_WORK_LOCATION,
      R.RESOURCE_STATUS1,
      R.RESOURCE_STATUS2,
      R.RESOURCE_COMPETENCY,
      R.RESOURCE_PROFICIENCY,
      R.RESOURCE_GEO,
      R.RESOURCE_ORG,
      R.RESOURCE_POOL,
      R.RESOURCE_POOL_MANAGER,
      C.PROJECT_ID,
      C.PROJECT_NAME,
      W.REF_CODE,
      W.CURRENCY_ID,
      W.START_FINISH_DATE,
      W.FINISH_START_DATE,
      W.OPPORTUNITY_NAME,
      W.ASSIGN_NAMES,
      W.PRIORITY,
      W.STAGE_ID,
      W.MILESTONE_PERCENT,
      W.BASELINE1_EFFORT,
      W.WORK_TODATE,
      C.RESOURCE_YEAR,
      C.RESOURCE_QUARTER,
      C.RESOURCE_MONTH;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL_OLD', 173+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL_OLD(174) : views_pivot.sql(3618) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --RESULT SET
   
   OPEN C_UPA FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   R.RESOURCE_ID,
   R.RESOURCE_NAME,
   R.RESOURCE_WORK_LOCATION,
   R.RESOURCE_STATUS1,
   R.RESOURCE_STATUS2,
   R.RESOURCE_COMPETENCY,
   R.RESOURCE_PROFICIENCY,
   R.RESOURCE_GEO,
   R.RESOURCE_ORG,
   R.RESOURCE_POOL,
   R.RESOURCE_POOL_MANAGER,
   '' AS PROJECT_ID,
   '' AS PROJECT_NAME,
   '' AS PROJECT_REF_NUMBER,
   0 AS PROJECT_CURRENCY,
   TO_DATE('1899-01-01') AS PROJECT_START_DT,
   TO_DATE('1899-01-01') AS PROJECT_FINISH_DT,
   '' AS PROJECT_CLIENT,
   '' AS PROJECT_MANAGER,
   '' AS STATUS_PRIORITY,
   0 AS STATUS_STAGE,
   0 AS STATUS_PERCENT_COMPLETE,
   0 AS STATUS_PERCENT_SPENT,
   C.RESOURCE_YEAR,
   C.RESOURCE_QUARTER,
   C.RESOURCE_MONTH,
   C.RESOURCE_AVAILABLE/60.00 AS RESOURCE_CALENDAR,
   0.00 AS RESOURCE_PROPOSED,
   0.00 AS RESOURCE_SCHEDULED,
   0.00 AS RESOURCE_ACTUAL,
   0.00 AS RESOURCE_BILLABLE_PROPOSED,
   0.00 AS RESOURCE_BILLABLE_SCHEDULED,
   0.00 AS RESOURCE_BILLABLE_ACTUAL,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES
   FROM PMO_PIVOT_TMP_RESOURCES R
   LEFT JOIN PMO_PIVOT_TMP_RES_MONTH1 C
   ON C.RESOURCE_ID = R.RESOURCE_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   R.LEVEL_ID,
   R.TYPE_ID,
   R.REF_TYPE,
   R.RESOURCE_ID,
   R.RESOURCE_NAME,
   R.RESOURCE_WORK_LOCATION,
   R.RESOURCE_STATUS1,
   R.RESOURCE_STATUS2,
   R.RESOURCE_COMPETENCY,
   R.RESOURCE_PROFICIENCY,
   R.RESOURCE_GEO,
   R.RESOURCE_ORG,
   R.RESOURCE_POOL,
   R.RESOURCE_POOL_MANAGER,
   R.PROJECT_ID,
   R.PROJECT_NAME,
   R.PROJECT_REF_NUMBER,
   R.PROJECT_CURRENCY,
   R.PROJECT_START_DT,
   R.PROJECT_FINISH_DT,
   R.PROJECT_CLIENT,
   R.PROJECT_MANAGER,
   R.STATUS_PRIORITY,
   R.STATUS_STAGE,
   R.STATUS_PERCENT_COMPLETE,
   R.STATUS_PERCENT_SPENT,
   R.RESOURCE_YEAR,
   R.RESOURCE_QUARTER,
   R.RESOURCE_MONTH,
   R.RESOURCE_CALENDAR,
   R.RESOURCE_PROPOSED,
   R.RESOURCE_SCHEDULED,
   R.RESOURCE_ACTUAL,
   R.RESOURCE_BILLABLE_PROPOSED,
   R.RESOURCE_BILLABLE_SCHEDULED,
   R.RESOURCE_BILLABLE_ACTUAL,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM UTIL_POOL R
   JOIN PMO_PIVOT_PAT AT
   ON AT.PROJECT_ID = R.PROJECT_ID
   
   ORDER BY RESOURCE_NAME,
   RESOURCE_YEAR,
   RESOURCE_QUARTER,
   RESOURCE_MONTH,
   LEVEL_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_POOL_OLD', 274+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_POOL_OLD(275) : views_pivot.sql(3719) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_UPA;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL_OLD', 282+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL_OLD(283) : views_pivot.sql(3727) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_POOL_OLD', 294+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_POOL_OLD(295) : views_pivot.sql(3739) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTILIZATION_POOL_OLD;
ALTER FUNCTION SP_UTILIZATION_POOL_OLD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTILIZATION_PROJECT_OLD ==
CREATE OR REPLACE FUNCTION SP_UTILIZATION_PROJECT_OLD
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_xsql VARCHAR2(29999);
   h_c_id VARCHAR2(32);
   h_c_rank VARCHAR2(200);
   h_finish_date DATE;
   h_id VARCHAR2(32);
   h_ids VARCHAR2(8192);
   h_rank VARCHAR2(200);
   h_rec_user VARCHAR2(32);
   h_resource_finish DATE;
   h_resource_id VARCHAR2(32);
   h_resource_start DATE;
   h_role_finish DATE;
   h_role_start DATE;
   h_start_date DATE;
   h_temp_str VARCHAR2(100);
   h_count PLS_INTEGER := 0;
   h_month PLS_INTEGER := 0;
   h_planned PLS_INTEGER := 0;
   h_quarter PLS_INTEGER := 0;
   h_total PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_year PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_PPA PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTILIZATION_PROJECT_OLD') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTILIZATION_PROJECT_OLD'), '-- ' || SYSTIMESTAMP, ':r := SP_UTILIZATION_PROJECT_OLD(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_PROJECT_OLD', 47+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTILIZATION_PROJECT_OLD(48) : views_pivot.sql(3803) : ' || SYSTIMESTAMP);
   END IF; 

   If p_rec_user IS NULL OR p_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_UTILIZATION_PROJECT_OLD', 52+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_UTILIZATION_PROJECT_OLD(53) : views_pivot.sql(3808) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   h_ids := p_ids;
   h_type := p_type;
   
   If p_start_date IS NULL Then
      h_start_date := '1899-01-01';
   Else
      h_start_date := p_start_date;
   End If;
   
   If p_finish_date IS NULL Then
      h_finish_date := '2300-12-12';
   Else
      h_finish_date := p_finish_date;
   End If;
   
   h_rec_user := p_rec_user;
   
   --trace_printf("START\n"); //trace_flush();
   PMO_DB2M.SC_STATE := FC_INIT_PRJ(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   --trace_printf("END STEP 1\n"); //trace_flush();
   PMO_DB2M.SC_STATE := FC_INIT_PRJ_RES(h_start_date, h_finish_date);
   --trace_printf("END STEP 2\n"); //trace_flush();
   --  SC_STATE = FC_INIT_PRJ_PRF(SC_PARAM(h_start_date), SC_PARAM(h_finish_date));
   --trace_printf("END STEP 3\n"); //trace_flush();
   PMO_DB2M.SC_STATE := FC_INIT_PV_ATTR();
   --trace_printf("END STEP 4\n"); //trace_flush();
   PMO_DB2M.SC_STATE := FC_PV_ATTRIBUTES();
   --trace_printf("END STEP 5\n"); //trace_flush();
   
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM UTIL_RES';
   PMO_DB2M.SC_STATE := 0;
   
   --  BEGIN_SQL
   --      DECLARE GLOBAL TEMPORARY TABLE UTIL_PRF (
   --          LEVEL_ID            INTEGER,
   --          TYPE_ID             INTEGER,
   --          REF_TYPE            INTEGER,
   --          PROJECT_ID          CHAR(32),
   --          PROJECT_NAME            VARCHAR(255),
   --          PROJECT_REF_NUMBER      VARCHAR(50),
   --          PROJECT_CURRENCY        INTEGER,
   --          PROJECT_START_DT        DATE,
   --          PROJECT_FINISH_DT       DATE,
   --          PROJECT_CLIENT          VARCHAR(50),
   --          PROJECT_MANAGER         VARCHAR(100),
   --          STATUS_PRIORITY         CHAR(5),
   --          STATUS_STAGE            INTEGER,
   --          STATUS_PERCENT_COMPLETE     SMALLINT,
   --          STATUS_PERCENT_SPENT        BIGINT,
   --          RESOURCE_ID         CHAR(32),
   --          RESOURCE_NAME           VARCHAR(100),
   --          RESOURCE_WORK_LOCATION      INTEGER,
   --          RESOURCE_STATUS1        INTEGER,
   --          RESOURCE_STATUS2        INTEGER,
   --              RESOURCE_COMPETENCY         CHAR(50),
   --              RESOURCE_PROFICIENCY        CHAR(50),
   --              RESOURCE_POOL           CHAR(50),
   --              RESOURCE_POOL_MANAGER       CHAR(100),
   --              RESOURCE_GEO            CHAR(50),
   --              RESOURCE_ORG            CHAR(50),
   --              RESOURCE_YEAR           SMALLINT,
   --              RESOURCE_QUARTER        SMALLINT,
   --              RESOURCE_MONTH          SMALLINT,
   --              RESOURCE_CALENDAR       BIGINT,
   --              RESOURCE_PROPOSED       BIGINT,
   --              RESOURCE_SCHEDULED      BIGINT,
   --              RESOURCE_ACTUAL         BIGINT,
   --              RESOURCE_BILLABLE_PROPOSED  BIGINT,
   --              RESOURCE_BILLABLE_SCHEDULED     BIGINT,
   --              RESOURCE_BILLABLE_ACTUAL    BIGINT
   --      ) WITH REPLACE ON COMMIT PRESERVE ROWS NOT LOGGED IN USRTS32K;
   --  END_SQL;
   --=====================================================================
   --trace_printf("END STEP 6\n"); //trace_flush();
   
   BEGIN
      INSERT INTO UTIL_RES
      SELECT  1 AS LEVEL_ID,
      13 AS TYPE_ID,
      2 AS REF_TYPE,
      
      C.PROJECT_ID,
      C.PROJECT_NAME,
      W.REF_CODE AS PROJECT_REF_NUMBER,
      W.CURRENCY_ID AS PROJECT_CURRENCY,
      W.START_FINISH_DATE AS PROJECT_START_DT,
      COALESCE(W.FINISH_START_DATE, TO_DATE('1899-01-01')) AS PROJECT_FINISH_DT,
      W.OPPORTUNITY_NAME AS PROJECT_CLIENT,
      PM.FULL_NAME AS PROJECT_MANAGER,
      TO_CHAR(W.PRIORITY) AS STATUS_PRIORITY,
      W.STAGE_ID AS STATUS_STAGE,
      W.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
      (CASE WHEN W.BASELINE1_EFFORT > 0 THEN ((W.WORK_TODATE*10000)/W.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
      
      R.RESOURCE_ID,
      R.RESOURCE_NAME,
      R.RESOURCE_WORK_LOCATION,
      R.RESOURCE_STATUS1,
      R.RESOURCE_STATUS2,
      R.RESOURCE_COMPETENCY,
      R.RESOURCE_PROFICIENCY,
      R.RESOURCE_POOL,
      R.RESOURCE_POOL_MANAGER,
      R.RESOURCE_GEO,
      R.RESOURCE_ORG,
      C.RESOURCE_YEAR,
      C.RESOURCE_QUARTER,
      C.RESOURCE_MONTH,
      -(SUM(C.RESOURCE_PROPOSED+C.RESOURCE_SCHEDULED)/60.00) AS RESOURCE_CALENDAR,
      SUM(C.RESOURCE_PROPOSED)/60.00 AS RESOURCE_PROPOSED,
      SUM(C.RESOURCE_SCHEDULED)/60.00 AS RESOURCE_SCHEDULED,
      SUM(C.RESOURCE_ACTUAL)/60.00 AS RESOURCE_ACTUAL,
      SUM(C.RESOURCE_BILLABLE_PROPOSED)/60.00 AS RESOURCE_BILLABLE_PROPOSED,
      SUM(C.RESOURCE_BILLABLE_SCHEDULED)/60.00 AS RESOURCE_BILLABLE_SCHEDULED,
      SUM(C.RESOURCE_BILLABLE_ACTUAL)/60.00 AS RESOURCE_BILLABLE_ACTUAL
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_PIVOT_TMP_RES_CAL C
      ON C.RESOURCE_ID = R.RESOURCE_ID
      AND C.RESOURCE_DAY BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND C.RESOURCE_DAY BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)))
      AND (C.RESOURCE_PROPOSED+C.RESOURCE_SCHEDULED) > 0
      JOIN TMT_WBS W
      ON W.ELEMENT_ID = C.PROJECT_ID
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = W.ELEMENT_ID
      AND RA.ELEMENT_ID = W.ELEMENT_ID
      AND BITAND(RA.PARTICIPANT,1) = 1
      JOIN RESOURCES PM
      ON PM.RESOURCE_ID = RA.RESOURCE_ID
      
      GROUP BY C.PROJECT_ID,
      C.PROJECT_NAME,
      W.REF_CODE,
      W.CURRENCY_ID,
      W.START_FINISH_DATE,
      W.FINISH_START_DATE,
      W.OPPORTUNITY_NAME,
      PM.FULL_NAME,
      W.PRIORITY,
      W.STAGE_ID,
      W.MILESTONE_PERCENT,
      W.BASELINE1_EFFORT,
      W.WORK_TODATE,
      R.RESOURCE_ID,
      R.RESOURCE_NAME,
      R.RESOURCE_WORK_LOCATION,
      R.RESOURCE_STATUS1,
      R.RESOURCE_STATUS2,
      R.RESOURCE_COMPETENCY,
      R.RESOURCE_PROFICIENCY,
      R.RESOURCE_POOL,
      R.RESOURCE_POOL_MANAGER,
      R.RESOURCE_GEO,
      R.RESOURCE_ORG,
      C.RESOURCE_YEAR,
      C.RESOURCE_QUARTER,
      C.RESOURCE_MONTH;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT_OLD', 228+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT_OLD(229) : views_pivot.sql(3984) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END STEP 7\n"); //trace_flush();
   
   --  BEGIN_SQL
   --      INSERT INTO session.UTIL_PRF
   --      SELECT  1 AS LEVEL_ID,
   --          41 AS TYPE_ID,
   --          1 AS REF_TYPE,
   --              C.PROJECT_ID,
   --              C.PROJECT_NAME,
   --          W.REF_CODE AS PROJECT_REF_NUMBER,
   --          W.CURRENCY_ID AS PROJECT_CURRENCY,
   --          W.START_FINISH_DATE AS PROJECT_START_DT,
   --          COALESCE(W.FINISH_START_DATE, SC_1899_01_01) AS PROJECT_FINISH_DT,
   --          W.OPPORTUNITY_NAME AS PROJECT_CLIENT,
   --          PM.FULL_NAME AS PROJECT_MANAGER,
   --          CHAR(W.PRIORITY) AS STATUS_PRIORITY,
   --          W.STAGE_ID AS STATUS_STAGE,
   --          W.MILESTONE_PERCENT AS STATUS_PERCENT_COMPLETE,
   --          (CASE WHEN W.BASELINE1_EFFORT > 0 THEN ((W.WORK_TODATE*10000)/W.BASELINE1_EFFORT) ELSE 0 END) AS STATUS_PERCENT_SPENT,
   --              R.PROFILE_ID AS RESOURCE_ID,
   --              R.PROFILE_NAME || ' (' || RTRIM(C.PROJECT_NAME) || ')' AS RESOURCE_NAME,
   --              0 AS RESOURCE_WORK_LOCATION,
   --              0 AS RESOURCE_STATUS1,
   --              0 AS RESOURCE_STATUS2,
   --              R.PROFILE_COMPETENCY AS RESOURCE_COMPETENCY,
   --              R.PROFILE_PROFICIENCY AS RESOURCE_PROFICIENCY,
   --              R.PROFILE_POOL AS RESOURCE_POOL,
   --              R.PROFILE_POOL_MANAGER AS RESOURCE_POOL_MANAGER,
   --              R.PROFILE_GEO AS RESOURCE_GEO,
   --              R.PROFILE_ORG AS RESOURCE_ORG,
   --              C.PROFILE_YEAR AS RESOURCE_YEAR,
   --              C.PROFILE_QUARTER AS RESOURCE_QUARTER,
   --              C.PROFILE_MONTH AS RESOURCE_MONTH,
   --              -(SUM(C.PROFILE_PROPOSED+C.PROFILE_SCHEDULED)/60.00) AS RESOURCE_CALENDAR,
   --              SUM(C.PROFILE_PROPOSED)/60.00 AS RESOURCE_PROPOSED,
   --              SUM(C.PROFILE_SCHEDULED)/60.00 AS RESOURCE_SCHEDULED,
   --              SUM(C.PROFILE_ACTUAL)/60.00 AS RESOURCE_ACTUAL,
   --              SUM(C.PROFILE_BILLABLE_PROPOSED)/60.00 AS RESOURCE_BILLABLE_PROPOSED,
   --              SUM(C.PROFILE_BILLABLE_SCHEDULED)/60.00 AS RESOURCE_BILLABLE_SCHEDULED,
   --              SUM(C.PROFILE_BILLABLE_ACTUAL)/60.00 AS RESOURCE_BILLABLE_ACTUAL
   --      FROM session.PMO_PIVOT_TMP_PROFILES R
   --      JOIN session.PMO_PIVOT_TMP_PRF_CAL C
   --          ON C.PROFILE_ID = R.PROFILE_ID
   --          AND C.PROFILE_DAY BETWEEN DATE(HOST(h_start_date)) AND DATE(HOST(h_finish_date))
   --          AND (C.PROFILE_PROPOSED+C.PROFILE_SCHEDULED) > 0
   --      JOIN TMT_WBS W
   --          ON W.ELEMENT_ID = C.PROJECT_ID
   --      JOIN RESOURCE_ASSIGNMENTS RA
   --          ON RA.PROJECT_ID = W.ELEMENT_ID
   --          AND RA.ELEMENT_ID = W.ELEMENT_ID
   --          AND BIT_AND(RA.PARTICIPANT,1) = 1
   --      JOIN RESOURCES PM
   --          ON PM.RESOURCE_ID = RA.RESOURCE_ID
   --
   --      GROUP BY C.PROJECT_ID,
   --          C.PROJECT_NAME,
   --          W.REF_CODE,
   --          W.CURRENCY_ID,
   --          W.START_FINISH_DATE,
   --          W.FINISH_START_DATE,
   --          W.OPPORTUNITY_NAME,
   --          PM.FULL_NAME,
   --          W.PRIORITY,
   --          W.STAGE_ID,
   --          W.MILESTONE_PERCENT,
   --          W.BASELINE1_EFFORT,
   --          W.WORK_TODATE,
   --          R.PROFILE_ID,
   --              R.PROFILE_NAME,
   --              R.PROFILE_COMPETENCY,
   --              R.PROFILE_PROFICIENCY,
   --              R.PROFILE_POOL,
   --              R.PROFILE_POOL_MANAGER,
   --              R.PROFILE_GEO,
   --              R.PROFILE_ORG,
   --              C.PROFILE_YEAR,
   --              C.PROFILE_QUARTER,
   --              C.PROFILE_MONTH;
   --  END_SQL_CHECK;
   --trace_printf("END STEP 8\n"); //trace_flush();
   
   --trace_printf("END STEP 9\n"); //trace_flush();
   
   OPEN C_PPA FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   0 AS LEVEL_ID,
   13 AS TYPE_ID,
   2 AS REF_TYPE,
   '' AS PROJECT_ID,
   '' AS PROJECT_NAME,
   '' AS PROJECT_REF_NUMBER,
   0 AS PROJECT_CURRENCY,
   TO_DATE('1899-01-01') AS PROJECT_START_DT,
   TO_DATE('1899-01-01') AS PROJECT_FINISH_DT,
   '' AS PROJECT_CLIENT,
   '' AS PROJECT_MANAGER,
   '' AS STATUS_PRIORITY,
   0 AS STATUS_STAGE,
   0 AS STATUS_PERCENT_COMPLETE,
   0 AS STATUS_PERCENT_SPENT,
   R.RESOURCE_ID,
   R.RESOURCE_NAME,
   R.RESOURCE_WORK_LOCATION,
   R.RESOURCE_STATUS1,
   R.RESOURCE_STATUS2,
   R.RESOURCE_COMPETENCY,
   R.RESOURCE_PROFICIENCY,
   R.RESOURCE_POOL,
   R.RESOURCE_POOL_MANAGER,
   R.RESOURCE_GEO,
   R.RESOURCE_ORG,
   C.RESOURCE_YEAR,
   C.RESOURCE_QUARTER,
   C.RESOURCE_MONTH,
   C.RESOURCE_AVAILABLE/60.00 AS RESOURCE_CALENDAR,
   0.00 AS RESOURCE_PROPOSED,
   0.00 AS RESOURCE_SCHEDULED,
   0.00 AS RESOURCE_ACTUAL,
   0.00 AS RESOURCE_BILLABLE_PROPOSED,
   0.00 AS RESOURCE_BILLABLE_SCHEDULED,
   0.00 AS RESOURCE_BILLABLE_ACTUAL,
   (SELECT CLOB_DATA FROM EMPTYLOB) AS ATTRIBUTES
   FROM PMO_PIVOT_TMP_RESOURCES R
   JOIN PMO_PIVOT_TMP_RES_MONTH C
   ON C.RESOURCE_ID = R.RESOURCE_ID
   
   UNION ALL
   
   SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   R.LEVEL_ID,
   R.TYPE_ID,
   R.REF_TYPE,
   R.PROJECT_ID,
   R.PROJECT_NAME,
   R.PROJECT_REF_NUMBER,
   R.PROJECT_CURRENCY,
   R.PROJECT_START_DT,
   R.PROJECT_FINISH_DT,
   R.PROJECT_CLIENT,
   R.PROJECT_MANAGER,
   R.STATUS_PRIORITY,
   R.STATUS_STAGE,
   R.STATUS_PERCENT_COMPLETE,
   R.STATUS_PERCENT_SPENT,
   R.RESOURCE_ID,
   R.RESOURCE_NAME,
   R.RESOURCE_WORK_LOCATION,
   R.RESOURCE_STATUS1,
   R.RESOURCE_STATUS2,
   R.RESOURCE_COMPETENCY,
   R.RESOURCE_PROFICIENCY,
   R.RESOURCE_POOL,
   R.RESOURCE_POOL_MANAGER,
   R.RESOURCE_GEO,
   R.RESOURCE_ORG,
   R.RESOURCE_YEAR,
   R.RESOURCE_QUARTER,
   R.RESOURCE_MONTH,
   R.RESOURCE_CALENDAR,
   R.RESOURCE_PROPOSED,
   R.RESOURCE_SCHEDULED,
   R.RESOURCE_ACTUAL,
   R.RESOURCE_BILLABLE_PROPOSED,
   R.RESOURCE_BILLABLE_SCHEDULED,
   R.RESOURCE_BILLABLE_ACTUAL,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES
   FROM UTIL_RES R
   LEFT JOIN PMO_PIVOT_PAT AT
   ON AT.PROJECT_ID = R.PROJECT_ID
   
   
   ORDER BY TYPE_ID,
   RESOURCE_NAME,
   RESOURCE_YEAR,
   RESOURCE_QUARTER,
   RESOURCE_MONTH,
   LEVEL_ID,
   PROJECT_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTILIZATION_PROJECT_OLD', 412+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_UTILIZATION_PROJECT_OLD(413) : views_pivot.sql(4168) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_PPA;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT_OLD', 420+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT_OLD(421) : views_pivot.sql(4176) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTILIZATION_PROJECT_OLD', 432+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTILIZATION_PROJECT_OLD(433) : views_pivot.sql(4188) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTILIZATION_PROJECT_OLD;
ALTER FUNCTION SP_UTILIZATION_PROJECT_OLD COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTIL_POOL_PIVOT ==
CREATE OR REPLACE FUNCTION SP_UTIL_POOL_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTIL_POOL_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTIL_POOL_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_UTIL_POOL_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTIL_POOL_PIVOT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTIL_POOL_PIVOT(23) : views_pivot.sql(4227) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTIL_POOL_PIVOT', 31+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTIL_POOL_PIVOT(32) : views_pivot.sql(4236) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTIL_POOL_PIVOT', 43+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTIL_POOL_PIVOT(44) : views_pivot.sql(4248) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTIL_POOL_PIVOT;
ALTER FUNCTION SP_UTIL_POOL_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_UTIL_PROJ_PIVOT ==
CREATE OR REPLACE FUNCTION SP_UTIL_PROJ_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_UTIL_PROJ_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_UTIL_PROJ_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_UTIL_PROJ_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_UTIL_PROJ_PIVOT', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_UTIL_PROJ_PIVOT(23) : views_pivot.sql(4287) : ' || SYSTIMESTAMP);
   END IF; 

   PMO_DB2M.SC_STATE := 0;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTIL_PROJ_PIVOT', 31+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTIL_PROJ_PIVOT(32) : views_pivot.sql(4296) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_UTIL_PROJ_PIVOT', 43+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_UTIL_PROJ_PIVOT(44) : views_pivot.sql(4308) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_UTIL_PROJ_PIVOT;
ALTER FUNCTION SP_UTIL_PROJ_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_TIMESHEET_PIVOT ==
CREATE OR REPLACE FUNCTION SP_TIMESHEET_PIVOT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_day PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_TPV PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TIMESHEET_PIVOT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TIMESHEET_PIVOT'), '-- ' || SYSTIMESTAMP, ':r := SP_TIMESHEET_PIVOT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_PIVOT', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TIMESHEET_PIVOT(32) : views_pivot.sql(4356) : ' || SYSTIMESTAMP);
   END IF; 

   If p_rec_user IS NULL OR p_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TIMESHEET_PIVOT', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TIMESHEET_PIVOT(37) : views_pivot.sql(4361) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TIMESHEETS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TS_OUT';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECT_MANANGER';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECT_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECT_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   If p_finish_date IS NULL Then
      h_finish_date := p_start_date;
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_PRJ(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   PMO_DB2M.SC_STATE := FC_INIT_PV_ATTR();
   PMO_DB2M.SC_STATE := FC_PV_ATTRIBUTES();
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECT_MANANGER( PROJECT_ID,
      PROJECT_MANAGER_ID,
      PROJECT_MANAGER )
      SELECT  P.PROJECT_ID,
      RA.RESOURCE_ID AS PROJECT_MANAGER_ID,
      PM.FULL_NAME AS PROJECT_MANAGER
      FROM PMO_PIVOT_PROJECTS P
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = P.PROJECT_ID
      AND BITAND(RA.PARTICIPANT,1) = 1
      JOIN RESOURCES PM
      ON PM.RESOURCE_ID = RA.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 104+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(105) : views_pivot.sql(4429) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECT_TASKS(    PROJECT_ID,
      TASK_ID,
      TASK_NAME,
      FS_CODE,
      REF_CODE,
      REFERENCE_NUMBER)
      SELECT  P.PROJECT_ID,
      T.ELEMENT_ID AS TASK_ID,
      T.ELEMENT_NAME AS TASK_NAME,
      T.FS_CODE,
      T.REF_CODE AS REF_CODE,
      T.REFERENCE_NUMBER AS REFERENCE_NUMBER
      FROM PMO_PIVOT_PROJECTS P
      JOIN TMT_WBS T
      ON T.PROJECT_ID = P.PROJECT_ID
      AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = P.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 138+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(139) : views_pivot.sql(4463) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECT_RESOURCES
      SELECT  T.PROJECT_ID,
      T.TASK_ID,
      TA.TSK_ASSIGNMENT_ID,
      PL.ELEMENT_ID AS RESOURCE_POOL_ID,
      PL.ELEMENT_NAME AS RESOURCE_POOL_NAME,
      RM.FULL_NAME AS POOL_MANAGER,
      PL.MASK_EMPLOYEE_INFO,
      ORG.ELEMENT_ID AS RESOURCE_ORG_ID,
      ORG.ELEMENT_NAME AS RESOURCE_ORG_NAME,
      GEO.ELEMENT_ID AS RESOURCE_GEO_ID,
      GEO.ELEMENT_NAME AS RESOURCE_GEO_NAME,
      TM.RESOURCE_ID AS RESOURCE_ID,
      TM.FULL_NAME AS RESOURCE_NAME,
      TM.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
      TM.STATUS1_ID AS RESOURCE_STATUS1,
      TM.STATUS2_ID AS RESOURCE_STATUS2,
      TM.MAXDAYHRS AS RESOURCE_MAX_WEEKLY,
      TM.COUNTRY_CODE AS RESOURCE_COUNTRY_CODE,
      TM.COMPANY_CODE AS RESOURCE_COMPANY_CODE,
      TM.DIVISION_CODE AS RESOURCE_DIVISION_CODE,
      TM.DEPARTMENT_CODE AS RESOURCE_DEPARTMENT_CODE,
      CASE WHEN PL.MASK_EMPLOYEE_INFO = 1 THEN SUBSTR('**********',1,LENGTH(TM.EMPLOYEE_CODE)) ELSE TM.EMPLOYEE_CODE END AS RESOURCE_EMPLOYEE_CODE,
      TM.CUSTOM_01 AS RESOURCE_CUSTOM_01,
      TM.CUSTOM_02 AS RESOURCE_CUSTOM_02,
      TM.CUSTOM_03 AS RESOURCE_CUSTOM_03,
      TM.CUSTOM_04 AS RESOURCE_CUSTOM_04,
      TM.CUSTOM_05 AS RESOURCE_CUSTOM_05
      FROM PMO_PIVOT_PROJECT_TASKS T
      JOIN TASK_ASSIGNMENTS TA
      ON TA.PROJECT_ID = T.PROJECT_ID
      AND TA.TASK_ID = T.TASK_ID
      JOIN RESOURCES TM
      ON TM.RESOURCE_ID = TA.RESOURCE_ID
      JOIN TMT_POOLS TMP
      ON TMP.ELEMENT_ID = TM.RESOURCE_ID
      JOIN TMT_POOLS PL
      ON PL.ELEMENT_ID = TMP.PARENT_ID
      JOIN RESOURCE_ASSIGNMENTS RMA
      ON RMA.ELEMENT_ID = PL.ELEMENT_ID
      AND BITAND(RMA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RMA.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS TMO
      ON TMO.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS ORG
      ON ORG.ELEMENT_ID = TMO.PARENT_ID
      LEFT JOIN TMT_GEOGRAPHIES TMG
      ON TMG.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_GEOGRAPHIES GEO
      ON GEO.ELEMENT_ID = TMG.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 205+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(206) : views_pivot.sql(4530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_day
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 219+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(220) : views_pivot.sql(4544) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TIMESHEETS
      SELECT  P.PROJECT_ID AS PROJECT_ID,
      P.PROJECT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.PROJECT_MANAGER_ID,
      PM.PROJECT_MANAGER,
      T.TASK_ID,
      T.TASK_NAME,
      T.REF_CODE, 
      T.REFERENCE_NUMBER, 
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      T1.ELEMENT_ID AS TIME_CODE1_ID,
      T1.ELEMENT_NAME AS TIME_CODE1,
      T2.ELEMENT_ID AS TIME_CODE2_ID,
      T2.ELEMENT_NAME AS TIME_CODE2,
      T.FS_CODE,
      ST.SUNDAY_REGULAR AS TIME_REG_SUN,
      ST.MONDAY_REGULAR AS TIME_REG_MON,
      ST.TUESDAY_REGULAR AS TIME_REG_TUE,
      ST.WEDNESDAY_REGULAR AS TIME_REG_WED,
      ST.THURSDAY_REGULAR AS TIME_REG_THU,
      ST.FRIDAY_REGULAR AS TIME_REG_FRI,
      ST.SATURDAY_REGULAR AS TIME_REG_SAT,
      ST.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      ST.MONDAY_SPECIAL AS TIME_OVR_MON,
      ST.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      ST.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      ST.THURSDAY_SPECIAL AS TIME_OVR_THU,
      ST.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      ST.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_PROJECTS P
      JOIN PMO_PIVOT_PROJECT_MANANGER PM
      ON PM.PROJECT_ID = P.PROJECT_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.PROJECT_ID = P.PROJECT_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT = 0
      JOIN PMO_PIVOT_PROJECT_TASKS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.TASK_ID = TA.TASK_ID
      JOIN PMO_PIVOT_PROJECT_RESOURCES TM
      ON TM.PROJECT_ID = ST.PROJECT_ID
      AND TM.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TM.RESOURCE_ID = ST.RESOURCE_ID
      LEFT JOIN TMT_TIMECODES T1
      ON T1.ELEMENT_ID = ST.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES T2
      ON T2.ELEMENT_ID = ST.TIMECODE_2_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 326+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(327) : views_pivot.sql(4651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TIMESHEETS
      SELECT  P.PROJECT_ID AS PROJECT_ID,
      P.PROJECT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.PROJECT_MANAGER_ID,
      PM.PROJECT_MANAGER,
      T.TASK_ID,
      T.TASK_NAME,
      T.REF_CODE, 
      T.REFERENCE_NUMBER, 
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      TD1.ELEMENT_ID AS TIME_CODE1_ID,
      TD1.ELEMENT_NAME AS TIME_CODE1,
      TD2.ELEMENT_ID AS TIME_CODE2_ID,
      TD2.ELEMENT_NAME AS TIME_CODE2,
      T.FS_CODE,
      DT.SUNDAY_REGULAR AS TIME_REG_SUN,
      DT.MONDAY_REGULAR AS TIME_REG_MON,
      DT.TUESDAY_REGULAR AS TIME_REG_TUE,
      DT.WEDNESDAY_REGULAR AS TIME_REG_WED,
      DT.THURSDAY_REGULAR AS TIME_REG_THU,
      DT.FRIDAY_REGULAR AS TIME_REG_FRI,
      DT.SATURDAY_REGULAR AS TIME_REG_SAT,
      DT.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      DT.MONDAY_SPECIAL AS TIME_OVR_MON,
      DT.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      DT.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      DT.THURSDAY_SPECIAL AS TIME_OVR_THU,
      DT.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      DT.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_PROJECTS P
      JOIN PMO_PIVOT_PROJECT_MANANGER PM
      ON PM.PROJECT_ID = P.PROJECT_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.PROJECT_ID = P.PROJECT_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT <> 0
      JOIN PMO_PIVOT_PROJECT_TASKS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.TASK_ID = TA.TASK_ID
      JOIN PMO_PIVOT_PROJECT_RESOURCES TM
      ON TM.PROJECT_ID = ST.PROJECT_ID
      AND TM.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TM.RESOURCE_ID = ST.RESOURCE_ID
      JOIN ACTIVITIES ACT
      ON ACT.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      JOIN DETAIL_TIMESHEETS DT
      ON DT.ACTIVITY_ID = ACT.ELEMENT_ID
      AND DT.WEEK_OF = ST.WEEK_OF
      LEFT JOIN TMT_TIMECODES TD1
      ON TD1.ELEMENT_ID = ACT.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES TD2
      ON TD2.ELEMENT_ID = ACT.TIMECODE_2_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 438+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(439) : views_pivot.sql(4763) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TS_OUT
      SELECT  P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE,
      P.TASK_REFERENCE,
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2,
      P.FS_CODE,
      SUM(P.TIME_REG_SUN) AS TIME_REG_SUN,
      SUM(P.TIME_REG_MON) AS TIME_REG_MON,
      SUM(P.TIME_REG_TUE) AS TIME_REG_TUE,
      SUM(P.TIME_REG_WED) AS TIME_REG_WED,
      SUM(P.TIME_REG_THU) AS TIME_REG_THU,
      SUM(P.TIME_REG_FRI) AS TIME_REG_FRI,
      SUM(P.TIME_REG_SAT) AS TIME_REG_SAT,
      SUM(P.TIME_OVR_SUN) AS TIME_OVR_SUN,
      SUM(P.TIME_OVR_MON) AS TIME_OVR_MON,
      SUM(P.TIME_OVR_TUE) AS TIME_OVR_TUE,
      SUM(P.TIME_OVR_WED) AS TIME_OVR_WED,
      SUM(P.TIME_OVR_THU) AS TIME_OVR_THU,
      SUM(P.TIME_OVR_FRI) AS TIME_OVR_FRI,
      SUM(P.TIME_OVR_SAT) AS TIME_OVR_SAT
      FROM PMO_PIVOT_TIMESHEETS P
      
      GROUP BY    P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE,
      P.TASK_REFERENCE,
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2,
      P.FS_CODE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 565+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(566) : views_pivot.sql(4890) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TPV FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE,
   P.TASK_REFERENCE,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES,
   h_day AS WEEK_FIRSTDAY,
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2,
   P.FS_CODE,
   P.TIME_REG_SUN,
   P.TIME_REG_MON,
   P.TIME_REG_TUE,
   P.TIME_REG_WED,
   P.TIME_REG_THU,
   P.TIME_REG_FRI,
   P.TIME_REG_SAT,
   P.TIME_OVR_SUN,
   P.TIME_OVR_MON,
   P.TIME_OVR_TUE,
   P.TIME_OVR_WED,
   P.TIME_OVR_THU,
   P.TIME_OVR_FRI,
   P.TIME_OVR_SAT
   FROM PMO_PIVOT_TS_OUT P
   LEFT JOIN PMO_PIVOT_PAT AT
   ON AT.PROJECT_ID = P.PROJECT_ID
   
   ORDER BY    P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE,
   P.TASK_REFERENCE,
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2,
   P.FS_CODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_PIVOT', 688+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TIMESHEET_PIVOT(689) : views_pivot.sql(5013) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_TPV;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 696+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(697) : views_pivot.sql(5021) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT', 708+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT(709) : views_pivot.sql(5033) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TIMESHEET_PIVOT;
ALTER FUNCTION SP_TIMESHEET_PIVOT COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_TIMESHEET_PIVOT_ATTR ==
CREATE OR REPLACE FUNCTION SP_TIMESHEET_PIVOT_ATTR
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_attribute_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_day PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_TPVAE PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TIMESHEET_PIVOT_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TIMESHEET_PIVOT_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_TIMESHEET_PIVOT_ATTR(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_attribute_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_PIVOT_ATTR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TIMESHEET_PIVOT_ATTR(34) : views_pivot.sql(5083) : ' || SYSTIMESTAMP);
   END IF; 

   If p_rec_user IS NULL OR p_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TIMESHEET_PIVOT_ATTR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TIMESHEET_PIVOT_ATTR(39) : views_pivot.sql(5088) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TIMESHEETS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TS_OUT';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECT_MANANGER';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECT_TASKS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_PROJECT_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   If p_finish_date IS NULL Then
      h_finish_date := p_start_date;
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_PRJ(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   PMO_DB2M.SC_STATE := FC_INIT_PV_ATTR();
   PMO_DB2M.SC_STATE := FC_PV_ATTRIBUTES();
   
   --Attribute filter
   If p_attribute_id IS NOT NULL Then
      BEGIN
         DELETE FROM PMO_PIVOT_PROJECTS
         WHERE PROJECT_ID IN (
         SELECT PROJECT_ID
         FROM PMO_PIVOT_PROJECTS
         MINUS
         SELECT ELEMENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE PARENT_ID = p_attribute_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 105+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(106) : views_pivot.sql(5155) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECT_MANANGER( PROJECT_ID,
      PROJECT_MANAGER_ID,
      PROJECT_MANAGER )
      SELECT  P.PROJECT_ID,
      RA.RESOURCE_ID AS PROJECT_MANAGER_ID,
      PM.FULL_NAME AS PROJECT_MANAGER
      FROM PMO_PIVOT_PROJECTS P
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = P.PROJECT_ID
      AND BITAND(RA.PARTICIPANT,1) = 1
      JOIN RESOURCES PM
      ON PM.RESOURCE_ID = RA.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 134+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(135) : views_pivot.sql(5184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECT_TASKS(    PROJECT_ID,
      TASK_ID,
      TASK_NAME,
      FS_CODE,
      REF_CODE,
      REFERENCE_NUMBER)
      SELECT  P.PROJECT_ID,
      T.ELEMENT_ID AS TASK_ID,
      T.ELEMENT_NAME AS TASK_NAME,
      T.FS_CODE,
      T.REF_CODE AS REF_CODE,
      T.REFERENCE_NUMBER AS REFERENCE_NUMBER
      FROM PMO_PIVOT_PROJECTS P
      JOIN TMT_WBS T
      ON T.PROJECT_ID = P.PROJECT_ID
      AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      JOIN TMT_WBS PRJ
      ON PRJ.ELEMENT_ID = P.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 168+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(169) : views_pivot.sql(5218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_PROJECT_RESOURCES
      SELECT  T.PROJECT_ID,
      T.TASK_ID,
      TA.TSK_ASSIGNMENT_ID,
      PL.ELEMENT_ID AS RESOURCE_POOL_ID,
      PL.ELEMENT_NAME AS RESOURCE_POOL_NAME,
      RM.FULL_NAME AS POOL_MANAGER,
      PL.MASK_EMPLOYEE_INFO,
      ORG.ELEMENT_ID AS RESOURCE_ORG_ID,
      ORG.ELEMENT_NAME AS RESOURCE_ORG_NAME,
      GEO.ELEMENT_ID AS RESOURCE_GEO_ID,
      GEO.ELEMENT_NAME AS RESOURCE_GEO_NAME,
      TM.RESOURCE_ID AS RESOURCE_ID,
      TM.FULL_NAME AS RESOURCE_NAME,
      TM.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
      TM.STATUS1_ID AS RESOURCE_STATUS1,
      TM.STATUS2_ID AS RESOURCE_STATUS2,
      TM.MAXDAYHRS AS RESOURCE_MAX_WEEKLY,
      TM.COUNTRY_CODE AS RESOURCE_COUNTRY_CODE,
      TM.COMPANY_CODE AS RESOURCE_COMPANY_CODE,
      TM.DIVISION_CODE AS RESOURCE_DIVISION_CODE,
      TM.DEPARTMENT_CODE AS RESOURCE_DEPARTMENT_CODE,
      CASE WHEN PL.MASK_EMPLOYEE_INFO = 1 THEN SUBSTR('**********',1,LENGTH(TM.EMPLOYEE_CODE)) ELSE TM.EMPLOYEE_CODE END AS RESOURCE_EMPLOYEE_CODE,
      TM.CUSTOM_01 AS RESOURCE_CUSTOM_01,
      TM.CUSTOM_02 AS RESOURCE_CUSTOM_02,
      TM.CUSTOM_03 AS RESOURCE_CUSTOM_03,
      TM.CUSTOM_04 AS RESOURCE_CUSTOM_04,
      TM.CUSTOM_05 AS RESOURCE_CUSTOM_05
      FROM PMO_PIVOT_PROJECT_TASKS T
      JOIN TASK_ASSIGNMENTS TA
      ON TA.PROJECT_ID = T.PROJECT_ID
      AND TA.TASK_ID = T.TASK_ID
      JOIN RESOURCES TM
      ON TM.RESOURCE_ID = TA.RESOURCE_ID
      JOIN TMT_POOLS TMP
      ON TMP.ELEMENT_ID = TM.RESOURCE_ID
      JOIN TMT_POOLS PL
      ON PL.ELEMENT_ID = TMP.PARENT_ID
      JOIN RESOURCE_ASSIGNMENTS RMA
      ON RMA.ELEMENT_ID = PL.ELEMENT_ID
      AND BITAND(RMA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RMA.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS TMO
      ON TMO.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS ORG
      ON ORG.ELEMENT_ID = TMO.PARENT_ID
      LEFT JOIN TMT_GEOGRAPHIES TMG
      ON TMG.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_GEOGRAPHIES GEO
      ON GEO.ELEMENT_ID = TMG.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 235+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(236) : views_pivot.sql(5285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_day
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 249+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(250) : views_pivot.sql(5299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TIMESHEETS
      SELECT  P.PROJECT_ID AS PROJECT_ID,
      P.PROJECT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.PROJECT_MANAGER_ID,
      PM.PROJECT_MANAGER,
      T.TASK_ID,
      T.TASK_NAME,
      T.REF_CODE,
      T.REFERENCE_NUMBER,
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      T1.ELEMENT_ID AS TIME_CODE1_ID,
      T1.ELEMENT_NAME AS TIME_CODE1,
      T2.ELEMENT_ID AS TIME_CODE2_ID,
      T2.ELEMENT_NAME AS TIME_CODE2,
      T.FS_CODE,
      ST.SUNDAY_REGULAR AS TIME_REG_SUN,
      ST.MONDAY_REGULAR AS TIME_REG_MON,
      ST.TUESDAY_REGULAR AS TIME_REG_TUE,
      ST.WEDNESDAY_REGULAR AS TIME_REG_WED,
      ST.THURSDAY_REGULAR AS TIME_REG_THU,
      ST.FRIDAY_REGULAR AS TIME_REG_FRI,
      ST.SATURDAY_REGULAR AS TIME_REG_SAT,
      ST.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      ST.MONDAY_SPECIAL AS TIME_OVR_MON,
      ST.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      ST.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      ST.THURSDAY_SPECIAL AS TIME_OVR_THU,
      ST.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      ST.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_PROJECTS P
      JOIN PMO_PIVOT_PROJECT_MANANGER PM
      ON PM.PROJECT_ID = P.PROJECT_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.PROJECT_ID = P.PROJECT_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT = 0
      JOIN PMO_PIVOT_PROJECT_TASKS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.TASK_ID = TA.TASK_ID
      JOIN PMO_PIVOT_PROJECT_RESOURCES TM
      ON TM.PROJECT_ID = ST.PROJECT_ID
      AND TM.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TM.RESOURCE_ID = ST.RESOURCE_ID
      LEFT JOIN TMT_TIMECODES T1
      ON T1.ELEMENT_ID = ST.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES T2
      ON T2.ELEMENT_ID = ST.TIMECODE_2_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 356+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(357) : views_pivot.sql(5406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TIMESHEETS
      SELECT  P.PROJECT_ID AS PROJECT_ID,
      P.PROJECT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.PROJECT_MANAGER_ID,
      PM.PROJECT_MANAGER,
      T.TASK_ID,
      T.TASK_NAME,
      T.REF_CODE,
      T.REFERENCE_NUMBER,
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      TD1.ELEMENT_ID AS TIME_CODE1_ID,
      TD1.ELEMENT_NAME AS TIME_CODE1,
      TD2.ELEMENT_ID AS TIME_CODE2_ID,
      TD2.ELEMENT_NAME AS TIME_CODE2,
      T.FS_CODE,
      DT.SUNDAY_REGULAR AS TIME_REG_SUN,
      DT.MONDAY_REGULAR AS TIME_REG_MON,
      DT.TUESDAY_REGULAR AS TIME_REG_TUE,
      DT.WEDNESDAY_REGULAR AS TIME_REG_WED,
      DT.THURSDAY_REGULAR AS TIME_REG_THU,
      DT.FRIDAY_REGULAR AS TIME_REG_FRI,
      DT.SATURDAY_REGULAR AS TIME_REG_SAT,
      DT.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      DT.MONDAY_SPECIAL AS TIME_OVR_MON,
      DT.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      DT.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      DT.THURSDAY_SPECIAL AS TIME_OVR_THU,
      DT.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      DT.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_PROJECTS P
      JOIN PMO_PIVOT_PROJECT_MANANGER PM
      ON PM.PROJECT_ID = P.PROJECT_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.PROJECT_ID = P.PROJECT_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT <> 0
      JOIN PMO_PIVOT_PROJECT_TASKS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.TASK_ID = TA.TASK_ID
      JOIN PMO_PIVOT_PROJECT_RESOURCES TM
      ON TM.PROJECT_ID = ST.PROJECT_ID
      AND TM.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TM.RESOURCE_ID = ST.RESOURCE_ID
      JOIN ACTIVITIES ACT
      ON ACT.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      JOIN DETAIL_TIMESHEETS DT
      ON DT.ACTIVITY_ID = ACT.ELEMENT_ID
      AND DT.WEEK_OF = ST.WEEK_OF
      LEFT JOIN TMT_TIMECODES TD1
      ON TD1.ELEMENT_ID = ACT.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES TD2
      ON TD2.ELEMENT_ID = ACT.TIMECODE_2_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 468+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(469) : views_pivot.sql(5518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TS_OUT
      SELECT  P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE,
      P.TASK_REFERENCE,
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2,
      P.FS_CODE,
      SUM(P.TIME_REG_SUN) AS TIME_REG_SUN,
      SUM(P.TIME_REG_MON) AS TIME_REG_MON,
      SUM(P.TIME_REG_TUE) AS TIME_REG_TUE,
      SUM(P.TIME_REG_WED) AS TIME_REG_WED,
      SUM(P.TIME_REG_THU) AS TIME_REG_THU,
      SUM(P.TIME_REG_FRI) AS TIME_REG_FRI,
      SUM(P.TIME_REG_SAT) AS TIME_REG_SAT,
      SUM(P.TIME_OVR_SUN) AS TIME_OVR_SUN,
      SUM(P.TIME_OVR_MON) AS TIME_OVR_MON,
      SUM(P.TIME_OVR_TUE) AS TIME_OVR_TUE,
      SUM(P.TIME_OVR_WED) AS TIME_OVR_WED,
      SUM(P.TIME_OVR_THU) AS TIME_OVR_THU,
      SUM(P.TIME_OVR_FRI) AS TIME_OVR_FRI,
      SUM(P.TIME_OVR_SAT) AS TIME_OVR_SAT
      FROM PMO_PIVOT_TIMESHEETS P
      
      GROUP BY    P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE,
      P.TASK_REFERENCE,
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2,
      P.FS_CODE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 595+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(596) : views_pivot.sql(5645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TPVAE FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE,
   P.TASK_REFERENCE,
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES,
   h_day AS WEEK_FIRSTDAY,
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2,
   P.FS_CODE,
   P.TIME_REG_SUN,
   P.TIME_REG_MON,
   P.TIME_REG_TUE,
   P.TIME_REG_WED,
   P.TIME_REG_THU,
   P.TIME_REG_FRI,
   P.TIME_REG_SAT,
   P.TIME_OVR_SUN,
   P.TIME_OVR_MON,
   P.TIME_OVR_TUE,
   P.TIME_OVR_WED,
   P.TIME_OVR_THU,
   P.TIME_OVR_FRI,
   P.TIME_OVR_SAT
   FROM PMO_PIVOT_TS_OUT P
   LEFT JOIN PMO_PIVOT_PAT AT
   ON AT.PROJECT_ID = P.PROJECT_ID
   
   ORDER BY    P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE,
   P.TASK_REFERENCE,
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2,
   P.FS_CODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_PIVOT_ATTR', 718+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TIMESHEET_PIVOT_ATTR(719) : views_pivot.sql(5768) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_TPVAE;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 726+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(727) : views_pivot.sql(5776) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_PIVOT_ATTR', 738+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_PIVOT_ATTR(739) : views_pivot.sql(5788) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TIMESHEET_PIVOT_ATTR;
ALTER FUNCTION SP_TIMESHEET_PIVOT_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_TIMESHEET_POOL ==
CREATE OR REPLACE FUNCTION SP_TIMESHEET_POOL
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_day PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_TPL PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TIMESHEET_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TIMESHEET_POOL'), '-- ' || SYSTIMESTAMP, ':r := SP_TIMESHEET_POOL(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_POOL', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TIMESHEET_POOL(32) : views_pivot.sql(5836) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TIMESHEET_POOL', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TIMESHEET_POOL(37) : views_pivot.sql(5841) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_TIMESHEETS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_TS_OUT';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_TS_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   If p_finish_date IS NULL Then
      h_finish_date := p_start_date;
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_RES(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   PMO_DB2M.SC_STATE := FC_INIT_RES_PRJ();
   PMO_DB2M.SC_STATE := FC_INIT_PV_ATTR();
   PMO_DB2M.SC_STATE := FC_PV_ATTRIBUTES();
   
   BEGIN
      INSERT INTO PMO_POOL_TS_RESOURCES
      SELECT  PL.ELEMENT_ID AS RESOURCE_POOL_ID,
      PL.ELEMENT_NAME AS RESOURCE_POOL_NAME,
      RM.FULL_NAME AS POOL_MANAGER,
      PL.MASK_EMPLOYEE_INFO,
      ORG.ELEMENT_ID AS RESOURCE_ORG_ID,
      ORG.ELEMENT_NAME AS RESOURCE_ORG_NAME,
      GEO.ELEMENT_ID AS RESOURCE_GEO_ID,
      GEO.ELEMENT_NAME AS RESOURCE_GEO_NAME,
      TM.RESOURCE_ID AS RESOURCE_ID,
      TM.FULL_NAME AS RESOURCE_NAME,
      TM.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
      TM.STATUS1_ID AS RESOURCE_STATUS1,
      TM.STATUS2_ID AS RESOURCE_STATUS2,
      TM.MAXDAYHRS AS RESOURCE_MAX_WEEKLY,
      TM.COUNTRY_CODE AS RESOURCE_COUNTRY_CODE,
      TM.COMPANY_CODE AS RESOURCE_COMPANY_CODE,
      TM.DIVISION_CODE AS RESOURCE_DIVISION_CODE,
      TM.DEPARTMENT_CODE AS RESOURCE_DEPARTMENT_CODE,
      CASE WHEN PL.MASK_EMPLOYEE_INFO = 1 THEN SUBSTR('**********',1,LENGTH(TM.EMPLOYEE_CODE)) ELSE TM.EMPLOYEE_CODE END AS RESOURCE_EMPLOYEE_CODE,
      TM.CUSTOM_01 AS RESOURCE_CUSTOM_01,
      TM.CUSTOM_02 AS RESOURCE_CUSTOM_02,
      TM.CUSTOM_03 AS RESOURCE_CUSTOM_03,
      TM.CUSTOM_04 AS RESOURCE_CUSTOM_04,
      TM.CUSTOM_05 AS RESOURCE_CUSTOM_05
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN RESOURCES TM
      ON TM.RESOURCE_ID = R.RESOURCE_ID
      JOIN TMT_POOLS TMP
      ON TMP.ELEMENT_ID = TM.RESOURCE_ID
      JOIN TMT_POOLS PL
      ON PL.ELEMENT_ID = TMP.PARENT_ID
      JOIN RESOURCE_ASSIGNMENTS RMA
      ON RMA.ELEMENT_ID = PL.ELEMENT_ID
      AND BITAND(RMA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RMA.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS TMO
      ON TMO.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS ORG
      ON ORG.ELEMENT_ID = TMO.PARENT_ID
      LEFT JOIN TMT_GEOGRAPHIES TMG
      ON TMG.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_GEOGRAPHIES GEO
      ON GEO.ELEMENT_ID = TMG.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL(131) : views_pivot.sql(5935) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_day
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL', 144+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL(145) : views_pivot.sql(5949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_POOL_TIMESHEETS
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      P.ELEMENT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.RESOURCE_ID AS PROJECT_MANAGER_ID,
      PM.FULL_NAME AS PROJECT_MANAGER,
      T.ELEMENT_ID AS TASK_ID,
      T.ELEMENT_NAME AS TASK_NAME,
      T.REF_CODE, 
      T.REFERENCE_NUMBER, 
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      T1.ELEMENT_ID AS TIME_CODE1_ID,
      T1.ELEMENT_NAME AS TIME_CODE1,
      T2.ELEMENT_ID AS TIME_CODE2_ID,
      T2.ELEMENT_NAME AS TIME_CODE2,
      ST.SUNDAY_REGULAR AS TIME_REG_SUN,
      ST.MONDAY_REGULAR AS TIME_REG_MON,
      ST.TUESDAY_REGULAR AS TIME_REG_TUE,
      ST.WEDNESDAY_REGULAR AS TIME_REG_WED,
      ST.THURSDAY_REGULAR AS TIME_REG_THU,
      ST.FRIDAY_REGULAR AS TIME_REG_FRI,
      ST.SATURDAY_REGULAR AS TIME_REG_SAT,
      ST.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      ST.MONDAY_SPECIAL AS TIME_OVR_MON,
      ST.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      ST.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      ST.THURSDAY_SPECIAL AS TIME_OVR_THU,
      ST.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      ST.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_POOL_TS_RESOURCES TM
      ON TM.RESOURCE_ID = R.RESOURCE_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.RESOURCE_ID = TM.RESOURCE_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT = 0
      JOIN TMT_WBS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.ELEMENT_ID = TA.TASK_ID
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = ST.PROJECT_ID
      AND BITAND(RA.PARTICIPANT,1) = 1
      JOIN RESOURCES PM
      ON PM.RESOURCE_ID = RA.RESOURCE_ID
      JOIN TMT_WBS P
      ON P.ELEMENT_ID = RA.PROJECT_ID
      LEFT JOIN TMT_TIMECODES T1
      ON T1.ELEMENT_ID = ST.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES T2
      ON T2.ELEMENT_ID = ST.TIMECODE_2_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL', 253+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL(254) : views_pivot.sql(6058) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_POOL_TIMESHEETS
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      P.ELEMENT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.RESOURCE_ID AS PROJECT_MANAGER_ID,
      PM.FULL_NAME AS PROJECT_MANAGER,
      T.ELEMENT_ID AS TASK_ID,
      T.ELEMENT_NAME AS TASK_NAME,
      T.REF_CODE, 
      T.REFERENCE_NUMBER, 
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      TD1.ELEMENT_ID AS TIME_CODE1_ID,
      TD1.ELEMENT_NAME AS TIME_CODE1,
      TD2.ELEMENT_ID AS TIME_CODE2_ID,
      TD2.ELEMENT_NAME AS TIME_CODE2,
      DT.SUNDAY_REGULAR AS TIME_REG_SUN,
      DT.MONDAY_REGULAR AS TIME_REG_MON,
      DT.TUESDAY_REGULAR AS TIME_REG_TUE,
      DT.WEDNESDAY_REGULAR AS TIME_REG_WED,
      DT.THURSDAY_REGULAR AS TIME_REG_THU,
      DT.FRIDAY_REGULAR AS TIME_REG_FRI,
      DT.SATURDAY_REGULAR AS TIME_REG_SAT,
      DT.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      DT.MONDAY_SPECIAL AS TIME_OVR_MON,
      DT.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      DT.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      DT.THURSDAY_SPECIAL AS TIME_OVR_THU,
      DT.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      DT.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_POOL_TS_RESOURCES TM
      ON TM.RESOURCE_ID = R.RESOURCE_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.RESOURCE_ID = TM.RESOURCE_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT <> 0
      JOIN TMT_WBS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN ACTIVITIES ACT
      ON ACT.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      LEFT JOIN DETAIL_TIMESHEETS DT
      ON DT.ACTIVITY_ID = ACT.ELEMENT_ID
      AND DT.WEEK_OF = ST.WEEK_OF
      LEFT JOIN TMT_TIMECODES TD1
      ON TD1.ELEMENT_ID = ACT.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES TD2
      ON TD2.ELEMENT_ID = ACT.TIMECODE_2_ID
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = ST.PROJECT_ID
      AND BITAND(RA.PARTICIPANT,1) = 1
      JOIN RESOURCES PM
      ON PM.RESOURCE_ID = RA.RESOURCE_ID
      JOIN TMT_WBS P
      ON P.ELEMENT_ID = RA.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL', 367+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL(368) : views_pivot.sql(6172) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_POOL_TS_OUT
      SELECT  P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE, 
      P.TASK_REFERENCE, 
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2,
      SUM(P.TIME_REG_SUN) AS TIME_REG_SUN,
      SUM(P.TIME_REG_MON) AS TIME_REG_MON,
      SUM(P.TIME_REG_TUE) AS TIME_REG_TUE,
      SUM(P.TIME_REG_WED) AS TIME_REG_WED,
      SUM(P.TIME_REG_THU) AS TIME_REG_THU,
      SUM(P.TIME_REG_FRI) AS TIME_REG_FRI,
      SUM(P.TIME_REG_SAT) AS TIME_REG_SAT,
      SUM(P.TIME_OVR_SUN) AS TIME_OVR_SUN,
      SUM(P.TIME_OVR_MON) AS TIME_OVR_MON,
      SUM(P.TIME_OVR_TUE) AS TIME_OVR_TUE,
      SUM(P.TIME_OVR_WED) AS TIME_OVR_WED,
      SUM(P.TIME_OVR_THU) AS TIME_OVR_THU,
      SUM(P.TIME_OVR_FRI) AS TIME_OVR_FRI,
      SUM(P.TIME_OVR_SAT) AS TIME_OVR_SAT
      FROM PMO_POOL_TIMESHEETS P
      
      GROUP BY    P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE, 
      P.TASK_REFERENCE, 
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL', 492+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL(493) : views_pivot.sql(6297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TPL FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE, 
   P.TASK_REFERENCE, 
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES,
   h_day AS WEEK_FIRSTDAY,
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2,
   P.TIME_REG_SUN,
   P.TIME_REG_MON,
   P.TIME_REG_TUE,
   P.TIME_REG_WED,
   P.TIME_REG_THU,
   P.TIME_REG_FRI,
   P.TIME_REG_SAT,
   P.TIME_OVR_SUN,
   P.TIME_OVR_MON,
   P.TIME_OVR_TUE,
   P.TIME_OVR_WED,
   P.TIME_OVR_THU,
   P.TIME_OVR_FRI,
   P.TIME_OVR_SAT
   FROM PMO_POOL_TS_OUT P
   LEFT JOIN PMO_PIVOT_PAT AT
   ON AT.PROJECT_ID = P.PROJECT_ID
   
   ORDER BY    P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE, 
   P.TASK_REFERENCE, 
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_POOL', 613+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TIMESHEET_POOL(614) : views_pivot.sql(6418) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_TPL;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL', 621+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL(622) : views_pivot.sql(6426) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL', 633+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL(634) : views_pivot.sql(6438) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TIMESHEET_POOL;
ALTER FUNCTION SP_TIMESHEET_POOL COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_TIMESHEET_POOL_ATTR ==
CREATE OR REPLACE FUNCTION SP_TIMESHEET_POOL_ATTR
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_attribute_id VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_day PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_TPLA PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TIMESHEET_POOL_ATTR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TIMESHEET_POOL_ATTR'), '-- ' || SYSTIMESTAMP, ':r := SP_TIMESHEET_POOL_ATTR(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_attribute_id || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_POOL_ATTR', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TIMESHEET_POOL_ATTR(34) : views_pivot.sql(6488) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TIMESHEET_POOL_ATTR', 38+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TIMESHEET_POOL_ATTR(39) : views_pivot.sql(6493) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_TIMESHEETS';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_TS_OUT';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_POOL_TS_RESOURCES';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   If p_finish_date IS NULL Then
      h_finish_date := p_start_date;
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_RES(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   PMO_DB2M.SC_STATE := FC_INIT_RES_PRJ();
   
   --Attribute filter
   If p_attribute_id IS NOT NULL Then
      BEGIN
         DELETE FROM PMO_PIVOT_PROJECTS
         WHERE PROJECT_ID IN (
         SELECT PROJECT_ID
         FROM PMO_PIVOT_PROJECTS
         MINUS
         SELECT ELEMENT_ID
         FROM TMT_WBS_ATTRIBUTES
         WHERE PARENT_ID = p_attribute_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 96+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(97) : views_pivot.sql(6551) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   PMO_DB2M.SC_STATE := FC_INIT_PV_ATTR();
   PMO_DB2M.SC_STATE := FC_PV_ATTRIBUTES();
   
   BEGIN
      INSERT INTO PMO_POOL_TS_RESOURCES
      SELECT  PL.ELEMENT_ID AS RESOURCE_POOL_ID,
      PL.ELEMENT_NAME AS RESOURCE_POOL_NAME,
      RM.FULL_NAME AS POOL_MANAGER,
      PL.MASK_EMPLOYEE_INFO,
      ORG.ELEMENT_ID AS RESOURCE_ORG_ID,
      ORG.ELEMENT_NAME AS RESOURCE_ORG_NAME,
      GEO.ELEMENT_ID AS RESOURCE_GEO_ID,
      GEO.ELEMENT_NAME AS RESOURCE_GEO_NAME,
      TM.RESOURCE_ID AS RESOURCE_ID,
      TM.FULL_NAME AS RESOURCE_NAME,
      TM.WORK_LOCATION AS RESOURCE_WORK_LOCATION,
      TM.STATUS1_ID AS RESOURCE_STATUS1,
      TM.STATUS2_ID AS RESOURCE_STATUS2,
      TM.MAXDAYHRS AS RESOURCE_MAX_WEEKLY,
      TM.COUNTRY_CODE AS RESOURCE_COUNTRY_CODE,
      TM.COMPANY_CODE AS RESOURCE_COMPANY_CODE,
      TM.DIVISION_CODE AS RESOURCE_DIVISION_CODE,
      TM.DEPARTMENT_CODE AS RESOURCE_DEPARTMENT_CODE,
      CASE WHEN PL.MASK_EMPLOYEE_INFO = 1 THEN SUBSTR('**********',1,LENGTH(TM.EMPLOYEE_CODE)) ELSE TM.EMPLOYEE_CODE END AS RESOURCE_EMPLOYEE_CODE,
      TM.CUSTOM_01 AS RESOURCE_CUSTOM_01,
      TM.CUSTOM_02 AS RESOURCE_CUSTOM_02,
      TM.CUSTOM_03 AS RESOURCE_CUSTOM_03,
      TM.CUSTOM_04 AS RESOURCE_CUSTOM_04,
      TM.CUSTOM_05 AS RESOURCE_CUSTOM_05
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN RESOURCES TM
      ON TM.RESOURCE_ID = R.RESOURCE_ID
      JOIN TMT_POOLS TMP
      ON TMP.ELEMENT_ID = TM.RESOURCE_ID
      JOIN TMT_POOLS PL
      ON PL.ELEMENT_ID = TMP.PARENT_ID
      JOIN RESOURCE_ASSIGNMENTS RMA
      ON RMA.ELEMENT_ID = PL.ELEMENT_ID
      AND BITAND(RMA.PARTICIPANT, PMO_CNST.SC_RESOURCE_MANAGER) = PMO_CNST.SC_RESOURCE_MANAGER
      JOIN RESOURCES RM
      ON RM.RESOURCE_ID = RMA.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS TMO
      ON TMO.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_ORGANIZATIONS ORG
      ON ORG.ELEMENT_ID = TMO.PARENT_ID
      LEFT JOIN TMT_GEOGRAPHIES TMG
      ON TMG.ELEMENT_ID = TM.RESOURCE_ID
      LEFT JOIN TMT_GEOGRAPHIES GEO
      ON GEO.ELEMENT_ID = TMG.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(162) : views_pivot.sql(6616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_day
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 175+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(176) : views_pivot.sql(6630) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_POOL_TIMESHEETS
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      P.ELEMENT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.RESOURCE_ID AS PROJECT_MANAGER_ID,
      PM.FULL_NAME AS PROJECT_MANAGER,
      T.ELEMENT_ID AS TASK_ID,
      T.ELEMENT_NAME AS TASK_NAME,
      T.REF_CODE, 
      T.REFERENCE_NUMBER, 
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      T1.ELEMENT_ID AS TIME_CODE1_ID,
      T1.ELEMENT_NAME AS TIME_CODE1,
      T2.ELEMENT_ID AS TIME_CODE2_ID,
      T2.ELEMENT_NAME AS TIME_CODE2,
      ST.SUNDAY_REGULAR AS TIME_REG_SUN,
      ST.MONDAY_REGULAR AS TIME_REG_MON,
      ST.TUESDAY_REGULAR AS TIME_REG_TUE,
      ST.WEDNESDAY_REGULAR AS TIME_REG_WED,
      ST.THURSDAY_REGULAR AS TIME_REG_THU,
      ST.FRIDAY_REGULAR AS TIME_REG_FRI,
      ST.SATURDAY_REGULAR AS TIME_REG_SAT,
      ST.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      ST.MONDAY_SPECIAL AS TIME_OVR_MON,
      ST.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      ST.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      ST.THURSDAY_SPECIAL AS TIME_OVR_THU,
      ST.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      ST.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_POOL_TS_RESOURCES TM
      ON TM.RESOURCE_ID = R.RESOURCE_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.RESOURCE_ID = TM.RESOURCE_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      JOIN PMO_PIVOT_PROJECTS X
      ON X.PROJECT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT = 0
      JOIN TMT_WBS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.ELEMENT_ID = TA.TASK_ID
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = ST.PROJECT_ID
      AND BITAND(RA.PARTICIPANT,1) = 1
      JOIN RESOURCES PM
      ON PM.RESOURCE_ID = RA.RESOURCE_ID
      JOIN TMT_WBS P
      ON P.ELEMENT_ID = RA.PROJECT_ID
      LEFT JOIN TMT_TIMECODES T1
      ON T1.ELEMENT_ID = ST.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES T2
      ON T2.ELEMENT_ID = ST.TIMECODE_2_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 286+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(287) : views_pivot.sql(6741) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_POOL_TIMESHEETS
      SELECT  P.ELEMENT_ID AS PROJECT_ID,
      P.ELEMENT_NAME AS PROJECT_NAME,
      P.REF_CODE AS PROJECT_CODE,
      P.REFERENCE_NUMBER AS PROJECT_REFERENCE,
      PM.RESOURCE_ID AS PROJECT_MANAGER_ID,
      PM.FULL_NAME AS PROJECT_MANAGER,
      T.ELEMENT_ID AS TASK_ID,
      T.ELEMENT_NAME AS TASK_NAME,
      T.REF_CODE, 
      T.REFERENCE_NUMBER, 
      PMO_ORASTD.WEEK(ST.WEEK_OF) AS WEEK_NUMBER,
      ST.WEEK_OF AS WEEK_START,
      ST.WEEK_OF + 6      AS WEEK_END,
      CASE WHEN TSA.MANAGER_ID = TSA.RESOURCE_ID THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS WEEK_MY_STATUS,
      TSM.FULL_NAME AS WEEK_MANAGER_NAME,
      TSA.CURRENT_STATE AS WEEK_MANAGER_STATUS,
      TSA.REC_DATETIME AS WEEK_STATUS_DATE,
      TSA.NOTE AS WEEK_STATUS_NOTE,
      TM.RESOURCE_POOL_ID,
      TM.RESOURCE_POOL_NAME,
      TM.POOL_MANAGER,
      TM.MASK_EMPLOYEE_INFO,
      TM.RESOURCE_ORG_ID,
      TM.RESOURCE_ORG_NAME,
      TM.RESOURCE_GEO_ID,
      TM.RESOURCE_GEO_NAME,
      TM.RESOURCE_ID,
      TM.RESOURCE_NAME,
      TM.RESOURCE_WORK_LOCATION,
      TM.RESOURCE_STATUS1,
      TM.RESOURCE_STATUS2,
      TM.RESOURCE_MAX_WEEKLY,
      TM.RESOURCE_COUNTRY_CODE,
      TM.RESOURCE_COMPANY_CODE,
      TM.RESOURCE_DIVISION_CODE,
      TM.RESOURCE_DEPARTMENT_CODE,
      TM.RESOURCE_EMPLOYEE_CODE,
      TM.RESOURCE_CUSTOM_01,
      TM.RESOURCE_CUSTOM_02,
      TM.RESOURCE_CUSTOM_03,
      TM.RESOURCE_CUSTOM_04,
      TM.RESOURCE_CUSTOM_05,
      TD1.ELEMENT_ID AS TIME_CODE1_ID,
      TD1.ELEMENT_NAME AS TIME_CODE1,
      TD2.ELEMENT_ID AS TIME_CODE2_ID,
      TD2.ELEMENT_NAME AS TIME_CODE2,
      DT.SUNDAY_REGULAR AS TIME_REG_SUN,
      DT.MONDAY_REGULAR AS TIME_REG_MON,
      DT.TUESDAY_REGULAR AS TIME_REG_TUE,
      DT.WEDNESDAY_REGULAR AS TIME_REG_WED,
      DT.THURSDAY_REGULAR AS TIME_REG_THU,
      DT.FRIDAY_REGULAR AS TIME_REG_FRI,
      DT.SATURDAY_REGULAR AS TIME_REG_SAT,
      DT.SUNDAY_SPECIAL AS TIME_OVR_SUN,
      DT.MONDAY_SPECIAL AS TIME_OVR_MON,
      DT.TUESDAY_SPECIAL AS TIME_OVR_TUE,
      DT.WEDNESDAY_SPECIAL AS TIME_OVR_WED,
      DT.THURSDAY_SPECIAL AS TIME_OVR_THU,
      DT.FRIDAY_SPECIAL AS TIME_OVR_FRI,
      DT.SATURDAY_SPECIAL AS TIME_OVR_SAT
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN PMO_POOL_TS_RESOURCES TM
      ON TM.RESOURCE_ID = R.RESOURCE_ID
      JOIN SUMMARY_TIMESHEETS ST
      ON ST.RESOURCE_ID = TM.RESOURCE_ID
      AND ST.WEEK_OF BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND (ST.SUNDAY_REGULAR+ST.MONDAY_REGULAR+ST.TUESDAY_REGULAR+ST.WEDNESDAY_REGULAR+ST.THURSDAY_REGULAR+ST.FRIDAY_REGULAR+ST.SATURDAY_REGULAR+ST.SUNDAY_SPECIAL+ST.MONDAY_SPECIAL+ST.TUESDAY_SPECIAL+ST.WEDNESDAY_SPECIAL+ST.THURSDAY_SPECIAL+ST.FRIDAY_SPECIAL+ST.SATURDAY_SPECIAL) > 0
      JOIN PMO_PIVOT_PROJECTS X
      ON X.PROJECT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA
      ON TSA.WEEK_OF = ST.WEEK_OF
      AND TSA.RESOURCE_ID = ST.RESOURCE_ID
      AND TSA.ELEMENT_ID = ST.PROJECT_ID
      LEFT OUTER JOIN RESOURCES TSM
      ON TSM.RESOURCE_ID = TSA.MANAGER_ID
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = ST.RESOURCE_ID
      AND TA.PROJECT_ID = ST.PROJECT_ID
      AND TA.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      AND TA.ACTIVITY_COUNT <> 0
      JOIN TMT_WBS T
      ON T.PROJECT_ID = TA.PROJECT_ID
      AND T.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN ACTIVITIES ACT
      ON ACT.TSK_ASSIGNMENT_ID = ST.TSK_ASSIGNMENT_ID
      LEFT JOIN DETAIL_TIMESHEETS DT
      ON DT.ACTIVITY_ID = ACT.ELEMENT_ID
      AND DT.WEEK_OF = ST.WEEK_OF
      LEFT JOIN TMT_TIMECODES TD1
      ON TD1.ELEMENT_ID = ACT.TIMECODE_1_ID
      LEFT JOIN TMT_TIMECODES TD2
      ON TD2.ELEMENT_ID = ACT.TIMECODE_2_ID
      JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.PROJECT_ID = ST.PROJECT_ID
      AND BITAND(RA.PARTICIPANT,1) = 1
      JOIN RESOURCES PM
      ON PM.RESOURCE_ID = RA.RESOURCE_ID
      JOIN TMT_WBS P
      ON P.ELEMENT_ID = RA.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 402+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(403) : views_pivot.sql(6857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_POOL_TS_OUT
      SELECT  P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE, 
      P.TASK_REFERENCE, 
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2,
      SUM(P.TIME_REG_SUN) AS TIME_REG_SUN,
      SUM(P.TIME_REG_MON) AS TIME_REG_MON,
      SUM(P.TIME_REG_TUE) AS TIME_REG_TUE,
      SUM(P.TIME_REG_WED) AS TIME_REG_WED,
      SUM(P.TIME_REG_THU) AS TIME_REG_THU,
      SUM(P.TIME_REG_FRI) AS TIME_REG_FRI,
      SUM(P.TIME_REG_SAT) AS TIME_REG_SAT,
      SUM(P.TIME_OVR_SUN) AS TIME_OVR_SUN,
      SUM(P.TIME_OVR_MON) AS TIME_OVR_MON,
      SUM(P.TIME_OVR_TUE) AS TIME_OVR_TUE,
      SUM(P.TIME_OVR_WED) AS TIME_OVR_WED,
      SUM(P.TIME_OVR_THU) AS TIME_OVR_THU,
      SUM(P.TIME_OVR_FRI) AS TIME_OVR_FRI,
      SUM(P.TIME_OVR_SAT) AS TIME_OVR_SAT
      FROM PMO_POOL_TIMESHEETS P
      
      GROUP BY    P.PROJECT_ID,
      P.PROJECT_NAME,
      P.PROJECT_CODE,
      P.PROJECT_REFERENCE,
      P.PROJECT_MANAGER_ID,
      P.PROJECT_MANAGER,
      P.TASK_ID,
      P.TASK_NAME,
      P.TASK_CODE, 
      P.TASK_REFERENCE, 
      P.WEEK_NUMBER,
      P.WEEK_START,
      P.WEEK_END,
      P.WEEK_MY_STATUS,
      P.WEEK_MANAGER_NAME,
      P.WEEK_MANAGER_STATUS,
      P.WEEK_STATUS_DATE,
      P.WEEK_STATUS_NOTE,
      P.RESOURCE_POOL_ID,
      P.RESOURCE_POOL_NAME,
      P.POOL_MANAGER,
      P.MASK_EMPLOYEE_INFO,
      P.RESOURCE_ORG_ID,
      P.RESOURCE_ORG_NAME,
      P.RESOURCE_GEO_ID,
      P.RESOURCE_GEO_NAME,
      P.RESOURCE_ID,
      P.RESOURCE_NAME,
      P.RESOURCE_WORK_LOCATION,
      P.RESOURCE_STATUS1,
      P.RESOURCE_STATUS2,
      P.RESOURCE_MAX_WEEKLY,
      P.RESOURCE_COUNTRY_CODE,
      P.RESOURCE_COMPANY_CODE,
      P.RESOURCE_DIVISION_CODE,
      P.RESOURCE_DEPARTMENT_CODE,
      P.RESOURCE_EMPLOYEE_CODE,
      P.RESOURCE_CUSTOM_01,
      P.RESOURCE_CUSTOM_02,
      P.RESOURCE_CUSTOM_03,
      P.RESOURCE_CUSTOM_04,
      P.RESOURCE_CUSTOM_05,
      P.TIME_CODE1_ID,
      P.TIME_CODE1,
      P.TIME_CODE2_ID,
      P.TIME_CODE2;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 527+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(528) : views_pivot.sql(6982) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TPLA FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE, 
   P.TASK_REFERENCE, 
   AT.PROJECT_ATTRIBUTES AS ATTRIBUTES,
   h_day AS WEEK_FIRSTDAY,
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2,
   P.TIME_REG_SUN,
   P.TIME_REG_MON,
   P.TIME_REG_TUE,
   P.TIME_REG_WED,
   P.TIME_REG_THU,
   P.TIME_REG_FRI,
   P.TIME_REG_SAT,
   P.TIME_OVR_SUN,
   P.TIME_OVR_MON,
   P.TIME_OVR_TUE,
   P.TIME_OVR_WED,
   P.TIME_OVR_THU,
   P.TIME_OVR_FRI,
   P.TIME_OVR_SAT
   FROM PMO_POOL_TS_OUT P
   LEFT JOIN PMO_PIVOT_PAT AT
   ON AT.PROJECT_ID = P.PROJECT_ID
   
   ORDER BY    P.PROJECT_ID,
   P.PROJECT_NAME,
   P.PROJECT_CODE,
   P.PROJECT_REFERENCE,
   P.PROJECT_MANAGER_ID,
   P.PROJECT_MANAGER,
   P.TASK_ID,
   P.TASK_NAME,
   P.TASK_CODE, 
   P.TASK_REFERENCE, 
   P.WEEK_NUMBER,
   P.WEEK_START,
   P.WEEK_END,
   P.WEEK_MY_STATUS,
   P.WEEK_MANAGER_NAME,
   P.WEEK_MANAGER_STATUS,
   P.WEEK_STATUS_DATE,
   P.WEEK_STATUS_NOTE,
   P.RESOURCE_POOL_ID,
   P.RESOURCE_POOL_NAME,
   P.POOL_MANAGER,
   P.MASK_EMPLOYEE_INFO,
   P.RESOURCE_ORG_ID,
   P.RESOURCE_ORG_NAME,
   P.RESOURCE_GEO_ID,
   P.RESOURCE_GEO_NAME,
   P.RESOURCE_ID,
   P.RESOURCE_NAME,
   P.RESOURCE_WORK_LOCATION,
   P.RESOURCE_STATUS1,
   P.RESOURCE_STATUS2,
   P.RESOURCE_MAX_WEEKLY,
   P.RESOURCE_COUNTRY_CODE,
   P.RESOURCE_COMPANY_CODE,
   P.RESOURCE_DIVISION_CODE,
   P.RESOURCE_DEPARTMENT_CODE,
   P.RESOURCE_EMPLOYEE_CODE,
   P.RESOURCE_CUSTOM_01,
   P.RESOURCE_CUSTOM_02,
   P.RESOURCE_CUSTOM_03,
   P.RESOURCE_CUSTOM_04,
   P.RESOURCE_CUSTOM_05,
   P.TIME_CODE1_ID,
   P.TIME_CODE1,
   P.TIME_CODE2_ID,
   P.TIME_CODE2;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_POOL_ATTR', 648+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TIMESHEET_POOL_ATTR(649) : views_pivot.sql(7103) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_TPLA;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 656+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(657) : views_pivot.sql(7111) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_POOL_ATTR', 668+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_POOL_ATTR(669) : views_pivot.sql(7123) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TIMESHEET_POOL_ATTR;
ALTER FUNCTION SP_TIMESHEET_POOL_ATTR COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_TIMESHEET_MISSING ==
CREATE OR REPLACE FUNCTION SP_TIMESHEET_MISSING
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_day PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_TMS PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TIMESHEET_MISSING') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TIMESHEET_MISSING'), '-- ' || SYSTIMESTAMP, ':r := SP_TIMESHEET_MISSING(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_MISSING', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TIMESHEET_MISSING(32) : views_pivot.sql(7171) : ' || SYSTIMESTAMP);
   END IF; 

   If (p_type IS NULL) OR (p_rec_user IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TIMESHEET_MISSING', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TIMESHEET_MISSING(37) : views_pivot.sql(7176) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES1';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES2';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   If p_finish_date IS NULL Then
      h_finish_date := p_start_date;
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_RES(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   
   BEGIN
      SELECT SETTING_VALUE INTO h_day
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING(77) : views_pivot.sql(7216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES1
      SELECT  R.RESOURCE_ID,
      CASE
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 1 THEN TDOY.DAY_YEAR
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 2 THEN TDOY.DAY_YEAR - 1     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 3 THEN TDOY.DAY_YEAR - 2     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 4 THEN TDOY.DAY_YEAR - 3     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 5 THEN TDOY.DAY_YEAR - 4     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 6 THEN TDOY.DAY_YEAR - 5     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 0 THEN TDOY.DAY_YEAR - 6     
      END,
      TDOY.DAY_YEAR,
      COALESCE(TDOY.ACTUAL_MIN, 0)
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = R.RESOURCE_ID
      AND TA.PROJECT_ID <> TA.TASK_ID
      JOIN TASK_DAY_OF_YEAR TDOY
      ON TDOY.RESOURCE_ID = TA.RESOURCE_ID
      AND TDOY.PROJECT_ID = TA.PROJECT_ID
      AND TDOY.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TDOY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND TDOY.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING', 115+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING(116) : views_pivot.sql(7255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES2
      SELECT RESOURCE_ID, WEEK_OF
      FROM PMO_PIVOT_TMP_RES1
      GROUP BY RESOURCE_ID, WEEK_OF
      HAVING SUM(WORK_TODATE) = 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING(137) : views_pivot.sql(7276) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TMS FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   h_day AS WEEK_FIRSTDAY,
   PMO_ORASTD.WEEK(R.WEEK_OF) AS WEEK_NUMBER,
   R.WEEK_OF AS WEEK_START,
   R.WEEK_OF + 6      AS WEEK_END,
   PL.ELEMENT_ID AS RESOURCE_POOL_ID,
   PL.ELEMENT_NAME AS RESOURCE_POOL_NAME,
   TM.RESOURCE_ID AS RESOURCE_ID,
   TM.FULL_NAME AS RESOURCE_NAME
   FROM PMO_PIVOT_TMP_RES2 R
   JOIN RESOURCES TM
   ON TM.RESOURCE_ID = R.RESOURCE_ID
   JOIN TMT_POOLS TMP
   ON TMP.ELEMENT_ID = TM.RESOURCE_ID
   JOIN TMT_POOLS PL
   ON PL.ELEMENT_ID = TMP.PARENT_ID
   
   ORDER BY    R.WEEK_OF,
   TM.FULL_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_MISSING', 163+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TIMESHEET_MISSING(164) : views_pivot.sql(7303) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_TMS;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING', 171+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING(172) : views_pivot.sql(7311) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING', 183+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING(184) : views_pivot.sql(7323) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TIMESHEET_MISSING;
ALTER FUNCTION SP_TIMESHEET_MISSING COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_TIMESHEET_MISSING_2 ==
CREATE OR REPLACE FUNCTION SP_TIMESHEET_MISSING_2
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_day PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_TMS2 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TIMESHEET_MISSING_2') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TIMESHEET_MISSING_2'), '-- ' || SYSTIMESTAMP, ':r := SP_TIMESHEET_MISSING_2(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_MISSING_2', 31+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TIMESHEET_MISSING_2(32) : views_pivot.sql(7371) : ' || SYSTIMESTAMP);
   END IF; 

   If p_type IS NULL OR p_rec_user IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TIMESHEET_MISSING_2', 36+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TIMESHEET_MISSING_2(37) : views_pivot.sql(7376) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES1';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_PIVOT_TMP_RES2';
   PMO_DB2M.SC_STATE := 0;
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   If p_finish_date IS NULL Then
      h_finish_date := p_start_date;
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   PMO_DB2M.SC_STATE := FC_INIT_RES(h_ids, h_type, h_start_date, h_finish_date, h_rec_user);
   
   BEGIN
      SELECT SETTING_VALUE INTO h_day
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_START_WEEKDAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING_2', 76+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING_2(77) : views_pivot.sql(7416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Collect data from CALENDAR_DAY_OF_YEAR
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES1
      SELECT  R.RESOURCE_ID,
      CASE
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR) + 7 - h_day, 7) = 1 THEN CDY.DAY_YEAR
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR) + 7 - h_day, 7) = 2 THEN CDY.DAY_YEAR - 1     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR) + 7 - h_day, 7) = 3 THEN CDY.DAY_YEAR - 2     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR) + 7 - h_day, 7) = 4 THEN CDY.DAY_YEAR - 3     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR) + 7 - h_day, 7) = 5 THEN CDY.DAY_YEAR - 4     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR) + 7 - h_day, 7) = 6 THEN CDY.DAY_YEAR - 5     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(CDY.DAY_YEAR) + 7 - h_day, 7) = 0 THEN CDY.DAY_YEAR - 6     
      END,
      CDY.DAY_YEAR,
      0
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN CALENDAR_DAY_OF_YEAR CDY
      ON CDY.ELEMENT_ID = R.RESOURCE_ID
      AND CDY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND CDY.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING_2', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING_2(112) : views_pivot.sql(7451) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --Collect data from TASK_DAY_OF_YEAR
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES1
      SELECT  R.RESOURCE_ID,
      CASE
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 1 THEN TDOY.DAY_YEAR
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 2 THEN TDOY.DAY_YEAR - 1     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 3 THEN TDOY.DAY_YEAR - 2     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 4 THEN TDOY.DAY_YEAR - 3     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 5 THEN TDOY.DAY_YEAR - 4     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 6 THEN TDOY.DAY_YEAR - 5     
      WHEN MOD(PMO_ORASTD.DAYOFWEEK(TDOY.DAY_YEAR) + 7 - h_day, 7) = 0 THEN TDOY.DAY_YEAR - 6     
      END,
      TDOY.DAY_YEAR,
      COALESCE(TDOY.ACTUAL_MIN, 0)
      FROM PMO_PIVOT_TMP_RESOURCES R
      JOIN TASK_ASSIGNMENTS TA
      ON TA.RESOURCE_ID = R.RESOURCE_ID
      AND TA.PROJECT_ID <> TA.TASK_ID
      JOIN TASK_DAY_OF_YEAR TDOY
      ON TDOY.RESOURCE_ID = TA.RESOURCE_ID
      AND TDOY.PROJECT_ID = TA.PROJECT_ID
      AND TDOY.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TDOY.DAY_YEAR BETWEEN TO_DATE(SubStr(h_start_date, 1, 10)) AND TO_DATE(SubStr(h_finish_date, 1, 10))
      AND TDOY.DAY_YEAR BETWEEN R.RESOURCE_EFFECTIVE_DATE AND COALESCE(R.RESOURCE_DISCONTINUE_DATE,TO_DATE(SubStr(h_finish_date, 1, 10)));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING_2', 151+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING_2(152) : views_pivot.sql(7491) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_PIVOT_TMP_RES2
      SELECT RESOURCE_ID, WEEK_OF
      FROM PMO_PIVOT_TMP_RES1
      GROUP BY RESOURCE_ID, WEEK_OF
      HAVING SUM(WORK_TODATE) = 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING_2', 172+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING_2(173) : views_pivot.sql(7512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_TMS2 FOR SELECT  '' AS ELEMENT_ID,
   '' AS ELEMENT_NAME,
   1 AS TYPE_ID,
   h_day AS WEEK_FIRSTDAY,
   PMO_ORASTD.WEEK(R.WEEK_OF) AS WEEK_NUMBER,
   R.WEEK_OF AS WEEK_START,
   R.WEEK_OF + 6      AS WEEK_END,
   PL.ELEMENT_ID AS RESOURCE_POOL_ID,
   PL.ELEMENT_NAME AS RESOURCE_POOL_NAME,
   TM.RESOURCE_ID AS RESOURCE_ID,
   TM.FULL_NAME AS RESOURCE_NAME
   FROM PMO_PIVOT_TMP_RES2 R
   JOIN RESOURCES TM
   ON TM.RESOURCE_ID = R.RESOURCE_ID
   JOIN TMT_POOLS TMP
   ON TMP.ELEMENT_ID = TM.RESOURCE_ID
   JOIN TMT_POOLS PL
   ON PL.ELEMENT_ID = TMP.PARENT_ID
   
   ORDER BY    R.WEEK_OF,
   TM.FULL_NAME;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TIMESHEET_MISSING_2', 199+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_TIMESHEET_MISSING_2(200) : views_pivot.sql(7539) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_TMS2;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING_2', 207+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING_2(208) : views_pivot.sql(7547) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TIMESHEET_MISSING_2', 219+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TIMESHEET_MISSING_2(220) : views_pivot.sql(7559) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TIMESHEET_MISSING_2;
ALTER FUNCTION SP_TIMESHEET_MISSING_2 COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION SP_EV_REPORT ==
CREATE OR REPLACE FUNCTION SP_EV_REPORT
(
     p_ids VARCHAR2
   , p_type PLS_INTEGER
   , p_start_date VARCHAR2
   , p_finish_date VARCHAR2
   , p_rec_user VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_ids VARCHAR2(8192);
   h_type PLS_INTEGER := 0;
   h_start_date DATE;
   h_finish_date DATE;
   h_rec_user VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_level PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_EVR PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_EV_REPORT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_EV_REPORT'), '-- ' || SYSTIMESTAMP, ':r := SP_EV_REPORT(' || 
       '''' || p_ids || ''''
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || '''' || p_start_date || ''''
          || ', ' || '''' || p_finish_date || ''''
          || ', ' || '''' || p_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EV_REPORT', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_EV_REPORT(33) : views_pivot.sql(7608) : ' || SYSTIMESTAMP);
   END IF; 

   If p_ids IS NULL OR p_type IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_EV_REPORT', 37+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_EV_REPORT(38) : views_pivot.sql(7613) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   
   -- Declare host variables
   
   --=====================================================================
   -- Declare Temporary Table
   --=====================================================================
   
   --=====================================================================
   
   h_ids := p_ids;
   h_type := p_type;
   h_start_date := p_start_date;
   If p_finish_date IS NULL Then
      h_finish_date := p_start_date;
   Else
      h_finish_date := p_finish_date;
   End If;
   h_rec_user := p_rec_user;
   
   BEGIN
      SELECT RTRIM(RANK), LEVEL_ID + h_type
      INTO h_rank, h_level
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_ids;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EV_REPORT', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EV_REPORT(72) : views_pivot.sql(7647) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_EVR FOR SELECT  ELEMENT_ID,
   ELEMENT_NAME,
   TYPE_ID,
   CASE WHEN MILESTONE_PERCENT = 0 THEN 3 WHEN MILESTONE_PERCENT = 10000 THEN 2 ELSE 1 END AS R_STATUS,
   LEVEL_ID,
   WBS_CODE,
   START_DT,
   FINISH_DT,
   BASELINE1_START,
   BASELINE1_FINISH,
   PROPOSED_START,
   PROPOSED_FINISH,
   SCHED_START,
   SCHED_FINISH,
   ACTUAL_START,
   ACTUAL_FINISH,
   MILESTONE_PERCENT,
   BASELINE1_EFFORT,
   WORK_TODATE,
   Trunc((PMO_ORASTD.TODECIMAL(WORK_TODATE,18,2)/BASELINE1_EFFORT)*10000) AS PERCENT_SPENT,
   ETC,
   BAC,
   EAC,
   BCWS,
   BCWP,
   ACWP,
   EV_ETC
   FROM TMT_WBS
   WHERE RANK LIKE h_rank || '%'
   AND LEVEL_ID <= h_level
   AND BASELINE1_EFFORT > 0
   ORDER BY R_STATUS, RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_EV_REPORT', 109+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: SP_EV_REPORT(110) : views_pivot.sql(7685) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_EVR;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EV_REPORT', 117+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EV_REPORT(118) : views_pivot.sql(7693) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_EV_REPORT', 129+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_EV_REPORT(130) : views_pivot.sql(7705) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_EV_REPORT;
ALTER FUNCTION SP_EV_REPORT COMPILE DEBUG;

