-- ********************** IMPORTANT RULE: May 13, 2004

-- ********************** PLEASE DONT MODIFY THIS FILE BEFORE READING THE FOLLWOING RULES

-- ********************** PLEASE IF YOU UPDATE THIS COMMENT, APPLY THE SAME MODIFICATIONS IN VIEWS_POOL(VIEWS_2POOL) I

-- 1- we never show participants in pool admin view (partcipants in project level or participant in task level)

-- 2- we show participants in my team's work

-- 3- in my work (wbs view) if user is assigned to task level(participant/effort) then we can see the project but

--  if user assigned to just project level (as a participant/effort) we can not see that project.

--  it means that we just can see the projects that we have assigned to a task (as a participant/effort).

-- 4- we show published and unpublished projects in pool admin

-- 5- all functions for Resource Management are started with FC_RM_...

-- 6- all functions for WBS View (MY WORK and MY TEAM) are started with FC_WBS_...

-- 7- Rules For MY WORK Security:

--  7-1- All Work packages

--      7-1-1- project_level:       if resource assigned to the project then return assigned security otherwise return SCPROJECTVISITOR

--      7-1-2- deliverable_level:   if resource assigned to the deliverable then return assigned security(rollup security project_security + deliverable security) otherwise return Nothing

--      7-1-3- task level:          resource has to be assigned to the task then return assigned security(rollup security project+deliverable+task security)

--  7-2- All Work Assignments (and all other options)

--      7-2-1- inherit security but if resource just has been assigned to the task level then return return SCPROJECTVISITOR + task level security

/*********************************************************************************/

Prompt == PROCEDURE GetViewsPoolActiveRecordFlags ==
CREATE OR REPLACE PROCEDURE GetViewsPoolActiveRecordFlags
(
     sh_h_active_record PLS_INTEGER
   , h_include_closed IN OUT NOCOPY PLS_INTEGER
   , h_include_completed IN OUT NOCOPY PLS_INTEGER
   , h_include_proposed IN OUT NOCOPY PLS_INTEGER
   , h_closed_not_completed IN OUT NOCOPY PLS_INTEGER
   , h_not_closed_but_completed IN OUT NOCOPY PLS_INTEGER
   , h_not_closed_not_completed IN OUT NOCOPY PLS_INTEGER
   , h_ready_to_start_task_only IN OUT NOCOPY PLS_INTEGER
)
AS
   h_active_record PLS_INTEGER := Coalesce(sh_h_active_record, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('GetViewsPoolActiveRecordFlags') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('GetViewsPoolActiveRecordFlags'), '-- ' || SYSTIMESTAMP, ':r := GetViewsPoolActiveRecordFlags(' || 
       COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_closed), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_completed), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_proposed), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_closed_not_completed), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_not_closed_but_completed), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_not_closed_not_completed), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_ready_to_start_task_only), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetViewsPoolActiveRecordFlags', 27+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: GetViewsPoolActiveRecordFlags(28) : views_pool.sql(67) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_closed := 0;
   h_include_completed := 0;
   h_include_proposed := 0;
   
   --trace_printf("\n h_active_record:%d", h_active_record);
   
   h_ready_to_start_task_only := 1;
   
   If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_CLOSED)) = PMO_CNST.SC_INCLUDE_CLOSED Then
      h_include_closed := 1;
   End If;
   
   If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_COMPLETED)) = PMO_CNST.SC_INCLUDE_COMPLETED Then
      h_include_completed := 1;
   End If;
   
   If (BITAND(h_active_record, PMO_CNST.SC_INCLUDE_PROPOSED)) = PMO_CNST.SC_INCLUDE_PROPOSED Then
      h_include_proposed := 1;
   End If;
   
   If 
         (BITAND(h_active_record, PMO_CNST.SC_READY_TO_START_TASK_ONLY)) = PMO_CNST.SC_READY_TO_START_TASK_ONLY Then
      h_include_closed := 0;
      h_include_completed := 0;
      h_ready_to_start_task_only := 0;
   End If;
   
   h_closed_not_completed := 1;
   h_not_closed_but_completed := 1;
   h_not_closed_not_completed := 1;
   If (h_include_closed = 1) AND (h_include_completed = 0) Then
      h_closed_not_completed := 0;
   ElsIf (h_include_closed = 0) AND (h_include_completed = 1) Then
      h_not_closed_but_completed := 0;
   ElsIf (h_include_closed = 0) AND (h_include_completed = 0) Then
      h_not_closed_not_completed := 0;
   End If;
   
   --trace_printf("\n h_include_closed:%d", h_include_closed);
   --trace_printf("\n h_include_completed:%d", h_include_completed);
   --trace_printf("\n h_include_proposed:%d", h_include_proposed);
   --trace_printf("\n h_closed_not_completed:%d", h_closed_not_completed);
   --trace_printf("\n h_not_closed_but_completed:%d", h_not_closed_but_completed);
   --trace_printf("\n h_not_closed_not_completed:%d", h_not_closed_not_completed);
END;
/
SHOW ERRORS PROCEDURE GetViewsPoolActiveRecordFlags;
ALTER PROCEDURE GetViewsPoolActiveRecordFlags COMPILE DEBUG;

/************************************************************************/

Prompt == FUNCTION FC_PREVIOUS_MONDAY ==
CREATE OR REPLACE FUNCTION FC_PREVIOUS_MONDAY
(
     h_week_of IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_temp_bitflag PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_PREVIOUS_MONDAY') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_PREVIOUS_MONDAY'), '-- ' || SYSTIMESTAMP, ':r := FC_PREVIOUS_MONDAY(' || 
       COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PREVIOUS_MONDAY', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_PREVIOUS_MONDAY(14) : views_pool.sql(135) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT PMO_ORASTD.DAYOFWEEK(h_week_of) INTO h_temp_bitflag FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PREVIOUS_MONDAY', 24+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PREVIOUS_MONDAY(25) : views_pool.sql(146) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_temp_bitflag, 0) > 2 Then
      h_temp_bitflag := Coalesce(h_temp_bitflag, 0) - 2;
      BEGIN
         SELECT TO_DATE(SubStr(h_week_of, 1, 10)) - h_temp_bitflag      INTO h_week_of FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PREVIOUS_MONDAY', 39+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PREVIOUS_MONDAY(40) : views_pool.sql(161) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_temp_bitflag, 0) < 2 Then
      BEGIN
         SELECT TO_DATE(SubStr(h_week_of, 1, 10)) + 1      INTO h_week_of FROM DUAL;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_PREVIOUS_MONDAY', 52+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_PREVIOUS_MONDAY(53) : views_pool.sql(174) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_PREVIOUS_MONDAY', 59+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_PREVIOUS_MONDAY(60) : views_pool.sql(181) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_PREVIOUS_MONDAY;
ALTER FUNCTION FC_PREVIOUS_MONDAY COMPILE DEBUG;

/************************************************************************/

Prompt == FUNCTION FC_U_SF_DATE ==
CREATE OR REPLACE FUNCTION FC_U_SF_DATE
(
     sh_h_bitflag PLS_INTEGER
   , h_temp_table_name IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
   myStmt VARCHAR2(19999);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_SF_DATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_SF_DATE'), '-- ' || SYSTIMESTAMP, ':r := FC_U_SF_DATE(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_temp_table_name || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SF_DATE', 16+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_SF_DATE(17) : views_pool.sql(208) : ' || SYSTIMESTAMP);
   END IF; 

   myStmt := 'UPDATE ' || SubStr(h_temp_table_name, 9) || ' SET '
          || 'SD = CASE '
          || 'WHEN ACTUAL_START IS NOT null THEN 29 '
          || 'WHEN FORECAST_START IS NOT NuLL AND (SCHED_START IS NuLL OR FORECAST_START < SCHED_START) THEN 27 '
          || 'WHEN PLANNED_START IS NOT NuLL AND (SCHED_START IS NuLL OR PLANNED_START < SCHED_START) THEN 11 '
          || 'WHEN SCHED_START IS NOT null THEN 25 '
          || 'WHEN PLANNED_START IS NOT null THEN 11 '
          || 'ELSE 0 END, '
          || 'START_DT = CASE '
          || 'WHEN ACTUAL_START IS NOT null THEN ACTUAL_START '
          || 'WHEN FORECAST_START IS NOT NuLL AND (SCHED_START IS NuLL OR FORECAST_START < SCHED_START) THEN FORECAST_START '
          || 'WHEN PLANNED_START IS NOT NuLL AND (SCHED_START IS NuLL OR PLANNED_START < SCHED_START) THEN PLANNED_START '
          || 'WHEN SCHED_START IS NOT null THEN SCHED_START '
          || 'WHEN PLANNED_START IS NOT null THEN PLANNED_START '
          || 'ELSE null END, '
          || 'FD = CASE '
          || 'when FD = 39 then 39 '
          || 'WHEN ACTUAL_FINISH IS NOT null AND MILESTONE_PERCENT = 10000 THEN 42 '
          || 'WHEN ACTUAL_FINISH IS NOT NuLL AND (FORECAST_FINISH IS NuLL OR ACTUAL_FINISH > FORECAST_FINISH) '
          || 'AND (SCHED_FINISH IS NuLL OR ACTUAL_FINISH > SCHED_FINISH) '
          || 'AND (PLANNED_FINISH IS NuLL OR ACTUAL_FINISH > PLANNED_FINISH) THEN 42 '
          || 'WHEN FORECAST_FINISH IS NOT NuLL AND (SCHED_FINISH IS NuLL OR FORECAST_FINISH > SCHED_FINISH) '
          || 'AND (PLANNED_FINISH IS NuLL OR FORECAST_FINISH > PLANNED_FINISH) THEN 28 '
          || 'WHEN PLANNED_FINISH IS NOT NuLL AND (SCHED_FINISH IS NuLL OR PLANNED_FINISH > SCHED_FINISH) THEN 12 '
          || 'WHEN SCHED_FINISH IS NOT null THEN 26 '
          || 'WHEN PLANNED_FINISH IS NOT null THEN 12 '
          || 'ELSE 0 END, '
          || 'FINISH_DT = CASE '
          || 'WHEN ACTUAL_FINISH IS NOT null AND MILESTONE_PERCENT = 10000 THEN ACTUAL_FINISH '
          || 'WHEN ACTUAL_FINISH IS NOT NuLL AND (FORECAST_FINISH IS NuLL OR ACTUAL_FINISH > FORECAST_FINISH) '
          || 'AND (SCHED_FINISH IS NuLL OR ACTUAL_FINISH > SCHED_FINISH) '
          || 'AND (PLANNED_FINISH IS NuLL OR ACTUAL_FINISH > PLANNED_FINISH) THEN ACTUAL_FINISH '
          || 'WHEN FORECAST_FINISH IS NOT NuLL AND (SCHED_FINISH IS NuLL OR FORECAST_FINISH > SCHED_FINISH) '
          || 'AND (PLANNED_FINISH IS NuLL OR FORECAST_FINISH > PLANNED_FINISH) THEN FORECAST_FINISH '
          || 'WHEN PLANNED_FINISH IS NOT NuLL AND (SCHED_FINISH IS NuLL OR PLANNED_FINISH > SCHED_FINISH) THEN PLANNED_FINISH '
          || 'WHEN SCHED_FINISH IS NOT null THEN SCHED_FINISH '
          || 'WHEN PLANNED_FINISH IS NOT null THEN PLANNED_FINISH '
          || 'ELSE null END ';
   If h_bitflag = 1 Then
      myStmt := myStmt || ', ETC_RED_FLAG = ABS(SIGN(ETC - SCHED_WORK + WORK_TODATE)) ';
   End If;
   
   BEGIN
      EXECUTE IMMEDIATE myStmt;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_SF_DATE', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_SF_DATE(74) : views_pool.sql(265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            LFILE.FPUT('AllTrace',                         'SQL : ' || myStmt);
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_SF_DATE', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_SF_DATE(81) : views_pool.sql(272) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_SF_DATE;
ALTER FUNCTION FC_U_SF_DATE COMPILE DEBUG;

/*********************************************************************************************/

-- this function calculates REGULAR_RATE for a selected resource for a specified project

Prompt == FUNCTION FC_CAL_RES_PRJ_REG_RATE ==
CREATE OR REPLACE FUNCTION FC_CAL_RES_PRJ_REG_RATE
(
     sh_h_bitflag PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_regular_rate IN OUT NOCOPY NUMBER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_s_b_planned_labor_revenue NUMBER := 0;
   h_s_b_planned_work NUMBER := 0;
   h_s_b_sched_labor_revenue NUMBER := 0;
   h_s_b_sched_work NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CAL_RES_PRJ_REG_RATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CAL_RES_PRJ_REG_RATE'), '-- ' || SYSTIMESTAMP, ':r := FC_CAL_RES_PRJ_REG_RATE(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(h_regular_rate), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CAL_RES_PRJ_REG_RATE', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CAL_RES_PRJ_REG_RATE(24) : views_pool.sql(308) : ' || SYSTIMESTAMP);
   END IF; 

   --sum_of_billable_planned_labor_revenue
   --sum_of_billable_planned_work
   --sum_of_billable_sched_labor_revenue
   --sum_of_billable_sched_work
   
   If Coalesce(h_bitflag, 0) = 1 Then
      -- get information necessary for calculating REGULAR_RATE for selected resource/project
      BEGIN
         SELECT  SUM(PLANNED_LABOR_REVENUE),
         SUM(PLANNED_WORK),
         SUM(SCHED_LABOR_REVENUE),
         SUM(SCHED_WORK)
         INTO    h_s_b_planned_labor_revenue,
         h_s_b_planned_work,
         h_s_b_sched_labor_revenue,
         h_s_b_sched_work
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id
         AND BILLABLE = 1;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_RES_PRJ_REG_RATE', 52+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_RES_PRJ_REG_RATE(53) : views_pool.sql(337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      -- get information necessary for calculating REGULAR_RATE for selected resource
      BEGIN
         SELECT  SUM(PLANNED_LABOR_REVENUE),
         SUM(PLANNED_WORK),
         SUM(SCHED_LABOR_REVENUE),
         SUM(SCHED_WORK)
         INTO h_s_b_planned_labor_revenue,
         h_s_b_planned_work,
         h_s_b_sched_labor_revenue,
         h_s_b_sched_work
         FROM TASK_ASSIGNMENTS
         WHERE RESOURCE_ID = h_resource_id
         AND BILLABLE = 1;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_RES_PRJ_REG_RATE', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_RES_PRJ_REG_RATE(77) : views_pool.sql(361) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 3 Then
      -- get information necessary for calculating REGULAR_RATE for selected project
      BEGIN
         SELECT  SUM(PLANNED_LABOR_REVENUE),
         SUM(PLANNED_WORK),
         SUM(SCHED_LABOR_REVENUE),
         SUM(SCHED_WORK)
         INTO    h_s_b_planned_labor_revenue,
         h_s_b_planned_work,
         h_s_b_sched_labor_revenue,
         h_s_b_sched_work
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND (SCHED_LABOR_REVENUE+PLANNED_LABOR_REVENUE) > 0    -- This condition is for profiles that assigned to the project level
         AND BILLABLE = 1;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CAL_RES_PRJ_REG_RATE', 101+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CAL_RES_PRJ_REG_RATE(102) : views_pool.sql(386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If (Coalesce(h_s_b_sched_work, 0) + Coalesce(h_s_b_planned_work, 0)) > 0.00 Then
      h_regular_rate := (((Coalesce(h_s_b_sched_labor_revenue, 0) + Coalesce(
                              h_s_b_planned_labor_revenue, 0)) * 60) / (Coalesce(
                              h_s_b_sched_work, 0) + Coalesce(h_s_b_planned_work, 0)));
   Else
      h_regular_rate := 0.00;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CAL_RES_PRJ_REG_RATE', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CAL_RES_PRJ_REG_RATE(117) : views_pool.sql(401) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CAL_RES_PRJ_REG_RATE;
ALTER FUNCTION FC_CAL_RES_PRJ_REG_RATE COMPILE DEBUG;

/*****************************************************************************************/

Prompt == FUNCTION FC_TMP_VIEWSPL_PROJ ==
CREATE OR REPLACE FUNCTION FC_TMP_VIEWSPL_PROJ
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_count PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_res_id VARCHAR2(32);
   h_temp_reg_rate NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TMP_VIEWSPL_PROJ') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TMP_VIEWSPL_PROJ'), '-- ' || SYSTIMESTAMP, ':r := FC_TMP_VIEWSPL_PROJ(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TMP_VIEWSPL_PROJ', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TMP_VIEWSPL_PROJ(21) : views_pool.sql(432) : ' || SYSTIMESTAMP);
   END IF; 

   h_temp_bitflag := 3;
   -- regular rate for a specified project
   h_temp_res_id := '';
   h_temp_sc_state := FC_CAL_RES_PRJ_REG_RATE(h_temp_bitflag, h_temp_res_id, h_id, h_temp_reg_rate);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSPL_PROJ';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VIEWSPL_PROJ
      SELECT  SUM(T.CHILD_COUNT) AS CHILD_COUNT , A.PROJECT_ID,
      SUM(COALESCE(A.REGULAR_TODATE, 0)), SUM(COALESCE(A.SPECIAL_TODATE, 0)),
      SUM(COALESCE(A.ESTIMATION_LABOR_COST, 0.00)), SUM(COALESCE(A.BASELINE_LABOR_COST, 0.00)),
      SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)), SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)),
      SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)), SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)),
      SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)), SUM(COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.BASELINE_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)), SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)),
      h_temp_reg_rate
      FROM PROJECT_ASSIGNMENTS A JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
      WHERE A.PROJECT_ID = h_id
      AND ( ((A.ESTIMATED_SCHED_EFFORT + A.ESTIMATED_PLANNED_EFFORT + A.PROPOSED_WORK) > 0) OR (A.PARTICIPANT > 0) )
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_VIEWSPL_PROJ', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_VIEWSPL_PROJ(59) : views_pool.sql(470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PMO_TMP_VIEWSPL_PROJ
      SET CHILD_COUNT = 1
      WHERE CHILD_COUNT = 0
      AND PROJECT_ID IN (
      SELECT DISTINCT TASK_ASSIGNMENTS.PROJECT_ID
      FROM TMT_WBS , TASK_ASSIGNMENTS
      WHERE TMT_WBS.PROJECT_ID = TASK_ASSIGNMENTS.TASK_ID
      AND TMT_WBS.PROJECT_ID = h_id
      AND TMT_WBS.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_VIEWSPL_PROJ', 83+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_VIEWSPL_PROJ(84) : views_pool.sql(495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT COUNT(PROJECT_ID) INTO h_count
      FROM PMO_TMP_VIEWSPL_PROJ
      WHERE PROJECT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TMP_VIEWSPL_PROJ', 98+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TMP_VIEWSPL_PROJ(99) : views_pool.sql(510) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := Coalesce(h_count, 0);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TMP_VIEWSPL_PROJ', 106+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TMP_VIEWSPL_PROJ(107) : views_pool.sql(518) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TMP_VIEWSPL_PROJ;
ALTER FUNCTION FC_TMP_VIEWSPL_PROJ COMPILE DEBUG;

/*********************************************************************************
 Flat list of MY tasks that did not start and where due to start before today.
    h_ids = list of project IDs
 If TEAM MEMBER than all assignments
 If PARTICIPANT than all duration based tasks  milestones
*********************************************************************************/

Prompt == FUNCTION FC_WORK_MANAGEMENT_VIEW ==
CREATE OR REPLACE FUNCTION FC_WORK_MANAGEMENT_VIEW
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := Coalesce(sh_h_bitflag, 0);
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WORK_MANAGEMENT_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WORK_MANAGEMENT_VIEW'), '-- ' || SYSTIMESTAMP, ':r := FC_WORK_MANAGEMENT_VIEW(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_ids || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WORK_MANAGEMENT_VIEW', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WORK_MANAGEMENT_VIEW(35) : views_pool.sql(568) : ' || SYSTIMESTAMP);
   END IF; 

   h_rank := NULL;
   h_project_id := '';
   h_project_id := SubStr(h_project_id, 1, 32);
   
   If h_bitflag > 10000 Then
      h_temp_bitflag := h_bitflag - 10000;
   Else
      h_temp_bitflag := h_bitflag;
   End If;
   
   BEGIN
      SELECT COUNT(R.RESOURCE_ID)
      INTO h_temp_var
      FROM RESOURCES R, TMT_GLOBAL_SECURITY S
      WHERE R.RESOURCE_ID = h_rec_user
      AND R.EXECUTIVE_SECURITY IS NOT NuLL
      AND R.EXECUTIVE_SECURITY = S.ELEMENT_ID
      AND BITAND(SECURITY_GROUP, 1219) > 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WORK_MANAGEMENT_VIEW', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WORK_MANAGEMENT_VIEW(62) : views_pool.sql(595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_bitflag > 10000 Then
      h_temp_var := Coalesce(h_temp_var, 0) + 10000;
   End If;
   
   If (Coalesce(h_temp_bitflag, 0) > 2000) AND (Coalesce(h_temp_bitflag, 0) <> 3224) Then
      h_type_id := PMO_CNST.SC_FOLDER;
      h_tree_type := PMO_CNST.SC_TABLE_PORTFOLIO;
      null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_rec_user, h_temp_var);
   Else
      h_type_id := PMO_CNST.SC_PROJECT;
      h_tree_type := PMO_CNST.SC_TABLE_WBS;
      null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_rec_user, h_temp_var);
   End If;
   
   --trace_printf("\n h_bitflag:%d", h_bitflag);
   --trace_printf("\n h_resource_id:%s:%d", h_resource_id, h_resource_id_Ind);
   
   If (h_bitflag < 10000) OR (h_resource_id IS NOT NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WORK_MANAGEMENT_VIEW', 85+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WORK_MANAGEMENT_VIEW(86) : views_pool.sql(619) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_TASKS(h_resource_id, h_rec_user, h_active_record, h_bitflag);
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WORK_MANAGEMENT_VIEW', 90+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WORK_MANAGEMENT_VIEW(91) : views_pool.sql(624) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_TEAM_RESOURCES(h_rec_user, h_nick_name, h_active_record, h_bitflag);
   End If;
   
   PMO_DB2M.SC_STATE := 0;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WORK_MANAGEMENT_VIEW', 101+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WORK_MANAGEMENT_VIEW(102) : views_pool.sql(635) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WORK_MANAGEMENT_VIEW', 113+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WORK_MANAGEMENT_VIEW(114) : views_pool.sql(647) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WORK_MANAGEMENT_VIEW;
ALTER FUNCTION FC_WORK_MANAGEMENT_VIEW COMPILE DEBUG;

/*********************************************************************************
//(My team's work package view) - Project Manager level
*********************************************************************************/

Prompt == FUNCTION FC_WBS_MY_TEAM_WP ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_TEAM_WP
(
     sh_h_table_type PLS_INTEGER
   , h_ids IN OUT NOCOPY VARCHAR2
   , h_manager_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_table_type PLS_INTEGER := sh_h_table_type;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_temp_project_rank VARCHAR2(200);
   h_prev_project_rank VARCHAR2(200);
   h_count PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   h_executive_security VARCHAR2(32);
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      C_MTWP_PM PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_TEAM_WP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_TEAM_WP'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_TEAM_WP(' || 
       COALESCE(TO_CHAR(sh_h_table_type), 'NULL')
          || ', ' || '''' || h_ids || ''''
          || ', ' || '''' || h_manager_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_WP', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_TEAM_WP(45) : views_pool.sql(710) : ' || SYSTIMESTAMP);
   END IF; 

   GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
   
   BEGIN
      SELECT COUNT(R.RESOURCE_ID)
      INTO h_temp_var
      FROM RESOURCES R, TMT_GLOBAL_SECURITY S
      WHERE R.RESOURCE_ID = h_manager_id
      AND R.EXECUTIVE_SECURITY IS NOT NuLL
      AND R.EXECUTIVE_SECURITY = S.ELEMENT_ID
      AND BITAND(SECURITY_GROUP, 1219) > 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_WP', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_WP(67) : views_pool.sql(732) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_table_type, 0) = PMO_CNST.SC_FOLDER Then
      h_tree_type := PMO_CNST.SC_TABLE_PORTFOLIO;
      null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_manager_id, h_temp_var);
   ElsIf Coalesce(h_table_type, 0) = PMO_CNST.SC_PROJECT Then
      h_tree_type := PMO_CNST.SC_TABLE_WBS;
      null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_ids, h_manager_id, h_temp_var);
   End If;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM VP_MTWP_PM_1';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO VP_MTWP_PM_1
      SELECT h_manager_id, C.ELEMENT_ID, C.RANK, PA.SECURITY_ID, PA.PARTICIPANT, 1 AS PROJECT_COUNT
      FROM PMO_TMP_PROJECTS_01 C, PROJECT_ASSIGNMENTS PA
      WHERE C.ELEMENT_ID = PA.PROJECT_ID
      AND PA.RESOURCE_ID = h_manager_id
      AND BITAND(PA.PARTICIPANT, 3) > 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_WP', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_WP(101) : views_pool.sql(766) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT EXECUTIVE_SECURITY
      INTO h_executive_security
      FROM RESOURCES
      WHERE RESOURCE_ID = h_manager_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_WP', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_WP(117) : views_pool.sql(782) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_executive_security:%s:%d", h_executive_security, h_executive_security_Ind);
   
   If Coalesce(h_temp_var, 0) = 1 Then
      BEGIN
         INSERT INTO VP_MTWP_PM_1
         SELECT h_manager_id, ELEMENT_ID, RANK, h_executive_security AS SECURITY_ID, 1 AS PARTICIPANT, 1 AS PROJECT_COUNT
         FROM PMO_TMP_PROJECTS_01
         WHERE PROJECT_FLAG IS NOT NuLL
         AND PROJECT_FLAG >= PMO_CNST.SC_EXECUTIVE_PROJECT;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_WP', 140+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_WP(141) : views_pool.sql(806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM VP_MTWP_PM_1 C
      WHERE EXISTS (SELECT P.RANK
      FROM VP_MTWP_PM_1 P
      WHERE P.RANK < C.RANK
      AND ((P.RANK >= SUBSTR(C.RANK, 1, 8) AND P.RANK <= C.RANK) 
      AND SUBSTR(C.RANK,1, CASE WHEN LENGTH(P.RANK) > LENGTH(C.RANK) THEN 1 ELSE LENGTH(P.RANK) END ) = P.RANK));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_WP', 163+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_WP(164) : views_pool.sql(829) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --RESULT_SET
   
   --trace_printf("\n C_MTWP_PM \n");
   
   OPEN C_MTWP_PM FOR SELECT  1 AS LEVEL_ID,     -- project level  -> ****** (FD, SD) are correct at project level come directly from TMT_WBS
   T.TYPE_ID,
   T.RANK,
   h_manager_id AS PARENT_ID,
   T.ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE,
   1 AS CHILD_COUNT,
   T.DELETED_COUNT,
   T.REC_STATUS,
   T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME,
   T.PRIORITY,
   T.ELEMENT_ID AS ORIGINAL_ID,
   
   T.SD,
   T.START_DT,
   T.FD,
   T.FINISH_DT,
   T.MINUTE_PER_DAY, T.DURATION,
   
   CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
   CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
   CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
   CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
   T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
   
   T.BASELINE1_START AS BASELINE_START, 
   T.BASELINE1_FINISH AS BASELINE_FINISH, 
   T.BASELINE1_EFFORT AS BASELINE1_EFFORT,
   
   T.PLANNED_START,
   T.PLANNED_FINISH,
   T.PLANNED_EFFORT AS PLANNED_EFFORT,
   
   T.PROPOSED_START,
   T.PROPOSED_FINISH,
   T.PROPOSED_EFFORT AS PROPOSED_EFFORT,
   
   T.SCHED_START,
   T.SCHED_FINISH,
   T.SCHED_EFFORT AS SCHED_EFFORT,
   
   T.FORECAST_START,
   T.FORECAST_FINISH,
   
   T.ETC AS ETC,
   
   (T.SCHED_EFFORT + T.PLANNED_EFFORT) AS FORECAST_EFFORT,
   
   T.ACTUAL_START,
   T.ACTUAL_FINISH,
   T.ACTUAL_DURATION,
   T.WORK_TODATE AS ACTUAL_EFFORT,
   
   0 AS REGULAR_TODATE,
   0 AS SPECIAL_TODATE,
   ((T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE) AS REMAINING_EFFORT,
   
   CASE WHEN T.ETC = ((T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE) THEN 0 else 1 END AS ETC_RED_FLAG,
   
   -1 AS MILESTONE_PERCENT,
   T.WORK_PERCENT,
   (T.SCHED_EFFORT + T.PLANNED_EFFORT) AS WORK,
   T.SUBPROJECT_COUNT,
   
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET,
   0.00 AS ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET,
   0.00 AS FORECAST_BUDGET,
   0.00 AS ACTUAL_BUDGET,
   0.00 AS REMAINING,
   0 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE,
   0.00 AS REG_COST,
   0.00 AS SPEC_COST,
   
   0.00 AS X_R_ESTIMATION_BUDGET,
   0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_REVENUE,
   0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET,
   0.00 AS R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING,
   0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   0.00 AS REG_RATE,
   0.00 AS SPEC_RATE,
   
   '' AS ASSIGN_STRING,
   T.PROJECT_ID,
   0 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   T.REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DT,
   
   '' AS RESOURCE_TYPE,
   '' AS RESOURCE_ID,
   A.PARTICIPANT,
   A.SECURITY_ID,
   T.ASSIGN_COUNT,
   
   T.ASSIGN_NAMES,
   
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   
   '' AS CALENDAR_FLAG,
   T.LAST_CHECKIN AS LAST_CHECKIN,
   '' AS TSK_ASSIGNMENT_ID,
   T.FS_CODE,
   T.STAGE_ID,
   T.FS_LABOR_CODE,
   T.CURRENCY_ID,
   T.EFFORT_DRIVEN,
   
   TO_TIMESTAMP('1899-01-01 12:00:00')            AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')           AS ESTIMATED_SCHED_FINISH,
   0           AS ESTIMATED_SCHED_EFFORT,
   0.00             AS ESTIMATED_SCHED_COST,
   0.00          AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00')           AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')       AS ESTIMATED_PLANNED_FINISH,
   0        AS ESTIMATED_PLANNED_EFFORT,
   0.00             AS ESTIMATED_PLANNED_COST,
   0.00         AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00')       AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')       AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00')          AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')         AS LEVEL_SCHED_FINISH,
   '' AS LEVEL_ASSIGN_STRING,
   T.LEVEL_START,
   T.LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00')        AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')       AS ESTIMATED_BASELINE1_FINISH,
   0        AS ESTIMATED_BASELINE1_EFFORT,
   0.00         AS ESTIMATED_BASELINE1_COST,
   0.00         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   T.BUBBLE_COLOR AS BUBBLE_COLOR,
   T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
   COALESCE(T.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00')) AS MP_STATUS_DT,
   '' AS EDIT_FLAG, '' AS BIT_FLAG,
   (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
   FROM VP_MTWP_PM_1 A
   JOIN TMT_WBS T
   ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   JOIN RESOURCES R
   ON R.RESOURCE_ID = T.REC_USER
   WHERE (h_include_proposed = 1         OR (T.SCHED_START IS NOT NuLL))
   AND (h_closed_not_completed = 1       OR (T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))  OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   ))
   AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
   AND (h_not_closed_not_completed = 1   OR ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )) )
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_WP', 344+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TEAM_WP(345) : views_pool.sql(1010) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN C_MTWP_PM;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_WP', 352+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_WP(353) : views_pool.sql(1018) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_WP', 364+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_WP(365) : views_pool.sql(1030) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_TEAM_WP;
ALTER FUNCTION FC_WBS_MY_TEAM_WP COMPILE DEBUG;

/* ******************************************************************************** */

-- This function returns all the pools generated by the current user

-- at pool level there is no need to calculate anything just the default values

-- will be return to the client

/* ******************************************************************************** */

Prompt == FUNCTION FC_S_VP_072 ==
CREATE OR REPLACE FUNCTION FC_S_VP_072
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active_record PLS_INTEGER := sh_h_active_record;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR072 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR072b PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VP_072') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VP_072'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VP_072(' || 
       '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL')
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_072', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VP_072(26) : views_pool.sql(1080) : ' || SYSTIMESTAMP);
   END IF; 

   If (BITAND(Coalesce(h_active_record, 0), 2)) = 2 Then
      --trace_printf("\n CR072a \n");
      
      OPEN CR072 FOR SELECT 0 AS LEVEL_ID,
      T.TYPE_ID AS TYPE_ID,
      T.RANK,
      h_rec_user AS PARENT_ID,
      T.ELEMENT_ID,
      T.ELEMENT_NAME,
      R.ACTIVE,
      0 AS CHILD_COUNT,
      T.DELETED_COUNT,
      RM.REC_STATUS,
      T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME,
      T.PRIORITY,
      T.ELEMENT_ID AS ORIGINAL_ID,
      0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
      0 AS MINUTE_PER_DAY, -1 AS DURATION,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
      0 AS BASELINE_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
      0 AS PLANNED_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
      0 AS PROPOSED_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
      0 AS SCHED_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
      0 AS ETC,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
      0 AS ACTUAL_EFFORT,
      0 AS REGULAR_TODATE,
      0 AS SPECIAL_TODATE,
      0 AS REMAINING_EFFORT,
      0 AS ETC_RED_FLAG,
      0 AS REMAINING,
      0 AS MILESTONE_PERCENT,
      0 AS WORK_PERCENT,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET,
      0.00 AS BASELINE1_BUDGET,
      0.00 AS ESTIMATION_BUDGET,
      0.00 AS PROPOSED_LABOR_COST,
      0.00 AS CURRENT_BUDGET,
      0.00 AS FORECAST_BUDGET,
      0.00 AS ACTUAL_BUDGET,
      0.00 AS BUDGET_REMAINING,
      0.00 AS BUDGET_FORECAST_VARIANCE,
      0.00 AS BASELINE_VARIANCE,
      0.00 AS REGULAR_COST,
      0.00 AS SPECIAL_COST,
      0.00 AS X_R_ESTIMATION_BUDGET,
      0.00 AS R_BASELINE1_BUDGET,
      0.00 AS R_ESTIMATION_BUDGET,
      0.00 AS PROPOSED_LABOR_REVENUE,
      0.00 AS R_CURRENT_BUDGET,
      0.00 AS R_FORECAST_BUDGET,
      0.00 AS R_ACTUAL_BUDGET,
      0.00 AS R_REMAINING,
      0.00 AS R_BUDGET_FORECAST_VARIANCE,
      0.00 AS R_BASELINE_VARIANCE,
      0.00 AS REGULAR_RATE,
      0.00 AS SPECIAL_RATE,
      '' AS ASSIGN_STRING,
      '' AS PROJECT_ID,
      T.TYPE_ID AS ELEMENT_TYPE_BITS,
      '' AS WBS_CODE,
      T.REFERENCE_NUMBER,
      0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY,
      R.REVISION_TYPE,
      R.REVISION_IMPACT,
      '' AS LAST_WF_TYPE,
      '' AS LAST_WF_BY,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      R.RESOURCE_ID AS RESOURCE_ID,
      0 AS PARTICIPANT,
      '' AS SECURITY_ID,
      0 AS ASSIGN_COUNT,
      T.ASSIGN_NAMES,
      'M' AS ASSIGNED,
      CASE WHEN R.CALENDAR_ID IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
      R.FS_CODE,
      0 AS STAGE_ID,
      R.FS_LABOR_CODE ,
      '0' AS PUBLIC_FLAG ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      0 AS UNITS_PERCENT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
      
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY
      
      FROM TMT_WBS T, RM_ASSIGNMENTS  RM, RESOURCES R
      WHERE T.ELEMENT_ID = RM.PROJECT_ID
      AND RM.MANAGER_ID = h_rec_user
      AND R.RESOURCE_ID =  h_rec_user
      AND RM.REC_STATUS IN ('D', 'A')
      AND RM.PROFILE_ID IS NuLL
      ORDER BY RM.REC_DATETIME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_072', 178+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_S_VP_072(179) : views_pool.sql(1233) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR072;
   Else
      --trace_printf("\n CR072b \n");
      
      OPEN CR072b FOR SELECT 0 AS LEVEL_ID,
      T.TYPE_ID AS TYPE_ID,
      T.RANK,
      h_rec_user AS PARENT_ID,
      T.ELEMENT_ID,
      T.ELEMENT_NAME,
      R.ACTIVE,
      0 AS CHILD_COUNT,
      T.DELETED_COUNT,
      RM.REC_STATUS,
      T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME,
      T.PRIORITY,
      T.ELEMENT_ID AS ORIGINAL_ID,
      T.SD,
      T.START_DT AS START_DT, T.FD,
      T.FINISH_DT,
      T.MINUTE_PER_DAY,
      T.DURATION,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
      0 AS BASELINE_WORK,
      T.PLANNED_START,
      T.PLANNED_FINISH,
      T.PLANNED_EFFORT,
      T.PROPOSED_START,
      T.PROPOSED_FINISH,
      T.PROPOSED_EFFORT,
      T.SCHED_START,
      T.SCHED_FINISH,
      T.SCHED_EFFORT,
      T.FORECAST_START,
      T.FORECAST_FINISH,
      T.ETC,
      T.ACTUAL_START,
      T.ACTUAL_FINISH,
      T.ACTUAL_EFFORT,
      0 AS REGULAR_TODATE,
      0 AS SPECIAL_TODATE,
      0 AS REMAINING_EFFORT,
      0 AS ETC_RED_FLAG,
      0 AS REMAINING,
      0 AS MILESTONE_PERCENT,
      0 AS WORK_PERCENT,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET,
      0.00 AS BASELINE1_BUDGET,
      0.00 AS ESTIMATION_BUDGET,
      0.00 AS PROPOSED_LABOR_COST,
      0.00 AS CURRENT_BUDGET,
      0.00 AS FORECAST_BUDGET,
      0.00 AS ACTUAL_BUDGET,
      0.00 AS BUDGET_REMAINING,
      0.00 AS BUDGET_FORECAST_VARIANCE,
      0.00 AS BASELINE_VARIANCE,
      0.00 AS REGULAR_COST,
      0.00 AS SPECIAL_COST,
      0.00 AS X_R_ESTIMATION_BUDGET,
      0.00 AS R_BASELINE1_BUDGET,
      0.00 AS R_ESTIMATION_BUDGET,
      0.00 AS PROPOSED_LABOR_REVENUE,
      0.00 AS R_CURRENT_BUDGET,
      0.00 AS R_FORECAST_BUDGET,
      0.00 AS R_ACTUAL_BUDGET,
      0.00 AS R_REMAINING,
      0.00 AS R_BUDGET_FORECAST_VARIANCE,
      0.00 AS R_BASELINE_VARIANCE,
      0.00 AS REGULAR_RATE,
      0.00 AS SPECIAL_RATE,
      '' AS ASSIGN_STRING,
      '' AS PROJECT_ID,
      T.TYPE_ID AS ELEMENT_TYPE_BITS,
      '' AS WBS_CODE,
      T.REFERENCE_NUMBER,
      0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY,
      R.REVISION_TYPE,
      R.REVISION_IMPACT,
      '' AS LAST_WF_TYPE,
      '' AS LAST_WF_BY,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      R.RESOURCE_ID AS RESOURCE_ID,
      0 AS PARTICIPANT,
      '' AS SECURITY_ID,
      0 AS ASSIGN_COUNT,
      T.ASSIGN_NAMES,
      'M' AS ASSIGNED,
      CASE WHEN R.CALENDAR_ID IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
      R.FS_CODE,
      0 AS STAGE_ID,
      R.FS_LABOR_CODE ,
      '0' AS PUBLIC_FLAG ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      0 AS UNITS_PERCENT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
      
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY
      
      FROM TMT_WBS T, RM_ASSIGNMENTS  RM, RESOURCES R
      WHERE T.ELEMENT_ID = RM.PROJECT_ID
      AND RM.MANAGER_ID = h_rec_user
      AND R.RESOURCE_ID =  h_rec_user
      AND RM.REC_STATUS NOT IN ('D', 'A')
      AND RM.PROFILE_ID IS NuLL
      ORDER BY RM.REC_DATETIME;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_072', 334+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_S_VP_072(335) : views_pool.sql(1389) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR072b;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_072', 343+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_072(344) : views_pool.sql(1398) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_072', 355+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_072(356) : views_pool.sql(1410) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VP_072;
ALTER FUNCTION FC_S_VP_072 COMPILE DEBUG;

/**************************************************************/

Prompt == FUNCTION FC_S_VP_073 ==
CREATE OR REPLACE FUNCTION FC_S_VP_073
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_result_type PLS_INTEGER := 0;
   h_default_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      cr0073 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VP_073') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VP_073'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VP_073(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_073', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VP_073(22) : views_pool.sql(1448) : ' || SYSTIMESTAMP);
   END IF; 

   h_result_type := 2;
   h_default_id := NULL;
   PMO_DB2M.SC_STATE := FC_GET_SELECTED_RESOURCES(h_result_type, h_default_id, h_resource_id);
   
   --trace_printf("\n cr0073 \n");
   
   OPEN cr0073 FOR SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID, T.RANK, h_resource_id AS PARENT_ID,
   T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
   (SELECT FULL_NAME FROM RESOURCES WHERE RESOURCE_ID = h_rec_user) AS REC_USER_NAME,
   T.REC_DATETIME, 0 AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,       TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,     TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   0 AS WORK_TODATE, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE, 0.00 AS REGULAR_COST,
   0.00 AS SPECIAL_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE, 0.00 AS REGULAR_RATE, 0.00 AS SPECIAL_RATE,
   '' AS ASSIGN_STRING, '' AS PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER,
   0 AS MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT, '' AS RESOURCE_TYPE,
   '' AS RESOURCE_ID,
   '' AS PARTICIPANT,
   '' AS SECURITY_ID, T.CHILD_COUNT AS ASSIGN_COUNT,
   T.ASSIGN_NAMES, 'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
   '' AS FS_CODE,
   0 AS STAGE_ID,
   '' AS FS_LABOR_CODE,
   T.PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY
   
   FROM TMT_POOLS T, TMP_SELECTED_RESOURCES S
   WHERE T.ELEMENT_ID = S.RESOURCE_ID
   ORDER BY T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_073', 116+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VP_073(117) : views_pool.sql(1543) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN cr0073;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_073', 124+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_073(125) : views_pool.sql(1551) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_073', 136+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_073(137) : views_pool.sql(1563) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VP_073;
ALTER FUNCTION FC_S_VP_073 COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_S_VP_001 ==
CREATE OR REPLACE FUNCTION FC_S_VP_001
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_filter_string IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   myStmt VARCHAR2(19999);
-- Declare Cursors
      -- Resultset Cursor Declaration
      resultSet0001 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VP_001') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VP_001'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VP_001(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_filter_string || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_001', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VP_001(21) : views_pool.sql(1600) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VP_0001';
   PMO_DB2M.SC_STATE := 0;
   
   myStmt := 'INSERT INTO PMO_TMP_VP_0001 '
          || 'SELECT TP.PARENT_ID, MIN(TA.SCHED_START) AS SCHED_START, MAX(TA.SCHED_FINISH) AS SCHED_FINISH, SUM(TA.SCHED_WORK) AS SCHED_WORK, '
          || 'MIN(TA.PLANNED_START) AS PLANNED_START, MAX(TA.PLANNED_FINISH) AS PLANNED_FINISH, SUM(TA.PLANNED_WORK) AS PLANNED_WORK, '
          || 'MIN(TA.PROPOSED_START) AS PROPOSED_START, MAX(TA.PROPOSED_FINISH) AS PROPOSED_FINISH, SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK, '
          || 'MIN(TA.FORECAST_START) AS FORECAST_START, MAX(TA.FORECAST_FINISH) AS FORECAST_FINISH, MIN(TA.ACTUAL_START) AS ACTUAL_START, MAX(TA.ACTUAL_FINISH) AS ACTUAL_FINISH, '
          || 'SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.ETC) AS ETC '
          || 'FROM (TMT_WBS T JOIN TASK_ASSIGNMENTS TA ON T.ELEMENT_ID=TA.PROJECT_ID AND TA.PROJECT_ID <> TA.TASK_ID) JOIN TMT_POOLS TP ON TP.TYPE_ID = 13 AND TP.ELEMENT_ID = TA.RESOURCE_ID '
          || 'WHERE T.TYPE_ID IN (';
   myStmt := myStmt || PMO_CNST.SC_STR_PROJECT_GROUP_TYPES;
   myStmt := myStmt || ') AND TP.MANAGER_ID = ''';
   myStmt := myStmt || h_resource_id;
   myStmt := myStmt || '''';
   myStmt := myStmt || h_filter_string;
   myStmt := myStmt || 'AND TA.RESOURCE_TYPE=''0'' GROUP BY TP.PARENT_ID';
   
   PMO_DB2M.SC_STATE := PMO_STPU.doUpdate(myStmt);
   
   --trace_printf("\n resultSet0001 \n");
   
   OPEN resultSet0001 FOR SELECT 1 AS LEVEL_ID, TYPE_ID, RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
   CASE WHEN all_col.PARENT_ID IS Null THEN 0 ELSE 1 END AS CHILD_COUNT, 0 AS DELETED_COUNT,
   SCHED_START, SCHED_FINISH, SCHED_WORK, PLANNED_START, PLANNED_FINISH, PLANNED_WORK,
   PROPOSED_START, PROPOSED_FINISH, PROPOSED_WORK, FORECAST_START, FORECAST_FINISH, ACTUAL_START,
   ACTUAL_FINISH, WORK_TODATE, SCHED_WORK - WORK_TODATE AS REMAINING, ETC,
   
   0 AS MILESTONE_PERCENT,
   0 AS SUBPROJECT_COUNT,
   
   REC_USER, REC_STATUS, REC_DATETIME, 0 AS PRIORITY, 0 AS REGULAR_COST, 0 AS SPECIAL_COST,
   0 AS REGULAR_RATE, 0 AS SPECIAL_RATE
   FROM TMT_POOLS T
   LEFT JOIN PMO_TMP_VP_0001 all_col ON ELEMENT_ID = all_col.PARENT_ID
   WHERE T.TYPE_ID = 11 AND T.MANAGER_ID = h_resource_id
   ORDER BY RANK, PLANNED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_001', 62+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VP_001(63) : views_pool.sql(1642) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN resultSet0001;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_001', 70+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_001(71) : views_pool.sql(1650) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_001', 82+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_001(83) : views_pool.sql(1662) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VP_001;
ALTER FUNCTION FC_S_VP_001 COMPILE DEBUG;

/*********************************************************************************/

-- This function called from pool administration section (work packages by project menu)

-- the result set is all the projects related to a selected resource in selected pool

Prompt == FUNCTION FC_RM_RESOURCE_PROJECTS ==
CREATE OR REPLACE FUNCTION FC_RM_RESOURCE_PROJECTS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_temp_reg_rate NUMBER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_prj_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_table_name VARCHAR2(255);
   h_rank VARCHAR2(200);
   h_project_id VARCHAR2(32);
   h_include_participant PLS_INTEGER := 0;
   h_include_unpublished_prj PLS_INTEGER := 0;
   h_week_of DATE;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0003a PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_RESOURCE_PROJECTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_RESOURCE_PROJECTS'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_RESOURCE_PROJECTS(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RESOURCE_PROJECTS', 33+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_RESOURCE_PROJECTS(34) : views_pool.sql(1716) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_PROJECTS', 44+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_PROJECTS(45) : views_pool.sql(1727) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   h_include_participant := 0;
   
   h_rank := '0000';
   h_project_id := NULL;
   h_temp_bitflag := 1;
   
   h_include_unpublished_prj := 1;
   h_temp_sc_state := FC_ROLLUP_PROJECTS(h_resource_id, h_project_id, h_rank, h_nick_name
                                      , h_temp_bitflag, h_active_record, h_include_participant
                                      , h_include_unpublished_prj);
   
   h_null_id := NULL;
   h_temp_sc_state := FC_PRJ_ASSIGN_STRING(h_resource_id, h_null_id, h_null_id, h_null_id, h_week_of
                                        , 0);
   
   --trace_printf("\n h_resource_id:%s", h_resource_id);
   
   --trace_printf("\n CR0003a \n");
   
   OPEN CR0003a FOR SELECT  --Resource level aggregated info
   T.LEVEL_ID, 13 AS TYPE_ID, '----' AS RANK, T.PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, R.ACTIVE,
   1 AS CHILD_COUNT,
   T.DELETED_COUNT, R.REC_STATUS, R.REC_USER,
   R1.FULL_NAME AS REC_USER_NAME,
   R.REC_DATETIME, 0 AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT,
   0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   0 AS MINUTE_PER_DAY,
   -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   
   0 AS ACTUAL_EFFORT,
   0 AS REGULAR_TODATE,
   0 AS SPECIAL_TODATE,
   0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG,
   0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET,
   0.00 AS ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET,
   0.00 AS FORECAST_BUDGET,
   0.00 AS ACTUAL_BUDGET,
   0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE,
   
   (SELECT REGULAR_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_COST,
   (SELECT SPECIAL_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_COST,
   
   0.00 AS X_R_ESTIMATION_BUDGET,
   0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_REVENUE,
   0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET,
   0.00 AS R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING,
   0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   
   (SELECT REGULAR_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_RATE,
   (SELECT SPECIAL_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_RATE,
   
   '' AS ASSIGN_STRING,
   '' AS PROJECT_ID,
   13 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   0 AS REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   R.RESOURCE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   T.CHILD_COUNT AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   CASE WHEN R.CALENDAR_ID IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
   R.FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE,
   T.PUBLIC_FLAG,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''               AS LEVEL_ASSIGN_STRING,
   h_week_of AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   
   R.LOGON_NAME    AS  RESOURCE_USER_NAME,
   R.LAST_NAME     AS  RESOURCE_LAST_NAME,
   R.FIRST_NAME    AS  RESOURCE_GIVEN_NAME,
   R.MIDDLE_NAME   AS  RESOURCE_MIDDLE_NAME,
   R.NICK_NAME     AS  RESOURCE_NICK_NAME,
   R.E_MAIL_ADDRESS AS RESOURCE_EMAIL_ADDRESS,
   R.WORK_PHONE    AS  RESOURCE_WORK_PHONE,
   R.EFFECTIVE_DATE AS RESOURCE_EFFECTIVE_DATE,
   R.DISCONTINUE_DATE AS   RESOURCE_DISCONTINUE_DATE,
   (SELECT ELEMENT_NAME  FROM TMT_CALENDARS WHERE ELEMENT_ID = R.CALENDAR_ID) AS   RESOURCE_CALENDAR,
   (SELECT DESCRIPTION FROM TMT_DATAFIELDS WHERE ELEMENT_ID = R.CURRENCY_ID)   AS  RESOURCE_CURRENCY,
   h_week_of AS TA_START_DT
   
   FROM TMT_POOLS T
   JOIN RESOURCES R ON R.RESOURCE_ID = T.ELEMENT_ID
   JOIN RESOURCES R1 ON R1.RESOURCE_ID = R.REC_USER
   WHERE T.ELEMENT_ID = h_resource_id
   
   UNION ALL
   
   SELECT  --Project level (work-assigned) for the selected resource
   P.LEVEL_ID + 1 AS LEVEL_ID,
   CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SC_PERSONAL_PROJECT ELSE T.TYPE_ID END AS TYPE_ID,
   T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID,
   CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SCPERSONALPROJECT ELSE T.ELEMENT_NAME END AS ELEMENT_NAME,
   ' ' AS ACTIVE,
   A.TASK_COUNT AS CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   
   CASE WHEN A.START_DT = TO_TIMESTAMP('1899-01-01 12:00:00') THEN 0
   WHEN A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00') THEN PMO_CNST.SC_AS
   WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
   WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
   ELSE PMO_CNST.SC_NS END AS SD,
   
   CASE WHEN A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00') THEN A.ACTUAL_START ELSE A.START_DT END AS START_DT,
   
   CASE
   when T.FD = PMO_CNST.SC_AF then  T.FD
   WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN 0
   WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
   WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
   WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
   WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
   ELSE PMO_CNST.SC_SF END AS FD,
   
   CASE WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN A.ACTUAL_FINISH
   ELSE A.FINISH_DT END AS FINISH_DT,
   
   T.MINUTE_PER_DAY AS MINUTE_PER_DAY,
   -1 AS DURATION,
   
   A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_WORK,
   A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT AS PLANNED_WORK,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT AS PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT AS SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH,
   A.WORK_TODATE AS ACTUAL_EFFORT,
   0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
   ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN (A.ETC) = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   
   CASE WHEN A.SCHED_EFFORT > 0 THEN (A.SCHED_EFFORT - A.WORK_TODATE)
   WHEN A.PLANNED_EFFORT > 0 THEN (A.PLANNED_EFFORT - A.WORK_TODATE)
   ELSE 0 END AS REMAINING,
   
   -1 AS MILESTONE_PERCENT,
   A.WORK_PERCENT,
   T.SUBPROJECT_COUNT,
   PA.ESTIMATED_SCHED_COST AS X_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
   A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
   A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   0.00 AS REGULAR_COST,
   0.00 AS SPECIAL_COST,
   
   A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
   A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
   A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   0.00 AS REGULAR_RATE,
   0.00 AS SPECIAL_RATE,
   
   S.ASSIGN_STRING,
   A.PROJECT_ID AS PROJECT_ID,
   0 AS ELEMENT_TYPE_BITS,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   A.RESOURCE_ID AS RESOURCE_ID,
   PA.PARTICIPANT,
   case when PA.SECURITY_ID = '' OR  PA.SECURITY_ID IS Null then PMO_CNST.SCPROJECTVISITOR_DB_STR else PA.SECURITY_ID end AS SECURITY_ID,
   BITAND(PA.ELEMENT_TYPE_BITS, 62) AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   R.FS_CODE,
   T.STAGE_ID,
   R.FS_LABOR_CODE,
   P.PUBLIC_FLAG ,
   
   PA.ESTIMATED_SCHED_START,
   PA.ESTIMATED_SCHED_FINISH,
   PA.ESTIMATED_SCHED_EFFORT,
   PA.ESTIMATED_SCHED_COST,
   PA.ESTIMATED_SCHED_REVENUE,
   
   PA.ESTIMATED_PLANNED_START,
   PA.ESTIMATED_PLANNED_FINISH,
   PA.ESTIMATED_PLANNED_EFFORT,
   PA.ESTIMATED_PLANNED_COST,
   PA.ESTIMATED_PLANNED_REVENUE,
   
   PA.LEVEL_PLANNED_START,
   PA.LEVEL_PLANNED_FINISH,
   PA.LEVEL_SCHED_START,
   PA.LEVEL_SCHED_FINISH,
   S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
   COALESCE(S.PA_START_DT,h_week_of)         AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')  AS LEVEL_FINISH,
   
   PA.ESTIMATED_BASELINE1_START,
   PA.ESTIMATED_BASELINE1_FINISH,
   PA.ESTIMATED_BASELINE1_EFFORT,
   PA.ESTIMATED_BASELINE1_COST,
   PA.ESTIMATED_BASELINE1_REVENUE,
   
   PA.ESTIMATED_BASELINE3_START,
   PA.ESTIMATED_BASELINE3_FINISH,
   PA.ESTIMATED_BASELINE3_EFFORT,
   PA.ESTIMATED_BASELINE3_COST,
   PA.ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   COALESCE(A.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00')) AS MP_STATUS_DT,
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
   
   FROM TMT_POOLS P
   JOIN VP_MWP_TM_2 A ON A.RESOURCE_ID = P.ELEMENT_ID
   JOIN PROJECT_ASSIGNMENTS PA ON PA.RESOURCE_ID = A.RESOURCE_ID
   AND PA.PROJECT_ID = A.PROJECT_ID
   JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID
   AND T.ELEMENT_ID = A.PROJECT_ID
   AND T.REC_STATUS <> 'D'
   JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
   JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.PROJECT_ID
   WHERE P.ELEMENT_ID = h_resource_id
   AND T.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3, PMO_CNST.SC_RESOURCE)
   ORDER BY RANK, PLANNED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RESOURCE_PROJECTS', 378+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_RESOURCE_PROJECTS(379) : views_pool.sql(2061) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0003a;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_PROJECTS', 386+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_PROJECTS(387) : views_pool.sql(2069) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_PROJECTS', 398+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_PROJECTS(399) : views_pool.sql(2081) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_RESOURCE_PROJECTS;
ALTER FUNCTION FC_RM_RESOURCE_PROJECTS COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_RM_WP_OPEN_PROJECT ==
CREATE OR REPLACE FUNCTION FC_RM_WP_OPEN_PROJECT
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_pool_level_id PLS_INTEGER := 0;
   h_pool_public_flag VARCHAR2(1);
   h_temp_reg_rate NUMBER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_bitflag_oracle PLS_INTEGER := 0;
   h_temp_table_name VARCHAR2(255);
   h_project_id VARCHAR2(32);
   h_rank_length PLS_INTEGER := 0;
   h_root_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_include_participant PLS_INTEGER := 0;
   h_include_unpublished_prj PLS_INTEGER := 0;
   h_week_of DATE;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0003b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      del_items PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_WP_OPEN_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_WP_OPEN_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_WP_OPEN_PROJECT(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_WP_OPEN_PROJECT', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_WP_OPEN_PROJECT(45) : views_pool.sql(2142) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 55+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(56) : views_pool.sql(2153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   h_include_participant := 0;
   
   BEGIN
      SELECT TYPE_ID, RANK, PROJECT_ID
      INTO h_type_id, h_rank, h_project_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(76) : views_pool.sql(2173) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VP_3005';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VP_3006';
   PMO_DB2M.SC_STATE := 0;
   
   h_rank_length := Coalesce(Length(h_rank), 0);
   
   --Aggregate information for the selected resource at Deliverable Level
   --work-assigned + participant
   BEGIN
      INSERT INTO PMO_TMP_VP_3005
      SELECT
      A.PROJECT_ID,
      del.element_id AS DELIVERABLE_ID,
      AVG(T.MINUTE_PER_DAY) AS MINUTE_PER_DAY,
      MIN(A.START_DT) AS START_DT,
      MAX(A.FINISH_DT) AS FINISH_DT,
      MIN(A.BASELINE1_START) AS BASELINE_START,
      MAX(A.BASELINE1_FINISH) AS BASELINE_FINISH,
      SUM(BASELINE1_WORK) AS BASELINE_WORK,
      MIN(A.PLANNED_START) AS PLANNED_START,
      MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
      SUM(A.PLANNED_WORK) AS PLANNED_WORK,
      MIN(A.PROPOSED_START) AS PROPOSED_START,
      MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      MIN(A.SCHED_START) AS SCHED_START,
      MAX(A.SCHED_FINISH) AS SCHED_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK,
      MIN(A.FORECAST_START) AS FORECAST_START,
      MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
      SUM(A.ETC) AS ETC,
      MIN(A.ACTUAL_START) AS ACTUAL_START,
      MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
      SUM(A.WORK_TODATE) AS WORK_TODATE,
      SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
      SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
      SUM(((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE)) AS REMAINING_EFFORT,
      CASE WHEN SUM(A.SCHED_DURATION) > 0
      THEN Trunc((PMO_ORASTD.TODECIMAL(SUM(A.ACTUAL_DURATION))/PMO_ORASTD.TODECIMAL(SUM(A.SCHED_DURATION))) *10000)
      ELSE CASE WHEN SUM(T.TOTAL_DURATION) > 0
      THEN (SUM(T.TOTAL_DURATION*T.MILESTONE_PERCENT) / SUM(T.TOTAL_DURATION))
      ELSE 0 END END AS MILESTONE_PERCENT,
      CASE WHEN SUM(A.WORK_TODATE) > 0 THEN Trunc((SUM(TO_NUMBER(A.WORK_TODATE))/SUM(TO_NUMBER((A.SCHED_WORK+A.PLANNED_WORK))) * 10000.00) + 0.5) ELSE 0 END AS WORK_PERCENT,
      SUM(A.SCHED_WORK+A.PLANNED_WORK) AS EFFORT,
      SUM(A.SCHED_WORK+A.PLANNED_WORK) AS TOTAL_EFFORT,
      SUM(A.ESTIMATION_LABOR_COST) AS ESTIMATION_LABOR_COST,
      SUM(A.BASELINE1_LABOR_COST) AS BASELINE_LABOR_COST,
      SUM(A.PLANNED_LABOR_COST) AS PLANNED_LABOR_COST,
      SUM(A.PROPOSED_LABOR_COST) AS PROPOSED_LABOR_COST,
      SUM(A.SCHED_LABOR_COST) AS SCHED_LABOR_COST,
      SUM(A.FORECAST_LABOR_COST) AS FORECAST_LABOR_COST,
      SUM(A.ACTUAL_LABOR_COST) AS ACTUAL_LABOR_COST,
      SUM(A.ESTIMATION_LABOR_REVENUE) AS ESTIMATION_LABOR_REVENUE,
      SUM(A.BASELINE1_LABOR_REVENUE) AS BASELINE_LABOR_REVENUE,
      SUM(A.PLANNED_LABOR_REVENUE) AS PLANNED_LABOR_REVENUE,
      SUM(A.PROPOSED_LABOR_REVENUE) AS PROPOSED_LABOR_REVENUE,
      SUM(A.SCHED_LABOR_REVENUE) AS SCHED_LABOR_REVENUE,
      SUM(A.FORECAST_LABOR_REVENUE) AS FORECAST_LABOR_REVENUE,
      SUM(A.ACTUAL_LABOR_REVENUE) AS ACTUAL_LABOR_REVENUE ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LEVEL_SCHED_FINISH,
      MIN(A.LEVEL_START) AS LEVEL_START,
      MAX(A.LEVEL_FINISH) AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00') AS EST_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS EST_PLANNED_FINISH,
      0                     AS EST_PLANNED_EFFORT,
      0.00                  AS EST_PLANNED_COST,
      0.00                  AS EST_PLANNED_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00') AS EST_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS EST_SCHED_FINISH,
      0                     AS EST_SCHED_EFFORT,
      0.00                  AS EST_SCHED_COST,
      0.00                  AS EST_SCHED_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00') AS EST_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS EST_BASELINE1_FINISH,
      0                     AS EST_BASELINE1_EFFORT,
      0.00                  AS EST_BASELINE1_COST,
      0.00                  AS EST_BASELINE1_REVENUE,
      
      MAX(A.REC_DATETIME)     AS MP_STATUS_DT,
      MIN(case when T.FD = PMO_CNST.SC_AF then PMO_CNST.SC_AF else 0 end) AS FD
      
      FROM TASK_ASSIGNMENTS A
      JOIN TMT_WBS T
      ON T.PROJECT_ID = A.PROJECT_ID
      AND T.ELEMENT_ID = A.TASK_ID
      join tmt_wbs del on del.rank = case when length(t.rank)>(h_rank_length + 4) then substr(t.rank,1,(h_rank_length + 4)) else h_rank end
      WHERE A.RESOURCE_ID = h_resource_id
      AND T.RANK LIKE h_rank || '%'
      AND T.RANK > h_rank
      AND A.TASK_ID <> A.PROJECT_ID
      AND T.PROJECT_ID = h_project_id
      GROUP BY A.PROJECT_ID, del.element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 193+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(194) : views_pool.sql(2291) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_VP_3006
      SELECT
      A.PROJECT_ID,
      A.DELIVERABLE_ID,
      1 AS CHILD_COUNT,
      0 AS SD,
      MIN(A.START_DT) AS START_DT,
      MIN(A.FD) AS FD,
      MAX(A.FINISH_DT) AS FINISH_DT,
      AVG(A.MINUTE_PER_DAY) AS MINUTE_PER_DAY,
      MIN(A.BASELINE_START) AS BASELINE_START,
      MAX(A.BASELINE_FINISH) AS BASELINE_FINISH,
      SUM(BASELINE_WORK) AS BASELINE_WORK,
      MIN(A.PLANNED_START) AS PLANNED_START,
      MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
      SUM(PLANNED_WORK) AS PLANNED_WORK,
      MIN(A.PROPOSED_START) AS PROPOSED_START,
      MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
      SUM(PROPOSED_WORK) AS PROPOSED_WORK,
      MIN(A.SCHED_START) AS SCHED_START,
      MAX(A.SCHED_FINISH) AS SCHED_FINISH,
      SUM(SCHED_WORK) AS SCHED_WORK,
      MIN(A.FORECAST_START) AS FORECAST_START,
      MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
      SUM(ETC) AS ETC,
      MIN(A.ACTUAL_START) AS ACTUAL_START,
      MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
      SUM(WORK_TODATE) AS WORK_TODATE,
      SUM(REGULAR_TODATE) AS REGULAR_TODATE,
      SUM(SPECIAL_TODATE) AS SPECIAL_TODATE,
      SUM(REMAINING_EFFORT) AS REMAINING_EFFORT,
      0 AS ETC_RED_FLAG,
      case when SUM(A.TOTAL_EFFORT) > 0 then (SUM(A.MILESTONE_PERCENT * A.TOTAL_EFFORT) / SUM(A.TOTAL_EFFORT))
      else 0 end AS MILESTONE_PERCENT,
      CASE WHEN SUM(A.WORK_TODATE) > 0 THEN Trunc((SUM(TO_NUMBER(A.WORK_TODATE))/SUM(TO_NUMBER(A.EFFORT)) * 10000.00) + 0.5) ELSE 0 END AS WORK_PERCENT,
      SUM(ESTIMATION_LABOR_COST) AS ESTIMATION_LABOR_COST,
      SUM(BASELINE_LABOR_COST) AS BASELINE_LABOR_COST,
      SUM(PLANNED_LABOR_COST) AS PLANNED_LABOR_COST,
      SUM(PROPOSED_LABOR_COST) AS PROPOSED_LABOR_COST,
      SUM(SCHED_LABOR_COST) AS SCHED_LABOR_COST,
      SUM(FORECAST_LABOR_COST) AS FORECAST_LABOR_COST,
      SUM(ACTUAL_LABOR_COST) AS ACTUAL_LABOR_COST,
      SUM(ESTIMATION_LABOR_REVENUE) AS ESTIMATION_LABOR_REVENUE,
      SUM(BASELINE_LABOR_REVENUE) AS BASELINE_LABOR_REVENUE,
      SUM(PLANNED_LABOR_REVENUE) AS PLANNED_LABOR_REVENUE,
      SUM(PROPOSED_LABOR_REVENUE) AS PROPOSED_LABOR_REVENUE,
      SUM(SCHED_LABOR_REVENUE) AS SCHED_LABOR_REVENUE,
      SUM(FORECAST_LABOR_REVENUE) AS FORECAST_LABOR_REVENUE,
      SUM(ACTUAL_LABOR_REVENUE) AS ACTUAL_LABOR_REVENUE,
      (SELECT CASE WHEN (SUM(SCHED_WORK) + SUM(PLANNED_WORK)) > 0.00
      THEN (((SUM(SCHED_LABOR_REVENUE) + SUM(PLANNED_LABOR_REVENUE))*60)/(SUM(SCHED_WORK) + SUM(PLANNED_WORK)))
      ELSE 0.00 END
      FROM TASK_ASSIGNMENTS
      WHERE BILLABLE = 1
      AND PROJECT_ID = A.PROJECT_ID
      AND RESOURCE_ID = h_resource_id
      AND TASK_ID IN ( SELECT  ELEMENT_ID FROM TMT_WBS WHERE PARENT_ID = A.DELIVERABLE_ID )
      ) AS BILLABLE_REG_RATE,
      MIN(LEVEL_PLANNED_START) AS LEVEL_PLANNED_START,
      MAX(LEVEL_PLANNED_FINISH) AS LEVEL_PLANNED_FINISH,
      MIN(LEVEL_SCHED_START) AS LEVEL_SCHED_START,
      MAX(LEVEL_SCHED_FINISH) AS LEVEL_SCHED_FINISH,
      MIN(LEVEL_START) AS LEVEL_START,
      MAX(LEVEL_FINISH) AS LEVEL_FINISH,
      MIN(EST_PLANNED_START) AS EST_PLANNED_START,
      MAX(EST_PLANNED_FINISH) AS EST_PLANNED_FINISH,
      SUM(EST_PLANNED_EFFORT) AS EST_PLANNED_EFFORT,
      SUM(EST_PLANNED_COST) AS EST_PLANNED_COST,
      SUM(EST_PLANNED_REVENUE) AS EST_PLANNED_REVENUE,
      MIN(EST_SCHED_START) AS EST_SCHED_START,
      MAX(EST_SCHED_FINISH) AS EST_SCHED_FINISH,
      SUM(EST_SCHED_EFFORT) AS EST_SCHED_EFFORT,
      SUM(EST_SCHED_COST) AS EST_SCHED_COST,
      SUM(EST_SCHED_REVENUE) AS EST_SCHED_REVENUE,
      MIN(EST_BASELINE1_START) AS EST_BASELINE1_START,
      MAX(EST_BASELINE1_FINISH) AS EST_BASELINE1_FINISH,
      SUM(EST_BASELINE1_EFFORT) AS EST_BASELINE1_EFFORT,
      SUM(EST_BASELINE1_COST) AS EST_BASELINE1_COST,
      SUM(EST_BASELINE1_REVENUE) AS EST_BASELINE1_REVENUE,
      MAX(A.MP_STATUS_DT)         AS MP_STATUS_DT
      FROM PMO_TMP_VP_3005 A
      GROUP BY A.PROJECT_ID, A.DELIVERABLE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 291+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(292) : views_pool.sql(2389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT DISTINCT V.DELIVERABLE_ID
      INTO h_root_id
      FROM PMO_TMP_VP_3005 V
      WHERE V.DELIVERABLE_ID = h_id
      AND V.PROJECT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 308+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(309) : views_pool.sql(2406) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_TMP_VP_3006
         SELECT h_project_id, h_id,
         1 AS CHILD_COUNT,
         0 AS SD,
         MIN(A.START_DT) AS START_DT,
         MIN(A.FD) AS FD,
         MAX(A.FINISH_DT) AS FINISH_DT,
         AVG(A.MINUTE_PER_DAY) AS MINUTE_PER_DAY,
         MIN(A.BASELINE_START) AS BASELINE_START,
         MAX(A.BASELINE_FINISH) AS BASELINE_FINISH,
         SUM(BASELINE_WORK) AS BASELINE_WORK,
         MIN(A.PLANNED_START) AS PLANNED_START,
         MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
         SUM(PLANNED_WORK) AS PLANNED_WORK,
         MIN(A.PROPOSED_START) AS PROPOSED_START,
         MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
         SUM(PROPOSED_WORK) AS PROPOSED_WORK,
         MIN(A.SCHED_START) AS SCHED_START,
         MAX(A.SCHED_FINISH) AS SCHED_FINISH,
         SUM(SCHED_WORK) AS SCHED_WORK,
         MIN(A.FORECAST_START) AS FORECAST_START,
         MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
         SUM(ETC) AS ETC,
         MIN(A.ACTUAL_START) AS ACTUAL_START,
         MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
         SUM(WORK_TODATE) AS WORK_TODATE,
         SUM(REGULAR_TODATE) AS REGULAR_TODATE,
         SUM(SPECIAL_TODATE) AS SPECIAL_TODATE,
         SUM(REMAINING_EFFORT) AS REMAINING_EFFORT,
         0 AS ETC_RED_FLAG,
         case when SUM(A.TOTAL_EFFORT) > 0 then (SUM(A.MILESTONE_PERCENT * A.TOTAL_EFFORT) / SUM(A.TOTAL_EFFORT))
         else 0 end AS MILESTONE_PERCENT,
         CASE WHEN SUM(A.WORK_TODATE) > 0 THEN Trunc((SUM(TO_NUMBER(A.WORK_TODATE))/SUM(TO_NUMBER(A.EFFORT)) * 10000.00) + 0.5) ELSE 0 END AS WORK_PERCENT,
         SUM(ESTIMATION_LABOR_COST) AS ESTIMATION_LABOR_COST,
         SUM(BASELINE_LABOR_COST) AS BASELINE_LABOR_COST,
         SUM(PLANNED_LABOR_COST) AS PLANNED_LABOR_COST,
         SUM(PROPOSED_LABOR_COST) AS PROPOSED_LABOR_COST,
         SUM(SCHED_LABOR_COST) AS SCHED_LABOR_COST,
         SUM(FORECAST_LABOR_COST) AS FORECAST_LABOR_COST,
         SUM(ACTUAL_LABOR_COST) AS ACTUAL_LABOR_COST,
         SUM(ESTIMATION_LABOR_REVENUE) AS ESTIMATION_LABOR_REVENUE,
         SUM(BASELINE_LABOR_REVENUE) AS BASELINE_LABOR_REVENUE,
         SUM(PLANNED_LABOR_REVENUE) AS PLANNED_LABOR_REVENUE,
         SUM(PROPOSED_LABOR_REVENUE) AS PROPOSED_LABOR_REVENUE,
         SUM(SCHED_LABOR_REVENUE) AS SCHED_LABOR_REVENUE,
         SUM(FORECAST_LABOR_REVENUE) AS FORECAST_LABOR_REVENUE,
         SUM(ACTUAL_LABOR_REVENUE) AS ACTUAL_LABOR_REVENUE,
         0 AS BILLABLE_REG_RATE,
         MIN(LEVEL_PLANNED_START) AS LEVEL_PLANNED_START,
         MAX(LEVEL_PLANNED_FINISH) AS LEVEL_PLANNED_FINISH,
         MIN(LEVEL_SCHED_START) AS LEVEL_SCHED_START,
         MAX(LEVEL_SCHED_FINISH) AS LEVEL_SCHED_FINISH,
         MIN(LEVEL_START) AS LEVEL_START,
         MAX(LEVEL_FINISH) AS LEVEL_FINISH,
         MIN(EST_PLANNED_START) AS EST_PLANNED_START,
         MAX(EST_PLANNED_FINISH) AS EST_PLANNED_FINISH,
         SUM(EST_PLANNED_EFFORT) AS EST_PLANNED_EFFORT,
         SUM(EST_PLANNED_COST) AS EST_PLANNED_COST,
         SUM(EST_PLANNED_REVENUE) AS EST_PLANNED_REVENUE,
         MIN(EST_SCHED_START) AS EST_SCHED_START,
         MAX(EST_SCHED_FINISH) AS EST_SCHED_FINISH,
         SUM(EST_SCHED_EFFORT) AS EST_SCHED_EFFORT,
         SUM(EST_SCHED_COST) AS EST_SCHED_COST,
         SUM(EST_SCHED_REVENUE) AS EST_SCHED_REVENUE,
         MIN(EST_BASELINE1_START) AS EST_BASELINE1_START,
         MAX(EST_BASELINE1_FINISH) AS EST_BASELINE1_FINISH,
         SUM(EST_BASELINE1_EFFORT) AS EST_BASELINE1_EFFORT,
         SUM(EST_BASELINE1_COST) AS EST_BASELINE1_COST,
         SUM(EST_BASELINE1_REVENUE) AS EST_BASELINE1_REVENUE ,
         MAX(A.MP_STATUS_DT)         AS MP_STATUS_DT
         FROM PMO_TMP_VP_3005 A
         GROUP BY A.PROJECT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 397+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(398) : views_pool.sql(2495) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      -- update root node -> aggregate to the root node
      BEGIN
         UPDATE PMO_TMP_VP_3006 V
         SET (
         CHILD_COUNT,
         SD,
         START_DT,
         FD,
         FINISH_DT,
         MINUTE_PER_DAY,
         BASELINE_START,
         BASELINE_FINISH,
         BASELINE_WORK,
         PLANNED_START,
         PLANNED_FINISH,
         PLANNED_WORK,
         PROPOSED_START,
         PROPOSED_FINISH,
         PROPOSED_WORK,
         SCHED_START,
         SCHED_FINISH,
         SCHED_WORK,
         FORECAST_START,
         FORECAST_FINISH,
         ETC,
         ACTUAL_START,
         ACTUAL_FINISH,
         WORK_TODATE,
         REGULAR_TODATE,
         SPECIAL_TODATE,
         REMAINING_EFFORT,
         ETC_RED_FLAG,
         MILESTONE_PERCENT,
         WORK_PERCENT,
         ESTIMATION_LABOR_COST,
         BASELINE_LABOR_COST,
         PLANNED_LABOR_COST,
         PROPOSED_LABOR_COST,
         SCHED_LABOR_COST,
         FORECAST_LABOR_COST,
         ACTUAL_LABOR_COST,
         ESTIMATION_LABOR_REVENUE,
         BASELINE_LABOR_REVENUE,
         PLANNED_LABOR_REVENUE,
         PROPOSED_LABOR_REVENUE,
         SCHED_LABOR_REVENUE,
         FORECAST_LABOR_REVENUE,
         ACTUAL_LABOR_REVENUE,
         BILLABLE_REG_RATE,
         LEVEL_PLANNED_START,
         LEVEL_PLANNED_FINISH,
         LEVEL_SCHED_START,
         LEVEL_SCHED_FINISH,
         LEVEL_START,
         LEVEL_FINISH,
         EST_PLANNED_START,
         EST_PLANNED_FINISH,
         EST_PLANNED_EFFORT,
         EST_PLANNED_COST,
         EST_PLANNED_REVENUE,
         EST_SCHED_START,
         EST_SCHED_FINISH,
         EST_SCHED_EFFORT,
         EST_SCHED_COST,
         EST_SCHED_REVENUE,
         EST_BASELINE1_START,
         EST_BASELINE1_FINISH,
         EST_BASELINE1_EFFORT,
         EST_BASELINE1_COST,
         EST_BASELINE1_REVENUE ,
         MP_STATUS_DT) =
         (SELECT
         1 AS CHILD_COUNT,
         0 AS SD,
         MIN(A.START_DT) AS START_DT,
         MIN(A.FD) AS FD,
         MAX(A.FINISH_DT) AS FINISH_DT,
         AVG(A.MINUTE_PER_DAY) AS MINUTE_PER_DAY,
         MIN(A.BASELINE_START) AS BASELINE_START,
         MAX(A.BASELINE_FINISH) AS BASELINE_FINISH,
         SUM(BASELINE_WORK) AS BASELINE_WORK,
         MIN(A.PLANNED_START) AS PLANNED_START,
         MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
         SUM(PLANNED_WORK) AS PLANNED_WORK,
         MIN(A.PROPOSED_START) AS PROPOSED_START,
         MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
         SUM(PROPOSED_WORK) AS PROPOSED_WORK,
         MIN(A.SCHED_START) AS SCHED_START,
         MAX(A.SCHED_FINISH) AS SCHED_FINISH,
         SUM(SCHED_WORK) AS SCHED_WORK,
         MIN(A.FORECAST_START) AS FORECAST_START,
         MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
         SUM(ETC) AS ETC,
         MIN(A.ACTUAL_START) AS ACTUAL_START,
         MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
         SUM(WORK_TODATE) AS WORK_TODATE,
         SUM(REGULAR_TODATE) AS REGULAR_TODATE,
         SUM(SPECIAL_TODATE) AS SPECIAL_TODATE,
         SUM(REMAINING_EFFORT) AS REMAINING_EFFORT,
         0 AS ETC_RED_FLAG,
         case when SUM(A.TOTAL_EFFORT) > 0 then (SUM(A.MILESTONE_PERCENT * A.TOTAL_EFFORT) / SUM(A.TOTAL_EFFORT))
         else 0 end AS MILESTONE_PERCENT,
         CASE WHEN SUM(A.WORK_TODATE) > 0 THEN Trunc((SUM(TO_NUMBER(A.WORK_TODATE))/SUM(TO_NUMBER(A.EFFORT)) * 10000.00) + 0.5) ELSE 0 END AS WORK_PERCENT,
         SUM(ESTIMATION_LABOR_COST) AS ESTIMATION_LABOR_COST,
         SUM(BASELINE_LABOR_COST) AS BASELINE_LABOR_COST,
         SUM(PLANNED_LABOR_COST) AS PLANNED_LABOR_COST,
         SUM(PROPOSED_LABOR_COST) AS PROPOSED_LABOR_COST,
         SUM(SCHED_LABOR_COST) AS SCHED_LABOR_COST,
         SUM(FORECAST_LABOR_COST) AS FORECAST_LABOR_COST,
         SUM(ACTUAL_LABOR_COST) AS ACTUAL_LABOR_COST,
         SUM(ESTIMATION_LABOR_REVENUE) AS ESTIMATION_LABOR_REVENUE,
         SUM(BASELINE_LABOR_REVENUE) AS BASELINE_LABOR_REVENUE,
         SUM(PLANNED_LABOR_REVENUE) AS PLANNED_LABOR_REVENUE,
         SUM(PROPOSED_LABOR_REVENUE) AS PROPOSED_LABOR_REVENUE,
         SUM(SCHED_LABOR_REVENUE) AS SCHED_LABOR_REVENUE,
         SUM(FORECAST_LABOR_REVENUE) AS FORECAST_LABOR_REVENUE,
         SUM(ACTUAL_LABOR_REVENUE) AS ACTUAL_LABOR_REVENUE,
         0 AS BILLABLE_REG_RATE,
         MIN(LEVEL_PLANNED_START) AS LEVEL_PLANNED_START,
         MAX(LEVEL_PLANNED_FINISH) AS LEVEL_PLANNED_FINISH,
         MIN(LEVEL_SCHED_START) AS LEVEL_SCHED_START,
         MAX(LEVEL_SCHED_FINISH) AS LEVEL_SCHED_FINISH,
         MIN(LEVEL_START) AS LEVEL_START,
         MAX(LEVEL_FINISH) AS LEVEL_FINISH,
         
         MIN(EST_PLANNED_START) AS EST_PLANNED_START,
         MAX(EST_PLANNED_FINISH) AS EST_PLANNED_FINISH,
         SUM(EST_PLANNED_EFFORT) AS EST_PLANNED_EFFORT,
         SUM(EST_PLANNED_COST) AS EST_PLANNED_COST,
         SUM(EST_PLANNED_REVENUE) AS EST_PLANNED_REVENUE,
         
         MIN(EST_SCHED_START) AS EST_SCHED_START,
         MAX(EST_SCHED_FINISH) AS EST_SCHED_FINISH,
         SUM(EST_SCHED_EFFORT) AS EST_SCHED_EFFORT,
         SUM(EST_SCHED_COST) AS EST_SCHED_COST,
         SUM(EST_SCHED_REVENUE) AS EST_SCHED_REVENUE,
         
         MIN(EST_BASELINE1_START) AS EST_BASELINE1_START,
         MAX(EST_BASELINE1_FINISH) AS EST_BASELINE1_FINISH,
         SUM(EST_BASELINE1_EFFORT) AS EST_BASELINE1_EFFORT,
         SUM(EST_BASELINE1_COST) AS EST_BASELINE1_COST,
         SUM(EST_BASELINE1_REVENUE) AS EST_BASELINE1_REVENUE ,
         
         MAX(A.MP_STATUS_DT)         AS MP_STATUS_DT
         FROM PMO_TMP_VP_3005 A
         GROUP BY A.PROJECT_ID)
         WHERE V.DELIVERABLE_ID = h_id
         AND V.PROJECT_ID = h_project_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 560+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(561) : views_pool.sql(2658) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_temp_table_name := 'session.PMO_TMP_VP_3006';
   h_bitflag_oracle := 1;
   h_temp_sc_state := FC_U_SF_DATE(Coalesce(h_bitflag_oracle, 0), h_temp_table_name);
   
   -- Fetch TMT_POOLS information
   BEGIN
      SELECT LEVEL_ID, PUBLIC_FLAG
      INTO h_pool_level_id, h_pool_public_flag
      FROM TMT_POOLS
      WHERE ELEMENT_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 582+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(583) : views_pool.sql(2680) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_type_id: %d, h_id: %d %s, h_rank: %d %s\n", h_type_id,h_id_Ind,h_id,h_rank_Ind,h_rank);
   
   If isProjectType(Coalesce(h_type_id, 0)) <> 0 OR Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
      h_project_id := NULL;
      h_temp_bitflag := 0;
      h_include_unpublished_prj := 1;
      h_temp_sc_state := FC_ROLLUP_PROJECTS(h_resource_id, h_project_id, h_rank, h_nick_name
                                      , h_temp_bitflag, h_active_record, h_include_participant
                                      , h_include_unpublished_prj);
      h_null_id := NULL;
      h_temp_sc_state := FC_PRJ_ASSIGN_STRING(h_resource_id, h_id, h_null_id, h_null_id, h_week_of, 0);
      
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      --trace_printf("\n h_id:%s", h_id);
      
      --trace_printf("\n CR0003b \n");
      
      OPEN CR0003b FOR SELECT  h_pool_level_id + 1 AS LEVEL_ID, T.TYPE_ID,
      T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID,
      T.ELEMENT_NAME, ' ' AS ACTIVE,
      1 AS CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
      0 AS MINUTE_PER_DAY,
      -1 AS DURATION,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
      0 AS BASELINE_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
      0 AS PLANNED_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
      0 AS PROPOSED_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
      0 AS SCHED_WORK,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
      0 AS ETC,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
      0 AS ACTUAL_EFFORT,
      0 AS REGULAR_TODATE,
      0 AS SPECIAL_TODATE,
      0 AS REMAINING_EFFORT,
      0 AS ETC_RED_FLAG,
      0 AS REMAINING,
      0 AS MILESTONE_PERCENT,
      0 AS WORK_PERCENT,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET,
      0.00 AS BASELINE1_BUDGET,
      0.00 AS ESTIMATION_BUDGET,
      0.00 AS PROPOSED_LABOR_COST,
      0.00 AS CURRENT_BUDGET,
      0.00 AS FORECAST_BUDGET,
      0.00 AS ACTUAL_BUDGET,
      0.00 AS BUDGET_REMAINING,
      0.00 AS BUDGET_FORECAST_VARIANCE,
      0.00 AS BASELINE_VARIANCE,
      0.00 AS REGULAR_COST,
      0.00 AS SPECIAL_COST,
      0.00 AS X_R_ESTIMATION_BUDGET,
      0.00 AS R_BASELINE1_BUDGET,
      0.00 AS R_ESTIMATION_BUDGET,
      0.00 AS PROPOSED_LABOR_REVENUE,
      0.00 AS R_CURRENT_BUDGET,
      0.00 AS R_FORECAST_BUDGET,
      0.00 R_ACTUAL_BUDGET,
      0.00 AS R_REMAINING,
      0.00 AS R_BUDGET_FORECAST_VARIANCE,
      0.00 AS R_BASELINE_VARIANCE,
      0.00 AS REGULAR_RATE,
      0.00 AS SPECIAL_RATE,
      '' AS ASSIGN_STRING,
      T.PROJECT_ID AS PROJECT_ID,
      T.TYPE_ID AS ELEMENT_TYPE_BITS,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
      T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY,
      T.REVISION_TYPE,
      T.REVISION_IMPACT,
      T.LAST_WF_TYPE,
      T.LAST_WF_BY,
      T.LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      R.RESOURCE_ID AS RESOURCE_ID,
      0 AS PARTICIPANT,
      '' AS SECURITY_ID,
      0 AS ASSIGN_COUNT,
      T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.FS_CODE,
      T.STAGE_ID,
      R.FS_LABOR_CODE,
      '0' AS PUBLIC_FLAG ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''               AS LEVEL_ASSIGN_STRING,
      PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_week_of, 1, 10)), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')    AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      0 AS UNITS_PERCENT,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY, h_week_of AS TA_START_DT
      FROM TMT_WBS T
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE T.ELEMENT_ID = h_id
      AND T.REC_STATUS <> 'D'
      
      UNION ALL
      
      SELECT  -- SUB Project level (work-assigned) for the selected resource
      h_pool_level_id + 2 AS LEVEL_ID, T.TYPE_ID,
      T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      A.TASK_COUNT AS CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.SD
      WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.ACTUAL_START = A.START_DT) THEN PMO_CNST.SC_AS
      WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
      WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
      ELSE PMO_CNST.SC_NS
      END AS SD,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.START_DT
      ELSE A.START_DT
      END AS START_DT,
      
      CASE when A.FD = PMO_CNST.SC_AF then T.FD
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FD
      WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
      WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
      WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
      WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
      ELSE PMO_CNST.SC_SF
      END AS FD,
      
      CASE
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FINISH_DT
      ELSE A.FINISH_DT
      END AS FINISH_DT,
      
      T.MINUTE_PER_DAY AS MINUTE_PER_DAY,
      -1 AS DURATION,
      
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_WORK,
      A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT AS PLANNED_WORK,
      A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT AS PROPOSED_WORK,
      A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT AS SCHED_WORK,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      A.WORK_TODATE AS ACTUAL_EFFORT,
      0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      (A.SCHED_EFFORT+A.PLANNED_EFFORT-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN (A.ETC) = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      
      A.TOTAL_EFFORT - A.WORK_TODATE AS REMAINING,
      
      -1 AS MILESTONE_PERCENT,
      A.WORK_PERCENT,
      T.SUBPROJECT_COUNT,
      A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
      A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
      A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.SCHED_LABOR_COST_RATE AS REGULAR_COST,
      0.00 AS SPECIAL_COST,
      
      A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
      A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
      A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
      ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      A.SCHED_LABOR_REVENUE_RATE AS REGULAR_RATE,
      0.00 AS SPECIAL_RATE,
      
      S.ASSIGN_STRING,
      A.PROJECT_ID AS PROJECT_ID,
      0 AS ELEMENT_TYPE_BITS,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      A.RESOURCE_ID AS RESOURCE_ID,
      PA.PARTICIPANT,
      case when PA.SECURITY_ID = '' OR  PA.SECURITY_ID IS Null then PMO_CNST.SCPROJECTVISITOR_DB_STR else PA.SECURITY_ID end AS SECURITY_ID,
      BITAND(PA.ELEMENT_TYPE_BITS, 62) AS ASSIGN_COUNT,
      T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.FS_CODE,
      T.STAGE_ID,
      R.FS_LABOR_CODE,
      P.PUBLIC_FLAG ,
      
      A.EST_SCHED_START AS ESTIMATED_SCHED_START,
      A.EST_SCHED_FINISH AS ESTIMATED_SCHED_FINISH,
      A.EST_SCHED_EFFORT AS ESTIMATED_SCHED_EFFORT,
      A.EST_SCHED_COST AS ESTIMATED_SCHED_COST,
      A.EST_SCHED_REVENUE AS ESTIMATED_SCHED_REVENUE,
      
      A.EST_PLANNED_START AS ESTIMATED_PLANNED_START,
      A.EST_PLANNED_FINISH AS ESTIMATED_PLANNED_FINISH,
      A.EST_PLANNED_EFFORT AS ESTIMATED_PLANNED_EFFORT,
      A.EST_PLANNED_COST AS ESTIMATED_PLANNED_COST,
      A.EST_PLANNED_REVENUE AS ESTIMATED_PLANNED_REVENUE,
      
      A.LEVEL_PLANNED_START AS LEVEL_PLANNED_START,
      A.LEVEL_PLANNED_FINISH AS LEVEL_PLANNED_FINISH,
      A.LEVEL_SCHED_START AS LEVEL_SCHED_START,
      A.LEVEL_SCHED_FINISH AS LEVEL_SCHED_FINISH,
      S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
      PMO_ORASTD.DB2TIMESTAMP(COALESCE(S.PA_START_DT,h_week_of), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      A.EST_BASELINE1_START AS ESTIMATED_BASELINE1_START,
      A.EST_BASELINE1_FINISH AS ESTIMATED_BASELINE1_FINISH,
      A.EST_BASELINE1_EFFORT AS ESTIMATED_BASELINE1_EFFORT,
      A.EST_BASELINE1_COST AS ESTIMATED_BASELINE1_COST,
      A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE1_REVENUE,
      A.EST_BASELINE1_START AS ESTIMATED_BASELINE3_START,
      A.EST_BASELINE1_FINISH AS ESTIMATED_BASELINE3_FINISH,
      A.EST_BASELINE1_EFFORT AS ESTIMATED_BASELINE3_EFFORT,
      A.EST_BASELINE1_COST AS ESTIMATED_BASELINE3_COST,
      A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      0 AS UNITS_PERCENT,
      A.MP_STATUS_DT AS MP_STATUS_DT,
      
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
      FROM TMT_POOLS P
      JOIN VP_MWP_TM_2 A ON A.RESOURCE_ID = P.ELEMENT_ID
      JOIN PROJECT_ASSIGNMENTS PA    ON PA.RESOURCE_ID = A.RESOURCE_ID AND PA.PROJECT_ID = A.PROJECT_ID
      JOIN TMT_WBS T  ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.PROJECT_ID AND T.REC_STATUS <> 'D'
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.PROJECT_ID
      WHERE P.ELEMENT_ID = h_resource_id
      
      UNION ALL
      
      SELECT  --Deliverable Level (work-assigned + Participant) for the selected resource
      h_pool_level_id + 2 AS LEVEL_ID,
      case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
      T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD,
      A.START_DT,
      A.FD,
      A.FINISH_DT,
      A.MINUTE_PER_DAY,
      -1 AS DURATION,
      A.BASELINE_START, A.BASELINE_FINISH,
      A.BASELINE_WORK, A.PLANNED_START, A.PLANNED_FINISH,
      A.PLANNED_WORK, A.PROPOSED_START, A.PROPOSED_FINISH,
      A.PROPOSED_WORK, A.SCHED_START, A.SCHED_FINISH,
      A.SCHED_WORK, A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
      A.REMAINING_EFFORT, A.ETC_RED_FLAG,
      (A.SCHED_WORK + A.PLANNED_WORK - A.WORK_TODATE) AS REMAINING,
      -1 AS MILESTONE_PERCENT,
      A.WORK_PERCENT,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN PMO_ORASTD.TODECIMAL((A.SCHED_WORK/60.00), 18, 2) > 0.00 THEN (A.SCHED_LABOR_COST * 60 / A.SCHED_WORK) WHEN PMO_ORASTD.TODECIMAL((A.PLANNED_WORK/60.00), 18, 2) > 0.00 THEN (A.PLANNED_LABOR_COST * 60 / A.PLANNED_WORK) ELSE 0.00 END AS REGULAR_COST, 0.00 AS SPECIAL_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      A.BILLABLE_REG_RATE AS REGULAR_RATE,
      0.00 AS SPECIAL_RATE,
      S.ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      RA.RESOURCE_TYPE, RA.RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.FS_CODE,
      T.STAGE_ID, R.FS_LABOR_CODE,
      h_pool_public_flag AS PUBLIC_FLAG,
      A.EST_SCHED_START       AS ESTIMATED_SCHED_START,
      A.EST_SCHED_FINISH      AS ESTIMATED_SCHED_FINISH,
      A.EST_SCHED_EFFORT      AS ESTIMATED_SCHED_EFFORT,
      A.EST_SCHED_COST        AS ESTIMATED_SCHED_COST,
      A.EST_SCHED_REVENUE     AS ESTIMATED_SCHED_REVENUE,
      A.EST_PLANNED_START     AS ESTIMATED_PLANNED_START,
      A.EST_PLANNED_FINISH    AS ESTIMATED_PLANNED_FINISH,
      A.EST_PLANNED_EFFORT    AS ESTIMATED_PLANNED_EFFORT,
      A.EST_PLANNED_COST      AS ESTIMATED_PLANNED_COST,
      A.EST_PLANNED_REVENUE   AS ESTIMATED_PLANNED_REVENUE,
      A.LEVEL_PLANNED_START   AS LEVEL_PLANNED_START,
      A.LEVEL_PLANNED_FINISH  AS LEVEL_PLANNED_FINISH,
      A.LEVEL_SCHED_START     AS LEVEL_SCHED_START,
      A.LEVEL_SCHED_FINISH    AS LEVEL_SCHED_FINISH,
      S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
      PMO_ORASTD.DB2TIMESTAMP(COALESCE(S.PA_START_DT,h_week_of), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      A.EST_BASELINE1_START   AS ESTIMATED_BASELINE1_START,
      A.EST_BASELINE1_FINISH  AS ESTIMATED_BASELINE1_FINISH,
      A.EST_BASELINE1_EFFORT  AS ESTIMATED_BASELINE1_EFFORT,
      A.EST_BASELINE1_COST    AS ESTIMATED_BASELINE1_COST,
      A.EST_BASELINE1_REVENUE     AS ESTIMATED_BASELINE1_REVENUE,
      A.EST_BASELINE1_START AS ESTIMATED_BASELINE3_START,
      A.EST_BASELINE1_FINISH AS ESTIMATED_BASELINE3_FINISH,
      A.EST_BASELINE1_EFFORT AS ESTIMATED_BASELINE3_EFFORT,
      A.EST_BASELINE1_COST AS ESTIMATED_BASELINE3_COST,
      A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      0 AS UNITS_PERCENT,
      A.MP_STATUS_DT,
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
      FROM PMO_TMP_VP_3006 A
      JOIN TMT_WBS T
      ON T.ELEMENT_ID = A.DELIVERABLE_ID
      JOIN TMT_WBS W
      ON W.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.DELIVERABLE_ID
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.ELEMENT_ID = A.DELIVERABLE_ID
      AND RA.RESOURCE_ID = h_resource_id
      WHERE A.DELIVERABLE_ID <> A.PROJECT_ID
      
      UNION ALL
      
      SELECT  --Task Level (Work-assigned) for the selected resource
      CASE WHEN T.PARENT_ID = T.PROJECT_ID THEN h_pool_level_id + 2 ELSE h_pool_level_id + 3 END AS LEVEL_ID,
      CASE    WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_PERSONAL_TASK or A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
      ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
      T.RANK, T.PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD, A.START_DT, A.FD, A.FINISH_DT,
      W.MINUTE_PER_DAY AS MINUTE_PER_DAY, A.DURATION,
      A.BASELINE1_START AS BASELINE_START,
      A.BASELINE1_FINISH AS BASELINE_FINISH,
      (A.BASELINE1_WORK) AS BASELINE_WORK, A.PLANNED_START, A.PLANNED_FINISH,
      (A.PLANNED_WORK) AS PLANNED_WORK, A.PROPOSED_START, A.PROPOSED_FINISH,
      (A.PROPOSED_WORK) AS PROPOSED_WORK, A.SCHED_START, A.SCHED_FINISH,
      (A.SCHED_WORK) AS SCHED_WORK, A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC, A.ACTUAL_START, A.ACTUAL_FINISH,
      (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
      ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING,
      -1 AS MILESTONE_PERCENT,
      COALESCE(A.MILESTONE_PERCENT, T.WORK_PERCENT) AS WORK_PERCENT,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.REGULAR_COST AS REGULAR_COST, A.SPECIAL_COST AS SPECIAL_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REGULAR_RATE,
      A.SPECIAL_RATE AS SPECIAL_RATE,
      S.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      R.FS_CODE,
      T.STAGE_ID, R.FS_LABOR_CODE,
      h_pool_public_flag AS PUBLIC_FLAG,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
      PMO_ORASTD.DB2TIMESTAMP(COALESCE(S.PA_START_DT,h_week_of), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      A.UNITS_MSP AS UNITS_PERCENT,
      A.REC_DATETIME          AS MP_STATUS_DT,
      
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
      FROM TASK_ASSIGNMENTS A
      JOIN RESOURCE_ASSIGNMENTS RA ON RA.PROJECT_ID = A.PROJECT_ID
      AND RA.ELEMENT_ID = A.TASK_ID
      AND RA.RESOURCE_ID = A.RESOURCE_ID
      JOIN TMT_WBS T
      ON T.ELEMENT_ID = A.TASK_ID
      AND T.PROJECT_ID = A.PROJECT_ID
      AND T.PARENT_ID = T.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID AND W.PROJECT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.TSK_ASSIGNMENT_ID
      
      WHERE A.RESOURCE_ID = h_resource_id
      AND A.PROJECT_ID = h_id
      AND A.TASK_ID <> A.PROJECT_ID
      ORDER BY RANK, PLANNED_START;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_WP_OPEN_PROJECT', 1116+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_RM_WP_OPEN_PROJECT(1117) : views_pool.sql(3214) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR0003b;
   Else
      h_temp_sc_state := FC_PRJ_ASSIGN_STRING(h_resource_id, h_project_id, h_id, h_rank, h_week_of, 0);
      
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      --trace_printf("\n h_id:%s", h_id);
      
      --trace_printf("\n del_items \n");
      
      OPEN del_items FOR SELECT  --Deliverable Level (work-assigned) for the selected resource
      case when A.DELIVERABLE_ID = h_id then h_pool_level_id + T.LEVEL_ID else  h_pool_level_id + T.LEVEL_ID + 1 end AS LEVEL_ID,
      case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
      T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT,
      T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD,
      A.START_DT,
      A.FD,
      A.FINISH_DT,
      A.MINUTE_PER_DAY,
      -1 AS DURATION,
      A.BASELINE_START, A.BASELINE_FINISH,
      A.BASELINE_WORK, A.PLANNED_START, A.PLANNED_FINISH,
      A.PLANNED_WORK, A.PROPOSED_START, A.PROPOSED_FINISH,
      A.PROPOSED_WORK, A.SCHED_START, A.SCHED_FINISH,
      A.SCHED_WORK, A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
      A.REMAINING_EFFORT, A.ETC_RED_FLAG,
      (A.SCHED_WORK + A.PLANNED_WORK - A.WORK_TODATE) AS REMAINING,
      -1 AS MILESTONE_PERCENT,
      A.WORK_PERCENT,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN PMO_ORASTD.TODECIMAL((A.SCHED_WORK/60.00), 18, 2) > 0.00 THEN (A.SCHED_LABOR_COST * 60 / A.SCHED_WORK) WHEN PMO_ORASTD.TODECIMAL((A.PLANNED_WORK/60.00), 18, 2) > 0.00 THEN (A.PLANNED_LABOR_COST * 60 / A.PLANNED_WORK) ELSE 0.00 END AS REGULAR_COST, 0.00 AS SPECIAL_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      A.BILLABLE_REG_RATE AS REGULAR_RATE,
      0.00 AS SPECIAL_RATE,
      S.ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE,T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      RA.RESOURCE_TYPE, RA.RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.FS_CODE,
      T.STAGE_ID, R.FS_LABOR_CODE,
      h_pool_public_flag AS PUBLIC_FLAG,
      A.EST_SCHED_START       AS ESTIMATED_SCHED_START,
      A.EST_SCHED_FINISH      AS ESTIMATED_SCHED_FINISH,
      A.EST_SCHED_EFFORT      AS ESTIMATED_SCHED_EFFORT,
      A.EST_SCHED_COST        AS ESTIMATED_SCHED_COST,
      A.EST_SCHED_REVENUE     AS ESTIMATED_SCHED_REVENUE,
      A.EST_PLANNED_START     AS ESTIMATED_PLANNED_START,
      A.EST_PLANNED_FINISH    AS ESTIMATED_PLANNED_FINISH,
      A.EST_PLANNED_EFFORT    AS ESTIMATED_PLANNED_EFFORT,
      A.EST_PLANNED_COST      AS ESTIMATED_PLANNED_COST,
      A.EST_PLANNED_REVENUE   AS ESTIMATED_PLANNED_REVENUE,
      A.LEVEL_PLANNED_START   AS LEVEL_PLANNED_START,
      A.LEVEL_PLANNED_FINISH  AS LEVEL_PLANNED_FINISH,
      A.LEVEL_SCHED_START     AS LEVEL_SCHED_START,
      A.LEVEL_SCHED_FINISH    AS LEVEL_SCHED_FINISH,
      S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
      PMO_ORASTD.DB2TIMESTAMP(COALESCE(S.PA_START_DT,h_week_of), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      A.EST_BASELINE1_START   AS ESTIMATED_BASELINE1_START,
      A.EST_BASELINE1_FINISH  AS ESTIMATED_BASELINE1_FINISH,
      A.EST_BASELINE1_EFFORT  AS ESTIMATED_BASELINE1_EFFORT,
      A.EST_BASELINE1_COST    AS ESTIMATED_BASELINE1_COST,
      A.EST_BASELINE1_REVENUE     AS ESTIMATED_BASELINE1_REVENUE,
      
      A.EST_BASELINE1_START AS ESTIMATED_BASELINE3_START,
      A.EST_BASELINE1_FINISH AS ESTIMATED_BASELINE3_FINISH,
      A.EST_BASELINE1_EFFORT AS ESTIMATED_BASELINE3_EFFORT,
      A.EST_BASELINE1_COST AS ESTIMATED_BASELINE3_COST,
      A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      0 AS UNITS_PERCENT,
      A.MP_STATUS_DT,
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
      FROM PMO_TMP_VP_3006 A
      JOIN TMT_WBS T
      ON T.PROJECT_ID =  A.PROJECT_ID AND T.ELEMENT_ID = A.DELIVERABLE_ID
      JOIN TMT_WBS W
      ON W.PROJECT_ID =  T.PROJECT_ID AND W.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.DELIVERABLE_ID
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA
      ON RA.ELEMENT_ID = A.DELIVERABLE_ID
      AND RA.RESOURCE_ID = h_resource_id
      
      UNION ALL
      
      SELECT  --Task Level (Work-assigned) for the selected resource
      h_pool_level_id + T.LEVEL_ID + 1 LEVEL_ID,
      case    WHEN T.TYPE_ID = PMO_CNST.SC_ACTIVE_ADM_TASK OR T.TYPE_ID = PMO_CNST.SC_INACTIVE_ADM_TASK THEN T.TYPE_ID
      WHEN A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
      ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
      T.RANK, T.PARENT_ID,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
      T.ELEMENT_NAME, ' ' AS ACTIVE, T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SD         else A.SD           end as SD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.START_DT   else A.START_DT     end as START_DT,
      case when A.TSK_ASSIGNMENT_ID IS null OR T.FD = PMO_CNST.SC_AF then T.FD         else A.FD           end as FD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FINISH_DT  else A.FINISH_DT    end as FINISH_DT,
      W.MINUTE_PER_DAY AS MINUTE_PER_DAY,
      case when A.TSK_ASSIGNMENT_ID IS null then T.DURATION           else A.DURATION         end as DURATION,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_START    else A.BASELINE1_START  end as BASELINE_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_FINISH   else A.BASELINE1_FINISH end as BASELINE_FINISH,
      COALESCE(A.BASELINE1_WORK,0) AS BASELINE_WORK,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_START  else A.PLANNED_START  end as PLANNED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_FINISH else A.PLANNED_FINISH end as PLANNED_FINISH,
      COALESCE(A.PLANNED_WORK, 0) AS PLANNED_WORK,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_START  else A.PROPOSED_START  end as PROPOSED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_FINISH else A.PROPOSED_FINISH end as PROPOSED_FINISH,
      COALESCE(A.PROPOSED_WORK,0) AS PROPOSED_WORK,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_START    else A.SCHED_START  end as SCHED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_FINISH   else A.SCHED_FINISH end as SCHED_FINISH,
      COALESCE(A.SCHED_WORK,0) AS SCHED_WORK,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_START   else A.FORECAST_START  end as FORECAST_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_FINISH  else A.FORECAST_FINISH end as FORECAST_FINISH,
      COALESCE(A.ETC, 0) AS ETC,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_START   else A.ACTUAL_START  end as ACTUAL_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_FINISH  else A.ACTUAL_FINISH end as ACTUAL_FINISH,
      COALESCE(A.WORK_TODATE,0) AS ACTUAL_EFFORT,
      COALESCE(A.REGULAR_TODATE,0) AS REGULAR_TODATE,
      COALESCE(A.SPECIAL_TODATE,0) AS SPECIAL_TODATE,
      COALESCE((A.SCHED_WORK+A.PLANNED_WORK-A.WORK_TODATE),0) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      COALESCE((A.SCHED_WORK+A.PLANNED_WORK-A.WORK_TODATE),0) AS REMAINING,
      case when A.TSK_ASSIGNMENT_ID IS null then T.MILESTONE_PERCENT  else /*CASE WHEN A.SCHED_DURATION > 0 THEN INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END*/ -1 end as MILESTONE_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_PERCENT       else A.MILESTONE_PERCENT end as WORK_PERCENT,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET,
      COALESCE(A.BASELINE1_LABOR_COST,0.00) AS BASELINE1_BUDGET,
      COALESCE(A.PLANNED_LABOR_COST,0.00) AS ESTIMATION_BUDGET,
      COALESCE(A.PROPOSED_LABOR_COST,0.00),
      COALESCE((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST),0.00) AS CURRENT_BUDGET,
      COALESCE(A.FORECAST_LABOR_COST,0.00) AS FORECAST_BUDGET,
      COALESCE(A.ACTUAL_LABOR_COST,0.00) AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      COALESCE(A.REGULAR_COST,0.00) AS REGULAR_COST,
      COALESCE(A.SPECIAL_COST,0.00) AS SPECIAL_COST,
      0.00 AS X_R_ESTIMATION_BUDGET,
      COALESCE(A.BASELINE1_LABOR_REVENUE,0.00) AS R_BASELINE1_BUDGET,
      COALESCE(A.PLANNED_LABOR_REVENUE,0.00) AS R_ESTIMATION_BUDGET,
      COALESCE(A.PROPOSED_LABOR_REVENUE,0.00),
      COALESCE((A.SCHED_LABOR_REVENUE+A.PLANNED_LABOR_REVENUE),0.00) AS R_CURRENT_BUDGET,
      COALESCE(A.FORECAST_LABOR_REVENUE,0.00) AS R_FORECAST_BUDGET,
      COALESCE(A.ACTUAL_LABOR_REVENUE,0.00) AS R_ACTUAL_BUDGET,
      ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      COALESCE((A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE),0.00) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      CASE WHEN A.BILLABLE = 1 THEN COALESCE(A.REGULAR_RATE,0.00) ELSE 0.00 END AS REGULAR_RATE,
      COALESCE(A.SPECIAL_RATE,0.00) AS SPECIAL_RATE,
      S.ASSIGN_STRING,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROJECT_ID else A.PROJECT_ID end as PROJECT_ID,
      T.TYPE_ID AS ELEMENT_TYPE_BITS,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
      T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY,
      T.REVISION_TYPE,
      T.REVISION_IMPACT,
      T.LAST_WF_TYPE,
      T.LAST_WF_BY,
      T.LAST_WF_DT,
      RA.RESOURCE_TYPE,
      RA.RESOURCE_ID,
      RA.PARTICIPANT,
      RA.SECURITY_ID,
      T.ASSIGN_COUNT,
      T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.FS_CODE,
      T.STAGE_ID,
      R.FS_LABOR_CODE,
      h_pool_public_flag AS PUBLIC_FLAG ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
      PMO_ORASTD.DB2TIMESTAMP(COALESCE(S.PA_START_DT,h_week_of), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
      case when A.TSK_ASSIGNMENT_ID IS null then 0 else A.UNITS_MSP end AS UNITS_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.MP_STATUS_DT else A.REC_DATETIME end as MP_STATUS_DT,
      
      '' AS RESOURCE_USER_NAME,
      '' AS RESOURCE_LAST_NAME,
      '' AS RESOURCE_GIVEN_NAME,
      '' AS RESOURCE_MIDDLE_NAME,
      '' AS RESOURCE_NICK_NAME,
      '' AS RESOURCE_EMAIL_ADDRESS,
      '' AS RESOURCE_WORK_PHONE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
      '' AS RESOURCE_CALENDAR,
      '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID
      AND T.PROJECT_ID = RA.PROJECT_ID
      AND T.PARENT_ID = h_id
      AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID
      AND W.PROJECT_ID = T.PROJECT_ID
      JOIN TASK_ASSIGNMENTS A ON A.TASK_ID = RA.ELEMENT_ID
      AND A.PROJECT_ID = RA.PROJECT_ID
      AND A.RESOURCE_ID = h_resource_id
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.TSK_ASSIGNMENT_ID
      WHERE RA.RESOURCE_ID = h_resource_id
      AND RA.ELEMENT_ID <> RA.PROJECT_ID
      ORDER BY RANK, PLANNED_START;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_WP_OPEN_PROJECT', 1389+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_RM_WP_OPEN_PROJECT(1390) : views_pool.sql(3487) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN del_items;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 1398+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(1399) : views_pool.sql(3496) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_WP_OPEN_PROJECT', 1410+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_WP_OPEN_PROJECT(1411) : views_pool.sql(3508) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_WP_OPEN_PROJECT;
ALTER FUNCTION FC_RM_WP_OPEN_PROJECT COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_RM_RES_PRJ_ASSIGNMENTS ==
CREATE OR REPLACE FUNCTION FC_RM_RES_PRJ_ASSIGNMENTS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_pool_level_id PLS_INTEGER := 0;
   h_pool_public_flag VARCHAR2(1);
   h_temp_table_name VARCHAR2(255);
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_reg_rate NUMBER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_project_id VARCHAR2(32);
   h_include_participant PLS_INTEGER := 0;
   h_include_unpublished_prj PLS_INTEGER := 0;
   h_week_of DATE;
   h_null_id VARCHAR2(32);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0003c PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_RES_PRJ_ASSIGNMENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_RES_PRJ_ASSIGNMENTS'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_RES_PRJ_ASSIGNMENTS(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RES_PRJ_ASSIGNMENTS', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_RES_PRJ_ASSIGNMENTS(38) : views_pool.sql(3562) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RES_PRJ_ASSIGNMENTS', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RES_PRJ_ASSIGNMENTS(49) : views_pool.sql(3573) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   h_include_participant := 0;
   
   BEGIN
      SELECT LEVEL_ID, PUBLIC_FLAG
      INTO h_pool_level_id, h_pool_public_flag
      FROM TMT_POOLS
      WHERE ELEMENT_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RES_PRJ_ASSIGNMENTS', 68+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RES_PRJ_ASSIGNMENTS(69) : views_pool.sql(3593) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_project_id := NULL;
   h_temp_bitflag := 0;
   h_include_unpublished_prj := 1;
   h_temp_sc_state := FC_ROLLUP_PROJECTS(h_resource_id, h_project_id, h_rank, h_nick_name
                                      , h_temp_bitflag, h_active_record, h_include_participant
                                      , h_include_unpublished_prj);
   
   h_null_id := NULL;
   h_temp_sc_state := FC_PRJ_ASSIGN_STRING(h_resource_id, h_id, h_null_id, h_null_id, h_week_of, 1);
   
   --trace_printf("\n CR0003c \n");
   
   OPEN CR0003c FOR SELECT  --Project level (work-assigned) for the selected resource
   h_pool_level_id + 1 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE,
   1 AS CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   T.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   0 AS ACTUAL_EFFORT,
   0 AS REGULAR_TODATE,
   0 AS SPECIAL_TODATE,
   0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG,
   0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   T.SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET,
   0.00 AS ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET,
   0.00 AS FORECAST_BUDGET,
   0.00 AS ACTUAL_BUDGET,
   0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE,
   0.00 AS REGULAR_COST,
   0.00 AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET,
   0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_REVENUE,
   0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET,
   0.00 R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING,
   0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   0.00 AS REGULAR_RATE,
   0.00 AS SPECIAL_RATE,
   '' AS ASSIGN_STRING,
   T.PROJECT_ID AS PROJECT_ID,
   T.TYPE_ID AS ELEMENT_TYPE_BITS,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
   T.MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   R.RESOURCE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   0 AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   R.FS_CODE,
   T.STAGE_ID,
   R.FS_LABOR_CODE,
   '0' AS PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY, h_week_of AS TA_START_DT
   FROM TMT_WBS T
   JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
   WHERE T.ELEMENT_ID = h_id
   AND T.REC_STATUS <> 'D'
   
   UNION ALL
   
   SELECT  -- SUB Project level (work-assigned) for the selected resource
   h_pool_level_id + 2 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
   A.TASK_COUNT AS CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   
   CASE
   WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.SD
   WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.ACTUAL_START = A.START_DT) THEN PMO_CNST.SC_AS
   WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
   WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
   ELSE PMO_CNST.SC_NS
   END AS SD,
   
   CASE
   WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.START_DT
   ELSE A.START_DT
   END AS START_DT,
   
   CASE
   when A.FD = PMO_CNST.SC_AF then A.FD
   WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FD
   WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
   WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
   WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
   WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
   ELSE PMO_CNST.SC_SF
   END AS FD,
   
   CASE
   WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FINISH_DT
   ELSE A.FINISH_DT
   END AS FINISH_DT,
   
   T.MINUTE_PER_DAY AS MINUTE_PER_DAY,
   -1 AS DURATION,
   
   A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE_WORK,
   A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT AS PLANNED_WORK,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT AS PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT AS SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH,
   A.WORK_TODATE AS ACTUAL_EFFORT,
   0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
   ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN A.ETC = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   
   CASE WHEN A.SCHED_EFFORT > 0 THEN (A.SCHED_EFFORT - A.WORK_TODATE)
   WHEN A.PLANNED_EFFORT > 0 THEN (A.PLANNED_EFFORT - A.WORK_TODATE)
   ELSE 0 END AS REMAINING,
   
   -1 AS MILESTONE_PERCENT,
   A.WORK_PERCENT,
   T.SUBPROJECT_COUNT,
   A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
   A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
   A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   A.SCHED_LABOR_COST_RATE AS REGULAR_COST,
   0.00 AS SPECIAL_COST,
   
   A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
   A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
   A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
   A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
   A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   A.SCHED_LABOR_REVENUE_RATE AS REGULAR_RATE,
   0.00 AS SPECIAL_RATE,
   
   '' AS ASSIGN_STRING,
   A.PROJECT_ID AS PROJECT_ID,
   0 AS ELEMENT_TYPE_BITS,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   A.RESOURCE_ID AS RESOURCE_ID,
   PA.PARTICIPANT,
   COALESCE(PA.SECURITY_ID,'') AS SECURITY_ID,
   BITAND(PA.ELEMENT_TYPE_BITS, 62) AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   R.FS_CODE,
   T.STAGE_ID,
   R.FS_LABOR_CODE,
   P.PUBLIC_FLAG ,
   
   A.EST_SCHED_START AS ESTIMATED_SCHED_START,
   A.EST_SCHED_FINISH AS ESTIMATED_SCHED_FINISH,
   A.EST_SCHED_EFFORT AS ESTIMATED_SCHED_EFFORT,
   A.EST_SCHED_COST AS ESTIMATED_SCHED_COST,
   A.EST_SCHED_REVENUE AS ESTIMATED_SCHED_REVENUE,
   
   A.EST_PLANNED_START AS ESTIMATED_PLANNED_START,
   A.EST_PLANNED_FINISH AS ESTIMATED_PLANNED_FINISH,
   A.EST_PLANNED_EFFORT AS ESTIMATED_PLANNED_EFFORT,
   A.EST_PLANNED_COST AS ESTIMATED_PLANNED_COST,
   A.EST_PLANNED_REVENUE AS ESTIMATED_PLANNED_REVENUE,
   
   A.LEVEL_PLANNED_START AS LEVEL_PLANNED_START,
   A.LEVEL_PLANNED_FINISH AS LEVEL_PLANNED_FINISH,
   A.LEVEL_SCHED_START AS LEVEL_SCHED_START,
   A.LEVEL_SCHED_FINISH AS LEVEL_SCHED_FINISH,
   ''                       AS LEVEL_ASSIGN_STRING,
   A.LEVEL_START           AS LEVEL_START,
   A.LEVEL_FINISH          AS LEVEL_FINISH,
   A.EST_BASELINE1_START AS ESTIMATED_BASELINE1_START,
   A.EST_BASELINE1_FINISH AS ESTIMATED_BASELINE1_FINISH,
   A.EST_BASELINE1_EFFORT AS ESTIMATED_BASELINE1_EFFORT,
   A.EST_BASELINE1_COST AS ESTIMATED_BASELINE1_COST,
   A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE1_REVENUE,
   A.EST_BASELINE1_START AS ESTIMATED_BASELINE3_START,
   A.EST_BASELINE1_FINISH AS ESTIMATED_BASELINE3_FINISH,
   A.EST_BASELINE1_EFFORT AS ESTIMATED_BASELINE3_EFFORT,
   A.EST_BASELINE1_COST AS ESTIMATED_BASELINE3_COST,
   A.EST_BASELINE1_REVENUE AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   A.MP_STATUS_DT,
   
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY, h_week_of AS TA_START_DT
   
   FROM TMT_POOLS P
   JOIN VP_MWP_TM_2 A ON A.RESOURCE_ID = P.ELEMENT_ID
   JOIN PROJECT_ASSIGNMENTS PA    ON PA.RESOURCE_ID = A.RESOURCE_ID AND PA.PROJECT_ID = A.PROJECT_ID
   JOIN TMT_WBS T  ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.PROJECT_ID AND T.REC_STATUS <> 'D'
   JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
   WHERE P.ELEMENT_ID = h_resource_id
   
   UNION ALL
   
   SELECT  --Task Level (Work-assigned) for the selected resource
   h_pool_level_id + 2 AS LEVEL_ID,
   CASE    WHEN T.TYPE_ID = PMO_CNST.SC_ACTIVE_ADM_TASK OR T.TYPE_ID = PMO_CNST.SC_INACTIVE_ADM_TASK THEN T.TYPE_ID
   WHEN T.TYPE_ID = PMO_CNST.SC_PERSONAL_TASK or A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
   ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
   T.RANK, T.PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
   T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   A.SD, A.START_DT, A.FD, A.FINISH_DT,
   W.MINUTE_PER_DAY AS MINUTE_PER_DAY, A.DURATION,
   A.BASELINE1_START, A.BASELINE1_FINISH,
   (A.BASELINE1_WORK) AS BASELINE_WORK, A.PLANNED_START, A.PLANNED_FINISH,
   (A.PLANNED_WORK) AS PLANNED_WORK, A.PROPOSED_START, A.PROPOSED_FINISH,
   (A.PROPOSED_WORK) AS PROPOSED_WORK, A.SCHED_START, A.SCHED_FINISH,
   (A.SCHED_WORK) AS SCHED_WORK, A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC, A.ACTUAL_START, A.ACTUAL_FINISH,
   (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   CASE WHEN A.SCHED_WORK > 0 THEN (A.SCHED_WORK - A.WORK_TODATE) WHEN A.PLANNED_WORK > 0 THEN (A.PLANNED_WORK - A.WORK_TODATE) ELSE 0 END AS REMAINING,
   
   CASE WHEN A.SCHED_DURATION > 0 THEN -1 ELSE T.MILESTONE_PERCENT END AS MILESTONE_PERCENT,
   COALESCE(A.MILESTONE_PERCENT, T.WORK_PERCENT) AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   
   0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   A.REGULAR_COST AS REGULAR_COST, A.SPECIAL_COST AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   
   CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REGULAR_RATE,
   
   A.SPECIAL_RATE AS SPECIAL_RATE,
   S.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
   A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID,
   T.ASSIGN_COUNT, T.ASSIGN_NAMES,
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
   R.FS_CODE,
   T.STAGE_ID, R.FS_LABOR_CODE,
   h_pool_public_flag AS PUBLIC_FLAG ,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
   S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
   PMO_ORASTD.DB2TIMESTAMP(COALESCE(S.PA_START_DT,h_week_of), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
   A.LEVEL_FINISH          AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   A.UNITS_MSP AS UNITS_PERCENT,
   A.REC_DATETIME          AS MP_STATUS_DT,
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
   
   FROM TASK_ASSIGNMENTS A
   JOIN RESOURCE_ASSIGNMENTS RA ON RA.PROJECT_ID = A.PROJECT_ID
   AND RA.ELEMENT_ID = A.TASK_ID
   AND RA.RESOURCE_ID = A.RESOURCE_ID
   JOIN TMT_WBS T
   ON T.ELEMENT_ID = A.TASK_ID
   JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID
   AND W.PROJECT_ID = T.PROJECT_ID
   JOIN RESOURCES R
   ON R.RESOURCE_ID = T.REC_USER
   JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.TSK_ASSIGNMENT_ID
   WHERE A.RESOURCE_ID = h_resource_id
   AND A.PROJECT_ID = h_id
   AND A.TASK_ID <> A.PROJECT_ID
   ORDER BY RANK, PLANNED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RES_PRJ_ASSIGNMENTS', 499+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_RES_PRJ_ASSIGNMENTS(500) : views_pool.sql(4024) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0003c;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RES_PRJ_ASSIGNMENTS', 507+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RES_PRJ_ASSIGNMENTS(508) : views_pool.sql(4032) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RES_PRJ_ASSIGNMENTS', 519+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RES_PRJ_ASSIGNMENTS(520) : views_pool.sql(4044) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_RES_PRJ_ASSIGNMENTS;
ALTER FUNCTION FC_RM_RES_PRJ_ASSIGNMENTS COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_S_VP_008 ==
CREATE OR REPLACE FUNCTION FC_S_VP_008
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pool_level_id PLS_INTEGER := 0;
   h_pool_public_flag VARCHAR2(1);
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_table_name VARCHAR2(255);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0005b PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VP_008') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VP_008'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VP_008(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_nick_name || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_008', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VP_008(26) : views_pool.sql(4086) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("5.2______*****\n");
   
   -- Fetch required TMT_POOLS information
   BEGIN
      SELECT LEVEL_ID, PUBLIC_FLAG
      INTO h_pool_level_id, h_pool_public_flag
      FROM TMT_POOLS
      WHERE ELEMENT_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_008', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_008(43) : views_pool.sql(4103) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR0005b \n");
   
   OPEN CR0005b FOR SELECT  --Deliverable Level (work-assigned + Participant) for the selected resource ,
   h_pool_level_id + 1 AS LEVEL_ID, T.TYPE_ID,  T.RANK, T.PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   0 AS ACTUAL_EFFORT,
   0 AS REGULAR_TODATE,
   0 AS SPECIAL_TODATE,
   0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG,
   0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET,
   0.00 AS ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET,
   0.00 AS FORECAST_BUDGET,
   0.00 AS ACTUAL_BUDGET,
   0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE,
   0.00 AS REGULAR_COST,
   0.00 AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET,
   0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_REVENUE,
   0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET,
   0.00 AS R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING,
   0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   0.00 AS REGULAR_RATE,
   0.00 AS SPECIAL_RATE,
   '' AS ASSIGN_STRING,
   T.PROJECT_ID,
   T.TYPE_ID AS ELEMENT_TYPE_BITS,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
   T.MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DT,
   RA.RESOURCE_TYPE,
   RA.RESOURCE_ID,
   RA.PARTICIPANT,
   RA.SECURITY_ID,
   T.ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   R.FS_CODE,
   T.STAGE_ID,
   R.FS_LABOR_CODE,
   h_pool_public_flag AS PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00')  AS MP_STATUS_DT,
   
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY
   
   FROM TMT_WBS T
   JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
   LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA
   ON RA.ELEMENT_ID = T.ELEMENT_ID
   AND RA.RESOURCE_ID = h_resource_id
   WHERE  T.ELEMENT_ID = h_id
   
   UNION ALL
   
   SELECT  --Task Level (Work-assigned + Participant) for the selected resource
   h_pool_level_id + 2 LEVEL_ID,
   case when A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
   T.RANK, T.PARENT_ID,
   case when A.TSK_ASSIGNMENT_ID IS null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE, T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   case when A.TSK_ASSIGNMENT_ID IS null then T.SD         else A.SD           end as SD,
   case when A.TSK_ASSIGNMENT_ID IS null then T.START_DT   else A.START_DT     end as START_DT,
   case when A.TSK_ASSIGNMENT_ID IS null OR T.FD = PMO_CNST.SC_AF then T.FD         else A.FD           end as FD,
   case when A.TSK_ASSIGNMENT_ID IS null then T.FINISH_DT  else A.FINISH_DT    end as FINISH_DT,
   W.MINUTE_PER_DAY AS MINUTE_PER_DAY,
   case when A.TSK_ASSIGNMENT_ID IS null then T.DURATION           else A.DURATION         end as DURATION,
   case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_START    else A.BASELINE1_START  end as BASELINE_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_FINISH   else A.BASELINE1_FINISH end as BASELINE_FINISH,
   COALESCE(A.BASELINE1_WORK,0) AS BASELINE_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_START  else A.PLANNED_START  end as PLANNED_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_FINISH else A.PLANNED_FINISH end as PLANNED_FINISH,
   COALESCE(A.PLANNED_WORK, 0) AS PLANNED_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_START  else A.PROPOSED_START  end as PROPOSED_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_FINISH else A.PROPOSED_FINISH end as PROPOSED_FINISH,
   COALESCE(A.PROPOSED_WORK,0) AS PROPOSED_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_START    else A.SCHED_START  end as SCHED_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_FINISH   else A.SCHED_FINISH end as SCHED_FINISH,
   COALESCE(A.SCHED_WORK,0) AS SCHED_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_START   else A.FORECAST_START  end as FORECAST_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_FINISH  else A.FORECAST_FINISH end as FORECAST_FINISH,
   COALESCE(A.ETC, 0) AS ETC,
   case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_START   else A.ACTUAL_START  end as ACTUAL_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_FINISH  else A.ACTUAL_FINISH end as ACTUAL_FINISH,
   COALESCE(A.WORK_TODATE,0) AS ACTUAL_EFFORT,
   COALESCE(A.REGULAR_TODATE,0) AS REGULAR_TODATE,
   COALESCE(A.SPECIAL_TODATE,0) AS SPECIAL_TODATE,
   COALESCE((A.SCHED_WORK+A.PLANNED_WORK-A.WORK_TODATE),0) AS REMAINING_EFFORT,
   CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   COALESCE((A.SCHED_WORK+A.PLANNED_WORK-A.WORK_TODATE),0) AS REMAINING,
   case when A.TSK_ASSIGNMENT_ID IS null then T.MILESTONE_PERCENT  else CASE WHEN A.SCHED_DURATION > 0 THEN Trunc((PMO_ORASTD.TODECIMAL(A.ACTUAL_DURATION)/PMO_ORASTD.TODECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END end as MILESTONE_PERCENT,
   case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_PERCENT       else A.MILESTONE_PERCENT end as WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   COALESCE(A.BASELINE1_LABOR_COST,0.00) AS BASELINE1_BUDGET,
   COALESCE(A.PLANNED_LABOR_COST,0.00) AS ESTIMATION_BUDGET,
   COALESCE(A.PROPOSED_LABOR_COST,0.00),
   COALESCE((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST),0.00) AS CURRENT_BUDGET,
   COALESCE(A.FORECAST_LABOR_COST,0.00) AS FORECAST_BUDGET,
   COALESCE(A.ACTUAL_LABOR_COST,0.00) AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   COALESCE(A.REGULAR_COST,0.00) AS REGULAR_COST,
   COALESCE(A.SPECIAL_COST,0.00) AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET,
   COALESCE(A.BASELINE1_LABOR_REVENUE,0.00) AS R_BASELINE1_BUDGET,
   COALESCE(A.PLANNED_LABOR_REVENUE,0.00) AS R_ESTIMATION_BUDGET,
   COALESCE(A.PROPOSED_LABOR_REVENUE,0.00),
   COALESCE((A.SCHED_LABOR_REVENUE+A.PLANNED_LABOR_REVENUE),0.00) AS R_CURRENT_BUDGET,
   COALESCE(A.FORECAST_LABOR_REVENUE,0.00) AS R_FORECAST_BUDGET,
   COALESCE(A.ACTUAL_LABOR_REVENUE,0.00) AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   COALESCE((A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE),0.00) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   CASE WHEN A.BILLABLE = 1 THEN COALESCE(A.REGULAR_RATE,0.00) ELSE 0.00 END AS REGULAR_RATE,
   COALESCE(A.SPECIAL_RATE,0.00) AS SPECIAL_RATE,
   A.ASSIGN_STRING,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PROJECT_ID else A.PROJECT_ID end as PROJECT_ID,
   T.TYPE_ID AS ELEMENT_TYPE_BITS,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
   T.MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   T.LAST_WF_TYPE,
   T.LAST_WF_BY,
   T.LAST_WF_DT,
   RA.RESOURCE_TYPE,
   RA.RESOURCE_ID,
   RA.PARTICIPANT,
   RA.SECURITY_ID,
   T.ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   R.FS_CODE,
   T.STAGE_ID,
   R.FS_LABOR_CODE,
   h_pool_public_flag AS PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
   A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
   A.LEVEL_START           AS LEVEL_START,
   A.LEVEL_FINISH          AS LEVEL_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   case when A.TSK_ASSIGNMENT_ID IS null then 0 else A.UNITS_MSP end AS UNITS_PERCENT,
   case when A.TSK_ASSIGNMENT_ID IS null then T.MP_STATUS_DT else A.REC_DATETIME end as MP_STATUS_DT,
   
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY
   FROM RESOURCE_ASSIGNMENTS RA
   JOIN TMT_WBS T
   ON T.ELEMENT_ID = RA.ELEMENT_ID
   AND T.PARENT_ID = h_id
   AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = T.PROJECT_ID
   JOIN RESOURCES R
   ON R.RESOURCE_ID = T.REC_USER
   LEFT OUTER JOIN TASK_ASSIGNMENTS A
   ON RA.RES_ASSIGNMENT_ID = A.RES_ASSIGNMENT_ID
   WHERE RA.RESOURCE_ID = h_resource_id
   AND RA.ELEMENT_ID <> RA.PROJECT_ID
   ORDER BY RANK, PLANNED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VP_008', 336+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VP_008(337) : views_pool.sql(4397) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0005b;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_008', 344+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_008(345) : views_pool.sql(4405) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VP_008', 356+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VP_008(357) : views_pool.sql(4417) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VP_008;
ALTER FUNCTION FC_S_VP_008 COMPILE DEBUG;

/* ******************************************************************************* */

-- Pool Admin View --> Pool Resource List Menu --> resource level -->returns all

-- the tasks assigned to the selected resource

/* ******************************************************************************* */

Prompt == FUNCTION FC_RM_RESOURCE_ASSIGNMENTS ==
CREATE OR REPLACE FUNCTION FC_RM_RESOURCE_ASSIGNMENTS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_pool_level_id PLS_INTEGER := 0;
   h_pool_public_flag VARCHAR2(1);
   h_project_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_week_of DATE;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0006a PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_RESOURCE_ASSIGNMENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_RESOURCE_ASSIGNMENTS'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_RESOURCE_ASSIGNMENTS(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_nick_name || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RESOURCE_ASSIGNMENTS', 24+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_RESOURCE_ASSIGNMENTS(25) : views_pool.sql(4464) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_ASSIGNMENTS', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_ASSIGNMENTS(36) : views_pool.sql(4475) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   h_project_id := NULL;
   h_temp_sc_state := FC_PRJ_ASSIGN_STRING(h_resource_id, h_project_id, h_project_id, h_project_id
                                        , h_week_of, 1);
   
   -- Fetch required TMT_POOLS information
   BEGIN
      SELECT LEVEL_ID, PUBLIC_FLAG
      INTO h_pool_level_id, h_pool_public_flag
      FROM TMT_POOLS
      WHERE ELEMENT_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_ASSIGNMENTS', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_ASSIGNMENTS(59) : views_pool.sql(4498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_resource_id:%s", h_resource_id);
   
   --trace_printf("\n CR0006a \n");
   
   OPEN CR0006a FOR SELECT  --Resource Level
   T.LEVEL_ID, 13 AS TYPE_ID, '----' AS RANK, T.PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, R.ACTIVE,
   
   CASE WHEN EXISTS (SELECT A.RESOURCE_ID
   FROM PROJECT_ASSIGNMENTS A, TMT_WBS P
   WHERE A.RESOURCE_ID = T.ELEMENT_ID
   AND P.PROJECT_ID = A.PROJECT_ID
   AND P.ELEMENT_ID = A.PROJECT_ID
   AND P.REC_STATUS <> 'D'
   AND (A.PROPOSED_WORK + A.ESTIMATED_PLANNED_EFFORT + A.ESTIMATED_SCHED_EFFORT) > 0
   AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3,PMO_CNST.SC_RESOURCE)) THEN 1 ELSE 0 END CHILD_COUNT,
   
   T.DELETED_COUNT, R.REC_STATUS, R.REC_USER,
   '' AS REC_USER_NAME,
   R.REC_DATETIME,
   0 AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   0 AS ACTUAL_EFFORT,
   0 AS REGULAR_TODATE,
   0 AS SPECIAL_TODATE,
   0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG,
   0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET,
   0.00 AS ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET,
   0.00 AS FORECAST_BUDGET,
   0.00 AS ACTUAL_BUDGET,
   0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE,
   0.00 AS BASELINE_VARIANCE,
   
   (SELECT REGULAR_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_COST,
   (SELECT SPECIAL_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_COST,
   
   0.00 AS X_R_ESTIMATION_BUDGET,
   0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET,
   0.00 AS PROPOSED_LABOR_REVENUE,
   0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET,
   0.00 AS R_ACTUAL_BUDGET,
   0.00 AS R_REMAINING,
   0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   
   (SELECT REGULAR_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_RATE,
   (SELECT SPECIAL_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_RATE,
   
   '' AS ASSIGN_STRING,
   '' AS PROJECT_ID,
   13 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   0 AS REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   T.REVISION_TYPE,
   T.REVISION_IMPACT,
   '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   R.RESOURCE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   T.CHILD_COUNT AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   CASE WHEN R.CALENDAR_ID IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
   R.FS_CODE AS    ,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE,
   T.PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   
   R.LOGON_NAME    AS  RESOURCE_USER_NAME,
   R.LAST_NAME     AS  RESOURCE_LAST_NAME,
   R.FIRST_NAME    AS  RESOURCE_GIVEN_NAME,
   R.MIDDLE_NAME   AS  RESOURCE_MIDDLE_NAME,
   R.NICK_NAME     AS  RESOURCE_NICK_NAME,
   R.E_MAIL_ADDRESS AS RESOURCE_EMAIL_ADDRESS,
   R.WORK_PHONE    AS  RESOURCE_WORK_PHONE,
   R.EFFECTIVE_DATE AS RESOURCE_EFFECTIVE_DATE,
   R.DISCONTINUE_DATE AS   RESOURCE_DISCONTINUE_DATE,
   (SELECT ELEMENT_NAME  FROM TMT_CALENDARS WHERE ELEMENT_ID = R.CALENDAR_ID) AS   RESOURCE_CALENDAR,
   (SELECT DESCRIPTION FROM TMT_DATAFIELDS WHERE ELEMENT_ID = R.CURRENCY_ID)   AS  RESOURCE_CURRENCY,
   h_week_of AS TA_START_DT
   
   FROM TMT_POOLS T
   JOIN RESOURCES R ON R.RESOURCE_ID = T.ELEMENT_ID
   WHERE T.ELEMENT_ID = h_resource_id
   
   UNION ALL
   
   SELECT  --Task Level (Work-assigned + Participant) for the selected resource
   h_pool_level_id + 1 LEVEL_ID,
   case    WHEN T.TYPE_ID = PMO_CNST.SC_ACTIVE_ADM_TASK OR T.TYPE_ID = PMO_CNST.SC_INACTIVE_ADM_TASK THEN T.TYPE_ID
   WHEN T.TYPE_ID = PMO_CNST.SC_PERSONAL_TASK or A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
   WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
   ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
   T.RANK, T.PARENT_ID,
   case when A.TSK_ASSIGNMENT_ID IS null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE, T.CHILD_COUNT, T.DELETED_COUNT,  T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   case when A.TSK_ASSIGNMENT_ID IS null then T.SD         else A.SD           end as SD,
   case when A.TSK_ASSIGNMENT_ID IS null then T.START_DT   else A.START_DT     end as START_DT,
   case when A.TSK_ASSIGNMENT_ID IS null then T.FD         else A.FD           end as FD,
   case when A.TSK_ASSIGNMENT_ID IS null then T.FINISH_DT  else A.FINISH_DT    end as FINISH_DT,
   W.MINUTE_PER_DAY AS MINUTE_PER_DAY,
   case when A.TSK_ASSIGNMENT_ID IS null then  T.DURATION          else A.DURATION         end as DURATION,
   case when A.TSK_ASSIGNMENT_ID IS null then  T.BASELINE1_START   else A.BASELINE1_START  end as BASELINE_START,
   case when A.TSK_ASSIGNMENT_ID IS null then  T.BASELINE1_FINISH  else A.BASELINE1_FINISH end as BASELINE_FINISH,
   COALESCE(A.BASELINE1_WORK,0) AS BASELINE_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_START  else A.PLANNED_START    end as PLANNED_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_FINISH else A.PLANNED_FINISH   end as PLANNED_FINISH,
   COALESCE(A.PLANNED_WORK,0) AS PLANNED_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_START  else A.PROPOSED_START  end as PROPOSED_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_FINISH else A.PROPOSED_FINISH end as PROPOSED_FINISH,
   COALESCE(A.PROPOSED_WORK,0) AS PROPOSED_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_START  else A.SCHED_START    end as SCHED_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_FINISH else A.SCHED_FINISH   end as SCHED_FINISH,
   COALESCE(A.SCHED_WORK,0) AS SCHED_WORK,
   case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_START  else A.FORECAST_START   end as FORECAST_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_FINISH else A.FORECAST_FINISH  end as FORECAST_FINISH,
   COALESCE(A.ETC,0) AS ETC,
   case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_START   else A.ACTUAL_START     end as ACTUAL_START,
   case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_FINISH  else A.ACTUAL_FINISH    end as ACTUAL_FINISH,
   COALESCE(A.WORK_TODATE,0) AS ACTUAL_EFFORT,
   COALESCE(A.REGULAR_TODATE,0) AS REGULAR_TODATE,
   COALESCE(A.SPECIAL_TODATE,0) AS SPECIAL_TODATE,
   COALESCE((A.SCHED_WORK+A.PLANNED_WORK-A.WORK_TODATE),0) AS REMAINING_EFFORT,
   CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   COALESCE(CASE WHEN A.SCHED_WORK > 0 THEN (A.SCHED_WORK - A.WORK_TODATE) WHEN A.PLANNED_WORK > 0 THEN (A.PLANNED_WORK - A.WORK_TODATE) ELSE 0 END, 0) AS REMAINING,
   case when A.TSK_ASSIGNMENT_ID IS null then T.MILESTONE_PERCENT  else /*CASE WHEN A.SCHED_DURATION > 0 THEN INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END*/ -1 end as MILESTONE_PERCENT,
   case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_PERCENT       else A.MILESTONE_PERCENT end as WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   COALESCE(A.BASELINE1_LABOR_COST,0.00) AS BASELINE1_BUDGET,
   COALESCE(A.PLANNED_LABOR_COST,0.00) AS ESTIMATION_BUDGET,
   COALESCE(A.PROPOSED_LABOR_COST,0.00),
   COALESCE((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST),0.00) AS CURRENT_BUDGET,
   COALESCE(A.FORECAST_LABOR_COST,0.00) AS FORECAST_BUDGET,
   COALESCE(A.ACTUAL_LABOR_COST,0.00) AS ACTUAL_BUDGET,
   ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS BUDGET_REMAINING,
   (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   COALESCE(A.REGULAR_COST,0.00) AS REGULAR_COST,
   COALESCE(A.SPECIAL_COST,0.00) AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET,
   COALESCE(A.BASELINE1_LABOR_REVENUE,0.00) AS R_BASELINE1_BUDGET,
   COALESCE(A.PLANNED_LABOR_REVENUE,0.00) AS R_ESTIMATION_BUDGET,
   COALESCE(A.PROPOSED_LABOR_REVENUE,0.00),
   COALESCE((A.SCHED_LABOR_REVENUE+A.PLANNED_LABOR_REVENUE),0.00) AS R_CURRENT_BUDGET,
   COALESCE(A.FORECAST_LABOR_REVENUE,0.00) AS R_FORECAST_BUDGET,
   COALESCE(A.ACTUAL_LABOR_REVENUE,0.00) AS R_ACTUAL_BUDGET,
   ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
   COALESCE((A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE),0.00) AS R_BUDGET_FORECAST_VARIANCE,
   CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   CASE WHEN A.BILLABLE = 1 THEN COALESCE(A.REGULAR_RATE,0.00) ELSE 0.00 END AS REGULAR_RATE,
   COALESCE(A.SPECIAL_RATE,0.00) AS SPECIAL_RATE,
   S.ASSIGN_STRING,
   case when A.TSK_ASSIGNMENT_ID IS null then T.PROJECT_ID else A.PROJECT_ID end as PROJECT_ID,
   T.TYPE_ID AS ELEMENT_TYPE_BITS,
   (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
   T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
   RA.RESOURCE_TYPE, RA.RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID,  T.ASSIGN_COUNT,  T.ASSIGN_NAMES,
   CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
   '' AS CALENDAR_FLAG,
   R.FS_CODE AS FS_CODE,
   T.STAGE_ID, R.FS_LABOR_CODE,
   h_pool_public_flag AS PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
   S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
   PMO_ORASTD.DB2TIMESTAMP(COALESCE(S.PA_START_DT,h_week_of), PMO_ORASTD.TIME('08:00')) AS LEVEL_START,
   A.LEVEL_FINISH          AS LEVEL_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   case when A.TSK_ASSIGNMENT_ID IS null then 0 else A.UNITS_MSP end as UNITS_PERCENT,
   COALESCE(A.REC_DATETIME, T.MP_STATUS_DT) AS MP_STATUS_DT,
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY, COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
   FROM RESOURCE_ASSIGNMENTS RA
   JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID
   AND T.PROJECT_ID = RA.PROJECT_ID
   AND T.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
   JOIN TMT_WBS W
   ON W.ELEMENT_ID = T.PROJECT_ID
   AND W.PROJECT_ID = T.PROJECT_ID
   AND W.REC_STATUS <> 'D'
   JOIN RESOURCES R
   ON R.RESOURCE_ID = T.REC_USER
   JOIN TASK_ASSIGNMENTS A ON A.PROJECT_ID = T.PROJECT_ID
   AND A.TASK_ID = T.ELEMENT_ID
   AND A.RESOURCE_ID = h_resource_id
   JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = A.TSK_ASSIGNMENT_ID
   WHERE RA.RESOURCE_ID = h_resource_id
   AND RA.ELEMENT_ID <> RA.PROJECT_ID
   ORDER BY RANK, PLANNED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RESOURCE_ASSIGNMENTS', 366+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_RESOURCE_ASSIGNMENTS(367) : views_pool.sql(4806) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0006a;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_ASSIGNMENTS', 374+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_ASSIGNMENTS(375) : views_pool.sql(4814) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_ASSIGNMENTS', 386+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_ASSIGNMENTS(387) : views_pool.sql(4826) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_RESOURCE_ASSIGNMENTS;
ALTER FUNCTION FC_RM_RESOURCE_ASSIGNMENTS COMPILE DEBUG;

/* ******************************************************************************** */

-- This function returns all the pools generated by the current user

-- at pool level there is no need to calculate anything just the default values

-- will be return to the client

/* ******************************************************************************** */

Prompt == FUNCTION FC_RM_POOL_LIST ==
CREATE OR REPLACE FUNCTION FC_RM_POOL_LIST
(
     h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_week_of DATE;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0007 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_POOL_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_POOL_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_POOL_LIST(' || 
       '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_POOL_LIST', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_POOL_LIST(20) : views_pool.sql(4870) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_POOL_LIST', 30+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_POOL_LIST(31) : views_pool.sql(4881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   -- at the pool level just return default value to the client (no need to any calculations)
   
   --trace_printf("\n h_resource_id:%s", h_resource_id);
   --trace_printf("\n CR0007 \n");
   
   OPEN CR0007 FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, h_resource_id AS PARENT_ID,
   T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, 0 AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,       TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,     TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   0 AS ACTUAL_EFFORT,
   0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE, 0.00 AS REGULAR_COST,
   0.00 AS SPECIAL_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE, 0.00 AS REGULAR_RATE, 0.00 AS SPECIAL_RATE,
   '' AS ASSIGN_STRING, '' AS PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER,
   0 AS MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT, '' AS RESOURCE_TYPE,
   '' AS RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID, T.CHILD_COUNT AS ASSIGN_COUNT,
   T.ASSIGN_NAMES, 'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
   R.FS_CODE AS FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE, T.PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY, h_week_of AS TA_START_DT
   FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS T , RESOURCES R    -- this query returns all the pools in the
   WHERE T.ELEMENT_ID = RA.ELEMENT_ID                         -- TMT_POOLS at the level = 0 that have been
   AND RA.RESOURCE_ID = h_resource_id                 -- generated by h_resource_id (current resource)
   AND BITAND(RA.PARTICIPANT, 2394) > 0
   AND RA.ELEMENT_TYPE = 11
   AND R.RESOURCE_ID = T.REC_USER
   AND NOT EXISTS(SELECT PP.ELEMENT_ID FROM TMT_POOLS PP, RESOURCE_ASSIGNMENTS RR
   WHERE RR.RESOURCE_ID = h_resource_id
   AND PP.ELEMENT_ID = RR.ELEMENT_ID
   AND BITAND(RR.PARTICIPANT, 2394) > 0
   AND RR.ELEMENT_TYPE = 11
   AND PP.LEVEL_ID < T.LEVEL_ID
   AND ((PP.RANK >= SUBSTR(T.RANK, 1, 8) AND PP.RANK <= T.RANK) 
   AND SUBSTR(T.RANK,1, CASE WHEN LENGTH(PP.RANK) > LENGTH(T.RANK) THEN 1 ELSE LENGTH(PP.RANK) END ) = PP.RANK))
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_POOL_LIST', 136+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_POOL_LIST(137) : views_pool.sql(4987) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0007;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_POOL_LIST', 144+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_POOL_LIST(145) : views_pool.sql(4995) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_POOL_LIST', 156+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_POOL_LIST(157) : views_pool.sql(5007) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_POOL_LIST;
ALTER FUNCTION FC_RM_POOL_LIST COMPILE DEBUG;

/****************************************************************************************************************/

Prompt == FUNCTION FC_RM_RESOURCE_LIST ==
CREATE OR REPLACE FUNCTION FC_RM_RESOURCE_LIST
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_family_name IN OUT NOCOPY VARCHAR2
   , sh_h_search_by_name_bitflag PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_search_by_name_bitflag PLS_INTEGER := sh_h_search_by_name_bitflag;
   h_temp_str VARCHAR2(8000);
   h_temp_sc_state PLS_INTEGER := 0;
   h_week_of DATE;
   h_rank VARCHAR2(200);
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00009 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_RESOURCE_LIST') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_RESOURCE_LIST'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_RESOURCE_LIST(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_family_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_search_by_name_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RESOURCE_LIST', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_RESOURCE_LIST(29) : views_pool.sql(5052) : ' || SYSTIMESTAMP);
   END IF; 

   h_temp_str := h_temp_str || '%%';
   h_temp_str := h_temp_str || h_name;
   h_temp_str := h_temp_str || '%%';
   h_name := h_temp_str;
   h_name := h_name;
   
   h_temp_str := h_temp_str || '%%';
   h_temp_str := h_temp_str || h_family_name;
   h_temp_str := h_temp_str || '%%';
   h_family_name := h_temp_str;
   h_family_name := h_family_name;
   
   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_LIST', 51+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_LIST(52) : views_pool.sql(5075) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   h_rank := NULL;
   h_temp_sc_state := FC_RES_ASSIGN_STRING(h_search_by_name_bitflag, h_name, h_family_name, h_rank
                                        , h_resource_id, h_week_of, 0);
   
   --trace_printf("\n h_search_by_name_bitflag:%d", h_search_by_name_bitflag);
   --trace_printf("\n h_resource_id:%s", h_resource_id);
   --trace_printf("\n h_name:%s", h_name);
   --trace_printf("\n h_family_name:%s", h_family_name);
   
   --trace_printf("\n CR00009 \n");
   
   OPEN CR00009 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, R.ACTIVE,
   CASE WHEN S.ELEMENT_ID IS NuLL THEN 0 ELSE 1 END AS CHILD_COUNT,
   T.DELETED_COUNT, R.REC_STATUS, R.REC_USER,
   R1.FULL_NAME AS REC_USER_NAME, R.REC_DATETIME,
   CASE WHEN S.ELEMENT_ID IS NuLL THEN 0 ELSE 1 END AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD, S.START_DT, 0 AS FD, S.FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   S.BASELINE_START, S.BASELINE_FINISH, S.BASELINE_WORK,
   S.PLANNED_START,  S.PLANNED_FINISH,  S.PLANNED_WORK,
   S.PROPOSED_START, S.PROPOSED_FINISH, S.PROPOSED_WORK,
   S.SCHED_START,    S.SCHED_FINISH,    S.SCHED_WORK,
   S.FORECAST_START, S.FORECAST_FINISH, S.ETC,
   S.ACTUAL_START, S.ACTUAL_FINISH, S.WORK_TODATE AS ACTUAL_EFFORT,
   S.REGULAR_TODATE, S.SPECIAL_TODATE, (S.SCHED_WORK + S.PLANNED_WORK - S.WORK_TODATE) AS REMAINING_EFFORT,
   
   0 AS ETC_RED_FLAG, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, S.PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE,
   
   (SELECT REGULAR_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_COST,
   (SELECT SPECIAL_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, S.PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   (SELECT REGULAR_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_RATE,
   (SELECT SPECIAL_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_RATE,
   S.ASSIGN_STRING,
   '' AS PROJECT_ID,
   13 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   0 AS REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(R.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(R.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   R.REVISION_TYPE,
   R.REVISION_IMPACT,
   '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   R.RESOURCE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   0 AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   CASE WHEN R.CALENDAR_ID IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
   R.FS_CODE AS FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE,
   T.PUBLIC_FLAG ,
   S.ESTIMATED_SCHED_START,
   S.ESTIMATED_SCHED_FINISH,
   S.ESTIMATED_SCHED_EFFORT,
   S.ESTIMATED_SCHED_COST,
   S.ESTIMATED_SCHED_REVENUE,
   S.ESTIMATED_PLANNED_START,
   S.ESTIMATED_PLANNED_FINISH,
   S.ESTIMATED_PLANNED_EFFORT,
   S.ESTIMATED_PLANNED_COST,
   S.ESTIMATED_PLANNED_REVENUE,
   S.LEVEL_PLANNED_START,
   S.LEVEL_PLANNED_FINISH,
   S.LEVEL_SCHED_START,
   S.LEVEL_SCHED_FINISH,
   S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
   COALESCE(S.PA_START_DT,h_week_of) AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')  AS LEVEL_FINISH,
   
   S.ESTIMATED_BASELINE1_START,
   S.ESTIMATED_BASELINE1_FINISH,
   S.ESTIMATED_BASELINE1_EFFORT,
   S.ESTIMATED_BASELINE1_COST,
   S.ESTIMATED_BASELINE1_REVENUE,
   
   S.ESTIMATED_BASELINE3_START,
   S.ESTIMATED_BASELINE3_FINISH,
   S.ESTIMATED_BASELINE3_EFFORT,
   S.ESTIMATED_BASELINE3_COST,
   S.ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   
   R.LOGON_NAME    AS  RESOURCE_USER_NAME,
   R.LAST_NAME     AS  RESOURCE_LAST_NAME,
   R.FIRST_NAME    AS  RESOURCE_GIVEN_NAME,
   R.MIDDLE_NAME   AS  RESOURCE_MIDDLE_NAME,
   R.NICK_NAME     AS  RESOURCE_NICK_NAME,
   R.E_MAIL_ADDRESS AS RESOURCE_EMAIL_ADDRESS,
   R.WORK_PHONE    AS  RESOURCE_WORK_PHONE,
   R.EFFECTIVE_DATE AS RESOURCE_EFFECTIVE_DATE,
   R.DISCONTINUE_DATE AS   RESOURCE_DISCONTINUE_DATE,
   (SELECT ELEMENT_NAME  FROM TMT_CALENDARS WHERE ELEMENT_ID = R.CALENDAR_ID) AS   RESOURCE_CALENDAR,
   (SELECT DESCRIPTION FROM TMT_DATAFIELDS WHERE ELEMENT_ID = R.CURRENCY_ID)   AS  RESOURCE_CURRENCY,
   COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
   
   FROM TMT_POOLS TP1 JOIN RESOURCE_ASSIGNMENTS RA ON TP1.TYPE_ID = 11 AND TP1.LEVEL_ID = 0
   AND TP1.ELEMENT_ID = RA.ELEMENT_ID AND RA.RESOURCE_ID = h_resource_id
   AND BITAND(RA.PARTICIPANT, 2394) > 0 AND RA.ELEMENT_TYPE = 11
   JOIN TMT_POOLS T ON T.TYPE_ID = 13 AND ((TP1.RANK >= SUBSTR(T.RANK, 1, 8) AND TP1.RANK <= T.RANK) 
   AND SUBSTR(T.RANK,1, CASE WHEN LENGTH(TP1.RANK) > LENGTH(T.RANK) THEN 1 ELSE LENGTH(TP1.RANK) END ) = TP1.RANK)
   JOIN RESOURCES R ON R.RESOURCE_ID = T.ELEMENT_ID
   AND (h_search_by_name_bitflag = 0 OR
   ((case when h_search_by_name_bitflag = PMO_CNST.SC_RES_BY_FULLNAME AND UPPER(R.FULL_NAME) LIKE UPPER(h_name)  then 1
   when h_search_by_name_bitflag = PMO_CNST.SC_RES_BY_GIVEN_FAMILY_NAME AND UPPER(R.FIRST_NAME) LIKE UPPER(h_name) AND UPPER(R.LAST_NAME) LIKE UPPER(h_family_name) then 1
   else 0 end) = 1))
   JOIN RESOURCES R1 ON R1.RESOURCE_ID = R.REC_USER
   LEFT JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = T.ELEMENT_ID
   
   ORDER BY T.RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_RESOURCE_LIST', 190+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_RESOURCE_LIST(191) : views_pool.sql(5214) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00009;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_LIST', 198+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_LIST(199) : views_pool.sql(5222) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_RESOURCE_LIST', 210+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_RESOURCE_LIST(211) : views_pool.sql(5234) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_RESOURCE_LIST;
ALTER FUNCTION FC_RM_RESOURCE_LIST COMPILE DEBUG;

/*********************************************************************************/

-- this function prepares the list of all resources under a selected pool in pool administration veiw

-- no need to return aggregation data for pool and resources level

Prompt == FUNCTION FC_RM_OPEN_POOL ==
CREATE OR REPLACE FUNCTION FC_RM_OPEN_POOL
(
     sh_h_bitflag PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_temp_sc_state PLS_INTEGER := 0;
   h_week_of DATE;
   h_name VARCHAR2(8000);
   h_family_name VARCHAR2(8000);
   h_search_by_name_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00011 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_OPEN_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_OPEN_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_OPEN_POOL(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_OPEN_POOL', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_OPEN_POOL(30) : views_pool.sql(5284) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_OPEN_POOL', 40+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_OPEN_POOL(41) : views_pool.sql(5295) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_POOLS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_OPEN_POOL', 57+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_OPEN_POOL(58) : views_pool.sql(5312) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_search_by_name_bitflag := PMO_CNST.SC_ALL_RESOURCES;
   h_name := NULL;
   h_family_name := NULL;
   h_temp_sc_state := FC_RES_ASSIGN_STRING(h_search_by_name_bitflag, h_name, h_family_name, h_rank
                                        , h_id, h_week_of, 0);
   
   --trace_printf("\n h_rank:%s \n", h_rank);
   --trace_printf("\n h_id:%s \n", h_id);
   
   --trace_printf("\n CR00011 \n");
   
   OPEN CR00011 FOR SELECT T.LEVEL_ID, 11 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE,
   T.CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, 0 AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,       TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,     TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   0 AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE, 0.00 AS REGULAR_COST,
   0.00 AS SPECIAL_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE, 0.00 AS REGULAR_RATE, 0.00 AS SPECIAL_RATE,
   '' AS ASSIGN_STRING, '' AS PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER,
   0 AS MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT, '' AS RESOURCE_TYPE,
   '' AS RESOURCE_ID,
   (SELECT RA.PARTICIPANT FROM RESOURCE_ASSIGNMENTS RA WHERE RA.ELEMENT_ID = T.ELEMENT_ID
   AND RA.RESOURCE_ID = h_resource_id) AS PARTICIPANT,
   (SELECT RA.SECURITY_ID FROM RESOURCE_ASSIGNMENTS RA WHERE RA.ELEMENT_ID = T.ELEMENT_ID
   AND RA.RESOURCE_ID = h_resource_id) AS SECURITY_ID,
   T.CHILD_COUNT AS ASSIGN_COUNT,
   T.ASSIGN_NAMES, 'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
   R.FS_CODE AS FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE, T.PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''               AS LEVEL_ASSIGN_STRING,
   h_week_of AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY, h_week_of AS TA_START_DT
   
   FROM TMT_POOLS T, RESOURCES R
   WHERE ((T.RANK LIKE h_rank || '%' AND T.PARENT_ID = h_id) OR (T.RANK = h_rank))
   AND T.TYPE_ID IN (PMO_CNST.SC_POOLS, PMO_CNST.SC_USER_GROUP)
   AND R.RESOURCE_ID = T.REC_USER
   
   UNION ALL
   
   SELECT T.LEVEL_ID, 13 AS TYPE_ID,
   T.RANK, h_id AS PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME,
   R.ACTIVE,
   
   CASE WHEN S.ELEMENT_ID IS NuLL THEN 0 ELSE 1 END AS CHILD_COUNT,
   
   T.DELETED_COUNT,
   R.REC_STATUS,
   R.REC_USER,
   R1.FULL_NAME AS REC_USER_NAME,
   R.REC_DATETIME,
   CASE WHEN S.ELEMENT_ID IS NuLL THEN 0 ELSE 1 END AS PRIORITY,
   T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD,
   case when S.ACTUAL_START IS NOT Null then S.ACTUAL_START else S.START_DT end as START_DT,
   0 AS FD, S.FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   S.BASELINE_START, S.BASELINE_FINISH, S.BASELINE_WORK,
   S.PLANNED_START,  S.PLANNED_FINISH,  S.PLANNED_WORK,
   S.PROPOSED_START, S.PROPOSED_FINISH, S.PROPOSED_WORK,
   S.SCHED_START,    S.SCHED_FINISH,    S.SCHED_WORK,
   S.FORECAST_START, S.FORECAST_FINISH, S.ETC,
   S.ACTUAL_START, S.ACTUAL_FINISH, S.WORK_TODATE AS ACTUAL_EFFORT,
   S.REGULAR_TODATE, S.SPECIAL_TODATE, (S.SCHED_WORK + S.PLANNED_WORK - S.WORK_TODATE) AS REMAINING_EFFORT,
   
   0 AS ETC_RED_FLAG, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, S.PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE,
   
   (SELECT REGULAR_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_COST,
   (SELECT SPECIAL_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, S.PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   (SELECT REGULAR_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_RATE,
   (SELECT SPECIAL_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_RATE,
   S.ASSIGN_STRING,
   '' AS PROJECT_ID,
   13 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   0 AS REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(R.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(R.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   R.REVISION_TYPE,
   R.REVISION_IMPACT,
   '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   R.RESOURCE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   0 AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   CASE WHEN R.CALENDAR_ID IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
   R.FS_CODE AS FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE,
   T.PUBLIC_FLAG ,
   S.ESTIMATED_SCHED_START,
   S.ESTIMATED_SCHED_FINISH,
   S.ESTIMATED_SCHED_EFFORT,
   S.ESTIMATED_SCHED_COST,
   S.ESTIMATED_SCHED_REVENUE,
   S.ESTIMATED_PLANNED_START,
   S.ESTIMATED_PLANNED_FINISH,
   S.ESTIMATED_PLANNED_EFFORT,
   S.ESTIMATED_PLANNED_COST,
   S.ESTIMATED_PLANNED_REVENUE,
   S.LEVEL_PLANNED_START,
   S.LEVEL_PLANNED_FINISH,
   S.LEVEL_SCHED_START,
   S.LEVEL_SCHED_FINISH,
   S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
   COALESCE(S.PA_START_DT,h_week_of) AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')  AS LEVEL_FINISH,
   
   S.ESTIMATED_BASELINE1_START,
   S.ESTIMATED_BASELINE1_FINISH,
   S.ESTIMATED_BASELINE1_EFFORT,
   S.ESTIMATED_BASELINE1_COST,
   S.ESTIMATED_BASELINE1_REVENUE,
   
   S.ESTIMATED_BASELINE3_START,
   S.ESTIMATED_BASELINE3_FINISH,
   S.ESTIMATED_BASELINE3_EFFORT,
   S.ESTIMATED_BASELINE3_COST,
   S.ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   
   R.LOGON_NAME    AS  RESOURCE_USER_NAME,
   R.LAST_NAME     AS  RESOURCE_LAST_NAME,
   R.FIRST_NAME    AS  RESOURCE_GIVEN_NAME,
   R.MIDDLE_NAME   AS  RESOURCE_MIDDLE_NAME,
   R.NICK_NAME     AS  RESOURCE_NICK_NAME,
   R.E_MAIL_ADDRESS AS RESOURCE_EMAIL_ADDRESS,
   R.WORK_PHONE    AS  RESOURCE_WORK_PHONE,
   R.EFFECTIVE_DATE AS RESOURCE_EFFECTIVE_DATE,
   R.DISCONTINUE_DATE AS   RESOURCE_DISCONTINUE_DATE,
   (SELECT ELEMENT_NAME  FROM TMT_CALENDARS WHERE ELEMENT_ID = R.CALENDAR_ID) AS   RESOURCE_CALENDAR,
   (SELECT DESCRIPTION FROM TMT_DATAFIELDS WHERE ELEMENT_ID = R.CURRENCY_ID)   AS  RESOURCE_CURRENCY,
   COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
   
   FROM TMT_POOLS T
   JOIN RESOURCES R ON R.RESOURCE_ID = T.ELEMENT_ID
   JOIN RESOURCES R1 ON R1.RESOURCE_ID = R.REC_USER
   LEFT JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = T.ELEMENT_ID
   WHERE RANK LIKE h_rank || '%'
   AND T.PARENT_ID = h_id
   AND T.TYPE_ID = 13
   AND T.PARENT_ID = h_id
   AND RANK <> h_rank
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_OPEN_POOL', 295+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_OPEN_POOL(296) : views_pool.sql(5550) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00011;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_OPEN_POOL', 303+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_OPEN_POOL(304) : views_pool.sql(5558) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_OPEN_POOL', 315+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_OPEN_POOL(316) : views_pool.sql(5570) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_OPEN_POOL;
ALTER FUNCTION FC_RM_OPEN_POOL COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_DEMAND_SUPPLY_PROFILES ==
CREATE OR REPLACE FUNCTION FC_DEMAND_SUPPLY_PROFILES
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_count PLS_INTEGER
   , sh_h_minute_per_day PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_count PLS_INTEGER := sh_h_count;
   h_minute_per_day PLS_INTEGER := sh_h_minute_per_day;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_res_id VARCHAR2(32);
   h_temp_reg_rate NUMBER := 0;
   h_temp_table_name VARCHAR2(255);
   h_bitflag_oracle PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00031 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DEMAND_SUPPLY_PROFILES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DEMAND_SUPPLY_PROFILES'), '-- ' || SYSTIMESTAMP, ':r := FC_DEMAND_SUPPLY_PROFILES(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_minute_per_day), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEMAND_SUPPLY_PROFILES', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DEMAND_SUPPLY_PROFILES(40) : views_pool.sql(5626) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PRJ';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_PRJ
      SELECT A.PROJECT_ID, 11, 12, TO_TIMESTAMP('1899-01-01 12:00:00.000000'), TO_TIMESTAMP('1899-01-01 12:00:00.000000'),
      MIN(A.BASELINE_START), MAX(A.BASELINE_FINISH), SUM(COALESCE(A.BASELINE_WORK, 0)),
      MIN(A.PLANNED_START),  MAX(A.PLANNED_FINISH),  SUM(COALESCE(A.PLANNED_WORK, 0)),
      MIN(A.PROPOSED_START), MAX(A.PROPOSED_FINISH), SUM(COALESCE(A.PROPOSED_WORK, 0)),
      MIN(A.SCHED_START),    MAX(A.SCHED_FINISH),    SUM(COALESCE(A.SCHED_WORK, 0)),
      MIN(A.FORECAST_START), MAX(A.FORECAST_FINISH), SUM(COALESCE(A.ETC, 0)),
      MIN(A.ACTUAL_START),   MAX(A.ACTUAL_FINISH),   SUM(COALESCE(A.WORK_TODATE, 0)),
      SUM(COALESCE(A.REGULAR_TODATE, 0)), SUM(COALESCE(A.SPECIAL_TODATE, 0)),
      (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))),
      CASE WHEN (SUM(COALESCE(A.ETC, 0))) = (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) THEN 0 ELSE 1 END,
      (CASE WHEN SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 WHEN SUM(COALESCE(A.WORK_TODATE, 0)) = 0 THEN 0 ELSE (SUM((A.WORK_TODATE + A.ETC) * A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC)) END),
      (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2) / (SUM(A.PLANNED_WORK)+SUM(A.SCHED_WORK))) * 10000.00), 0)) ELSE 0 END),
      SUM(COALESCE(A.BASELINE_LABOR_COST, 0.00)),
      SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)),
      SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)),
      SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)),
      SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)),
      SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)),
      SUM(COALESCE(A.ESTIMATION_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.BASELINE_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)),
      SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00))
      FROM PROJECT_ASSIGNMENTS A
      WHERE A.PROJECT_ID = h_id AND RESOURCE_TYPE = '1' AND A.ELEMENT_TYPE_BITS != 0
      GROUP BY A.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_PROFILES', 86+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_PROFILES(87) : views_pool.sql(5673) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_count := 1;
      
      h_temp_table_name := 'session.PMO_TMP_PRJ';
      h_bitflag_oracle := 0;
      h_temp_sc_state := FC_U_SF_DATE(Coalesce(h_bitflag_oracle, 0), h_temp_table_name);
   Else
      h_count := 0;
   End If;
   
   h_temp_bitflag := 3;
   -- regular rate for a specified project
   h_temp_res_id := '';
   h_temp_sc_state := FC_CAL_RES_PRJ_REG_RATE(h_temp_bitflag, h_temp_res_id, h_id, h_temp_reg_rate);
   
   --trace_printf("\n CR00031 \n");
   
   OPEN CR00031 FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, ' ' AS ACTIVE,
   h_count AS CHILD_COUNT, T.DELETED_COUNT,
   T.REC_STATUS,
   T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   A.SD, A.START_DT, A.FD, A.FINISH_DT,
   h_minute_per_day AS MINUTE_PER_DAY,
   -1 AS DURATION,
   A.BASELINE_START, A.BASELINE_FINISH,
   A.BASELINE_WORK AS BASELINE1_EFFORT,
   A.PLANNED_START, A.PLANNED_FINISH,
   A.PLANNED_WORK AS PLANNED_EFFORT,
   A.PROPOSED_START,
   A.PROPOSED_FINISH,
   A.PROPOSED_WORK AS PROPOSED_EFFORT,
   A.SCHED_START, A.SCHED_FINISH,
   A.SCHED_WORK AS SCHED_EFFORT,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
   A.ACTUAL_START, A.ACTUAL_FINISH,
   A.WORK_TODATE, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
   ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   A.MILESTONE_PERCENT,
   T.SUBPROJECT_COUNT,
   A.ESTIMATION_LABOR_COST AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, CASE WHEN A.SCHED_LABOR_COST > 0 THEN (A.SCHED_LABOR_COST - A.ACTUAL_LABOR_COST) WHEN A.PLANNED_LABOR_COST > 0 THEN (A.PLANNED_LABOR_COST - A.ACTUAL_LABOR_COST) ELSE 0.00 END AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   0.00 AS REG_COST,
   0.00 AS SPEC_COST,
   A.ESTIMATION_LABOR_REVENUE AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   
   CASE WHEN h_count > 0 THEN h_temp_reg_rate ELSE 0.00 END AS REG_RATE,
   
   0.00 AS SPEC_RATE,
   '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, '1' AS RESOURCE_TYPE,
   h_resource_id AS RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID, T.ASSIGN_COUNT, T.ASSIGN_NAMES, 'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
   0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,
   R.FS_CODE,
   T.STAGE_ID, R.FS_LABOR_CODE  ,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR, T.TASK_TYPE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
   0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME, 0 AS C_EFFORT
   FROM TMT_WBS T
   JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
   LEFT OUTER JOIN PMO_TMP_PRJ A ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT JOIN RESOURCE_ASSIGNMENTS RA ON RA.PROJECT_ID = A.PROJECT_ID AND RA.ELEMENT_ID = A.PROJECT_ID AND RA.RESOURCE_ID = h_resource_id
   WHERE T.ELEMENT_ID = h_id
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, 41 AS TYPE_ID, (h_rank || 'qqqq' || RTRIM(T.PROFILE_NAME)) AS RANK, h_id AS PARENT_ID,
   T.PROFILE_ID AS ELEMENT_ID, T.PROFILE_NAME AS ELEMENT_NAME, ' ' AS ACTIVE,
   
   CASE WHEN (A.PLANNED_WORK + A.SCHED_WORK)>0 THEN 1 ELSE 0 END AS CHILD_COUNT,
   
   0 AS DELETED_COUNT,
   h_rec_status AS REC_STATUS,
   h_resource_id AS REC_USER,
   h_full_name AS REC_USER_NAME,
   A.SCHED_FINISH AS REC_DATETIME, 0 AS PRIORITY, T.PROFILE_ID AS ORIGINAL_ID,
   
   A.SD,
   COALESCE(A.ESTIMATED_SCHED_START, COALESCE(A.ESTIMATED_PLANNED_START, A.START_DT)) AS START_DT,
   A.FD,
   COALESCE(A.ESTIMATED_SCHED_FINISH, COALESCE(A.ESTIMATED_PLANNED_FINISH, A.FINISH_DT)) AS FINISH_DT,
   
   h_minute_per_day AS MINUTE_PER_DAY,
   -1 AS DURATION,
   A.BASELINE_START, A.BASELINE_FINISH,
   A.BASELINE_WORK AS BASELINE1_EFFORT,
   COALESCE(A.ESTIMATED_SCHED_START, COALESCE(A.ESTIMATED_PLANNED_START,A.PLANNED_START)) AS PLANNED_START,
   COALESCE(A.ESTIMATED_SCHED_FINISH, COALESCE(A.ESTIMATED_PLANNED_FINISH,A.PLANNED_FINISH)) AS PLANNED_FINISH,
   CASE WHEN A.ESTIMATED_PLANNED_EFFORT > 0 THEN A.ESTIMATED_PLANNED_EFFORT ELSE A.PLANNED_WORK END AS PLANNED_EFFORT,
   A.PROPOSED_START,
   A.PROPOSED_FINISH,
   A.PROPOSED_WORK AS PROPOSED_EFFORT,
   A.SCHED_START, A.SCHED_FINISH,
   CASE WHEN A.ESTIMATED_SCHED_EFFORT > 0 THEN A.ESTIMATED_SCHED_EFFORT ELSE A.SCHED_WORK END AS SCHED_EFFORT,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC,(A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
   A.ACTUAL_START, A.ACTUAL_FINISH,
   A.WORK_TODATE, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
   ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
   CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
   A.MILESTONE_PERCENT,
   0 AS SUBPROJECT_COUNT,
   A.ESTIMATION_LABOR_COST AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
   (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
   (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, CASE WHEN A.SCHED_LABOR_COST > 0 THEN (A.SCHED_LABOR_COST - A.ACTUAL_LABOR_COST) WHEN A.PLANNED_LABOR_COST > 0 THEN (A.PLANNED_LABOR_COST - A.ACTUAL_LABOR_COST) ELSE 0.00 END AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
   COALESCE(RT.REGULAR_COST, 0.00) AS REG_COST, COALESCE(RT.SPECIAL_COST, 0.00) AS SPEC_COST,
   A.ESTIMATION_LABOR_REVENUE AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
   (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
   A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
   
   (SELECT CASE WHEN (SUM(TA.SCHED_WORK) + SUM(TA.PLANNED_WORK)) > 0.00
   THEN (((SUM(TA.SCHED_LABOR_REVENUE) + SUM(TA.PLANNED_LABOR_REVENUE))*60)/(SUM(TA.SCHED_WORK) + SUM(TA.PLANNED_WORK)))
   ELSE 0.00 END
   FROM TASK_ASSIGNMENTS TA
   WHERE TA.PROJECT_ID = h_id AND TA.RESOURCE_ID = A.RESOURCE_ID AND TA.BILLABLE = 1) AS REG_RATE,
   
   COALESCE(RT.SPECIAL_SALE, 0.00) AS SPEC_RATE,
   TA.BAK_ASSIGN_STRING AS ASSIGN_STRING, h_id AS PROJECT_ID, 0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID, '0' AS REVISION, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT, '' AS RESOURCE_TYPE, '' AS RESOURCE_ID, 0 AS PARTICIPANT,
   '' AS SECURITY_ID, 1 AS ASSIGN_COUNT,
   h_nick_name || ';' ASSIGN_NAMES, 'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
   0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,  '' AS FS_CODE, 0 AS STAGE_ID, '' AS FS_LABOR_CODE  ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR, 0 AS TASK_TYPE,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
   T.STAFFING_STATE,
   CASE WHEN EXISTS(SELECT RM.PROFILE_ID FROM RM_ASSIGNMENTS RM
   WHERE RM.PROJECT_ID = A.PROJECT_ID AND RM.PROFILE_ID = T.PROFILE_ID
   AND RM.MANAGER_ID = h_resource_id) THEN 'Y' ELSE 'N' END AS SUGGESTED_BY_ME,
   CASE WHEN EXISTS(SELECT RM.PROFILE_ID FROM RM_ASSIGNMENTS RM
   WHERE RM.PROJECT_ID = A.PROJECT_ID AND RM.PROFILE_ID = T.PROFILE_ID
   AND RM.MANAGER_ID = h_resource_id
   AND RM.ACCEPTED = 'Y') THEN 'Y' ELSE 'N' END AS ACCEPT_ME, CASE WHEN (SELECT COUNT(TSK_ASSIGNMENT_ID)
   FROM TASK_ASSIGNMENTS
   WHERE PROJECT_ID = h_id AND RESOURCE_ID = A.RESOURCE_ID) > 1 THEN 0 ELSE TA.C_EFFORT END AS C_EFFORT
   FROM PROJECT_ASSIGNMENTS A
   JOIN PROFILES T ON T.PROFILE_ID = A.RESOURCE_ID
   JOIN TMT_COMPETENCIES TC ON TC.ELEMENT_ID = T.ROLE_ID
   LEFT JOIN RATES RT ON RT.RATE_ID = TC.RATE_ID
   LEFT JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = A.PROJECT_ID AND TA.TASK_ID = A.PROJECT_ID AND TA.RESOURCE_ID = A.RESOURCE_ID
   WHERE A.PROJECT_ID = h_id
   AND A.RESOURCE_TYPE = '1' AND A.ELEMENT_TYPE_BITS != 0
   ORDER BY RANK, PLANNED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEMAND_SUPPLY_PROFILES', 300+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DEMAND_SUPPLY_PROFILES(301) : views_pool.sql(5887) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00031;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_PROFILES', 308+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_PROFILES(309) : views_pool.sql(5895) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_PROFILES', 320+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_PROFILES(321) : views_pool.sql(5907) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_DEMAND_SUPPLY_PROFILES;
ALTER FUNCTION FC_DEMAND_SUPPLY_PROFILES COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_WBS_MY_WORK_OPEN_PROJECT ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_WORK_OPEN_PROJECT
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_level PLS_INTEGER
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_temp_resource_type IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_level PLS_INTEGER := sh_h_level;
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_temp_reg_rate NUMBER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_temp PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_edit_flag VARCHAR2(1);
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_include_participant PLS_INTEGER := 0;
   h_include_unpublished_prj PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00033a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR00033b PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_WORK_OPEN_PROJECT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_WORK_OPEN_PROJECT'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_WORK_OPEN_PROJECT(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_level), 'NULL')
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_temp_resource_type || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_OPEN_PROJECT', 56+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_WORK_OPEN_PROJECT(57) : views_pool.sql(5980) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_participant := 1;
   
   If (isProjectType(Coalesce(h_type_id, 0))) <> 0 OR (Coalesce(
         h_type_id, 0) = PMO_CNST.SC_RESOURCE) Then
      PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_id, h_resource_id, PMO_CNST.SC_TASK);
      
      h_temp := 1;
      PMO_DB2M.SC_STATE := FC_TMP_PRJ_DLV(h_id, h_rank, h_resource_id, h_temp, h_active_record);
      
      h_temp_bitflag := 1;
      h_temp_sc_state := FC_CAL_RES_PRJ_REG_RATE(h_temp_bitflag, h_resource_id, h_id, h_temp_reg_rate);
      
      h_project_id := NULL;
      h_temp_bitflag := 0;
      h_include_unpublished_prj := 0;
      h_temp_sc_state := FC_ROLLUP_PROJECTS(h_resource_id, h_project_id, h_rank, h_nick_name
                                      , h_temp_bitflag, h_active_record, h_include_participant
                                      , h_include_unpublished_prj);
      
      GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
      
      --trace_printf("\n h_resource_id:%s", h_resource_id);
      --trace_printf("\n h_id:%s", h_id);
      
      --trace_printf("\n ---------> CR00033a \n");
      
      OPEN CR00033a FOR SELECT  T.LEVEL_ID AS LEVEL_ID, CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SC_PERSONAL_PROJECT ELSE T.TYPE_ID END AS TYPE_ID,
      T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SCPERSONALPROJECT ELSE T.ELEMENT_NAME END ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      h_full_name AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
      T.MINUTE_PER_DAY, -1 AS DURATION,
      'N' AS RTF, 'N' AS EXCEPTIONS, 'N' AS DOCUMENTS, 'N' AS SCORECARDS, '0' AS PUBLISHED, 0 AS CONSTRAINT_TYPE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS CONSTRAINT_DT,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH, 0 AS BASELINE1_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH, 0 AS PLANNED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH, 0 AS PROPOSED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH, 0 AS SCHED_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH, 0 AS ETC, 0 AS FORECAST_EFFORT,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION,
      0 AS ACTUAL_EFFORT,
      0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      0 AS REMAINING_EFFORT, 0 AS ETC_RED_FLAG,
      0 AS MILESTONE_PERCENT,
      0 AS WORK_PERCENT,
      0 AS WORK,
      T.SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS REMAINING,
      0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE, 0.00 AS REG_COST, 0.00 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING,
      0.00 AS R_BUDGET_FORECAST_VARIANCE, 0.00 AS R_BASELINE_VARIANCE, 0.00 AS REG_RATE, 0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING,
      T.ELEMENT_ID AS PROJECT_ID,
      0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, T.REFERENCE_NUMBER, 0 AS MSP_ID,
      '' AS REVISION, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
      '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      h_resource_id AS RESOURCE_ID,
      0 AS PARTICIPANT,
      COALESCE(PA.SECURITY_ID, PMO_CNST.SCPROJECTVISITOR_DB_STR) AS SECURITY_ID,
      0 ASSIGN_COUNT,
      h_nick_name || ';' AS ASSIGN_NAMES,
      '' AS ASSIGNED,
      CASE WHEN T.CALENDAR_ID IS NOT NULL THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
      T.LAST_CHECKIN,
      '' AS TSK_ASSIGNMENT_ID,
      '' AS FS_CODE,
      0 AS STAGE_ID,
      '' AS FS_LABOR_CODE,
      T.CURRENCY_ID,
      T.EFFORT_DRIVEN,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_SCHED_FINISH,
      0 AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_PLANNED_FINISH,
      0 AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0 AS ESTIMATED_BASELINE1_EFFORT,
      0.00 AS ESTIMATED_BASELINE1_COST,
      0.00 AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      T.BUBBLE_COLOR AS BUBBLE_COLOR,
      T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT,0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS MP_STATUS_DT,
      '' AS EDIT_FLAG,
      '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM TMT_WBS T
      JOIN PROJECT_ASSIGNMENTS PA ON
      PA.PROJECT_ID = T.PROJECT_ID
      AND PA.RESOURCE_ID = h_resource_id
      WHERE T.PROJECT_ID = h_id
      AND T.ELEMENT_ID = h_id
      AND T.REC_STATUS <> 'D'
      AND ((T.PUBLISHED = '1') OR PA.SECURITY_ID IN ('SCPROJECTMANAGER', 'SCCOMANAGER'))
      
      UNION ALL
      
      SELECT T.LEVEL_ID AS LEVEL_ID,
      T.TYPE_ID,
      T.RANK,
      h_resource_id AS PARENT_ID,
      T.ELEMENT_ID,
      T.ELEMENT_NAME, ' ' AS ACTIVE,
      A.TASK_COUNT AS CHILD_COUNT,
      T.DELETED_COUNT,
      T.REC_STATUS,
      T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME,
      T.PRIORITY,
      T.ELEMENT_ID AS ORIGINAL_ID,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.SD
      WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.ACTUAL_START = A.START_DT) THEN PMO_CNST.SC_AS
      WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
      WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
      ELSE PMO_CNST.SC_NS
      END AS SD,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.START_DT
      ELSE A.START_DT
      END AS START_DT,
      
      CASE
      when A.FD = PMO_CNST.SC_AF then A.FD
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FD
      WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
      WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
      WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
      WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
      ELSE PMO_CNST.SC_SF
      END AS FD,
      
      CASE
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FINISH_DT
      ELSE A.FINISH_DT
      END AS FINISH_DT,
      
      A.MINUTE_PER_DAY, -1 AS DURATION,
      
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED,
      T.CONSTRAINT_TYPE AS CONSTRAINT_TYPE,
      T.CONSTRAINT_DT AS CONSTRAINT_DT,
      
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE1_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT,
      A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT,
      A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC,
      A.TOTAL_EFFORT AS FORECAST_EFFORT,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT,
      0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      
      (A.TOTAL_EFFORT-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      
      -1 AS MILESTONE_PERCENT,
      A.WORK_PERCENT,
      A.TOTAL_EFFORT AS WORK,
      T.SUBPROJECT_COUNT,
      
      A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
      A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
      A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.SCHED_LABOR_COST_RATE AS REG_COST,
      0.00 AS SPEC_COST,
      
      A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
      A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
      A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
      ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      A.SCHED_LABOR_REVENUE_RATE AS REG_RATE,
      0.00 AS SPEC_RATE,
      
      '' AS ASSIGN_STRING,
      T.PROJECT_ID,
      0 AS ELEMENT_TYPE_BITS,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
      0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION ,
      '' AS REVISION_HISTORY,
      0 AS REVISION_TYPE,
      0 AS REVISION_IMPACT,
      '' AS LAST_WF_TYPE,
      '' AS LAST_WF_BY,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      R.RESOURCE_ID AS RESOURCE_ID,
      PA.PARTICIPANT,
      COALESCE(PA.SECURITY_ID,'') AS SECURITY_ID,
      0 AS ASSIGN_COUNT,
      '' AS ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.REC_DATETIME AS LAST_CHECKIN,
      '' AS TSK_ASSIGNMENT_ID,
      R.FS_CODE,
      0 AS STAGE_ID,
      R.FS_LABOR_CODE,
      T.CURRENCY_ID,
      T.EFFORT_DRIVEN,
      
      PA.ESTIMATED_SCHED_START,
      PA.ESTIMATED_SCHED_FINISH,
      PA.ESTIMATED_SCHED_EFFORT,
      PA.ESTIMATED_SCHED_COST,
      PA.ESTIMATED_SCHED_REVENUE,
      
      PA.ESTIMATED_PLANNED_START,
      PA.ESTIMATED_PLANNED_FINISH,
      PA.ESTIMATED_PLANNED_EFFORT,
      PA.ESTIMATED_PLANNED_COST,
      PA.ESTIMATED_PLANNED_REVENUE,
      
      PA.LEVEL_PLANNED_START,
      PA.LEVEL_PLANNED_FINISH,
      PA.LEVEL_SCHED_START,
      PA.LEVEL_SCHED_FINISH,
      ''                       AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      PA.ESTIMATED_BASELINE1_START,
      PA.ESTIMATED_BASELINE1_FINISH,
      PA.ESTIMATED_BASELINE1_EFFORT,
      PA.ESTIMATED_BASELINE1_COST,
      PA.ESTIMATED_BASELINE1_REVENUE,
      
      PA.ESTIMATED_BASELINE3_START,
      PA.ESTIMATED_BASELINE3_FINISH,
      PA.ESTIMATED_BASELINE3_EFFORT,
      PA.ESTIMATED_BASELINE3_COST,
      PA.ESTIMATED_BASELINE3_REVENUE,
      
      T.BUBBLE_COLOR AS BUBBLE_COLOR,
      T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT,0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
      A.MP_STATUS_DT AS MP_STATUS_DT,
      '' AS EDIT_FLAG,
      '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM VP_MWP_TM_2 A
      JOIN TMT_WBS T
      ON T.PROJECT_ID = A.PROJECT_ID
      AND T.ELEMENT_ID = A.PROJECT_ID
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = A.PROJECT_ID
      AND PA.RESOURCE_ID = A.RESOURCE_ID
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      
      UNION ALL
      
      SELECT  T.LEVEL_ID AS LEVEL_ID,
      case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
      T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD, A.START_DT, A.FD, A.FINISH_DT,
      W.MINUTE_PER_DAY, -1 AS DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH,
      A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
      A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
      A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC,
      A.EFFORT AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT,
      A.REGULAR_TODATE, A.SPECIAL_TODATE,
      
      (A.EFFORT-A.WORK_TODATE) AS REMAINING_EFFORT,
      
      ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
      
      -1 AS MILESTONE_PERCENT,
      A.WORK_PERCENT,
      A.EFFORT AS WORK,
      0 AS SUBPROJECT_COUNT,
      
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      
      A.BILLABLE_REG_RATE AS REG_RATE,
      
      0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      '0' AS RESOURCE_TYPE, h_resource_id AS RESOURCE_ID, 0 AS PARTICIPANT, PTS.SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
      W.CURRENCY_ID,
      W.EFFORT_DRIVEN ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT,0 AS UNITS_PERCENT,
      W.ELEMENT_NAME AS PROJECT_NAME,
      A.MP_STATUS_DT AS MP_STATUS_DT,
      '' AS EDIT_FLAG,
      '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM PMO_TMP_PRJ_DLV A
      JOIN TMT_WBS T
      ON T.PROJECT_ID = A.PROJECT_ID
      AND T.ELEMENT_ID = A.ELEMENT_ID
      AND T.ELEMENT_ID <> h_id
      JOIN TMT_WBS W
      ON W.PROJECT_ID = T.PROJECT_ID
      AND W.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN PMO_TMP_SECURITY PTS
      ON PTS.PARENT_ID = A.ELEMENT_ID
      
      UNION ALL
      
      SELECT   -- task level information
      T.LEVEL_ID,
      case when T.TYPE_ID = PMO_CNST.SC_PERSONAL_TASK or A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
      T.RANK, T.PARENT_ID,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
      
      T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.SD         else A.SD           end as SD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.START_DT   else A.START_DT     end as START_DT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FD         else A.FD           end as FD,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FINISH_DT  else A.FINISH_DT    end as FINISH_DT,
      
      W.MINUTE_PER_DAY,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.DURATION else A.DURATION end as DURATION,
      
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_START    else A.BASELINE1_START  end as BASELINE_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_FINISH   else A.BASELINE1_FINISH end as BASELINE_FINISH,
      
      COALESCE(A.BASELINE1_WORK,0) AS BASELINE1_EFFORT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_START  else A.PLANNED_START    end as PLANNED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_FINISH else A.PLANNED_FINISH   end as PLANNED_FINISH,
      
      COALESCE(A.PLANNED_WORK, 0) AS PLANNED_EFFORT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_START  else A.PROPOSED_START  end as PROPOSED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_FINISH else A.PROPOSED_FINISH end as PROPOSED_FINISH,
      
      COALESCE(A.PROPOSED_WORK,0) AS PROPOSED_EFFORT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_START    else A.SCHED_START  end as SCHED_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_FINISH   else A.SCHED_FINISH end as SCHED_FINISH,
      
      COALESCE(A.SCHED_WORK, 0) AS SCHED_EFFORT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_START         else A.FORECAST_START       end as FORECAST_START,
      case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_FINISH        else A.FORECAST_FINISH      end as FORECAST_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ETC                    else A.ETC                  end as ETC,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_TODATE + T.ETC    else A.WORK_TODATE + A.ETC  end as FORECAST_EFFORT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_START           else A.ACTUAL_START         end as ACTUAL_START,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_FINISH          else A.ACTUAL_FINISH        end as ACTUAL_FINISH,
      case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_DURATION            else A.ACTUAL_DURATION          end as ACTUAL_DURATION,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_TODATE            else A.WORK_TODATE          end as ACTUAL_EFFORT,
      
      COALESCE(A.REGULAR_TODATE,0) AS REGULAR_TODATE,
      COALESCE(A.SPECIAL_TODATE,0) AS SPECIAL_TODATE,
      
      case when A.TSK_ASSIGNMENT_ID IS null then (T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE else (A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE end as REMAINING_EFFORT,
      
      case when A.TSK_ASSIGNMENT_ID IS null then ABS(SIGN(T.ETC - ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE)))
      else ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) end as ETC_RED_FLAG,
      
      case when A.TSK_ASSIGNMENT_ID IS null then T.MILESTONE_PERCENT else /*CASE WHEN A.SCHED_DURATION > 0 THEN INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END*/ -1 END AS MILESTONE_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_PERCENT      else A.MILESTONE_PERCENT end as WORK_PERCENT,
      case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_EFFORT+T.PLANNED_EFFORT else A.SCHED_WORK+A.PLANNED_WORK  end as WORK,
      
      0 AS SUBPROJECT_COUNT,
      
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      
      CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
      
      A.SPECIAL_RATE AS SPEC_RATE,
      A.ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT, CASE WHEN PTS.SECURITY_ID IS NuLL THEN RA.SECURITY_ID ELSE PTS.SECURITY_ID || RA.SECURITY_ID END AS SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES, CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
      W.CURRENCY_ID,
      W.EFFORT_DRIVEN ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT, COALESCE(A.UNITS_MSP,0) AS UNITS_PERCENT,
      W.ELEMENT_NAME AS PROJECT_NAME,
      case when A.TSK_ASSIGNMENT_ID IS null THEN COALESCE(T.MP_STATUS_DT,TO_TIMESTAMP('1899-01-01 12:00:00.000000')) ELSE COALESCE(A.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) END AS MP_STATUS_DT,
      
      case when A.TSK_ASSIGNMENT_ID is NuLL then
      case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0 AND
      EXISTS (SELECT TA.REC_STATUS
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.PROJECT_ID = T.PROJECT_ID
      AND TA.TASK_ID = T.ELEMENT_ID
      AND TA.REC_STATUS = 'E') then 'E'
      else 'U'
      end
      else
      A.REC_STATUS
      end AS EDIT_FLAG,
      
      case when (T.SCHED_EFFORT > 0 AND COALESCE(A.PLANNED_WORK, T.PLANNED_EFFORT) = 0) OR
      ((T.PLANNED_EFFORT + T.SCHED_EFFORT) = 0 AND COALESCE(A.SCHED_START,T.SCHED_START) IS NOT NuLL)
      then '2' else '1' end AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN TMT_WBS T
      ON T.PROJECT_ID = RA.PROJECT_ID
      AND T.ELEMENT_ID = RA.ELEMENT_ID
      AND T.PARENT_ID = T.PROJECT_ID
      JOIN PROJECT_ASSIGNMENTS PA ON PA.PROJECT_ID = RA.PROJECT_ID
      AND PA.RESOURCE_ID = RA.RESOURCE_ID
      JOIN TMT_WBS W
      ON W.PROJECT_ID = T.PROJECT_ID
      AND W.ELEMENT_ID = T.PROJECT_ID
      AND ((W.PUBLISHED = '1') OR PA.SECURITY_ID IN ('SCPROJECTMANAGER', 'SCCOMANAGER'))
      AND W.REC_STATUS <> 'D'
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      JOIN PMO_TMP_SECURITY PTS
      ON PTS.PARENT_ID = T.PARENT_ID
      LEFT JOIN TASK_ASSIGNMENTS A
      ON RA.PROJECT_ID = A.PROJECT_ID
      AND RA.ELEMENT_ID = A.TASK_ID
      AND RA.RES_ASSIGNMENT_ID = A.RES_ASSIGNMENT_ID
      WHERE RA.RESOURCE_ID = h_resource_id
      AND RA.PROJECT_ID = h_id
      AND RA.ELEMENT_ID <> RA.PROJECT_ID
      AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND (h_include_proposed = 1           OR (case when A.TSK_ASSIGNMENT_ID IS NOT NuLL AND A.SCHED_START IS NOT NuLL then 1
      when A.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
      else 0 end) = 1)
      AND (h_closed_not_completed = 1 OR
      ((((case when A.TSK_ASSIGNMENT_ID IS NOT NuLL AND A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
      when A.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
      else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
      OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_not_completed = 1   OR
      ((((case when A.TSK_ASSIGNMENT_ID IS NOT NuLL AND A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
      when A.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
      else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
      AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND ((h_ready_to_start_task_only = 1)
      OR ((case when A.TSK_ASSIGNMENT_ID IS NOT NuLL AND A.ACTUAL_START IS NOT NuLL AND A.ACTUAL_FINISH IS NuLL then 1
      when A.TSK_ASSIGNMENT_ID IS NuLL AND T.ACTUAL_START IS NOT NuLL AND T.ACTUAL_FINISH IS NuLL then 1
      else 0 end) = 1)
      OR (T.DEPEND_FLAG IN ('0', '2') AND (T.CONSTRAINT_TYPE NOT IN (5, 6)
      OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SYSDATE)))))
      ORDER BY RANK, PLANNED_START;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_OPEN_PROJECT', 650+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_WORK_OPEN_PROJECT(651) : views_pool.sql(6574) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR00033a;
   Else
      BEGIN
         SELECT PROJECT_ID INTO h_project_id FROM TMT_WBS WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_OPEN_PROJECT', 662+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_OPEN_PROJECT(663) : views_pool.sql(6586) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp := 0;
      PMO_DB2M.SC_STATE := FC_TMP_PRJ_DLV(h_id, h_rank, h_resource_id, h_temp, h_active_record);
      PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_project_id, h_resource_id, PMO_CNST.SC_TASK);
      
      GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
      
      --trace_printf("\n ------------>CR00033b \n");
      
      OPEN CR00033b FOR SELECT T.LEVEL_ID, T.TYPE_ID,    -- deliverable level
      T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD, A.START_DT, A.FD, A.FINISH_DT,
      P.MINUTE_PER_DAY, -1 AS DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
      A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
      A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
      A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC,
      A.TOTAL_EFFORT AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT,
      A.REGULAR_TODATE, A.SPECIAL_TODATE,
      ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      A.MILESTONE_PERCENT,
      A.WORK_PERCENT,
      A.EFFORT AS WORK,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      
      A.BILLABLE_REG_RATE AS REG_RATE,
      
      0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      h_temp_resource_type AS RESOURCE_TYPE, h_resource_id AS RESOURCE_ID, RA.PARTICIPANT, PTS.SECURITY_ID AS SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES, CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
      P.CURRENCY_ID,
      P.EFFORT_DRIVEN ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
      P.ELEMENT_NAME AS PROJECT_NAME,
      A.MP_STATUS_DT AS MP_STATUS_DT,
      '' AS EDIT_FLAG, '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM PMO_TMP_PRJ_DLV A
      JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
      JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
      AND P.PROJECT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = A.ELEMENT_ID AND RA.RESOURCE_ID = h_resource_id
      LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = RA.ELEMENT_ID
      
      UNION ALL
      
      SELECT T.LEVEL_ID,
      CASE    WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
      WHEN T.TYPE_ID = PMO_CNST.SC_ACTIVE_ADM_TASK OR T.TYPE_ID = PMO_CNST.SC_INACTIVE_ADM_TASK THEN T.TYPE_ID
      ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
      T.RANK, T.PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD, A.START_DT,
      case when T.FD = PMO_CNST.SC_AF then T.FD else A.FD end AS FD, A.FINISH_DT, P.MINUTE_PER_DAY, A.DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
      (A.BASELINE1_WORK) AS BASELINE1_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH,
      (A.PLANNED_WORK) AS PLANNED_EFFORT,
      A.PROPOSED_START, A.PROPOSED_FINISH,
      (A.PROPOSED_WORK) AS PROPOSED_EFFORT,
      A.SCHED_START, A.SCHED_FINISH,
      (A.SCHED_WORK) AS SCHED_EFFORT,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC,
      (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      A.ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT,
      (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
      ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      CASE WHEN A.SCHED_DURATION > 0 THEN Trunc((PMO_ORASTD.TODECIMAL(A.ACTUAL_DURATION)/PMO_ORASTD.TODECIMAL(A.SCHED_DURATION)) * 10000) ELSE T.MILESTONE_PERCENT END AS MILESTONE_PERCENT,
      COALESCE(A.MILESTONE_PERCENT, T.WORK_PERCENT) AS WORK_PERCENT,
      (A.SCHED_WORK+A.PLANNED_WORK) AS WORK,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      
      CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
      
      A.SPECIAL_RATE AS SPEC_RATE,
      A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT,
      COALESCE(PTS.SECURITY_ID, '') || COALESCE(RA.SECURITY_ID, '') AS SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
      P.CURRENCY_ID,
      P.EFFORT_DRIVEN ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT,COALESCE(A.UNITS_MSP,0) AS UNITS_PERCENT,
      P.ELEMENT_NAME AS PROJECT_NAME,
      COALESCE(A.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
      A.REC_STATUS AS EDIT_FLAG, A.BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM TASK_ASSIGNMENTS A
      JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
      AND T.PARENT_ID = h_id
      JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
      AND P.PROJECT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = A.TASK_ID
      AND RA.RESOURCE_ID = A.RESOURCE_ID
      LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
      WHERE A.RESOURCE_ID = h_resource_id
      AND A.TASK_ID <> A.PROJECT_ID
      AND A.TASK_ID <> A.PROJECT_ID
      AND (h_include_proposed = 1 OR A.SCHED_START IS NOT NuLL)
      AND (h_closed_not_completed = 1 OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
      OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_not_completed = 1   OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND ((h_ready_to_start_task_only = 1)
      OR (A.ACTUAL_START IS NOT NuLL AND A.ACTUAL_FINISH IS NuLL)
      OR (T.DEPEND_FLAG IN ('0', '2') AND (T.CONSTRAINT_TYPE NOT IN (5, 6)
      OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SYSDATE)))))
      
      UNION ALL
      
      SELECT T.LEVEL_ID, T.TYPE_ID,
      T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      T.SD, T.START_DT, T.FD, T.FINISH_DT,
      P.MINUTE_PER_DAY, T.DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      T.BASELINE1_START AS BASELINE_START, T.BASELINE1_FINISH AS BASELINE_FINISH,
      0 AS BASELINE1_EFFORT,
      T.PLANNED_START, T.PLANNED_FINISH,
      0 AS PLANNED_EFFORT,
      T.PROPOSED_START, T.PROPOSED_FINISH,
      0 AS PROPOSED_EFFORT,
      T.SCHED_START, T.SCHED_FINISH,
      0 AS SCHED_EFFORT,
      T.FORECAST_START, T.FORECAST_FINISH,
      
      0 AS ETC,
      0 AS FORECAST_EFFORT,
      
      T.ACTUAL_START, T.ACTUAL_FINISH,
      T.ACTUAL_DURATION, 0 AS ACTUAL_EFFORT,
      0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      0 AS REMAINING_EFFORT,
      0 AS ETC_RED_FLAG,
      
      T.MILESTONE_PERCENT AS MILESTONE_PERCENT,
      T.WORK_PERCENT,
      0 AS WORK,
      0 AS SUBPROJECT_COUNT,
      
      0.00 AS X_ESTIMATION_BUDGET, T.BASELINE1_BUDGET, T.ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_COST, T.CURRENT_BUDGET, T.FORECAST_BUDGET, T.ACTUAL_BUDGET, T.CURRENT_BUDGET - T.ACTUAL_BUDGET AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE, 0 BASELINE_VARIANCE, 0 AS REG_COST, 0 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, 0 AS R_BASELINE1_BUDGET, 0 AS R_ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_REVENUE, 0 AS R_CURRENT_BUDGET, 0 AS R_FORECAST_BUDGET, 0 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0 AS R_BUDGET_FORECAST_VARIANCE, 0 AS R_BASELINE_VARIANCE,
      0 AS REG_RATE, 0 AS SPEC_RATE,
      '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      RA.RESOURCE_TYPE, RA.RESOURCE_ID, RA.PARTICIPANT,
      COALESCE(PTS.SECURITY_ID, '') || COALESCE(RA.SECURITY_ID, '') AS SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, RA.RES_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
      P.CURRENCY_ID,
      P.EFFORT_DRIVEN ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT,0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
      COALESCE(T.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
      
      case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0
      AND EXISTS (SELECT TA.REC_STATUS
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.PROJECT_ID = T.PROJECT_ID
      AND TA.TASK_ID = T.ELEMENT_ID
      AND TA.REC_STATUS = 'E') then 'E'
      else 'U'
      end AS EDIT_FLAG,
      case when T.PLANNED_START IS NuLL AND T.SCHED_START IS NOT NuLL then '2' else '1' end AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN TMT_WBS T ON RA.RESOURCE_ID = h_resource_id
      AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND BITAND(RA.PARTICIPANT,16) = 0
      AND T.ELEMENT_ID = RA.ELEMENT_ID
      AND T.PARENT_ID = h_id
      JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
      WHERE (h_include_proposed = 1 OR T.SCHED_START IS NOT NuLL)
      AND (h_closed_not_completed = 1 OR ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_not_completed = 1   OR ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND ((h_ready_to_start_task_only = 1)
      OR (T.ACTUAL_START IS NOT NuLL AND T.ACTUAL_FINISH IS NuLL)
      OR (T.DEPEND_FLAG IN ('0', '2') AND (T.CONSTRAINT_TYPE NOT IN (5, 6)
      OR (T.CONSTRAINT_TYPE IN (5, 6) AND TO_DATE(SubStr(T.CONSTRAINT_DT, 1, 10)) <= TO_DATE(SYSDATE)))))
      ORDER BY RANK, PLANNED_START;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_OPEN_PROJECT', 1000+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_WORK_OPEN_PROJECT(1001) : views_pool.sql(6924) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR00033b;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_OPEN_PROJECT', 1009+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_OPEN_PROJECT(1010) : views_pool.sql(6933) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_OPEN_PROJECT', 1021+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_OPEN_PROJECT(1022) : views_pool.sql(6945) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_WORK_OPEN_PROJECT;
ALTER FUNCTION FC_WBS_MY_WORK_OPEN_PROJECT COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_WBS_MY_WORK_REFRESH_ELEMENT ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_WORK_REFRESH_ELEMENT
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_temp_reg_rate NUMBER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_prj_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_edit_flag VARCHAR2(1);
   h_temp_table_name VARCHAR2(255);
   h_include_participant PLS_INTEGER := 0;
   h_include_unpublished_prj PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0053a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR0053b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR0053c PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_WORK_REFRESH_ELEMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_WORK_REFRESH_ELEMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_WORK_REFRESH_ELEMENT(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_REFRESH_ELEMENT', 46+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_WORK_REFRESH_ELEMENT(47) : views_pool.sql(7008) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_participant := 1;
   
   --trace_printf("h_type_id: %d, h_id: %s, h_resource_id: %s\n",h_type_id,h_id,h_resource_id);
   --trace_printf("h_project_id: %s, h_rank: %s\n",h_project_id,h_rank);
   
   If (isProjectType(Coalesce(h_type_id, 0))) <> 0 OR (Coalesce(
         h_type_id, 0) = PMO_CNST.SC_RESOURCE) Then
      -- REFRESH AT PROJECT AND PERSONAL_PROJECT LEVEL IN MY WORK -> ALL WORK PACKAGE:
      PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_id, h_resource_id, PMO_CNST.SC_TASK);
      
      h_temp_bitflag := 0;
      h_include_unpublished_prj := 0;
      h_temp_sc_state := FC_ROLLUP_PROJECTS(h_resource_id, h_project_id, h_rank, h_nick_name
                                      , h_temp_bitflag, h_active_record, h_include_participant
                                      , h_include_unpublished_prj);
      
      --RESULT_SET
      
      --trace_printf("\n CR0053a \n");
      
      OPEN CR0053a FOR SELECT  1 AS LEVEL_ID,      -- project level
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SC_PERSONAL_PROJECT ELSE T.TYPE_ID END AS TYPE_ID,
      T.RANK,
      h_resource_id AS PARENT_ID,
      T.ELEMENT_ID,
      CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SCPERSONALPROJECT ELSE T.ELEMENT_NAME END AS ELEMENT_NAME,
      ' ' AS ACTIVE,
      A.TASK_COUNT AS CHILD_COUNT,
      T.DELETED_COUNT,
      T.REC_STATUS,
      T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME,
      T.PRIORITY,
      T.ELEMENT_ID AS ORIGINAL_ID,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.SD
      WHEN (A.ACTUAL_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.ACTUAL_START = A.START_DT) THEN PMO_CNST.SC_AS
      WHEN (A.FORECAST_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS
      WHEN (A.SCHED_START <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS
      ELSE PMO_CNST.SC_NS
      END AS SD,
      
      CASE
      WHEN (A.START_DT = TO_TIMESTAMP('2300-12-12 12:00:00')) THEN T.START_DT
      ELSE A.START_DT
      END AS START_DT,
      
      CASE
      
      when A.FD = PMO_CNST.SC_AF then A.FD
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FD
      WHEN (A.ACTUAL_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_UAF
      WHEN (A.FORECAST_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.FORECAST_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_FF
      WHEN (A.SCHED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.SCHED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_SF
      WHEN (A.PLANNED_FINISH <> TO_TIMESTAMP('1899-01-01 12:00:00')) AND (A.PLANNED_FINISH = A.FINISH_DT) THEN PMO_CNST.SC_NF
      ELSE PMO_CNST.SC_SF
      END AS FD,
      
      CASE
      WHEN (A.FINISH_DT = TO_TIMESTAMP('1899-01-01 12:00:00')) THEN T.FINISH_DT
      ELSE A.FINISH_DT
      END AS FINISH_DT,
      
      A.MINUTE_PER_DAY, -1 AS DURATION,
      
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
      CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
      CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED,
      T.CONSTRAINT_TYPE AS CONSTRAINT_TYPE,
      T.CONSTRAINT_DT AS CONSTRAINT_DT,
      
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH, A.BASELINE1_EFFORT AS BASELINE1_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_EFFORT,
      A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_EFFORT,
      A.SCHED_START, A.SCHED_FINISH, A.SCHED_EFFORT,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC,
      A.EFFORT AS FORECAST_EFFORT,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION,
      A.WORK_TODATE AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_EFFORT+A.PLANNED_EFFORT)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      
      -1 AS MILESTONE_PERCENT,
      A.WORK_PERCENT,
      A.EFFORT AS WORK,
      T.SUBPROJECT_COUNT,
      
      A.EST_SCHED_COST AS X_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET,
      A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET,
      A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET,
      ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING,
      (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.SCHED_LABOR_COST_RATE AS REG_COST,
      0.00 AS SPEC_COST,
      
      A.EST_SCHED_REVENUE AS X_R_ESTIMATION_BUDGET,
      A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET,
      A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET,
      A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET,
      A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET,
      ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING,
      (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE,
      CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      A.SCHED_LABOR_REVENUE_RATE AS REG_RATE,
      0.00 AS SPEC_RATE,
      
      '' AS ASSIGN_STRING,
      '' AS PROJECT_ID,
      0 AS ELEMENT_TYPE_BITS,
      (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,
      0 AS MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION ,
      '' AS REVISION_HISTORY,
      0 AS REVISION_TYPE,
      0 AS REVISION_IMPACT,
      '' AS LAST_WF_TYPE,
      '' AS LAST_WF_BY,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS LAST_WF_DT,
      '0' AS RESOURCE_TYPE,
      R.RESOURCE_ID AS RESOURCE_ID,
      PA.PARTICIPANT,
      case when PA.SECURITY_ID = '' OR  PA.SECURITY_ID IS Null then PMO_CNST.SCPROJECTVISITOR_DB_STR else PA.SECURITY_ID end AS SECURITY_ID,
      T.ASSIGN_COUNT AS ASSIGN_COUNT,
      T.ASSIGN_NAMES AS ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED,
      '' AS CALENDAR_FLAG,
      R.REC_DATETIME AS LAST_CHECKIN,
      '' AS TSK_ASSIGNMENT_ID,
      R.FS_CODE AS FS_CODE,
      0 AS STAGE_ID,
      R.FS_LABOR_CODE,
      T.CURRENCY_ID,
      0 AS EFFORT_DRIVEN,
      PA.ESTIMATED_SCHED_START,
      PA.ESTIMATED_SCHED_FINISH,
      PA.ESTIMATED_SCHED_EFFORT,
      PA.ESTIMATED_SCHED_COST,
      PA.ESTIMATED_SCHED_REVENUE,
      PA.ESTIMATED_PLANNED_START,
      PA.ESTIMATED_PLANNED_FINISH,
      PA.ESTIMATED_PLANNED_EFFORT,
      PA.ESTIMATED_PLANNED_COST,
      PA.ESTIMATED_PLANNED_REVENUE,
      PA.LEVEL_PLANNED_START,
      PA.LEVEL_PLANNED_FINISH,
      PA.LEVEL_SCHED_START,
      PA.LEVEL_SCHED_FINISH,
      ''   AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      PA.ESTIMATED_BASELINE1_START,
      PA.ESTIMATED_BASELINE1_FINISH,
      PA.ESTIMATED_BASELINE1_EFFORT,
      PA.ESTIMATED_BASELINE1_COST,
      PA.ESTIMATED_BASELINE1_REVENUE,
      PA.ESTIMATED_BASELINE3_START,
      PA.ESTIMATED_BASELINE3_FINISH,
      PA.ESTIMATED_BASELINE3_EFFORT,
      PA.ESTIMATED_BASELINE3_COST,
      PA.ESTIMATED_BASELINE3_REVENUE,
      T.BUBBLE_COLOR AS BUBBLE_COLOR,
      T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT,0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
      A.MP_STATUS_DT AS MP_STATUS_DT,
      '' AS EDIT_FLAG,
      '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      
      FROM VP_MWP_TM_2 A
      JOIN TMT_WBS T
      ON T.PROJECT_ID = A.PROJECT_ID
      AND T.ELEMENT_ID = A.PROJECT_ID
      JOIN PROJECT_ASSIGNMENTS PA
      ON PA.PROJECT_ID = A.PROJECT_ID
      AND PA.RESOURCE_ID = A.RESOURCE_ID
      JOIN RESOURCES R
      ON R.RESOURCE_ID = T.REC_USER
      
      ORDER BY RANK;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_REFRESH_ELEMENT', 241+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_WORK_REFRESH_ELEMENT(242) : views_pool.sql(7203) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR0053a;
   Else
      BEGIN
         SELECT PROJECT_ID INTO h_project_id FROM TMT_WBS WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_REFRESH_ELEMENT', 253+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_REFRESH_ELEMENT(254) : views_pool.sql(7215) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_project_id, h_resource_id, PMO_CNST.SC_TASK);
      
      If (isWBSTask(Coalesce(h_type_id, 0))) <> 0 OR (Coalesce(h_type_id, 0) = PMO_CNST.SC_TASK_ASSN) Then
         --trace_printf("\n h_id:%s", h_id);
         --trace_printf("\n h_resource_id:%s", h_resource_id);
         
         --trace_printf("\n CR0053b \n");
         
         OPEN CR0053b FOR SELECT
         T.LEVEL_ID,
         case    WHEN T.TYPE_ID = PMO_CNST.SC_ACTIVE_ADM_TASK OR T.TYPE_ID = PMO_CNST.SC_INACTIVE_ADM_TASK THEN T.TYPE_ID
         WHEN T.TYPE_ID = PMO_CNST.SC_PERSONAL_TASK OR A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN
         WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN
         ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
         T.RANK, T.PARENT_ID,
         case when a.tsk_assignment_id is null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE, T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         
         case when a.tsk_assignment_id is null then T.SD         else A.SD           end as SD,
         case when a.tsk_assignment_id is null then T.START_DT   else A.START_DT     end as START_DT,
         case when a.tsk_assignment_id is null then T.FD         else A.FD           end as FD,
         case when a.tsk_assignment_id is null then T.FINISH_DT  else A.FINISH_DT    end as FINISH_DT,
         
         W.MINUTE_PER_DAY, T.DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF,
         CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS,
         CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         
         case when a.tsk_assignment_id is null then T.BASELINE1_START   else A.BASELINE1_START  end as BASELINE_START,
         case when a.tsk_assignment_id is null then T.BASELINE1_FINISH  else A.BASELINE1_FINISH end as BASELINE_FINISH,
         
         COALESCE(A.BASELINE1_WORK,0) AS BASELINE1_EFFORT,
         
         case when a.tsk_assignment_id is null then T.PLANNED_START  else    A.PLANNED_START  end as PLANNED_START,
         case when a.tsk_assignment_id is null then T.PLANNED_FINISH else    A.PLANNED_FINISH end as PLANNED_FINISH,
         case when a.tsk_assignment_id is null then T.PLANNED_EFFORT else    A.PLANNED_WORK   end as PLANNED_EFFORT,
         
         case when a.tsk_assignment_id is null then  T.PROPOSED_START    else A.PROPOSED_START   end as PROPOSED_START,
         case when a.tsk_assignment_id is null then  T.PROPOSED_FINISH   else A.PROPOSED_FINISH  end as PROPOSED_FINISH,
         case when a.tsk_assignment_id is null then  T.PROPOSED_EFFORT   else A.PROPOSED_WORK    end as PROPOSED_EFFORT,
         
         case when a.tsk_assignment_id is null then T.SCHED_START  else A.SCHED_START     end as SCHED_START,
         case when a.tsk_assignment_id is null then T.SCHED_FINISH else A.SCHED_FINISH    end as SCHED_FINISH,
         case when a.tsk_assignment_id is null then T.SCHED_EFFORT else A.SCHED_WORK  end as SCHED_EFFORT,
         
         case when a.tsk_assignment_id is null then T.FORECAST_START         else A.FORECAST_START       end as FORECAST_START,
         case when a.tsk_assignment_id is null then T.FORECAST_FINISH        else A.FORECAST_FINISH      end as FORECAST_FINISH,
         case when a.tsk_assignment_id is null then T.ETC                    else A.ETC                  end as ETC,
         case when a.tsk_assignment_id is null then T.WORK_TODATE + T.ETC    else A.WORK_TODATE + A.ETC  end as FORECAST_EFFORT,
         case when a.tsk_assignment_id is null then T.ACTUAL_START           else A.ACTUAL_START         end as ACTUAL_START,
         case when a.tsk_assignment_id is null then T.ACTUAL_FINISH          else A.ACTUAL_FINISH        end as ACTUAL_FINISH,
         
         case when a.tsk_assignment_id is null then T.ACTUAL_DURATION else A.ACTUAL_DURATION end as ACTUAL_DURATION,
         case when a.tsk_assignment_id is null then T.WORK_TODATE else A.WORK_TODATE end as ACTUAL_EFFORT,
         
         COALESCE(A.REGULAR_TODATE,0) AS REGULAR_TODATE,
         COALESCE(A.SPECIAL_TODATE,0) AS SPECIAL_TODATE,
         
         case when a.tsk_assignment_id is null then (T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE else (A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE end as REMAINING_EFFORT,
         case when A.TSK_ASSIGNMENT_ID IS null then ABS(SIGN(T.ETC - ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE)))
         else ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) end as ETC_RED_FLAG,
         case when a.tsk_assignment_id is null then T.MILESTONE_PERCENT  else /*CASE when A.SCHED_DURATION > 0 THEN INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END*/ -1 end as MILESTONE_PERCENT,
         case when a.tsk_assignment_id is null then T.WORK_PERCENT       else A.MILESTONE_PERCENT end as WORK_PERCENT,
         case when a.tsk_assignment_id is null then T.PLANNED_EFFORT + T.SCHED_EFFORT else A.PLANNED_WORK+A.SCHED_WORK end as WORK,
         
         0 AS SUBPROJECT_COUNT,
         
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
         
         A.SPECIAL_RATE AS SPEC_RATE,
         A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT,
         CASE WHEN PTS.SECURITY_ID IS NuLL THEN RA.SECURITY_ID ELSE PTS.SECURITY_ID || RA.SECURITY_ID END AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES, CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
         0 AS CURRENCY_ID,
         W.EFFORT_DRIVEN ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
         A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
         A.LEVEL_START           AS LEVEL_START,
         A.LEVEL_FINISH          AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT,
         COALESCE(A.UNITS_MSP,0) AS UNITS_PERCENT,
         W.ELEMENT_NAME AS PROJECT_NAME,
         COALESCE(COALESCE(A.REC_DATETIME, T.MP_STATUS_DT), TO_TIMESTAMP('1899-01-01 12:00:00.000000'))   AS MP_STATUS_DT,
         
         case when A.TSK_ASSIGNMENT_ID is NuLL then
         case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0 AND
         EXISTS (SELECT TA.REC_STATUS
         FROM TASK_ASSIGNMENTS TA
         WHERE TA.PROJECT_ID = T.PROJECT_ID
         AND TA.TASK_ID = T.ELEMENT_ID
         AND TA.REC_STATUS = 'E') then 'E'
         else 'U'
         end
         else
         A.REC_STATUS
         end AS EDIT_FLAG,
         
         case when (T.SCHED_EFFORT > 0 AND COALESCE(A.PLANNED_WORK, T.PLANNED_EFFORT) = 0) OR
         ((T.PLANNED_EFFORT + T.SCHED_EFFORT) = 0 AND COALESCE(A.SCHED_START,T.SCHED_START) IS NOT NuLL)
         then '2' else '1' end AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM RESOURCE_ASSIGNMENTS RA
         JOIN TMT_WBS T ON T.PROJECT_ID = RA.PROJECT_ID
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         JOIN TMT_WBS W ON W.PROJECT_ID = T.PROJECT_ID
         AND W.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
         LEFT JOIN TASK_ASSIGNMENTS A ON RA.PROJECT_ID = A.PROJECT_ID
         AND RA.ELEMENT_ID = A.TASK_ID
         AND RA.RES_ASSIGNMENT_ID = A.RES_ASSIGNMENT_ID
         WHERE RA.RESOURCE_ID = h_resource_id
         AND RA.ELEMENT_ID = h_id
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_REFRESH_ELEMENT', 423+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_WORK_REFRESH_ELEMENT(424) : views_pool.sql(7385) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CR0053b;
      Else
         h_temp_bitflag := 0;
         PMO_DB2M.SC_STATE := FC_TMP_PRJ_DLV(h_id, h_rank, h_resource_id, h_temp_bitflag, h_active_record);
         
         --trace_printf("\n ----> CR0053c \n");
         
         OPEN CR0053c FOR -- deliverable level
         SELECT 3 AS LEVEL_ID,
         case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
         T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME,
         T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         P.MINUTE_PER_DAY, -1 AS DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC AS ETC,
         A.EFFORT AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT,
         A.REGULAR_TODATE, A.SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         A.MILESTONE_PERCENT,
         A.WORK_PERCENT,
         A.EFFORT AS WORK,
         T.SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         A.BILLABLE_REG_RATE AS REG_RATE,
         
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         RA.RESOURCE_TYPE, h_resource_id AS RESOURCE_ID, RA.PARTICIPANT, PTS.SECURITY_ID AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES, CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
         0 AS CURRENCY_ID,
         P.EFFORT_DRIVEN ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BUBBLE_PUBLISHED_DT,0 AS UNITS_PERCENT,
         P.ELEMENT_NAME AS PROJECT_NAME,
         A.MP_STATUS_DT              AS MP_STATUS_DT,
         '' AS EDIT_FLAG, '' AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         
         FROM PMO_TMP_PRJ_DLV A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
         JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
         AND P.PROJECT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = A.ELEMENT_ID AND RA.RESOURCE_ID = h_resource_id
         LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = RA.ELEMENT_ID;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_WORK_REFRESH_ELEMENT', 522+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_WORK_REFRESH_ELEMENT(523) : views_pool.sql(7484) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CR0053c;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_REFRESH_ELEMENT', 532+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_REFRESH_ELEMENT(533) : views_pool.sql(7494) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_WORK_REFRESH_ELEMENT', 544+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_WORK_REFRESH_ELEMENT(545) : views_pool.sql(7506) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_WORK_REFRESH_ELEMENT;
ALTER FUNCTION FC_WBS_MY_WORK_REFRESH_ELEMENT COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_WBS_RES_PRJ_ASSIGNMENTS ==
CREATE OR REPLACE FUNCTION FC_WBS_RES_PRJ_ASSIGNMENTS
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_minute_per_day PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_manager_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_temp_resource_type IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_minute_per_day PLS_INTEGER := sh_h_minute_per_day;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_temp_rec_status VARCHAR2(1);
   h_temp PLS_INTEGER := 0;
   h_temp_reg_rate NUMBER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_edit_flag VARCHAR2(1);
   h_include_closed PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_proposed PLS_INTEGER := 0;
   h_closed_not_completed PLS_INTEGER := 0;
   h_not_closed_but_completed PLS_INTEGER := 0;
   h_not_closed_not_completed PLS_INTEGER := 0;
   h_ready_to_start_task_only PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00037 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR0035b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR00060 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_RES_PRJ_ASSIGNMENTS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_RES_PRJ_ASSIGNMENTS'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_RES_PRJ_ASSIGNMENTS(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_minute_per_day), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_manager_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_temp_resource_type || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 58+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_RES_PRJ_ASSIGNMENTS(59) : views_pool.sql(7581) : ' || SYSTIMESTAMP);
   END IF; 

   GetViewsPoolActiveRecordFlags(Coalesce(h_active_record, 0), h_include_closed, h_include_completed
                              , h_include_proposed, h_closed_not_completed
                              , h_not_closed_but_completed, h_not_closed_not_completed
                              , h_ready_to_start_task_only);
   
   --trace_printf("0_* h_resource_id: %d:%s, h_manager_id: %d:%s\n", h_resource_id_Ind,h_resource_id,h_manager_id_Ind,h_manager_id);
   --trace_printf("1_* h_project_id: %d:%s, h_id: %d:%s\n", h_project_id_Ind,h_project_id,h_id_Ind,h_id);
   
   BEGIN
      SELECT RANK, PROJECT_ID, MINUTE_PER_DAY
      INTO h_rank, h_project_id, h_minute_per_day
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id
      and type_id in (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_RES_PRJ_ASSIGNMENTS(82) : views_pool.sql(7604) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("1_* SC_STATE: %d, h_project_id: %d:%s,h_rank: %d:%s\n", SC_STATE,h_project_id_Ind,h_project_id,h_rank_Ind,h_rank);
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS OR (h_rank IS NULL) Then
      BEGIN
         SELECT RANK, PROJECT_ID
         INTO h_rank, h_project_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 99+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_RES_PRJ_ASSIGNMENTS(100) : views_pool.sql(7622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("2_* SC_STATE: %d, h_project_id: %d:%s,h_rank: %d:%s\n", SC_STATE,h_project_id_Ind,h_project_id,h_rank_Ind,h_rank);
      
      BEGIN
         SELECT MINUTE_PER_DAY
         INTO h_minute_per_day
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 116+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_RES_PRJ_ASSIGNMENTS(117) : views_pool.sql(7639) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_rec_status := NULL;
      
      BEGIN
         SELECT REC_STATUS INTO h_temp_rec_status FROM RESOURCES WHERE RESOURCE_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_RES_PRJ_ASSIGNMENTS(132) : views_pool.sql(7654) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_temp_rec_status IS NULL Then
         h_temp_resource_type := '0';
      Else
         h_temp_resource_type := '1';
      End If;
      
      h_temp := 0;
      PMO_DB2M.SC_STATE := FC_TMP_PRJ_DLV(h_id, h_rank, h_resource_id, h_temp, h_active_record);
      
      --trace_printf("\n -----> CR00037\n");
      
      OPEN CR00037 FOR SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID,
      T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD, A.START_DT, A.FD, A.FINISH_DT,
      P.MINUTE_PER_DAY, -1 AS DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
      A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
      A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
      A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC, A.EFFORT AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
      -1 AS ACTUAL_DURATION,
      A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
      (A.EFFORT-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = (A.EFFORT-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      A.MILESTONE_PERCENT,
      A.WORK_PERCENT,
      A.EFFORT AS WORK,
      T.SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      
      A.BILLABLE_REG_RATE AS REG_RATE,
      
      0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      h_temp_resource_type AS RESOURCE_TYPE, h_resource_id AS RESOURCE_ID, RA.PARTICIPANT,
      '' AS SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES, CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID, T.FS_CODE AS FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, P.CURRENCY_ID, P.EFFORT_DRIVEN ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
      A.MP_STATUS_DT,
      '' AS EDIT_FLAG, '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      
      FROM PMO_TMP_PRJ_DLV A JOIN TMT_WBS T ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.ELEMENT_ID
      JOIN TMT_WBS P ON P.PROJECT_ID = T.PROJECT_ID AND P.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = A.ELEMENT_ID AND RA.RESOURCE_ID = h_manager_id
      
      UNION ALL
      
      SELECT t.LEVEL_ID AS LEVEL_ID, CASE WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
      T.RANK, T.PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD, A.START_DT,
      case when T.FD = PMO_CNST.SC_AF then T.FD else A.FD end,
      A.FINISH_DT,
      P.MINUTE_PER_DAY,
      A.DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
      (A.BASELINE1_WORK) AS BASELINE1_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH,
      (A.PLANNED_WORK) AS PLANNED_EFFORT,
      A.PROPOSED_START, A.PROPOSED_FINISH,
      (A.PROPOSED_WORK) AS PROPOSED_EFFORT,
      A.SCHED_START, A.SCHED_FINISH,
      (A.SCHED_WORK) AS SCHED_EFFORT,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      A.ACTUAL_DURATION,
      (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
      (A.SCHED_WORK+A.PLANNED_WORK-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = (A.SCHED_WORK+A.PLANNED_WORK-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      CASE WHEN A.SCHED_DURATION > 0 THEN Trunc((PMO_ORASTD.TODECIMAL(A.ACTUAL_DURATION)/PMO_ORASTD.TODECIMAL(A.SCHED_DURATION))  * 10000) ELSE T.MILESTONE_PERCENT END AS MILESTONE_PERCENT,
      COALESCE(A.MILESTONE_PERCENT, T.WORK_PERCENT) AS WORK_PERCENT,
      A.SCHED_WORK+A.PLANNED_WORK AS WORK,
      0 AS SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      
      CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
      
      A.SPECIAL_RATE AS SPEC_RATE,
      A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT,
      RA.SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
      P.CURRENCY_ID,
      P.EFFORT_DRIVEN ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
      A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, A.UNITS_MSP AS UNITS_PERCENT,
      P.ELEMENT_NAME AS PROJECT_NAME,
      COALESCE(A.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
      A.REC_STATUS AS EDIT_FLAG,
      A.BIT_FLAG AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      
      FROM TASK_ASSIGNMENTS A
      JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
      AND T.PARENT_ID = h_id
      JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
      AND P.PROJECT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = A.TASK_ID
      AND RA.RESOURCE_ID = h_manager_id
      WHERE A.RESOURCE_ID = h_resource_id
      AND A.TASK_ID <> A.PROJECT_ID
      AND (h_include_proposed = 1 OR A.SCHED_START IS NOT NuLL)
      AND (h_closed_not_completed = 1 OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
      OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_not_completed = 1   OR (((A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      
      UNION ALL
      
      SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID,     -- task level
      T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      
      T.SD, T.START_DT, T.FD, T.FINISH_DT,
      
      P.MINUTE_PER_DAY,
      T.DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      T.BASELINE1_START AS BASELINE_START, T.BASELINE1_FINISH AS BASELINE_FINISH, T.BASELINE1_EFFORT AS BASELINE1_EFFORT,
      T.PLANNED_START, T.PLANNED_FINISH,
      0 AS PLANNED_EFFORT,
      T.PROPOSED_START, T.PROPOSED_FINISH,
      0 AS PROPOSED_EFFORT,
      T.SCHED_START, T.SCHED_FINISH,
      0 AS SCHED_EFFORT,
      T.FORECAST_START, T.FORECAST_FINISH,
      0 AS ETC,
      0 AS FORECAST_EFFORT, T.ACTUAL_START, T.ACTUAL_FINISH,
      T.ACTUAL_DURATION, 0 AS ACTUAL_EFFORT,
      0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      0 AS REMAINING_EFFORT,
      0 AS ETC_RED_FLAG,
      
      T.MILESTONE_PERCENT,
      T.WORK_PERCENT,
      0 AS WORK,
      T.SUBPROJECT_COUNT,
      
      0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_COST, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0 AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE, 0 BASELINE_VARIANCE, 0 AS REG_COST, 0 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, 0 AS R_BASELINE1_BUDGET, 0 AS R_ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_REVENUE, 0 AS R_CURRENT_BUDGET, 0 AS R_FORECAST_BUDGET, 0 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0 AS R_BUDGET_FORECAST_VARIANCE, 0 AS R_BASELINE_VARIANCE,
      0 AS REG_RATE, 0 AS SPEC_RATE,
      '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      RA.RESOURCE_TYPE, RA.RESOURCE_ID, PM.PARTICIPANT,
      PM.SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, RA.RES_ASSIGNMENT_ID AS TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
      
      P.CURRENCY_ID,  -- currency at task level is empty
      
      P.EFFORT_DRIVEN ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
      P.ELEMENT_NAME AS PROJECT_NAME,
      COALESCE(T.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
      
      case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0
      AND EXISTS (SELECT TA.REC_STATUS
      FROM TASK_ASSIGNMENTS TA
      WHERE TA.PROJECT_ID = T.PROJECT_ID
      AND TA.TASK_ID = T.ELEMENT_ID
      AND TA.REC_STATUS = 'E') then 'E'
      else 'U'
      end AS EDIT_FLAG,
      
      case when T.PLANNED_START IS NuLL AND T.SCHED_START IS NOT NuLL then '2' else '1' end AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      
      FROM RESOURCE_ASSIGNMENTS RA
      JOIN TMT_WBS T ON RA.RESOURCE_ID = h_resource_id
      AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
      AND BITAND(RA.PARTICIPANT,16) = 0
      AND T.ELEMENT_ID = RA.ELEMENT_ID
      AND T.PARENT_ID = h_id
      JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
      AND P.PROJECT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS PM ON PM.PROJECT_ID = RA.PROJECT_ID
      AND PM.ELEMENT_ID = RA.ELEMENT_ID
      AND PM.RESOURCE_ID = h_manager_id
      WHERE (h_include_proposed = 1 OR T.SCHED_START IS NOT NuLL)
      AND (h_closed_not_completed = 1 OR ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
      AND (h_not_closed_not_completed = 1   OR ((T.MILESTONE_PERCENT < 10000 OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929)) AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )) )
      ORDER BY RANK, PLANNED_START;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 453+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_RES_PRJ_ASSIGNMENTS(454) : views_pool.sql(7976) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR00037;
   Else
      --Get Resource Type
      BEGIN
         SELECT RESOURCE_TYPE
         INTO h_temp_resource_type
         FROM PROJECT_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 470+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_RES_PRJ_ASSIGNMENTS(471) : views_pool.sql(7993) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp := 1;
      PMO_DB2M.SC_STATE := FC_TMP_PRJ_DLV(h_id, h_rank, h_resource_id, h_temp, h_active_record);
      
      If SubStr(h_temp_resource_type, 1, 1) = '1' Then
         --STAFFING VIEW (WORKPACKAGE)  --> EXPAND PROFILE LEVEL
         
         --trace_printf("\n -----------> CR0035b \n ");
         
         OPEN CR0035b FOR SELECT  2 AS LEVEL_ID, 41 AS TYPE_ID, '----' AS RANK,     --Profile level
         h_project_id AS PARENT_ID,
         R.PROFILE_ID AS ELEMENT_ID,
         R.PROFILE_NAME AS ELEMENT_NAME, ' ' AS ACTIVE,
         1 AS CHILD_COUNT, 0 AS DELETED_COUNT,
         h_rec_status AS REC_STATUS,
         R.PROFILE_ID AS REC_USER,
         h_full_name AS REC_USER_NAME,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS REC_DATETIME,
         0 AS PRIORITY,
         R.PROFILE_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         0 AS MINUTE_PER_DAY, -1 AS DURATION,
         'N' AS RTF, 'N' AS EXCEPTIONS, 'N' AS DOCUMENTS, 'N' AS SCORECARDS, '0' AS PUBLISHED, 0 AS CONSTRAINT_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS CONSTRAINT_DT,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT,
         A.PLANNED_START, A.PLANNED_FINISH, A.PLANNED_WORK AS PLANNED_EFFORT,
         A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK AS PROPOSED_EFFORT,
         A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK AS SCHED_EFFORT,
         A.FORECAST_START, A.FORECAST_FINISH, A.ETC, A.EFFORT AS FORECAST_EFFORT,
         A.ACTUAL_START, A.ACTUAL_FINISH,
         -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
         A.EFFORT AS REMAINING_EFFORT, 0 AS ETC_RED_FLAG,
         0 AS MILESTONE_PERCENT,
         A.WORK_PERCENT,
         A.EFFORT AS WORK,
         0 AS SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET,
         A.PROPOSED_LABOR_COST, A.PLANNED_LABOR_COST AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, A.PLANNED_LABOR_COST AS REMAINING, (A.FORECAST_LABOR_COST-A.PLANNED_LABOR_COST) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN (A.PLANNED_LABOR_COST - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN A.PLANNED_WORK > 0.00 THEN ((A.PLANNED_LABOR_COST*60)/A.PLANNED_WORK) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         A.PLANNED_LABOR_REVENUE AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, (A.PLANNED_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, A.FORECAST_LABOR_REVENUE AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN (A.PLANNED_LABOR_REVENUE - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         A.BILLABLE_REG_RATE AS REG_RATE,
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING,
         h_project_id AS PROJECT_ID,
         0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID,
         '' AS REVISION, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
         '0' AS RESOURCE_TYPE,
         R.PROFILE_ID AS RESOURCE_ID,
         0 AS PARTICIPANT,
         '' AS SECURITY_ID,
         0 ASSIGN_COUNT,
         h_nick_name || ';' AS ASSIGN_NAMES,
         '' AS ASSIGNED,
         'N' AS CALENDAR_FLAG,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_CHECKIN,
         '' AS TSK_ASSIGNMENT_ID,
         '' AS FS_CODE,
         0 AS STAGE_ID,
         '' AS FS_LABOR_CODE,
         0 AS CURRENCY_ID,
         0 AS EFFORT_DRIVEN,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_SCHED_FINISH,
         0 AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_PLANNED_FINISH,
         0 AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0 AS ESTIMATED_BASELINE1_EFFORT,
         0.00 AS ESTIMATED_BASELINE1_COST,
         0.00 AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
         A.MP_STATUS_DT AS MP_STATUS_DT,
         '' AS EDIT_FLAG, '' AS BIT_FLAG,
         0 as LEVEL_TOTAL_SLACK
         FROM PMO_TMP_PRJ_DLV A, PROFILES R
         WHERE A.PROJECT_ID = h_project_id AND R.PROFILE_ID = h_resource_id
         
         UNION ALL
         
         SELECT  3 AS LEVEL_ID, T.TYPE_ID,
         T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME,
         T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         P.MINUTE_PER_DAY, -1 AS DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC, A.EFFORT AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
         (A.EFFORT-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         0 AS MILESTONE_PERCENT,
         A.WORK_PERCENT,
         A.EFFORT AS WORK,
         T.SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         A.BILLABLE_REG_RATE AS REG_RATE,
         
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER,  T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         h_temp_resource_type AS RESOURCE_TYPE, h_resource_id AS RESOURCE_ID,
         0 AS PARTICIPANT, '' AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
         0 AS CURRENCY_ID,
         P.EFFORT_DRIVEN  ,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
         A.MP_STATUS_DT AS MP_STATUS_DT,
         '' AS EDIT_FLAG, '' AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM PMO_TMP_PRJ_DLV A
         JOIN TMT_WBS T
         ON T.PROJECT_ID = A.PROJECT_ID
         AND T.ELEMENT_ID = A.ELEMENT_ID
         AND T.ELEMENT_ID <> h_id
         JOIN TMT_WBS P
         ON P.PROJECT_ID = T.PROJECT_ID
         AND P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R
         ON R.RESOURCE_ID = T.REC_USER
         
         UNION ALL
         
         SELECT  CASE WHEN T.PARENT_ID = A.PROJECT_ID THEN 3 ELSE 4 END AS LEVEL_ID,
         CASE WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
         T.RANK, T.PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME,
         T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT, P.MINUTE_PER_DAY,
         A.DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
         (A.BASELINE1_WORK) AS BASELINE1_EFFORT,
         A.PLANNED_START, A.PLANNED_FINISH,
         (A.PLANNED_WORK) AS PLANNED_EFFORT,
         A.PROPOSED_START, A.PROPOSED_FINISH,
         (A.PROPOSED_WORK) AS PROPOSED_EFFORT,
         A.SCHED_START, A.SCHED_FINISH,
         (A.SCHED_WORK) AS SCHED_EFFORT,
         A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
         A.ACTUAL_START, A.ACTUAL_FINISH,
         A.ACTUAL_DURATION, (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) AS ETC_RED_FLAG,
         0 AS MILESTONE_PERCENT,
         COALESCE(A.MILESTONE_PERCENT, T.WORK_PERCENT) AS WORK_PERCENT,
         (A.SCHED_WORK+A.PLANNED_WORK) AS WORK,
         0 AS SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
         
         A.SPECIAL_RATE AS SPEC_RATE,
         A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         A.RESOURCE_TYPE, A.RESOURCE_ID,
         0 AS PARTICIPANT, '' AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
         0 AS CURRENCY_ID, P.EFFORT_DRIVEN  ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
         A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
         A.LEVEL_START           AS LEVEL_START,
         A.LEVEL_FINISH          AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, COALESCE(A.UNITS_MSP, 0) AS UNITS_PERCENT,'' AS PROJECT_NAME,
         COALESCE(A.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
         A.REC_STATUS AS EDIT_FLAG,
         A.BIT_FLAG AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM TASK_ASSIGNMENTS A
         JOIN TMT_WBS T
         ON T.PROJECT_ID = A.PROJECT_ID
         AND T.ELEMENT_ID = A.TASK_ID
         AND T.PARENT_ID = T.PROJECT_ID
         JOIN TMT_WBS P
         ON P.PROJECT_ID = T.PROJECT_ID
         AND P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R
         ON R.RESOURCE_ID = T.REC_USER
         WHERE A.RESOURCE_ID = h_resource_id
         AND A.PROJECT_ID = h_id
         AND A.TASK_ID <> A.PROJECT_ID
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 770+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_RES_PRJ_ASSIGNMENTS(771) : views_pool.sql(8293) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CR0035b;
      Else
         PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_project_id, h_manager_id, PMO_CNST.SC_TASK);
         
         -- STAFFING VIEW (WORKPACKAGE) EXPAND RESOURCE LEVEL
         
         --trace_printf("\n-----> CR00060\n");
         
         --trace_printf("\n-----> h_include_proposed:%d\n", h_include_proposed);
         --trace_printf("\n-----> h_closed_not_completed:%d\n", h_closed_not_completed);
         --trace_printf("\n-----> h_not_closed_but_completed:%d\n", h_not_closed_but_completed);
         --trace_printf("\n-----> h_not_closed_not_completed:%d\n", h_not_closed_not_completed);
         
         --trace_printf("\n-----> h_id:%s\n", h_id);
         --trace_printf("\n-----> h_resource_id:%s\n", h_resource_id);
         
         OPEN CR00060 FOR -- resource level
         SELECT  2 AS LEVEL_ID, 13 AS TYPE_ID, '----' AS RANK,
         h_project_id AS PARENT_ID,
         R.RESOURCE_ID AS ELEMENT_ID,
         R.FULL_NAME AS ELEMENT_NAME, R.ACTIVE,
         1 AS CHILD_COUNT, 0 AS DELETED_COUNT,
         h_rec_status AS REC_STATUS,
         R.RESOURCE_ID AS REC_USER,
         h_full_name AS REC_USER_NAME,
         R.REC_DATETIME AS REC_DATETIME,
         0 AS PRIORITY,
         R.RESOURCE_ID AS ORIGINAL_ID,
         
         0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
         
         480 AS MINUTE_PER_DAY, -1 AS DURATION,
         'N' AS RTF, 'N' AS EXCEPTIONS, 'N' AS DOCUMENTS, 'N' AS SCORECARDS, '0' AS PUBLISHED, 0 AS CONSTRAINT_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS CONSTRAINT_DT,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH, 0 AS BASELINE1_EFFORT,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH, 0 AS PLANNED_EFFORT,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH, 0 AS PROPOSED_EFFORT,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH, 0 AS SCHED_EFFORT,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH, 0 AS ETC, 0 AS FORECAST_EFFORT,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
         -1 AS ACTUAL_DURATION,
         0 AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
         0 AS REMAINING_EFFORT, 0 AS ETC_RED_FLAG,
         0 AS MILESTONE_PERCENT,
         0 AS WORK_PERCENT,
         0 AS WORK,
         0 AS SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS REMAINING,
         0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE, 0.00 AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING,
         0.00 AS R_BUDGET_FORECAST_VARIANCE, 0.00 AS R_BASELINE_VARIANCE, 0.00 AS REG_RATE, 0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING,
         h_project_id AS PROJECT_ID,
         0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID,
         '' AS REVISION, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT,
         '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
         '0' AS RESOURCE_TYPE,
         R.RESOURCE_ID,
         0 AS PARTICIPANT,
         '' AS SECURITY_ID,
         0 ASSIGN_COUNT,
         h_nick_name || ';' AS ASSIGN_NAMES,
         '' AS ASSIGNED,
         CASE WHEN R.CALENDAR_ID IS NOT NULL THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
         R.REC_DATETIME AS LAST_CHECKIN,
         '' AS TSK_ASSIGNMENT_ID,
         R.FS_CODE,
         0 AS STAGE_ID,
         R.FS_LABOR_CODE,
         R.CURRENCY_ID,
         0 AS EFFORT_DRIVEN,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_SCHED_FINISH,
         0 AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_PLANNED_FINISH,
         0 AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0 AS ESTIMATED_BASELINE1_EFFORT,
         0.00 AS ESTIMATED_BASELINE1_COST,
         0.00 AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,'' AS PROJECT_NAME,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS MP_STATUS_DT,
         '' AS EDIT_FLAG, '' AS BIT_FLAG,
         0 as LEVEL_TOTAL_SLACK
         FROM RESOURCES R
         WHERE R.RESOURCE_ID = h_resource_id
         
         UNION ALL
         
         SELECT  3 AS LEVEL_ID, T.TYPE_ID, T.RANK,      -- deliverable level
         h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         
         P.MINUTE_PER_DAY, -1 AS DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC, A.EFFORT AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         -1 AS ACTUAL_DURATION,
         A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
         (A.EFFORT - A.WORK_TODATE) AS REMAINING_EFFORT,
         ABS(SIGN(A.ETC - (A.EFFORT - A.WORK_TODATE))) AS ETC_RED_FLAG,
         
         -1 AS MILESTONE_PERCENT,
         A.WORK_PERCENT,
         A.EFFORT AS WORK,
         T.SUBPROJECT_COUNT,
         
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         A.BILLABLE_REG_RATE AS REG_RATE,
         
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         h_temp_resource_type AS RESOURCE_TYPE, h_resource_id AS RESOURCE_ID,
         0 AS PARTICIPANT, PTS.SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES, CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
         
         P.CURRENCY_ID,    -- currency at deliverable level is empty
         
         P.EFFORT_DRIVEN  ,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         P.ELEMENT_NAME AS PROJECT_NAME,
         A.MP_STATUS_DT AS MP_STATUS_DT,
         '' AS EDIT_FLAG, '' AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM PMO_TMP_PRJ_DLV A
         JOIN TMT_WBS T
         ON T.PROJECT_ID = h_id
         AND T.ELEMENT_ID = A.ELEMENT_ID
         AND T.ELEMENT_ID <> h_id
         JOIN TMT_WBS P
         ON P.PROJECT_ID = T.PROJECT_ID
         AND P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R
         ON R.RESOURCE_ID = T.REC_USER
         LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.ELEMENT_ID
         
         UNION ALL
         
         SELECT  CASE WHEN T.PARENT_ID = RA.PROJECT_ID THEN 3 ELSE 4 END AS LEVEL_ID,    -- task, assignment level
         case when A.TSK_ASSIGNMENT_ID IS null then T.TYPE_ID WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN ELSE PMO_CNST.SC_TASK_ASSN END AS TYPE_ID,
         T.RANK,
         case when h_project_id = T.PARENT_ID then h_resource_id else T.PARENT_ID end AS PARENT_ID,
         case when A.TSK_ASSIGNMENT_ID IS null then T.ELEMENT_ID else A.TSK_ASSIGNMENT_ID end as ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE, T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         
         case when A.TSK_ASSIGNMENT_ID IS null then  T.SD         else A.SD          end as SD,
         case when A.TSK_ASSIGNMENT_ID IS null then  T.START_DT   else A.START_DT    end as START_DT,
         case when (A.TSK_ASSIGNMENT_ID IS null) OR T.FD = PMO_CNST.SC_AF then    T.FD         else A.FD  end as FD,
         case when A.TSK_ASSIGNMENT_ID IS null then  T.FINISH_DT  else A.FINISH_DT   end as FINISH_DT,
         
         P.MINUTE_PER_DAY,
         case when A.TSK_ASSIGNMENT_ID IS null then T.DURATION    else A.DURATION    end as DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_START   else A.BASELINE1_START  end as BASELINE_START,
         case when A.TSK_ASSIGNMENT_ID IS null then T.BASELINE1_FINISH  else A.BASELINE1_FINISH end as BASELINE_FINISH,
         COALESCE(A.BASELINE1_WORK,0) AS BASELINE1_EFFORT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_START      else A.PLANNED_START    end as PLANNED_START,
         case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_FINISH     else A.PLANNED_FINISH   end as PLANNED_FINISH,
         case when A.TSK_ASSIGNMENT_ID IS null then CASE WHEN T.SCHED_DURATION = 0 THEN T.TOTAL_DURATION ELSE 0 END  else A.PLANNED_WORK end as PLANNED_EFFORT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_START     else A.PROPOSED_START   end as PROPOSED_START,
         case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_FINISH    else A.PROPOSED_FINISH  end as PROPOSED_FINISH,
         case when A.TSK_ASSIGNMENT_ID IS null then T.PROPOSED_EFFORT    else A.PROPOSED_WORK    end as PROPOSED_EFFORT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_START        else A.SCHED_START      end as SCHED_START,
         case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_FINISH       else A.SCHED_FINISH     end as SCHED_FINISH,
         case when A.TSK_ASSIGNMENT_ID IS null then T.SCHED_EFFORT       else A.SCHED_WORK       end as SCHED_EFFORT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_START     else A.FORECAST_START   end as FORECAST_START,
         case when A.TSK_ASSIGNMENT_ID IS null then T.FORECAST_FINISH    else A.FORECAST_FINISH  end as FORECAST_FINISH,
         case when A.TSK_ASSIGNMENT_ID IS null then T.ETC                else A.ETC              end as ETC,
         (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_START       else A.ACTUAL_START     end as ACTUAL_START,
         case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_FINISH      else A.ACTUAL_FINISH    end as ACTUAL_FINISH,
         case when A.TSK_ASSIGNMENT_ID IS null then T.ACTUAL_DURATION    else A.ACTUAL_DURATION  end as ACTUAL_DURATION,
         case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_TODATE        else A.WORK_TODATE      end as ACTUAL_EFFORT,
         COALESCE(A.REGULAR_TODATE,0) AS REGULAR_TODATE,
         COALESCE(A.SPECIAL_TODATE,0) AS SPECIAL_TODATE,
         case when A.TSK_ASSIGNMENT_ID IS null then (T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE else (A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE end as REMAINING_EFFORT,
         case when A.TSK_ASSIGNMENT_ID IS null then ABS(SIGN(T.ETC - ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE)))
         else ABS(SIGN(A.ETC - ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE))) end as ETC_RED_FLAG,
         case when A.TSK_ASSIGNMENT_ID IS null then T.MILESTONE_PERCENT else /*CASE WHEN A.SCHED_DURATION > 0 THEN INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000) ELSE 0 END*/ -1   end as MILESTONE_PERCENT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.WORK_PERCENT      else A.MILESTONE_PERCENT end as WORK_PERCENT,
         case when A.TSK_ASSIGNMENT_ID IS null then T.PLANNED_EFFORT + T.SCHED_EFFORT else A.PLANNED_WORK + A.SCHED_WORK end as WORK,
         0 AS SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
         A.SPECIAL_RATE AS SPEC_RATE,
         A.ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT, CASE WHEN PTS.SECURITY_ID IS NuLL THEN RA.SECURITY_ID ELSE PTS.SECURITY_ID || RA.SECURITY_ID END AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE,
         P.CURRENCY_ID,    -- currency at task level is empty
         P.EFFORT_DRIVEN,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
         A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
         A.LEVEL_START           AS LEVEL_START,
         A.LEVEL_FINISH          AS LEVEL_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, COALESCE(A.UNITS_MSP,0) as UNITS_PERCENT,
         P.ELEMENT_NAME AS PROJECT_NAME,
         COALESCE(COALESCE(A.REC_DATETIME, T.MP_STATUS_DT), TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
         
         case when A.TSK_ASSIGNMENT_ID is NuLL then
         case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0 AND
         EXISTS (SELECT TA.REC_STATUS FROM TASK_ASSIGNMENTS TA
         WHERE TA.PROJECT_ID = T.PROJECT_ID
         AND TA.TASK_ID = T.ELEMENT_ID
         AND TA.REC_STATUS = 'E') then 'E'
         else 'U'
         end
         else
         A.REC_STATUS
         end AS EDIT_FLAG,
         
         case when (T.SCHED_EFFORT > 0 AND COALESCE(A.PLANNED_WORK, T.PLANNED_EFFORT) = 0) OR
         ((T.PLANNED_EFFORT + T.SCHED_EFFORT) = 0 AND COALESCE(A.SCHED_START,T.SCHED_START) IS NOT NuLL)
         then '2' else '1' end AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM RESOURCE_ASSIGNMENTS RA
         JOIN TMT_WBS T
         ON T.PROJECT_ID = RA.PROJECT_ID
         AND T.ELEMENT_ID = RA.ELEMENT_ID
         AND T.PARENT_ID = T.PROJECT_ID
         JOIN TMT_WBS P
         ON P.PROJECT_ID = T.PROJECT_ID
         AND P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R
         ON R.RESOURCE_ID = T.REC_USER
         LEFT JOIN TASK_ASSIGNMENTS A
         ON A.PROJECT_ID = RA.PROJECT_ID
         AND A.TASK_ID = RA.ELEMENT_ID
         AND A.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
         LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
         WHERE RA.RESOURCE_ID = h_resource_id
         AND RA.PROJECT_ID = h_id
         AND RA.ELEMENT_ID <> RA.PROJECT_ID
         AND RA.ELEMENT_TYPE IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
         
         AND (h_include_proposed = 1           OR (case when A.TSK_ASSIGNMENT_ID IS NOT NuLL AND A.SCHED_START IS NOT NuLL then 1
         when A.TSK_ASSIGNMENT_ID IS NuLL AND T.SCHED_START IS NOT NuLL then 1
         else 0 end) = 1)
         AND (h_closed_not_completed = 1 OR
         ((((case when A.TSK_ASSIGNMENT_ID IS NOT NuLL AND A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when A.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         OR T.STAGE_ID IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_but_completed = 1   OR (T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         AND (h_not_closed_not_completed = 1   OR
         ((((case when A.TSK_ASSIGNMENT_ID IS NOT NuLL AND A.MILESTONE_PERCENT < 10000 AND T.MILESTONE_PERCENT < 10000 then 1
         when A.TSK_ASSIGNMENT_ID IS NuLL AND T.MILESTONE_PERCENT < 10000 then 1
         else 0 end) = 1) OR T.STAGE_ID NOT IN (5490, 4948, 5520, 4909, 5416, 5385, 6116, 4938, 4919, 4929))
         AND T.STAGE_ID NOT IN (4949, 5491, 5521, 4910, 4920, 4930, 4939, 5386, 5417, 6117   )))
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 1132+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_RES_PRJ_ASSIGNMENTS(1133) : views_pool.sql(8655) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CR00060;
      End If;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 1141+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_RES_PRJ_ASSIGNMENTS(1142) : views_pool.sql(8664) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_RES_PRJ_ASSIGNMENTS', 1153+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_RES_PRJ_ASSIGNMENTS(1154) : views_pool.sql(8676) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_RES_PRJ_ASSIGNMENTS;
ALTER FUNCTION FC_WBS_RES_PRJ_ASSIGNMENTS COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_WBS_MY_TEAM_REFRESH_ELEMENT ==
CREATE OR REPLACE FUNCTION FC_WBS_MY_TEAM_REFRESH_ELEMENT
(
     sh_h_type_id PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , sh_h_count PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_manager_id IN OUT NOCOPY VARCHAR2
   , sh_h_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_count PLS_INTEGER := sh_h_count;
   h_active_record PLS_INTEGER := sh_h_active_record;
   h_temp PLS_INTEGER := 0;
   h_pool_level_id PLS_INTEGER := 0;
   h_edit_flag VARCHAR2(1);
   h_task_id VARCHAR2(32);
   h_executive_security VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_executive_project PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_tree_type PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0051a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR0051b PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR0051d PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR0051c PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_WBS_MY_TEAM_REFRESH_ELEMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_WBS_MY_TEAM_REFRESH_ELEMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_WBS_MY_TEAM_REFRESH_ELEMENT(' || 
       COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_count), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_manager_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 55+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_WBS_MY_TEAM_REFRESH_ELEMENT(56) : views_pool.sql(8748) : ' || SYSTIMESTAMP);
   END IF; 

   If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      h_temp_var := 1;
      h_tree_type := PMO_CNST.SC_TABLE_ATTRIBUTE;
      null_return := FC_GET_SELECTED_PROJECTS(h_tree_type, h_id, h_manager_id, h_temp_var);
      
      h_executive_project := 0;
      
      BEGIN
         SELECT COUNT(ELEMENT_ID)
         INTO h_executive_project
         FROM PMO_TMP_PROJECTS_01
         WHERE ELEMENT_ID = h_id
         AND PROJECT_FLAG IS NOT NuLL
         AND PROJECT_FLAG >= PMO_CNST.SC_EXECUTIVE_PROJECT;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_REFRESH_ELEMENT(79) : views_pool.sql(8771) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_executive_project, 0) <> 0 Then
         BEGIN
            SELECT EXECUTIVE_SECURITY
            INTO h_executive_security
            FROM RESOURCES
            WHERE RESOURCE_ID = h_manager_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 95+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_REFRESH_ELEMENT(96) : views_pool.sql(8788) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_id, h_manager_id, PMO_CNST.SC_PROJECT);
      
      h_temp := 0;
      
      --refresh project
      --resource id must be the pm id
      
      --trace_printf("\n--------->CR0051a\n");
      
      OPEN CR0051a FOR SELECT 1 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      1 AS CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      T.SD, T.START_DT, T.FD, T.FINISH_DT, T.MINUTE_PER_DAY,  T.DURATION,
      CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
      CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
      T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
      T.BASELINE1_START AS BASELINE_START, 
      T.BASELINE1_FINISH AS BASELINE_FINISH, 
      T.BASELINE1_EFFORT AS BASELINE1_EFFORT,
      T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_EFFORT,
      T.PROPOSED_START, T.PROPOSED_FINISH, T.PROPOSED_EFFORT,
      T.SCHED_START, T.SCHED_FINISH, T.SCHED_EFFORT,
      T.FORECAST_START, T.FORECAST_FINISH, T.ETC, (T.SCHED_EFFORT + T.PLANNED_EFFORT) AS FORECAST_EFFORT,
      T.ACTUAL_START, T.ACTUAL_FINISH,
      T.ACTUAL_DURATION,
      T.WORK_TODATE AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
      ((T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN T.ETC = ((T.SCHED_EFFORT + T.PLANNED_EFFORT) - T.WORK_TODATE) THEN 0 else 1 END AS ETC_RED_FLAG,
      -1 AS MILESTONE_PERCENT,
      T.WORK_PERCENT,
      (T.SCHED_EFFORT + T.PLANNED_EFFORT) AS WORK,
      T.SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, 0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST, 0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS REMAINING, 0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE, 0.00 AS REG_COST, 0.00 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET, 0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET, 0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE, 0.00 AS R_BASELINE_VARIANCE,
      
      0.00 AS REG_RATE,0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, '1' AS RESOURCE_TYPE,
      h_resource_id AS RESOURCE_ID, RA.PARTICIPANT,
      
      case when h_executive_project = 1 then h_executive_security
      else COALESCE(PTS.SECURITY_ID, '') || COALESCE(RA.SECURITY_ID, '') end AS SECURITY_ID,
      
      T.ASSIGN_COUNT, T.ASSIGN_NAMES, 'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
      T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID,
      T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, T.CURRENCY_ID, T.EFFORT_DRIVEN  ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      T.BUBBLE_COLOR AS BUBBLE_COLOR,
      T.BUBBLE_PUBLISHED_DT AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT, '' AS PROJECT_NAME,
      COALESCE(T.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00')) AS MP_STATUS_DT,
      '' AS EDIT_FLAG, '' AS BIT_FLAG,
      (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
      FROM TMT_WBS T JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = T.ELEMENT_ID AND RA.RESOURCE_ID = h_resource_id
      LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = RA.ELEMENT_ID
      WHERE T.PROJECT_ID = h_id AND T.ELEMENT_ID = h_id
      ORDER BY RANK, PLANNED_START;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 188+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TEAM_REFRESH_ELEMENT(189) : views_pool.sql(8881) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR0051a;
   Else
      --refresh task or milestone
      If isWBSTask(Coalesce(h_type_id, 0)) <> 0 OR Coalesce(h_type_id, 0) = PMO_CNST.SC_TASK_ASSN Then
         If isWBSTask(Coalesce(h_type_id, 0)) <> 0 Then
            h_count := 0;
         Else
            h_type_id := PMO_CNST.SC_TASK;
            h_count := 1;
         End If;
         
         PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_project_id, h_manager_id, PMO_CNST.SC_TASK);
         
         If Coalesce(h_count, 0) = 0 Then
            --trace_printf("\n-------->CR0051b\n");
            
            OPEN CR0051b FOR SELECT P.LEVEL_ID + 3 LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
            T.ELEMENT_NAME, ' ' AS ACTIVE,
            T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
            R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
            T.SD, T.START_DT, T.FD, T.FINISH_DT,
            W.MINUTE_PER_DAY AS MINUTE_PER_DAY,
            T.DURATION,
            CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
            CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
            T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
            T.BASELINE1_START AS BASELINE_START, T.BASELINE1_FINISH AS BASELINE_FINISH,
            (T.BASELINE1_EFFORT) AS BASELINE1_EFFORT, T.PLANNED_START, T.PLANNED_FINISH,
            T.PLANNED_EFFORT, T.PROPOSED_START, T.PROPOSED_FINISH,
            T.PROPOSED_EFFORT, T.SCHED_START, T.SCHED_FINISH,
            T.SCHED_EFFORT, T.FORECAST_START, T.FORECAST_FINISH,
            T.ETC AS ETC, (T.WORK_TODATE + T.ETC) AS FORECAST_EFFORT, T.ACTUAL_START, T.ACTUAL_FINISH,
            (T.ACTUAL_DURATION) AS ACTUAL_DURATION,
            (T.WORK_TODATE) AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE,
            ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) AS REMAINING_EFFORT,
            CASE WHEN T.ETC = ((T.SCHED_EFFORT+T.PLANNED_EFFORT)-T.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
            T.MILESTONE_PERCENT,
            T.WORK_PERCENT, (T.SCHED_EFFORT+T.PLANNED_EFFORT) AS WORK,
            T.SUBPROJECT_COUNT,
            0.00 AS X_ESTIMATION_BUDGET, 0 AS BASELINE1_BUDGET, 0 AS ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_COST, 0 AS CURRENT_BUDGET, 0 AS FORECAST_BUDGET, 0 AS ACTUAL_BUDGET, 0 AS REMAINING, 0 AS BUDGET_FORECAST_VARIANCE, 0 AS BASELINE_VARIANCE, 0 AS REG_COST, 0 AS SPEC_COST,
            0.00 AS X_R_ESTIMATION_BUDGET, 0 AS R_BASELINE1_BUDGET, 0 AS R_ESTIMATION_BUDGET, 0 AS PROPOSED_LABOR_REVENUE, 0 AS R_CURRENT_BUDGET, 0 AS R_FORECAST_BUDGET, 0 AS R_ACTUAL_BUDGET, 0 AS R_REMAINING, 0 AS R_BUDGET_FORECAST_VARIANCE, 0 AS R_BASELINE_VARIANCE,
            
            0 AS REG_RATE,
            
            0 AS SPEC_RATE,
            '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
            RA.RESOURCE_TYPE, RA.RESOURCE_ID, RA.PARTICIPANT,
            COALESCE(PTS.SECURITY_ID, '') || COALESCE(RA.SECURITY_ID, '') AS SECURITY_ID,
            T.ASSIGN_COUNT, T.ASSIGN_NAMES,
            CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
            T.LAST_CHECKIN AS LAST_CHECKIN, RA.RES_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, W.CURRENCY_ID, W.EFFORT_DRIVEN  ,
            
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
            0    AS ESTIMATED_SCHED_EFFORT,
            0.00 AS ESTIMATED_SCHED_COST,
            0.00 AS ESTIMATED_SCHED_REVENUE,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
            0    AS ESTIMATED_PLANNED_EFFORT,
            0.00 AS ESTIMATED_PLANNED_COST,
            0.00 AS ESTIMATED_PLANNED_REVENUE,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
            ''                               AS LEVEL_ASSIGN_STRING,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
            
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
            0                            AS ESTIMATED_BASELINE1_EFFORT,
            0.00                         AS ESTIMATED_BASELINE1_COST,
            0.00                         AS ESTIMATED_BASELINE1_REVENUE,
            
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
            0                            AS ESTIMATED_BASELINE3_EFFORT,
            0.00                         AS ESTIMATED_BASELINE3_COST,
            0.00                         AS ESTIMATED_BASELINE3_REVENUE,
            
            0 AS BUBBLE_COLOR,
            TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
            W.ELEMENT_NAME AS PROJECT_NAME,
            COALESCE(T.MP_STATUS_DT, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
            
            case when (T.PLANNED_EFFORT + T.SCHED_EFFORT) > 0
            AND EXISTS (SELECT TA.REC_STATUS
            FROM TASK_ASSIGNMENTS TA
            WHERE TA.PROJECT_ID = T.PROJECT_ID
            AND TA.TASK_ID = T.ELEMENT_ID
            AND TA.REC_STATUS = 'E') then 'E'
            else 'U'
            end AS EDIT_FLAG,
            
            case when T.PLANNED_START IS NuLL AND T.SCHED_START IS NOT NuLL then '2' else '1' end AS BIT_FLAG,
            (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
            FROM RESOURCE_ASSIGNMENTS RA JOIN TMT_POOLS P ON P.ELEMENT_ID = RA.RESOURCE_ID
            JOIN TMT_WBS T ON T.ELEMENT_ID = RA.ELEMENT_ID
            JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID
            JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
            LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
            WHERE RA.RESOURCE_ID = h_resource_id AND RA.ELEMENT_ID = h_id
            ORDER BY RANK, PLANNED_START;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 296+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TEAM_REFRESH_ELEMENT(297) : views_pool.sql(8989) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN CR0051b;
         Else
            h_parent_id := NULL;
            BEGIN
               SELECT PROJECT_ID INTO h_parent_id
               FROM TMT_WBS WHERE TYPE_ID = PMO_CNST.SC_RESOURCE AND POOL_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 310+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_REFRESH_ELEMENT(311) : views_pool.sql(9003) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            -- Fetch required TMT_POOLS information
            BEGIN
               SELECT LEVEL_ID
               INTO h_pool_level_id
               FROM TMT_POOLS
               WHERE ELEMENT_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 327+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_REFRESH_ELEMENT(328) : views_pool.sql(9020) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("\n h_id:%s", h_id);
            --trace_printf("\n h_resource_id:%s", h_resource_id);
            
            --trace_printf("\n-------->CR0051d  \n");
            
            OPEN CR0051d FOR SELECT h_pool_level_id + 3 LEVEL_ID, CASE WHEN T.TYPE_ID = PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN PMO_CNST.SC_WBS_CHANGE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_RISK_TASK THEN PMO_CNST.SC_WBS_RISK_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ISSUE_TASK THEN PMO_CNST.SC_WBS_ISSUE_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_DEFECT_TASK THEN PMO_CNST.SC_WBS_DEFECT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN PMO_CNST.SC_WBS_SERVICE_REQUEST_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN PMO_CNST.SC_WBS_REQUIREMENT_ASSN WHEN T.TYPE_ID = PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN PMO_CNST.SC_WBS_ACTION_ITEM_ASSN ELSE CASE WHEN T.PROJECT_ID = h_parent_id THEN PMO_CNST.SC_PERSONAL_TASK ELSE PMO_CNST.SC_TASK_ASSN END END AS TYPE_ID, T.RANK,
            h_resource_id AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID,
            T.ELEMENT_NAME, ' ' AS ACTIVE,
            T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
            R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
            A.SD, A.START_DT,
            case when T.FD = PMO_CNST.SC_AF then T.FD else A.FD end AS FD, A.FINISH_DT,
            W.MINUTE_PER_DAY AS MINUTE_PER_DAY, A.DURATION,
            CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
            CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
            T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
            A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
            (A.BASELINE1_WORK) AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
            (A.PLANNED_WORK) AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
            (A.PROPOSED_WORK) AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
            (A.SCHED_WORK) AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
            A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
            A.ACTUAL_DURATION, (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
            ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
            CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
            CASE WHEN h_pool_level_id = 0 THEN 0 ELSE
            CASE WHEN COALESCE(A.SCHED_DURATION, 0) > 0 THEN /*INT((DECIMAL(A.ACTUAL_DURATION)/DECIMAL(A.SCHED_DURATION)) * 10000)*/ -1 ELSE T.MILESTONE_PERCENT END END AS MILESTONE_PERCENT,
            COALESCE(A.MILESTONE_PERCENT, T.WORK_PERCENT) AS WORK_PERCENT,
            (A.PLANNED_WORK+A.SCHED_WORK) AS WORK,
            0 AS SUBPROJECT_COUNT,
            0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
            (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
            (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
            A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
            0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
            (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
            A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
            
            CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
            
            A.SPECIAL_RATE AS SPEC_RATE,
            A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
            A.RESOURCE_TYPE, A.RESOURCE_ID, RA.PARTICIPANT,
            COALESCE(PTS.SECURITY_ID, '') || COALESCE(RA.SECURITY_ID, '') AS SECURITY_ID,
            T.ASSIGN_COUNT, T.ASSIGN_NAMES,
            CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
            T.LAST_CHECKIN AS LAST_CHECKIN, A.TSK_ASSIGNMENT_ID, T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, W.CURRENCY_ID, W.EFFORT_DRIVEN  ,
            
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
            0    AS ESTIMATED_SCHED_EFFORT,
            0.00 AS ESTIMATED_SCHED_COST,
            0.00 AS ESTIMATED_SCHED_REVENUE,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
            0    AS ESTIMATED_PLANNED_EFFORT,
            0.00 AS ESTIMATED_PLANNED_COST,
            0.00 AS ESTIMATED_PLANNED_REVENUE,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_PLANNED_FINISH,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LEVEL_SCHED_FINISH,
            A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
            A.LEVEL_START           AS LEVEL_START,
            A.LEVEL_FINISH          AS LEVEL_FINISH,
            
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
            0                            AS ESTIMATED_BASELINE1_EFFORT,
            0.00                         AS ESTIMATED_BASELINE1_COST,
            0.00                         AS ESTIMATED_BASELINE1_REVENUE,
            
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
            TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
            0                            AS ESTIMATED_BASELINE3_EFFORT,
            0.00                         AS ESTIMATED_BASELINE3_COST,
            0.00                         AS ESTIMATED_BASELINE3_REVENUE,
            
            0 AS BUBBLE_COLOR,
            TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, A.UNITS_MSP AS UNITS_PERCENT,
            W.ELEMENT_NAME AS PROJECT_NAME,
            COALESCE(A.REC_DATETIME, TO_TIMESTAMP('1899-01-01 12:00:00.000000')) AS MP_STATUS_DT,
            A.REC_STATUS AS EDIT_FLAG, A.BIT_FLAG,
            (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
            FROM TASK_ASSIGNMENTS A
            JOIN RESOURCE_ASSIGNMENTS RA ON RA.RES_ASSIGNMENT_ID = A.RES_ASSIGNMENT_ID
            JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
            JOIN TMT_WBS W ON W.ELEMENT_ID = T.PROJECT_ID
            JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
            LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = T.PARENT_ID
            WHERE A.RESOURCE_ID = h_resource_id
            AND A.TASK_ID = h_id
            AND A.TASK_ID <> A.PROJECT_ID
            ORDER BY RANK, PLANNED_START;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 427+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TEAM_REFRESH_ELEMENT(428) : views_pool.sql(9120) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN CR0051d;
         End If;
      Else
         --refresh deliverable, work_product, summary_task
         
         h_temp := 0;
         
         PMO_DB2M.SC_STATE := FC_TMP_PRJ_DLV(h_id, h_rank, h_resource_id, h_temp, h_active_record);
         PMO_DB2M.SC_STATE := FC_TMP_SECURITY(h_project_id, h_manager_id, PMO_CNST.SC_DELIVERABLE);
         
         --trace_printf("\n-------->CR0051c\n");
         
         OPEN CR0051c FOR SELECT 3 AS LEVEL_ID, T.TYPE_ID, T.RANK, T.PARENT_ID, T.ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME, T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         P.MINUTE_PER_DAY,  -1 AS DURATION,
         CASE WHEN T.RTF_BITS > 0 THEN 'Y' ELSE 'N' END AS RTF, CASE WHEN T.CRI_COUNT > 0 THEN 'Y' ELSE 'N' END AS EXCEPTIONS, CASE WHEN T.DOC_COUNT > 0 THEN 'Y' ELSE 'N' END AS DOCUMENTS,
         CASE WHEN T.SCORECARD_COUNT > 0 THEN 'Y' ELSE 'N' END AS SCORECARDS,
         T.PUBLISHED, T.CONSTRAINT_TYPE, T.CONSTRAINT_DT,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC AS ETC,
         (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         -1 AS ACTUAL_DURATION, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         A.MILESTONE_PERCENT,
         A.WORK_PERCENT,
         A.EFFORT AS WORK,
         
         T.SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         A.BILLABLE_REG_RATE AS REG_RATE,
         
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION, '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT, '0' AS RESOURCE_TYPE,h_resource_id AS RESOURCE_ID, 4 AS PARTICIPANT,
         PTS.SECURITY_ID, T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         T.LAST_CHECKIN AS LAST_CHECKIN, '' AS TSK_ASSIGNMENT_ID,  T.FS_CODE, T.STAGE_ID, T.FS_LABOR_CODE, P.CURRENCY_ID, P.EFFORT_DRIVEN  ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         P.ELEMENT_NAME AS PROJECT_NAME,
         A.MP_STATUS_DT              AS MP_STATUS_DT,
         '' AS EDIT_FLAG, '' AS BIT_FLAG,
         (CASE WHEN T.LEVEL_INDEX = -1 THEN 0 ELSE T.TOTAL_SLACK-100 END) as LEVEL_TOTAL_SLACK
         FROM PMO_TMP_PRJ_DLV A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
         JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
         AND P.PROJECT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         LEFT OUTER JOIN RESOURCE_ASSIGNMENTS RA ON RA.ELEMENT_ID = T.ELEMENT_ID AND RA.RESOURCE_ID = h_resource_id
         LEFT OUTER JOIN PMO_TMP_SECURITY PTS ON PTS.PARENT_ID = A.ELEMENT_ID
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 524+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_WBS_MY_TEAM_REFRESH_ELEMENT(525) : views_pool.sql(9217) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CR0051c;
      End If;
   End If;
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 533+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_REFRESH_ELEMENT(534) : views_pool.sql(9226) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_WBS_MY_TEAM_REFRESH_ELEMENT', 545+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_WBS_MY_TEAM_REFRESH_ELEMENT(546) : views_pool.sql(9238) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_WBS_MY_TEAM_REFRESH_ELEMENT;
ALTER FUNCTION FC_WBS_MY_TEAM_REFRESH_ELEMENT COMPILE DEBUG;

/*********************************************************************************/

/* ******************************************************************************* */

-- this function returns the information related to the selected pool (refresh pool)

-- at the pool level just the default values will be returned no need to do any calculations for

-- aggregate data

/* ******************************************************************************* */

Prompt == FUNCTION FC_RM_REFRESH_POOL ==
CREATE OR REPLACE FUNCTION FC_RM_REFRESH_POOL
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_pool_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR003 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_REFRESH_POOL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_REFRESH_POOL'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_REFRESH_POOL(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_pool_id || ''''
          || ', ' || '''' || h_rank || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_REFRESH_POOL', 21+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_REFRESH_POOL(22) : views_pool.sql(9286) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("\n CR003 \n");
   
   OPEN CR003 FOR SELECT 0 AS LEVEL_ID, T.TYPE_ID, T.RANK, h_resource_id AS PARENT_ID,
   T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
   T.CHILD_COUNT, T.DELETED_COUNT, T.REC_STATUS, T.REC_USER,
   R.FULL_NAME AS REC_USER_NAME,
   T.REC_DATETIME, 0 AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS START_DT, 0 AS FD, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS BASELINE_FINISH,
   0 AS BASELINE_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_START,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PLANNED_FINISH,
   0 AS PLANNED_WORK,   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,  TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_START,       TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,     TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_START, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ACTUAL_FINISH,
   0 AS ACTUAL_EFFORT, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING_EFFORT,
   0 AS ETC_RED_FLAG, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE, 0.00 AS REGULAR_COST,
   0.00 AS SPECIAL_COST, 0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, 0.00 AS PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE, 0.00 AS REGULAR_RATE, 0.00 AS SPECIAL_RATE,
   '' AS ASSIGN_STRING, '' AS PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER,
   0 AS MSP_ID, (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT, '' AS RESOURCE_TYPE,
   '' AS RESOURCE_ID, RA.PARTICIPANT, RA.SECURITY_ID, T.CHILD_COUNT AS ASSIGN_COUNT,
   T.ASSIGN_NAMES, 'M' AS ASSIGNED, '' AS CALENDAR_FLAG,
   R.FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE, T.PUBLIC_FLAG ,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
   0    AS ESTIMATED_SCHED_EFFORT,
   0.00 AS ESTIMATED_SCHED_COST,
   0.00 AS ESTIMATED_SCHED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
   0    AS ESTIMATED_PLANNED_EFFORT,
   0.00 AS ESTIMATED_PLANNED_COST,
   0.00 AS ESTIMATED_PLANNED_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
   ''                               AS LEVEL_ASSIGN_STRING,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
   0                            AS ESTIMATED_BASELINE1_EFFORT,
   0.00                         AS ESTIMATED_BASELINE1_COST,
   0.00                         AS ESTIMATED_BASELINE1_REVENUE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
   0                            AS ESTIMATED_BASELINE3_EFFORT,
   0.00                         AS ESTIMATED_BASELINE3_COST,
   0.00                         AS ESTIMATED_BASELINE3_REVENUE,
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   '' AS RESOURCE_USER_NAME,
   '' AS RESOURCE_LAST_NAME,
   '' AS RESOURCE_GIVEN_NAME,
   '' AS RESOURCE_MIDDLE_NAME,
   '' AS RESOURCE_NICK_NAME,
   '' AS RESOURCE_EMAIL_ADDRESS,
   '' AS RESOURCE_WORK_PHONE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_EFFECTIVE_DATE,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS    RESOURCE_DISCONTINUE_DATE,
   '' AS RESOURCE_CALENDAR,
   '' AS RESOURCE_CURRENCY
   FROM RESOURCE_ASSIGNMENTS RA, TMT_POOLS T , RESOURCES R
   WHERE T.ELEMENT_ID = RA.ELEMENT_ID
   AND RA.RESOURCE_ID = h_resource_id
   AND T.ELEMENT_ID = h_pool_id
   AND RA.ELEMENT_TYPE = 11
   AND R.RESOURCE_ID = T.REC_USER
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_REFRESH_POOL', 111+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_REFRESH_POOL(112) : views_pool.sql(9376) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR003;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_REFRESH_POOL', 119+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_REFRESH_POOL(120) : views_pool.sql(9384) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_REFRESH_POOL', 131+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_REFRESH_POOL(132) : views_pool.sql(9396) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_REFRESH_POOL;
ALTER FUNCTION FC_RM_REFRESH_POOL COMPILE DEBUG;

/*********************************************************************************/

-- refresh on resources level in pool_administration

Prompt == FUNCTION FC_RM_REFRESH_RESOURCE ==
CREATE OR REPLACE FUNCTION FC_RM_REFRESH_RESOURCE
(
     sh_h_bitflag PLS_INTEGER
   , h_resource_id IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_temp_sc_state PLS_INTEGER := 0;
   h_week_of DATE;
   h_rank VARCHAR2(200);
   h_name VARCHAR2(8000);
   h_family_name VARCHAR2(8000);
   h_search_by_name_bitflag PLS_INTEGER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00021 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_RM_REFRESH_RESOURCE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_RM_REFRESH_RESOURCE'), '-- ' || SYSTIMESTAMP, ':r := FC_RM_REFRESH_RESOURCE(' || 
       COALESCE(TO_CHAR(sh_h_bitflag), 'NULL')
          || ', ' || '''' || h_resource_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_REFRESH_RESOURCE', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_RM_REFRESH_RESOURCE(27) : views_pool.sql(9441) : ' || SYSTIMESTAMP);
   END IF; 

   h_rank := NULL;
   
   BEGIN
      SELECT TO_DATE(SYSDATE) INTO h_week_of FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_REFRESH_RESOURCE', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_REFRESH_RESOURCE(40) : views_pool.sql(9454) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   h_temp_sc_state := FC_PREVIOUS_MONDAY(h_week_of);
   --trace_printf("h_week_of: %d %s\n",h_week_of_Ind,h_week_of);
   
   h_search_by_name_bitflag := PMO_CNST.SC_ALL_RESOURCES;
   h_name := NULL;
   h_family_name := NULL;
   h_temp_sc_state := FC_RES_ASSIGN_STRING(h_search_by_name_bitflag, h_name, h_family_name, h_rank
                                        , h_resource_id, h_week_of, 1);
   
   --trace_printf("\n CR00021 \n");
   
   OPEN CR00021 FOR SELECT T.LEVEL_ID, 13 AS TYPE_ID, '----' AS RANK, T.PARENT_ID, T.ELEMENT_ID,
   T.ELEMENT_NAME, R.ACTIVE,
   
   CASE WHEN S.ELEMENT_ID IS NuLL THEN 0 ELSE 1 END AS CHILD_COUNT,
   T.DELETED_COUNT, R.REC_STATUS, R.REC_USER,
   R1.FULL_NAME AS REC_USER_NAME, R.REC_DATETIME,
   CASE WHEN S.ELEMENT_ID IS NuLL THEN 0 ELSE 1 END AS PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
   0 AS SD,
   CASE WHEN S.ACTUAL_START IS NOT Null THEN S.ACTUAL_START ELSE S.START_DT END AS START_DT,
   0 AS FD, S.FINISH_DT,
   0 AS MINUTE_PER_DAY, -1 AS DURATION,
   S.BASELINE_START, S.BASELINE_FINISH, S.BASELINE_WORK,
   S.PLANNED_START,  S.PLANNED_FINISH,  S.PLANNED_WORK,
   S.PROPOSED_START, S.PROPOSED_FINISH, S.PROPOSED_WORK,
   S.SCHED_START,    S.SCHED_FINISH,    S.SCHED_WORK,
   S.FORECAST_START, S.FORECAST_FINISH, S.ETC,
   S.ACTUAL_START, S.ACTUAL_FINISH, S.WORK_TODATE AS ACTUAL_EFFORT,
   S.REGULAR_TODATE, S.SPECIAL_TODATE, (S.SCHED_WORK + S.PLANNED_WORK - S.WORK_TODATE) AS REMAINING_EFFORT,
   
   0 AS ETC_RED_FLAG, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT,
   0 AS WORK_PERCENT,
   0 AS SUBPROJECT_COUNT,
   0.00 AS X_ESTIMATION_BUDGET,
   0.00 AS BASELINE1_BUDGET, 0.00 AS ESTIMATION_BUDGET, S.PROPOSED_LABOR_COST,
   0.00 AS CURRENT_BUDGET, 0.00 AS FORECAST_BUDGET, 0.00 AS ACTUAL_BUDGET, 0.00 AS BUDGET_REMAINING,
   0.00 AS BUDGET_FORECAST_VARIANCE, 0.00 AS BASELINE_VARIANCE,
   
   (SELECT REGULAR_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_COST,
   (SELECT SPECIAL_COST FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_COST,
   0.00 AS X_R_ESTIMATION_BUDGET, 0.00 AS R_BASELINE1_BUDGET,
   0.00 AS R_ESTIMATION_BUDGET, S.PROPOSED_LABOR_REVENUE, 0.00 AS R_CURRENT_BUDGET,
   0.00 AS R_FORECAST_BUDGET, 0.00 AS R_ACTUAL_BUDGET, 0.00 AS R_REMAINING, 0.00 AS R_BUDGET_FORECAST_VARIANCE,
   0.00 AS R_BASELINE_VARIANCE,
   (SELECT REGULAR_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS REGULAR_RATE,
   (SELECT SPECIAL_SALE FROM RATES WHERE RATE_ID = R.RATE_ID) AS SPECIAL_RATE,
   S.ASSIGN_STRING,
   '' AS PROJECT_ID,
   13 AS ELEMENT_TYPE_BITS,
   '' AS WBS_CODE,
   0 AS REFERENCE_NUMBER,
   0 AS MSP_ID,
   (RTRIM(TO_CHAR(R.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(R.MINOR_REVISION))) AS REVISION,
   '' AS REVISION_HISTORY,
   R.REVISION_TYPE,
   R.REVISION_IMPACT,
   '' AS LAST_WF_TYPE,
   '' AS LAST_WF_BY,
   TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
   '0' AS RESOURCE_TYPE,
   R.RESOURCE_ID AS RESOURCE_ID,
   0 AS PARTICIPANT,
   '' AS SECURITY_ID,
   0 AS ASSIGN_COUNT,
   T.ASSIGN_NAMES,
   'M' AS ASSIGNED,
   CASE WHEN R.CALENDAR_ID IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
   R.FS_CODE AS FS_CODE,
   0 AS STAGE_ID,
   R.FS_LABOR_CODE,
   T.PUBLIC_FLAG ,
   S.ESTIMATED_SCHED_START,
   S.ESTIMATED_SCHED_FINISH,
   S.ESTIMATED_SCHED_EFFORT,
   S.ESTIMATED_SCHED_COST,
   S.ESTIMATED_SCHED_REVENUE,
   S.ESTIMATED_PLANNED_START,
   S.ESTIMATED_PLANNED_FINISH,
   S.ESTIMATED_PLANNED_EFFORT,
   S.ESTIMATED_PLANNED_COST,
   S.ESTIMATED_PLANNED_REVENUE,
   S.LEVEL_PLANNED_START,
   S.LEVEL_PLANNED_FINISH,
   S.LEVEL_SCHED_START,
   S.LEVEL_SCHED_FINISH,
   S.PA_ASSIGN_STRING      AS LEVEL_ASSIGN_STRING,
   COALESCE(S.PA_START_DT,h_week_of) AS LEVEL_START,
   TO_TIMESTAMP('1899-01-01 12:00:00')  AS LEVEL_FINISH,
   
   S.ESTIMATED_BASELINE1_START,
   S.ESTIMATED_BASELINE1_FINISH,
   S.ESTIMATED_BASELINE1_EFFORT,
   S.ESTIMATED_BASELINE1_COST,
   S.ESTIMATED_BASELINE1_REVENUE,
   
   S.ESTIMATED_BASELINE3_START,
   S.ESTIMATED_BASELINE3_FINISH,
   S.ESTIMATED_BASELINE3_EFFORT,
   S.ESTIMATED_BASELINE3_COST,
   S.ESTIMATED_BASELINE3_REVENUE,
   
   0 AS BUBBLE_COLOR,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT,
   0 AS UNITS_PERCENT,
   TO_TIMESTAMP('1899-01-01 12:00:00') AS MP_STATUS_DT,
   
   R.LOGON_NAME    AS  RESOURCE_USER_NAME,
   R.LAST_NAME     AS  RESOURCE_LAST_NAME,
   R.FIRST_NAME    AS  RESOURCE_GIVEN_NAME,
   R.MIDDLE_NAME   AS  RESOURCE_MIDDLE_NAME,
   R.NICK_NAME     AS  RESOURCE_NICK_NAME,
   R.E_MAIL_ADDRESS AS RESOURCE_EMAIL_ADDRESS,
   R.WORK_PHONE    AS  RESOURCE_WORK_PHONE,
   R.EFFECTIVE_DATE AS RESOURCE_EFFECTIVE_DATE,
   R.DISCONTINUE_DATE AS   RESOURCE_DISCONTINUE_DATE,
   (SELECT ELEMENT_NAME  FROM TMT_CALENDARS WHERE ELEMENT_ID = R.CALENDAR_ID) AS   RESOURCE_CALENDAR,
   (SELECT DESCRIPTION FROM TMT_DATAFIELDS WHERE ELEMENT_ID = R.CURRENCY_ID)   AS  RESOURCE_CURRENCY,
   COALESCE(S.TA_START_DT,h_week_of) AS TA_START_DT
   
   FROM TMT_POOLS T
   JOIN RESOURCES R ON R.RESOURCE_ID = T.ELEMENT_ID
   JOIN RESOURCES R1 ON R1.RESOURCE_ID = R.REC_USER
   LEFT JOIN PMO_TMP_ASSIGN_STRING S ON S.ELEMENT_ID = T.ELEMENT_ID
   WHERE T.ELEMENT_ID = h_resource_id;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_RM_REFRESH_RESOURCE', 169+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_RM_REFRESH_RESOURCE(170) : views_pool.sql(9584) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00021;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_REFRESH_RESOURCE', 177+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_REFRESH_RESOURCE(178) : views_pool.sql(9592) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_RM_REFRESH_RESOURCE', 189+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_RM_REFRESH_RESOURCE(190) : views_pool.sql(9604) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_RM_REFRESH_RESOURCE;
ALTER FUNCTION FC_RM_REFRESH_RESOURCE COMPILE DEBUG;

/*********************************************************************************/

Prompt == FUNCTION FC_DEMAND_SUPPLY_OPEN_PROFILES ==
CREATE OR REPLACE FUNCTION FC_DEMAND_SUPPLY_OPEN_PROFILES
(
     h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , h_nick_name IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , sh_h_minute_per_day PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_manager_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
   , h_temp_resource_type IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_minute_per_day PLS_INTEGER := sh_h_minute_per_day;
   h_project_min_per_day PLS_INTEGER := 0;
   h_res_nick_name VARCHAR2(100);
   h_res_calendar_id VARCHAR2(32);
   h_res_fs_code VARCHAR2(50);
   h_res_fs_labor_code VARCHAR2(50);
   h_temp_rec_status VARCHAR2(1);
   h_rt_regular_cost NUMBER := 0;
   h_rt_special_cost NUMBER := 0;
   h_rt_regular_sale NUMBER := 0;
   h_rt_special_sale NUMBER := 0;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR004 PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR00311a PMO_DB2M.REF_CURSOR;

      -- Resultset Cursor Declaration
      CR00311b PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DEMAND_SUPPLY_OPEN_PROFILES') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DEMAND_SUPPLY_OPEN_PROFILES'), '-- ' || SYSTIMESTAMP, ':r := FC_DEMAND_SUPPLY_OPEN_PROFILES(' || 
       '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || '''' || h_nick_name || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_minute_per_day), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_manager_id || ''''
          || ', ' || '''' || h_rec_status || ''''
          || ', ' || '''' || h_temp_resource_type || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 52+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DEMAND_SUPPLY_OPEN_PROFILES(53) : views_pool.sql(9673) : ' || SYSTIMESTAMP);
   END IF; 

   h_rank := NULL;
   
   BEGIN
      SELECT RANK, PROJECT_ID, MINUTE_PER_DAY
      INTO h_rank, h_project_id, h_minute_per_day
      FROM TMT_WBS
      WHERE ELEMENT_ID = PROJECT_ID
      AND PROJECT_ID = h_id
      AND TYPE_ID <> 13;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 70+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(71) : views_pool.sql(9691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If h_rank IS NULL Then
      BEGIN
         SELECT RANK, PROJECT_ID
         INTO h_rank, h_project_id
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(88) : views_pool.sql(9708) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT MINUTE_PER_DAY
         INTO h_minute_per_day
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 103+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(104) : views_pool.sql(9724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_rec_status := NULL;
      BEGIN
         SELECT REC_STATUS INTO h_temp_rec_status FROM RESOURCES WHERE RESOURCE_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 117+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(118) : views_pool.sql(9738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_temp_rec_status IS NULL Then
         h_temp_resource_type := '0';
      Else
         h_temp_resource_type := '1';
      End If;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSPL_0002';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_VIEWSPL_0002
         SELECT T.PARENT_ID AS ELEMENT_ID, MIN(A.START_DT) AS START_DT, MAX(A.FINISH_DT) AS FINISH_DT,
         MIN(A.BASELINE1_START) AS BASELINE_START, MAX(A.BASELINE1_FINISH) AS BASELINE_FINISH,
         SUM(COALESCE(A.BASELINE1_WORK, 0)) AS BASELINE_WORK,
         MIN(A.PLANNED_START) AS PLANNED_START, MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
         SUM(COALESCE(A.PLANNED_WORK, 0)) AS PLANNED_WORK,
         MIN(A.PROPOSED_START) AS PROPOSED_START, MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
         SUM(COALESCE(A.PROPOSED_WORK, 0)) AS PROPOSED_WORK,
         MIN(A.SCHED_START) AS SCHED_START, MAX(A.SCHED_FINISH) AS SCHED_FINISH,
         SUM(COALESCE(A.SCHED_WORK, 0)) AS SCHED_WORK,
         MIN(A.FORECAST_START) AS FORECAST_START, MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
         SUM(COALESCE(A.ETC, 0)) AS ETC,
         MIN(A.ACTUAL_START) AS ACTUAL_START, MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
         SUM(COALESCE(A.WORK_TODATE, 0)) AS WORK_TODATE, SUM(COALESCE(A.REGULAR_TODATE, 0)) AS REGULAR_TODATE, SUM(COALESCE(A.SPECIAL_TODATE, 0)) AS SPECIAL_TODATE,
         (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) AS REMAINING_EFFORT,
         CASE WHEN (SUM(COALESCE(A.ETC, 0))) = (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         case when SUM(T.TOTAL_DURATION) > 0 then (SUM(T.MILESTONE_PERCENT * T.TOTAL_DURATION) / SUM(T.TOTAL_DURATION))
         else 0 end AS MILESTONE_PERCENT,
         0.00 AS ESTIMATION_LABOR_COST, SUM(COALESCE(A.BASELINE1_LABOR_COST, 0.00)) AS BASELINE_LABOR_COST, SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)) AS PLANNED_LABOR_COST, SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)) AS PROPOSED_LABOR_COST, SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)) AS SCHED_LABOR_COST,  SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)) AS FORECAST_LABOR_COST, SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)) AS ACTUAL_LABOR_COST,
         0.00 AS ESTIMATION_LABOR_REVENUE, SUM(COALESCE(A.BASELINE1_LABOR_REVENUE, 0.00)) AS BASELINE_LABOR_REVENUE, SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)) AS PLANNED_LABOR_REVENUE, SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)) AS PROPOSED_LABOR_REVENUE, SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)) AS SCHED_LABOR_REVENUE, SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)) AS FORECAST_LABOR_REVENUE, SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)) AS ACTUAL_LABOR_REVENUE
         FROM TASK_ASSIGNMENTS A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
         AND T.PARENT_ID = h_id
         AND T.REC_STATUS <> 'D'
         WHERE A.RESOURCE_ID = h_resource_id
         AND A.BIT_FLAG = '0'
         AND A.PROJECT_ID <> A.TASK_ID
         GROUP BY A.PROJECT_ID, T.PARENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 171+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(172) : views_pool.sql(9792) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --trace_printf("\n\n =================> CR004\n");   // DEMAND  SUPPLY              --> EXPAND DELIVERABLE LEVEL
      
      --trace_printf("\n CR004 \n");
      
      OPEN CR004 FOR SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK,
      h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      
      CASE WHEN A.ACTUAL_START IS NOT Null THEN PMO_CNST.SC_AS WHEN (A.FORECAST_START IS NOT Null) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS WHEN (A.SCHED_START IS NOT Null) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS ELSE PMO_CNST.SC_NS END AS SD, CASE WHEN A.ACTUAL_START IS NOT Null THEN A.ACTUAL_START ELSE A.START_DT END AS START_DT, CASE WHEN (A.ACTUAL_FINISH IS NOT Null) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_AF WHEN (A.FORECAST_FINISH IS NOT Null) AND (A.FORECAST_FINISH=A.START_DT) THEN PMO_CNST.SC_FS WHEN (A.SCHED_FINISH IS NOT Null) AND (A.SCHED_FINISH = A.START_DT) THEN PMO_CNST.SC_SS ELSE PMO_CNST.SC_NS END AS FD, CASE WHEN (A.ACTUAL_FINISH IS NOT Null) AND (A.MILESTONE_PERCENT=10000) THEN A.ACTUAL_FINISH ELSE A.FINISH_DT END AS FINISH_DT,
      
      P.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
      A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
      A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
      A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
      A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
      A.WORK_TODATE, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
      ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      A.MILESTONE_PERCENT,
      T.SUBPROJECT_COUNT,
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      (SELECT CASE WHEN (SUM(SCHED_WORK) + SUM(PLANNED_WORK)) > 0.00
      THEN (((SUM(SCHED_LABOR_REVENUE) + SUM(PLANNED_LABOR_REVENUE))*60)/(SUM(SCHED_WORK) + SUM(PLANNED_WORK)))
      ELSE 0.00 END
      FROM TASK_ASSIGNMENTS
      WHERE BILLABLE = 1
      AND PROJECT_ID = T.PROJECT_ID
      AND RESOURCE_ID = h_resource_id
      AND TASK_ID IN ( SELECT  ELEMENT_ID FROM TMT_WBS WHERE PARENT_ID = A.ELEMENT_ID )
      
      ) AS REG_RATE, 0.00 AS SPEC_RATE,
      '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      h_temp_resource_type AS RESOURCE_TYPE, h_resource_id AS RESOURCE_ID, 4 AS PARTICIPANT, 'SCDELIVERABLEMANAGER' AS SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,
      R.FS_CODE,
      T.STAGE_ID, R.FS_LABOR_CODE ,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      ''                               AS LEVEL_ASSIGN_STRING,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR, T.TASK_TYPE,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
      0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME, 0 AS C_EFFORT
      
      FROM PMO_TMP_VIEWSPL_0002 A
      JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
      JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      
      UNION ALL
      
      SELECT 3 LEVEL_ID, T.TYPE_ID,
      T.RANK, T.PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
      T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
      R.FULL_NAME AS REC_USER_NAME,
      T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
      A.SD, A.START_DT, A.FD, A.FINISH_DT,
      P.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
      A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
      (A.BASELINE1_WORK) AS BASELINE1_EFFORT,
      A.PLANNED_START, A.PLANNED_FINISH,
      (A.PLANNED_WORK) AS PLANNED_EFFORT,
      A.PROPOSED_START, A.PROPOSED_FINISH,
      (A.PROPOSED_WORK) AS PROPOSED_EFFORT,
      A.SCHED_START, A.SCHED_FINISH,
      (A.SCHED_WORK) AS SCHED_EFFORT,
      A.FORECAST_START, A.FORECAST_FINISH,
      A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
      A.ACTUAL_START, A.ACTUAL_FINISH,
      (A.WORK_TODATE) AS WORK_TODATE, (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
      ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
      CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
      
      A.MILESTONE_PERCENT,
      T.SUBPROJECT_COUNT,
      
      0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
      (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
      (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
      A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
      0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
      (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
      A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
      CASE WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
      A.SPECIAL_RATE AS SPEC_RATE,
      A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
      (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
      '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
      A.RESOURCE_TYPE, A.RESOURCE_ID, 32 AS PARTICIPANT, 'SCTASKRESPONSIBLE' AS SECURITY_ID,
      T.ASSIGN_COUNT, T.ASSIGN_NAMES,
      CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
      0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,
      R.FS_CODE,
      T.STAGE_ID, R.FS_LABOR_CODE ,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
      0    AS ESTIMATED_SCHED_EFFORT,
      0.00 AS ESTIMATED_SCHED_COST,
      0.00 AS ESTIMATED_SCHED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
      0    AS ESTIMATED_PLANNED_EFFORT,
      0.00 AS ESTIMATED_PLANNED_COST,
      0.00 AS ESTIMATED_PLANNED_REVENUE,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
      A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
      A.LEVEL_START           AS LEVEL_START,
      A.LEVEL_FINISH          AS LEVEL_FINISH,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
      0                            AS ESTIMATED_BASELINE1_EFFORT,
      0.00                         AS ESTIMATED_BASELINE1_COST,
      0.00                         AS ESTIMATED_BASELINE1_REVENUE,
      
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
      TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
      0                            AS ESTIMATED_BASELINE3_EFFORT,
      0.00                         AS ESTIMATED_BASELINE3_COST,
      0.00                         AS ESTIMATED_BASELINE3_REVENUE,
      
      0 AS BUBBLE_COLOR, T.TASK_TYPE,
      TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, A.UNITS_MSP AS UNITS_PERCENT,
      0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME, A.C_EFFORT
      
      FROM TASK_ASSIGNMENTS A
      JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID AND T.PARENT_ID = h_id
      JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
      JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
      WHERE A.RESOURCE_ID = h_resource_id
      AND A.BIT_FLAG = '0' AND A.PROJECT_ID <> A.TASK_ID
      ORDER BY RANK, PLANNED_START;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 351+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_DEMAND_SUPPLY_OPEN_PROFILES(352) : views_pool.sql(9972) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN CR004;
   Else
      h_temp_rec_status := NULL;
      BEGIN
         SELECT REC_STATUS INTO h_temp_rec_status FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 364+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(365) : views_pool.sql(9985) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Temporary Table Declaration has been changed to Truncate
      EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSPL_0002';
      PMO_DB2M.SC_STATE := 0;
      
      BEGIN
         INSERT INTO PMO_TMP_VIEWSPL_0002
         SELECT T.PARENT_ID AS ELEMENT_ID, MIN(A.START_DT) AS START_DT, MAX(A.FINISH_DT) AS FINISH_DT,
         MIN(A.BASELINE1_START) AS BASELINE_START, MAX(A.BASELINE1_FINISH) AS BASELINE_FINISH,
         SUM(COALESCE(A.BASELINE1_WORK, 0)) AS BASELINE_WORK,
         MIN(A.PLANNED_START) AS PLANNED_START, MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
         SUM(COALESCE(A.PLANNED_WORK, 0)) AS PLANNED_WORK,
         MIN(A.PROPOSED_START) AS PROPOSED_START, MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
         SUM(COALESCE(A.PROPOSED_WORK, 0)) AS PROPOSED_WORK,
         MIN(A.SCHED_START) AS SCHED_START, MAX(A.SCHED_FINISH) AS SCHED_FINISH,
         SUM(COALESCE(A.SCHED_WORK, 0)) AS SCHED_WORK,
         MIN(A.FORECAST_START) AS FORECAST_START, MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
         SUM(COALESCE(A.ETC, 0)) AS ETC,
         MIN(A.ACTUAL_START) AS ACTUAL_START, MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
         SUM(COALESCE(A.WORK_TODATE, 0)) AS WORK_TODATE, SUM(COALESCE(A.REGULAR_TODATE, 0)) AS REGULAR_TODATE, SUM(COALESCE(A.SPECIAL_TODATE, 0)) AS SPECIAL_TODATE,
         (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) AS REMAINING_EFFORT,
         CASE WHEN (SUM(COALESCE(A.ETC, 0))) = (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         
         case when SUM(T.TOTAL_DURATION) > 0 then (SUM(T.MILESTONE_PERCENT * T.TOTAL_DURATION) / SUM(T.TOTAL_DURATION))
         else 0 end AS MILESTONE_PERCENT,
         
         0.00 AS ESTIMATION_LABOR_COST, SUM(COALESCE(A.BASELINE1_LABOR_COST, 0.00)) AS BASELINE_LABOR_COST, SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)) AS PLANNED_LABOR_COST, SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)) AS PROPOSED_LABOR_COST, SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)) AS SCHED_LABOR_COST,  SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)) AS FORECAST_LABOR_COST, SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)) AS ACTUAL_LABOR_COST,
         0.00 AS ESTIMATION_LABOR_REVENUE, SUM(COALESCE(A.BASELINE1_LABOR_REVENUE, 0.00)) AS BASELINE_LABOR_REVENUE, SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)) AS PLANNED_LABOR_REVENUE, SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)) AS PROPOSED_LABOR_REVENUE, SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)) AS SCHED_LABOR_REVENUE, SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)) AS FORECAST_LABOR_REVENUE, SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)) AS ACTUAL_LABOR_REVENUE
         FROM TASK_ASSIGNMENTS A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID AND T.PARENT_ID <> T.PROJECT_ID AND T.REC_STATUS <> 'D'
         WHERE A.RESOURCE_ID = h_resource_id
         AND A.PROJECT_ID = h_id
         AND A.BIT_FLAG = '0' AND A.PROJECT_ID <> A.TASK_ID
         GROUP BY A.PROJECT_ID, T.PARENT_ID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 412+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(413) : views_pool.sql(10033) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If h_temp_rec_status IS NULL Then
         -- Temporary Table Declaration has been changed to Truncate
         EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VIEWSPL_00024';
         PMO_DB2M.SC_STATE := 0;
         
         BEGIN
            INSERT INTO PMO_TMP_VIEWSPL_00024
            SELECT
            RA.PROJECT_ID,
            W.MINUTE_PER_DAY,
            
            MIN(A.START_DT) AS START_DT,
            MAX(A.FINISH_DT) AS FINISH_DT,
            RA.PROFILE_ID,
            MIN(A.BASELINE1_START) AS BASELINE_START,
            MAX(A.BASELINE1_FINISH) AS BASELINE_FINISH,
            SUM(COALESCE(A.BASELINE1_WORK, 0)) AS BASELINE_WORK,
            MIN(A.PLANNED_START) AS PLANNED_START,
            MAX(A.PLANNED_FINISH) AS PLANNED_FINISH,
            SUM(COALESCE(A.PLANNED_WORK, 0)) AS PLANNED_WORK,
            MIN(A.PROPOSED_START) AS PROPOSED_START,
            MAX(A.PROPOSED_FINISH) AS PROPOSED_FINISH,
            SUM(COALESCE(A.PROPOSED_WORK, 0)) AS PROPOSED_WORK,
            MIN(A.SCHED_START) AS SCHED_START,
            MAX(A.SCHED_FINISH) AS SCHED_FINISH,
            SUM(COALESCE(A.SCHED_WORK, 0)) AS SCHED_WORK,
            MIN(A.FORECAST_START) AS FORECAST_START,
            MAX(A.FORECAST_FINISH) AS FORECAST_FINISH,
            SUM(COALESCE(A.ETC, 0)) AS ETC,
            MIN(A.ACTUAL_START) AS ACTUAL_START,
            MAX(A.ACTUAL_FINISH) AS ACTUAL_FINISH,
            SUM(COALESCE(A.WORK_TODATE, 0)) AS WORK_TODATE,
            SUM(COALESCE(A.REGULAR_TODATE, 0)) AS REGULAR_TODATE,
            SUM(COALESCE(A.SPECIAL_TODATE, 0)) AS SPECIAL_TODATE,
            (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) AS REMAINING_EFFORT,
            CASE WHEN (SUM(COALESCE(A.ETC, 0))) = (SUM(COALESCE(A.SCHED_WORK+A.PLANNED_WORK, 0)) - SUM(COALESCE(A.WORK_TODATE, 0))) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
            (CASE WHEN SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0
            WHEN SUM(COALESCE(A.WORK_TODATE, 0)) = 0 THEN 0
            ELSE (SUM((A.WORK_TODATE + A.ETC) * A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC)) END) AS MILESTONE_PERCENT,
            0.00 AS ESTIMATION_LABOR_COST,
            SUM(COALESCE(A.BASELINE1_LABOR_COST, 0.00)) AS BASELINE_LABOR_COST,
            SUM(COALESCE(A.PLANNED_LABOR_COST, 0.00)) AS PLANNED_LABOR_COST,
            SUM(COALESCE(A.PROPOSED_LABOR_COST, 0.00)) AS PROPOSED_LABOR_COST,
            SUM(COALESCE(A.SCHED_LABOR_COST, 0.00)) AS SCHED_LABOR_COST,
            SUM(COALESCE(A.FORECAST_LABOR_COST, 0.00)) AS FORECAST_LABOR_COST,
            SUM(COALESCE(A.ACTUAL_LABOR_COST, 0.00)) AS ACTUAL_LABOR_COST,
            0.00 AS ESTIMATION_LABOR_REVENUE,
            SUM(COALESCE(A.BASELINE1_LABOR_REVENUE, 0.00)) AS BASELINE_LABOR_REVENUE,
            SUM(COALESCE(A.PLANNED_LABOR_REVENUE, 0.00)) AS PLANNED_LABOR_REVENUE,
            SUM(COALESCE(A.PROPOSED_LABOR_REVENUE, 0.00)) AS PROPOSED_LABOR_REVENUE,
            SUM(COALESCE(A.SCHED_LABOR_REVENUE, 0.00)) AS SCHED_LABOR_REVENUE,
            SUM(COALESCE(A.FORECAST_LABOR_REVENUE, 0.00)) AS FORECAST_LABOR_REVENUE,
            SUM(COALESCE(A.ACTUAL_LABOR_REVENUE, 0.00)) AS ACTUAL_LABOR_REVENUE,
            MAX(A.REGULAR_COST) AS REGULAR_COST,
            MAX(A.SPECIAL_COST) AS SPECIAL_COST,
            MAX(A.REGULAR_RATE) AS REGULAR_RATE,
            MAX(A.SPECIAL_RATE) AS SPECIAL_RATE
            FROM RESOURCE_ASSIGNMENTS RA
            JOIN TMT_WBS W
            ON W.ELEMENT_ID = RA.PROJECT_ID
            JOIN TASK_ASSIGNMENTS A
            ON A.RES_ASSIGNMENT_ID = RA.RES_ASSIGNMENT_ID
            AND A.PROJECT_ID <> A.TASK_ID
            AND A.BIT_FLAG = '0'
            WHERE RA.PROJECT_ID = h_project_id
            AND RA.PROFILE_ID = h_resource_id
            GROUP BY RA.PROJECT_ID, W.MINUTE_PER_DAY, RA.PROFILE_ID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 494+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(495) : views_pool.sql(10115) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If h_temp_rec_status IS NULL Then
            h_temp_resource_type := '0';
         Else
            h_temp_resource_type := '1';
         End If;
         
         --trace_printf("\n\n =================> CR00311a \n");   //DEMAND  SUPPLY              --> EXPAND PROFILE LEVEL
         
         --trace_printf("\n CR00311a \n");
         
         OPEN CR00311a FOR SELECT 1 AS LEVEL_ID, 41 AS TYPE_ID, '----' AS RANK,
         A.PROJECT_ID AS PARENT_ID, T.PROFILE_ID AS ELEMENT_ID,
         T.PROFILE_NAME AS ELEMENT_NAME, ' ' AS ACTIVE,
         1 AS CHILD_COUNT, 0 AS DELETED_COUNT,
         h_rec_status AS REC_STATUS,
         h_resource_id AS REC_USER,
         h_full_name AS REC_USER_NAME,
         A.SCHED_FINISH AS REC_DATETIME, 0 AS PRIORITY, T.PROFILE_ID AS ORIGINAL_ID,
         
         PA.SD AS SD,
         COALESCE(PA.ESTIMATED_SCHED_START, COALESCE(PA.ESTIMATED_PLANNED_START, PA.START_DT)) AS START_DT,
         PA.FD AS FD,
         COALESCE(PA.ESTIMATED_SCHED_FINISH, COALESCE(PA.ESTIMATED_PLANNED_FINISH, PA.FINISH_DT)) AS FINISH_DT,
         A.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT,
         A.PLANNED_START, A.PLANNED_FINISH,
         CASE WHEN PA.ESTIMATED_PLANNED_EFFORT > 0 THEN PA.ESTIMATED_PLANNED_EFFORT ELSE A.PLANNED_WORK END AS PLANNED_EFFORT,
         A.PROPOSED_START, A.PROPOSED_FINISH,
         A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         CASE WHEN PA.ESTIMATED_SCHED_EFFORT > 0 THEN PA.ESTIMATED_SCHED_EFFORT ELSE A.SCHED_WORK END AS SCHED_EFFORT,
         A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         A.WORK_TODATE, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         A.MILESTONE_PERCENT,
         0 AS SUBPROJECT_COUNT,
         A.ESTIMATION_LABOR_COST AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         A.REGULAR_COST AS REG_COST, 0.00 AS SPEC_COST,
         A.ESTIMATION_LABOR_REVENUE AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         0.00 AS REG_RATE,
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING, A.PROJECT_ID AS PROJECT_ID, 0 AS ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID,
         '0' AS REVISION, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
         '41' AS RESOURCE_TYPE, h_resource_id AS RESOURCE_ID, 0 AS PARTICIPANT, '' AS SECURITY_ID,
         1 AS ASSIGN_COUNT, h_nick_name || ';' AS ASSIGN_NAMES,
         '' AS ASSIGNED, '' AS CALENDAR_FLAG,
         0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,  '' AS FS_CODE, 0 AS STAGE_ID, '' AS FS_LABOR_CODE ,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR, 0 AS TASK_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME, 0 AS C_EFFORT
         
         FROM PMO_TMP_VIEWSPL_00024 A
         JOIN PROFILES T ON T.PROFILE_ID = A.PROFILE_ID
         JOIN PROJECT_ASSIGNMENTS PA ON PA.PROJECT_ID = A.PROJECT_ID AND PA.RESOURCE_ID = A.PROFILE_ID AND PA.RESOURCE_TYPE = '1'
         
         UNION ALL
         
         SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK,
         h_resource_id AS PARENT_ID, T.ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
         R.FULL_NAME AS REC_USER_NAME,
         
         T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         
         CASE WHEN A.ACTUAL_START IS NOT Null THEN PMO_CNST.SC_AS WHEN (A.FORECAST_START IS NOT Null) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS WHEN (A.SCHED_START IS NOT Null) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS ELSE PMO_CNST.SC_NS END AS SD, CASE WHEN A.ACTUAL_START IS NOT Null THEN A.ACTUAL_START ELSE A.START_DT END AS START_DT, CASE WHEN (A.ACTUAL_FINISH IS NOT Null) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_AF WHEN (A.FORECAST_FINISH IS NOT Null) AND (A.FORECAST_FINISH=A.START_DT) THEN PMO_CNST.SC_FS WHEN (A.SCHED_FINISH IS NOT Null) AND (A.SCHED_FINISH = A.START_DT) THEN PMO_CNST.SC_SS ELSE PMO_CNST.SC_NS END AS FD, CASE WHEN (A.ACTUAL_FINISH IS NOT Null) AND (A.MILESTONE_PERCENT=10000) THEN A.ACTUAL_FINISH ELSE A.FINISH_DT END AS FINISH_DT,
         
         P.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         A.WORK_TODATE, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         
         A.MILESTONE_PERCENT,
         T.SUBPROJECT_COUNT,
         
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         (SELECT CASE WHEN (SUM(SCHED_WORK) + SUM(PLANNED_WORK)) > 0.00
         THEN (((SUM(SCHED_LABOR_REVENUE) + SUM(PLANNED_LABOR_REVENUE))*60)/(SUM(SCHED_WORK) + SUM(PLANNED_WORK)))
         ELSE 0.00 END
         FROM TASK_ASSIGNMENTS
         WHERE BILLABLE = 1
         AND PROJECT_ID = T.PROJECT_ID
         AND RESOURCE_ID = h_resource_id
         AND TASK_ID IN ( SELECT  ELEMENT_ID FROM TMT_WBS WHERE PARENT_ID = A.ELEMENT_ID )
         
         ) AS REG_RATE,
         
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         h_temp_resource_type
         AS RESOURCE_TYPE,
         h_resource_id
         AS RESOURCE_ID, 4 AS PARTICIPANT, 'SCDELIVERABLEMANAGER' AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,
         R.FS_CODE,
         T.STAGE_ID, R.FS_LABOR_CODE ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR, T.TASK_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME, 0 AS C_EFFORT
         
         FROM PMO_TMP_VIEWSPL_0002 A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
         JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         
         UNION ALL
         
         SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK,
         h_resource_id
         AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME, ' ' AS ACTIVE,
         0 AS CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
         
         R.FULL_NAME AS REC_USER_NAME,
         
         T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         P.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
         A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
         (A.BASELINE1_WORK) AS BASELINE1_EFFORT,
         A.PLANNED_START, A.PLANNED_FINISH,
         (A.PLANNED_WORK) AS PLANNED_EFFORT,
         A.PROPOSED_START, A.PROPOSED_FINISH,
         (A.PROPOSED_WORK) AS PROPOSED_EFFORT,
         A.SCHED_START, A.SCHED_FINISH,
         (A.SCHED_WORK) AS SCHED_EFFORT,
         A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
         A.ACTUAL_START, A.ACTUAL_FINISH,
         (A.WORK_TODATE) AS WORK_TODATE, (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         A.MILESTONE_PERCENT,
         T.SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         CASE WHEN (A.BILLABLE = 1 AND A.PLANNED_LABOR_REVENUE > 0) THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
         
         A.SPECIAL_RATE AS SPEC_RATE,
         A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         A.RESOURCE_TYPE, A.RESOURCE_ID, 32 AS PARTICIPANT, 'SCTASKRESPONSIBLE' AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,
         R.FS_CODE,
         T.STAGE_ID, R.FS_LABOR_CODE ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
         A.LEVEL_START           AS LEVEL_START,
         A.LEVEL_FINISH          AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR, T.TASK_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, A.UNITS_MSP AS UNITS_PERCENT,
         0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME, A.C_EFFORT
         
         FROM TASK_ASSIGNMENTS A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID AND (T.PARENT_ID = A.PROJECT_ID OR T.PROJECT_ID = A.TASK_ID)
         JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         WHERE A.RESOURCE_ID = h_resource_id
         AND A.PROJECT_ID = h_id
         AND A.TASK_ID <> A.PROJECT_ID
         AND A.BIT_FLAG = '0'
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 777+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_DEMAND_SUPPLY_OPEN_PROFILES(778) : views_pool.sql(10398) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CR00311a;
      Else
         If h_temp_rec_status IS NULL Then
            h_temp_resource_type := '0';
         Else
            h_temp_resource_type := '1';
         End If;
         
         -- fetch TMT_WBS information
         BEGIN
            SELECT MINUTE_PER_DAY
            INTO h_project_min_per_day
            FROM TMT_WBS
            WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 799+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(800) : views_pool.sql(10420) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- fetch RESOURCES/RATES information
         BEGIN
            SELECT R.NICK_NAME, R.CALENDAR_ID,   R.FS_CODE,       R.FS_LABOR_CODE,
            RT.REGULAR_COST, RT.SPECIAL_COST, RT.REGULAR_SALE, RT.SPECIAL_SALE
            INTO
            h_res_nick_name, h_res_calendar_id, h_res_fs_code, h_res_fs_labor_code,
            h_rt_regular_cost, h_rt_special_cost, h_rt_regular_sale, h_rt_special_sale
            FROM RESOURCES R, RATES RT
            WHERE R.RESOURCE_ID = h_resource_id
            AND RT.RATE_ID = R.RATE_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 820+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(821) : views_pool.sql(10441) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n\n =================> CR00311b \n");
         
         --trace_printf("\n CR00311b \n");
         
         OPEN CR00311b FOR SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID,
         '----' AS RANK, A.PROJECT_ID AS PARENT_ID, A.RESOURCE_ID AS ELEMENT_ID,
         h_res_nick_name AS ELEMENT_NAME, ' ' AS ACTIVE,
         1 AS CHILD_COUNT, 0 AS DELETED_COUNT,
         h_rec_status AS REC_STATUS,
         h_resource_id AS REC_USER,
         
         h_full_name AS REC_USER_NAME,
         
         A.FINISH_DT AS REC_DATETIME, 0 AS PRIORITY, A.RESOURCE_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         h_project_min_per_day AS MINUTE_PER_DAY, -1 AS DURATION,
         A.BASELINE_START, A.BASELINE_FINISH, (A.BASELINE_WORK) AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         (A.PLANNED_WORK) AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         (A.PROPOSED_WORK) AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         (A.SCHED_WORK) AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         (A.WORK_TODATE) AS WORK_TODATE, (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         (CASE WHEN COALESCE(A.SCHED_WORK, 0) = 0 OR COALESCE(A.MILESTONE_PERCENT, 0) = 0 THEN 0
         ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
         0 AS SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, h_rt_regular_cost AS REG_COST, h_rt_special_cost AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         h_rt_regular_sale AS REG_RATE, h_rt_special_sale AS SPEC_RATE,
         '' AS ASSIGN_STRING, A.PROJECT_ID, A.ELEMENT_TYPE_BITS, '' AS WBS_CODE, 0 AS REFERENCE_NUMBER, 0 AS MSP_ID,
         '' AS REVISION, '' AS REVISION_HISTORY, 0 AS REVISION_TYPE, 0 AS REVISION_IMPACT, '' AS LAST_WF_TYPE, '' AS LAST_WF_BY, TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS LAST_WF_DT,
         '0' AS RESOURCE_TYPE, A.RESOURCE_ID, 0 AS PARTICIPANT, '' AS SECURITY_ID,
         0 ASSIGN_COUNT, h_nick_name || ';' AS ASSIGN_NAMES, '' AS ASSIGNED, CASE WHEN h_res_calendar_id IS NOT null THEN 'Y' ELSE 'N' END AS CALENDAR_FLAG,
         0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,   h_res_fs_code AS FS_CODE, 0 AS STAGE_ID, h_res_fs_labor_code AS FS_LABOR_CODE ,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR, 0 AS TASK_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME
         
         FROM PROJECT_ASSIGNMENTS A
         WHERE A.PROJECT_ID = h_id
         AND A.RESOURCE_ID = h_resource_id
         
         UNION ALL
         
         SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK,
         h_resource_id AS PARENT_ID, T.ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE,
         T.CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
         
         R.FULL_NAME AS REC_USER_NAME,
         
         T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         
         CASE WHEN A.ACTUAL_START IS NOT Null THEN PMO_CNST.SC_AS WHEN (A.FORECAST_START IS NOT Null) AND (A.FORECAST_START = A.START_DT) THEN PMO_CNST.SC_FS WHEN (A.SCHED_START IS NOT Null) AND (A.SCHED_START = A.START_DT) THEN PMO_CNST.SC_SS ELSE PMO_CNST.SC_NS END AS SD, CASE WHEN A.ACTUAL_START IS NOT Null THEN A.ACTUAL_START ELSE A.START_DT END AS START_DT, CASE WHEN (A.ACTUAL_FINISH IS NOT Null) AND (A.MILESTONE_PERCENT=10000) THEN PMO_CNST.SC_AF WHEN (A.FORECAST_FINISH IS NOT Null) AND (A.FORECAST_FINISH=A.START_DT) THEN PMO_CNST.SC_FS WHEN (A.SCHED_FINISH IS NOT Null) AND (A.SCHED_FINISH = A.START_DT) THEN PMO_CNST.SC_SS ELSE PMO_CNST.SC_NS END AS FD, CASE WHEN (A.ACTUAL_FINISH IS NOT Null) AND (A.MILESTONE_PERCENT=10000) THEN A.ACTUAL_FINISH ELSE A.FINISH_DT END AS FINISH_DT,
         
         P.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
         A.BASELINE_START, A.BASELINE_FINISH, A.BASELINE_WORK AS BASELINE1_EFFORT, A.PLANNED_START, A.PLANNED_FINISH,
         A.PLANNED_WORK AS PLANNED_EFFORT, A.PROPOSED_START, A.PROPOSED_FINISH,
         A.PROPOSED_WORK AS PROPOSED_EFFORT, A.SCHED_START, A.SCHED_FINISH,
         A.SCHED_WORK AS SCHED_EFFORT, A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT, A.ACTUAL_START, A.ACTUAL_FINISH,
         A.WORK_TODATE, A.WORK_TODATE AS ACTUAL_EFFORT, A.REGULAR_TODATE, A.SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         A.MILESTONE_PERCENT,
         T.SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE, CASE WHEN (A.SCHED_WORK+A.PLANNED_WORK) > 0.00 THEN (((A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)*60)/(A.SCHED_WORK+A.PLANNED_WORK)) ELSE 0.00 END AS REG_COST, 0.00 AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         
         (SELECT CASE WHEN (SUM(SCHED_WORK) + SUM(PLANNED_WORK)) > 0.00
         THEN (((SUM(SCHED_LABOR_REVENUE) + SUM(PLANNED_LABOR_REVENUE))*60)/(SUM(SCHED_WORK) + SUM(PLANNED_WORK)))
         ELSE 0.00 END
         FROM TASK_ASSIGNMENTS
         WHERE BILLABLE = 1
         AND PROJECT_ID = T.PROJECT_ID
         AND RESOURCE_ID = h_resource_id
         AND TASK_ID IN ( SELECT  ELEMENT_ID FROM TMT_WBS WHERE PARENT_ID = A.ELEMENT_ID )
         
         ) AS REG_RATE,
         
         0.00 AS SPEC_RATE,
         '' AS ASSIGN_STRING, T.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         h_temp_resource_type AS RESOURCE_TYPE,
         h_resource_id AS RESOURCE_ID, 4 AS PARTICIPANT, 'SCDELIVERABLEMANAGER' AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,
         R.FS_CODE,
         T.STAGE_ID, R.FS_LABOR_CODE ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         ''                               AS LEVEL_ASSIGN_STRING,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR, T.TASK_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME
         
         FROM PMO_TMP_VIEWSPL_0002 A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.ELEMENT_ID
         JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         
         UNION ALL
         
         SELECT 2 AS LEVEL_ID, T.TYPE_ID, T.RANK,
         h_resource_id AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID,
         T.ELEMENT_NAME, ' ' AS ACTIVE,
         0 AS CHILD_COUNT, T.DELETED_COUNT, h_rec_status AS REC_STATUS, T.REC_USER,
         
         R.FULL_NAME AS REC_USER_NAME,
         
         T.REC_DATETIME, T.PRIORITY, T.ELEMENT_ID AS ORIGINAL_ID,
         A.SD, A.START_DT, A.FD, A.FINISH_DT,
         P.MINUTE_PER_DAY AS MINUTE_PER_DAY, -1 AS DURATION,
         A.BASELINE1_START AS BASELINE_START, A.BASELINE1_FINISH AS BASELINE_FINISH,
         (A.BASELINE1_WORK) AS BASELINE1_EFFORT,
         A.PLANNED_START, A.PLANNED_FINISH,
         (A.PLANNED_WORK) AS PLANNED_EFFORT,
         A.PROPOSED_START, A.PROPOSED_FINISH,
         (A.PROPOSED_WORK) AS PROPOSED_EFFORT,
         A.SCHED_START, A.SCHED_FINISH,
         (A.SCHED_WORK) AS SCHED_EFFORT,
         A.FORECAST_START, A.FORECAST_FINISH,
         A.ETC AS ETC, (A.WORK_TODATE + A.ETC) AS FORECAST_EFFORT,
         A.ACTUAL_START, A.ACTUAL_FINISH,
         (A.WORK_TODATE) AS WORK_TODATE, (A.WORK_TODATE) AS ACTUAL_EFFORT, (A.REGULAR_TODATE) AS REGULAR_TODATE, (A.SPECIAL_TODATE) AS SPECIAL_TODATE,
         ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) AS REMAINING_EFFORT,
         CASE WHEN A.ETC = ((A.SCHED_WORK+A.PLANNED_WORK)-A.WORK_TODATE) THEN 0 ELSE 1 END AS ETC_RED_FLAG,
         A.MILESTONE_PERCENT,
         T.SUBPROJECT_COUNT,
         0.00 AS X_ESTIMATION_BUDGET, A.BASELINE1_LABOR_COST AS BASELINE1_BUDGET, A.PLANNED_LABOR_COST AS ESTIMATION_BUDGET, A.PROPOSED_LABOR_COST,
         (A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) AS CURRENT_BUDGET,
         (A.FORECAST_LABOR_COST) AS FORECAST_BUDGET, A.ACTUAL_LABOR_COST AS ACTUAL_BUDGET, ((A.SCHED_LABOR_COST + A.PLANNED_LABOR_COST) - A.ACTUAL_LABOR_COST) AS REMAINING, (A.FORECAST_LABOR_COST-(A.SCHED_LABOR_COST+A.PLANNED_LABOR_COST)) AS BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_COST > 0.00 THEN ((A.PLANNED_LABOR_COST+A.SCHED_LABOR_COST) - A.BASELINE1_LABOR_COST) ELSE 0.00 END AS BASELINE_VARIANCE,
         A.REGULAR_COST AS REG_COST, A.SPECIAL_COST AS SPEC_COST,
         0.00 AS X_R_ESTIMATION_BUDGET, A.BASELINE1_LABOR_REVENUE AS R_BASELINE1_BUDGET, A.PLANNED_LABOR_REVENUE AS R_ESTIMATION_BUDGET, A.PROPOSED_LABOR_REVENUE,
         (A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) AS R_CURRENT_BUDGET,
         A.FORECAST_LABOR_REVENUE AS R_FORECAST_BUDGET, A.ACTUAL_LABOR_REVENUE AS R_ACTUAL_BUDGET, ((A.SCHED_LABOR_REVENUE + A.PLANNED_LABOR_REVENUE) - A.ACTUAL_LABOR_REVENUE) AS R_REMAINING, (A.FORECAST_LABOR_REVENUE - A.ACTUAL_LABOR_REVENUE) AS R_BUDGET_FORECAST_VARIANCE, CASE WHEN A.BASELINE1_LABOR_REVENUE > 0.00 THEN ((A.PLANNED_LABOR_REVENUE+A.SCHED_LABOR_REVENUE) - A.BASELINE1_LABOR_REVENUE) ELSE 0.00 END AS R_BASELINE_VARIANCE,
         case WHEN A.BILLABLE = 1 THEN A.REGULAR_RATE ELSE 0.00 END AS REG_RATE,
         A.SPECIAL_RATE AS SPEC_RATE,
         A.ASSIGN_STRING, A.PROJECT_ID, T.TYPE_ID AS ELEMENT_TYPE_BITS, (CASE WHEN PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3) = 0 THEN '1.0' ELSE '1' || SUBSTR(T.WBS_CODE, PMO_ORASTD.LOCATE('.', T.WBS_CODE, 3)) END) AS WBS_CODE, T.REFERENCE_NUMBER, T.MSP_ID,
         (RTRIM(TO_CHAR(T.MAJOR_REVISION)) || '.' || RTRIM(TO_CHAR(T.MINOR_REVISION))) AS REVISION,
         '' AS REVISION_HISTORY, T.REVISION_TYPE, T.REVISION_IMPACT, T.LAST_WF_TYPE, T.LAST_WF_BY, T.LAST_WF_DT,
         A.RESOURCE_TYPE, A.RESOURCE_ID, 32 AS PARTICIPANT, 'SCTASKRESPONSIBLE' AS SECURITY_ID,
         T.ASSIGN_COUNT, T.ASSIGN_NAMES,
         CASE WHEN InStr(T.ASSIGN_NAMES, h_nick_name || ';') > 0 THEN 'M' ELSE (CASE WHEN T.ASSIGN_COUNT > 0 THEN 'A' ELSE 'N' END) END AS ASSIGNED, '' AS CALENDAR_FLAG,
         0 AS WORK_LOCATION, '' AS ORGANIZATION_NAME, '' AS GEOGRAPHY_NAME,
         R.FS_CODE,
         T.STAGE_ID, R.FS_LABOR_CODE ,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_SCHED_FINISH,
         0    AS ESTIMATED_SCHED_EFFORT,
         0.00 AS ESTIMATED_SCHED_COST,
         0.00 AS ESTIMATED_SCHED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS ESTIMATED_PLANNED_FINISH,
         0    AS ESTIMATED_PLANNED_EFFORT,
         0.00 AS ESTIMATED_PLANNED_COST,
         0.00 AS ESTIMATED_PLANNED_REVENUE,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_PLANNED_FINISH,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000')   AS LEVEL_SCHED_FINISH,
         A.LEVEL_ASSIGN_STRING   AS LEVEL_ASSIGN_STRING,
         A.LEVEL_START           AS LEVEL_START,
         A.LEVEL_FINISH          AS LEVEL_FINISH,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE1_FINISH,
         0                            AS ESTIMATED_BASELINE1_EFFORT,
         0.00                         AS ESTIMATED_BASELINE1_COST,
         0.00                         AS ESTIMATED_BASELINE1_REVENUE,
         
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_START,
         TO_TIMESTAMP('1899-01-01 12:00:00.000000') AS ESTIMATED_BASELINE3_FINISH,
         0                            AS ESTIMATED_BASELINE3_EFFORT,
         0.00                         AS ESTIMATED_BASELINE3_COST,
         0.00                         AS ESTIMATED_BASELINE3_REVENUE,
         
         0 AS BUBBLE_COLOR, T.TASK_TYPE,
         TO_TIMESTAMP('1899-01-01 12:00:00') AS BUBBLE_PUBLISHED_DT, 0 AS UNITS_PERCENT,
         0 AS STAFFING_STATE, 'N' AS SUGGESTED_BY_ME, 'N' AS ACCEPT_ME
         
         FROM TASK_ASSIGNMENTS A
         JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID AND (T.PARENT_ID = A.PROJECT_ID OR T.PROJECT_ID = A.TASK_ID)
         JOIN TMT_WBS P ON P.ELEMENT_ID = T.PROJECT_ID
         JOIN RESOURCES R ON R.RESOURCE_ID = T.REC_USER
         WHERE A.RESOURCE_ID = h_resource_id
         AND A.PROJECT_ID = h_id
         AND A.BIT_FLAG = '0'
         ORDER BY RANK, PLANNED_START;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 1085+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_DEMAND_SUPPLY_OPEN_PROFILES(1086) : views_pool.sql(10706) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN CR00311b;
      End If;
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 1095+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(1096) : views_pool.sql(10716) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEMAND_SUPPLY_OPEN_PROFILES', 1107+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEMAND_SUPPLY_OPEN_PROFILES(1108) : views_pool.sql(10728) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_DEMAND_SUPPLY_OPEN_PROFILES;
ALTER FUNCTION FC_DEMAND_SUPPLY_OPEN_PROFILES COMPILE DEBUG;

/*********************************************************************************/

--

--  p_search_by_name_bitflag = 0(no search by name)

--  p_search_by_name_bitflag = SC_RES_BY_FULLNAME

--  p_search_by_name_bitflag = SC_RES_BY_GIVEN_FAMILY_NAME

--  4th bit NOT USED                                                    (8)

--

--  5th bit NOT USED

--

--  6th bit used to indicate include/exclude Closed items               (32)

--      0:  exclude Closed items

--      1:  include Closed items

--

--  7th bit used to indicate include/exclude Completed items            (64)

--      0:  exclude Completed items

--      1:  include Completed items

--

--  8th bit used to indicate ready to start/in progress only            (128)

--      0:  others

--      1:  ready to start/in progress only

--

--  11th bit: Include Proposed Items                                    (1024)

--      0:  Exclude Proposed Items

--      1:  Include Proposed Items

Prompt == FUNCTION SP_POOL_VIEW ==
CREATE OR REPLACE FUNCTION SP_POOL_VIEW
(
     p_id VARCHAR2
   , p_resource_id VARCHAR2
   , p_name VARCHAR2
   , p_family_name VARCHAR2
   , p_search_by_name_bitflag PLS_INTEGER
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
   , p_user_id VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_string VARCHAR2(1024);
   myStmt VARCHAR2(31999);
   h_nick_name VARCHAR2(100);
   h_full_name VARCHAR2(100);
   h_id VARCHAR2(32);
   h_manager_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_resource_id VARCHAR2(32);
   h_temp_filter_string VARCHAR2(1024);
   h_temp_resource_type VARCHAR2(1);
   h_count PLS_INTEGER := 0;
   h_is_static PLS_INTEGER := 0;
   h_level PLS_INTEGER := 0;
   h_minute_per_day PLS_INTEGER := 0;
   h_temp_bitflag PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_ids VARCHAR2(4000);
   h_active_record PLS_INTEGER := 0;
   h_tsk_assignment_id VARCHAR2(32);
   h_rollup_security PLS_INTEGER := 0;
   h_name VARCHAR2(8000);
   h_family_name VARCHAR2(8000);
   h_search_by_name_bitflag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_POOL_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_POOL_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_POOL_VIEW(' || 
       '''' || p_id || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_name || ''''
          || ', ' || '''' || p_family_name || ''''
          || ', ' || COALESCE(TO_CHAR(p_search_by_name_bitflag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL')
          || ', ' || '''' || p_user_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 56+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_POOL_VIEW(57) : views_pool.sql(10847) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_manager_id := p_user_id;
   h_resource_id := p_resource_id;
   h_active_record := p_active_record;
   h_name := p_name;
   h_family_name := p_family_name;
   h_search_by_name_bitflag := p_search_by_name_bitflag;
   
   /*InitializeHost(SC_PARAM(h_name), "gp1");
   InitializeHost(SC_PARAM(h_family_name), "fp1");
   InitializeHost(SC_PARAM(h_search_by_name_bitflag), SC_RES_BY_GIVEN_FAMILY_NAME);*/
   
   h_rank := '';
   h_count := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_SECURITY';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT REPLACE( RTRIM(NICK_NAME), '''', ''''''), FULL_NAME
      INTO h_nick_name , h_full_name
      FROM RESOURCES
      WHERE RESOURCE_ID = h_resource_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 90+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(91) : views_pool.sql(10881) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
      h_nick_name := NULL;
   End If;
   
   If ((Coalesce(p_type, 0) > 1000) AND (Coalesce(p_type, 0) < 3000)) OR ((Coalesce(
              p_type, 0) > 11000) AND (Coalesce(p_type, 0) < 13000)) OR (Coalesce(
              p_type, 0) = 3224) OR (Coalesce(p_type, 0) = 4224) OR (Coalesce(p_type, 0) = 13224) 
              OR (Coalesce(p_type, 0) = 14224) Then
      h_ids := p_id;
   Else
      h_id := p_id;
      
      If p_id IS NOT NULL Then
         BEGIN
            SELECT TSK_ASSIGNMENT_ID
            INTO h_tsk_assignment_id
            FROM TASK_ASSIGNMENTS
            WHERE TASK_ID = h_id
            AND PROJECT_ID <> TASK_ID
            AND RESOURCE_ID = h_resource_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 121+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(122) : views_pool.sql(10912) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE: %d, h_id: %d %s, h_resource_id: %d %s\n", SC_STATE,h_id_Ind,h_id,h_resource_id_Ind,h_resource_id);
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            h_type_id := PMO_CNST.SC_TASK_ASSN;
            
            BEGIN
               SELECT RANK, LEVEL_ID, MINUTE_PER_DAY, PROJECT_ID, ASSIGN_COUNT, REC_STATUS
               INTO h_rank, h_level, h_minute_per_day, h_project_id, h_count, h_rec_status
               FROM TMT_WBS WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 140+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(141) : views_pool.sql(10931) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT TASK_ID, TSK_ASSIGNMENT_ID
               INTO h_id, h_tsk_assignment_id
               FROM TASK_ASSIGNMENTS
               WHERE TSK_ASSIGNMENT_ID = h_id
               AND PROJECT_ID <> TASK_ID
               AND RESOURCE_ID = h_resource_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 158+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(159) : views_pool.sql(10949) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_type_id := PMO_CNST.SC_TASK_ASSN;
               
               BEGIN
                  SELECT RANK, LEVEL_ID, MINUTE_PER_DAY, PROJECT_ID, ASSIGN_COUNT, REC_STATUS
                  INTO h_rank, h_level, h_minute_per_day, h_project_id, h_count, h_rec_status
                  FROM TMT_WBS WHERE ELEMENT_ID = h_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 176+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(177) : views_pool.sql(10967) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               --trace_printf("SC_STATE: %d, h_id: %d %s, h_resource_id: %d %s\n", SC_STATE,h_id_Ind,h_id,h_resource_id_Ind,h_resource_id);
               BEGIN
                  SELECT RANK, TYPE_ID, LEVEL_ID, MINUTE_PER_DAY, PROJECT_ID, ASSIGN_COUNT, REC_STATUS
                  INTO h_rank, h_type_id, h_level, h_minute_per_day, h_project_id, h_count, h_rec_status
                  FROM TMT_WBS WHERE ELEMENT_ID = h_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 192+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(193) : views_pool.sql(10983) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  h_type_id := 0;
               End If;
            End If;
         End If;
      End If;
      --trace_printf("h_type_id: %d, h_id: %d %s\n",h_type_id,h_id_Ind,h_id);
      
      --h_active_record = h_active_record + SC_INCLUDE_PROPOSED;
   End If;
   
   h_filter_string := ' ';
   
   If Coalesce(p_active_record, 0) = 1 Then
      h_filter_string := h_filter_string || 'AND TA.MILESTONE_PERCENT = 10000 ';
   ElsIf Coalesce(p_active_record, 0) = 2 Then
      h_filter_string := h_filter_string || 'AND TA.MILESTONE_PERCENT < 10000 ';
   End If;
   
   If Coalesce(p_filter_count, 0) = 1 Then
      h_filter_string := h_filter_string || 
                                      'AND TA.ETC > 0 AND PMO_ORASTD.WEEK(COALESCE(TA.ACTUAL_START, TA.FORECAST_START, TA.SCHED_START)) = PMO_ORASTD.WEEK(TO_DATE(SYSDATE)) ';
   ElsIf Coalesce(p_filter_count, 0) = 2 Then
      h_filter_string := h_filter_string || 
                                      'AND TA.ETC > 0 AND PMO_ORASTD.MONTH(COALESCE(TA.ACTUAL_START, TA.FORECAST_START, TA.SCHED_START)) = PMO_ORASTD.MONTH(TO_DATE(SYSDATE)) ';
   ElsIf Coalesce(p_filter_count, 0) = 3 Then
      h_filter_string := h_filter_string || 
                                      'AND TA.MILESTONE_PERCENT = 10000 AND PMO_ORASTD.WEEK(TA.ACTUAL_FINISH) = PMO_ORASTD.WEEK(TO_DATE(SYSDATE)) ';
   ElsIf Coalesce(p_filter_count, 0) = 4 Then
      h_filter_string := h_filter_string || 
                                      'AND TA.MILESTONE_PERCENT = 10000 AND PMO_ORASTD.MONTH(TA.ACTUAL_FINISH) = PMO_ORASTD.MONTH(TO_DATE(SYSDATE)) ';
   End If;
   
   h_is_static := 0;
   If Coalesce(p_type, 0) = 1 Then
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 234+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(235) : views_pool.sql(11025) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      h_temp_filter_string := h_filter_string;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 241+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(242) : views_pool.sql(11032) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_S_VP_001(h_resource_id, h_temp_filter_string);
   ElsIf (Coalesce(p_type, 0) = 3) OR (Coalesce(p_type, 0) = 4) Then
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 247+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(248) : views_pool.sql(11038) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      If p_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 254+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(255) : views_pool.sql(11045) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_RM_RESOURCE_PROJECTS(h_resource_id, h_nick_name, h_active_record);
      Else
         If isProjectType(Coalesce(h_type_id, 0)) <> 0 OR Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
            If (Coalesce(p_type, 0) = 3) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 261+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(262) : views_pool.sql(11052) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_RM_WP_OPEN_PROJECT(h_resource_id, h_id, h_rank, h_nick_name, h_active_record);
            Else
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 266+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(267) : views_pool.sql(11057) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_RM_RES_PRJ_ASSIGNMENTS(h_resource_id, h_id, h_rank, h_nick_name, h_active_record);
            End If;
         End If;
      End If;
   ElsIf Coalesce(p_type, 0) = 5 Then
      -- required: pool_id  resource_id
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 276+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(277) : views_pool.sql(11067) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 282+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(283) : views_pool.sql(11073) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_RM_WP_OPEN_PROJECT(h_resource_id, h_id, h_rank, h_nick_name, h_active_record);
   ElsIf Coalesce(p_type, 0) = 6 Then
      -- required: pool_id  resource_id
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 289+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(290) : views_pool.sql(11080) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 295+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(296) : views_pool.sql(11086) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_RM_RESOURCE_ASSIGNMENTS(h_resource_id, h_nick_name);
   ElsIf Coalesce(p_type, 0) = 7 Then
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 301+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(302) : views_pool.sql(11092) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      If Coalesce(h_search_by_name_bitflag, 0) = 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 308+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(309) : views_pool.sql(11099) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_RM_POOL_LIST(h_resource_id);
      Else
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 313+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(314) : views_pool.sql(11104) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN FC_RM_RESOURCE_LIST(h_resource_id, h_name, h_family_name, h_search_by_name_bitflag);
      End If;
   ElsIf Coalesce(p_type, 0) = 9 Then
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 320+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(321) : views_pool.sql(11111) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 326+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(327) : views_pool.sql(11117) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_RM_RESOURCE_LIST(h_resource_id, h_name, h_family_name, h_search_by_name_bitflag);
   ElsIf Coalesce(p_type, 0) = 12 Then
      If p_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 332+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(333) : views_pool.sql(11123) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      h_temp_bitflag := p_type;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 340+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(341) : views_pool.sql(11131) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_RM_OPEN_POOL(h_temp_bitflag, h_resource_id, h_id, h_rank);
   ElsIf Coalesce(p_type, 0) = 14 Then
      If p_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 346+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(347) : views_pool.sql(11137) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      h_temp_bitflag := p_type;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 354+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(355) : views_pool.sql(11145) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_RM_OPEN_POOL(h_temp_bitflag, h_resource_id, h_id, h_rank);
   ElsIf Coalesce(p_type, 0) = 20 Then
      If p_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 360+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(361) : views_pool.sql(11151) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      BEGIN
         SELECT RANK INTO h_rank
         FROM TMT_POOLS WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 374+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(375) : views_pool.sql(11165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_rank := h_rank || '%%';
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 382+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(383) : views_pool.sql(11173) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_RM_REFRESH_POOL(h_resource_id, h_id, h_rank);
   ElsIf (Coalesce(p_type, 0) = 21) OR (Coalesce(p_type, 0) = 22) Then
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 388+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(389) : views_pool.sql(11179) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      BEGIN
         SELECT REPLACE( RTRIM(R.NICK_NAME), '''', '''''')
         INTO h_nick_name
         FROM TMT_POOLS P JOIN RESOURCES R ON R.RESOURCE_ID = P.REC_USER
         WHERE P.ELEMENT_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 404+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(405) : views_pool.sql(11195) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_temp_bitflag := p_type;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 412+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(413) : views_pool.sql(11203) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_RM_REFRESH_RESOURCE(h_temp_bitflag, h_resource_id);
   ElsIf (Coalesce(p_type, 0) = 30) OR (Coalesce(p_type, 0) = 1030) OR (Coalesce(
                p_type, 0) = 2030) Then
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 419+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(420) : views_pool.sql(11210) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      h_ids := p_id;
      
      If (h_ids IS NOT NULL) AND (Coalesce(p_type, 0) = 2030) Then
         h_table_type := PMO_CNST.SC_FOLDER;
      Else
         h_table_type := PMO_CNST.SC_PROJECT;
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 433+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(434) : views_pool.sql(11224) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_TEAM_WP(h_table_type, h_ids, h_resource_id, h_nick_name, h_active_record);
   ElsIf Coalesce(p_type, 0) = 31 Then
      -- Demand Supply, Returns: Project/Profiles
      If p_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 440+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(441) : views_pool.sql(11231) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 446+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(447) : views_pool.sql(11237) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_DEMAND_SUPPLY_PROFILES(h_resource_id, h_id, h_nick_name, h_full_name, h_rank, h_count
            , h_minute_per_day, h_rec_status);
   ElsIf Coalesce(p_type, 0) = 311 Then
      If p_id IS NULL AND (p_resource_id IS NULL) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 453+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(454) : views_pool.sql(11244) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 459+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(460) : views_pool.sql(11250) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_DEMAND_SUPPLY_OPEN_PROFILES(h_resource_id, h_id, h_nick_name, h_full_name, h_rank
            , h_minute_per_day, h_project_id, h_manager_id, h_rec_status, h_temp_resource_type);
   ElsIf (Coalesce(p_type, 0) = 32) OR (Coalesce(p_type, 0) = 1032) OR (Coalesce(
                p_type, 0) = 2032) Then
      --trace_printf("32.0__ ******************************************\n");
      -- Team Member Level 0, Returns: ME/Projects
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 469+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(470) : views_pool.sql(11260) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      h_ids := p_id;
      
      If (h_ids IS NOT NULL) AND (Coalesce(p_type, 0) = 2032) Then
         h_table_type := PMO_CNST.SC_FOLDER;
      Else
         h_table_type := PMO_CNST.SC_PROJECT;
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 483+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(484) : views_pool.sql(11274) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_WORK_WP(h_table_type, h_ids, h_resource_id, h_nick_name, h_active_record);
   ElsIf Coalesce(p_type, 0) = 33 Then
      -- required: project_id  resource_id
      -- Resource Manager Level 2, Work Package View, Returns: Project/Deliverable/Task_Assignments
      If (p_resource_id IS NULL) OR (p_id IS NULL) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 491+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(492) : views_pool.sql(11282) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 497+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(498) : views_pool.sql(11288) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_WORK_OPEN_PROJECT(h_resource_id, h_id, h_level, h_nick_name, h_full_name
            , h_temp_resource_type, h_type_id, h_project_id, h_rank, h_active_record);
   ElsIf Coalesce(p_type, 0) = 34 Then
      If p_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 504+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(505) : views_pool.sql(11295) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 510+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(511) : views_pool.sql(11301) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_TEAM_OPEN_PROJECT(h_resource_id, h_id, h_rank, h_level, h_nick_name, h_rec_status
            , h_active_record);
   ElsIf Coalesce(p_type, 0) = 35 Then
      If p_resource_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 517+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(518) : views_pool.sql(11308) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      If p_id IS NULL Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 524+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(525) : views_pool.sql(11315) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 530+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(531) : views_pool.sql(11321) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_RES_PRJ_ASSIGNMENTS(h_resource_id, h_id, h_nick_name, h_full_name, h_rank
            , h_minute_per_day, h_project_id, h_manager_id, h_rec_status, h_temp_resource_type
            , h_active_record);
   ElsIf Coalesce(p_type, 0) = 51 Then
      --PM WBS ELEMENTS REFRESH
      If (p_id IS NULL) AND (p_resource_id IS NULL) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 539+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(540) : views_pool.sql(11330) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 545+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(546) : views_pool.sql(11336) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_TEAM_REFRESH_ELEMENT(h_type_id, h_resource_id, h_id, h_rank, h_nick_name, h_count
            , h_project_id, h_manager_id, h_active_record);
   ElsIf Coalesce(p_type, 0) = 53 Then
      --TM WBS ELEMENTS REFRESH
      If (p_id IS NULL) AND (p_resource_id IS NULL) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 553+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(554) : views_pool.sql(11344) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 559+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(560) : views_pool.sql(11350) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WBS_MY_WORK_REFRESH_ELEMENT(h_resource_id, h_id, h_nick_name, h_type_id, h_project_id
            , h_rank, h_active_record);
   ElsIf Coalesce(p_type, 0) = 72 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 565+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(566) : views_pool.sql(11356) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_S_VP_072(h_resource_id, h_active_record, h_manager_id);
   ElsIf Coalesce(p_type, 0) = 73 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 570+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(571) : views_pool.sql(11361) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_S_VP_073(h_resource_id, h_manager_id);
   ElsIf (Coalesce(p_type, 0) = 100) OR (Coalesce(p_type, 0) = 101) Then
      --PM WBS ELEMENTS REFRESH
      If (p_id IS NULL) AND (p_resource_id IS NULL) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 577+1) THEN 
            LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(578) : views_pool.sql(11368) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
         END IF; 
         PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
      End If;
      
      If Coalesce(p_type, 0) = 100 Then
         h_rollup_security := 1;
      ElsIf Coalesce(p_type, 0) = 101 Then
         h_rollup_security := 2;
      End If;
      
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 589+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(590) : views_pool.sql(11380) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_REF_TASK_IN_MY_AND_MYTEAM(h_rollup_security, h_type_id, h_resource_id, h_id, h_rank
            , h_nick_name, h_count, h_project_id, h_manager_id);
   ElsIf ((Coalesce(p_type, 0) > 1000) AND (Coalesce(p_type, 0) < 3000)) OR ((Coalesce(
                 p_type, 0) > 11000) AND (Coalesce(p_type, 0) < 13000)) OR (Coalesce(
                 p_type, 0) = 3224) OR (Coalesce(p_type, 0) = 4224) OR (Coalesce(
                 p_type, 0) = 13224) OR (Coalesce(p_type, 0) = 14224) Then
      h_temp_bitflag := p_type;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 599+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(600) : views_pool.sql(11390) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN FC_WORK_MANAGEMENT_VIEW(h_resource_id, h_ids, h_nick_name, Coalesce(h_temp_bitflag, 0)
            , h_manager_id, h_active_record);
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_POOL_VIEW', 605+1) THEN 
         LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_POOL_VIEW(606) : views_pool.sql(11396) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
      END IF; 
      PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
   End If;
   --Return a resultset
   
   --trace_printf("%s\n", (char *) myStmt);
   If Coalesce(h_is_static, 0) = 0 Then
      myStmt := myStmt || ' ORDER BY RANK, PLANNED_START ';
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 615+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(616) : views_pool.sql(11406) : ' || SYSTIMESTAMP);
      END IF; 
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_POOL_VIEW', 618+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: SP_POOL_VIEW(619) : views_pool.sql(11409) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMODEFINES.PMO_SELECT_READ(myStmt);
   End If;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 627+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(628) : views_pool.sql(11418) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_POOL_VIEW', 639+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_POOL_VIEW(640) : views_pool.sql(11430) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_POOL_VIEW;
ALTER FUNCTION SP_POOL_VIEW COMPILE DEBUG;

