/*******************************************************************************************/

Prompt == FUNCTION FC_DECLARE_RES_AGGREGATION ==
CREATE OR REPLACE FUNCTION FC_DECLARE_RES_AGGREGATION RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DECLARE_RES_AGGREGATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DECLARE_RES_AGGREGATION'), '-- ' || SYSTIMESTAMP, ':r := FC_DECLARE_RES_AGGREGATION();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_RES_AGGREGATION', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DECLARE_RES_AGGREGATION(9) : views_ts.sql(12) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_RES_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_RES_AGGREGATION', 16+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DECLARE_RES_AGGREGATION(17) : views_ts.sql(20) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DECLARE_RES_AGGREGATION;
ALTER FUNCTION FC_DECLARE_RES_AGGREGATION COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_DECLARE_PRJ_AGGREGATION ==
CREATE OR REPLACE FUNCTION FC_DECLARE_PRJ_AGGREGATION RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DECLARE_PRJ_AGGREGATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DECLARE_PRJ_AGGREGATION'), '-- ' || SYSTIMESTAMP, ':r := FC_DECLARE_PRJ_AGGREGATION();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_PRJ_AGGREGATION', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DECLARE_PRJ_AGGREGATION(9) : views_ts.sql(39) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PRJ_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_PRJ_AGGREGATION', 16+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DECLARE_PRJ_AGGREGATION(17) : views_ts.sql(47) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DECLARE_PRJ_AGGREGATION;
ALTER FUNCTION FC_DECLARE_PRJ_AGGREGATION COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_DECLARE_DEL_AGGREGATION ==
CREATE OR REPLACE FUNCTION FC_DECLARE_DEL_AGGREGATION RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DECLARE_DEL_AGGREGATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DECLARE_DEL_AGGREGATION'), '-- ' || SYSTIMESTAMP, ':r := FC_DECLARE_DEL_AGGREGATION();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_DEL_AGGREGATION', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DECLARE_DEL_AGGREGATION(9) : views_ts.sql(66) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DEL_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_DEL_AGGREGATION', 16+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DECLARE_DEL_AGGREGATION(17) : views_ts.sql(74) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DECLARE_DEL_AGGREGATION;
ALTER FUNCTION FC_DECLARE_DEL_AGGREGATION COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_DECLARE_TASK_AGGREGATION ==
CREATE OR REPLACE FUNCTION FC_DECLARE_TASK_AGGREGATION RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DECLARE_TASK_AGGREGATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DECLARE_TASK_AGGREGATION'), '-- ' || SYSTIMESTAMP, ':r := FC_DECLARE_TASK_AGGREGATION();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_TASK_AGGREGATION', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DECLARE_TASK_AGGREGATION(9) : views_ts.sql(93) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_TASK_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_TASK_AGGREGATION', 16+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DECLARE_TASK_AGGREGATION(17) : views_ts.sql(101) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DECLARE_TASK_AGGREGATION;
ALTER FUNCTION FC_DECLARE_TASK_AGGREGATION COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_DECLARE_ASSIGN_AGGREGATION ==
CREATE OR REPLACE FUNCTION FC_DECLARE_ASSIGN_AGGREGATION RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DECLARE_ASSIGN_AGGREGATION') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DECLARE_ASSIGN_AGGREGATION'), '-- ' || SYSTIMESTAMP, ':r := FC_DECLARE_ASSIGN_AGGREGATION();');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_ASSIGN_AGGREGATION', 8+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DECLARE_ASSIGN_AGGREGATION(9) : views_ts.sql(120) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_ASSIGN_AGGREGATION';
   PMO_DB2M.SC_STATE := 0;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DECLARE_ASSIGN_AGGREGATION', 16+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DECLARE_ASSIGN_AGGREGATION(17) : views_ts.sql(128) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DECLARE_ASSIGN_AGGREGATION;
ALTER FUNCTION FC_DECLARE_ASSIGN_AGGREGATION COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_TIMESHEET_ROLLUP_DEL_LEVEL ==
CREATE OR REPLACE FUNCTION FC_TIMESHEET_ROLLUP_DEL_LEVEL
(
     h_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_root_id VARCHAR2(32);
   null_return LONG;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMESHEET_ROLLUP_DEL_LEVEL') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMESHEET_ROLLUP_DEL_LEVEL'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMESHEET_ROLLUP_DEL_LEVEL(' || 
       '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMESHEET_ROLLUP_DEL_LEVEL', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMESHEET_ROLLUP_DEL_LEVEL(18) : views_ts.sql(156) : ' || SYSTIMESTAMP);
   END IF; 

   null_return := FC_DECLARE_DEL_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_DEL_AGGREGATION
      SELECT A.PROJECT_ID, A.DELIVERABLE_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      WHERE A.PROJECT_ID <> A.DELIVERABLE_ID
      GROUP BY A.PROJECT_ID, A.DELIVERABLE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMESHEET_ROLLUP_DEL_LEVEL', 58+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMESHEET_ROLLUP_DEL_LEVEL(59) : views_ts.sql(197) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_type_id:%d", h_type_id);
   
   If NOT (isProjectType(Coalesce(h_type_id, 0)) <> 0 OR (Coalesce(
         h_type_id, 0) = PMO_CNST.SC_RESOURCE)) Then
      BEGIN
         SELECT DISTINCT DELIVERABLE_ID
         INTO h_root_id
         FROM PMO_TMP_DEL_AGGREGATION
         WHERE DELIVERABLE_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMESHEET_ROLLUP_DEL_LEVEL', 78+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMESHEET_ROLLUP_DEL_LEVEL(79) : views_ts.sql(217) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO PMO_TMP_DEL_AGGREGATION
            SELECT A.PROJECT_ID, h_id,
            CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
            CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
            SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
            CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
            CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
            CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
            CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
            CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
            CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
            SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
            (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
            SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
            SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
            SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
            SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
            SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
            SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
            SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
            SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
            SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
            FROM PMO_TMP_TASK_AGGREGATION A
            WHERE A.PROJECT_ID <> A.DELIVERABLE_ID
            GROUP BY A.PROJECT_ID, h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMESHEET_ROLLUP_DEL_LEVEL', 120+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMESHEET_ROLLUP_DEL_LEVEL(121) : views_ts.sql(259) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE PMO_TMP_DEL_AGGREGATION
            SET (PROPOSED_START, PROPOSED_FINISH, PROPOSED_WORK, SCHED_START,
            SCHED_FINISH, FORECAST_START, FORECAST_FINISH, ACTUAL_START,
            ACTUAL_FINISH, SCHED_WORK, ETC, WORK_TODATE, REGULAR_TODATE,
            SPECIAL_TODATE, BASELINE1_WORK, MILESTONE_PERCENT, MONDAY_REGULAR,
            MONDAY_SPECIAL, TUESDAY_REGULAR, TUESDAY_SPECIAL, WEDNESDAY_REGULAR,
            WEDNESDAY_SPECIAL, THURSDAY_REGULAR, THURSDAY_SPECIAL, FRIDAY_REGULAR,
            FRIDAY_SPECIAL, SATURDAY_REGULAR, SATURDAY_SPECIAL, SUNDAY_REGULAR,
            SUNDAY_SPECIAL, WEEKLY_REGULAR_TOTAL, WEEKLY_SPECIAL_TOTAL, ORIGINAL_SCHED_WEEK,
            SCHED_WEEK) =
            (SELECT CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
            CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
            SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
            CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
            CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
            CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
            CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
            CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
            CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
            SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
            (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
            SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
            SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
            SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
            SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
            SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
            SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
            SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
            SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
            SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
            FROM PMO_TMP_TASK_AGGREGATION A
            WHERE A.PROJECT_ID <> A.DELIVERABLE_ID
            GROUP BY A.PROJECT_ID, h_id)
            WHERE DELIVERABLE_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMESHEET_ROLLUP_DEL_LEVEL', 170+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMESHEET_ROLLUP_DEL_LEVEL(171) : views_ts.sql(309) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMESHEET_ROLLUP_DEL_LEVEL', 178+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMESHEET_ROLLUP_DEL_LEVEL(179) : views_ts.sql(317) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMESHEET_ROLLUP_DEL_LEVEL;
ALTER FUNCTION FC_TIMESHEET_ROLLUP_DEL_LEVEL COMPILE DEBUG;

/*******************************************************************************************/

Prompt == PROCEDURE GetTimesheetFilterFlag ==
CREATE OR REPLACE PROCEDURE GetTimesheetFilterFlag
(
     sh_h_filter_flag PLS_INTEGER
   , h_include_all IN OUT NOCOPY PLS_INTEGER
   , h_include_opened IN OUT NOCOPY PLS_INTEGER
   , h_include_completed IN OUT NOCOPY PLS_INTEGER
   , h_include_active IN OUT NOCOPY PLS_INTEGER
   , h_include_week IN OUT NOCOPY PLS_INTEGER
   , h_include_month IN OUT NOCOPY PLS_INTEGER
)
AS
   h_filter_flag PLS_INTEGER := Coalesce(sh_h_filter_flag, 0);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('GetTimesheetFilterFlag') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('GetTimesheetFilterFlag'), '-- ' || SYSTIMESTAMP, ':r := GetTimesheetFilterFlag(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_all), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_opened), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_completed), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_active), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_week), 'NULL')
          || ', ' || COALESCE(TO_CHAR(h_include_month), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'GetTimesheetFilterFlag', 25+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: GetTimesheetFilterFlag(26) : views_ts.sql(353) : ' || SYSTIMESTAMP);
   END IF; 

   h_include_all := 1;
   h_include_opened := 1;
   h_include_completed := 1;
   h_include_active := 1;
   h_include_week := 1;
   h_include_month := 1;
   
   If h_filter_flag = PMO_CNST.SC_ALL_ASSIGNMENTS Then
      h_include_all := 0;
   ElsIf h_filter_flag = PMO_CNST.SC_OPENED_ASSIGNMENTS Then
      h_include_opened := 0;
   ElsIf h_filter_flag = PMO_CNST.SC_COMPLETED_ASSIGNMENTS Then
      h_include_completed := 0;
   ElsIf h_filter_flag = PMO_CNST.SC_ACTIVE_ASSIGNMENTS Then
      h_include_active := 0;
   ElsIf h_filter_flag = PMO_CNST.SC_WEEK_ASSIGNMENTS Then
      h_include_week := 0;
   ElsIf h_filter_flag = PMO_CNST.SC_MONTH_ASSIGNMENTS Then
      h_include_month := 0;
   End If;
END;
/
SHOW ERRORS PROCEDURE GetTimesheetFilterFlag;
ALTER PROCEDURE GetTimesheetFilterFlag COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_GET_LAST_DATE_OF_TIMESHEET ==
CREATE OR REPLACE FUNCTION FC_GET_LAST_DATE_OF_TIMESHEET
(
     h_last_date_of_timesheet IN OUT NOCOPY TIMESTAMP
) RETURN PLS_INTEGER
AS
   h_month PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_GET_LAST_DATE_OF_TIMESHEET') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_GET_LAST_DATE_OF_TIMESHEET'), '-- ' || SYSTIMESTAMP, ':r := FC_GET_LAST_DATE_OF_TIMESHEET(' || 
       COALESCE(NULLIF('''' || h_last_date_of_timesheet || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_LAST_DATE_OF_TIMESHEET', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_GET_LAST_DATE_OF_TIMESHEET(14) : views_ts.sql(397) : ' || SYSTIMESTAMP);
   END IF; 

   h_last_date_of_timesheet := NULL;
   
   BEGIN
      SELECT SETTING_VALUE
      INTO h_month
      FROM TMT_SETTINGS
      WHERE ELEMENT_ID = 'MAX_MONTHS_FOR_ALL_TIMESHEET';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_LAST_DATE_OF_TIMESHEET', 29+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_LAST_DATE_OF_TIMESHEET(30) : views_ts.sql(413) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT Add_Months(SYSTIMESTAMP, h_month)
      INTO h_last_date_of_timesheet FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_GET_LAST_DATE_OF_TIMESHEET', 43+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_GET_LAST_DATE_OF_TIMESHEET(44) : views_ts.sql(427) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_GET_LAST_DATE_OF_TIMESHEET', 49+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_GET_LAST_DATE_OF_TIMESHEET(50) : views_ts.sql(433) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_GET_LAST_DATE_OF_TIMESHEET;
ALTER FUNCTION FC_GET_LAST_DATE_OF_TIMESHEET COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_S_VTS_001 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_001
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_count PLS_INTEGER := 0;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0001 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_001') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_001'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_001(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_001', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_001(41) : views_ts.sql(484) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   null_return := FC_DECLARE_PRJ_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_PRJ_AGGREGATION
      SELECT TA.RESOURCE_ID, TA.PROJECT_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.RESOURCE_ID = TA.RESOURCE_ID
      AND EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.TASK_ID <> EW.PROJECT_ID
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10)) AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.PROJECT_ID = TA.PROJECT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      AND P.PUBLISHED = '1'
      AND P.REC_STATUS <> 'D'
      AND P.TYPE_ID <> PMO_CNST.SC_RESOURCE
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.RESOURCE_ID = h_resource_id
      AND TA.TABLE_TYPE = 1
      AND TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_001', 116+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_001(117) : views_ts.sql(560) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -----------------------------------------------------------------------//
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_TMP_PRJ_AGGREGATION (RESOURCE_ID) VALUES( h_resource_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_001', 135+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_001(136) : views_ts.sql(579) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      INSERT INTO PMO_TMP_PRJ_AGGREGATION
      SELECT P.Pool_ID, P.PROJECT_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.RESOURCE_ID = P.PROJECT_ID
      AND EW.PROJECT_ID = P.PROJECT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.TASK_ID <> EW.PROJECT_ID
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = P.PROJECT_ID
      AND TC.PROJECT_ID = P.PROJECT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TMT_WBS P
      LEFT JOIN TASK_ASSIGNMENTS TA ON P.PROJECT_ID = TA.PROJECT_ID
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE P.POOL_ID = h_resource_id
      AND P.TYPE_ID = PMO_CNST.SC_RESOURCE
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY P.POOL_ID, P.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_001', 202+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_001(203) : views_ts.sql(646) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   ---------------------------------------------------------------------------//
   h_count := 0;
   
   BEGIN
      SELECT COUNT(TA.TASK_ID)
      INTO h_count
      FROM TMT_WBS P
      JOIN TASK_ASSIGNMENTS TA ON P.PROJECT_ID = TA.PROJECT_ID
      WHERE P.POOL_ID =  h_resource_id
      AND P.TYPE_ID = PMO_CNST.SC_RESOURCE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_001', 223+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_001(224) : views_ts.sql(667) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR0001 \n");
   
   OPEN CR0001 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID, '----' AS RANK, '' AS PARENT_ID,
   h_resource_id  AS ELEMENT_ID, h_full_name AS ELEMENT_NAME,
   COUNT(A.PROJECT_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
   SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R.FULL_NAME AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE,'' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_resource_id THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, R2.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   0 AS STAGE_ID, A.RESOURCE_ID AS ORIGINAL_ID
   FROM PMO_TMP_PRJ_AGGREGATION A
   LEFT OUTER JOIN RESOURCES R ON R.RESOURCE_ID = A.CHECKEDOUT_BY
   LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.WEEK_OF = h_week_of
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.ELEMENT_ID = A.RESOURCE_ID
   LEFT OUTER JOIN RESOURCES R2 ON R2.RESOURCE_ID = TSA.MANAGER_ID
   GROUP BY A.RESOURCE_ID, A.CHECKEDOUT_BY, R.FULL_NAME, TSA.CURRENT_STATE,TSA.MANAGER_ID,R2.FULL_NAME,TSA.REC_DATETIME
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, 1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE,'' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_resource_id THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   RA.RESOURCE_ID AS MANAGER_ID, RA.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_PRJ_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.WEEK_OF = h_week_of
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.ELEMENT_ID = A.PROJECT_ID
   LEFT OUTER JOIN RESOURCES RA ON RA.RESOURCE_ID = TSA.MANAGER_ID
   WHERE T.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, PMO_CNST.SC_PERSONAL_PROJECT AS TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   h_count AS CHILD_COUNT,
   T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE,'' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_resource_id THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   RA.RESOURCE_ID AS MANAGER_ID, RA.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   0 AS STAGE_ID, '' AS ORIGINAL_ID
   FROM PMO_TMP_PRJ_AGGREGATION A JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.WEEK_OF = h_week_of
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.ELEMENT_ID = A.PROJECT_ID
   LEFT OUTER JOIN RESOURCES RA ON RA.RESOURCE_ID = TSA.MANAGER_ID
   WHERE T.TYPE_ID = 13
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_001', 352+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_001(353) : views_ts.sql(796) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0001;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_001', 360+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_001(361) : views_ts.sql(804) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_001', 372+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_001(373) : views_ts.sql(816) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_001;
ALTER FUNCTION FC_S_VTS_001 COMPILE DEBUG;

/**********************************************************************************************/

Prompt == FUNCTION FC_S_VTS_10 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_10
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR10 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_10') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_10'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_10(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_10', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_10(45) : views_ts.sql(877) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   --trace_printf("h_resource_id: %s,h_week_of: %s,h_last_date_of_timesheet: %s\n", h_resource_id,h_week_of,h_last_date_of_timesheet);
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID,  TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, ''  AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END) AS CHECKEDOUT_BY,
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10)) AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10)) AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_10', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_10(118) : views_ts.sql(950) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_resource_id: %s,h_week_of: %s,h_last_date_of_timesheet: %s\n", SC_STATE,h_resource_id,h_week_of,h_last_date_of_timesheet);
   
   --trace_printf("\n CR10 \n");
   
   OPEN CR10 FOR -- PROJECT LEVEL
   SELECT 1 AS LEVEL_ID, CASE WHEN T.TYPE_ID = 13 THEN PMO_CNST.SC_PERSONAL_PROJECT ELSE T.TYPE_ID END AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   COUNT(A.TASK_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, T.PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
   SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE,'' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_resource_id THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, R.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM TMT_WBS T
   LEFT JOIN PMO_TMP_TASK_AGGREGATION A ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.WEEK_OF = h_week_of
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.ELEMENT_ID = A.PROJECT_ID
   LEFT JOIN RESOURCES R ON TSA.MANAGER_ID = R.RESOURCE_ID
   WHERE T.ELEMENT_ID = h_id
   GROUP BY A.RESOURCE_ID, A.PROJECT_ID, T.TYPE_ID, T.RANK, T.ELEMENT_ID, T.ELEMENT_NAME, T.PRIORITY, TSA.MANAGER_ID, TSA.CURRENT_STATE, TSA.REC_DATETIME, R.FULL_NAME, T.STAGE_ID;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_10', 173+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_10(174) : views_ts.sql(1006) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR10;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_10', 181+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_10(182) : views_ts.sql(1014) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_10', 193+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_10(194) : views_ts.sql(1026) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_10;
ALTER FUNCTION FC_S_VTS_10 COMPILE DEBUG;

/**********************************************************************************************/

Prompt == FUNCTION FC_S_VTS_002 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_002
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0002 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_002') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_002'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_002(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_002', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_002(45) : views_ts.sql(1087) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_002', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_002(64) : views_ts.sql(1106) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID,  TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10)) AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10)) AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      join tmt_wbs del on del.rank = case when length(w.rank)>(h_rank_length + 4) then substr(W.rank,1,(h_rank_length + 4)) else h_rank end
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_002', 133+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_002(134) : views_ts.sql(1176) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_TIMESHEET_ROLLUP_DEL_LEVEL(h_id, h_type_id);
   
   null_return := FC_DECLARE_ASSIGN_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGN_AGGREGATION
      SELECT A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      WHERE A.PROJECT_ID = A.DELIVERABLE_ID
      GROUP BY A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_002', 178+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_002(179) : views_ts.sql(1221) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR0002 \n");
   
   OPEN CR0002 FOR SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   COUNT(A.TASK_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, T.PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
   SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE,'' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_resource_id THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, R.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT OUTER JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.WEEK_OF = h_week_of
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.ELEMENT_ID = A.PROJECT_ID
   LEFT JOIN RESOURCES R ON TSA.MANAGER_ID = R.RESOURCE_ID
   GROUP BY A.RESOURCE_ID, A.PROJECT_ID, T.RANK, T.ELEMENT_ID, T.ELEMENT_NAME, T.PRIORITY, TSA.MANAGER_ID, TSA.CURRENT_STATE, TSA.REC_DATETIME, R.FULL_NAME, T.STAGE_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID,
   case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   A.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   A.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.DELIVERABLE_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID,
   CASE WHEN W.POOL_ID = h_resource_id THEN PMO_CNST.SC_PERSONAL_TASK ELSE T.TYPE_ID END AS TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_ASSIGN_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TMT_WBS W ON W.ELEMENT_ID = A.PROJECT_ID
   AND W.PROJECT_ID = A.PROJECT_ID
   AND W.REC_STATUS <> 'D'
   JOIN TASK_ASSIGNMENTS TA
   ON TA.TASK_ID = A.TASK_ID
   AND TA.RESOURCE_ID = h_resource_id
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1 ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2 ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1 ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2 ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_002', 322+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_002(323) : views_ts.sql(1365) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0002;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_002', 330+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_002(331) : views_ts.sql(1373) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_002', 342+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_002(343) : views_ts.sql(1385) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_002;
ALTER FUNCTION FC_S_VTS_002 COMPILE DEBUG;

/********************************************************************/

Prompt == FUNCTION FC_S_VTS_005 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_005
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0005 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_005') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_005'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_005(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_005', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_005(40) : views_ts.sql(1441) : ' || SYSTIMESTAMP);
   END IF; 

   --  SC_CHAR(h_parent_id, SC_H_ID);
   
   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   --  Nullify(SC_PARAM(h_parent_id));
   --  BEGIN_SQL
   --      SELECT PROJECT_ID
   --      INTO HOST(h_parent_id)
   --      FROM TMT_WBS
   --      WHERE ELEMENT_ID = HOST(h_project_id)
   --          AND TYPE_ID = SC_RESOURCE
   --          AND POOL_ID = HOST(h_resource_id);
   --  END_SQL_CHECK;
   --trace_printf("SC_STATE: %d, h_parent_id: %d %s\n", SC_STATE, h_parent_id_Ind,h_parent_id);
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT
      TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID AS DELIVERABLE_ID,  MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_project_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_005', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_005(128) : views_ts.sql(1529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_ASSIGN_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGN_AGGREGATION
      SELECT A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      GROUP BY A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_005', 169+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_005(170) : views_ts.sql(1571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR0005 \n");
   
   OPEN CR0005 FOR SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   COUNT(A.TASK_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, T.PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   TSA.CURRENT_STATE, TSA.MANAGER_ID, PM1.FULL_NAME AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   AND T.PROJECT_ID = A.PROJECT_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON  TSA.WEEK_OF = h_week_of
   AND TSA.RESOURCE_ID = h_resource_id
   AND TSA.ELEMENT_ID  = A.PROJECT_ID
   LEFT JOIN RESOURCES PM1 ON PM1.RESOURCE_ID = TSA.MANAGER_ID
   GROUP BY A.RESOURCE_ID, A.PROJECT_ID, T.RANK, T.ELEMENT_ID, T.ELEMENT_NAME, T.PRIORITY,TSA.NOTE,TSA.CURRENT_STATE, TSA.MANAGER_ID, PM1.FULL_NAME, T.STAGE_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_ASSIGN_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1 ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2 ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1 ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2 ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_005', 270+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_005(271) : views_ts.sql(1672) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0005;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_005', 278+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_005(279) : views_ts.sql(1680) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_005', 290+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_005(291) : views_ts.sql(1692) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_005;
ALTER FUNCTION FC_S_VTS_005 COMPILE DEBUG;

/*******************************************************************************************/

Prompt == FUNCTION FC_S_VTS_006 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_006
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_cur_date TIMESTAMP;
   h_manager_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      CURSOR C_MNG_ID IS
         SELECT DISTINCT A.PROJECT_ID, TSA.MANAGER_ID, TSA.REC_DATETIME
         FROM PMO_TMP_VTS_0005 A
         JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
         AND TSA.ELEMENT_ID = A.PROJECT_ID
         AND TSA.CURRENT_STATE = A.ROLLUP_STATE;

      -- Resultset Cursor Declaration
      CR0006 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_006') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_006'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_006(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_006', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_006(50) : views_ts.sql(1758) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_0005';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_0005
      SELECT PA.PROJECT_ID,
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = PA.PROJECT_ID
      AND EW.PROJECT_ID <> EW.TASK_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = TC.TSK_ASSIGNMENT_ID
      AND TA.RESOURCE_TYPE = '0'
      AND TA.TASK_ID <> TA.PROJECT_ID
      WHERE TC.PROJECT_ID = PA.PROJECT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK,
      MAX(TSA.CURRENT_STATE), '1899-12-31 00:00:00' , ''
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS P ON P.ELEMENT_ID = PA.PROJECT_ID
      AND P.PROJECT_ID = PA.PROJECT_ID
      AND P.PUBLISHED = '1'
      AND P.REC_STATUS <> 'D'
      AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
      JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = PA.PROJECT_ID
      AND TA.TABLE_TYPE = 1
      AND TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = TA.PROJECT_ID
      AND TSA.RESOURCE_ID = TA.RESOURCE_ID
      AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE PA.RESOURCE_ID = h_resource_id
      AND BITAND(PA.PARTICIPANT, 67) > 0
      GROUP BY PA.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_006', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_006(136) : views_ts.sql(1844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_project_id := NULL;
   h_manager_id := NULL;
   h_cur_date := NULL;
   
   OPEN C_MNG_ID;
   
   LOOP
      FETCH C_MNG_ID INTO h_project_id, h_manager_id, h_cur_date;
      IF C_MNG_ID%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      --trace_printf("SC_STATE: %d,h_project_id: %d, h_manager_id: %s\n", SC_STATE,h_project_id,h_manager_id);
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If h_manager_id IS NOT NULL Then
         BEGIN
            UPDATE PMO_TMP_VTS_0005
            SET MANAGER_ID = h_manager_id,
            REC_DT = h_cur_date
            WHERE PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_006', 175+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_006(176) : views_ts.sql(1884) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_MNG_ID ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_006', 190+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_006(191) : views_ts.sql(1899) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR0006 \n");
   
   OPEN CR0006 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID,        -- resource level
   '----' AS RANK, '' AS PARENT_ID,
   h_resource_id
   AS ELEMENT_ID,
   h_full_name
   AS ELEMENT_NAME,
   COUNT(A.PROJECT_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_FINISH) < MIN(A.SCHED_FINISH) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE, '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE ,
   0 AS STAGE_ID, h_resource_id AS ORIGINAL_ID
   FROM PMO_TMP_VTS_0005 A
   
   UNION ALL
   
   SELECT 1 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN A.MANAGER_ID = h_resource_id THEN CASE WHEN A.ROLLUP_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN A.ROLLUP_STATE ELSE BITAND(A.ROLLUP_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   A.MANAGER_ID, R.FULL_NAME AS MANAGER_NAME, A.REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG,
   A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, A.ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_0005 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT JOIN RESOURCES R ON R.RESOURCE_ID = A.MANAGER_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_006', 277+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_006(278) : views_ts.sql(1986) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0006;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_006', 285+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_006(286) : views_ts.sql(1994) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_006', 297+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_006(298) : views_ts.sql(2006) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_006;
ALTER FUNCTION FC_S_VTS_006 COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION FC_S_VTS_008 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_008
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_cur_date TIMESTAMP;
   h_manager_id VARCHAR2(32);
   h_rollup_state PLS_INTEGER := 0;
   h_current_state PLS_INTEGER := 0;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      CURSOR C_STATE IS
         SELECT TSA.MANAGER_ID, TSA.REC_DATETIME, R.FULL_NAME
         FROM TIMESHEET_APPROVAL_STATUS TSA JOIN RESOURCES R ON TSA.MANAGER_ID = R.RESOURCE_ID
         WHERE  ROWNUM <= 1 AND  WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10)) AND ELEMENT_ID = h_id AND CURRENT_STATE = h_rollup_state;

      -- Resultset Cursor Declaration
      CR0007 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_008') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_008'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_008(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_008', 50+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_008(51) : views_ts.sql(2073) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_0006';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_0006
      SELECT
      PA.PROJECT_ID, PA.RESOURCE_ID, P.RANK, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.RESOURCE_ID = PA.RESOURCE_ID
      AND EW.PROJECT_ID = PA.PROJECT_ID
      AND EW.PROJECT_ID <> EW.TASK_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = TC.TSK_ASSIGNMENT_ID
      AND TA.PROJECT_ID <> TA.TASK_ID
      WHERE TC.RESOURCE_ID = PA.RESOURCE_ID
      AND TC.PROJECT_ID = PA.PROJECT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM PROJECT_ASSIGNMENTS PA
      JOIN TMT_WBS P ON P.ELEMENT_ID = PA.PROJECT_ID
      AND P.PROJECT_ID = PA.PROJECT_ID
      JOIN TASK_ASSIGNMENTS TA ON TA.PROJECT_ID = PA.PROJECT_ID
      AND TA.RESOURCE_ID = PA.RESOURCE_ID
      AND TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE PA.PROJECT_ID = h_id
      GROUP BY PA.PROJECT_ID, PA.RESOURCE_ID, P.RANK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_008', 130+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_008(131) : views_ts.sql(2153) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_cur_date := NULL;
   h_manager_id := NULL;
   
   BEGIN
      SELECT MAX(CURRENT_STATE) INTO h_rollup_state FROM TIMESHEET_APPROVAL_STATUS
      WHERE WEEK_OF = h_week_of AND ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_008', 147+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_008(148) : views_ts.sql(2170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_current_state, 0) <> PMO_CNST.SC_APV_STATE_SUBMITTED Then
         h_current_state := BITAND(Coalesce(h_rollup_state, 0), PMO_CNST.SC_APV_CLEAN_PMRM);
      End If;
      --trace_printf("h_rollup_state: %d, h_current_state: %d\n",h_rollup_state,h_current_state);
      
      OPEN C_STATE;
      
      FETCH C_STATE INTO h_manager_id, h_cur_date, h_full_name;
      IF C_STATE%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      BEGIN
         CLOSE C_STATE ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_008', 175+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_008(176) : views_ts.sql(2198) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("h_manager_id: %s, h_resource_id: %s, h_full_name: %s\n",h_manager_id,h_resource_id,h_full_name);
   End If;
   
   --trace_printf("\n CR0007 \n");
   
   OPEN CR0007 FOR SELECT 1 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   COUNT(A.RESOURCE_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   h_current_state AS CURRENT_STATE,
   h_manager_id AS MANAGER_ID, h_full_name AS MANAGER_NAME, h_cur_date AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, T.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED,
   h_rollup_state AS ROLLUP_STATE,
   T.STAGE_ID AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_0006 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   GROUP BY T.RANK, T.PROJECT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, T.STAGE_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, -- RESOURCE LEVEL
   TO_CHAR(RTRIM(A.RANK) || RTRIM(R.FULL_NAME)) AS RANK, A.PROJECT_ID AS PARENT_ID, R.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME,
   1 AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R2.FULL_NAME AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_resource_id THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, PM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   0 AS STAGE_ID, R.RESOURCE_ID AS ORIGINAL_ID
   FROM
   PMO_TMP_VTS_0006 A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA
   ON TSA.ELEMENT_ID = A.PROJECT_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES PM1 ON PM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = A.CHECKEDOUT_BY
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_008', 264+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_008(265) : views_ts.sql(2287) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0007;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_008', 272+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_008(273) : views_ts.sql(2295) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_008', 284+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_008(285) : views_ts.sql(2307) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_008;
ALTER FUNCTION FC_S_VTS_008 COMPILE DEBUG;

/*************************************************************************/

Prompt == FUNCTION FC_S_VTS_009 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_009
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_root_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0008 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_009') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_009'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_009(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_009', 43+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_009(44) : views_ts.sql(2367) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_009', 62+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_009(63) : views_ts.sql(2386) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT
      TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.RESOURCE_ID = TA.RESOURCE_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      join tmt_wbs del on del.rank = case when length(w.rank)>(h_rank_length + 4) then substr(W.rank,1,(h_rank_length + 4)) else h_rank end
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_009', 136+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_009(137) : views_ts.sql(2460) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_TIMESHEET_ROLLUP_DEL_LEVEL(h_id, h_type_id);
   
   null_return := FC_DECLARE_ASSIGN_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGN_AGGREGATION
      SELECT  A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      WHERE A.PROJECT_ID = A.DELIVERABLE_ID
      GROUP BY A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_009', 181+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_009(182) : views_ts.sql(2505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR0008 \n");
   
   OPEN CR0008 FOR SELECT  2 AS LEVEL_ID, 13 AS TYPE_ID, -- RESOURCE LEVEL
   '----' AS RANK, A.PROJECT_ID AS PARENT_ID, A.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME,
   COUNT(A.TASK_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R2.FULL_NAME AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   TSA.CURRENT_STATE,
   TSA.MANAGER_ID, PM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   0 AS STAGE_ID, A.RESOURCE_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN RESOURCES R
   ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA
   ON TSA.ELEMENT_ID = A.PROJECT_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES PM1
   ON PM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = A.CHECKEDOUT_BY
   GROUP BY A.PROJECT_ID, A.RESOURCE_ID, R.FULL_NAME, A.CHECKEDOUT_BY, R2.FULL_NAME,
   TSA.CURRENT_STATE, TSA.MANAGER_ID, PM1.FULL_NAME, TSA.REC_DATETIME
   
   UNION ALL
   
   SELECT  3 AS LEVEL_ID, T.TYPE_ID, T.RANK,
   h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC, A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   A.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   A.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.DELIVERABLE_ID
   
   UNION ALL
   
   SELECT  3 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_ASSIGN_AGGREGATION A
   JOIN TMT_WBS T
   ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA
   ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA
   ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1
   ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2
   ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB
   ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1
   ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2
   ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_009', 327+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_009(328) : views_ts.sql(2651) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0008;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_009', 335+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_009(336) : views_ts.sql(2659) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_009', 347+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_009(348) : views_ts.sql(2671) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_009;
ALTER FUNCTION FC_S_VTS_009 COMPILE DEBUG;

/************************************************************************************************/

Prompt == FUNCTION FC_S_VTS_010 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_010
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_root_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR0009 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_010') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_010'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_010(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_010', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_010(46) : views_ts.sql(2733) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_010', 64+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_010(65) : views_ts.sql(2752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID AS DELIVERABLE_ID,  MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TMT_WBS W
      JOIN TASK_ASSIGNMENTS TA ON TA.TASK_ID = W.ELEMENT_ID
      AND TA.PROJECT_ID = W.PROJECT_ID
      JOIN TMT_WBS P ON P.ELEMENT_ID = W.PROJECT_ID
      AND P.PROJECT_ID = W.PROJECT_ID
      join tmt_wbs del on del.rank = case when length(w.rank)>(h_rank_length + 4) then substr(W.rank,1,(h_rank_length + 4)) else h_rank end
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE W.RANK LIKE h_rank || '%%'
      AND TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_project_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_010', 138+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_010(139) : views_ts.sql(2826) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_TIMESHEET_ROLLUP_DEL_LEVEL(h_id, h_type_id);
   
   --trace_printf("\n CR0009 \n");
   
   OPEN CR0009 FOR -- DELIVERABLE LEVEL
   SELECT T.LEVEL_ID AS LEVEL_ID,
   case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH, A.ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   A.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   A.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_DEL_AGGREGATION A
   JOIN TMT_WBS T
   ON T.ELEMENT_ID = A.DELIVERABLE_ID
   
   UNION ALL
   
   SELECT T.LEVEL_ID AS LEVEL_ID, T.TYPE_ID,
   T.RANK, A.DELIVERABLE_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN TMT_WBS T
   ON T.ELEMENT_ID = A.TASK_ID AND T.PARENT_ID = h_id
   JOIN TASK_ASSIGNMENTS TA
   ON TA.PROJECT_ID = A.PROJECT_ID
   AND TA.TASK_ID = A.TASK_ID
   AND TA.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA
   ON STA.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1
   ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2
   ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB
   ON STB.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1
   ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2
   ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_010', 241+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_010(242) : views_ts.sql(2929) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR0009;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_010', 249+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_010(250) : views_ts.sql(2937) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_010', 261+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_010(262) : views_ts.sql(2949) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_010;
ALTER FUNCTION FC_S_VTS_010 COMPILE DEBUG;

/*************************************************************************************/

Prompt == FUNCTION FC_S_VTS_011 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_011
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00010 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_011') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_011'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_011(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_011', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_011(40) : views_ts.sql(3005) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W  ON W.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_011', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_011(114) : views_ts.sql(3079) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_ASSIGN_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGN_AGGREGATION
      SELECT A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      GROUP BY A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_011', 155+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_011(156) : views_ts.sql(3121) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR00010 \n");
   
   OPEN CR00010 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID,
   '----' AS RANK, A.PROJECT_ID AS PARENT_ID, A.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME,
   COUNT(A.TASK_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R2.FULL_NAME AS CHECKEDOUT_NAME, h_week_of AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   TSA.CURRENT_STATE,
   TSA.MANAGER_ID, PM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   0 AS STAGE_ID, A.RESOURCE_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.PROJECT_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES PM1 ON PM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = A.CHECKEDOUT_BY
   GROUP BY A.PROJECT_ID, A.RESOURCE_ID, R.FULL_NAME, A.CHECKEDOUT_BY, R2.FULL_NAME,
   TSA.CURRENT_STATE, TSA.MANAGER_ID, PM1.FULL_NAME, TSA.REC_DATETIME
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_ASSIGN_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1 ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2 ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1 ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2 ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_011', 256+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_011(257) : views_ts.sql(3222) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00010;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_011', 264+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_011(265) : views_ts.sql(3230) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_011', 276+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_011(277) : views_ts.sql(3242) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_011;
ALTER FUNCTION FC_S_VTS_011 COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_S_VTS_012 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_012
(
     h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00011 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_012') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_012'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_012(' || 
       COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_012', 28+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_012(29) : views_ts.sql(3287) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_0007';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_0007
      SELECT TP.RANK
      FROM RESOURCE_ASSIGNMENTS RA JOIN TMT_POOLS TP ON TP.ELEMENT_ID = RA.ELEMENT_ID
      WHERE RA.RESOURCE_ID = h_resource_id
      AND BITAND(RA.PARTICIPANT, 2394) > 0
      AND RA.ELEMENT_TYPE = 11;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_012', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_012(53) : views_ts.sql(3311) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_0008';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_0008
      SELECT DISTINCT TP.ELEMENT_ID
      FROM TMT_POOLS TP, PMO_TMP_VTS_0007 RP
      WHERE ((RP.RANK >= SUBSTR(TP.RANK, 1, 8) AND RP.RANK <= TP.RANK) 
      AND SUBSTR(TP.RANK,1, CASE WHEN LENGTH(RP.RANK) > LENGTH(TP.RANK) THEN 1 ELSE LENGTH(RP.RANK) END ) = RP.RANK)
      AND TP.TYPE_ID = 11;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_012', 78+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_012(79) : views_ts.sql(3337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR00011 \n");
   
   OPEN CR00011 FOR SELECT 0 AS LEVEL_ID, 13 AS TYPE_ID,
   '----' AS RANK, '' AS PARENT_ID,  h_resource_id AS ELEMENT_ID,
   h_full_name AS ELEMENT_NAME,  COUNT(A.ELEMENT_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS PROPOSED_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS SCHED_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS FORECAST_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS ACTUAL_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS ACTUAL_FINISH,
   0 AS WORK_TODATE, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT, 0 AS SPENT_PERCENT, 0 AS ASSIGN_MILESTONE_PERCENT,
   0 AS EDPCOMPLETED, '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,  h_week_of AS WEEK_OF,
   0 AS ORIGINAL_SCHED_WEEK, 0 AS SCHED_WEEK, 0 AS BASELINE1_WORK, 0 AS MONDAY_REGULAR,
   0 AS MONDAY_SPECIAL, 0 AS TUESDAY_REGULAR, 0 AS TUESDAY_SPECIAL, 0 AS WEDNESDAY_REGULAR,
   0 AS WEDNESDAY_SPECIAL, 0 AS THURSDAY_REGULAR, 0 AS THURSDAY_SPECIAL, 0 AS FRIDAY_REGULAR,
   0 AS FRIDAY_SPECIAL, 0 AS SATURDAY_REGULAR, 0 AS SATURDAY_SPECIAL, 0 AS SUNDAY_REGULAR,
   0 AS SUNDAY_SPECIAL, 0 AS WEEKLY_REGULAR_TOTAL, 0 AS WEEKLY_SPECIAL_TOTAL, '' AS NOTE,
   '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE, '' AS MANAGER_ID, '' AS MANAGER_NAME,
   TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT, '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME,
   '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD,
   'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME,
   'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE, 0 AS STAGE_ID, h_resource_id AS ORIGINAL_ID
   FROM PMO_TMP_VTS_0008 A
   
   UNION ALL
   
   SELECT DISTINCT 1 AS LEVEL_ID, 11 AS TYPE_ID,
   T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   (SELECT COUNT(*) FROM TMT_POOLS R WHERE R.PARENT_ID = A.ELEMENT_ID AND R.TYPE_ID = 13) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS PROPOSED_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS PROPOSED_FINISH,
   0 AS PROPOSED_WORK,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS SCHED_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS SCHED_FINISH,
   0 AS SCHED_WORK,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS FORECAST_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS FORECAST_FINISH,
   0 AS ETC,
   PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AS ACTUAL_START,
   PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AS ACTUAL_FINISH,
   0 AS WORK_TODATE, 0 AS REGULAR_TODATE, 0 AS SPECIAL_TODATE, 0 AS REMAINING,
   0 AS MILESTONE_PERCENT, 0 AS SPENT_PERCENT, 0 AS ASSIGN_MILESTONE_PERCENT,
   0 AS EDPCOMPLETED, '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME, h_week_of AS WEEK_OF,
   0 AS ORIGINAL_SCHED_WEEK, 0 AS SCHED_WEEK, 0 AS BASELINE1_WORK, 0 AS MONDAY_REGULAR,
   0 AS MONDAY_SPECIAL, 0 AS TUESDAY_REGULAR, 0 AS TUESDAY_SPECIAL, 0 AS WEDNESDAY_REGULAR,
   0 AS WEDNESDAY_SPECIAL, 0 AS THURSDAY_REGULAR, 0 AS THURSDAY_SPECIAL,
   0 AS FRIDAY_REGULAR, 0 AS FRIDAY_SPECIAL, 0 AS SATURDAY_REGULAR, 0 AS SATURDAY_SPECIAL,
   0 AS SUNDAY_REGULAR, 0 AS SUNDAY_SPECIAL, 0 AS WEEKLY_REGULAR_TOTAL, 0 AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE, '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME,
   0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS,
   '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE, 0 AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_0008 A
   JOIN TMT_POOLS T ON T.ELEMENT_ID = A.ELEMENT_ID
   ORDER BY RANK;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_012', 148+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_012(149) : views_ts.sql(3407) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00011;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_012', 156+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_012(157) : views_ts.sql(3415) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_012', 168+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_012(169) : views_ts.sql(3427) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_012;
ALTER FUNCTION FC_S_VTS_012 COMPILE DEBUG;

/******************************************************************************************/

Prompt == FUNCTION FC_S_VTS_014 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_014
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_rank VARCHAR2(200);
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00012 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_014') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_014'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_014(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_014', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_014(41) : views_ts.sql(3484) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_RES10';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      SELECT RTRIM(RANK)
      INTO h_rank
      FROM TMT_POOLS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_014', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_014(64) : views_ts.sql(3507) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_RES10
      SELECT h_id, ELEMENT_ID, RTRIM(RANK)
      FROM TMT_POOLS
      WHERE RANK LIKE h_rank || '%'
      AND LENGTH(RANK) = (LENGTH(h_rank) + 4)
      AND TYPE_ID = PMO_CNST.SC_RESOURCE;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_014', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_014(86) : views_ts.sql(3529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_RES_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_RES_AGGREGATION
      SELECT RES.POOL_ID, RES.RESOURCE_ID, RES.RANK, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      COUNT(TA.PROJECT_ID) AS CHILD_COUNT,
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      JOIN TMT_WBS EWP ON EWP.ELEMENT_ID = EW.PROJECT_ID
      AND EWP.PUBLISHED = '1'
      WHERE EW.RESOURCE_ID = RES.RESOURCE_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      AND EW.TASK_ID <> EW.PROJECT_ID) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      JOIN TASK_ASSIGNMENTS TA2 ON TA2.TSK_ASSIGNMENT_ID = TC.TSK_ASSIGNMENT_ID
      AND TA2.TASK_ID <> TA2.PROJECT_ID
      JOIN TMT_WBS TAP ON TAP.ELEMENT_ID = TA2.PROJECT_ID
      AND TAP.PUBLISHED = '1'
      WHERE TC.RESOURCE_ID = RES.RESOURCE_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6      ) AS SCHED_WEEK
      FROM PMO_TMP_VTS_RES10 RES
      JOIN TASK_ASSIGNMENTS TA ON TA.RESOURCE_ID = RES.RESOURCE_ID
      AND TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND (P.PUBLISHED = '1' OR P.TYPE_ID = 13)
      AND P.REC_STATUS <> 'D'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      GROUP BY RES.POOL_ID, RES.RESOURCE_ID, RES.RANK;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_014', 161+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_014(162) : views_ts.sql(3605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_00010';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_00010
      SELECT  RES.POOL_ID,
      RES.RESOURCE_ID,
      RES.RANK, WRK.CHECKEDOUT_BY,
      CASE WHEN COALESCE(WRK.PROPOSED_WORK, 0) > 0 THEN 1 ELSE 0 END AS CHILD_COUNT,
      WRK.PROPOSED_START,
      WRK.PROPOSED_FINISH,
      COALESCE(WRK.PROPOSED_WORK, 0),
      WRK.SCHED_START,
      WRK.SCHED_FINISH,
      WRK.FORECAST_START,
      WRK.FORECAST_FINISH,
      WRK.ACTUAL_START,
      WRK.ACTUAL_FINISH,
      COALESCE(WRK.SCHED_WORK, 0),
      COALESCE(WRK.ETC, 0),
      COALESCE(WRK.WORK_TODATE, 0),
      COALESCE(WRK.REGULAR_TODATE, 0),
      COALESCE(WRK.SPECIAL_TODATE, 0),
      COALESCE(WRK.BASELINE1_WORK, 0),
      COALESCE(WRK.MILESTONE_PERCENT, 0),
      COALESCE(WRK.MONDAY_REGULAR, 0),
      COALESCE(WRK.MONDAY_SPECIAL, 0),
      COALESCE(WRK.TUESDAY_REGULAR, 0),
      COALESCE(WRK.TUESDAY_SPECIAL, 0),
      COALESCE(WRK.WEDNESDAY_REGULAR, 0),
      COALESCE(WRK.WEDNESDAY_SPECIAL, 0),
      COALESCE(WRK.THURSDAY_REGULAR, 0),
      COALESCE(WRK.THURSDAY_SPECIAL, 0),
      COALESCE(WRK.FRIDAY_REGULAR, 0),
      COALESCE(WRK.FRIDAY_SPECIAL, 0),
      COALESCE(WRK.SATURDAY_REGULAR, 0),
      COALESCE(WRK.SATURDAY_SPECIAL, 0),
      COALESCE(WRK.SUNDAY_REGULAR, 0),
      COALESCE(WRK.SUNDAY_SPECIAL, 0),
      COALESCE(WRK.WEEKLY_REGULAR_TOTAL, 0),
      COALESCE(WRK.WEEKLY_SPECIAL_TOTAL, 0),
      COALESCE(WRK.ORIGINAL_SCHED_WEEK, 0),
      COALESCE(WRK.SCHED_WEEK, 0)
      FROM PMO_TMP_VTS_RES10 RES
      LEFT JOIN PMO_TMP_RES_AGGREGATION WRK
      ON WRK.POOL_ID = RES.POOL_ID
      AND WRK.RESOURCE_ID = RES.RESOURCE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_014', 224+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_014(225) : views_ts.sql(3668) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR00012 \n");
   
   OPEN CR00012 FOR -- POOL LEVEL
   SELECT 1 AS LEVEL_ID, 11 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   COUNT(A.RESOURCE_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   0 AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_00010 A
   JOIN TMT_POOLS T ON T.ELEMENT_ID = A.POOL_ID
   GROUP BY A.POOL_ID, T.RANK, T.ELEMENT_ID, T.ELEMENT_NAME
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID, -- RESOURCE LEVEL
   A.RANK, h_id AS PARENT_ID, A.RESOURCE_ID AS ELEMENT_ID, R.FULL_NAME AS ELEMENT_NAME,
   A.CHILD_COUNT AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R2.FULL_NAME AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_resource_id THEN CASE WHEN TSA.CURRENT_STATE = PMO_CNST.SC_APV_STATE_SUBMITTED THEN TSA.CURRENT_STATE ELSE BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) END ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED,
   TSA.CURRENT_STATE AS ROLLUP_STATE, 0 AS STAGE_ID, R.RESOURCE_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_00010 A
   JOIN RESOURCES R ON R.RESOURCE_ID = A.RESOURCE_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.ELEMENT_ID = A.RESOURCE_ID
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = A.CHECKEDOUT_BY
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_014', 310+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_014(311) : views_ts.sql(3754) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00012;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_014', 318+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_014(319) : views_ts.sql(3762) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_014', 330+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_014(331) : views_ts.sql(3774) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_014;
ALTER FUNCTION FC_S_VTS_014 COMPILE DEBUG;

/******************************************************************************/

Prompt == FUNCTION FC_S_VTS_015 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_015
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   h_manager_id VARCHAR2(32);
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00013 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_015') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_015'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_015(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_015', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_015(41) : views_ts.sql(3831) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   null_return := FC_DECLARE_PRJ_AGGREGATION();
   
   BEGIN
      SELECT RA.RESOURCE_ID INTO h_manager_id
      FROM TMT_POOLS TP, RESOURCE_ASSIGNMENTS RA
      WHERE TP.ELEMENT_ID = h_resource_id
      AND TP.PARENT_ID = RA.ELEMENT_ID
      AND RA.ELEMENT_TYPE = 11
      AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_RESOURCE_MANAGER) > 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_015', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_015(64) : views_ts.sql(3854) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PMO_TMP_PRJ_AGGREGATION
      SELECT TA.RESOURCE_ID, TA.PROJECT_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.RESOURCE_ID = TA.RESOURCE_ID
      AND EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TASK_ID <> EW.PROJECT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      JOIN TASK_ASSIGNMENTS TA2 ON TA2.TSK_ASSIGNMENT_ID = TC.TSK_ASSIGNMENT_ID
      AND TA2.TASK_ID <> TA2.PROJECT_ID
      AND TC.BIT_FLAG = '2'
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.PROJECT_ID = TA.PROJECT_ID
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      AND (P.PUBLISHED = '1' OR P.TYPE_ID = 13)
      AND P.REC_STATUS <> 'D'
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.RESOURCE_ID = h_resource_id
      AND TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_015', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_015(136) : views_ts.sql(3926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_TMP_PRJ_AGGREGATION(RESOURCE_ID)
         VALUES( h_resource_id );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_015', 154+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_015(155) : views_ts.sql(3945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --trace_printf("\n CR00013 \n");
   
   OPEN CR00013 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID,   -- RESOURCE LEVEL
   '----' AS RANK, T.PARENT_ID AS PARENT_ID,
   h_resource_id
   AS ELEMENT_ID,
   h_full_name
   AS ELEMENT_NAME,
   COUNT(A.PROJECT_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
   SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R.FULL_NAME AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_manager_id THEN BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, T.REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE ,
   0 AS STAGE_ID, h_resource_id AS ORIGINAL_ID
   FROM PMO_TMP_PRJ_AGGREGATION A
   JOIN TMT_POOLS T ON T.ELEMENT_ID = A.RESOURCE_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.RESOURCE_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R ON R.RESOURCE_ID = A.CHECKEDOUT_BY
   GROUP BY A.RESOURCE_ID, T.PARENT_ID, A.CHECKEDOUT_BY, R.FULL_NAME, TSA.CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME, TSA.REC_DATETIME, TSA.NOTE, T.REC_STATUS
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, CASE WHEN T.TYPE_ID = 13 THEN PMO_CNST.SC_PERSONAL_PROJECT ELSE T.TYPE_ID END AS TYPE_ID, T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME, 1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_manager_id THEN BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, T.REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   T.STAGE_ID AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_PRJ_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.PROJECT_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_015', 254+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_015(255) : views_ts.sql(4045) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00013;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_015', 262+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_015(263) : views_ts.sql(4053) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_015', 274+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_015(275) : views_ts.sql(4065) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_015;
ALTER FUNCTION FC_S_VTS_015 COMPILE DEBUG;

/*************************************************************************/

Prompt == FUNCTION FC_S_VTS_016 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_016
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_manager_id VARCHAR2(32);
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   h_root_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00014 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_016') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_016'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_016(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_016', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_016(45) : views_ts.sql(4126) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_016', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_016(64) : views_ts.sql(4145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RA.RESOURCE_ID INTO h_manager_id
      FROM TMT_POOLS TP, RESOURCE_ASSIGNMENTS RA
      WHERE TP.ELEMENT_ID = h_resource_id
      AND TP.PARENT_ID = RA.ELEMENT_ID
      AND RA.ELEMENT_TYPE = 11
      AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_RESOURCE_MANAGER) > 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_016', 81+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_016(82) : views_ts.sql(4163) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID,  TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID AS DELIVERABLE_ID,  MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      join tmt_wbs del on del.rank = case when length(w.rank)>(h_rank_length + 4) then substr(W.rank,1,(h_rank_length + 4)) else h_rank end
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_id
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, del.ELEMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_016', 153+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_016(154) : views_ts.sql(4235) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_TIMESHEET_ROLLUP_DEL_LEVEL(h_id, h_type_id);
   
   null_return := FC_DECLARE_ASSIGN_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGN_AGGREGATION
      SELECT A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      WHERE A.PROJECT_ID = A.DELIVERABLE_ID
      GROUP BY A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_016', 198+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_016(199) : views_ts.sql(4280) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR00014 \n");
   
   OPEN CR00014 FOR -- PROJECT_ID
   SELECT 3 AS LEVEL_ID, 1 AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   COUNT(A.TASK_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, T.PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
   SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID, h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_manager_id THEN BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   T.STAGE_ID AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   AND T.PROJECT_ID =  A.PROJECT_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.PROJECT_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   GROUP BY A.RESOURCE_ID, A.PROJECT_ID, T.RANK, T.ELEMENT_ID, T.ELEMENT_NAME, T.PRIORITY, T.STAGE_ID,
   TSA.CURRENT_STATE, TSA.MANAGER_ID, RM1.FULL_NAME, TSA.REC_DATETIME, TSA.CURRENT_STATE
   
   UNION ALL
   
   SELECT 4 AS LEVEL_ID, -- DELIVERABLE LEVEL
   case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   A.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   A.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE, '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.DELIVERABLE_ID
   
   UNION ALL
   
   SELECT 4 AS LEVEL_ID, T.TYPE_ID, -- TASK LEVEL
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE ,
   T.STAGE_ID AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_ASSIGN_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1 ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2 ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1 ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2 ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_016', 340+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_016(341) : views_ts.sql(4422) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00014;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_016', 348+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_016(349) : views_ts.sql(4430) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_016', 360+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_016(361) : views_ts.sql(4442) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_016;
ALTER FUNCTION FC_S_VTS_016 COMPILE DEBUG;

/********************************************************************************************/

Prompt == FUNCTION FC_S_VTS_018 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_018
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_full_name IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_manager_id VARCHAR2(32);
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00017 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_018') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_018'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_018(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_full_name || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_018', 40+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_018(41) : views_ts.sql(4499) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   BEGIN
      SELECT RA.RESOURCE_ID INTO h_manager_id
      FROM TMT_POOLS TP, RESOURCE_ASSIGNMENTS RA
      WHERE TP.ELEMENT_ID = h_resource_id
      AND TP.PARENT_ID = RA.ELEMENT_ID
      AND RA.ELEMENT_TYPE = 11
      AND BITAND(RA.PARTICIPANT,PMO_CNST.SC_RESOURCE_MANAGER) > 0;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_018', 61+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_018(62) : views_ts.sql(4520) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_PRJ_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_PRJ_AGGREGATION
      SELECT TA.RESOURCE_ID, TA.PROJECT_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.RESOURCE_ID = TA.RESOURCE_ID
      AND EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TASK_ID <> EW.PROJECT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      JOIN TASK_ASSIGNMENTS TA2 ON TA2.TSK_ASSIGNMENT_ID = TC.TSK_ASSIGNMENT_ID
      AND TA2.TASK_ID <> TA2.PROJECT_ID
      AND TC.BIT_FLAG = '2'
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.PROJECT_ID = TA.PROJECT_ID
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      AND (P.PUBLISHED = '1' OR P.TYPE_ID = 13)
      AND P.REC_STATUS <> 'D'
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.RESOURCE_ID = h_resource_id
      AND TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_018', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_018(136) : views_ts.sql(4594) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PMO_TMP_PRJ_AGGREGATION (RESOURCE_ID) VALUES( h_resource_id );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_018', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_018(154) : views_ts.sql(4612) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --trace_printf("\n CR00017 \n");
   
   OPEN CR00017 FOR SELECT 2 AS LEVEL_ID, 13 AS TYPE_ID,   -- RESOURCE LEVEL
   '----' AS RANK, T.PARENT_ID AS PARENT_ID,
   h_resource_id
   AS ELEMENT_ID,
   h_full_name
   AS ELEMENT_NAME,
   COUNT(A.PROJECT_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
   SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R.FULL_NAME AS CHECKEDOUT_NAME,
   h_week_of AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_manager_id THEN BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   0 AS STAGE_ID, A.RESOURCE_ID AS ORIGINAL_ID
   FROM PMO_TMP_PRJ_AGGREGATION A
   JOIN TMT_POOLS T ON T.ELEMENT_ID = A.RESOURCE_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.RESOURCE_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R ON R.RESOURCE_ID = A.CHECKEDOUT_BY
   GROUP BY A.RESOURCE_ID, T.PARENT_ID, A.CHECKEDOUT_BY, R.FULL_NAME,
   TSA.CURRENT_STATE, TSA.MANAGER_ID, RM1.FULL_NAME, TSA.REC_DATETIME, TSA.NOTE
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, CASE WHEN T.TYPE_ID = PMO_CNST.SC_RESOURCE THEN PMO_CNST.SC_PERSONAL_PROJECT ELSE T.TYPE_ID END AS TYPE_ID, T.RANK, h_resource_id AS PARENT_ID,
   T.ELEMENT_ID, T.ELEMENT_NAME, 1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   TSA.NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   CASE WHEN TSA.MANAGER_ID = h_manager_id THEN BITAND(TSA.CURRENT_STATE,PMO_CNST.SC_APV_CLEAN_PMRM) ELSE PMO_CNST.SC_APV_NOT_ME END AS CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, TSA.CURRENT_STATE AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_PRJ_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.PROJECT_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_018', 253+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_018(254) : views_ts.sql(4712) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00017;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_018', 261+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_018(262) : views_ts.sql(4720) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_018', 273+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_018(274) : views_ts.sql(4732) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_018;
ALTER FUNCTION FC_S_VTS_018 COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION FC_S_VTS_019 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_019
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00018 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_019') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_019'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_019(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_019', 39+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_019(40) : views_ts.sql(4788) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID,  TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_019', 113+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_019(114) : views_ts.sql(4862) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_ASSIGN_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_ASSIGN_AGGREGATION
      SELECT A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A GROUP BY A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_019', 154+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_019(155) : views_ts.sql(4903) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR00018 \n");
   
   OPEN CR00018 FOR SELECT 3 AS LEVEL_ID, 1 AS TYPE_ID,   -- PROJECT LEVEL
   T.RANK,
   h_resource_id
   AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   COUNT(A.TASK_ID) AS CHILD_COUNT, 0 AS DELETED_COUNT, T.PRIORITY,
   CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
   CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
   SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
   CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
   CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
   SUM(A.SCHED_WORK) AS SCHED_WORK,
   CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
   CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
   SUM(A.ETC) AS ETC,
   CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
   CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
   SUM(A.WORK_TODATE) AS WORK_TODATE,
   SUM(A.REGULAR_TODATE) AS REGULAR_TODATE,
   SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE,
   (SUM(A.SCHED_WORK) - SUM(A.WORK_TODATE)) AS REMAINING,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
   (CASE WHEN SUM(A.SCHED_WORK) > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(SUM(A.WORK_TODATE), 18, 2)/SUM(A.SCHED_WORK)) * 10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 1 WHEN (SUM(Trunc((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT))/SUM(A.WORK_TODATE + A.ETC)) = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF,
   SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
   SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
   SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
   SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
   SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
   SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
   SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
   SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
   SUM(A.REGULAR_TODATE) AS WEEKLY_REGULAR_TOTAL, SUM(A.SPECIAL_TODATE) AS WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   TSA.CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.PROJECT_ID
   AND T.PROJECT_ID = A.PROJECT_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.PROJECT_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   GROUP BY A.RESOURCE_ID, A.PROJECT_ID, T.RANK, T.ELEMENT_ID, T.ELEMENT_NAME, T.PRIORITY,
   TSA.CURRENT_STATE, TSA.MANAGER_ID, RM1.FULL_NAME, TSA.REC_DATETIME, TSA.CURRENT_STATE, T.STAGE_ID
   
   UNION ALL
   
   SELECT 4 AS LEVEL_ID, T.TYPE_ID, -- TASK LEVEL
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_ASSIGN_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1 ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2 ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1 ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2 ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_019', 264+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_019(265) : views_ts.sql(5013) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00018;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_019', 272+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_019(273) : views_ts.sql(5021) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_019', 284+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_019(285) : views_ts.sql(5033) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_019;
ALTER FUNCTION FC_S_VTS_019 COMPILE DEBUG;

/****************************************************************************************/

Prompt == FUNCTION FC_S_VTS_020 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_020
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00019 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_020') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_020'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_020(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_020', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_020(38) : views_ts.sql(5087) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID,  TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      AND (P.PUBLISHED = '1' OR P.TYPE_ID = 13)
      AND P.REC_STATUS <> 'D'
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      AND TA.RESOURCE_ID = h_resource_id
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_020', 112+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_020(113) : views_ts.sql(5162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_00011';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_00011
      SELECT A.RESOURCE_ID, A.CHECKEDOUT_BY,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      GROUP BY A.RESOURCE_ID, A.CHECKEDOUT_BY;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_020', 156+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_020(157) : views_ts.sql(5206) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_00012';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_00012
      SELECT A.RESOURCE_ID, A.PROJECT_ID, A.DELIVERABLE_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A WHERE A.PROJECT_ID <> A.DELIVERABLE_ID GROUP BY A.RESOURCE_ID, A.PROJECT_ID, A.DELIVERABLE_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_020', 199+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_020(200) : views_ts.sql(5249) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_00013';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_00013
      SELECT A.RESOURCE_ID, A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A WHERE A.PROJECT_ID = A.DELIVERABLE_ID GROUP BY A.RESOURCE_ID, A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_020', 242+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_020(243) : views_ts.sql(5292) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR00019 \n");
   
   OPEN CR00019 FOR SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID,  -- RESOURCE LEVEL
   '----' AS RANK, T.PARENT_ID AS PARENT_ID, T.ELEMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME AS ELEMENT_NAME,
   1 AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R2.FULL_NAME AS CHECKEDOUT_NAME, h_week_of AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   TSA.CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, T.REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   0 AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_00011 A JOIN TMT_POOLS T ON T.ELEMENT_ID = A.RESOURCE_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.RESOURCE_ID AND TSA.RESOURCE_ID = A.RESOURCE_ID AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = A.CHECKEDOUT_BY
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, -- DELIVERABLE LEVEL
   case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   A.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   A.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, T.REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_00012 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.DELIVERABLE_ID
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID, T.TYPE_ID,    -- TASK LEVEL
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, T.REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_00013 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_020', 353+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_020(354) : views_ts.sql(5403) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00019;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_020', 361+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_020(362) : views_ts.sql(5411) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_020', 373+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_020(374) : views_ts.sql(5423) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_020;
ALTER FUNCTION FC_S_VTS_020 COMPILE DEBUG;

/********************************************************************************/

Prompt == FUNCTION FC_S_VTS_021 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_021
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , h_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_project_id IN OUT NOCOPY VARCHAR2
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   h_type_id PLS_INTEGER := 0;
   h_rank VARCHAR2(200);
   h_rank_length PLS_INTEGER := 0;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00020 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_021') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_021'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_021(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || '''' || h_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_project_id || ''''
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_021', 44+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_021(45) : views_ts.sql(5484) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   BEGIN
      SELECT RANK, LENGTH(RANK), TYPE_ID
      INTO h_rank, h_rank_length, h_type_id
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_021', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_021(64) : views_ts.sql(5503) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT
      TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID AND W.PARENT_ID = h_id
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.RESOURCE_ID = h_resource_id
      AND TA.PROJECT_ID = h_project_id
      AND TA.BIT_FLAG = '2'
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_021', 135+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_021(136) : views_ts.sql(5575) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   null_return := FC_TIMESHEET_ROLLUP_DEL_LEVEL(h_id, h_type_id);
   
   --trace_printf("\n CR00020 \n");
   
   OPEN CR00020 FOR SELECT 2 AS LEVEL_ID,
   case when T.TYPE_ID = PMO_CNST.SC_SUMMARY_TASK AND T.POOL_ID is not Null then PMO_CNST.SC_ADM_SUMMARY_TASK else T.TYPE_ID end AS TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, T.ELEMENT_ID, T.ELEMENT_NAME,
   1 AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   A.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   A.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, A.PROJECT_ID, h_rec_status AS REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE ,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_DEL_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.DELIVERABLE_ID
   
   UNION ALL
   
   SELECT 3 AS LEVEL_ID, T.TYPE_ID,
   T.RANK, A.DELIVERABLE_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE,
   A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE h_rec_status END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_TASK_AGGREGATION A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1 ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2 ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1 ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2 ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_021', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_021(230) : views_ts.sql(5669) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00020;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_021', 237+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_021(238) : views_ts.sql(5677) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_021', 249+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_021(250) : views_ts.sql(5689) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_021;
ALTER FUNCTION FC_S_VTS_021 COMPILE DEBUG;

/***********************************************************************************************/

Prompt == FUNCTION FC_S_VTS_022 ==
CREATE OR REPLACE FUNCTION FC_S_VTS_022
(
     sh_h_filter_flag PLS_INTEGER
   , h_week_of IN OUT NOCOPY DATE
   , h_filter_string IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_auto_approval PLS_INTEGER
   , h_rec_status IN OUT NOCOPY VARCHAR2
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_filter_flag PLS_INTEGER := sh_h_filter_flag;
   h_auto_approval PLS_INTEGER := sh_h_auto_approval;
   h_include_all PLS_INTEGER := 0;
   h_include_opened PLS_INTEGER := 0;
   h_include_completed PLS_INTEGER := 0;
   h_include_active PLS_INTEGER := 0;
   h_include_week PLS_INTEGER := 0;
   h_include_month PLS_INTEGER := 0;
   h_last_date_of_timesheet TIMESTAMP;
   null_return LONG;
-- Declare Cursors
      -- Resultset Cursor Declaration
      CR00021 PMO_DB2M.REF_CURSOR;

   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_S_VTS_022') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_S_VTS_022'), '-- ' || SYSTIMESTAMP, ':r := FC_S_VTS_022(' || 
       COALESCE(TO_CHAR(sh_h_filter_flag), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_week_of || '''',''''''), 'NULL')
          || ', ' || '''' || h_filter_string || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_auto_approval), 'NULL')
          || ', ' || '''' || h_rec_status || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_022', 37+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_S_VTS_022(38) : views_ts.sql(5743) : ' || SYSTIMESTAMP);
   END IF; 

   GetTimesheetFilterFlag(Coalesce(h_filter_flag, 0), h_include_all, h_include_opened
                       , h_include_completed, h_include_active, h_include_week, h_include_month);
   
   null_return := FC_GET_LAST_DATE_OF_TIMESHEET(h_last_date_of_timesheet);
   
   null_return := FC_DECLARE_TASK_AGGREGATION();
   
   BEGIN
      INSERT INTO PMO_TMP_TASK_AGGREGATION
      SELECT TA.RESOURCE_ID,  TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID AS DELIVERABLE_ID, MAX(CASE WHEN TA.REC_STATUS = 'E' THEN TA.REC_USER ELSE NuLL END),
      CASE WHEN MIN(COALESCE(TA.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(TA.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(TA.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(TA.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(TA.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(TA.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(TA.FORECAST_START) <> MIN(TA.SCHED_START) THEN MIN(TA.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(TA.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(TA.FORECAST_FINISH) <> MAX(TA.SCHED_FINISH) THEN MAX(TA.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(TA.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(TA.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(TA.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(TA.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(TA.SCHED_WORK) AS SCHED_WORK, SUM(TA.ETC) AS ETC, SUM(TA.WORK_TODATE) AS WORK_TODATE, SUM(TA.REGULAR_TODATE) AS REGULAR_TODATE, SUM(TA.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(TA.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE((TA.WORK_TODATE + TA.ETC), 0)) = 0 OR SUM(COALESCE(TA.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((TA.WORK_TODATE + TA.ETC)*TA.MILESTONE_PERCENT)/SUM(TA.WORK_TODATE + TA.ETC))) END) AS MILESTONE_PERCENT,
      SUM(ST.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(ST.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(ST.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(ST.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(ST.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(ST.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(ST.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(ST.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(ST.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(ST.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(ST.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(ST.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(ST.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(ST.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(ST.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(ST.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      (SELECT SUM(EW.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR EW
      WHERE EW.PROJECT_ID = TA.PROJECT_ID
      AND EW.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND EW.BIT_FLAG = '2'
      AND EW.DAY_YEAR BETWEEN TO_DATE(SubStr(h_week_of, 1, 10))
      AND TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS ORIGINAL_SCHED_WEEK,
      (SELECT SUM(TC.SCHED_MIN)
      FROM TASK_DAY_OF_YEAR TC
      WHERE TC.RESOURCE_ID = TA.RESOURCE_ID
      AND TC.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND TC.BIT_FLAG = '2'
      AND TC.DAY_YEAR >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND TC.DAY_YEAR <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ) AS SCHED_WEEK
      FROM TASK_ASSIGNMENTS TA
      JOIN TMT_WBS P ON P.ELEMENT_ID = TA.PROJECT_ID
      AND P.PROJECT_ID = TA.PROJECT_ID
      AND (P.PUBLISHED = '1' OR P.TYPE_ID = 13) AND P.REC_STATUS <> 'D'
      JOIN TMT_WBS W ON W.ELEMENT_ID = TA.TASK_ID
      LEFT JOIN SUMMARY_TIMESHEETS ST ON ST.TSK_ASSIGNMENT_ID = TA.TSK_ASSIGNMENT_ID
      AND ST.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
      AND ST.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
      WHERE TA.TASK_ID <> TA.PROJECT_ID
      AND TA.BIT_FLAG = '2'
      AND TA.RESOURCE_ID = h_resource_id
      AND (h_include_all = 1        OR (CASE WHEN P.ACTUAL_START IS NOT NuLL THEN P.ACTUAL_START ELSE SYSTIMESTAMP END <= PMO_ORASTD.DB2TIMESTAMP(h_last_date_of_timesheet)))
      AND (h_include_opened = 1     OR (TA.MILESTONE_PERCENT < 10000))
      AND (h_include_completed = 1  OR (TA.MILESTONE_PERCENT = 10000))
      AND (h_include_active = 1     OR (TA.ACTUAL_START IS NOT NuLL AND TA.MILESTONE_PERCENT < 10000))
      AND (h_include_week = 1       OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     ))
      AND (h_include_month = 1      OR (TA.MILESTONE_PERCENT < 10000 AND TO_DATE(SubStr(TA.SCHED_START, 1, 10)) <= TO_DATE(SubStr(h_week_of, 1, 10)) + 27      ))
      GROUP BY TA.RESOURCE_ID, TA.PROJECT_ID, TA.TASK_ID, TA.TSK_ASSIGNMENT_ID, W.PARENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_022', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_022(112) : views_ts.sql(5817) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_00011';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_00011
      SELECT A.RESOURCE_ID, A.CHECKEDOUT_BY,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      GROUP BY A.RESOURCE_ID,A.CHECKEDOUT_BY;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_022', 155+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_022(156) : views_ts.sql(5861) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_VTS_00013';
   PMO_DB2M.SC_STATE := 0;
   
   BEGIN
      INSERT INTO PMO_TMP_VTS_00013
      SELECT A.RESOURCE_ID, A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID,
      CASE WHEN MIN(COALESCE(A.PROPOSED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.PROPOSED_START) ELSE NuLL END AS PROPOSED_START,
      CASE WHEN MAX(COALESCE(A.PROPOSED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.PROPOSED_FINISH) ELSE NuLL END AS PROPOSED_FINISH,
      SUM(A.PROPOSED_WORK) AS PROPOSED_WORK,
      CASE WHEN MIN(COALESCE(A.SCHED_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.SCHED_START) ELSE NuLL END AS SCHED_START,
      CASE WHEN MAX(COALESCE(A.SCHED_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.SCHED_FINISH) ELSE NuLL END AS SCHED_FINISH,
      CASE WHEN MIN(COALESCE(A.FORECAST_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') AND MIN(A.FORECAST_START) <> MIN(A.SCHED_START) THEN MIN(A.FORECAST_START) ELSE NuLL END AS FORECAST_START,
      CASE WHEN MAX(COALESCE(A.FORECAST_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') AND MAX(A.FORECAST_FINISH) <> MAX(A.SCHED_FINISH) THEN MAX(A.FORECAST_FINISH) ELSE NuLL END AS FORECAST_FINISH,
      CASE WHEN MIN(COALESCE(A.ACTUAL_START, PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('2100-01-01 00:00:00.000000') THEN MIN(A.ACTUAL_START) ELSE NuLL END AS ACTUAL_START,
      CASE WHEN MAX(COALESCE(A.ACTUAL_FINISH, PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000'))) <> PMO_ORASTD.DB2TIMESTAMP('1900-01-01 00:00:00.000000') THEN MAX(A.ACTUAL_FINISH) ELSE NuLL END AS ACTUAL_FINISH,
      SUM(A.SCHED_WORK) AS SCHED_WORK, SUM(A.ETC) AS ETC, SUM(A.WORK_TODATE) AS WORK_TODATE, SUM(A.REGULAR_TODATE) AS REGULAR_TODATE, SUM(A.SPECIAL_TODATE) AS SPECIAL_TODATE, SUM(A.BASELINE1_WORK) AS BASELINE1_WORK,
      (CASE WHEN SUM(COALESCE(A.WORK_TODATE + A.ETC, 0)) = 0 OR SUM(COALESCE(A.MILESTONE_PERCENT, 0)) = 0 THEN 0 ELSE (Trunc(SUM((A.WORK_TODATE + A.ETC)*A.MILESTONE_PERCENT)/SUM(A.WORK_TODATE + A.ETC))) END) AS MILESTONE_PERCENT,
      SUM(A.MONDAY_REGULAR) AS MONDAY_REGULAR, SUM(A.MONDAY_SPECIAL) AS MONDAY_SPECIAL,
      SUM(A.TUESDAY_REGULAR) AS TUESDAY_REGULAR, SUM(A.TUESDAY_SPECIAL) AS TUESDAY_SPECIAL,
      SUM(A.WEDNESDAY_REGULAR) AS WEDNESDAY_REGULAR, SUM(A.WEDNESDAY_SPECIAL) AS WEDNESDAY_SPECIAL,
      SUM(A.THURSDAY_REGULAR) AS THURSDAY_REGULAR, SUM(A.THURSDAY_SPECIAL) AS THURSDAY_SPECIAL,
      SUM(A.FRIDAY_REGULAR) AS FRIDAY_REGULAR, SUM(A.FRIDAY_SPECIAL) AS FRIDAY_SPECIAL,
      SUM(A.SATURDAY_REGULAR) AS SATURDAY_REGULAR, SUM(A.SATURDAY_SPECIAL) AS SATURDAY_SPECIAL,
      SUM(A.SUNDAY_REGULAR) AS SUNDAY_REGULAR, SUM(A.SUNDAY_SPECIAL) AS SUNDAY_SPECIAL,
      SUM(A.WEEKLY_REGULAR_TOTAL) AS WEEKLY_REGULAR_TOTAL, SUM(A.WEEKLY_SPECIAL_TOTAL) AS WEEKLY_SPECIAL_TOTAL,
      SUM(A.ORIGINAL_SCHED_WEEK) AS ORIGINAL_SCHED_WEEK, SUM(A.SCHED_WEEK) AS SCHED_WEEK
      FROM PMO_TMP_TASK_AGGREGATION A
      GROUP BY A.RESOURCE_ID, A.PROJECT_ID, A.TASK_ID, A.TSK_ASSIGNMENT_ID;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_022', 199+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_022(200) : views_ts.sql(5905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n CR00021 \n");
   
   OPEN CR00021 FOR SELECT 1 AS LEVEL_ID, 13 AS TYPE_ID, -- Resource level
   '----' AS RANK, T.PARENT_ID AS PARENT_ID, T.ELEMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME AS ELEMENT_NAME,
   1 AS CHILD_COUNT, 0 AS DELETED_COUNT, 0 AS PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 0 ELSE A.MILESTONE_PERCENT END) AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK = 0 OR A.MILESTONE_PERCENT = 0 THEN 1 WHEN A.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   A.CHECKEDOUT_BY, R2.FULL_NAME AS CHECKEDOUT_NAME, h_week_of AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, '' AS NOTES, '' AS ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   TSA.CURRENT_STATE,
   TSA.MANAGER_ID, RM1.FULL_NAME AS MANAGER_NAME, TSA.REC_DATETIME AS REC_DT,
   
   '' AS TIMECODE_1_ID, '' AS TIMECODE_1_NAME, '' AS TIMECODE_2_ID, '' AS TIMECODE_2_NAME, 0 AS BILLABLE, 0 AS FD, 'P' AS PDA_FLAG, '' AS PROJECT_ID, T.REC_STATUS, '' AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   0 AS STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_00011 A
   JOIN TMT_POOLS T ON T.ELEMENT_ID = A.RESOURCE_ID
   LEFT JOIN TIMESHEET_APPROVAL_STATUS TSA ON TSA.ELEMENT_ID = A.RESOURCE_ID
   AND TSA.RESOURCE_ID = A.RESOURCE_ID
   AND TSA.WEEK_OF = TO_DATE(SubStr(h_week_of, 1, 10))
   LEFT JOIN RESOURCES RM1 ON RM1.RESOURCE_ID = TSA.MANAGER_ID
   LEFT JOIN RESOURCES R2 ON R2.RESOURCE_ID = A.CHECKEDOUT_BY
   
   UNION ALL
   
   SELECT 2 AS LEVEL_ID,
   T.TYPE_ID,
   T.RANK, A.PROJECT_ID AS PARENT_ID, A.TSK_ASSIGNMENT_ID AS ELEMENT_ID, T.ELEMENT_NAME,
   TA.ACTIVITY_COUNT AS CHILD_COUNT, T.DELETED_COUNT, T.PRIORITY,
   A.PROPOSED_START, A.PROPOSED_FINISH, A.PROPOSED_WORK,
   A.SCHED_START, A.SCHED_FINISH, A.SCHED_WORK,
   A.FORECAST_START, A.FORECAST_FINISH,
   A.ETC AS ETC,
   A.ACTUAL_START, A.ACTUAL_FINISH, A.WORK_TODATE, A.REGULAR_TODATE, A.SPECIAL_TODATE, (A.SCHED_WORK - A.WORK_TODATE) AS REMAINING,
   TA.MILESTONE_PERCENT,
   (CASE WHEN A.SCHED_WORK > 0 THEN Trunc(ROUND(((PMO_ORASTD.TODECIMAL(A.WORK_TODATE, 18, 2)/A.SCHED_WORK)*10000.00), 0)) ELSE 0 END) AS SPENT_PERCENT,
   TA.MILESTONE_PERCENT AS ASSIGN_MILESTONE_PERCENT,
   (CASE WHEN TA.MILESTONE_PERCENT = 10000 THEN 0 ELSE 1 END) AS EDPCOMPLETED,
   '' AS CHECKEDOUT_BY, '' AS CHECKEDOUT_NAME,
   h_week_of
   AS WEEK_OF, A.ORIGINAL_SCHED_WEEK, A.SCHED_WEEK, A.BASELINE1_WORK,
   A.MONDAY_REGULAR, A.MONDAY_SPECIAL,
   A.TUESDAY_REGULAR, A.TUESDAY_SPECIAL,
   A.WEDNESDAY_REGULAR, A.WEDNESDAY_SPECIAL,
   A.THURSDAY_REGULAR, A.THURSDAY_SPECIAL,
   A.FRIDAY_REGULAR, A.FRIDAY_SPECIAL,
   A.SATURDAY_REGULAR, A.SATURDAY_SPECIAL,
   A.SUNDAY_REGULAR, A.SUNDAY_SPECIAL,
   A.WEEKLY_REGULAR_TOTAL, A.WEEKLY_SPECIAL_TOTAL,
   '' AS NOTE, STA.NOTES, STA.ACTIVITY_ID,
   h_auto_approval AS AUTO_APPROVED,
   0 AS CURRENT_STATE,
   '' AS MANAGER_ID, '' AS MANAGER_NAME, TO_TIMESTAMP('1899-12-31 00:00:00') AS REC_DT,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN STB.TIMECODE_1_ID ELSE STA.TIMECODE_1_ID END AS TIMECODE_1_ID,
   CASE WHEN STA.TIMECODE_1_ID IS NuLL THEN TCB1.ELEMENT_NAME ELSE TCA1.ELEMENT_NAME END AS TIMECODE_1_NAME,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN STB.TIMECODE_2_ID ELSE STA.TIMECODE_2_ID END AS TIMECODE_2_ID,
   CASE WHEN STA.TIMECODE_2_ID IS NuLL THEN TCB2.ELEMENT_NAME ELSE TCA2.ELEMENT_NAME END AS TIMECODE_2_NAME,
   TA.BILLABLE, T.FD, STA.PDA_FLAG, A.PROJECT_ID, CASE WHEN LENGTH(T.FS_CODE) > 0 THEN 'D' ELSE T.REC_STATUS END AS REC_STATUS, TO_CHAR(STA.REC_DATETIME) AS REC_DATETIME, 'N' AS ETC_MODIFIED, 0 AS ROLLUP_STATE,
   T.STAGE_ID, T.ELEMENT_ID AS ORIGINAL_ID
   FROM PMO_TMP_VTS_00013 A
   JOIN TMT_WBS T ON T.ELEMENT_ID = A.TASK_ID
   JOIN TASK_ASSIGNMENTS TA ON TA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   LEFT JOIN SUMMARY_TIMESHEETS STA ON STA.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STA.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10))
   AND STA.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) + 6     
   LEFT JOIN TMT_TIMECODES TCA1 ON TCA1.ELEMENT_ID = STA.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCA2 ON TCA2.ELEMENT_ID = STA.TIMECODE_2_ID
   LEFT JOIN SUMMARY_TIMESHEETS STB ON STB.TSK_ASSIGNMENT_ID = A.TSK_ASSIGNMENT_ID
   AND STB.WEEK_OF >= TO_DATE(SubStr(h_week_of, 1, 10)) - 14     
   AND STB.WEEK_OF <= TO_DATE(SubStr(h_week_of, 1, 10)) - 7     
   LEFT JOIN TMT_TIMECODES TCB1 ON TCB1.ELEMENT_ID = STB.TIMECODE_1_ID
   LEFT JOIN TMT_TIMECODES TCB2 ON TCB2.ELEMENT_ID = STB.TIMECODE_2_ID
   ORDER BY RANK, SCHED_START;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_S_VTS_022', 293+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_S_VTS_022(294) : views_ts.sql(5999) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN CR00021;
   
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_022', 301+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_022(302) : views_ts.sql(6007) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_S_VTS_022', 313+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: FC_S_VTS_022(314) : views_ts.sql(6019) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION FC_S_VTS_022;
ALTER FUNCTION FC_S_VTS_022 COMPILE DEBUG;

/******************************************************************************************************/

Prompt == FUNCTION SP_TS_VIEW ==
CREATE OR REPLACE FUNCTION SP_TS_VIEW
(
     p_sp_id PLS_INTEGER
   , p_id VARCHAR2
   , p_resource_id VARCHAR2
   , p_week_of VARCHAR2
   , p_filter_string VARCHAR2
   , p_filter_count PLS_INTEGER
   , p_type PLS_INTEGER
   , p_active_record PLS_INTEGER
) RETURN PMO_DB2M.REF_CURSOR
AS
   h_full_name VARCHAR2(255);
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_week_of DATE;
   h_rec_status VARCHAR2(1);
   participant001 VARCHAR2(19);
   h_month PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_cur_date TIMESTAMP;
   h_auto_approval PLS_INTEGER := 0;
   h_before_today PLS_INTEGER := 0;
   h_after_today PLS_INTEGER := 0;
   h_is_static PLS_INTEGER := 0;
   h_filter_string VARCHAR2(1024);
   h_temp_filter_string VARCHAR2(1024);
   h_filter_flag PLS_INTEGER := 0;
-- Declare Cursors
   resultSet PMO_DB2M.REF_CURSOR;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('SP_TS_VIEW') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('SP_TS_VIEW'), '-- ' || SYSTIMESTAMP, ':r := SP_TS_VIEW(' || 
       COALESCE(TO_CHAR(p_sp_id), 'NULL')
          || ', ' || '''' || p_id || ''''
          || ', ' || '''' || p_resource_id || ''''
          || ', ' || '''' || p_week_of || ''''
          || ', ' || '''' || p_filter_string || ''''
          || ', ' || COALESCE(TO_CHAR(p_filter_count), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_type), 'NULL')
          || ', ' || COALESCE(TO_CHAR(p_active_record), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 45+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: SP_TS_VIEW(46) : views_ts.sql(6081) : ' || SYSTIMESTAMP);
   END IF; 

   --timeLog(file,"vts: ");
   
   -- Declare host variables
   
   --For approval process
   
   h_week_of := p_week_of;
   h_resource_id := p_resource_id;
   h_id := p_id;
   
   h_rec_status := NULL;
   h_full_name := NULL;
   
   If p_resource_id IS NOT NULL Then
      BEGIN
         SELECT REPLACE( RTRIM(FULL_NAME), '''', '''''' ) INTO h_full_name
         FROM RESOURCES WHERE RESOURCE_ID = h_resource_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TS_VIEW', 71+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TS_VIEW(72) : views_ts.sql(6107) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If p_id IS NOT NULL Then
      BEGIN
         SELECT TYPE_ID, PROJECT_ID, REC_STATUS INTO h_type_id, h_project_id, h_rec_status
         FROM TMT_WBS WHERE ELEMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TS_VIEW', 87+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TS_VIEW(88) : views_ts.sql(6123) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_type_id, 0) = PMO_CNST.SC_RESOURCE Then
         h_type_id := PMO_CNST.SC_PROJECT;
         -- Personal Project
      End If;
      
      --trace_printf("SC_STATE: %d, h_rec_status: %s\n", SC_STATE,h_rec_status);
   End If;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_auto_approval
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_AUTO_APPROVAL';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TS_VIEW', 109+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TS_VIEW(110) : views_ts.sql(6145) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_before_today
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_APV_BEFORE_TODAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TS_VIEW', 123+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TS_VIEW(124) : views_ts.sql(6159) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT SETTING_VALUE INTO h_after_today
      FROM TMT_SETTINGS WHERE ELEMENT_ID = 'TIMESHEET_APV_AFTER_TODAY';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TS_VIEW', 137+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TS_VIEW(138) : views_ts.sql(6173) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("h_week_of: %s, h_id: %d:%s, h_type_id: %d\nh_resource_id: %d:%s,h_full_name: %s\n",h_week_of,h_id_Ind,h_id,h_type_id,h_resource_id_Ind,h_resource_id,h_full_name);
   CASE p_sp_id
      WHEN 6 THEN
         If p_week_of IS NULL Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 147+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(148) : views_ts.sql(6183) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
         End If;
         participant001 := TO_CHAR(PMO_CNST.SC_MANAGER);
         
         h_filter_flag := 0;
         If (Coalesce(p_active_record, 0) = 1) AND (Coalesce(p_filter_count, 0) = 0) Then
            h_filter_flag := PMO_CNST.SC_ALL_ASSIGNMENTS;
         ElsIf (Coalesce(p_active_record, 0) = 0) AND (Coalesce(p_filter_count, 0) = 0) Then
            h_filter_flag := PMO_CNST.SC_OPENED_ASSIGNMENTS;
         ElsIf (Coalesce(p_active_record, 0) = 2) AND (Coalesce(p_filter_count, 0) = 0) Then
            h_filter_flag := PMO_CNST.SC_COMPLETED_ASSIGNMENTS;
         ElsIf (Coalesce(p_active_record, 0) = 3) AND (Coalesce(p_filter_count, 0) = 0) Then
            h_filter_flag := PMO_CNST.SC_ACTIVE_ASSIGNMENTS;
         ElsIf (Coalesce(p_active_record, 0) = 0) AND (Coalesce(p_filter_count, 0) = 1) Then
            h_filter_flag := PMO_CNST.SC_WEEK_ASSIGNMENTS;
         ElsIf (Coalesce(p_active_record, 0) = 0) AND (Coalesce(p_filter_count, 0) = 2) Then
            h_filter_flag := PMO_CNST.SC_MONTH_ASSIGNMENTS;
         End If;
         
         If Coalesce(p_type, 0) = 10 Then
            If (p_resource_id IS NULL) OR (p_id IS NULL) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 171+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(172) : views_ts.sql(6207) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 180+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(181) : views_ts.sql(6216) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_10(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name, h_id
                     , h_auto_approval, h_rec_status);
            End If;
         ElsIf Coalesce(p_type, 0) = 1 Then
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 188+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(189) : views_ts.sql(6224) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 197+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(198) : views_ts.sql(6233) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_001(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name
                     , h_auto_approval, h_rec_status);
            Else
               If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
                  h_temp_filter_string := h_filter_string;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 206+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(207) : views_ts.sql(6242) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_S_VTS_002(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name, h_id
                        , h_auto_approval, h_rec_status);
               Else
                  h_temp_filter_string := h_filter_string;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 214+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(215) : views_ts.sql(6250) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_S_VTS_010(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                        , h_auto_approval, h_project_id, h_rec_status);
               End If;
            End If;
         ElsIf Coalesce(p_type, 0) = 2 Then
            -- Team Member Task View,
            -- returns ME/project/task_assignbments for resource_id (all levels)
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 225+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(226) : views_ts.sql(6261) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 234+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(235) : views_ts.sql(6270) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_001(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name
                     , h_auto_approval, h_rec_status);
            Else
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 242+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(243) : views_ts.sql(6278) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_005(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_auto_approval
                     , h_project_id, h_rec_status);
            End If;
         ElsIf (Coalesce(p_type, 0) = 20) OR (Coalesce(p_type, 0) = 21) Then
            -- Project Manager Workpackage View All Levels,
            -- Returns: PM/Projects/Resources/Deliverables/Task_assignments
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 252+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(253) : views_ts.sql(6288) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 261+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(262) : views_ts.sql(6297) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_006(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name
                     , h_auto_approval, h_rec_status);
            Else
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 269+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(270) : views_ts.sql(6305) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_008(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name, h_id
                     , h_auto_approval, h_rec_status);
            End If;
         ElsIf Coalesce(p_type, 0) = 201 Then
            -- PM (TM-DLV/TM-TSK)
            If p_id IS NULL OR p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 278+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(279) : views_ts.sql(6314) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 287+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(288) : views_ts.sql(6323) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_009(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                     , h_auto_approval, h_rec_status);
            Else
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 295+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(296) : views_ts.sql(6331) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_010(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                     , h_auto_approval, h_project_id, h_rec_status);
            End If;
         ElsIf Coalesce(p_type, 0) = 211 Then
            -- PM (TM-DLV/TM-TSK)
            If p_id IS NULL OR p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 304+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(305) : views_ts.sql(6340) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            h_temp_filter_string := h_filter_string;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 311+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(312) : views_ts.sql(6347) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VTS_011(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                  , h_auto_approval, h_rec_status);
         ElsIf (Coalesce(p_type, 0) = 22) OR (Coalesce(p_type, 0) = 23) OR (Coalesce(p_type, 0) = 24) 
                OR (Coalesce(p_type, 0) = 25) Then
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 319+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(320) : views_ts.sql(6355) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 328+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(329) : views_ts.sql(6364) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_012(h_week_of, h_temp_filter_string, h_resource_id, h_full_name, h_auto_approval
                     , h_rec_status);
            Else
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 336+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(337) : views_ts.sql(6372) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_014(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                     , h_auto_approval, h_rec_status);
            End If;
         ElsIf Coalesce(p_type, 0) = 221 Then
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 344+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(345) : views_ts.sql(6380) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 353+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(354) : views_ts.sql(6389) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_015(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name
                     , h_auto_approval, h_rec_status);
            Else
               If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
                  h_temp_filter_string := h_filter_string;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 362+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(363) : views_ts.sql(6398) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_S_VTS_016(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                        , h_auto_approval, h_rec_status);
               End If;
            End If;
         ElsIf Coalesce(p_type, 0) = 222 Then
            If p_resource_id IS NULL AND (p_id IS NULL) Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 371+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(372) : views_ts.sql(6407) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            h_temp_filter_string := h_filter_string;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 379+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(380) : views_ts.sql(6415) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN FC_S_VTS_010(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                  , h_auto_approval, h_project_id, h_rec_status);
         ElsIf Coalesce(p_type, 0) = 231 Then
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 386+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(387) : views_ts.sql(6422) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 395+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(396) : views_ts.sql(6431) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_018(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_full_name
                     , h_auto_approval, h_rec_status);
            Else
               If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
                  h_temp_filter_string := h_filter_string;
                  
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 404+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(405) : views_ts.sql(6440) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN FC_S_VTS_019(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                        , h_auto_approval, h_rec_status);
               End If;
            End If;
         ElsIf Coalesce(p_type, 0) = 241 Then
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 413+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(414) : views_ts.sql(6449) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 422+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(423) : views_ts.sql(6458) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_020(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_auto_approval
                     , h_rec_status);
            Else
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 430+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(431) : views_ts.sql(6466) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_021(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_id
                     , h_auto_approval, h_project_id, h_rec_status);
            End If;
         ElsIf Coalesce(p_type, 0) = 251 Then
            If p_resource_id IS NULL Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 438+1) THEN 
                  LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(439) : views_ts.sql(6474) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
               END IF; 
               PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
            End If;
            
            If p_id IS NULL Then
               h_temp_filter_string := h_filter_string;
               
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'SP_TS_VIEW', 447+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: SP_TS_VIEW(448) : views_ts.sql(6483) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN FC_S_VTS_022(h_filter_flag, h_week_of, h_temp_filter_string, h_resource_id, h_auto_approval
                     , h_rec_status);
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 454+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(455) : views_ts.sql(6490) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
         End If;
         
      
      ELSE
         BEGIN
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(8, 'SP_TS_VIEW', 463+1) THEN 
               LFILE.FPUT('AllTrace', '      RETURN_INVALID: SP_TS_VIEW(464) : views_ts.sql(6499) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARAMS), 'NULL'));
            END IF; 
            PMODEFINES.PMO_RETURN_INVALID(PMO_CNST.INVALID_PARAMS);
         END;
   END CASE;
   --timeLog(file,"vtf: ");
   
EXCEPTION
   WHEN PMO_DB2M.RETURN_ERROR_EXCEPTION THEN
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TS_VIEW', 473+1) THEN 
         LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TS_VIEW(474) : views_ts.sql(6509) : ' || SYSTIMESTAMP);
         LFILE.FPUT('AllTrace',                         'RETURN_ERROR_EXCEPTION : STATE: ' || PMO_DB2M.CURRENT_STATE || ' ID: ' || PMO_DB2M.CURRENT_ID);
      END IF; 
      OPEN resultSet
         FOR SELECT PMO_DB2M.CURRENT_STATE "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   WHEN OTHERS THEN
   BEGIN
      PMO_DB2M.SC_STATE := SQLCODE;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'SP_TS_VIEW', 485+1) THEN 
      LFILE.FPUT('AllTrace', '           EXCEPTION: SP_TS_VIEW(486) : views_ts.sql(6521) : ' || SYSTIMESTAMP);
      LFILE.FPUT('AllTrace',                         'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
   END IF; 
      OPEN resultSet
         FOR SELECT -9999 "ERROR" ,
         PMO_DB2M.CURRENT_ID "ID"
         FROM DUAL;
      RETURN resultSet;
   END;
END;
/
SHOW ERRORS FUNCTION SP_TS_VIEW;
ALTER FUNCTION SP_TS_VIEW COMPILE DEBUG;

