-- already in pmo_sqlprep.h : #include "pmodefines.h"

/*********************************************
delete TEMPLATES records
*********************************************/

Prompt == FUNCTION DELETE_TEMPLATE ==
CREATE OR REPLACE FUNCTION DELETE_TEMPLATE
(
     id001 IN OUT NOCOPY VARCHAR2
   , rec_user001 IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_cur_id VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_id VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_cur_type PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_count CHAR;
-- Declare Cursors
      CURSOR C_TEMPLATE IS
         SELECT ELEMENT_ID, TYPE_ID, RANK FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND TYPE_ID > 0 AND TYPE_ID < PMO_CNST.SC_TMP_FOLDER1 AND T_RANK LIKE h_rank || '%';

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('DELETE_TEMPLATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('DELETE_TEMPLATE'), '-- ' || SYSTIMESTAMP, ':r := DELETE_TEMPLATE(' || 
       '''' || id001 || ''''
          || ', ' || '''' || rec_user001 || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'DELETE_TEMPLATE', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: DELETE_TEMPLATE(31) : wbs_ext.sql(38) : ' || SYSTIMESTAMP);
   END IF; 

   --local variable
   
   h_id := id001;
   h_rec_user := rec_user001;
   
   BEGIN
      SELECT PROJECT_ID, PARENT_ID, RANK, ELEMENT_ID, TYPE_ID, DOC_COUNT
      INTO h_project_id, h_parent_id, h_rank, h_cur_id, h_cur_type, h_doc_count
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(49) : wbs_ext.sql(56) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_cur_type, 0) = PMO_CNST.SC_TMP_FOLDER1 Then
      OPEN C_TEMPLATE;
      
      LOOP
         FETCH C_TEMPLATE INTO h_cur_id, h_cur_type, h_cur_rank;
         IF C_TEMPLATE%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_WBS SET PUBLISHED = '0', PUBLISHED_BY = h_rec_user, T_PARENT_ID = '', T_RANK = ''
            WHERE ELEMENT_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 80+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(81) : wbs_ext.sql(88) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT ELEMENT_ID, PUBLISHED, CASE WHEN EXISTS(SELECT * FROM TMT_WBS WHERE PUBLISHED = '2' AND RANK LIKE h_cur_rank) THEN 1 ELSE 0 END
            INTO h_cur_id, h_rec_status, h_count FROM TMT_WBS
            WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND (SUBSTR(h_cur_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_cur_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
            AND (RANK LIKE SUBSTR(h_cur_rank, 1, 8) || '%'));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 97+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(98) : wbs_ext.sql(105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         -- if the PROJECT is Partialy Templeted and does not exists any children templeted, then flag it to NONE
         If (SubStr(h_rec_status, 1, 1) = '3') AND (Coalesce(h_count, 0) = 0) Then
            BEGIN
               UPDATE TMT_WBS SET PUBLISHED = '0' WHERE ELEMENT_ID = h_cur_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 116+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(117) : wbs_ext.sql(124) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TEMPLATE ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 131+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(132) : wbs_ext.sql(139) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_WBS WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 148+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(149) : wbs_ext.sql(156) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      If Coalesce(h_doc_count, 0) > 0 Then
         BEGIN
            DELETE FROM TMT_DOCUMENTS
            WHERE PROJECT_ID = h_cur_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 167+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(168) : wbs_ext.sql(175) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      BEGIN
         DELETE FROM TMT_WBS
         WHERE ELEMENT_ID = h_cur_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 186+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(187) : wbs_ext.sql(194) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If h_parent_id IS NULL Then
      BEGIN
         UPDATE TMT_WBS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID is Null;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 205+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(206) : wbs_ext.sql(213) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         UPDATE TMT_WBS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID = h_parent_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'DELETE_TEMPLATE', 222+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: DELETE_TEMPLATE(223) : wbs_ext.sql(230) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'DELETE_TEMPLATE', 229+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: DELETE_TEMPLATE(230) : wbs_ext.sql(237) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION DELETE_TEMPLATE;
ALTER FUNCTION DELETE_TEMPLATE COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION FC_FISCAL_SF_DATE ==
CREATE OR REPLACE FUNCTION FC_FISCAL_SF_DATE
(
     h_SD IN OUT NOCOPY DATE
   , h_FD IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_temp_sc_state PLS_INTEGER := 0;
   h_start_year PLS_INTEGER := 0;
   h_start_month PLS_INTEGER := 0;
   h_end_year PLS_INTEGER := 0;
   h_end_month PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_FISCAL_SF_DATE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_FISCAL_SF_DATE'), '-- ' || SYSTIMESTAMP, ':r := FC_FISCAL_SF_DATE(' || 
       COALESCE(NULLIF('''' || h_SD || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_FD || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FISCAL_SF_DATE', 19+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_FISCAL_SF_DATE(20) : wbs_ext.sql(267) : ' || SYSTIMESTAMP);
   END IF; 

   --trace_printf("1_** h_SD: %d:%s, h_FD: %d:%s\n",h_SD_Ind,h_SD,h_FD_Ind,h_FD);
   
   h_temp_sc_state := FC_FISCAL_DATE(h_SD, h_start_year, h_start_month);
   
   BEGIN
      SELECT START_DATE INTO h_SD FROM FISCAL_CALENDAR WHERE FISCAL_YEAR = h_start_year AND FISCAL_MONTH = 1;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FISCAL_SF_DATE', 34+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FISCAL_SF_DATE(35) : wbs_ext.sql(282) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := FC_FISCAL_DATE(h_FD, h_end_year, h_end_month);
   
   BEGIN
      SELECT FINISH_DATE INTO h_FD FROM FISCAL_CALENDAR WHERE FISCAL_YEAR = h_end_year AND FISCAL_MONTH = 12;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_FISCAL_SF_DATE', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_FISCAL_SF_DATE(50) : wbs_ext.sql(297) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("2_** h_SD: %d:%s, h_FD: %d:%s\n",h_SD_Ind,h_SD,h_FD_Ind,h_FD);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_FISCAL_SF_DATE', 56+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_FISCAL_SF_DATE(57) : wbs_ext.sql(304) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_FISCAL_SF_DATE;
ALTER FUNCTION FC_FISCAL_SF_DATE COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION FC_LOCK_UNLOCK ==
CREATE OR REPLACE FUNCTION FC_LOCK_UNLOCK
(
     h_rank IN OUT NOCOPY VARCHAR2
   , h_resource_id IN OUT NOCOPY VARCHAR2
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_rank2 VARCHAR2(200);
   h_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR C_PORTF1 IS
         SELECT RANK, REC_STATUS FROM PMO_TMP_PROJECTS_03;

      CURSOR C_CKP IS
         SELECT REC_STATUS
         FROM TMT_WBS
         WHERE RANK LIKE h_rank2
         AND REC_STATUS IN ('L','O','D')
         ORDER BY REC_STATUS DESC;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_LOCK_UNLOCK') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_LOCK_UNLOCK'), '-- ' || SYSTIMESTAMP, ':r := FC_LOCK_UNLOCK(' || 
       '''' || h_rank || ''''
          || ', ' || '''' || h_resource_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_UNLOCK', 30+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_LOCK_UNLOCK(31) : wbs_ext.sql(345) : ' || SYSTIMESTAMP);
   END IF; 

   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_ALL';
   PMO_DB2M.SC_STATE := 0;
   
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_PROJECTS_03';
   PMO_DB2M.SC_STATE := 0;
   
   If (Coalesce(h_bitflag, 0) = 1) OR (Coalesce(h_bitflag, 0) = 3) Then
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_03(ELEMENT_ID, RANK, REC_STATUS)
         SELECT W.ELEMENT_ID, W.RANK, W.REC_STATUS
         FROM TMT_PORTFOLIOS P JOIN TMT_WBS W ON W.PROJECT_ID = P.ELEMENT_ID
         AND W.ELEMENT_ID = P.ELEMENT_ID
         WHERE P.RANK LIKE h_rank || '%'
         AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
         AND P.REC_STATUS <> 'D';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 60+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(61) : wbs_ext.sql(375) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_ALL
         SELECT T.ELEMENT_ID, T.RANK
         FROM PROJECT_ASSIGNMENTS A JOIN TMT_WBS T
         ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.PROJECT_ID AND T.REC_STATUS <> 'D'
         WHERE A.RESOURCE_ID = h_resource_id
         AND (BITAND(A.PARTICIPANT, 3) > 0
         OR (BITAND(A.PARTICIPANT, 3) = 0 AND T.PUBLISHED ='1'));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 83+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(84) : wbs_ext.sql(398) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   ElsIf Coalesce(h_bitflag, 0) = 2 Then
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_03(ELEMENT_ID, RANK)
         SELECT W.ELEMENT_ID, W.RANK FROM TMT_PORTFOLIOS P JOIN TMT_WBS W ON W.PROJECT_ID = P.ELEMENT_ID AND W.ELEMENT_ID = P.ELEMENT_ID
         WHERE P.RANK LIKE h_rank || '%' AND P.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND P.REC_STATUS = 'L';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 102+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(103) : wbs_ext.sql(417) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         INSERT INTO PMO_TMP_PROJECTS_ALL
         SELECT T.ELEMENT_ID, T.RANK
         FROM PROJECT_ASSIGNMENTS A JOIN TMT_WBS T
         ON T.PROJECT_ID = A.PROJECT_ID AND T.ELEMENT_ID = A.PROJECT_ID AND T.REC_STATUS = 'L'
         WHERE A.RESOURCE_ID = h_resource_id
         AND (BITAND(A.PARTICIPANT, 3) > 0 OR (BITAND(A.PARTICIPANT, 3) = 0 AND T.PUBLISHED ='1' ));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 124+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(125) : wbs_ext.sql(439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   BEGIN
      DELETE FROM PMO_TMP_PROJECTS_03
      WHERE ELEMENT_ID IN (SELECT B.ELEMENT_ID
      FROM PMO_TMP_PROJECTS_ALL A, PMO_TMP_PROJECTS_ALL B
      WHERE A.RANK < B.RANK AND ((A.RANK >= SUBSTR(B.RANK, 1, 8) AND A.RANK <= B.RANK) 
      AND SUBSTR(B.RANK,1, CASE WHEN LENGTH(A.RANK) > LENGTH(B.RANK) THEN 1 ELSE LENGTH(A.RANK) END ) = A.RANK) /*SUBSTR( B.RANK, 1, LENGTH( A.RANK ) ) = A.RANK*/ );
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 146+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(147) : wbs_ext.sql(461) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_PORTF1;
   
   LOOP
      FETCH C_PORTF1 INTO h_rank2, h_rec_status;
      IF C_PORTF1%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_rank2 := h_rank2 || '%';
      --trace_printf("h_rank2: %s, h_rec_status: %s\n",h_rank2,h_rec_status); //trace_flush();
      If Coalesce(h_bitflag, 0) = 1 Then
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank2, 1);
         BEGIN
            UPDATE TMT_WBS SET REC_USER = h_resource_id, REC_STATUS = 'L', REC_DATETIME = SYSTIMESTAMP
            WHERE RANK LIKE h_rank2 AND REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 182+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(183) : wbs_ext.sql(497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI SET REC_STATUS = 'L', REC_DATETIME = SYSTIMESTAMP
            WHERE PARENT_RANK LIKE h_rank2 AND REC_STATUS <> 'D';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 200+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(201) : wbs_ext.sql(515) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 2 Then
         PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank2, 1);
         BEGIN
            UPDATE TMT_WBS SET REC_USER = h_resource_id, REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE RANK LIKE h_rank2 AND REC_STATUS = 'L';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 219+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(220) : wbs_ext.sql(534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_CRI SET REC_STATUS = 'U', REC_DATETIME = SYSTIMESTAMP
            WHERE PARENT_RANK LIKE h_rank2 AND REC_STATUS = 'L';
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 237+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(238) : wbs_ext.sql(552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_bitflag, 0) = 3 Then
         OPEN C_CKP;
         
         FETCH C_CKP INTO h_rec_status;
         IF C_CKP%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         --trace_printf("SC_STATE: %d, h_rec_status: %s\n",SC_STATE,h_rec_status); //trace_flush();
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               CLOSE C_CKP ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 261+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(262) : wbs_ext.sql(576) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               CLOSE C_PORTF1 ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 274+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(275) : wbs_ext.sql(589) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If SubStr(h_rec_status, 1, 1) = 'L' Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_UNLOCK', 281+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_UNLOCK(282) : wbs_ext.sql(596) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN 1;
            ElsIf SubStr(h_rec_status, 1, 1) = 'D' Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_UNLOCK', 286+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_UNLOCK(287) : wbs_ext.sql(601) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN 3;
            Else
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_UNLOCK', 291+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_UNLOCK(292) : wbs_ext.sql(606) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN 2;
            End If;
         Else
            PMO_DB2M.SC_STATE := 0;
         End If;
         
         BEGIN
            CLOSE C_CKP ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 307+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(308) : wbs_ext.sql(622) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_PORTF1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_LOCK_UNLOCK', 322+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_LOCK_UNLOCK(323) : wbs_ext.sql(637) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("END: SC_STATE: %d, h_rec_status: %s\n",SC_STATE,h_rec_status); //trace_flush();
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_LOCK_UNLOCK', 329+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_LOCK_UNLOCK(330) : wbs_ext.sql(644) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_LOCK_UNLOCK;
ALTER FUNCTION FC_LOCK_UNLOCK COMPILE DEBUG;

/*********************************************
CHECK for project / resource CALENDAR
*********************************************/

Prompt == FUNCTION FC_CHECK_CALENDAR ==
CREATE OR REPLACE FUNCTION FC_CHECK_CALENDAR
(
     id001 IN OUT NOCOPY VARCHAR2
   , SD001 IN OUT NOCOPY DATE
   , sh_duration001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   duration001 PLS_INTEGER := sh_duration001;
   h_FD DATE;
   h_SD DATE;
   h_project_id VARCHAR2(32);
   h_count PLS_INTEGER := 0;
   h_duration PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHECK_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHECK_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := FC_CHECK_CALENDAR(' || 
       '''' || id001 || ''''
          || ', ' || COALESCE(NULLIF('''' || SD001 || '''',''''''), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_duration001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_CALENDAR', 23+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHECK_CALENDAR(24) : wbs_ext.sql(680) : ' || SYSTIMESTAMP);
   END IF; 

   h_SD := SubStr(SD001, 1, 10);
   h_type_id := PMO_CNST.SC_PROJECT;
   
   If (id001 IS NULL) OR (duration001 IS NULL) OR (Coalesce(duration001, 0) = 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_CALENDAR', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_CALENDAR(32) : wbs_ext.sql(688) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN -1;
   End If;
   
   h_project_id := id001;
   h_duration := duration001;
   --strcpy(h_SD[10], "\0");
   
   -- Check for project calendar
   BEGIN
      SELECT COUNT(*) INTO h_count FROM CALENDAR_DAY_OF_YEAR WHERE ELEMENT_ID = h_project_id AND DAY_YEAR > TO_DATE(SubStr(h_SD, 1, 10));
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_CALENDAR', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_CALENDAR(50) : wbs_ext.sql(706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) < Coalesce(h_duration, 0) Then
      BEGIN
         SELECT TO_DATE(SubStr(MAX(DAY_YEAR), 1, 10)) + 1      INTO h_SD FROM CALENDAR_DAY_OF_YEAR WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHECK_CALENDAR', 63+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHECK_CALENDAR(64) : wbs_ext.sql(720) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         h_FD := '';
         
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_CALENDAR', 72+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_CALENDAR(73) : wbs_ext.sql(729) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN POPULATE_CALENDAR(h_project_id, h_type_id, h_SD, h_FD, h_duration);
      Else
         PMO_DB2M.SC_STATE := -1;
         NULL;
      End If;
   Else
      PMO_DB2M.SC_STATE := 0;
      NULL;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHECK_CALENDAR', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHECK_CALENDAR(86) : wbs_ext.sql(742) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHECK_CALENDAR;
ALTER FUNCTION FC_CHECK_CALENDAR COMPILE DEBUG;

/*************************************************************************************************
*** When insert a project, Timephase availability from PROJECT CALENDAR
*** insert in PROJECT_BUDGET_BREAKDOWN one row per fiscal year
**************************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_CALENDAR ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_CALENDAR
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_SD IN OUT NOCOPY DATE
   , h_FD IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_total PLS_INTEGER := 0;
   h_cur_year PLS_INTEGER := 0;
   h_start_year PLS_INTEGER := 0;
   h_end_year PLS_INTEGER := 0;
   h_fiscal_year PLS_INTEGER := 0;
   h_01 PLS_INTEGER := 0;
   h_02 PLS_INTEGER := 0;
   h_03 PLS_INTEGER := 0;
   h_04 PLS_INTEGER := 0;
   h_05 PLS_INTEGER := 0;
   h_06 PLS_INTEGER := 0;
   h_07 PLS_INTEGER := 0;
   h_08 PLS_INTEGER := 0;
   h_09 PLS_INTEGER := 0;
   h_10 PLS_INTEGER := 0;
   h_11 PLS_INTEGER := 0;
   h_12 PLS_INTEGER := 0;
   h_uniqueID VARCHAR2(32);
-- Declare Cursors
      CURSOR CTPH01 IS
         SELECT
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 1)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 2)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 3)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 4)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 5)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 6)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 7)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 8)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 9)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 10)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 11)))),
         SUM(AVAILABLE_MIN * (1 - ABS(SIGN(FISCAL_MONTH - 12))))
         FROM CALENDAR_DAY_OF_YEAR cdy JOIN FISCAL_CALENDAR fy
         ON cdy.DAY_YEAR BETWEEN fy.START_DATE AND fy.FINISH_DATE AND fy.FISCAL_YEAR = h_cur_year
         WHERE cdy.ELEMENT_ID = h_project_id AND cdy.DAY_YEAR BETWEEN h_SD AND h_FD;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_CALENDAR') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_CALENDAR'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_CALENDAR(' || 
       '''' || h_project_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_SD || '''',''''''), 'NULL')
          || ', ' || COALESCE(NULLIF('''' || h_FD || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_CALENDAR', 54+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_CALENDAR(55) : wbs_ext.sql(810) : ' || SYSTIMESTAMP);
   END IF; 

   If h_project_id IS NULL Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_CALENDAR', 59+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_CALENDAR(60) : wbs_ext.sql(815) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN -1;
   End If;
   
   h_total := 0;
   
   --trace_printf("h_project_id: %s, h_SD: %s, h_FD: %s\n",h_project_id,h_SD, h_FD);
   If h_FD IS NULL Then
      BEGIN
         SELECT MIN(DAY_YEAR), MAX(DAY_YEAR) INTO h_SD, h_FD
         FROM CALENDAR_DAY_OF_YEAR WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_CALENDAR', 77+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_CALENDAR(78) : wbs_ext.sql(833) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("h_SD: %s, h_FD: %s\n",h_SD, h_FD);
   
   BEGIN
      SELECT PMO_ORASTD.YEAR(h_SD), PMO_ORASTD.YEAR(h_FD) INTO h_start_year, h_end_year
      FROM DUAL;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_CALENDAR', 93+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_CALENDAR(94) : wbs_ext.sql(849) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_cur_year := h_start_year;
   
   WHILE Coalesce(h_cur_year, 0) <= Coalesce(h_end_year, 0) LOOP
      --trace_printf("*** h_cur_year: %d\n",h_cur_year);
      
      OPEN CTPH01;
      
      LOOP
         FETCH CTPH01 INTO h_01, h_02, h_03, h_04, h_05, h_06, h_07, h_08, h_09, h_10, h_11, h_12;
         IF CTPH01%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS OR (h_01 IS NULL) Then
            EXIT;
         End If;
         
         h_total := Coalesce(h_01, 0) + Coalesce(h_02, 0) + Coalesce(h_03, 0) + Coalesce(h_04, 0) + Coalesce(
                    h_05, 0) + Coalesce(h_06, 0) + Coalesce(h_07, 0) + Coalesce(h_08, 0) + Coalesce(
                    h_09, 0) + Coalesce(h_10, 0) + Coalesce(h_11, 0) + Coalesce(h_12, 0);
         
         BEGIN
            INSERT INTO PROJECT_BUDGET_BREAKDOWN ( ELEMENT_ID, PROJECT_ID, CHARGECODE_ID, BUDGET_YEAR, TOTAL_AMOUNT,
            MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT, MONTH_06_AMOUNT,
            MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT)
            VALUES(h_project_id, h_project_id, 'PMO_PROJECT_TIMEPHASE_CALENDAR__', h_cur_year, h_total,
            h_01, h_02, h_03, h_04, h_05, h_06,
            h_07, h_08, h_09, h_10, h_11, h_12);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_CALENDAR', 138+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_CALENDAR(139) : wbs_ext.sql(894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE: %d, h_cur_year: %d, h_total: %d\n", SC_STATE,h_cur_year,h_total);
      END LOOP;
      
      BEGIN
         CLOSE CTPH01 ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_CALENDAR', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_CALENDAR(154) : wbs_ext.sql(909) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_cur_year := Coalesce(h_cur_year, 0) + 1;
   END LOOP;
   
   BEGIN
      SELECT CHARGECODE_ID INTO h_id FROM BUDGETS
      WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__';
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_CALENDAR', 170+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_CALENDAR(171) : wbs_ext.sql(926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      h_uniqueID := SYS_GUID();
      BEGIN
         INSERT INTO BUDGETS(BUDGET_ID, PROJECT_ID, ELEMENT_ID, TYPE_ID, CREATED_BY, CHARGECODE_ID, ACTUAL_EDITED, REC_USER)
         VALUES(h_uniqueID, h_project_id, h_project_id, 31, 'PMO_SUPERVISOR', 'PMO_PROJECT_TIMEPHASE_CALENDAR__', 1, 'PMO_SUPERVISOR');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_CALENDAR', 190+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_CALENDAR(191) : wbs_ext.sql(946) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   --trace_printf("BUDGETS: SC_STATE: %d\n", SC_STATE);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_CALENDAR', 198+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_CALENDAR(199) : wbs_ext.sql(954) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_CALENDAR;
ALTER FUNCTION FC_TIMEPHASE_CALENDAR COMPILE DEBUG;

/*************************************************************************************************
*** When update / insert, PROJECT CALENDAR EXCEPTIONS
*** update the month in PROJECT_BUDGET_BREAKDOWN
**************************************************************************************************/

Prompt == FUNCTION FC_TIMEPHASE_MONTH ==
CREATE OR REPLACE FUNCTION FC_TIMEPHASE_MONTH
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_day_ofyear IN OUT NOCOPY DATE
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_SD DATE;
   h_FD DATE;
   h_total PLS_INTEGER := 0;
   h_cur_year PLS_INTEGER := 0;
   h_start_year PLS_INTEGER := 0;
   h_end_year PLS_INTEGER := 0;
   h_fiscal_year PLS_INTEGER := 0;
   h_fiscal_month PLS_INTEGER := 0;
   h_d_min NUMBER := 0;
   h_d_month NUMBER := 0;
   h_d_total NUMBER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_TIMEPHASE_MONTH') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_TIMEPHASE_MONTH'), '-- ' || SYSTIMESTAMP, ':r := FC_TIMEPHASE_MONTH(' || 
       '''' || h_project_id || ''''
          || ', ' || COALESCE(NULLIF('''' || h_day_ofyear || '''',''''''), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_MONTH', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_TIMEPHASE_MONTH(27) : wbs_ext.sql(994) : ' || SYSTIMESTAMP);
   END IF; 

   If (h_project_id IS NULL) OR (h_fiscal_month IS NULL) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_MONTH', 31+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_MONTH(32) : wbs_ext.sql(999) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN -1;
   End If;
   
   --trace_printf("h_project_id: %s, h_day_ofyear: %s\n",h_project_id,h_day_ofyear);
   BEGIN
      SELECT START_DATE, FINISH_DATE, FISCAL_YEAR, FISCAL_MONTH
      INTO h_SD, h_FD, h_fiscal_year, h_fiscal_month
      FROM FISCAL_CALENDAR WHERE h_day_ofyear BETWEEN START_DATE AND FINISH_DATE;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(48) : wbs_ext.sql(1015) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_SD: %s, h_FD: %s, h_fiscal_year: %d, h_fiscal_month: %d\n",SC_STATE,h_SD, h_FD,h_fiscal_year,h_fiscal_month);
   
   BEGIN
      SELECT SUM(AVAILABLE_MIN) INTO h_d_min
      FROM CALENDAR_DAY_OF_YEAR
      WHERE ELEMENT_ID = h_project_id AND DAY_YEAR BETWEEN h_SD AND h_FD;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 63+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(64) : wbs_ext.sql(1031) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE: %d, h_d_min: %d:%.2f\n",SC_STATE,h_d_min_Ind,h_d_min);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_fiscal_month, 0) = 1 Then
         BEGIN
            SELECT MONTH_01_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 80+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(81) : wbs_ext.sql(1048) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_01_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 100+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(101) : wbs_ext.sql(1068) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 2 Then
         BEGIN
            SELECT MONTH_02_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 114+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(115) : wbs_ext.sql(1082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_02_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 134+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(135) : wbs_ext.sql(1102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 3 Then
         BEGIN
            SELECT MONTH_03_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 148+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(149) : wbs_ext.sql(1116) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_03_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 168+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(169) : wbs_ext.sql(1136) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 4 Then
         BEGIN
            SELECT MONTH_04_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 182+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(183) : wbs_ext.sql(1150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_04_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 202+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(203) : wbs_ext.sql(1170) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 5 Then
         BEGIN
            SELECT MONTH_05_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 216+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(217) : wbs_ext.sql(1184) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_05_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 236+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(237) : wbs_ext.sql(1204) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 6 Then
         BEGIN
            SELECT MONTH_06_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 250+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(251) : wbs_ext.sql(1218) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_06_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 270+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(271) : wbs_ext.sql(1238) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 7 Then
         BEGIN
            SELECT MONTH_07_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 284+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(285) : wbs_ext.sql(1252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_07_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 304+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(305) : wbs_ext.sql(1272) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 8 Then
         BEGIN
            SELECT MONTH_08_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 318+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(319) : wbs_ext.sql(1286) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_08_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 338+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(339) : wbs_ext.sql(1306) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 9 Then
         BEGIN
            SELECT MONTH_09_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 352+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(353) : wbs_ext.sql(1320) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_09_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 372+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(373) : wbs_ext.sql(1340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 10 Then
         BEGIN
            SELECT MONTH_10_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 386+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(387) : wbs_ext.sql(1354) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_10_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 406+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(407) : wbs_ext.sql(1374) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 11 Then
         BEGIN
            SELECT MONTH_11_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 420+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(421) : wbs_ext.sql(1388) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_11_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 440+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(441) : wbs_ext.sql(1408) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_fiscal_month, 0) = 12 Then
         BEGIN
            SELECT MONTH_12_AMOUNT INTO h_d_month FROM PROJECT_BUDGET_BREAKDOWN
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 454+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(455) : wbs_ext.sql(1422) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_d_total := Coalesce(h_d_min, 0) - Coalesce(h_d_month, 0);
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET TOTAL_AMOUNT = TOTAL_AMOUNT + h_d_total, MONTH_12_AMOUNT = h_d_min
            WHERE ELEMENT_ID = h_project_id AND CHARGECODE_ID = 'PMO_PROJECT_TIMEPHASE_CALENDAR__' AND BUDGET_YEAR = h_fiscal_year;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_TIMEPHASE_MONTH', 474+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_TIMEPHASE_MONTH(475) : wbs_ext.sql(1442) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --trace_printf("SC_STATE: %d, h_d_min: %.2f, h_d_month: %.2f, h_d_total: %.2f\n",SC_STATE, h_d_min, h_d_month, h_d_total);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_TIMEPHASE_MONTH', 484+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_TIMEPHASE_MONTH(485) : wbs_ext.sql(1452) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_TIMEPHASE_MONTH;
ALTER FUNCTION FC_TIMEPHASE_MONTH COMPILE DEBUG;

/*********************************************
DELETE Assignment
*********************************************/

Prompt == FUNCTION FC_DEL_ASSIGNMENT ==
CREATE OR REPLACE FUNCTION FC_DEL_ASSIGNMENT
(
     current_id IN OUT NOCOPY VARCHAR2
   , current_resource_id IN OUT NOCOPY VARCHAR2
   , res_type IN OUT NOCOPY VARCHAR2
   , sh_type001 PLS_INTEGER
   , sh_participant001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type001 PLS_INTEGER := sh_type001;
   participant001 PLS_INTEGER := sh_participant001;
   h_current_id VARCHAR2(32);
   h_current_resource_id VARCHAR2(32);
   h_day_year DATE;
   h_id2 VARCHAR2(32);
   h_prj_assignment_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_res_type VARCHAR2(1);
   h_available PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_bitID RAW(36) NOT NULL := PMO_CNST.SC_ZERO_BIT;
   h_temp_var PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CPASS IS
         SELECT PROJECT_ID, TSK_ASSIGNMENT_ID, PROJECT_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_current_id;

      CURSOR CTDY IS
         SELECT DAY_YEAR, SCHED_MIN, BIT_SCHED
         FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID = h_id2
         AND PARENT_ID = h_prj_assignment_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DEL_ASSIGNMENT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DEL_ASSIGNMENT'), '-- ' || SYSTIMESTAMP, ':r := FC_DEL_ASSIGNMENT(' || 
       '''' || current_id || ''''
          || ', ' || '''' || current_resource_id || ''''
          || ', ' || '''' || res_type || ''''
          || ', ' || COALESCE(TO_CHAR(sh_type001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_participant001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEL_ASSIGNMENT', 49+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DEL_ASSIGNMENT(50) : wbs_ext.sql(1514) : ' || SYSTIMESTAMP);
   END IF; 

   h_current_id := current_id;
   h_current_resource_id := current_resource_id;
   h_res_type := res_type;
   h_type := type001;
   h_participant := participant001;
   
   h_participant := BITAND(Coalesce(h_participant, 0), 4112);
   If Coalesce(h_participant, 0) = 0 Then
      BEGIN
         SELECT COUNT('X') INTO h_temp_var FROM DUAL WHERE EXISTS (
         SELECT 'X' FROM TASK_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_current_id);
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 69+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(70) : wbs_ext.sql(1534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_temp_var, 0) > 0 Then
         h_participant := 16;
      End If;
   End If;
   
   --trace_printf("2_** h_participant: %d\n",h_participant);
   If Coalesce(h_participant, 0) > 0 Then
      If (BITAND(Coalesce(h_participant, 0), 16)) = 16 Then
         -- Check if created from PROJECT assignment
         
         OPEN CPASS;
         
         LOOP
            FETCH CPASS INTO h_project_id, h_id2,  h_prj_assignment_id;
            IF CPASS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            If h_prj_assignment_id IS NOT NULL Then
               h_count := 0;
               -- Check if created from PROJECT assignment
               
               OPEN CTDY;
               
               LOOP
                  FETCH CTDY INTO h_day_year, h_count, h_bitID;
                  IF CTDY%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                     EXIT;
                  End If;
                  
                  BEGIN
                     UPDATE TASK_DAY_OF_YEAR SET
                     SCHED_MIN = SCHED_MIN + h_count, BIT_SCHED = UTL_RAW.BIT_OR(BIT_SCHED, h_bitID)
                     WHERE PROJECT_ID = h_project_id
                     AND TSK_ASSIGNMENT_ID = h_prj_assignment_id
                     AND DAY_YEAR = h_day_year;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 130+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(131) : wbs_ext.sql(1595) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  
                  If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
                     BEGIN
                        DELETE FROM TASK_DAY_OF_YEAR
                        WHERE PROJECT_ID = h_project_id
                        AND TSK_ASSIGNMENT_ID = h_id2
                        AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 151+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(152) : wbs_ext.sql(1616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     
                     BEGIN
                        DELETE FROM LEVEL_TASK_DAY_OF_YEAR
                        WHERE PROJECT_ID = h_project_id
                        AND TSK_ASSIGNMENT_ID = h_id2
                        AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 171+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(172) : wbs_ext.sql(1636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  Else
                     BEGIN
                        UPDATE TASK_DAY_OF_YEAR SET
                        TSK_ASSIGNMENT_ID = PARENT_ID
                        WHERE PROJECT_ID = h_project_id
                        AND TSK_ASSIGNMENT_ID = h_id2
                        AND DAY_YEAR = h_day_year;
                        IF SQL%FOUND = TRUE THEN
                           PMO_DB2M.SC_STATE := 0;
                        ELSE
                           PMO_DB2M.SC_STATE := 100;
                        END IF;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 192+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(193) : wbs_ext.sql(1657) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                  End If;
               END LOOP;
               
               BEGIN
                  CLOSE CTDY ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 207+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(208) : wbs_ext.sql(1672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- CALL UPDATE assign string function
               If isNotProjectType(Coalesce(h_type, 0)) <> 0 Then
                  h_temp_var := 0;
                  h_temp_sc_state := U_ASSIGN_STRING(h_project_id, h_prj_assignment_id, h_temp_var, 0, 0);
               End If;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE CPASS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 228+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(229) : wbs_ext.sql(1693) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- UPDATE CALENDAR_DAY_OF_YEAR
      /*      BEGIN_SQL
                  DECLARE C2 CURSOR WITH HOLD FOR SELECT RESOURCE_ID, SCHED_MIN, DAY_YEAR, BIT_SCHED
                  FROM TASK_DAY_OF_YEAR
                  WHERE PROJECT_ID = HOST(h_project_id)
                  AND TSK_ASSIGNMENT_ID IN (
                      SELECT TSK_ASSIGNMENT_ID
                      FROM TASK_ASSIGNMENTS
                      WHERE PROJECT_ID = HOST(h_project_id)
                      AND RES_ASSIGNMENT_ID = HOST(h_current_id)
                      AND BIT_FLAG = '2' )
                  AND BIT_FLAG = '2';
              END_SQL;
      
              BEGIN_SQL
                  OPEN C2;
              END_SQL_CHECK;
      
              while (1==1)
              {
                  BEGIN_SQL
                      FETCH C2 INTO HOST(h_res_id), HOST(h_available), HOST(h_day_year), HOST(h_bitID);
                  END_SQL_CHECK;
                  if (SC_NOSUCCESS) break;
      
                  //removed the update of ASSIGNED_MIN  BIT_ASSIGNED fields
              }
      
              BEGIN_SQL
                  CLOSE C2 WITH RELEASE;
              END_SQL_CHECK;
      */
      --delete timesheets
      BEGIN
         DELETE FROM DETAIL_TIMESHEETS
         WHERE ACTIVITY_ID IN (
         SELECT ELEMENT_ID
         FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = h_current_id));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 286+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(287) : wbs_ext.sql(1751) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM ACTIVITIES
         WHERE TSK_ASSIGNMENT_ID IN
         (SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = h_current_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 307+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(308) : wbs_ext.sql(1772) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM SUMMARY_TIMESHEETS
         WHERE TSK_ASSIGNMENT_ID IN
         (SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = h_current_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 328+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(329) : wbs_ext.sql(1793) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RES_ASSIGNMENT_ID = h_current_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 351+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(352) : wbs_ext.sql(1816) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM LEVEL_TASK_DAY_OF_YEAR
         WHERE PROJECT_ID = h_project_id
         AND TSK_ASSIGNMENT_ID IN (
         SELECT TSK_ASSIGNMENT_ID
         FROM TASK_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND RES_ASSIGNMENT_ID = h_current_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 374+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(375) : wbs_ext.sql(1839) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TASK_ASSIGNMENTS
         WHERE RES_ASSIGNMENT_ID = h_current_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 392+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(393) : wbs_ext.sql(1857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --      if ( h_prj_assignment_id_Ind == 0 )
      If h_prj_assignment_id IS NOT NULL Then
         BEGIN
            DELETE FROM TASK_ASSIGNMENTS WHERE TSK_ASSIGNMENT_ID = h_prj_assignment_id AND BIT_FLAG = '0' AND
            PLANNED_WORK = 0 AND NOT EXISTS(SELECT * FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND
            TASK_ID <> PROJECT_ID AND PROJECT_ASSIGNMENT_ID = h_prj_assignment_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 413+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(414) : wbs_ext.sql(1878) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --  if (h_res_type[0] == '1') // profile
      If SubStr(h_res_type, 1, 1) = '1' Then
         If isNotProjectType(Coalesce(h_type, 0)) <> 0 Then
            BEGIN
               UPDATE PROFILES SET REC_STATUS='D' WHERE PROFILE_ID = h_current_resource_id AND
               (SELECT COUNT(*) FROM RESOURCE_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND
               RESOURCE_TYPE = '1' AND PROFILE_ID = h_current_resource_id) = 1;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 436+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(437) : wbs_ext.sql(1901) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         BEGIN
            DELETE FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID = h_current_resource_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DEL_ASSIGNMENT', 454+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DEL_ASSIGNMENT(455) : wbs_ext.sql(1919) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DEL_ASSIGNMENT', 462+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DEL_ASSIGNMENT(463) : wbs_ext.sql(1927) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DEL_ASSIGNMENT;
ALTER FUNCTION FC_DEL_ASSIGNMENT COMPILE DEBUG;

/*********************************************
delete TMT_WBS records

    IF NOT EXISTS (TMT_COSTS)
        IF NOT EXISTS (WEEKLY_TIMESHEETS)
            DELETE BUDGETS
                RollupBudgets
            DELETE RESOURCE_ASSIGNMENTS
                RollupDates
            DELETE TMT_DOCUMENTS
                DELETE DOCUMENT_BLOBS
            DELETE TMT_CRI
                DELETE CRIBUDGETS
                DELETE CRIDEPENDENCIES
                DELETE TMT_???_ATTRIBUTES
            DELETE TMT_???_ATTRIBUTES
            DELETE DEPENDENCIES
                UPDATE TMT_WBS.DEPENDENCIES
            DELETE TMT_WBS
/#############################################*/

Prompt == FUNCTION FC_DELETE_WBS ==
CREATE OR REPLACE FUNCTION FC_DELETE_WBS
(
     id001 IN OUT NOCOPY VARCHAR2
   , parent_id001 IN OUT NOCOPY VARCHAR2
   , status_id001 IN OUT NOCOPY VARCHAR2
   , rec_user001 IN OUT NOCOPY VARCHAR2
   , sh_rollup PLS_INTEGER
) RETURN PLS_INTEGER
AS
   rollup PLS_INTEGER := sh_rollup;
   h_actual_start TIMESTAMP;
   h_cri_id VARCHAR2(32);
   h_cri_parent_id VARCHAR2(32);
   h_current_id VARCHAR2(32);
   h_current_rank VARCHAR2(200);
   h_current_resource_id VARCHAR2(32);
   h_week_of DATE;
   h_exists VARCHAR2(32);
   h_id VARCHAR2(32);
   h_id2 VARCHAR2(32);
   h_parent_id VARCHAR2(32);
   h_parent_id2 VARCHAR2(32);
   h_proj_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_published VARCHAR2(1);
   h_published2 VARCHAR2(1);
   h_published3 VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_rank2 VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_rec_user VARCHAR2(32);
   h_res_type VARCHAR2(1);
   h_status_id VARCHAR2(1);
   h_t_rank VARCHAR2(200);
   h_transfer_flag VARCHAR2(1);
   h_parent_transfer_flag VARCHAR2(1);
   h_wbs_id VARCHAR2(32);
   h_workflow_date TIMESTAMP;
   h_xsql VARCHAR2(4999);
   h_fs_state PLS_INTEGER := 0;
   h_a_cri_count PLS_INTEGER := 0;
   h_a_req_count PLS_INTEGER := 0;
   h_actual_effort PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_count2 PLS_INTEGER := 0;
   h_cri_count PLS_INTEGER := 0;
   h_doc_count PLS_INTEGER := 0;
   h_go_delete PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_req_count PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_cannot_delete PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_cur_rank VARCHAR2(200);
   h_host_table PLS_INTEGER := 0;
   h_delete_all_child PLS_INTEGER := 0;
   h_temp_id VARCHAR2(32);
   h_temp_parent_id VARCHAR2(32);
   h_temp_sc_state PLS_INTEGER := 0;
   h_auto_approval PLS_INTEGER := 0;
   h_sched_start TIMESTAMP;
   h_task_actual_start TIMESTAMP;
   h_current_participant PLS_INTEGER := 0;
   h_new_participant_bit_value PLS_INTEGER := 0;
   h_update_participant PLS_INTEGER := 0;
   h_res_assignment_id VARCHAR2(32);
   h_cri_security_id VARCHAR2(32);
   h_element_id VARCHAR2(32);
   h_cri_type PLS_INTEGER := 0;
   h_transferred_cri_type PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_item_rec_status VARCHAR2(1);
-- Declare Cursors
      CURSOR C1_TS IS
         SELECT CURRENT_STATE FROM TIMESHEET_APPROVAL_STATUS
         WHERE  ROWNUM <= 1 AND  ELEMENT_ID = h_project_id AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_RM_APPROVED,PMO_CNST.SC_APV_STATE_PM_APPROVED);

      CURSOR C2_TS IS
         SELECT TS.CURRENT_STATE
         FROM TIMESHEET_APPROVAL_STATUS TS JOIN TMT_WBS W ON
         TS.ELEMENT_ID = W.PROJECT_ID AND CURRENT_STATE IN (PMO_CNST.SC_APV_STATE_RM_APPROVED,PMO_CNST.SC_APV_STATE_PM_APPROVED)
         JOIN TASK_ASSIGNMENTS TA ON W.PROJECT_ID = TA.PROJECT_ID AND W.ELEMENT_ID = TA.TASK_ID
         AND TA.ACTUAL_START IS NOT NuLL AND TO_DATE(SubStr(TA.ACTUAL_START, 1, 10)) <= TS.WEEK_OF + 7     
         WHERE  ROWNUM <= 1 AND  W.RANK LIKE h_rank || '%' AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK);

      CURSOR C_COSTS IS
         SELECT ELEMENT_ID FROM TMT_COSTS
         WHERE  ROWNUM <= 1 AND  PARENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');

      CURSOR C_TIME IS
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND WORK_TODATE > 0;

      CURSOR C_PORTFOLIO IS
         SELECT ELEMENT_ID, TYPE_ID, RANK FROM TMT_WBS
         WHERE PROJECT_ID = h_project_id AND TYPE_ID > 0 AND TYPE_ID < PMO_CNST.SC_TMP_FOLDER1 AND T_RANK LIKE h_rank || '%';

      CURSOR UPPUB IS
         SELECT ELEMENT_ID, PUBLISHED
         FROM TMT_WBS
         WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND PUBLISHED ='3' AND (SUBSTR(h_rank2, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_rank2) THEN 1 ELSE LENGTH(RANK) END) = RANK 
         AND (RANK LIKE SUBSTR(h_rank2, 1, 8) || '%'))
         ORDER BY RANK DESC;

      CURSOR CDLC IS
         SELECT FS_STATE
         FROM TMT_WBS
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND (FS_CODE IS NOT Null OR FS_STATE IN (2,3));

      CURSOR C_TSAPV IS
         SELECT DISTINCT RESOURCE_ID
         FROM TIMESHEET_APPROVAL_STATUS
         WHERE ELEMENT_ID = h_project_id;

      CURSOR C_TSAPV2 IS
         SELECT RESOURCE_ID FROM TIMESHEET_APPROVAL_STATUS
         WHERE RESOURCE_ID = h_exists AND ELEMENT_ID <> h_exists AND ELEMENT_ID <> h_project_id;

      CURSOR C_WEEKS IS
         SELECT DISTINCT WEEK_OF FROM TIMESHEET_APPROVAL_STATUS
         WHERE RESOURCE_ID = h_exists;

      CURSOR C_ASSIGNMENTS IS
         SELECT RES_ASSIGNMENT_ID, RESOURCE_TYPE, PARTICIPANT,
         CASE WHEN RESOURCE_TYPE = '0' THEN RESOURCE_ID ELSE PROFILE_ID END
         FROM RESOURCE_ASSIGNMENTS R, TMT_WBS W
         WHERE W.RANK LIKE h_rank || '%' AND W.ASSIGN_COUNT > 0
         AND (W.TRANSFER_FLAG IS Null OR h_delete_all_child = 1
         OR
         ( W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND W.ACTUAL_START IS NOT Null))
         AND R.ELEMENT_ID = W.ELEMENT_ID;

      CURSOR C_RA IS
         SELECT PARTICIPANT,RES_ASSIGNMENT_ID,ELEMENT_TYPE,ELEMENT_ID,CRI_SECURITY_ID
         FROM  RESOURCE_ASSIGNMENTS RA
         WHERE RA.ELEMENT_ID IN (SELECT W.ELEMENT_ID FROM TMT_WBS W WHERE W.RANK LIKE h_rank || '%' AND TRANSFER_FLAG = 'C');

      CURSOR C_WBS IS
         SELECT TYPE_ID, ELEMENT_ID, CRI_COUNT, DOC_COUNT, LAST_WF_DT, RANK,
         TRANSFER_FLAG, A_CRI_COUNT, PARENT_ID, SCHED_START, ACTUAL_START
         FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%'
         ORDER BY RANK DESC;

      CURSOR C_A_CRI IS
         SELECT ELEMENT_ID, PARENT_ID
         FROM TMT_CRI
         WHERE WBS_ID = h_wbs_id AND ELEMENT_ID <> WBS_ID;

      CURSOR C_WORKFLOW IS
         SELECT RANK FROM TMT_WORKFLOWS
         WHERE ELEMENT_ID = h_wbs_id
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3 , PMO_CNST.SC_DELIVERABLE, PMO_CNST.SC_TASK, PMO_CNST.SC_WBS_NOTIFICATION, PMO_CNST.SC_STAFFING_REQUESTS);

      CURSOR C_DEPENDENCIES IS
         SELECT SUCC_ID
         FROM DEPENDENCIES
         WHERE PRED_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');

      CURSOR C_TF_CRI IS
         SELECT C.ELEMENT_ID
         FROM TMT_WBS W, TMT_CRI C
         WHERE W.RANK LIKE h_rank || '%'
         AND W.ELEMENT_ID = C.ELEMENT_ID;

      CURSOR C_TCAL IS
         SELECT PARENT_ID FROM TMT_CALENDARS
         WHERE ELEMENT_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) );

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_DELETE_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_DELETE_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_DELETE_WBS(' || 
       '''' || id001 || ''''
          || ', ' || '''' || parent_id001 || ''''
          || ', ' || '''' || status_id001 || ''''
          || ', ' || '''' || rec_user001 || ''''
          || ', ' || COALESCE(TO_CHAR(sh_rollup), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 188+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_DELETE_WBS(189) : wbs_ext.sql(2145) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_cannot_delete := 0;
   h_id := id001;
   h_parent_id := parent_id001;
   h_status_id := status_id001;
   h_rec_user := rec_user001;
   h_rollup := rollup;
   
   BEGIN
      SELECT PROJECT_ID, TYPE_ID, LEVEL_ID, PUBLISHED, RANK, PARENT_ID,
      ACTUAL_START, COALESCE(ACTUAL_EFFORT, 0),TRANSFER_FLAG, STAGE_ID, REC_STATUS
      INTO h_project_id, h_type, h_level_id, h_published, h_rank,h_parent_id,
      h_actual_start, h_actual_effort,h_transfer_flag, h_stage_id, h_item_rec_status
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 214+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(215) : wbs_ext.sql(2171) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 221+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(222) : wbs_ext.sql(2178) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_CNST.RECORD_NOT_FOUND;
   End If;
   
   If isProjectType(Coalesce(h_type, 0)) <> 0 Then
      -- delete from tmt_portfolios
      BEGIN
         UPDATE TMT_PORTFOLIOS
         SET CHILD_COUNT = CHILD_COUNT - 1
         WHERE ELEMENT_ID IN
         (SELECT PARENT_ID
         FROM TMT_PORTFOLIOS
         WHERE ELEMENT_ID = h_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 245+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(246) : wbs_ext.sql(2202) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         DELETE FROM TMT_PORTFOLIOS WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 262+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(263) : wbs_ext.sql(2219) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --added by paria
   --we can not delete transfered item if it's parent also transfered
   --unless it is task,deliverable,milstone,summary_task,or other cri_task type
   h_delete_all_child := 0;
   
   If h_transfer_flag IS NOT NULL Then
      If PMO_CNST.SC_MAINTAIN_TRANSFERRED_CRI_TR = 0 Then
         If isPureWBSTask(Coalesce(h_type, 0)) <> 0 Then
            h_delete_all_child := 1;
         Else
            BEGIN
               SELECT RANK INTO h_cur_rank
               FROM TMT_CRI
               WHERE ELEMENT_ID = h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 288+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(289) : wbs_ext.sql(2245) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            h_count := 0;
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count
               FROM TMT_CRI
               WHERE (SUBSTR(h_cur_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_cur_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
               AND (RANK LIKE SUBSTR(h_cur_rank, 1, 12) || '%'))
               AND LEVEL_ID > 1
               AND TYPE_ID <> PMO_CNST.SC_FOLDER
               AND ELEMENT_ID <> h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 308+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(309) : wbs_ext.sql(2265) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) > 0 Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 315+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(316) : wbs_ext.sql(2272) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_CNST.CANNOT_DELETE_SUB_TRANSFERRED_;
            End If;
         End If;
      Else
         If (isTask(Coalesce(h_type, 0))) <> 0 OR (Coalesce(h_type, 0) = PMO_CNST.SC_SUMMARY_TASK) 
               OR (Coalesce(h_type, 0) = PMO_CNST.SC_DELIVERABLE) Then
            --trace_printf("1------------\n");
            h_delete_all_child := 1;
            
            BEGIN
               SELECT WBS_ID
               INTO  h_wbs_id
               FROM TMT_CRI
               WHERE ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 337+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(338) : wbs_ext.sql(2294) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS OR (h_wbs_id IS NULL) Then
               h_delete_all_child := 0;
            End If;
         Else
            BEGIN
               SELECT TRANSFER_FLAG
               INTO  h_parent_transfer_flag
               FROM TMT_WBS
               WHERE ELEMENT_ID = h_parent_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 357+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(358) : wbs_ext.sql(2314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("2------------\n");
            --trace_printf("3------------h_parent_transfer_flag %s\n",h_parent_transfer_flag);
            If h_parent_transfer_flag IS NOT NULL Then
               If Coalesce(h_rollup, 0) = 1 Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 366+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(367) : wbs_ext.sql(2323) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN 0;
               Else
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 371+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(372) : wbs_ext.sql(2328) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_CNST.CANNOT_DELETE;
               End If;
            End If;
         End If;
      End If;
   End If;
   
   --trace_printf("\ndelete flag: %s\n", h_status_id); //trace_flush();
   If NOT (SubStr(h_status_id, 1, 1) = 'Q') Then
      h_count := 0;
      BEGIN
         SELECT SUM(CRI_COUNT) INTO h_count
         FROM TMT_WBS
         WHERE CRI_COUNT > 0 AND RANK LIKE h_rank || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 393+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(394) : wbs_ext.sql(2350) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         h_cannot_delete := Coalesce(h_cannot_delete, 0) + 1;
         h_count := 0;
      End If;
      
      BEGIN
         SELECT SUM(DOC_COUNT) INTO h_count
         FROM TMT_WBS
         WHERE DOC_COUNT > 0 AND RANK LIKE h_rank || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 413+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(414) : wbs_ext.sql(2370) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         h_cannot_delete := Coalesce(h_cannot_delete, 0) + 2;
         h_count := 0;
      Else
         BEGIN
            SELECT SUM(DOC_COUNT) INTO h_count
            FROM TMT_CRI
            WHERE DOC_COUNT > 0 AND PARENT_RANK LIKE 'WBS#' || h_rank || '%';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 432+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(433) : wbs_ext.sql(2389) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_cannot_delete := Coalesce(h_cannot_delete, 0) + 2;
            h_count := 0;
         End If;
      End If;
      
      h_count := 0;
      BEGIN
         SELECT COUNT(ELEMENT_ID) INTO h_count
         FROM TMT_ASSIGNED_SCORECARDS
         WHERE PARENT_RANK LIKE 'WBS#' || h_rank || '%'
         AND TYPE_ID = PMO_CNST.SC_SCORECARD;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 455+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(456) : wbs_ext.sql(2412) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         h_cannot_delete := Coalesce(h_cannot_delete, 0) + 4;
         h_count := 0;
      Else
         BEGIN
            SELECT COUNT(SCORECARD_COUNT) INTO h_count
            FROM TMT_CRI
            WHERE SCORECARD_COUNT > 0 AND PARENT_RANK LIKE 'WBS#' || h_rank || '%';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 474+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(475) : wbs_ext.sql(2431) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If Coalesce(h_count, 0) > 0 Then
            h_cannot_delete := Coalesce(h_cannot_delete, 0) + 4;
            h_count := 0;
         End If;
      End If;
      
      If (h_actual_start IS NOT NULL OR Coalesce(h_actual_effort, 0) <> 0) Then
         h_cannot_delete := Coalesce(h_cannot_delete, 0) + 8;
         
         If isProjectType(Coalesce(h_type, 0)) <> 0 Then
            h_count := 100;
            If Coalesce(h_stage_id, 0) <> PMO_CNST.SC_WBS_PROJECT_CLOSED_STATE Then
               OPEN C1_TS;
               
               FETCH C1_TS INTO h_count;
               IF C1_TS%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               h_count := PMO_DB2M.SC_STATE;
               
               BEGIN
                  CLOSE C1_TS ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 510+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(511) : wbs_ext.sql(2467) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         Else
            OPEN C2_TS;
            
            FETCH C2_TS INTO h_count;
            IF C2_TS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            h_count := PMO_DB2M.SC_STATE;
            
            BEGIN
               CLOSE C2_TS ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 535+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(536) : wbs_ext.sql(2492) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_count, 0) = 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 543+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(544) : wbs_ext.sql(2500) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.TS_APPROVAL_EXISTS;
         End If;
      End If;
      
      If Coalesce(h_cannot_delete, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 551+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(552) : wbs_ext.sql(2508) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN Coalesce(h_cannot_delete, 0) + PMO_CNST.CANNOT_DEL_ATTACHED_EXISTS;
      End If;
   End If;
   
   -- check if there is any transferred cri attached to the wbs elements to be deleted
   If isNotProjectType(Coalesce(h_type, 0)) <> 0 Then
      BEGIN
         SELECT COUNT(C.ELEMENT_ID) INTO h_count
         FROM TMT_CRI C, TMT_WBS W
         WHERE C.PARENT_RANK LIKE 'WBS#' || h_rank || '%'
         AND C.WBS_ID = C.ELEMENT_ID
         AND W.ELEMENT_ID = C.ELEMENT_ID
         AND W.RANK NOT LIKE h_rank || '%';
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 572+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(573) : wbs_ext.sql(2529) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 579+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(580) : wbs_ext.sql(2536) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.ATTACHED_CRI_TRANSFERRED_TO_WB;
      End If;
   End If;
   
   BEGIN
      SELECT COALESCE(MINUTE_PER_DAY, 480) INTO h_min_per_day
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 595+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(596) : wbs_ext.sql(2552) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If SubStr(h_status_id, 1, 1) = 'Q' OR SubStr(h_status_id, 1, 1) = 'A' Then
      --strcpy(h_status_id, "X");
      h_status_id := 'X';
   Else
      OPEN C_COSTS;
      
      FETCH C_COSTS INTO h_exists;
      IF C_COSTS%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      h_go_delete := PMO_DB2M.SC_STATE;
      
      BEGIN
         CLOSE C_COSTS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 623+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(624) : wbs_ext.sql(2580) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_go_delete, 0) <> 0 Then
         OPEN C_TIME;
         
         FETCH C_TIME INTO h_exists;
         IF C_TIME%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         h_go_delete := PMO_DB2M.SC_STATE;
         
         BEGIN
            CLOSE C_TIME ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 648+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(649) : wbs_ext.sql(2605) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      -- ? Can Delete ?
      If SubStr(h_status_id, 1, 1) = '?' Then
         If Coalesce(h_go_delete, 0) = 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 658+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(659) : wbs_ext.sql(2615) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_RECORD;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 663+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(664) : wbs_ext.sql(2620) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_DB2M.SC_SQL_SUCCESS;
         End If;
      End If;
      
      -- Lock
      If Coalesce(h_go_delete, 0) = 0 Then
         h_status_id := 'L';
      End If;
      --          strcpy(h_status_id, "L");
   End If;
   
   --trace_printf("\ndelete flag: %s, h_type: %d\n", h_status_id,h_type); //trace_flush();
   -- Physical Delete
   If SubStr(h_status_id, 1, 1) = 'X' Then
      h_temp_sc_state := FC_U_PROJ_ASSIGN_BEFORE_D_WBS(h_id);
      
      If (Coalesce(h_type, 0) = 175) OR (Coalesce(h_type, 0) = PMO_CNST.SC_TEMPLATE_LINKS) OR (Coalesce(
             h_type, 0) = 210) OR (Coalesce(h_type, 0) = 211) Then
         OPEN C_PORTFOLIO;
         
         LOOP
            FETCH C_PORTFOLIO INTO h_exists, h_type_id, h_t_rank;
            IF C_PORTFOLIO%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
               PMODEFINES.PMO_PMO_VERIFY_RANK(h_t_rank, 0);
               BEGIN
                  UPDATE TMT_WBS
                  SET PUBLISHED = '0',
                  PUBLISHED_BY = h_rec_user,
                  T_PARENT_ID = Null,
                  T_RANK = Null
                  WHERE PUBLISHED = '2' AND RANK LIKE h_t_rank || '%';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 715+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(716) : wbs_ext.sql(2672) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  UPDATE TMT_WBS
                  SET PUBLISHED = '0',
                  PUBLISHED_BY = h_rec_user,
                  T_PARENT_ID = Null,
                  T_RANK = Null
                  WHERE ELEMENT_ID = h_exists;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 737+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(738) : wbs_ext.sql(2694) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  SELECT ELEMENT_ID, PUBLISHED,
                  CASE WHEN EXISTS(SELECT * FROM TMT_WBS
                  WHERE PUBLISHED='2'
                  AND RANK LIKE h_t_rank || '%') THEN 1 ELSE 0 END
                  INTO h_exists, h_rec_status, h_count
                  FROM TMT_WBS
                  WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND (SUBSTR(h_t_rank, 1, CASE WHEN LENGTH(RANK) > LENGTH(h_t_rank) THEN 1 ELSE LENGTH(RANK) END) = RANK 
                  AND (RANK LIKE SUBSTR(h_t_rank, 1, 8) || '%'));
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 757+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(758) : wbs_ext.sql(2714) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               -- if the PROJECT is Partialy Templeted and does not exists any children templeted,
               -- then flag it to NONE
               If (SubStr(h_rec_status, 1, 1) = '3') AND (Coalesce(h_count, 0) = 0) Then
                  BEGIN
                     UPDATE TMT_WBS
                     SET PUBLISHED = '0'
                     WHERE ELEMENT_ID = h_exists;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 779+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(780) : wbs_ext.sql(2736) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         END LOOP;
         
         BEGIN
            CLOSE C_PORTFOLIO ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 795+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(796) : wbs_ext.sql(2752) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If (SubStr(h_published, 1, 1) = '2') AND (isNotProjectType(Coalesce(h_type, 0))) <> 0 Then
            BEGIN
               SELECT PROJECT_ID, PUBLISHED
               INTO h_proj_id, h_published2
               FROM TMT_WBS
               WHERE ELEMENT_ID =h_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 812+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(813) : wbs_ext.sql(2769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               SELECT COUNT(ELEMENT_ID) INTO h_count2
               FROM TMT_WBS
               WHERE PUBLISHED IN('2', '3')
               AND PROJECT_ID=h_proj_id
               AND ELEMENT_ID NOT IN (h_id,h_proj_id);
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 829+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(830) : wbs_ext.sql(2786) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If (Coalesce(h_count2, 0) = 0) AND (SubStr(h_published2, 1, 1) = '3') Then
               BEGIN
                  UPDATE TMT_WBS
                  SET PUBLISHED = '0'
                  WHERE ELEMENT_ID = h_proj_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 849+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(850) : wbs_ext.sql(2806) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            BEGIN
               SELECT PARENT_ID, RANK INTO h_parent_id2, h_rank2
               FROM TMT_WBS
               WHERE ELEMENT_ID =h_proj_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 865+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(866) : wbs_ext.sql(2822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If h_parent_id2 IS NOT NULL Then
               OPEN UPPUB;
               
               LOOP
                  FETCH UPPUB INTO h_id2, h_published3;
                  IF UPPUB%FOUND THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
                  
                  If PMO_DB2M.SC_STATE = 0 Then
                     If SubStr(h_published3, 1, 1) = '3' Then
                        BEGIN
                           SELECT COUNT(ELEMENT_ID)INTO h_count2
                           FROM TMT_WBS
                           WHERE PARENT_ID=h_id2 AND PUBLISHED IN ('2','3');
                           PMO_DB2M.SC_STATE := SQLCODE;
                        EXCEPTION
                           WHEN OTHERS THEN
                           BEGIN
                              PMO_DB2M.SC_STATE := SQLCODE;
                              IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 893+1) THEN 
                                 LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(894) : wbs_ext.sql(2850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                              END IF; 
                           END;
                        END;
                        
                        If (Coalesce(h_count2, 0) = 0) Then
                           BEGIN
                              UPDATE TMT_WBS
                              SET PUBLISHED = '0'
                              WHERE ELEMENT_ID=h_id2;
                              IF SQL%FOUND = TRUE THEN
                                 PMO_DB2M.SC_STATE := 0;
                              ELSE
                                 PMO_DB2M.SC_STATE := 100;
                              END IF;
                           EXCEPTION
                              WHEN OTHERS THEN
                              BEGIN
                                 PMO_DB2M.SC_STATE := SQLCODE;
                                 IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 913+1) THEN 
                                    LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(914) : wbs_ext.sql(2870) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                                 END IF; 
                              END;
                           END;
                        End If;
                     End If;
                  Else
                     BEGIN
                        CLOSE UPPUB ;
                        PMO_DB2M.SC_STATE := SQLCODE;
                     EXCEPTION
                        WHEN OTHERS THEN
                        BEGIN
                           PMO_DB2M.SC_STATE := SQLCODE;
                           IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 928+1) THEN 
                              LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(929) : wbs_ext.sql(2885) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                           END IF; 
                        END;
                     END;
                     EXIT;
                  End If;
               END LOOP;
            End If;
         End If;
         
         -- Check for FS Project / Assignment
         
         OPEN CDLC;
         
         FETCH CDLC INTO h_fs_state;
         IF CDLC%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               CLOSE CDLC ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 958+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(959) : wbs_ext.sql(2915) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 964+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(965) : wbs_ext.sql(2921) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_CNST.CANNOT_DELETE_FS_ASSIGN_EXISTS;
         Else
            BEGIN
               CLOSE CDLC ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 976+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(977) : wbs_ext.sql(2933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("*** h_type: %d, h_project_id: %s,h_rank: %s\n", h_type,h_project_id,h_rank);
         If isProjectType(Coalesce(h_type, 0)) <> 0 Then
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_ROLES WHERE RES_ASSIGNMENT_ID IN
               (SELECT PROFILE_ID FROM PROFILES WHERE PROJECT_ID = h_project_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 997+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(998) : wbs_ext.sql(2954) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID IN
               (SELECT PROFILE_ID FROM PROFILES WHERE PROJECT_ID = h_project_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1015+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1016) : wbs_ext.sql(2972) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_ROLES WHERE RES_ASSIGNMENT_ID IN
               (SELECT TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND RESOURCE_TYPE = '0');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1033+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1034) : wbs_ext.sql(2990) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_SKILLS WHERE RES_ASSIGNMENT_ID IN
               (SELECT TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS WHERE PROJECT_ID = h_project_id AND RESOURCE_TYPE = '0');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1051+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1052) : wbs_ext.sql(3008) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RM_ASSIGNMENTS
               WHERE PROJECT_ID = h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1069+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1070) : wbs_ext.sql(3026) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --get system settings
            BEGIN
               SELECT SETTING_VALUE INTO h_auto_approval
               FROM TMT_SETTINGS
               WHERE ELEMENT_ID = 'TIMESHEET_AUTO_APPROVAL';
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1085+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1086) : wbs_ext.sql(3042) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            OPEN C_TSAPV;
            
            LOOP
               FETCH C_TSAPV INTO h_exists;
               IF C_TSAPV%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  EXIT;
               End If;
               
               OPEN C_TSAPV2;
               
               FETCH C_TSAPV2 INTO h_exists;
               IF C_TSAPV2%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               --trace_printf("1_SC_STATE: %d, h_exists: %s\n", SC_STATE,h_exists);
               
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  BEGIN
                     DELETE FROM TIMESHEET_APPROVAL_STATUS WHERE RESOURCE_ID = h_exists AND ELEMENT_ID = h_exists;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1127+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1128) : wbs_ext.sql(3084) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("2_SC_STATE: %d, h_exists: %s\n", SC_STATE,h_exists);
                  
                  BEGIN
                     DELETE FROM TIMESHEET_APPROVAL_STATUS WHERE RESOURCE_ID = h_exists AND ELEMENT_ID = h_project_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1145+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1146) : wbs_ext.sql(3102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("3.1_SC_STATE: %d, h_project_id: %s\n", SC_STATE,h_project_id);
               Else
                  BEGIN
                     DELETE FROM TIMESHEET_APPROVAL_STATUS WHERE RESOURCE_ID = h_exists AND ELEMENT_ID = h_project_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1163+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1164) : wbs_ext.sql(3120) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  --trace_printf("3.2_SC_STATE: %d, h_project_id: %s\n", SC_STATE,h_project_id);
                  
                  OPEN C_WEEKS;
                  
                  LOOP
                     FETCH C_WEEKS INTO h_week_of;
                     IF C_WEEKS%FOUND THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                     
                     If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                        EXIT;
                     End If;
                     
                     h_temp_sc_state := FC_U_APVS_RESOURCE(h_exists, h_week_of, h_auto_approval);
                  END LOOP;
                  
                  BEGIN
                     CLOSE C_WEEKS ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1194+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1195) : wbs_ext.sql(3151) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
               
               BEGIN
                  CLOSE C_TSAPV2 ;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1208+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1209) : wbs_ext.sql(3165) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            END LOOP;
            
            BEGIN
               CLOSE C_TSAPV ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1222+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1223) : wbs_ext.sql(3179) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_ROLES
               WHERE RES_ASSIGNMENT_ID IN
               (SELECT TA.RESOURCE_ID FROM TASK_ASSIGNMENTS TA, TMT_WBS W
               WHERE W.RANK LIKE h_rank || '%' AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
               AND TA.PROJECT_ID = h_project_id AND W.ELEMENT_ID = TA.TASK_ID AND TA.RESOURCE_TYPE = '1');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1244+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1245) : wbs_ext.sql(3201) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_SKILLS
               WHERE RES_ASSIGNMENT_ID IN
               (SELECT TA.RESOURCE_ID FROM TASK_ASSIGNMENTS TA, TMT_WBS W
               WHERE W.RANK LIKE h_rank || '%' AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK)
               AND TA.PROJECT_ID = h_project_id AND W.ELEMENT_ID = TA.TASK_ID AND TA.RESOURCE_TYPE = '1');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1265+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1266) : wbs_ext.sql(3222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_ROLES
               WHERE RES_ASSIGNMENT_ID IN
               (SELECT TA.TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS TA, TMT_WBS W
               WHERE W.RANK LIKE h_rank || '%' AND TA.PROJECT_ID = h_project_id
               AND W.ELEMENT_ID = TA.TASK_ID AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND TA.RESOURCE_TYPE = '0');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1286+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1287) : wbs_ext.sql(3243) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGN_SKILLS
               WHERE RES_ASSIGNMENT_ID IN
               (SELECT TA.TSK_ASSIGNMENT_ID FROM TASK_ASSIGNMENTS TA, TMT_WBS W
               WHERE W.RANK LIKE h_rank || '%' AND TA.PROJECT_ID = h_project_id
               AND W.ELEMENT_ID = TA.TASK_ID AND W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND TA.RESOURCE_TYPE = '0');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1307+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1308) : wbs_ext.sql(3264) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --trace_printf("pp1---------->h_delete_all_child:%d \n",h_delete_all_child);
         --DELETE RESOURCE_ASSIGNMENTS
         
         OPEN C_ASSIGNMENTS;
         
         LOOP
            FETCH C_ASSIGNMENTS INTO h_current_id, h_res_type, h_participant, h_current_resource_id;
            IF C_ASSIGNMENTS%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            PMO_DB2M.SC_STATE := FC_DEL_ASSIGNMENT(h_current_id, h_current_resource_id, h_res_type, h_type
                                       , h_participant);
         END LOOP;
         
         BEGIN
            CLOSE C_ASSIGNMENTS ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1342+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1343) : wbs_ext.sql(3299) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If isProjectType(Coalesce(h_type, 0)) <> 0 Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            BEGIN
               DELETE FROM PROFILES WHERE PROJECT_ID IN (
               SELECT ELEMENT_ID FROM TMT_WBS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1362+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1363) : wbs_ext.sql(3319) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TASK_DAY_OF_YEAR
               WHERE PROJECT_ID IN (
               SELECT ELEMENT_ID
               FROM TMT_WBS
               WHERE RANK LIKE h_rank || '%'
               AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1384+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1385) : wbs_ext.sql(3341) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM LEVEL_TASK_DAY_OF_YEAR
               WHERE PROJECT_ID IN (
               SELECT ELEMENT_ID
               FROM TMT_WBS
               WHERE RANK LIKE h_rank || '%'
               AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1406+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1407) : wbs_ext.sql(3363) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TASK_ASSIGNMENTS WHERE PROJECT_ID IN (
               SELECT ELEMENT_ID FROM TMT_WBS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1424+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1425) : wbs_ext.sql(3381) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM RESOURCE_ASSIGNMENTS WHERE PROJECT_ID IN (
               SELECT ELEMENT_ID FROM TMT_WBS WHERE TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND RANK LIKE h_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1442+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1443) : wbs_ext.sql(3399) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            --trace_printf("pp2222---------->h_delete_all_child:%d \n",h_delete_all_child);
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            BEGIN
               DELETE FROM RESOURCE_ASSIGNMENTS RA
               WHERE RA.ELEMENT_ID IN (SELECT W.ELEMENT_ID FROM TMT_WBS W
               WHERE W.RANK LIKE h_rank || '%'
               AND (W.TRANSFER_FLAG IS Null OR h_delete_all_child = 1
               OR
               (W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND W.ACTUAL_START IS NOT Null)));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1466+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1467) : wbs_ext.sql(3423) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --UPDATE SECURITY_ID AND PARTICIPANT
            
            OPEN C_RA;
            
            LOOP
               FETCH C_RA INTO h_current_participant,h_res_assignment_id, h_transferred_cri_type, h_element_id,h_cri_security_id;
               IF C_RA%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               BEGIN
                  SELECT C.TYPE_ID INTO h_cri_type FROM TMT_CRI C WHERE C.ELEMENT_ID = h_element_id;
                  PMO_DB2M.SC_STATE := SQLCODE;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1495+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1496) : wbs_ext.sql(3452) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               h_update_participant := 0;
               If IsResponsible(h_cri_security_id) = 1 Then
                  h_new_participant_bit_value := (Coalesce(h_current_participant, 0) - GetParticipantBitValue(
                                         Coalesce(h_transferred_cri_type, 0)));
                  h_update_participant := 1;
               End If;
               
               BEGIN
                  UPDATE RESOURCE_ASSIGNMENTS SET
                  TABLE_TYPE = PMO_CNST.SC_TABLE_CRI,
                  ELEMENT_TYPE = h_cri_type,
                  SECURITY_ID = CRI_SECURITY_ID,
                  CRI_SECURITY_ID = NULL,
                  PARTICIPANT = case when h_update_participant = 1 then h_new_participant_bit_value
                  else PARTICIPANT end
                  WHERE RES_ASSIGNMENT_ID = h_res_assignment_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1526+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1527) : wbs_ext.sql(3483) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            END LOOP;
            
            BEGIN
               CLOSE C_RA ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1540+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1541) : wbs_ext.sql(3497) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --trace_printf("\n 2314 FC_DELETE_WBS");//trace_flush();
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
            BEGIN
               UPDATE TASK_ASSIGNMENTS
               SET TABLE_TYPE = PMO_CNST.SC_TABLE_CRI,
               TIMECODE_1_ID = NuLL,
               TIMECODE_2_ID = NuLL
               WHERE TASK_ID IN (SELECT ELEMENT_ID FROM TMT_WBS
               WHERE RANK LIKE h_rank || '%' AND TRANSFER_FLAG = 'C');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1564+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1565) : wbs_ext.sql(3521) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("TA_SC_STATE: %d\n",SC_STATE);
         End If;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         UPDATE TMT_ASSETS
         SET REC_STATUS = 'D'
         WHERE (PARENT_ID, ELEMENT_ID) IN (SELECT ASSET_ID, ELEMENT_ID FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%' AND ASSET_ID IS NOT NuLL
         AND TRANSFER_FLAG IS NuLL);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1589+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1590) : wbs_ext.sql(3546) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_WBS;
      
      LOOP
         FETCH C_WBS
         INTO h_type_id, h_wbs_id, h_cri_count, h_doc_count,
         h_workflow_date, h_current_rank,
         h_transfer_flag, h_a_cri_count, h_cri_parent_id,
         h_sched_start,h_task_actual_start;
         IF C_WBS
         %FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               DELETE FROM CALENDAR_DAY_OF_YEAR
               WHERE ELEMENT_ID = h_wbs_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1626+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1627) : wbs_ext.sql(3583) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         --          if (isNotNull(SC_NULL_INDICATOR(h_transfer_flag))
         --               ((h_delete_all_child == 1) ||
         --              ((isTask(h_type_id))  (isNotNull(SC_NULL_INDICATOR(h_sched_start))))))
         If h_transfer_flag IS NOT NULL Then
            If (Coalesce(h_delete_all_child, 0) = 1) OR ((isTask(Coalesce(h_type_id, 0))) <> 0 
                  AND (h_task_actual_start IS NOT NULL)) Then
               --trace_printf("pp333333---------->h_type_id:%d \n",h_type_id);
               BEGIN
                  DELETE FROM PROJECT_BUDGET_BREAKDOWN
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_wbs_id
                  AND PROCESS_FLAG = 'T';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1654+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1655) : wbs_ext.sql(3611) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE PROJECT_BUDGET_BREAKDOWN
                  SET PROCESS_FLAG = 'D'
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_wbs_id
                  AND PROCESS_FLAG = 'I';
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1675+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1676) : wbs_ext.sql(3632) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM TIMEPHASED_DELTA
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_wbs_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1694+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1695) : wbs_ext.sql(3651) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE TMT_WBS
                  SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_DELETE_TRANSFERRED_TASK_BIT)
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1714+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1715) : wbs_ext.sql(3671) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               --SC_STATE = FC_DELETE_CRI(h_wbs_id, h_cri_parent_id, h_rec_user);
               PMO_DB2M.SC_STATE := FC_DELETE_CRI(h_wbs_id, h_cri_parent_id, h_project_id, h_rec_user);
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 1723+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(1724) : wbs_ext.sql(3680) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_DB2M.SC_STATE;
               End If;
               
               BEGIN
                  UPDATE TMT_TIMECODES
                  SET CHILD_COUNT = CHILD_COUNT - 1
                  WHERE ELEMENT_ID IN
                  (SELECT PARENT_ID
                  FROM TMT_TIMECODES
                  WHERE ELEMENT_ID = h_wbs_id);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1745+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1746) : wbs_ext.sql(3702) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM TMT_TIMECODES
                  WHERE ELEMENT_ID = h_wbs_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1763+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1764) : wbs_ext.sql(3720) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               --trace_printf("pp44444444---------->h_type_id:%d \n",h_type_id);
               BEGIN
                  UPDATE PROJECT_BUDGET_BREAKDOWN
                  SET PROCESS_FLAG =  CASE
                  WHEN PROCESS_FLAG = 'I' THEN 'U'
                  WHEN PROCESS_FLAG = 'T' THEN 'I'
                  ELSE PROCESS_FLAG
                  END
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_wbs_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1788+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1789) : wbs_ext.sql(3745) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  DELETE FROM TIMEPHASED_DELTA
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_wbs_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1807+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1808) : wbs_ext.sql(3764) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               BEGIN
                  UPDATE TMT_WBS
                  SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_DELETE_TRANSFERRED_TASK_BIT)
                  WHERE PROJECT_ID = h_project_id
                  AND ELEMENT_ID = h_project_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1827+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1828) : wbs_ext.sql(3784) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         ElsIf isTask(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               UPDATE PROJECT_BUDGET_BREAKDOWN
               SET PROCESS_FLAG = 'D'
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_wbs_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1848+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1849) : wbs_ext.sql(3805) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WBS
               SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS, PMO_CNST.SC_DELETE_TASK_BIT)
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_project_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1868+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1869) : wbs_ext.sql(3825) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If Coalesce(h_cri_count, 0) > 0 Then
            h_temp_id := NULL;
            PMO_DB2M.SC_STATE := FC_DELETE_CRI(h_temp_id, h_wbs_id, h_project_id, h_rec_user);
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 1879+1) THEN 
                  LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(1880) : wbs_ext.sql(3836) : ' || SYSTIMESTAMP);
               END IF; 
               RETURN PMO_DB2M.SC_STATE;
            End If;
         End If;
         
         If Coalesce(h_a_cri_count, 0) > 0 Then
            OPEN C_A_CRI;
            
            LOOP
               FETCH C_A_CRI INTO h_cri_id, h_cri_parent_id;
               IF C_A_CRI%FOUND THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  EXIT;
               End If;
               
               PMO_DB2M.SC_STATE := FC_DELETE_CRI(h_cri_id, h_cri_parent_id, h_project_id, h_rec_user);
               If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
                  BEGIN
                     CLOSE C_A_CRI ;
                     PMO_DB2M.SC_STATE := SQLCODE;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1909+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1910) : wbs_ext.sql(3866) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 1914+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(1915) : wbs_ext.sql(3871) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN PMO_DB2M.SC_STATE;
               End If;
               
               -- turn on rollup_bits in tmt_cri
               BEGIN
                  UPDATE TMT_CRI
                  SET ROLLUP_BITS = PMO_CNST.SC_SET_ALL_BITS
                  WHERE ELEMENT_ID = h_cri_parent_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1934+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1935) : wbs_ext.sql(3891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            END LOOP;
            
            BEGIN
               CLOSE C_A_CRI ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1948+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1949) : wbs_ext.sql(3905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         h_host_table := PMO_CNST.SC_TABLE_WBS;
         --DELETE all assigned SCORECARDS
         PMO_DB2M.SC_STATE := FC_D_SCD_BY_RANK(h_host_table, h_current_rank, h_rec_user);
         
         --DELETE TMT_cri_ATTRIBUTES
         If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               UPDATE TMT_CHARGECODES
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID IN
               (SELECT PARENT_ID
               FROM TMT_CHARGECODES
               WHERE ELEMENT_ID = h_wbs_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1977+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1978) : wbs_ext.sql(3934) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_CHARGECODES
               WHERE ELEMENT_ID = h_wbs_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 1995+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(1996) : wbs_ext.sql(3952) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --added by paria
         --delete all related attribute
         h_temp_id := NULL;
         PMO_DB2M.SC_STATE := FC_UA_ATR(h_type_id, h_wbs_id, h_temp_id, h_rec_user);
         
         -- delete related workflows
         
         OPEN C_WORKFLOW;
         LOOP
            FETCH C_WORKFLOW INTO h_cur_rank;
            IF C_WORKFLOW%FOUND THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
            If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
               EXIT;
            End If;
            
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_cur_rank, 0);
            BEGIN
               DELETE FROM WORKFLOW_REPLIES
               WHERE ELEMENT_ID IN
               (SELECT ELEMENT_ID FROM TMT_WORKFLOWS WHERE RANK LIKE h_cur_rank || '%');
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2034+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2035) : wbs_ext.sql(3991) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               DELETE FROM TMT_WORKFLOWS
               WHERE RANK LIKE h_cur_rank || '%';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2052+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2053) : wbs_ext.sql(4009) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            BEGIN
               UPDATE TMT_WORKFLOWS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE RANK = '0000';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2071+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2072) : wbs_ext.sql(4028) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         END LOOP;
         BEGIN
            CLOSE C_WORKFLOW ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2084+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2085) : wbs_ext.sql(4041) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         COMMIT;
      END LOOP;
      
      BEGIN
         CLOSE C_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2100+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2101) : wbs_ext.sql(4057) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DOCUMENTS
      If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         BEGIN
            DELETE FROM TMT_DOCUMENTS WHERE PROJECT_ID = h_wbs_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2119+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2120) : wbs_ext.sql(4076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         PMO_DB2M.SC_STATE := FC_MOVE_DOC_UNDER_PROJECT(h_host_table, h_rank, h_project_id, h_rec_user);
      End If;
      
      --BUDGETS REMOVED
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM BUDGETS
         WHERE PROJECT_ID = h_project_id
         AND ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS W
         WHERE RANK LIKE h_rank || '%'
         AND (W.TRANSFER_FLAG IS Null OR h_delete_all_child = 1
         OR
         (W.TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK) AND W.ACTUAL_START IS NOT Null)));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2147+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2148) : wbs_ext.sql(4104) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- remove all the related records in TMT_COSTS
      If isTask(Coalesce(h_type, 0)) <> 0 Then
         BEGIN
            DELETE FROM TMT_COSTS
            WHERE PROJECT_ID = h_project_id AND SUBSTR(RANK , 1, 8) IN
            (SELECT RANK
            FROM TMT_COSTS
            WHERE PROJECT_ID = h_project_id AND  PARENT_ID = h_id);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2170+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2171) : wbs_ext.sql(4127) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf isProjectType(Coalesce(h_type, 0)) <> 0 Then
         BEGIN
            DELETE FROM TMT_COSTS WHERE PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2187+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2188) : wbs_ext.sql(4144) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      --REMOVING DEPENDENCIES
      BEGIN
         DELETE FROM DEPENDENCIES
         WHERE SUCC_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2207+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2208) : wbs_ext.sql(4164) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE DEPENDENCIES
         SET REC_STATUS = 'K'
         WHERE PRED_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2226+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2227) : wbs_ext.sql(4183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      OPEN C_DEPENDENCIES;
      
      LOOP
         FETCH C_DEPENDENCIES INTO h_current_id;
         IF C_DEPENDENCIES%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_xsql := PMO_STPU.packDependencies(h_current_id);
         
         If PMO_ORASTD.strcmp(h_xsql, '{RS}{RF}') = 0 Then
            BEGIN
               UPDATE TMT_WBS SET DEPENDENCIES = Null WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2259+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2260) : wbs_ext.sql(4216) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            UPDATE TMT_WBS SET
                    DEPENDENCIES = NULL
               WHERE ELEMENT_ID = H_CURRENT_ID;

            BEGIN
               UPDATE TMT_WBS SET DEPENDENCIES = h_xsql WHERE ELEMENT_ID = h_current_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2280+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2281) : wbs_ext.sql(4237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_DEPENDENCIES ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2295+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2296) : wbs_ext.sql(4252) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DEPENDENCIES REMOVED
      BEGIN
         DELETE FROM DEPENDENCIES
         WHERE PRED_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2314+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2315) : wbs_ext.sql(4271) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- DELETE HISTORY_WBS
      BEGIN
         DELETE FROM HISTORY_WBS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2333+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2334) : wbs_ext.sql(4290) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS W1
         SET W1.CHILD_COUNT = W1.CHILD_COUNT - (SELECT COUNT(W3.T_PARENT_ID)
         FROM TMT_WBS W3
         WHERE W3.PUBLISHED = '2' AND W3.T_PARENT_ID = W1.ELEMENT_ID AND W3.RANK LIKE h_rank || '%')
         WHERE W1.PUBLISHED = '2' AND W1.ELEMENT_ID IN
         (SELECT DISTINCT W2.T_PARENT_ID
         FROM TMT_WBS W2
         WHERE W2.PUBLISHED = '2' AND W2.T_PARENT_ID IS NOT Null AND W2.RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2357+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2358) : wbs_ext.sql(4314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DELETE WBS_RTF
      BEGIN
         DELETE FROM WBS_RTF
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2376+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2377) : wbs_ext.sql(4333) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DELETE HISTORY_WBS_RTF
      BEGIN
         DELETE FROM HISTORY_WBS_RTF
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%');
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2395+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2396) : wbs_ext.sql(4352) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- ROLLUP TRANSFERRED CRI
      
      OPEN C_TF_CRI;
      
      LOOP
         FETCH C_TF_CRI INTO h_current_id;
         IF C_TF_CRI%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         PMO_DB2M.SC_STATE := FC_UPDATE_TRANSFERRED_CRI(h_current_id);
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               CLOSE C_TF_CRI ;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2425+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2426) : wbs_ext.sql(4382) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 2430+1) THEN 
               LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(2431) : wbs_ext.sql(4387) : ' || SYSTIMESTAMP);
            END IF; 
            RETURN PMO_DB2M.SC_STATE;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_TF_CRI ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2444+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2445) : wbs_ext.sql(4401) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --UPDATE CALENDAR REFERENCES
      
      OPEN C_TCAL;
      
      LOOP
         FETCH C_TCAL INTO h_current_id;
         IF C_TCAL%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         BEGIN
            UPDATE TMT_CALENDARS SET CHILD_COUNT = CHILD_COUNT - 1 WHERE ELEMENT_ID = h_current_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2476+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2477) : wbs_ext.sql(4433) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      END LOOP;
      
      BEGIN
         CLOSE C_TCAL ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2490+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2491) : wbs_ext.sql(4447) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --REMOVE CALENDAR_EXCEPTIONS
      BEGIN
         DELETE FROM CALENDAR_EXCEPTIONS
         WHERE CALENDAR_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2513+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2514) : wbs_ext.sql(4470) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --REMOVE CALENDARS
      BEGIN
         DELETE FROM TMT_CALENDARS
         WHERE ELEMENT_ID IN (
         SELECT ELEMENT_ID
         FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%'
         AND TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) );
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2536+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2537) : wbs_ext.sql(4493) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DELETE TMT_WBS
      BEGIN
         DELETE FROM EFFORT_WEEK WHERE TASK_ID IN
         (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank || '%' AND TYPE_ID IN (PMO_CNST.SC_TASK,PMO_CNST.SC_TASK_TYPE1,PMO_CNST.SC_TASK_TYPE2,PMO_CNST.SC_TASK_TYPE3,PMO_CNST.SC_MILESTONE,PMO_CNST.SC_PERSONAL_TASK,PMO_CNST.SC_ACTIVE_ADM_TASK,PMO_CNST.SC_INACTIVE_ADM_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK,PMO_CNST.SC_WBS_ACTION_ITEM_TASK,PMO_CNST.SC_WBS_RISK_TASK,PMO_CNST.SC_WBS_ISSUE_TASK,PMO_CNST.SC_WBS_REQUIREMENT_TASK,PMO_CNST.SC_WBS_DEFECT_TASK,PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK));
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2555+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2556) : wbs_ext.sql(4512) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --DELETE TMT_WBS
      BEGIN
         DELETE FROM TMT_WBS
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2574+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2575) : wbs_ext.sql(4531) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- delete related records in project_state_def
      BEGIN
         DELETE FROM PROJECT_STATE_DEF
         WHERE PROJECT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2593+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2594) : wbs_ext.sql(4550) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      -- Update Parent's Hierarchy Info
      If (Coalesce(h_level_id, 0) = 0) OR (Coalesce(Length(h_parent_id), 0) = 0) Then
         BEGIN
            UPDATE TMT_WBS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID IS Null;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2614+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2615) : wbs_ext.sql(4571) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         If PMO_ORASTD.strncmp(h_item_rec_status, 'D', 1) <> 0 Then
            BEGIN
               UPDATE TMT_WBS
               SET CHILD_COUNT = CHILD_COUNT - 1
               WHERE ELEMENT_ID = h_parent_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2634+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2635) : wbs_ext.sql(4591) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
      End If;
      
      If (Coalesce(h_level_id, 0) > 0) AND (Coalesce(Length(h_parent_id), 0) <> 0) Then
         BEGIN
            UPDATE TMT_WBS SET ROLLUP_BITS = PMO_CNST.SC_SET_DATES+PMO_CNST.SC_DELETE_BUDGET_BIT
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2655+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2656) : wbs_ext.sql(4612) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --Rollup Dates
         --RollupSubTree(1, 5, h_parent_id, 0, "");      // Rollup Dates
      End If;
      
      -- Fix Timephase table
      -- if project than delete from Timephase  Delta table where project id
      -- if task delete from Delta table and mark Timephase table where task id
      If isProjectType(Coalesce(h_type, 0)) <> 0 Then
         BEGIN
            DELETE FROM TIMEPHASED_DELTA WHERE PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2679+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2680) : wbs_ext.sql(4636) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PROJECT_BUDGET_BREAKDOWN WHERE PROJECT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2696+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2697) : wbs_ext.sql(4653) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            DELETE FROM TIMEPHASED_DELTA WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2713+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2714) : wbs_ext.sql(4670) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE PROJECT_BUDGET_BREAKDOWN SET PROCESS_FLAG = 'D'
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2731+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2732) : wbs_ext.sql(4688) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            UPDATE TMT_WBS SET TIMEPHASED_BITS = PMO_STPU.BIT_OR(TIMEPHASED_BITS,PMO_CNST.SC_DELETE_TASK_BIT)
            WHERE PROJECT_ID = h_project_id AND ELEMENT_ID = h_project_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_DELETE_WBS', 2749+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_DELETE_WBS(2750) : wbs_ext.sql(4706) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   Else
      -- Soft Delete -----------------------------------------------------------------------------------------------------------
      --trace_printf("\n??? delete flag: %s\n", h_status_id); //trace_flush();
      
      If SubStr(h_rec_status, 1, 1) = 'D' Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 2760+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(2761) : wbs_ext.sql(4717) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_CNST.PARENT_MARKED_AS_DELETED;
      Else
         PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_DEL_ACTUAL_EXISTS;
      End If;
      
      /*
              //Execute Update Statement
              BEGIN_SQL
                  VALUES(SC_NOW) INTO HOST(h_current_date) ;
              END_SQL_CHECK;
      
              BEGIN_SQL
                  UPDATE TMT_WBS SET REC_STATUS = HOST(h_status_id), REC_USER = HOST(h_rec_user), REC_DATETIME = HOST(h_current_date)
                  WHERE REC_STATUS IN ('I', 'U') AND RANK LIKE HOST(h_rank) || '%';
              END_SQL_CHECK;
      
              if( SC_SUCCESS)
              {
                  BEGIN_SQL
                      UPDATE RESOURCE_ASSIGNMENTS SET REC_STATUS = HOST(h_status_id), REC_DATETIME = HOST(h_current_date)
                      WHERE REC_STATUS IN ('I', 'U') AND ELEMENT_ID IN
                      (SELECT ELEMENT_ID FROM TMT_WBS WHERE REC_DATETIME = HOST(h_current_date) AND RANK LIKE HOST(h_rank) || '%');
                  END_SQL_CHECK;
      
                  if( (h_level_id == 0) || (strlen(h_parent_id) == 0) )
                  {
                      BEGIN_SQL
                          UPDATE TMT_WBS SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
                          WHERE ELEMENT_ID IS Null;
                      END_SQL_CHECK;
                  }
                  else
                  {
                      BEGIN_SQL
                          UPDATE TMT_WBS SET CHILD_COUNT = CHILD_COUNT - 1, DELETED_COUNT = DELETED_COUNT + 1
                          WHERE ELEMENT_ID = HOST(h_parent_id) ;
                      END_SQL_CHECK;
                  }
              }
              */
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_DELETE_WBS', 2805+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_DELETE_WBS(2806) : wbs_ext.sql(4762) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_DELETE_WBS;
ALTER FUNCTION FC_DELETE_WBS COMPILE DEBUG;

/*######################################################################################*/

/* Create project folder and group folders in tmt_requirements, tmt_cri, ... tables     */

/*######################################################################################*/

Prompt == FUNCTION FC_I_PROJECT_FOLDERS ==
CREATE OR REPLACE FUNCTION FC_I_PROJECT_FOLDERS
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_uniqueID VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
   h_folder_name VARCHAR2(255);
   h_parent_id VARCHAR2(32);
   h_foreign_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_host_table PLS_INTEGER := 0;
   h_foreign_table PLS_INTEGER := 0;
   h_element_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_PROJECT_FOLDERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_PROJECT_FOLDERS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_PROJECT_FOLDERS(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_PROJECT_FOLDERS', 29+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_PROJECT_FOLDERS(30) : wbs_ext.sql(4806) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Create project_folder and group folders in TMT_CRI
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_CRI', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- insert project_folder
   BEGIN
      INSERT INTO TMT_CRI (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CREATED_BY, CHILD_COUNT, MAX_RANK, REC_USER)
      VALUES (h_rankBase64, 'PRJ#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 0, h_project_id,
      Null, h_project_id, h_name, h_rec_user, 2, 2, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(55) : wbs_ext.sql(4831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0001';
   
   -- insert wbs group_folder
   BEGIN
      INSERT INTO TMT_CRI (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CREATED_BY, REC_USER)
      VALUES (h_cur_rank, 'WBS#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'WBS', h_rec_user, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(81) : wbs_ext.sql(4857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- insert another project_folder under wbs group_folder
   h_parent_id := h_uniqueID;
   h_foreign_id := h_project_id;
   h_foreign_table := PMO_CNST.SC_TABLE_WBS;
   h_type_id := PMO_CNST.SC_FOLDER;
   h_host_table := PMO_CNST.SC_TABLE_CRI;
   
   PMO_DB2M.SC_STATE := FC_I_ATTACH_WBS_CRI(h_host_table, h_foreign_table, h_name, h_parent_id
                                         , h_project_id, h_foreign_id, h_type_id, h_rec_user
                                         , h_element_id);
   
   If PMO_DB2M.SC_STATE = 0 Then
      BEGIN
         UPDATE TMT_CRI
         SET STAGE_ID = PMO_CNST.SC_PROJECT
         WHERE ELEMENT_ID = h_element_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 111+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(112) : wbs_ext.sql(4888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      PMO_DB2M.SC_STATE := FC_A_SC_DEFAULT(h_host_table, h_name, h_parent_id, h_element_id, h_type_id
                                     , h_rec_user);
   End If;
   
   --    // insert Requirements folder under the second project_folder
   --    InitializeHost(SC_PARAM(h_folder_name), SC_REQUIREMENT_FOLDER_NAME);
   --    InitializeHost(SC_PARAM(h_parent_id), SC_PARAM(h_element_id));
   --    InitializeHost(SC_PARAM(h_foreign_id), SC_PARAM(h_project_id));
   --    InitializeHost(SC_PARAM(h_foreign_table), SC_TABLE_WBS);
   --    InitializeHost(SC_PARAM(h_type_id), SC_FOLDER);
   --    InitializeHost(SC_PARAM(h_host_table), SC_TABLE_CRI);
   --
   --    SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_folder_name), SC_PARAM(h_parent_id), SC_PARAM(h_project_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   --
   --    if (SC_STATE == 0)
   --    {
   --        BEGIN_SQL
   --            UPDATE TMT_CRI
   --            SET STAGE_ID = SC_CRI_REQUIREMENT
   --            WHERE ELEMENT_ID = HOST(h_element_id);
   --        END_SQL_CHECK;
   --
   --        SC_STATE = FC_A_SC_DEFAULT(SC_PARAM(h_host_table),SC_PARAM(h_folder_name),SC_PARAM(h_parent_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
   --    }
   --
   --    // insert Change Requests folder under the second project_folder
   --    InitializeHost(SC_PARAM(h_folder_name), SC_CHANGE_REQUEST_FOLDER_NAME);
   --
   --    SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_folder_name), SC_PARAM(h_parent_id), SC_PARAM(h_project_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   --
   --    if (SC_STATE == 0)
   --    {
   --        BEGIN_SQL
   --            UPDATE TMT_CRI
   --            SET STAGE_ID = SC_CRI_CHANGE_REQUEST
   --            WHERE ELEMENT_ID = HOST(h_element_id);
   --        END_SQL_CHECK;
   --
   --        SC_STATE = FC_A_SC_DEFAULT(SC_PARAM(h_host_table),SC_PARAM(h_folder_name),SC_PARAM(h_parent_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
   --    }
   --
   --    // insert Service Requests folder under the second project_folder
   --    InitializeHost(SC_PARAM(h_folder_name), SC_SERVICE_REQUEST_FOLDER_NAME);
   --
   --    SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_folder_name), SC_PARAM(h_parent_id), SC_PARAM(h_project_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   --
   --    if (SC_STATE == 0)
   --    {
   --        BEGIN_SQL
   --            UPDATE TMT_CRI
   --            SET STAGE_ID = SC_CRI_SERVICE_REQUEST
   --            WHERE ELEMENT_ID = HOST(h_element_id);
   --        END_SQL_CHECK;
   --
   --        SC_STATE = FC_A_SC_DEFAULT(SC_PARAM(h_host_table),SC_PARAM(h_folder_name),SC_PARAM(h_parent_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
   --    }
   --
   --    // insert Action Items folder under the second project_folder
   --    InitializeHost(SC_PARAM(h_folder_name), SC_ACTION_ITEM_FOLDER_NAME);
   --
   --    SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_folder_name), SC_PARAM(h_parent_id), SC_PARAM(h_project_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   --
   --    if (SC_STATE == 0)
   --    {
   --        BEGIN_SQL
   --            UPDATE TMT_CRI
   --            SET STAGE_ID = SC_CRI_ACTION_ITEM
   --            WHERE ELEMENT_ID = HOST(h_element_id);
   --        END_SQL_CHECK;
   --
   --        SC_STATE = FC_A_SC_DEFAULT(SC_PARAM(h_host_table),SC_PARAM(h_folder_name),SC_PARAM(h_parent_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
   --    }
   --
   --    // insert Defects folder under the second project_folder
   --    InitializeHost(SC_PARAM(h_folder_name), SC_DEFECT_FOLDER_NAME);
   --
   --    SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_folder_name), SC_PARAM(h_parent_id), SC_PARAM(h_project_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   --
   --    if (SC_STATE == 0)
   --    {
   --        BEGIN_SQL
   --            UPDATE TMT_CRI
   --            SET STAGE_ID = SC_CRI_DEFECT
   --            WHERE ELEMENT_ID = HOST(h_element_id);
   --        END_SQL_CHECK;
   --
   --        SC_STATE = FC_A_SC_DEFAULT(SC_PARAM(h_host_table),SC_PARAM(h_folder_name),SC_PARAM(h_parent_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
   --    }
   --
   --    // insert Issues folder under the second project_folder
   --    InitializeHost(SC_PARAM(h_folder_name), SC_ISSUE_FOLDER_NAME);
   --
   --    SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_folder_name), SC_PARAM(h_parent_id), SC_PARAM(h_project_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   --
   --    if (SC_STATE == 0)
   --    {
   --        BEGIN_SQL
   --            UPDATE TMT_CRI
   --            SET STAGE_ID = SC_CRI_ISSUE
   --            WHERE ELEMENT_ID = HOST(h_element_id);
   --        END_SQL_CHECK;
   --
   --        SC_STATE = FC_A_SC_DEFAULT(SC_PARAM(h_host_table),SC_PARAM(h_folder_name),SC_PARAM(h_parent_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
   --    }
   --
   --    // insert Risks folder under the second project_folder
   --    InitializeHost(SC_PARAM(h_folder_name), SC_RISK_FOLDER_NAME);
   --
   --    SC_STATE = FC_I_ATTACH_WBS_CRI(SC_PARAM(h_host_table), SC_PARAM(h_foreign_table), SC_PARAM(h_folder_name), SC_PARAM(h_parent_id), SC_PARAM(h_project_id), SC_PARAM(h_foreign_id), SC_PARAM(h_type_id), SC_PARAM(h_rec_user), SC_PARAM(h_element_id));
   --
   --    if (SC_STATE == 0)
   --    {
   --        BEGIN_SQL
   --            UPDATE TMT_CRI
   --            SET STAGE_ID = SC_CRI_RISK
   --            WHERE ELEMENT_ID = HOST(h_element_id);
   --        END_SQL_CHECK;
   --
   --        SC_STATE = FC_A_SC_DEFAULT(SC_PARAM(h_host_table),SC_PARAM(h_folder_name),SC_PARAM(h_parent_id),SC_PARAM(h_element_id),SC_PARAM(h_type_id),SC_PARAM(h_rec_user));
   --    }
   --
   --    // set all folders under the second project_folder to be private
   --    BEGIN_SQL
   --        UPDATE TMT_CRI
   --        SET PRIVATE = 'Y'
   --        WHERE ELEMENT_ID = HOST(h_parent_id) OR PARENT_ID = HOST(h_parent_id);
   --    END_SQL_CHECK;
   --
   -- set the cri_count of the new project to 1
   BEGIN
      UPDATE TMT_WBS
      SET CRI_COUNT = 1
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 259+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(260) : wbs_ext.sql(5036) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Prepare for inserting REQ group_folder
   /*  getUniqueID(h_uniqueID);
       InitializeHost(SC_PARAM(h_uniqueID), h_uniqueID);
       InitializeHost(SC_PARAM(h_cur_rank), SC_PARAM(h_rankBase64));
       strcat(h_cur_rank, "0002");
   
       // insert req group_folder
       BEGIN_SQL
           INSERT INTO TMT_CRI (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
               PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CREATED_BY, REC_USER)
           VALUES (HOST(h_cur_rank), 'REQ#' || HOST(h_rank), SC_CUSTOM_FOLDER, 1, HOST(h_project_id),
               HOST(h_project_id), HOST(h_uniqueID), 'REQ', HOST(h_rec_user), HOST(h_rec_user));
       END_SQL_CHECK;
   
   */
   -- Create project_folder and group folders in TMT_DOCUMENTS
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_DOCUMENTS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- insert project_folder
   BEGIN
      INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MAX_RANK, REC_USER)
      VALUES (h_rankBase64, 'PRJ#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 0, h_project_id,
      Null, h_project_id, h_name, 2, 2, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 299+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(300) : wbs_ext.sql(5076) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0001';
   
   -- insert wbs group_folder
   BEGIN
      INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
      VALUES (h_cur_rank, 'WBS#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'WBS', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 325+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(326) : wbs_ext.sql(5102) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- insert new folder under wbs group_folder in TMT_DOCUMENTS
   h_parent_id := h_uniqueID;
   h_folder_name := h_name;
   --    strcat(h_folder_name, " Documents");
   h_host_table := PMO_CNST.SC_TABLE_DOC;
   h_type_id := PMO_CNST.SC_FOLDER;
   
   PMO_DB2M.SC_STATE := FC_I_DOC_WBS(h_host_table, h_foreign_table, h_folder_name, h_parent_id
                                  , h_foreign_id, h_type_id, h_rec_user, h_element_id);
   
   -- set the folder to be private
   BEGIN
      UPDATE TMT_DOCUMENTS
      SET STAGE_ID = PMO_CNST.SC_PROJECT
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 355+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(356) : wbs_ext.sql(5132) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --    // set the folder to be private
   --  BEGIN_SQL
   --        UPDATE TMT_DOCUMENTS
   --        SET PRIVATE = 'Y'
   --        WHERE PARENT_ID = HOST(h_parent_id);
   --    END_SQL_CHECK;
   
   /*  // Prepare for inserting REQ group_folder
       getUniqueID(h_uniqueID);
       InitializeHost(SC_PARAM(h_uniqueID), h_uniqueID);
       InitializeHost(SC_PARAM(h_cur_rank), SC_PARAM(h_rankBase64));
       strcat(h_cur_rank, "0002");
   
       // insert req group_folder
       BEGIN_SQL
           INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
               PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
           VALUES (HOST(h_cur_rank), 'REQ#' || HOST(h_rank), SC_CUSTOM_FOLDER, 1, HOST(h_project_id),
               HOST(h_project_id), HOST(h_uniqueID), 'REQ', HOST(h_rec_user));
       END_SQL_CHECK;
   */
   -- Prepare for inserting CRI group_folder
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0003';
   
   -- insert req group_folder
   BEGIN
      INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
      VALUES (h_cur_rank, 'CRI#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'CRI', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 403+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(404) : wbs_ext.sql(5180) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Create project_folder and group folders in TMT_ASSIGNED_SCORECARDS
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_ASSIGNED_SCORECARDS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- insert project_folder
   BEGIN
      INSERT INTO TMT_ASSIGNED_SCORECARDS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MAX_RANK, CREATED_BY, REC_USER)
      VALUES (h_rankBase64, 'PRJ#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 0, h_project_id,
      Null, h_project_id, h_name, 3, 3, h_rec_user, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 428+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(429) : wbs_ext.sql(5205) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0001';
   
   -- insert wbs group_folder
   BEGIN
      INSERT INTO TMT_ASSIGNED_SCORECARDS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CREATED_BY, REC_USER)
      VALUES (h_cur_rank, 'WBS#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'WBS', h_rec_user, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 454+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(455) : wbs_ext.sql(5231) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Prepare for inserting CRI group_folder
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0002';
   
   -- insert cri group_folder
   BEGIN
      INSERT INTO TMT_ASSIGNED_SCORECARDS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CREATED_BY, REC_USER)
      VALUES (h_cur_rank, 'CRI#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'CRI', h_rec_user, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 481+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(482) : wbs_ext.sql(5258) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Prepare for inserting default group_folder
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0003';
   
   -- insert default group_folder
   BEGIN
      INSERT INTO TMT_ASSIGNED_SCORECARDS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CREATED_BY, REC_USER)
      VALUES (h_cur_rank, 'DEF#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'DEF_SCD', h_rec_user, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 508+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(509) : wbs_ext.sql(5285) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Create project_folder and group folders in TMT_PUBLISHED_SCORECARDS
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_PUBLISHED_SCORECARDS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- insert project_folder
   BEGIN
      INSERT INTO TMT_PUBLISHED_SCORECARDS  (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MAX_RANK, REC_USER)
      VALUES (h_rankBase64, 'PRJ#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 0, h_project_id,
      Null, h_project_id, h_name, 2, 2, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 533+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(534) : wbs_ext.sql(5310) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Prepare for inserting WBS group_folder
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0001';
   
   -- insert WBS group_folder
   BEGIN
      INSERT INTO TMT_PUBLISHED_SCORECARDS  (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
      VALUES (h_cur_rank, 'WBS#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'WBS', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 560+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(561) : wbs_ext.sql(5337) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Prepare for inserting CRI group_folder
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0002';
   
   -- insert CRI group_folder
   BEGIN
      INSERT INTO TMT_PUBLISHED_SCORECARDS  (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
      VALUES (h_cur_rank, 'CRI#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'CRI', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 587+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(588) : wbs_ext.sql(5364) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PROJECT_DETAILS
      (PROJECT_ID, ASSIGNMENT_BILLABLE_FLAG)
      VALUES(h_project_id, COALESCE((SELECT SETTING_VALUE FROM TMT_SETTINGS WHERE ELEMENT_ID = 'ASSIGNMENT_BILLABLE_FLAG'),1));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PROJECT_FOLDERS', 606+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PROJECT_FOLDERS(607) : wbs_ext.sql(5383) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_PROJECT_FOLDERS', 612+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_PROJECT_FOLDERS(613) : wbs_ext.sql(5389) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_PROJECT_FOLDERS', 617+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_PROJECT_FOLDERS(618) : wbs_ext.sql(5394) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_PROJECT_FOLDERS;
ALTER FUNCTION FC_I_PROJECT_FOLDERS COMPILE DEBUG;

/*######################################################################################*/

/* Create folder and group folders for links created in templates view                  */

/*######################################################################################*/

Prompt == FUNCTION FC_I_LINK_FOLDERS ==
CREATE OR REPLACE FUNCTION FC_I_LINK_FOLDERS
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_rank IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_max_rank PLS_INTEGER := 0;
   h_rankBase64 VARCHAR2(8);
   h_uniqueID VARCHAR2(32);
   h_cur_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_LINK_FOLDERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_LINK_FOLDERS'), '-- ' || SYSTIMESTAMP, ':r := FC_I_LINK_FOLDERS(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_rank || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_LINK_FOLDERS', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_LINK_FOLDERS(23) : wbs_ext.sql(5431) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Create project_folder and group folders in TMT_DOCUMENTS
   PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_DOCUMENTS', h_max_rank);
   PMO_STPU.toBase64Long(Coalesce(h_max_rank, 0), h_rankBase64);
   
   -- insert project_folder
   BEGIN
      INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, CHILD_COUNT, MAX_RANK, REC_USER)
      VALUES (h_rankBase64, 'PRJ#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 0, h_project_id,
      Null, h_project_id, h_name, 3, 3, h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_LINK_FOLDERS', 47+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_LINK_FOLDERS(48) : wbs_ext.sql(5456) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0001';
   
   -- insert wbs group_folder
   BEGIN
      INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
      VALUES (h_cur_rank, 'WBS#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'WBS', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_LINK_FOLDERS', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_LINK_FOLDERS(74) : wbs_ext.sql(5482) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Prepare for inserting REQ group_folder
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0002';
   
   -- insert req group_folder
   BEGIN
      INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
      VALUES (h_cur_rank, 'REQ#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'REQ', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_LINK_FOLDERS', 100+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_LINK_FOLDERS(101) : wbs_ext.sql(5509) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   -- Prepare for inserting CRI group_folder
   h_uniqueID := SYS_GUID();
   h_uniqueID := h_uniqueID;
   h_cur_rank := h_rankBase64;
   h_cur_rank := h_cur_rank || '0003';
   
   -- insert req group_folder
   BEGIN
      INSERT INTO TMT_DOCUMENTS (RANK, PARENT_RANK, TYPE_ID, LEVEL_ID, PROJECT_ID,
      PARENT_ID, ELEMENT_ID, ELEMENT_NAME, REC_USER)
      VALUES (h_cur_rank, 'CRI#' || h_rank, PMO_CNST.SC_CUSTOM_FOLDER, 1, h_project_id,
      h_project_id, h_uniqueID, 'CRI', h_rec_user);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_LINK_FOLDERS', 127+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_LINK_FOLDERS(128) : wbs_ext.sql(5536) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_LINK_FOLDERS', 133+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_LINK_FOLDERS(134) : wbs_ext.sql(5542) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_LINK_FOLDERS', 138+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_LINK_FOLDERS(139) : wbs_ext.sql(5547) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_LINK_FOLDERS;
ALTER FUNCTION FC_I_LINK_FOLDERS COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION FC_I_WBS_MSP ==
CREATE OR REPLACE FUNCTION FC_I_WBS_MSP
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_ieflag PLS_INTEGER
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_ieflag PLS_INTEGER := sh_h_ieflag;
   h_F TIMESTAMP;
   h_S TIMESTAMP;
   h_fs_code VARCHAR2(50);
   h_fs_labor_code VARCHAR2(50);
   h_full_name VARCHAR2(99);
   h_project_id VARCHAR2(32);
   h_published VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_rec_status VARCHAR2(1);
   h_security_id VARCHAR2(32);
   h_transfer_flag VARCHAR2(1);
   h_uniqueID2 VARCHAR2(32);
   h_uniqueID3 VARCHAR2(32);
   h_uniqueID4 VARCHAR2(32);
   h_transfer_security_id VARCHAR2(32);
   h_wbs_code VARCHAR2(255);
   h_wbs_code2 VARCHAR2(255);
   h_timecode_1_id VARCHAR2(32);
   h_timecode_2_id VARCHAR2(32);
   h_fsflag PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_max_rank PLS_INTEGER := 0;
   h_type PLS_INTEGER := 0;
   h_fs_flag PLS_INTEGER := 0;
   h_min_per_day PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
   h_stage_id PLS_INTEGER := 0;
   h_group_type PLS_INTEGER := 0;
   h_effort_driven PLS_INTEGER := 0;
   h_task_type PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_res_type VARCHAR2(1);
   h_tmp_flag PLS_INTEGER := 0;
   h_asset_flag PLS_INTEGER := 0;
   h_financial_category PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_WBS_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_WBS_MSP'), '-- ' || SYSTIMESTAMP, ':r := FC_I_WBS_MSP(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_ieflag), 'NULL')
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_WBS_MSP', 61+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_WBS_MSP(62) : wbs_ext.sql(5619) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   h_res_type := '0';
   
   h_uniqueID := SYS_GUID();
   
   BEGIN
      SELECT NICK_NAME || ';'
      INTO h_full_name
      FROM RESOURCES WHERE RESOURCE_ID = h_rec_user;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 80+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(81) : wbs_ext.sql(5638) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_temp_sc_state := groupType(Coalesce(h_type_id, 0), h_group_type);
   
   If Coalesce(h_group_type, 0) = PMO_CNST.SC_PROJECT Then
      h_stage_id := 740;
   ElsIf Coalesce(h_group_type, 0) = PMO_CNST.SC_DELIVERABLE Then
      h_stage_id := 5470;
   ElsIf Coalesce(h_group_type, 0) = PMO_CNST.SC_TASK Then
      h_stage_id := 5500;
   Else
      h_stage_id := 740;
   End If;
   
   --trace_printf("\n1");
   --trace_printf("\nh_uniqueID: %d, %s", h_uniqueID_Ind, h_uniqueID);
   --trace_printf("\nh_type_id: %d, %d", h_type_id_Ind, h_type_id);
   --trace_printf("\nh_rec_user: %d, %s", h_rec_user_Ind, h_rec_user);
   --trace_printf("\nh_full_name: %d, %s", h_full_name_Ind, h_full_name);
   --trace_printf("\n"); //trace_flush();
   
   If h_parent_id IS NULL Then
      PMODEFINES.PMO_GET_ROOT_MAX_RANK('TMT_WBS', h_max_rank);
      h_wbs_code2 := TO_CHAR(Coalesce(h_max_rank, 0));
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      BEGIN
         SELECT  LEVEL_ID + 1,
         RTRIM(p.RANK) || h_rankBase64,
         RTRIM(p.WBS_CODE) || '.' || h_wbs_code2,
         CASE WHEN h_type_id IN (175,PMO_CNST.SC_TEMPLATE_LINKS,210,211) THEN 'U' ELSE 'O' END
         INTO    h_level_id,
         h_rank,
         h_wbs_code,
         h_rec_status
         FROM TMT_WBS p WHERE p.ELEMENT_ID IS Null;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 125+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(126) : wbs_ext.sql(5683) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      h_project_id := h_uniqueID;
      
      --trace_printf("\nparent_id is null...");
      --trace_printf("\nh_project_id: %d, %s", h_project_id_Ind, h_project_id);
      --trace_printf("\nh_uniqueID: %d, %s", h_uniqueID_Ind, h_uniqueID);
      --trace_printf("\nh_type_id: %d, %d", h_type_id_Ind, h_type_id);
      --trace_printf("\nh_level_id: %d, %d", h_level_id_Ind, h_level_id);
      --trace_printf("\nh_rec_user: %d, %s", h_rec_user_Ind, h_rec_user);
      --trace_printf("\nh_rank: %d, %s", h_rank_Ind, h_rank);
      --trace_printf("\nh_wbs_code: %d, %s", h_wbs_code_Ind, h_wbs_code);
      --trace_printf("\nh_rec_status: %d, %s", h_rec_status_Ind, h_rec_status);
      --trace_printf("\n"); //trace_flush();
      
      BEGIN
         INSERT INTO TMT_WBS(
         PROJECT_ID, ELEMENT_ID, ELEMENT_NAME,
         TYPE_ID, LEVEL_ID,
         CREATED_BY, REC_USER, REC_DATETIME,
         RANK, WBS_CODE, PROBABILITY, REC_STATUS,
         ASSIGN_NAMES, FS_STATE, EFFORT_DRIVEN,STAGE_ID )
         VALUES(
         h_project_id, h_uniqueID, h_name,
         h_type_id, h_level_id,
         h_rec_user, h_rec_user, SYSTIMESTAMP,
         h_rank, h_wbs_code, 100, h_rec_status,
         h_full_name, 0, 0 ,h_stage_id);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 166+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(167) : wbs_ext.sql(5724) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_I_WBS_MSP', 172+1) THEN 
         LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_I_WBS_MSP(173) : wbs_ext.sql(5730) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_parent_id || '''');
      END IF; 
      PMODEFINES.PMO_VALIDATE_RECORD('TMT_WBS', h_parent_id, h_rec_status);
      
      If Coalesce(h_ieflag, 0) = 0 Then
         If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_WBS_MSP', 179+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_WBS_MSP(180) : wbs_ext.sql(5737) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD, h_parent_id);
         End If;
      End If;
      
      BEGIN
         SELECT  CASE WHEN TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN ELEMENT_ID ELSE PROJECT_ID END,
         TYPE_ID,
         PUBLISHED,
         TRANSFER_FLAG,
         CASE WHEN TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) AND (FS_CODE IS NOT Null OR LENGTH(FS_CODE) > 1) THEN 1 ELSE 0 END,
         TIMECODE_1_ID,
         TIMECODE_2_ID,
         ASSET_FLAG,
         FINANCIAL_CATEGORY
         INTO h_project_id,
         h_type,
         h_published,
         h_transfer_flag,
         h_fsflag,
         h_timecode_1_id,
         h_timecode_2_id,
         h_asset_flag,
         h_financial_category
         FROM TMT_WBS WHERE ELEMENT_ID = h_parent_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 211+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(212) : wbs_ext.sql(5769) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_asset_flag, 0) <> PMO_CNST.SC_WITHOUT_ASSET Then
         h_asset_flag := PMO_CNST.SC_PARENT_HAS_ASSET;
      End If;
      
      --trace_printf("\nparent_id is not null...");
      --trace_printf("\nh_project_id: %d, %s", h_project_id_Ind, h_project_id);
      --trace_printf("\nh_uniqueID: %d, %s", h_uniqueID_Ind, h_uniqueID);
      --trace_printf("\nh_type: %d, %d", h_type_Ind, h_type);
      --trace_printf("\nh_published: %d, %s", h_published_Ind, h_published);
      --trace_printf("\nh_transfer_flag: %d, %s", h_transfer_flag_Ind, h_transfer_flag);
      --trace_printf("\nh_fsflag: %d, %d", h_fsflag_Ind, h_fsflag);
      --trace_printf("\n"); //trace_flush();
      
      If (Coalesce(h_type, 0) = PMO_CNST.SC_TASK) OR (Coalesce(h_type, 0) = PMO_CNST.SC_MILESTONE) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_WBS_MSP', 231+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_WBS_MSP(232) : wbs_ext.sql(5789) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.INVALID_PARENT), 'NULL') || ' ID: ' || '''' || h_parent_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.INVALID_PARENT, h_parent_id);
      End If;
      /*
              if((isProjectType(h_type))  (checkFlagStatus(h_published,'2'))  (isProjectType(h_type_id)))
              {
                  RETURN_ERROR(MARKED_AS_UNAVAILABLE, h_parent_id);
              }
      */
      PMODEFINES.PMO_GET_MAX_RANK('TMT_WBS', h_parent_id, h_max_rank);
      h_wbs_code2 := TO_CHAR(Coalesce(h_max_rank, 0));
      PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
      
      If Coalesce(h_type, 0) <> PMO_CNST.SC_RESOURCE Then
         If isTask(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               SELECT
               PMO_ORASTD.DB2TIMESTAMP(CASE WHEN START_FINISH_DATE > TO_DATE(SYSDATE) THEN START_FINISH_DATE ELSE TO_DATE(SYSDATE) END, COALESCE(PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)), '08:00:00')),
               COALESCE(TW.MINUTE_PER_DAY, 480), EFFORT_DRIVEN, TASK_TYPE
               INTO h_S, h_min_per_day, h_effort_driven, h_task_type
               FROM TMT_WBS TW
               LEFT JOIN CALENDAR_DAY_OF_YEAR CDY
               ON CDY.ELEMENT_ID = TW.PROJECT_ID
               AND CDY.DAY_YEAR = TW.START_FINISH_DATE
               WHERE TW.PROJECT_ID = h_project_id
               AND TW.ELEMENT_ID = h_project_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 264+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(265) : wbs_ext.sql(5822) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT
               PMO_ORASTD.DB2TIMESTAMP(COALESCE(TW.START_FINISH_DATE, TO_DATE(SubStr(SYSTIMESTAMP, 1, 10))), COALESCE(PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED)), '08:00:00')),
               COALESCE(TW.MINUTE_PER_DAY, 480), EFFORT_DRIVEN, TASK_TYPE
               INTO h_S, h_min_per_day, h_effort_driven, h_task_type
               FROM TMT_WBS TW
               LEFT JOIN CALENDAR_DAY_OF_YEAR CDY
               ON CDY.ELEMENT_ID = TW.PROJECT_ID
               AND CDY.DAY_YEAR = TW.START_FINISH_DATE
               WHERE TW.PROJECT_ID = h_project_id
               AND TW.ELEMENT_ID = h_project_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 286+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(287) : wbs_ext.sql(5844) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         --trace_printf("\n=== SC_STATE: %d, h_S: %d %s, h_effort_driven: %d\n", SC_STATE,h_S_Ind,h_S,h_effort_driven);
      End If;
      
      --trace_printf("\n=== SC_STATE: %d", SC_STATE);
      --trace_printf("\nh_F: %d, %s", h_F_Ind, h_F);
      --trace_printf("\nh_min_per_day: %d, %d", h_min_per_day_Ind, h_min_per_day);
      --trace_printf("\n"); //trace_flush();
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            SELECT
            LEVEL_ID + 1,
            RTRIM(p.Rank) || h_rankBase64,
            RTRIM(p.WBS_CODE) || '.' || h_wbs_code2,
            CASE WHEN h_fsflag = 1 THEN RTRIM(p.FS_CODE) || '.' || h_rankBase64 ELSE Null END,
            CASE WHEN h_fsflag = 1 THEN RTRIM(p.FS_LABOR_CODE) ELSE Null END
            INTO
            h_level_id,
            h_rank,
            h_wbs_code,
            h_fs_code,
            h_fs_labor_code
            FROM TMT_WBS p
            WHERE p.ELEMENT_ID = h_parent_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 321+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(322) : wbs_ext.sql(5879) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            SELECT CASE WHEN LENGTH(FS_CODE) > 0 THEN 1 ELSE 0 END
            INTO h_fs_flag
            FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 336+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(337) : wbs_ext.sql(5894) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\nh_level_id: %d, %d", h_level_id_Ind, h_level_id);
         --trace_printf("\nh_rank: %d, %s", h_rank_Ind, h_rank);
         --trace_printf("\nh_wbs_code: %d, %s", h_wbs_code_Ind, h_wbs_code);
         --trace_printf("\nh_fs_code: %d, %s", h_fs_code_Ind, h_fs_code);
         --trace_printf("\nh_fs_labor_code: %d, %s", h_fs_labor_code_Ind, h_fs_labor_code);
         --trace_printf("\n"); //trace_flush();
         
         --created at wbs but the transfer_flag of its parent is not null.
         If PMO_CNST.SC_MAINTAIN_TRANSFERRED_CRI_TR = 1 Then
            If h_transfer_flag IS NOT NULL Then
               If SubStr(h_transfer_flag, 1, 1) = 'C' OR SubStr(h_transfer_flag, 1, 1) = 'W' Then
                  h_transfer_flag := 'W';
               ElsIf SubStr(h_transfer_flag, 1, 1) = 'R' Then
                  h_transfer_flag := 'U';
               Else
                  h_transfer_flag := NULL;
               End If;
            End If;
         Else
            h_transfer_flag := NULL;
         End If;
         
         If Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1 OR Coalesce(
               h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER2 Then
            BEGIN
               INSERT INTO TMT_WBS (
               PROJECT_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               TYPE_ID, LEVEL_ID,
               CREATED_BY, REC_USER, REC_DATETIME,
               RANK, WBS_CODE )
               VALUES(
               h_uniqueID, h_parent_id, h_uniqueID, h_name,
               h_type_id, h_level_id,
               h_rec_user, h_rec_user, SYSTIMESTAMP,
               h_rank, h_wbs_code );
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 386+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(387) : wbs_ext.sql(5944) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         ElsIf isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
            h_project_id := h_uniqueID;
            
            BEGIN
               INSERT INTO TMT_WBS(
               PROJECT_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               TYPE_ID, LEVEL_ID,
               CREATED_BY, REC_USER, REC_DATETIME,
               RANK, WBS_CODE, PROBABILITY, ASSIGN_NAMES, MINUTE_PER_DAY,
               FS_STATE, FS_CODE, FS_LABOR_CODE, EFFORT_DRIVEN,STAGE_ID )
               VALUES(
               h_project_id, h_parent_id, h_uniqueID, h_name,
               h_type_id, h_level_id,
               h_rec_user, h_rec_user, SYSTIMESTAMP,
               h_rank, h_wbs_code, 100, h_full_name, h_min_per_day,
               0, h_fs_code, h_fs_labor_code, 0, h_stage_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 416+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(417) : wbs_ext.sql(5974) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            --Update the dates to trigger the roll-up
            BEGIN
               UPDATE TMT_WBS SET
               PLANNED_START = h_S,
               PLANNED_DURATION = h_min_per_day
               WHERE PROJECT_ID = h_uniqueID
               AND ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 438+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(439) : wbs_ext.sql(5996) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_fsflag, 0) = 1 Then
               h_temp_var := h_type_id;
               PMO_DB2M.SC_STATE := FC_C_WBS_TC(h_uniqueID, h_parent_id, h_temp_var);
            End If;
         ElsIf Coalesce(h_type, 0) = PMO_CNST.SC_RESOURCE Then
            BEGIN
               INSERT INTO TMT_WBS(
               PROJECT_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
               TYPE_ID, LEVEL_ID,
               CREATED_BY, REC_USER, REC_DATETIME, REC_STATUS,
               RANK, WBS_CODE, PROBABILITY, ASSIGN_NAMES,
               TRANSFER_FLAG, MINUTE_PER_DAY, FS_STATE, EFFORT_DRIVEN,STAGE_ID,TIMECODE_1_ID,TIMECODE_2_ID )
               VALUES(
               h_project_id, h_parent_id, h_uniqueID, h_name,
               h_type_id, h_level_id,
               h_rec_user, h_rec_user, SYSTIMESTAMP, 'U',
               h_rank, h_wbs_code, 100, h_full_name,
               h_transfer_flag, h_min_per_day, 0, 0 ,h_stage_id,h_timecode_1_id,h_timecode_2_id);
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 471+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(472) : wbs_ext.sql(6029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            If (isTask(Coalesce(h_type_id, 0))) <> 0 AND (Coalesce(h_effort_driven, 0) = 0) Then
               BEGIN
                  INSERT INTO TMT_WBS(PROJECT_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME,
                  TYPE_ID, LEVEL_ID,CREATED_BY, REC_USER, REC_DATETIME,
                  RANK, WBS_CODE, PROBABILITY, ASSIGN_NAMES, TASK_TYPE,
                  ASSET_FLAG, FINANCIAL_CATEGORY,
                  TRANSFER_FLAG, MINUTE_PER_DAY, FS_STATE, EFFORT_DRIVEN,STAGE_ID,TIMECODE_1_ID,TIMECODE_2_ID )
                  VALUES(h_project_id, h_parent_id, h_uniqueID, h_name,
                  h_type_id, h_level_id,h_rec_user, h_rec_user, SYSTIMESTAMP,
                  h_rank, h_wbs_code, 100, h_full_name, h_task_type,
                  h_asset_flag, h_financial_category,
                  h_transfer_flag, h_min_per_day, 0, h_effort_driven, h_stage_id,h_timecode_1_id,h_timecode_2_id);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 498+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(499) : wbs_ext.sql(6056) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               BEGIN
                  INSERT INTO TMT_WBS(
                  PROJECT_ID, PARENT_ID, ELEMENT_ID, ELEMENT_NAME, TYPE_ID, LEVEL_ID,
                  CREATED_BY, REC_USER, REC_DATETIME,RANK, WBS_CODE, PROBABILITY, ASSIGN_NAMES,
                  ASSET_FLAG, FINANCIAL_CATEGORY,
                  TRANSFER_FLAG, MINUTE_PER_DAY, FS_STATE, EFFORT_DRIVEN,STAGE_ID,TIMECODE_1_ID,TIMECODE_2_ID )
                  VALUES(
                  h_project_id, h_parent_id, h_uniqueID, h_name,h_type_id, h_level_id,
                  h_rec_user, h_rec_user, SYSTIMESTAMP,h_rank, h_wbs_code, 100, h_full_name,
                  h_asset_flag, h_financial_category,
                  h_transfer_flag, h_min_per_day, 0, h_effort_driven, h_stage_id,h_timecode_1_id,h_timecode_2_id);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 524+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(525) : wbs_ext.sql(6082) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
            
            --Update the dates to trigger the roll-up
            BEGIN
               UPDATE TMT_WBS
               SET PLANNED_START = h_S,
               PLANNED_DURATION = CASE WHEN h_type_id = PMO_CNST.SC_MILESTONE THEN 0 ELSE h_min_per_day END
               WHERE PROJECT_ID = h_project_id
               AND ELEMENT_ID = h_uniqueID;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 547+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(548) : wbs_ext.sql(6105) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            --trace_printf("UPDATE TMT_WBS: SC_STATE: %d, h_S: %d %s\n",SC_STATE,h_S_Ind,h_S);
            
            If ((Coalesce(h_type_id, 0) = PMO_CNST.SC_TASK) OR (Coalesce(
                  h_type_id, 0) = PMO_CNST.SC_MILESTONE)) AND (h_fs_flag IS NOT NULL AND (Coalesce(
                  h_fs_flag, 0) = 1)) Then
               PMO_DB2M.SC_STATE := FC_A_WBS_TC(h_uniqueID, h_rank, h_type_id);
            End If;
            
            If (PMO_CNST.SC_MAINTAIN_TRANSFERRED_CRI_TR = 1) AND (h_transfer_flag IS NOT NULL) Then
               If SubStr(h_transfer_flag, 1, 1) = 'W' Then
                  h_tmp_flag := 0;
                  PMO_DB2M.SC_STATE := FC_INSERT_CRI_AFTER_WBS(h_parent_id, h_uniqueID, h_rec_user, h_tmp_flag);
               End If;
            End If;
         End If;
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If (Coalesce(h_type_id, 0) = 210) OR (Coalesce(h_type_id, 0) = 211) OR (Coalesce(
             h_type_id, 0) = 175) OR (Coalesce(h_type_id, 0) = PMO_CNST.SC_TEMPLATE_LINKS) Then
         BEGIN
            UPDATE TMT_WBS SET
            T_RANK = RANK,
            PUBLISHED = '2',
            T_PARENT_ID = PARENT_ID,
            REC_STATUS = 'U'
            WHERE ELEMENT_ID = h_uniqueID;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 589+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(590) : wbs_ext.sql(6147) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf (Coalesce(h_ieflag, 0) = 0) AND (Coalesce(h_type, 0) <> PMO_CNST.SC_RESOURCE) AND (Coalesce(
                h_type_id, 0) <> PMO_CNST.SC_ACTIVE_ADM_TASK) AND (isNotProjectType(Coalesce(
                h_type_id, 0))) <> 0 Then
         --trace_printf("ROLLUP_IN\n");
         --trace_printf("h_type_id: %d (%d)\n", h_type_id, h_type_id_Ind);
         --trace_flush();
         -- New Rollup
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
      End If;
      
      If NOT ((Coalesce(h_type_id, 0) = 210) OR (Coalesce(h_type_id, 0) = 211) OR (Coalesce(
                  h_type_id, 0) = 175)) Then
         BEGIN
            SELECT ( CASE
            WHEN h_type_id IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN PMO_CNST.SC_MANAGER
            WHEN h_type_id IN (PMO_CNST.SC_TEMPLATE_LINKS) THEN PMO_CNST.SC_DOCUMENT_RESPONSIBLE
            WHEN h_type_id IN (PMO_CNST.SC_TASK, PMO_CNST.SC_MILESTONE) THEN PMO_CNST.SC_TASK_RESPONSIBLE
            WHEN h_type_id IN (PMO_CNST.SC_PERSONAL_TASK, PMO_CNST.SC_ACTIVE_ADM_TASK) THEN PMO_CNST.SC_TASK_RESPONSIBLE+PMO_CNST.SC_TEAMMEMBER
            ELSE PMO_CNST.SC_DLV_MANAGER
            END )  INTO  h_participant FROM DUAL;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 619+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(620) : wbs_ext.sql(6177) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_security_id := '';
         h_temp_sc_state := GetSecurityID(PMO_CNST.SC_TABLE_WBS, Coalesce(h_type_id, 0)
                                 , PMO_CNST.SC_RESPONSIBLE_GROUP, h_security_id);
         
         If (PMO_CNST.SC_MAINTAIN_TRANSFERRED_CRI_TR = 1) AND (SubStr(h_transfer_flag, 1, 1) = 'W') Then
            h_transfer_security_id := h_security_id;
         Else
            h_transfer_security_id := NULL;
         End If;
         
         h_temp_var := 1;
         PMO_DB2M.SC_STATE := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_rec_user, h_type_id, h_participant
                                            , h_security_id, h_res_type, h_temp_var);
         
         --trace_printf("\n2");
         --trace_printf("\nh_project_id: %d, %s", h_project_id_Ind, h_project_id);
         --trace_printf("\nh_uniqueID: %d, %s", h_uniqueID_Ind, h_uniqueID);
         --trace_printf("\nh_type_id: %d, %d", h_type_id_Ind, h_type_id);
         --trace_printf("\nh_rec_user: %d, %s", h_rec_user_Ind, h_rec_user);
         --trace_printf("\nh_participant: %d, %d", h_participant_Ind, h_participant);
         --trace_printf("\nh_security_id: %d, %s", h_security_id_Ind, h_security_id);
         --trace_printf("\n"); //trace_flush();
         h_uniqueID4 := SYS_GUID();
         BEGIN
            INSERT INTO RESOURCE_ASSIGNMENTS(
            RES_ASSIGNMENT_ID,
            PROJECT_ID,
            ELEMENT_ID,
            ELEMENT_TYPE,
            RESOURCE_ID,
            PARTICIPANT,
            SECURITY_ID,
            CRI_SECURITY_ID,
            REC_USER,TABLE_TYPE)
            VALUES(
            h_uniqueID4,
            h_project_id,
            h_uniqueID,
            h_type_id,
            h_rec_user,
            h_participant,
            h_security_id,
            h_transfer_security_id,
            h_rec_user,PMO_CNST.SC_TABLE_WBS );
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 678+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(679) : wbs_ext.sql(6236) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      h_uniqueID2 := SYS_GUID();
      
      BEGIN
         INSERT INTO HISTORY_WBS (
         HISTORY_ID,
         ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,
         BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,
         CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,
         DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,
         EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,
         EXPECTED_COST, EXPECTED_MARGIN, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH,
         ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,
         FD, FINISH_DT, FORECAST_BUDGET, FORECAST_CLOSED, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,
         LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,
         MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,
         OPPORTUNITY_NAME,
         PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY, PURSUIT_FINISH, PURSUIT_START,
         RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,
         SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,
         TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,
         UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,
         VARIANCE,
         WBS_CODE, WORK_TODATE,
         ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,
         ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,
         ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,
         R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3
         )
         SELECT
         h_uniqueID2,
         ACTUAL_BUDGET, ACTUAL_DURATION, ACTUAL_EFFORT, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, ASSIGN_COUNT, ASSIGN_NAMES, A_CRI_COUNT,
         BAC, BASELINE1_BUDGET, BASELINE1_EST_DT, BASELINE1_SCH_DT, BASELINE1_DURATION, BASELINE1_EFFORT, BASELINE1_FINISH, BASELINE1_START, BASELINE1_VARIANCE, BASELINE2_BUDGET, BASELINE2_EST_DT, BASELINE2_SCH_DT, BASELINE2_DURATION, BASELINE2_EFFORT, BASELINE2_FINISH, BASELINE2_START, BASELINE3_BUDGET, BASELINE3_EST_DT, BASELINE3_DURATION, BASELINE3_EFFORT, BASELINE3_FINISH, BASELINE3_START, BASELINE_WORK_TODATE, BCWP, BCWS, BUBBLE_COLOR, BUBBLE_PUBLISHED_DT, BUFFER_PERCENT,
         CALENDAR_ID, CHILD_COUNT, CLOSED_BY, CONSTRAINT_DT, CONSTRAINT_TYPE, CREATED_BY, CREATED_DT, CRITICAL, CRI_COUNT, CURRENCY_ID, CURRENT_BUDGET,
         DELETED_COUNT, DEPENDENCIES, DOC_COUNT, DURATION,
         EAC, EV_ETC, EAC_FORECAST, EV_ETC_FORECAST, EFFORT_DRIVEN, ELEMENT_ID, ELEMENT_NAME,
         EXPECTED_COST, EXPECTED_MARGIN, EXPECTED_REVENUE, EXPECTED_PAYBACK_PERIOD, EXPECTED_PAYBACK_MONTH,
         ESTIMATION_BUDGET, ESTIMATION_TOTAL, ETC, EV_FLAG,
         FD, FINISH_DT, FORECAST_BUDGET, FORECAST_CLOSED, FORECAST_DURATION, FORECAST_EFFORT, FORECAST_FINISH, FORECAST_START, FORECAST_VARIANCE, FREE_SLACK, FS_CODE, FS_LABOR_CODE, FS_STATE,
         LAST_CHECKIN, LAST_WF_BY, LAST_WF_DT, LAST_WF_TYPE, LEVEL_ID,
         MAJOR_REVISION, MAX_RANK, METHOD, MILESTONE_PERCENT, MINOR_REVISION, MINUTE_PER_DAY, MINUTE_PER_WEEK, MSP_ID,
         OPPORTUNITY_NAME,
         PARENT_ID, PLANNED_DURATION, PLANNED_EFFORT, PLANNED_FINISH, PLANNED_START, PRIORITY, PROBABILITY, PROJECT_ID, PROPOSED_DURATION, PROPOSED_EFFORT, PROPOSED_FINISH, PROPOSED_START, PUBLISHED, PUBLISHED_BY, PURSUIT_FINISH, PURSUIT_START,
         RANK, REC_DATETIME, REC_FLAGS, REC_STATUS, REC_USER, REF_CODE, REVISION_HISTORY, REVISION_IMPACT, REVISION_TYPE, ROLLUP_BITS, RTF_BITS, R_ACTUAL_BUDGET, R_BASELINE1_BUDGET, R_BASELINE2_BUDGET, R_BASELINE3_BUDGET, R_CURRENT_BUDGET, R_ESTIMATION_BUDGET, R_ESTIMATION_TOTAL, R_FORECAST_BUDGET,
         SCHED_DURATION, SCHED_EFFORT, SCHED_FINISH, SCHED_START, SD, STAGE_ID, START_DT, START_FINISH_DATE, FINISH_START_DATE, START_FINISH_FLAG, S_ACTUAL_BUDGET, S_BASELINE1_BUDGET, S_BASELINE2_BUDGET, S_BASELINE3_BUDGET, S_CURRENT_BUDGET, S_ESTIMATION_BUDGET, S_ESTIMATION_TOTAL, S_FORECAST_BUDGET,
         TASK_TYPE, TOOLTIP_DESCR, TOTAL_SLACK, TRANSFER_FLAG, TYPE_ID, T_PARENT_ID, T_RANK,
         UNRESOLVED_DURATION, UNRESOLVED_FINISH, UNRESOLVED_START,
         VARIANCE,
         WBS_CODE, WORK_TODATE,
         ESTIMATED_ACTUAL, ESTIMATED_ETC, R_ESTIMATED_ACTUAL, R_ESTIMATED_ETC, S_ESTIMATED_ACTUAL, S_ESTIMATED_ETC,
         ESTIMATED_HOURS, ESTIMATED_ACTUAL_HOURS, ESTIMATED_HOURS_ETC, R_ESTIMATED_HOURS, R_ESTIMATED_ACTUAL_HOURS, R_ESTIMATED_HOURS_ETC,
         ESTIMATED_HOURS_BASELINE1, ESTIMATED_HOURS_BASELINE2, ESTIMATED_HOURS_BASELINE3,
         R_ESTIMATED_HOURS_BASELINE1, R_ESTIMATED_HOURS_BASELINE2, R_ESTIMATED_HOURS_BASELINE3
         FROM TMT_WBS
         WHERE ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 748+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(749) : wbs_ext.sql(6306) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE HISTORY_WBS SET REC_STATUS = 'U' WHERE HISTORY_ID = h_uniqueID2;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 765+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(766) : wbs_ext.sql(6323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         UPDATE TMT_WBS SET REVISION_HISTORY = Null WHERE ELEMENT_ID = h_uniqueID;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_WBS_MSP', 782+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_WBS_MSP(783) : wbs_ext.sql(6340) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         --for every new project we add a record in every attribute table
         --exept tmt_pool_attributes
         --PARIA --
         PMO_DB2M.SC_STATE := FC_I_PROJECT_CATEGORY(h_uniqueID, h_name, h_rec_user);
         PMO_DB2M.SC_STATE := FC_I_PROJECT_FOLDERS(h_uniqueID, h_rank, h_name, h_rec_user);
      Else
         If (Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER2) OR (Coalesce(
               h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER1) Then
            If Coalesce(h_type_id, 0) = PMO_CNST.SC_TMP_FOLDER2 Then
               PMO_DB2M.SC_STATE := FC_I_LINK_FOLDERS(h_uniqueID, h_rank, h_name, h_rec_user);
            End If;
         Else
            --PARIA
            --An item be added under a project so related default attribute must be assign to this new item
            PMO_DB2M.SC_STATE := FC_A_DEFAULT_ATTRIBUTE(h_project_id, h_uniqueID, h_type_id, h_rec_user);
         End If;
      End If;
   End If;
   
   If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      h_parent_id := 'LOCAL_CLIENT____________________';
      PMO_DB2M.SC_STATE := FC_I_CLIENT(h_name, h_uniqueID, h_parent_id, h_type_id, h_rec_user);
      
      h_parent_id := 'LOCAL_GROUPS____________________';
      PMO_DB2M.SC_STATE := FC_I_CONTACT(h_name, h_uniqueID, h_parent_id, h_type_id, h_rec_user);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_WBS_MSP', 815+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_WBS_MSP(816) : wbs_ext.sql(6373) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_WBS_MSP;
ALTER FUNCTION FC_I_WBS_MSP COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION FC_CLOSE_EFFORT ==
CREATE OR REPLACE FUNCTION FC_CLOSE_EFFORT
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_prj_assignment_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_ta_id VARCHAR2(32);
   h_task_id VARCHAR2(32);
   h_resource_id VARCHAR2(32);
   h_AF TIMESTAMP;
   h_last_submitted DATE;
   h_last_day PLS_INTEGER := 0;
   h_res_type VARCHAR2(1);
   h_actual_effort PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_TA IS
         SELECT TSK_ASSIGNMENT_ID, PROJECT_ID, TASK_ID, RESOURCE_ID, WORK_TODATE, RESOURCE_TYPE,
         PROJECT_ASSIGNMENT_ID, LAST_SUBMITTED, LAST_SCHED_MIN
         FROM TASK_ASSIGNMENTS
         WHERE TASK_ID = h_id AND NOT MILESTONE_PERCENT = 10000;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLOSE_EFFORT') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLOSE_EFFORT'), '-- ' || SYSTIMESTAMP, ':r := FC_CLOSE_EFFORT(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLOSE_EFFORT', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLOSE_EFFORT(33) : wbs_ext.sql(6416) : ' || SYSTIMESTAMP);
   END IF; 

   --effort based
   -- Temporary Table Declaration has been changed to Truncate
   EXECUTE IMMEDIATE 'DELETE FROM PMO_TMP_DELETE';
   PMO_DB2M.SC_STATE := 0;
   
   --clear all assignments without actuals
   
   OPEN C_TA;
   
   LOOP
      FETCH C_TA INTO h_ta_id, h_project_id, h_task_id, h_resource_id, h_actual_effort, h_res_type,
      h_prj_assignment_id, h_last_submitted, h_last_day;
      IF C_TA%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      If Coalesce(h_actual_effort, 0) > 0 Then
         h_temp_var := FC_U_TDY_LAST_ACTUAL(h_project_id, h_task_id, h_resource_id, h_prj_assignment_id
                                   , h_ta_id, h_last_submitted, h_last_day, 0);
         
         BEGIN
            SELECT PMO_ORASTD.DB2TIMESTAMP(TO_DATE(SubStr(h_last_submitted, 1, 10)), PMO_ORASTD.TIME(PMO_STPU.FIRST_AVAIL_TIME(BIT_SCHED))) INTO h_AF
            FROM TASK_DAY_OF_YEAR
            WHERE TSK_ASSIGNMENT_ID = h_ta_id AND DAY_YEAR = TO_DATE(SubStr(h_last_submitted, 1, 10));
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLOSE_EFFORT', 71+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLOSE_EFFORT(72) : wbs_ext.sql(6455) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE: %d, h_last_submitted: %s, h_AF: %d %s\n", SC_STATE, h_last_submitted,h_AF_Ind,h_AF);
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
            BEGIN
               UPDATE TASK_ASSIGNMENTS SET
               ACTUAL_FINISH = h_AF,
               SCHED_WORK = WORK_TODATE,
               ETC = 0, FD = PMO_CNST.SC_AF,
               MILESTONE_PERCENT = 10000
               WHERE TSK_ASSIGNMENT_ID = h_ta_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLOSE_EFFORT', 95+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLOSE_EFFORT(96) : wbs_ext.sql(6479) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
               h_temp_var := 1;
               PMO_DB2M.SC_STATE := FC_ETC_SCHEDULE(h_ta_id, h_temp_var, h_rec_user);
               
               --we need to update the activities table when we close a task, and this task contains steps in timesheets to be consistent
               BEGIN
                  UPDATE ACTIVITIES
                  SET ETC_MODIFIED = 'N'
                  WHERE TSK_ASSIGNMENT_ID = h_ta_id
                  AND TSK_ASSIGNMENT_ID <> ELEMENT_ID;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLOSE_EFFORT', 120+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLOSE_EFFORT(121) : wbs_ext.sql(6504) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            Else
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_CLOSE_EFFORT', 126+1) THEN 
                  LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_CLOSE_EFFORT(127) : wbs_ext.sql(6510) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_ta_id || '''');
               END IF; 
               PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, h_ta_id);
            End If;
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_CLOSE_EFFORT', 132+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_CLOSE_EFFORT(133) : wbs_ext.sql(6516) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_DB2M.SC_STATE), 'NULL') || ' ID: ' || '''' || h_ta_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_DB2M.SC_STATE, h_ta_id);
         End If;
      Else
         h_temp_var := PMO_CNST.SC_BIT_28_29_30;
         h_temp_var := FC_D_TSKRES(h_ta_id, h_temp_var, h_resource_id, h_rec_user);
      End If;
   END LOOP;
   
   BEGIN
      CLOSE C_TA ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLOSE_EFFORT', 150+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLOSE_EFFORT(151) : wbs_ext.sql(6534) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLOSE_EFFORT', 156+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLOSE_EFFORT(157) : wbs_ext.sql(6540) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLOSE_EFFORT;
ALTER FUNCTION FC_CLOSE_EFFORT COMPILE DEBUG;

/*###########################################*/

Prompt == FUNCTION FC_I_PORTF ==
CREATE OR REPLACE FUNCTION FC_I_PORTF
(
     h_name IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , h_uniqueID IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_rank VARCHAR2(200);
   h_rankBase64 VARCHAR2(200);
   h_max_rank PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_root_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_I_PORTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_I_PORTF'), '-- ' || SYSTIMESTAMP, ':r := FC_I_PORTF(' || 
       '''' || h_name || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || '''' || h_uniqueID || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_PORTF', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_I_PORTF(27) : wbs_ext.sql(6577) : ' || SYSTIMESTAMP);
   END IF; 

   h_uniqueID := SYS_GUID();
   
   If h_parent_id IS NULL Then
      h_root_id := h_rec_user;
   Else
      h_root_id := h_parent_id;
   End If;
   
   BEGIN
      SELECT RANK, LEVEL_ID + 1 INTO h_rank, h_level_id
      FROM TMT_PORTFOLIOS WHERE ELEMENT_ID = h_root_id AND REC_STATUS IN ('I', 'O', 'U');
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PORTF', 46+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PORTF(47) : wbs_ext.sql(6597) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_I_PORTF', 53+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_I_PORTF(54) : wbs_ext.sql(6604) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_root_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_root_id);
   End If;
   
   PMODEFINES.PMO_GET_MAX_RANK('TMT_PORTFOLIOS', h_root_id, h_max_rank);
   PMO_STPU.toBase64(Coalesce(h_max_rank, 0), h_rankBase64);
   
   BEGIN
      INSERT INTO TMT_PORTFOLIOS (RANK,TYPE_ID,LEVEL_ID,PARENT_ID,ELEMENT_ID,ELEMENT_NAME,REC_STATUS)
      VALUES (RTRIM(h_rank) || h_rankBase64, h_type_id, h_level_id, h_root_id, h_uniqueID, h_name, 'I');
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_I_PORTF', 74+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_I_PORTF(75) : wbs_ext.sql(6625) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_I_PORTF', 80+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_I_PORTF(81) : wbs_ext.sql(6631) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_I_PORTF;
ALTER FUNCTION FC_I_PORTF COMPILE DEBUG;

/*********************************************************************/

Prompt == FUNCTION FC_U_WBS_NAME_MSP ==
CREATE OR REPLACE FUNCTION FC_U_WBS_NAME_MSP
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_ieflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_ieflag PLS_INTEGER := sh_h_ieflag;
   h_transfer_flag VARCHAR2(1);
   h_type_id PLS_INTEGER := 0;
   h_a_cri_count PLS_INTEGER := 0;
   h_a_req_count PLS_INTEGER := 0;
   h_error_id VARCHAR2(32);
   h_host_table PLS_INTEGER := 0;
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_WBS_NAME_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_WBS_NAME_MSP'), '-- ' || SYSTIMESTAMP, ':r := FC_U_WBS_NAME_MSP(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WBS_NAME_MSP', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_WBS_NAME_MSP(27) : wbs_ext.sql(6668) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT TYPE_ID, TRANSFER_FLAG, REC_STATUS, A_CRI_COUNT
      INTO h_type_id, h_transfer_flag, h_rec_status, h_a_cri_count
      FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WBS_NAME_MSP', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WBS_NAME_MSP(40) : wbs_ext.sql(6681) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      -- for personal task onlt
      BEGIN
         SELECT TASK_ID
         INTO h_id
         FROM TASK_ASSIGNMENTS
         WHERE TSK_ASSIGNMENT_ID = h_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WBS_NAME_MSP', 57+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WBS_NAME_MSP(58) : wbs_ext.sql(6699) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         PMO_DB2M.SC_STATE := PMO_CNST.RECORD_NOT_FOUND;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WBS_NAME_MSP', 65+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_WBS_NAME_MSP(66) : wbs_ext.sql(6707) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      Else
         BEGIN
            SELECT TYPE_ID, TRANSFER_FLAG, REC_STATUS, A_CRI_COUNT
            INTO h_type_id, h_transfer_flag, h_rec_status, h_a_cri_count
            FROM TMT_WBS WHERE ELEMENT_ID = h_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WBS_NAME_MSP', 79+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WBS_NAME_MSP(80) : wbs_ext.sql(6721) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If Coalesce(h_ieflag, 0) = 0 Then
      If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
         PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WBS_NAME_MSP', 90+1) THEN 
            LFILE.FPUT('AllTrace', '                EXIT: FC_U_WBS_NAME_MSP(91) : wbs_ext.sql(6732) : ' || SYSTIMESTAMP);
         END IF; 
         RETURN PMO_DB2M.SC_STATE;
      End If;
   End If;
   
   -- commented by paria because we don't have tmt_requirement table anymore 11/18/2002
   /*  if(checkFlagStatus(h_transfer_flag,'U') || checkFlagStatus(h_transfer_flag,'R')||(h_a_req_count>0))
           {
               BEGIN_SQL
                   UPDATE TMT_REQUIREMENTS SET ELEMENT_NAME = HOST_DB(p_name,ind_u_prj_name) WHERE ELEMENT_ID = HOST_DB(p_id,ind_u_prj_name);
               END_SQL_CHECK;
   
       }*/
   
   If SubStr(h_transfer_flag, 1, 1) = 'C' OR SubStr(h_transfer_flag, 1, 1) = 'W' Then
      BEGIN
         UPDATE TMT_CRI SET
         ELEMENT_NAME = h_name
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WBS_NAME_MSP', 120+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WBS_NAME_MSP(121) : wbs_ext.sql(6762) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   If Coalesce(h_a_cri_count, 0) > 0 Then
      BEGIN
         UPDATE TMT_CRI SET
         ELEMENT_NAME = h_name
         WHERE WBS_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WBS_NAME_MSP', 141+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WBS_NAME_MSP(142) : wbs_ext.sql(6783) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   --Execute Insert Statement
   BEGIN
      UPDATE TMT_WBS SET
      ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WBS_NAME_MSP', 162+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WBS_NAME_MSP(163) : wbs_ext.sql(6804) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
      PMO_DB2M.SC_STATE := FC_U_PROJECT_CATEGORY_NAME(h_id, h_name, h_rec_user);
      
      h_host_table := PMO_CNST.SC_TABLE_CLN;
      PMO_DB2M.SC_STATE := FC_U_ITEM_NAME_CLN(h_host_table, h_id, h_name, h_rec_user, h_error_id);
      
      PMO_DB2M.SC_STATE := FC_U_NAME_SCD(h_id, h_name, h_rec_user);
      
      BEGIN
         UPDATE TMT_CONTACTS
         SET ELEMENT_NAME = h_name
         WHERE ELEMENT_ID = h_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_WBS_NAME_MSP', 189+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_WBS_NAME_MSP(190) : wbs_ext.sql(6831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_WBS_NAME_MSP', 196+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_WBS_NAME_MSP(197) : wbs_ext.sql(6838) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_WBS_NAME_MSP;
ALTER FUNCTION FC_U_WBS_NAME_MSP COMPILE DEBUG;

/***********************************************/

Prompt == FUNCTION FC_U_PORTF_NAME1 ==
CREATE OR REPLACE FUNCTION FC_U_PORTF_NAME1
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_name IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rec_status VARCHAR2(1);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PORTF_NAME1') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PORTF_NAME1'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PORTF_NAME1(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_name || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PORTF_NAME1', 17+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PORTF_NAME1(18) : wbs_ext.sql(6866) : ' || SYSTIMESTAMP);
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1024, 'FC_U_PORTF_NAME1', 21+1) THEN 
      LFILE.FPUT('AllTrace', '     VALIDATE_RECORD: FC_U_PORTF_NAME1(22) : wbs_ext.sql(6870) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_PORTFOLIOS' || '''' || ' ID: ' || '''' || h_id || '''');
   END IF; 
   PMODEFINES.PMO_VALIDATE_RECORD('TMT_PORTFOLIOS', h_id, h_rec_status);
   
   If SubStr(h_rec_status, 1, 1) IN ('D', 'L', 'A') Then
      PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_UPDATE_LOCKED_RECORD;
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PORTF_NAME1', 28+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_U_PORTF_NAME1(29) : wbs_ext.sql(6877) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN PMO_DB2M.SC_STATE;
   End If;
   
   --Execute UPDATE Statement
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET ELEMENT_NAME = h_name
      WHERE ELEMENT_ID = h_id AND
      TYPE_ID = PMO_CNST.SC_FOLDER;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PORTF_NAME1', 49+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PORTF_NAME1(50) : wbs_ext.sql(6898) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PORTF_NAME1', 55+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PORTF_NAME1(56) : wbs_ext.sql(6904) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PORTF_NAME1;
ALTER FUNCTION FC_U_PORTF_NAME1 COMPILE DEBUG;

/********************************************************/

Prompt == FUNCTION FC_D_PROJECT_FOLDERS ==
CREATE OR REPLACE FUNCTION FC_D_PROJECT_FOLDERS
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_PROJECT_FOLDERS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_PROJECT_FOLDERS'), '-- ' || SYSTIMESTAMP, ':r := FC_D_PROJECT_FOLDERS(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_PROJECT_FOLDERS', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_PROJECT_FOLDERS(14) : wbs_ext.sql(6928) : ' || SYSTIMESTAMP);
   END IF; 

   -- DELETE project_folder
   BEGIN
      DELETE FROM  TMT_CRI
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PROJECT_FOLDERS', 30+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PROJECT_FOLDERS(31) : wbs_ext.sql(6945) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM  TMT_DOCUMENTS
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PROJECT_FOLDERS', 48+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PROJECT_FOLDERS(49) : wbs_ext.sql(6963) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM  TMT_ASSIGNED_SCORECARDS
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PROJECT_FOLDERS', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PROJECT_FOLDERS(67) : wbs_ext.sql(6981) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM  TMT_PUBLISHED_SCORECARDS
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PROJECT_FOLDERS', 84+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PROJECT_FOLDERS(85) : wbs_ext.sql(6999) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM  PROJECT_DETAILS
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PROJECT_FOLDERS', 102+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PROJECT_FOLDERS(103) : wbs_ext.sql(7017) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      SELECT RANK INTO h_rank
      FROM TMT_CONTACTS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PROJECT_FOLDERS', 117+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PROJECT_FOLDERS(118) : wbs_ext.sql(7032) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_CONTACTS
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PROJECT_FOLDERS', 137+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PROJECT_FOLDERS(138) : wbs_ext.sql(7052) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_PROJECT_FOLDERS', 144+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_PROJECT_FOLDERS(145) : wbs_ext.sql(7059) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_PROJECT_FOLDERS', 149+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_PROJECT_FOLDERS(150) : wbs_ext.sql(7064) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_PROJECT_FOLDERS;
ALTER FUNCTION FC_D_PROJECT_FOLDERS COMPILE DEBUG;

--#########################################################

Prompt == FUNCTION FC_D_WBS_MSP ==
CREATE OR REPLACE FUNCTION FC_D_WBS_MSP
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_status_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
   , sh_h_ieflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_ieflag PLS_INTEGER := sh_h_ieflag;
   h_id2 VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rec_user2 VARCHAR2(32);
   h_rec_user3 VARCHAR2(32);
   h_rec_status VARCHAR2(1);
   h_rank VARCHAR2(200);
   h_cur_rank VARCHAR2(200);
   h_type_id PLS_INTEGER := 0;
   h_fs_state PLS_INTEGER := 0;
   h_fs_project PLS_INTEGER := 0;
   h_rollup PLS_INTEGER := 0;
   h_level_id PLS_INTEGER := 0;
   h_bitflag PLS_INTEGER := 0;
   h_temp_sc_state PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
   h_locked_project PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR CDFST IS
         SELECT FS_STATE FROM TMT_WBS
         WHERE  ROWNUM <= 1 AND  RANK LIKE h_rank || '%' AND (FS_CODE IS NOT Null OR FS_STATE IN (2,3));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_WBS_MSP') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_WBS_MSP'), '-- ' || SYSTIMESTAMP, ':r := FC_D_WBS_MSP(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_status_id || ''''
          || ', ' || '''' || h_rec_user || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_ieflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_WBS_MSP', 42+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_WBS_MSP(43) : wbs_ext.sql(7117) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   If Coalesce(h_ieflag, 0) = 0 Then
      If NOT SubStr(h_status_id, 1, 1) = 'A' AND NOT SubStr(h_status_id, 1, 1) = 'Q' Then
         If h_parent_id IS NULL Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(256, 'FC_D_WBS_MSP', 51+1) THEN 
               LFILE.FPUT('AllTrace', '     VALIDATE_DELETE: FC_D_WBS_MSP(52) : wbs_ext.sql(7126) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''');
            END IF; 
            PMODEFINES.PMO_VALIDATE_DELETE('TMT_WBS', h_id, h_rec_status);
         Else
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(128, 'FC_D_WBS_MSP', 56+1) THEN 
               LFILE.FPUT('AllTrace', '    VALIDATE_DELETE2: FC_D_WBS_MSP(57) : wbs_ext.sql(7131) : ' || SYSTIMESTAMP || ' ' || 'TABLE: ' || '''' || 'TMT_WBS' || '''' || ' ID: ' || '''' || h_id || '''' || ' PARENTID: ' || '''' || h_parent_id || '''');
            END IF; 
            PMODEFINES.PMO_VALIDATE_DELETE2('TMT_WBS', h_id, h_parent_id, h_rec_status);
         End If;
      End If;
   End If;
   
   BEGIN
      SELECT TYPE_ID, PROJECT_ID, RANK, LEVEL_ID, REC_USER, REC_STATUS
      INTO h_type_id, h_project_id, h_rank, h_level_id,
      h_rec_user2, h_rec_status
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 75+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(76) : wbs_ext.sql(7150) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --trace_printf("\n h_rec_status:%s", h_rec_status);
   --trace_printf("\n h_id:%s", h_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If (PMO_ORASTD.strcmp(h_rec_status, 'O') = 0) AND (PMO_ORASTD.strcmp(h_rec_user
            , h_rec_user2) <> 0) Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_WBS_MSP', 87+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_WBS_MSP(88) : wbs_ext.sql(7162) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.MARKED_AS_UNAVAILABLE), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.MARKED_AS_UNAVAILABLE, h_id);
      End If;
      
      h_locked_project := 0;
      If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         /*BEGIN_SQL
                         SELECT COUNT(PD.PROJECT_ID)
                         INTO HOST(h_count)
                         FROM TMT_WBS W, PROJECT_DETAILS PD
                         WHERE W.RANK LIKE HOST(h_rank) || '%'
                             AND W.TYPE_ID IN (SC_PROJECT_GROUP_TYPES)
                             AND W.ELEMENT_ID = PD.PROJECT_ID
                             AND PD.LEVEL_LOCK > 0;
                     END_SQL_CHECK;*/
         
         BEGIN
            SELECT SUM(PD.LEVEL_LOCK), SUM(case when w.rec_status = 'L' then 1 else 0 end)
            INTO h_count, h_locked_project
            FROM TMT_WBS W, PROJECT_DETAILS PD
            WHERE W.RANK LIKE h_rank || '%'
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND W.ELEMENT_ID = PD.PROJECT_ID;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 117+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(118) : wbs_ext.sql(7192) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         --trace_printf("\n h_locked_project:%d", h_locked_project);
         --trace_printf("\n h_count:%d", h_count);
         
         If Coalesce(h_locked_project, 0) > 0 Then
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_WBS_MSP', 127+1) THEN 
               LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_WBS_MSP(128) : wbs_ext.sql(7202) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL), 'NULL') || ' ID: ' || '''' || h_id || '''');
            END IF; 
            PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND_OR_UNAVAIL, h_id);
         End If;
      Else
         BEGIN
            SELECT COUNT(PD.PROJECT_ID)
            INTO h_count
            FROM TMT_WBS W, PROJECT_DETAILS PD
            WHERE W.ELEMENT_ID = h_project_id
            AND W.PROJECT_ID = h_project_id
            AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
            AND W.ELEMENT_ID = PD.PROJECT_ID
            AND PD.LEVEL_LOCK > 0;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 147+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(148) : wbs_ext.sql(7222) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      If Coalesce(h_count, 0) > 0 Then
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_WBS_MSP', 155+1) THEN 
            LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_WBS_MSP(156) : wbs_ext.sql(7230) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC), 'NULL') || ' ID: ' || '''' || h_id || '''');
         END IF; 
         PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.CANNOT_LEVEL_OTHER_LEVEL_PORC, h_id);
      End If;
   Else
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_WBS_MSP', 161+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_WBS_MSP(162) : wbs_ext.sql(7236) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.RECORD_NOT_FOUND), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.RECORD_NOT_FOUND, h_id);
   End If;
   
   BEGIN
      SELECT RANK INTO h_cur_rank
      FROM TMT_WBS
      WHERE ELEMENT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 176+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(177) : wbs_ext.sql(7251) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   h_count := 0;
   BEGIN
      SELECT COUNT('X') INTO h_count
      FROM DUAL
      WHERE EXISTS (SELECT D.PROJECT_ID FROM PROJECT_DETAILS D, TMT_WBS W
      WHERE W.RANK LIKE h_cur_rank || '%' AND W.TYPE_ID IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3)
      AND D.PROJECT_ID = W.ELEMENT_ID AND D.LEVEL_LOCK > 0);
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 194+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(195) : wbs_ext.sql(7269) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_count, 0) > 0 Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(32, 'FC_D_WBS_MSP', 201+1) THEN 
         LFILE.FPUT('AllTrace', '        RETURN_ERROR: FC_D_WBS_MSP(202) : wbs_ext.sql(7276) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || COALESCE(TO_CHAR(PMO_CNST.LEV_LOCKED_BY_LEVEL), 'NULL') || ' ID: ' || '''' || h_id || '''');
      END IF; 
      PMODEFINES.PMO_RETURN_ERROR(PMO_CNST.LEV_LOCKED_BY_LEVEL, h_id);
   End If;
   
   h_rollup := 0;
   If (Coalesce(h_type_id, 0) = 175) OR (Coalesce(h_type_id, 0) = PMO_CNST.SC_TEMPLATE_LINKS) Then
      h_temp_sc_state := DELETE_TEMPLATE(h_id, h_rec_user);
      PMO_DB2M.SC_STATE := 0;
   ElsIf (isProjectType(Coalesce(h_type_id, 0))) <> 0 OR (Coalesce(h_type_id, 0) = PMO_CNST.SC_TASK) 
         OR (Coalesce(h_type_id, 0) = PMO_CNST.SC_MILESTONE) Then
      BEGIN
         SELECT CASE WHEN FS_CODE IS Null THEN 0 ELSE 1 END INTO h_fs_project
         FROM TMT_WBS WHERE ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 221+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(222) : wbs_ext.sql(7296) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_fs_project, 0) = 1 Then
         If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
            PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_DELETE_FS_PROJECT;
         Else
            BEGIN
               SELECT FS_STATE INTO h_fs_state FROM TMT_WBS
               WHERE ELEMENT_ID = h_id AND (FS_CODE IS NOT Null OR FS_STATE IN (2,3));
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 239+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(240) : wbs_ext.sql(7314) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            /*
            //trace_printf("\nfs state checking...");
            //trace_printf("\nh_rollup: %d, %d", h_rollup_Ind, h_rollup);
            //trace_printf("\nh_fs_state: %d, %d", h_fs_state_Ind, h_fs_state);
            //trace_printf("\n"); //trace_flush();
            */
            If PMO_DB2M.SC_STATE = 0 Then
               If Coalesce(h_ieflag, 0) = 0 Then
                  PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_DELETE_FS_TASK;
               Else
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_WBS_MSP', 254+1) THEN 
                     LFILE.FPUT('AllTrace', '                EXIT: FC_D_WBS_MSP(255) : wbs_ext.sql(7329) : ' || SYSTIMESTAMP);
                  END IF; 
                  RETURN 0;
               End If;
            Else
               PMO_DB2M.SC_STATE := FC_DELETE_WBS(h_id, h_parent_id, h_status_id, h_rec_user, h_rollup);
            End If;
         End If;
      Else
         If h_parent_id IS NULL Then
            h_parent_id := '';
         End If;
         
         PMO_DB2M.SC_STATE := FC_DELETE_WBS(h_id, h_parent_id, h_status_id, h_rec_user, h_rollup);
      End If;
   Else
      -- Check for FS Tasks
      
      OPEN CDFST;
      
      FETCH CDFST INTO h_fs_state;
      IF CDFST%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         BEGIN
            CLOSE CDFST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 290+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(291) : wbs_ext.sql(7365) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         PMO_DB2M.SC_STATE := PMO_CNST.CANNOT_DELETE_FS_TASK;
      Else
         BEGIN
            CLOSE CDFST ;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 305+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(306) : wbs_ext.sql(7380) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         h_rollup := Coalesce(h_ieflag, 0);
         
         PMO_DB2M.SC_STATE := FC_DELETE_WBS(h_id, h_parent_id, h_status_id, h_rec_user, h_rollup);
      End If;
   End If;
   
   --trace_printf("\n4");
   --trace_printf("\nSC_STATE: %d", SC_STATE);
   --trace_printf("\n"); //trace_flush();
   
   If (PMO_DB2M.SC_STATE <> 0) AND (Coalesce(h_ieflag, 0) <> 0) Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_WBS_MSP', 322+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_D_WBS_MSP(323) : wbs_ext.sql(7397) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
         h_bitflag := 1;
         PMO_DB2M.SC_STATE := FC_D_CLIENT(h_id, h_bitflag, h_rec_user);
         PMO_DB2M.SC_STATE := FC_D_PROJECT_FOLDERS(h_id);
         
         --Tj
         BEGIN
            DELETE FROM PROJECT_COSTBACK WHERE PROJECT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 346+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(347) : wbs_ext.sql(7421) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PROJECT_CHARGEBACK WHERE PROJECT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 363+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(364) : wbs_ext.sql(7438) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM PROJECT_CHARGEBACK_BREAKDOWN WHERE PROJECT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 380+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(381) : wbs_ext.sql(7455) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM HISTORY_PUBLISHED_SCORECARDS WHERE PROJECT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 397+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(398) : wbs_ext.sql(7472) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_PUBLISHED_SCORECARDS WHERE PROJECT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 414+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(415) : wbs_ext.sql(7489) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM HISTORY_ASSIGNED_SCORECARDS WHERE PROJECT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 431+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(432) : wbs_ext.sql(7506) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         BEGIN
            DELETE FROM TMT_ASSIGNED_SCORECARDS WHERE PROJECT_ID = h_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 448+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(449) : wbs_ext.sql(7523) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --Tj
         
         BEGIN
            SELECT CASE WHEN h_id = RTRIM(ELEMENT_NAME) THEN 1 ELSE 0 END INTO h_temp_sc_state
            FROM TMT_SETTINGS WHERE ELEMENT_ID = 'SC_DEFAULT_PROJECT_IN_SYSTEM___ ';
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 463+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(464) : wbs_ext.sql(7538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         
         If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS AND (Coalesce(h_temp_sc_state, 0) = 1) Then
            BEGIN
               UPDATE TMT_SETTINGS SET ELEMENT_NAME = NuLL WHERE ELEMENT_ID = 'SC_DEFAULT_PROJECT_IN_SYSTEM___ ';
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_WBS_MSP', 481+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_WBS_MSP(482) : wbs_ext.sql(7556) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         End If;
         
         If (Coalesce(h_ieflag, 0) = 0) AND (Coalesce(h_level_id, 0) > 0) Then
            /*  BEGIN_SQL
                                SELECT ELEMENT_ID INTO HOST(h_project_id)
                                FROM TMT_WBS
                                WHERE RANK = SUBSTR(HOST(h_rank),1,8);
                            END_SQL_CHECK;*/
            
            PMO_DB2M.SC_STATE := FC_Rollup(h_parent_id);
            -- New Rollup
         End If;
      ElsIf (Coalesce(h_ieflag, 0) = 0) AND (Coalesce(h_type_id, 0) <> 175) AND (Coalesce(
                h_type_id, 0) <> 176) Then
         PMO_DB2M.SC_STATE := FC_Rollup(h_project_id);
         -- New Rollup
      End If;
   End If;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      PMO_DB2M.SC_STATE := 0;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_WBS_MSP', 509+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_WBS_MSP(510) : wbs_ext.sql(7584) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_WBS_MSP', 514+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_WBS_MSP(515) : wbs_ext.sql(7589) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_WBS_MSP;
ALTER FUNCTION FC_D_WBS_MSP COMPILE DEBUG;

/********************************************/

--   archive a specific proj.

--   1. update child count of father's proj

--   2. change rec_status to 'd'

--   3. upd child_count of the specific proj

/*******************************************/

Prompt == FUNCTION FC_ARCHIVE_WBS ==
CREATE OR REPLACE FUNCTION FC_ARCHIVE_WBS
(
     h_element_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_ARCHIVE_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_ARCHIVE_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_ARCHIVE_WBS(' || 
       '''' || h_element_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ARCHIVE_WBS', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_ARCHIVE_WBS(15) : wbs_ext.sql(7624) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET CHILD_COUNT = CHILD_COUNT - 1
      WHERE ELEMENT_ID IN (SELECT PARENT_ID FROM TMT_PORTFOLIOS WHERE ELEMENT_ID = h_element_id)
      AND REC_STATUS <> 'D';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ARCHIVE_WBS', 32+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ARCHIVE_WBS(33) : wbs_ext.sql(7642) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET REC_STATUS  = 'D',
      CHILD_COUNT = (SELECT COUNT(*) FROM TMT_PORTFOLIOS WHERE PARENT_ID = h_element_id)
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ARCHIVE_WBS', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ARCHIVE_WBS(53) : wbs_ext.sql(7662) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS
      SET CHILD_COUNT = CHILD_COUNT - 1
      WHERE ELEMENT_ID = (SELECT PARENT_ID FROM TMT_WBS WHERE ELEMENT_ID = h_element_id)
      AND REC_STATUS <> 'D';
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ARCHIVE_WBS', 72+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ARCHIVE_WBS(73) : wbs_ext.sql(7682) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_WBS
      SET REC_STATUS = 'D',
      REC_USER = h_rec_user,
      REC_DATETIME = SYSTIMESTAMP,
      CHILD_COUNT = (SELECT COUNT(*) FROM TMT_WBS WHERE PARENT_ID = h_element_id)
      WHERE ELEMENT_ID = h_element_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_ARCHIVE_WBS', 94+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_ARCHIVE_WBS(95) : wbs_ext.sql(7704) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_ARCHIVE_WBS', 100+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_ARCHIVE_WBS(101) : wbs_ext.sql(7710) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_ARCHIVE_WBS;
ALTER FUNCTION FC_ARCHIVE_WBS COMPILE DEBUG;

/********************************************************************************/

Prompt == FUNCTION FC_D_PORTF ==
CREATE OR REPLACE FUNCTION FC_D_PORTF
(
     h_id IN OUT NOCOPY VARCHAR2
   , h_parent_id IN OUT NOCOPY VARCHAR2
   , h_status_id IN OUT NOCOPY VARCHAR2
   , h_rec_user IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_rank VARCHAR2(200);
   h_level_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_D_PORTF') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_D_PORTF'), '-- ' || SYSTIMESTAMP, ':r := FC_D_PORTF(' || 
       '''' || h_id || ''''
          || ', ' || '''' || h_parent_id || ''''
          || ', ' || '''' || h_status_id || ''''
          || ', ' || '''' || h_rec_user || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_PORTF', 20+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_D_PORTF(21) : wbs_ext.sql(7741) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      SELECT RANK, PARENT_ID, LEVEL_ID
      
      INTO h_rank, h_parent_id, h_level_id
      FROM TMT_PORTFOLIOS
      WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PORTF', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PORTF(36) : wbs_ext.sql(7756) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      If Coalesce(h_level_id, 0) <> 0 Then
         BEGIN
            UPDATE TMT_PORTFOLIOS
            SET CHILD_COUNT = CHILD_COUNT - 1
            WHERE ELEMENT_ID = h_parent_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PORTF', 56+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PORTF(57) : wbs_ext.sql(7777) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      
      PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 0);
      BEGIN
         DELETE FROM TMT_PORTFOLIOS
         WHERE RANK LIKE h_rank || '%';
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_D_PORTF', 76+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_D_PORTF(77) : wbs_ext.sql(7797) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_D_PORTF', 83+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_D_PORTF(84) : wbs_ext.sql(7804) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_D_PORTF;
ALTER FUNCTION FC_D_PORTF COMPILE DEBUG;

/*###############################################################*/

Prompt == FUNCTION FC_CHANGE_PROJ_TYPE ==
CREATE OR REPLACE FUNCTION FC_CHANGE_PROJ_TYPE
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_old_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_old_type_id PLS_INTEGER := sh_h_old_type_id;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CHANGE_PROJ_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CHANGE_PROJ_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_CHANGE_PROJ_TYPE(' || 
       '''' || h_project_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_old_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_PROJ_TYPE', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CHANGE_PROJ_TYPE(19) : wbs_ext.sql(7833) : ' || SYSTIMESTAMP);
   END IF; 

   BEGIN
      UPDATE TMT_WBS
      SET TYPE_ID = h_type_id
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_PROJ_TYPE', 35+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_PROJ_TYPE(36) : wbs_ext.sql(7850) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_PORTFOLIOS
      SET TYPE_ID = h_type_id
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_PROJ_TYPE', 54+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_PROJ_TYPE(55) : wbs_ext.sql(7869) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CLIENTS
      SET TYPE_ID   = h_type_id
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_PROJ_TYPE', 73+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_PROJ_TYPE(74) : wbs_ext.sql(7888) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE TMT_CONTACTS
      SET TYPE_ID   = h_type_id
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_PROJ_TYPE', 92+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_PROJ_TYPE(93) : wbs_ext.sql(7907) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE RESOURCE_ASSIGNMENTS
      SET ELEMENT_TYPE = h_type_id
      WHERE ELEMENT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_PROJ_TYPE', 111+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_PROJ_TYPE(112) : wbs_ext.sql(7926) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := FC_AFTER_U_RES_ASSIGN_TYPE(h_project_id, h_old_type_id, h_type_id);
   
   BEGIN
      UPDATE TMT_ASSIGNED_SCORECARDS
      SET PARENT_TYPE_ID = h_type_id
      WHERE PROJECT_ID = h_project_id AND LEVEL_ID = 2;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CHANGE_PROJ_TYPE', 132+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CHANGE_PROJ_TYPE(133) : wbs_ext.sql(7947) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_PROJ_TYPE', 138+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_PROJ_TYPE(139) : wbs_ext.sql(7953) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN PMO_DB2M.SC_SQL_SUCCESS;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CHANGE_PROJ_TYPE', 143+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CHANGE_PROJ_TYPE(144) : wbs_ext.sql(7958) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CHANGE_PROJ_TYPE;
ALTER FUNCTION FC_CHANGE_PROJ_TYPE COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION FC_CLEAR_BASELINE_EX ==
CREATE OR REPLACE FUNCTION FC_CLEAR_BASELINE_EX
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_CLEAR_BASELINE_EX') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_CLEAR_BASELINE_EX'), '-- ' || SYSTIMESTAMP, ':r := FC_CLEAR_BASELINE_EX(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEAR_BASELINE_EX', 12+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_CLEAR_BASELINE_EX(13) : wbs_ext.sql(7981) : ' || SYSTIMESTAMP);
   END IF; 

   --COST CENTERS
   BEGIN
      UPDATE PROJECT_COSTBACK SET
      BASELINE3_EXPENSE_AMOUNT =  0.00,
      BASELINE2_EXPENSE_AMOUNT =  0.00,
      BASELINE1_EXPENSE_AMOUNT =  0.00,
      BASELINE3_CAPITAL_AMOUNT =  0.00,
      BASELINE2_CAPITAL_AMOUNT =  0.00,
      BASELINE1_CAPITAL_AMOUNT =  0.00,
      BASELINE3_LABOR_AMOUNT =    0.00,
      BASELINE2_LABOR_AMOUNT =    0.00,
      BASELINE1_LABOR_AMOUNT =    0.00
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAR_BASELINE_EX', 38+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAR_BASELINE_EX(39) : wbs_ext.sql(8007) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --CHARGE-BACK
   BEGIN
      UPDATE PROJECT_CHARGEBACK SET
      BASELINE3_BENEFIT_AMOUNT =  0.00,
      BASELINE2_BENEFIT_AMOUNT =  0.00,
      BASELINE1_BENEFIT_AMOUNT =  0.00
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAR_BASELINE_EX', 60+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAR_BASELINE_EX(61) : wbs_ext.sql(8029) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      DELETE FROM PROJECT_CHARGEBACK_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND ENTRY_TYPE IN (2,3,4);
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_CLEAR_BASELINE_EX', 79+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_CLEAR_BASELINE_EX(80) : wbs_ext.sql(8048) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_CLEAR_BASELINE_EX', 85+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_CLEAR_BASELINE_EX(86) : wbs_ext.sql(8054) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_CLEAR_BASELINE_EX;
ALTER FUNCTION FC_CLEAR_BASELINE_EX COMPILE DEBUG;

/***************************************************************************************************/

Prompt == FUNCTION FC_COMMIT_BASELINE_EX ==
CREATE OR REPLACE FUNCTION FC_COMMIT_BASELINE_EX
(
     h_project_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_total_rule PLS_INTEGER := 0;
   h_chargeback_rule PLS_INTEGER := 0;
   h_expense_budget NUMBER := 0;
   h_capital_budget NUMBER := 0;
   h_benefit_budget NUMBER := 0;
   h_labor_budget NUMBER := 0;
   h_temp_id VARCHAR2(32);
-- Declare Cursors
      CURSOR CCHK1 IS
         SELECT CLIENT_ID
         FROM PROJECT_CHARGEBACK_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND ENTRY_TYPE = 4;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_COMMIT_BASELINE_EX') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_COMMIT_BASELINE_EX'), '-- ' || SYSTIMESTAMP, ':r := FC_COMMIT_BASELINE_EX(' || 
       '''' || h_project_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT_BASELINE_EX', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_COMMIT_BASELINE_EX(27) : wbs_ext.sql(8091) : ' || SYSTIMESTAMP);
   END IF; 

   --BUDGET_SETTING_BIST ==>
   --  0: estimated
   --  1: scheduled
   --  2: estimated including sched actual
   --  3: estimated + schedule
   
   --CASHBACK_FORMULA ==>
   --  0: Non billable
   --  1: Billable
   --  2: All
   --  3: Cost
   
   BEGIN
      SELECT BUDGET_SETTING_BITS, CHARGEBACK_FORMULA
      INTO h_total_rule, h_chargeback_rule
      FROM PROJECT_DETAILS
      WHERE PROJECT_ID = h_project_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 52+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(53) : wbs_ext.sql(8117) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_total_rule, 0) = 0 Then
      --labor
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET)
         INTO    h_labor_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK < '0000'
         AND C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR')
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 75+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(76) : wbs_ext.sql(8140) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --expense
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET)
         INTO    h_expense_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 0
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 97+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(98) : wbs_ext.sql(8162) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET)
         INTO    h_capital_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 1
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 118+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(119) : wbs_ext.sql(8183) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_chargeback_rule, 0) = 0 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 0
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 143+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(144) : wbs_ext.sql(8208) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 1 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 1
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 167+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(168) : wbs_ext.sql(8232) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 2 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 190+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(191) : wbs_ext.sql(8255) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 3 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE < 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 213+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(214) : wbs_ext.sql(8278) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf Coalesce(h_total_rule, 0) = 1 Then
      --labor
      BEGIN
         SELECT  SUM(B.BUDGET)
         INTO    h_labor_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK < '0000'
         AND C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR')
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 236+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(237) : wbs_ext.sql(8301) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --expense
      BEGIN
         SELECT  SUM(B.BUDGET)
         INTO    h_expense_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 0
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 258+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(259) : wbs_ext.sql(8323) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(B.BUDGET)
         INTO    h_capital_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 1
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 279+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(280) : wbs_ext.sql(8344) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_chargeback_rule, 0) = 0 Then
         --benefit
         BEGIN
            SELECT  SUM(B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 0
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 304+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(305) : wbs_ext.sql(8369) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 1 Then
         --benefit
         BEGIN
            SELECT  SUM(B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 1
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 328+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(329) : wbs_ext.sql(8393) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 2 Then
         --benefit
         BEGIN
            SELECT  SUM(B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 351+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(352) : wbs_ext.sql(8416) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 3 Then
         --benefit
         BEGIN
            SELECT  SUM(B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE < 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 374+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(375) : wbs_ext.sql(8439) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf Coalesce(h_total_rule, 0) = 2 Then
      --labor
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET + B.ACTUAL)
         INTO    h_labor_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK < '0000'
         AND C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR')
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 397+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(398) : wbs_ext.sql(8462) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --expense
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET + B.ACTUAL)
         INTO    h_expense_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 0
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 419+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(420) : wbs_ext.sql(8484) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET + B.ACTUAL)
         INTO    h_capital_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 1
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 440+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(441) : wbs_ext.sql(8505) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_chargeback_rule, 0) = 0 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.ACTUAL)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 0
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 465+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(466) : wbs_ext.sql(8530) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 1 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.ACTUAL)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 1
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 489+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(490) : wbs_ext.sql(8554) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 2 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.ACTUAL)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 512+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(513) : wbs_ext.sql(8577) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 3 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.ACTUAL)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE < 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 535+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(536) : wbs_ext.sql(8600) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   ElsIf Coalesce(h_total_rule, 0) = 3 Then
      --labor
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET + B.BUDGET)
         INTO    h_labor_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK < '0000'
         AND C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR')
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 558+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(559) : wbs_ext.sql(8623) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      --expense
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET + B.BUDGET)
         INTO    h_expense_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 0
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 580+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(581) : wbs_ext.sql(8645) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      BEGIN
         SELECT  SUM(B.ESTIMATED_BUDGET + B.BUDGET)
         INTO    h_capital_budget
         FROM BUDGETS B
         JOIN TMT_CHARGECODES C
         ON C.ELEMENT_ID = B.CHARGECODE_ID
         AND C.RANK > '0000'
         AND C.CAPITAL_EXPENSE = 1
         WHERE B.PROJECT_ID = h_project_id
         AND B.ELEMENT_ID = h_project_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 601+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(602) : wbs_ext.sql(8666) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_chargeback_rule, 0) = 0 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 0
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 626+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(627) : wbs_ext.sql(8691) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 1 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            AND C.BILLABLE = 1
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 650+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(651) : wbs_ext.sql(8715) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 2 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE = 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 673+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(674) : wbs_ext.sql(8738) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      ElsIf Coalesce(h_chargeback_rule, 0) = 3 Then
         --benefit
         BEGIN
            SELECT  SUM(B.ESTIMATED_BUDGET + B.BUDGET)
            INTO    h_benefit_budget
            FROM BUDGETS B
            JOIN TMT_CHARGECODES C
            ON C.ELEMENT_ID = B.CHARGECODE_ID
            AND (C.RANK > '0000'
            OR C.ELEMENT_ID IN ('EXPENSE_LABOR', 'EXPENSE_CONTRACTOR_LABOR', 'CAPITAL_LABOR', 'CAPITAL_CONTRACTOR_LABOR', 'BILLABLE_BENEFIT_LABOR'))
            AND C.CAPITAL_EXPENSE < 2
            WHERE B.PROJECT_ID = h_project_id
            AND B.ELEMENT_ID = h_project_id;
            PMO_DB2M.SC_STATE := SQLCODE;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 696+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(697) : wbs_ext.sql(8761) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   If h_expense_budget IS NULL Then
      h_expense_budget := 0.00;
   End If;
   
   If h_capital_budget IS NULL Then
      h_capital_budget := 0.00;
   End If;
   
   If h_benefit_budget IS NULL Then
      h_benefit_budget := 0.00;
   End If;
   
   If h_labor_budget IS NULL Then
      h_labor_budget := 0.00;
   End If;
   
   --COST CENTERS
   BEGIN
      UPDATE PROJECT_COSTBACK SET
      BASELINE3_EXPENSE_AMOUNT =  CASE WHEN BASELINE3_EXPENSE_AMOUNT = 0 THEN CASE WHEN EXPENSE_FLAG = 0 THEN h_expense_budget * EXPENSE_PERCENT/10000.00 ELSE EXPENSE_AMOUNT END ELSE BASELINE3_EXPENSE_AMOUNT END,
      BASELINE2_EXPENSE_AMOUNT =  BASELINE1_EXPENSE_AMOUNT,
      BASELINE1_EXPENSE_AMOUNT =  CASE WHEN EXPENSE_FLAG = 0 THEN h_expense_budget * EXPENSE_PERCENT/10000.00 ELSE EXPENSE_AMOUNT END,
      
      BASELINE3_CAPITAL_AMOUNT =  CASE WHEN BASELINE3_CAPITAL_AMOUNT = 0 THEN CASE WHEN CAPITAL_FLAG = 0 THEN h_capital_budget * CAPITAL_PERCENT/10000.00 ELSE CAPITAL_AMOUNT END ELSE BASELINE3_CAPITAL_AMOUNT END,
      BASELINE2_CAPITAL_AMOUNT =  BASELINE1_CAPITAL_AMOUNT,
      BASELINE1_CAPITAL_AMOUNT =  CASE WHEN CAPITAL_FLAG = 0 THEN h_capital_budget * CAPITAL_PERCENT/10000.00 ELSE CAPITAL_AMOUNT END,
      
      BASELINE3_LABOR_AMOUNT =    CASE WHEN BASELINE3_LABOR_AMOUNT = 0 THEN CASE WHEN LABOR_FLAG = 0 THEN h_labor_budget * LABOR_PERCENT/10000.00 ELSE LABOR_AMOUNT END ELSE BASELINE3_LABOR_AMOUNT END,
      BASELINE2_LABOR_AMOUNT =    BASELINE1_LABOR_AMOUNT,
      BASELINE1_LABOR_AMOUNT =    CASE WHEN LABOR_FLAG = 0 THEN h_labor_budget * LABOR_PERCENT/10000.00 ELSE LABOR_AMOUNT END
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 744+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(745) : wbs_ext.sql(8809) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --CHARGE-BACK
   BEGIN
      UPDATE PROJECT_CHARGEBACK SET
      BASELINE3_BENEFIT_AMOUNT =  CASE WHEN BASELINE3_BENEFIT_AMOUNT = 0 THEN CASE WHEN BENEFIT_FLAG = 0 THEN h_benefit_budget * BENEFIT_PERCENT/10000.00 ELSE BENEFIT_AMOUNT END ELSE BASELINE3_BENEFIT_AMOUNT END,
      BASELINE2_BENEFIT_AMOUNT =  BASELINE1_BENEFIT_AMOUNT,
      BASELINE1_BENEFIT_AMOUNT =  CASE WHEN BENEFIT_FLAG = 0 THEN h_benefit_budget * BENEFIT_PERCENT/10000.00 ELSE BENEFIT_AMOUNT END
      WHERE PROJECT_ID = h_project_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 766+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(767) : wbs_ext.sql(8831) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   --CHARGE-BACK BREAKDOWN
   --0: estimated
   --1: paid
   --2: baseline1
   --3: baseline2
   --4: baseline3
   
   BEGIN
      DELETE FROM PROJECT_CHARGEBACK_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND ENTRY_TYPE = 3;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 792+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(793) : wbs_ext.sql(8857) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      UPDATE PROJECT_CHARGEBACK_BREAKDOWN
      SET ENTRY_TYPE = 3
      WHERE PROJECT_ID = h_project_id
      AND ENTRY_TYPE = 2;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 812+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(813) : wbs_ext.sql(8877) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   BEGIN
      INSERT INTO PROJECT_CHARGEBACK_BREAKDOWN
      (CHARGEBACK_ID, PROJECT_ID, CLIENT_ID, ENTRY_TYPE, ENTRY_YEAR,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
      MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT)
      SELECT  SYS_GUID(), PROJECT_ID, CLIENT_ID, 2, ENTRY_YEAR,
      MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
      MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
      TOTAL_AMOUNT
      FROM PROJECT_CHARGEBACK_BREAKDOWN
      WHERE PROJECT_ID = h_project_id
      AND ENTRY_TYPE = 0;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 840+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(841) : wbs_ext.sql(8905) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN CCHK1;
   
   FETCH CCHK1 INTO h_temp_id;
   IF CCHK1%FOUND THEN
      PMO_DB2M.SC_STATE := 0;
   ELSE
      PMO_DB2M.SC_STATE := 100;
   END IF;
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      h_total_rule := 1;
   Else
      h_total_rule := 0;
   End If;
   
   BEGIN
      CLOSE CCHK1 ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 868+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(869) : wbs_ext.sql(8933) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   If Coalesce(h_total_rule, 0) = 0 Then
      BEGIN
         INSERT INTO PROJECT_CHARGEBACK_BREAKDOWN
         (CHARGEBACK_ID, PROJECT_ID, CLIENT_ID, ENTRY_TYPE, ENTRY_YEAR,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
         MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
         TOTAL_AMOUNT)
         SELECT  SYS_GUID(), PROJECT_ID, CLIENT_ID, 4, ENTRY_YEAR,
         MONTH_01_AMOUNT, MONTH_02_AMOUNT, MONTH_03_AMOUNT, MONTH_04_AMOUNT, MONTH_05_AMOUNT,
         MONTH_06_AMOUNT, MONTH_07_AMOUNT, MONTH_08_AMOUNT, MONTH_09_AMOUNT, MONTH_10_AMOUNT, MONTH_11_AMOUNT, MONTH_12_AMOUNT,
         TOTAL_AMOUNT
         FROM PROJECT_CHARGEBACK_BREAKDOWN
         WHERE PROJECT_ID = h_project_id
         AND ENTRY_TYPE = 0;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_COMMIT_BASELINE_EX', 897+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_COMMIT_BASELINE_EX(898) : wbs_ext.sql(8962) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_COMMIT_BASELINE_EX', 904+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_COMMIT_BASELINE_EX(905) : wbs_ext.sql(8969) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_COMMIT_BASELINE_EX;
ALTER FUNCTION FC_COMMIT_BASELINE_EX COMPILE DEBUG;

/************************************************************************************/

Prompt == FUNCTION FC_BITS_VALUE ==
CREATE OR REPLACE FUNCTION FC_BITS_VALUE
(
     sh_type_id001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type_id001 PLS_INTEGER := sh_type_id001;
   bits PLS_INTEGER NOT NULL := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BITS_VALUE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BITS_VALUE'), '-- ' || SYSTIMESTAMP, ':r := FC_BITS_VALUE(' || 
       COALESCE(TO_CHAR(sh_type_id001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BITS_VALUE', 14+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BITS_VALUE(15) : wbs_ext.sql(8994) : ' || SYSTIMESTAMP);
   END IF; 

   CASE type_id001
      WHEN PMO_CNST.SC_PROJECT THEN
         -- 1
         bits := PMO_CNST.SC_PROJECT_BIT;
         -- 1
      
      WHEN PMO_CNST.SC_DELIVERABLE THEN
         -- 2
         bits := PMO_CNST.SC_DELIVERABLE_BIT;
         -- 2
      
      WHEN PMO_CNST.SC_WORK_PRODUCT THEN
         -- 58
         bits := PMO_CNST.SC_WORK_PRODUCT_BIT;
         -- 4
      
      WHEN PMO_CNST.SC_SUMMARY_TASK THEN
         -- 60
         bits := PMO_CNST.SC_SUMMARY_TASK_BIT;
         -- 8
      
      WHEN PMO_CNST.SC_TASK THEN
         -- 3
         bits := PMO_CNST.SC_TASK_BIT;
         -- 16
         
      
      WHEN PMO_CNST.SC_ACTIVE_ADM_TASK THEN
         -- 313
         bits := PMO_CNST.SC_TASK_BIT;
         -- 16
         
      
      WHEN PMO_CNST.SC_PERSONAL_TASK THEN
         -- 306
         bits := PMO_CNST.SC_TASK_BIT;
         -- 16
         
      
      WHEN PMO_CNST.SC_MILESTONE THEN
         -- 59
         bits := PMO_CNST.SC_MILESTONE_BIT;
         -- 32
      
      WHEN PMO_CNST.SC_WBS_CHANGE_REQUEST THEN
         -- 36
         bits := PMO_CNST.SC_WBS_CHANGE_REQUEST_BIT;
         -- 64
      
      WHEN PMO_CNST.SC_WBS_RISK THEN
         -- 37
         bits := PMO_CNST.SC_WBS_RISK_BIT;
         -- 128
      
      WHEN PMO_CNST.SC_WBS_ISSUE THEN
         -- 39
         bits := PMO_CNST.SC_WBS_ISSUE_BIT;
         -- 256
      
      WHEN PMO_CNST.SC_WBS_REQUIREMENT THEN
         -- 225
         bits := PMO_CNST.SC_WBS_REQUIREMENT_BIT;
         -- 512
      
      WHEN PMO_CNST.SC_WBS_DEFECT THEN
         -- 230
         bits := PMO_CNST.SC_WBS_DEFECT_BIT;
         -- 1024
      
      WHEN PMO_CNST.SC_WBS_SERVICE_REQUEST THEN
         -- 231
         bits := PMO_CNST.SC_WBS_SERVICE_REQUEST_BIT;
         -- 2048
      
      WHEN PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK THEN
         -- 236
         bits := PMO_CNST.SC_WBS_CHANGE_REQUEST_TASK_BIT;
         -- 4096
      
      WHEN PMO_CNST.SC_WBS_RISK_TASK THEN
         -- 237
         bits := PMO_CNST.SC_WBS_RISK_TASK_BIT;
         -- 8192
      
      WHEN PMO_CNST.SC_WBS_ISSUE_TASK THEN
         -- 238
         bits := PMO_CNST.SC_WBS_ISSUE_TASK_BIT;
         -- 16384
      
      WHEN PMO_CNST.SC_WBS_REQUIREMENT_TASK THEN
         -- 241
         bits := PMO_CNST.SC_WBS_REQUIREMENT_TASK_BIT;
         -- 32768
      
      WHEN PMO_CNST.SC_WBS_DEFECT_TASK THEN
         -- 239
         bits := PMO_CNST.SC_WBS_DEFECT_TASK_BIT;
         -- 65536
      
      WHEN PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK THEN
         -- 240
         bits := PMO_CNST.SC_WBS_SERVICE_REQUEST_TASK_BI;
         -- 131072
      
      WHEN PMO_CNST.SC_PROPOSAL THEN
         -- 154
         bits := PMO_CNST.SC_PROPOSAL_BIT;
         -- 262144
      
      WHEN PMO_CNST.SC_PROJ_TYPE1 THEN
         -- 288
         bits := PMO_CNST.SC_PROJ_TYPE1_BIT;
         -- 2097152
      
      WHEN PMO_CNST.SC_PROJ_TYPE2 THEN
         -- 289
         bits := PMO_CNST.SC_PROJ_TYPE2_BIT;
         -- 4194304
      
      WHEN PMO_CNST.SC_PROJ_TYPE3 THEN
         -- 290
         bits := PMO_CNST.SC_PROJ_TYPE3_BIT;
         -- 8388608
      
      WHEN PMO_CNST.SC_WBS_ACTION_ITEM THEN
         -- 259
         bits := PMO_CNST.SC_WBS_ACTION_ITEM_BIT;
         -- 524288
      
      WHEN PMO_CNST.SC_WBS_ACTION_ITEM_TASK THEN
         -- 260
         bits := PMO_CNST.SC_WBS_ACTION_ITEM_TASK_BIT;
         -- 1048576
         -- deliverable, summary task and work product and transferred cri
      
      WHEN PMO_CNST.SC_ALL_DELIVERABLE THEN
         -- 223
         bits := PMO_CNST.SC_ALL_DELIVERABLE_BITS;
         -- 528334
      
      WHEN PMO_CNST.SC_TASK_MILESTONE THEN
         -- 224 (tasks and milestone)
         bits := PMO_CNST.SC_TASK_MILESTONE_BITS;
         -- 1306672
         -- transferred cris (change_request, issue, risk, action item)
      
      WHEN PMO_CNST.SC_TRANSFERRED_CRI THEN
         -- 4
         bits := PMO_CNST.SC_TRANSFERRED_CRI_BITS;
         -- 524736
      
      ELSE
         bits := 0;
   END CASE;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BITS_VALUE', 173+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BITS_VALUE(174) : wbs_ext.sql(9153) : ' || SYSTIMESTAMP);
   END IF; 
   RETURN bits;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BITS_VALUE', 178+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BITS_VALUE(179) : wbs_ext.sql(9158) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BITS_VALUE;
ALTER FUNCTION FC_BITS_VALUE COMPILE DEBUG;

/***********************************************************************************
    Call this function *BEFORE* inserting a record in resource_assignments table
************************************************************************************/

Prompt == FUNCTION FC_BEFORE_I_RES_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_BEFORE_I_RES_ASSIGN
(
     project_id001 IN OUT NOCOPY VARCHAR2
   , res_id001 IN OUT NOCOPY VARCHAR2
   , sh_type_id001 PLS_INTEGER
   , sh_participant001 PLS_INTEGER
   , security_id001 IN OUT NOCOPY VARCHAR2
   , res_type IN OUT NOCOPY VARCHAR2
   , sh_bitflag001 PLS_INTEGER
) RETURN PLS_INTEGER
AS
   type_id001 PLS_INTEGER := sh_type_id001;
   participant001 PLS_INTEGER := sh_participant001;
   bitflag001 PLS_INTEGER := sh_bitflag001;
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_res_type VARCHAR2(1);
   h_security_id VARCHAR2(32);
   h_element_type_bits PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BEFORE_I_RES_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BEFORE_I_RES_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_BEFORE_I_RES_ASSIGN(' || 
       '''' || project_id001 || ''''
          || ', ' || '''' || res_id001 || ''''
          || ', ' || COALESCE(TO_CHAR(sh_type_id001), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_participant001), 'NULL')
          || ', ' || '''' || security_id001 || ''''
          || ', ' || '''' || res_type || ''''
          || ', ' || COALESCE(TO_CHAR(sh_bitflag001), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BEFORE_I_RES_ASSIGN', 34+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BEFORE_I_RES_ASSIGN(35) : wbs_ext.sql(9205) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_project_id := project_id001;
   h_res_id := res_id001;
   h_security_id := security_id001;
   h_res_type := res_type;
   h_type_id := type_id001;
   h_participant := participant001;
   
   h_element_type_bits := FC_BITS_VALUE(h_type_id);
   
   --trace_printf("h_res_id: %s, h_type_id: %d, h_element_type_bits: %d\n", h_res_id,h_type_id,h_element_type_bits);
   BEGIN
      UPDATE PROJECT_ASSIGNMENTS
      SET PARTICIPANT = CASE WHEN h_type_id IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN h_participant ELSE PARTICIPANT END,
      SECURITY_ID = CASE WHEN h_type_id IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN h_security_id ELSE SECURITY_ID END,
      ELEMENT_TYPE_BITS = PMO_STPU.BIT_OR(ELEMENT_TYPE_BITS, h_element_type_bits)
      WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_I_RES_ASSIGN', 66+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_I_RES_ASSIGN(67) : wbs_ext.sql(9237) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("UPDATE__SC_STATE: %d\n", SC_STATE);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      BEGIN
         INSERT INTO PROJECT_ASSIGNMENTS
         (PROJECT_ID, RESOURCE_ID, PARTICIPANT, SECURITY_ID, RESOURCE_TYPE, ELEMENT_TYPE_BITS)
         VALUES(h_project_id, h_res_id,
         CASE WHEN h_type_id IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN h_participant ELSE 0 END,
         CASE WHEN h_type_id IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3) THEN h_security_id ELSE '' END,
         h_res_type, h_element_type_bits);
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_I_RES_ASSIGN', 90+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_I_RES_ASSIGN(91) : wbs_ext.sql(9261) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("INSERT__SC_STATE: %d\n", SC_STATE);
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BEFORE_I_RES_ASSIGN', 98+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BEFORE_I_RES_ASSIGN(99) : wbs_ext.sql(9269) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BEFORE_I_RES_ASSIGN;
ALTER FUNCTION FC_BEFORE_I_RES_ASSIGN COMPILE DEBUG;

/***********************************************************************************
    Call this function *AFTER* changing element_type in resource_assignments table
************************************************************************************/

Prompt == FUNCTION FC_AFTER_U_RES_ASSIGN_TYPE ==
CREATE OR REPLACE FUNCTION FC_AFTER_U_RES_ASSIGN_TYPE
(
     element_id001 IN OUT NOCOPY VARCHAR2
   , sh_old_type_id PLS_INTEGER
   , sh_new_type_id PLS_INTEGER
) RETURN PLS_INTEGER
AS
   old_type_id PLS_INTEGER := sh_old_type_id;
   new_type_id PLS_INTEGER := sh_new_type_id;
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_res_type VARCHAR2(1);
   h_security_id VARCHAR2(32);
   h_new_type_id PLS_INTEGER := 0;
   h_old_type_id PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_RES_ASSIGN IS
         SELECT PARTICIPANT, SECURITY_ID, RESOURCE_TYPE, CASE WHEN RESOURCE_TYPE = '0' THEN RESOURCE_ID ELSE PROFILE_ID END
         FROM RESOURCE_ASSIGNMENTS WHERE ELEMENT_ID = h_id;

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_AFTER_U_RES_ASSIGN_TYPE') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_AFTER_U_RES_ASSIGN_TYPE'), '-- ' || SYSTIMESTAMP, ':r := FC_AFTER_U_RES_ASSIGN_TYPE(' || 
       '''' || element_id001 || ''''
          || ', ' || COALESCE(TO_CHAR(sh_old_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_new_type_id), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AFTER_U_RES_ASSIGN_TYPE', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_AFTER_U_RES_ASSIGN_TYPE(33) : wbs_ext.sql(9314) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := element_id001;
   h_old_type_id := old_type_id;
   h_new_type_id := new_type_id;
   
   BEGIN
      SELECT PROJECT_ID INTO h_project_id FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_U_RES_ASSIGN_TYPE', 50+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_U_RES_ASSIGN_TYPE(51) : wbs_ext.sql(9332) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   OPEN C_RES_ASSIGN;
   
   LOOP
      FETCH C_RES_ASSIGN INTO h_participant, h_security_id, h_res_type, h_res_id;
      IF C_RES_ASSIGN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_temp_var := 0;
      PMO_DB2M.SC_STATE := FC_BEFORE_I_RES_ASSIGN(h_project_id, h_res_id, h_new_type_id, h_participant
                                            , h_security_id, h_res_type, h_temp_var);
      
      h_temp_var := 0;
      PMO_DB2M.SC_STATE := FC_BEFORE_2_D_RES_ASSIGN(h_project_id, h_res_id, h_old_type_id, h_temp_var);
   END LOOP;
   
   BEGIN
      CLOSE C_RES_ASSIGN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_U_RES_ASSIGN_TYPE', 85+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_U_RES_ASSIGN_TYPE(86) : wbs_ext.sql(9367) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AFTER_U_RES_ASSIGN_TYPE', 91+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_AFTER_U_RES_ASSIGN_TYPE(92) : wbs_ext.sql(9373) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_AFTER_U_RES_ASSIGN_TYPE;
ALTER FUNCTION FC_AFTER_U_RES_ASSIGN_TYPE COMPILE DEBUG;

/***********************************************************************************
    Call this function *BEFORE* deleting a record in resource_assignments table
************************************************************************************/

Prompt == FUNCTION FC_BEFORE_2_D_RES_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_BEFORE_2_D_RES_ASSIGN
(
     h_project_id IN OUT NOCOPY VARCHAR2
   , h_res_id IN OUT NOCOPY VARCHAR2
   , sh_h_type_id PLS_INTEGER
   , sh_h_bitflag PLS_INTEGER
) RETURN PLS_INTEGER
AS
   h_type_id PLS_INTEGER := sh_h_type_id;
   h_bitflag PLS_INTEGER := sh_h_bitflag;
   h_element_type_bits PLS_INTEGER := 0;
   h_count PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BEFORE_2_D_RES_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BEFORE_2_D_RES_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_BEFORE_2_D_RES_ASSIGN(' || 
       '''' || h_project_id || ''''
          || ', ' || '''' || h_res_id || ''''
          || ', ' || COALESCE(TO_CHAR(sh_h_type_id), 'NULL')
          || ', ' || COALESCE(TO_CHAR(sh_h_bitflag), 'NULL') || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BEFORE_2_D_RES_ASSIGN', 22+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BEFORE_2_D_RES_ASSIGN(23) : wbs_ext.sql(9408) : ' || SYSTIMESTAMP);
   END IF; 

   h_element_type_bits := FC_BITS_VALUE(h_type_id);
   
   --trace_printf("h_res_id: %s, h_type_id = %d, h_element_type_bits = %d\n",h_res_id,h_type_id,h_element_type_bits);
   
   h_element_type_bits := PMO_CNST.SC_ELEMENT_TYPE_BIT - Coalesce(h_element_type_bits, 0);
   
   --trace_printf("h_bitflag = %d, h_res_id = %d;%s\n",h_bitflag,h_res_id_Ind,h_res_id);
   
   If Coalesce(h_bitflag, 0) = 1 Then
      -- August 20, 2004
      -- ELEMENT_TYPE <> 64 has been removed because we should count
      -- assignments to folders before deleting project_assignments table
      -- senario: I am project manager, I create a cri folder and assigned it to u1
      -- publish to team, login as u1 and unassigned me from cri folder,
      -- if we dont count folders' assignments in resource_assignments then
      -- we remove project_assignment table that is wrong.
      
      BEGIN
         SELECT COUNT(RES_ASSIGNMENT_ID)
         INTO h_count
         FROM RESOURCE_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND
         ((RESOURCE_ID = h_res_id AND RESOURCE_TYPE = '0') OR (PROFILE_ID = h_res_id AND RESOURCE_TYPE = '1'));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_2_D_RES_ASSIGN', 54+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_2_D_RES_ASSIGN(55) : wbs_ext.sql(9440) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 1 Then
         BEGIN
            DELETE FROM PROJECT_ASSIGNMENTS
            WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_2_D_RES_ASSIGN', 73+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_2_D_RES_ASSIGN(74) : wbs_ext.sql(9459) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("SC_STATE = %d, h_type_id = %d, h_project_id = %s\n", SC_STATE,h_type_id,h_project_id);
      Else
         If isProjectType(Coalesce(h_type_id, 0)) <> 0 Then
            BEGIN
               UPDATE PROJECT_ASSIGNMENTS
               SET PARTICIPANT = 0, SECURITY_ID = Null,
               ELEMENT_TYPE_BITS = BITAND(ELEMENT_TYPE_BITS, h_element_type_bits)
               WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_2_D_RES_ASSIGN', 95+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_2_D_RES_ASSIGN(96) : wbs_ext.sql(9481) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
         Else
            BEGIN
               SELECT COUNT(RES_ASSIGNMENT_ID)
               INTO h_count
               FROM RESOURCE_ASSIGNMENTS
               WHERE PROJECT_ID = h_project_id AND ((RESOURCE_ID = h_res_id AND RESOURCE_TYPE = '0') OR (PROFILE_ID = h_res_id AND RESOURCE_TYPE = '1'))
               AND ELEMENT_TYPE = h_type_id;
               PMO_DB2M.SC_STATE := SQLCODE;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_2_D_RES_ASSIGN', 112+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_2_D_RES_ASSIGN(113) : wbs_ext.sql(9498) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If Coalesce(h_count, 0) = 1 Then
               BEGIN
                  UPDATE PROJECT_ASSIGNMENTS
                  SET ELEMENT_TYPE_BITS = BITAND(ELEMENT_TYPE_BITS, h_element_type_bits)
                  WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_2_D_RES_ASSIGN', 132+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_2_D_RES_ASSIGN(133) : wbs_ext.sql(9518) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
            End If;
         End If;
      End If;
   Else
      BEGIN
         SELECT COUNT(RES_ASSIGNMENT_ID)
         INTO h_count
         FROM RESOURCE_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND ((RESOURCE_ID = h_res_id AND RESOURCE_TYPE = '0') OR (PROFILE_ID = h_res_id AND RESOURCE_TYPE = '1'))
         AND ELEMENT_TYPE = h_type_id;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_2_D_RES_ASSIGN', 152+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_2_D_RES_ASSIGN(153) : wbs_ext.sql(9538) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      
      If Coalesce(h_count, 0) = 0 Then
         BEGIN
            UPDATE PROJECT_ASSIGNMENTS
            SET ELEMENT_TYPE_BITS = BITAND(ELEMENT_TYPE_BITS, h_element_type_bits)
            WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_2_D_RES_ASSIGN', 172+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_2_D_RES_ASSIGN(173) : wbs_ext.sql(9558) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BEFORE_2_D_RES_ASSIGN', 180+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BEFORE_2_D_RES_ASSIGN(181) : wbs_ext.sql(9566) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BEFORE_2_D_RES_ASSIGN;
ALTER FUNCTION FC_BEFORE_2_D_RES_ASSIGN COMPILE DEBUG;

/***********************************************************************************
    Call this function *BEFORE* deleting a record in resource_assignments table
************************************************************************************/

Prompt == FUNCTION FC_BEFORE_D_RES_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_BEFORE_D_RES_ASSIGN
(
     res_assign_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_type_id PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_temp_var PLS_INTEGER := 0;
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_BEFORE_D_RES_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_BEFORE_D_RES_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_BEFORE_D_RES_ASSIGN(' || 
       '''' || res_assign_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BEFORE_D_RES_ASSIGN', 18+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_BEFORE_D_RES_ASSIGN(19) : wbs_ext.sql(9597) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := res_assign_id;
   
   BEGIN
      SELECT PROJECT_ID, CASE WHEN RESOURCE_TYPE = '0' THEN RESOURCE_ID ELSE PROFILE_ID END, ELEMENT_TYPE, PARTICIPANT
      INTO h_project_id, h_res_id, h_type_id, h_participant
      FROM RESOURCE_ASSIGNMENTS
      WHERE RES_ASSIGNMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_D_RES_ASSIGN', 37+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_D_RES_ASSIGN(38) : wbs_ext.sql(9616) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("SC_STATE = %d, h_id = %s,h_participant = %d,h_type_id = %d\n", SC_STATE,h_id,h_participant,h_type_id);
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
      IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BEFORE_D_RES_ASSIGN', 45+1) THEN 
         LFILE.FPUT('AllTrace', '                EXIT: FC_BEFORE_D_RES_ASSIGN(46) : wbs_ext.sql(9624) : ' || SYSTIMESTAMP);
      END IF; 
      RETURN 0;
   End If;
   
   If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
      BEGIN
         UPDATE PROJECT_ASSIGNMENTS
         SET ROLLUP_BITS = PMO_CNST.SC_ASSIGNMENT_BIT
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_BEFORE_D_RES_ASSIGN', 65+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_BEFORE_D_RES_ASSIGN(66) : wbs_ext.sql(9644) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   h_temp_var := 1;
   PMO_DB2M.SC_STATE := FC_BEFORE_2_D_RES_ASSIGN(h_project_id, h_res_id, h_type_id, h_temp_var);
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_BEFORE_D_RES_ASSIGN', 75+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_BEFORE_D_RES_ASSIGN(76) : wbs_ext.sql(9654) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_BEFORE_D_RES_ASSIGN;
ALTER FUNCTION FC_BEFORE_D_RES_ASSIGN COMPILE DEBUG;

/****************************************************************************************
    If needing update participant and security, calling this function after updating
    participant and security in resource_assignments table
*****************************************************************************************/

Prompt == FUNCTION FC_AFTER_U_RES_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_AFTER_U_RES_ASSIGN
(
     res_assign_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_AFTER_U_RES_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_AFTER_U_RES_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_AFTER_U_RES_ASSIGN(' || 
       '''' || res_assign_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AFTER_U_RES_ASSIGN', 13+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_AFTER_U_RES_ASSIGN(14) : wbs_ext.sql(9681) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := res_assign_id;
   
   BEGIN
      UPDATE PROJECT_ASSIGNMENTS
      SET (PARTICIPANT, SECURITY_ID, RESOURCE_ID, RESOURCE_TYPE) =
      (SELECT PARTICIPANT, SECURITY_ID, CASE WHEN RESOURCE_TYPE = '0' THEN RESOURCE_ID ELSE PROFILE_ID END, RESOURCE_TYPE
      FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_id)
      WHERE (PROJECT_ID, RESOURCE_ID) IN
      (SELECT PROJECT_ID, CASE WHEN RESOURCE_TYPE = '0' THEN RESOURCE_ID ELSE PROFILE_ID END
      FROM RESOURCE_ASSIGNMENTS WHERE RES_ASSIGNMENT_ID = h_id AND ELEMENT_TYPE IN (PMO_CNST.SC_PROJECT,PMO_CNST.SC_PROPOSAL,PMO_CNST.SC_PROJ_TYPE1,PMO_CNST.SC_PROJ_TYPE2,PMO_CNST.SC_PROJ_TYPE3));
      IF SQL%FOUND = TRUE THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_U_RES_ASSIGN', 39+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_U_RES_ASSIGN(40) : wbs_ext.sql(9707) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   
   PMO_DB2M.SC_STATE := 0;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AFTER_U_RES_ASSIGN', 46+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_AFTER_U_RES_ASSIGN(47) : wbs_ext.sql(9714) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_AFTER_U_RES_ASSIGN;
ALTER FUNCTION FC_AFTER_U_RES_ASSIGN COMPILE DEBUG;

/****************************************************************************************
    Calling this function after replacing resource by profiles or profile by resource.
*****************************************************************************************/

Prompt == FUNCTION FC_AFTER_REPLACE_RES_ASSIGN ==
CREATE OR REPLACE FUNCTION FC_AFTER_REPLACE_RES_ASSIGN
(
     project_id001 IN OUT NOCOPY VARCHAR2
   , res_id001 IN OUT NOCOPY VARCHAR2
   , res_type IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_project_id VARCHAR2(32);
   h_res_id VARCHAR2(32);
   h_security_id VARCHAR2(32);
   h_element_type_bits PLS_INTEGER := 0;
   h_participant PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_table_type PLS_INTEGER := 0;
   h_res_type VARCHAR2(1);
-- Declare Cursors
      CURSOR RES_ASSIGN IS
         SELECT DISTINCT ELEMENT_TYPE, TABLE_TYPE
         FROM RESOURCE_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id
         AND ((RESOURCE_ID = h_res_id AND RESOURCE_TYPE = '0')
         OR (PROFILE_ID = h_res_id AND RESOURCE_TYPE = '1'));

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_AFTER_REPLACE_RES_ASSIGN') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_AFTER_REPLACE_RES_ASSIGN'), '-- ' || SYSTIMESTAMP, ':r := FC_AFTER_REPLACE_RES_ASSIGN(' || 
       '''' || project_id001 || ''''
          || ', ' || '''' || res_id001 || ''''
          || ', ' || '''' || res_type || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AFTER_REPLACE_RES_ASSIGN', 32+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_AFTER_REPLACE_RES_ASSIGN(33) : wbs_ext.sql(9759) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_project_id := project_id001;
   h_res_id := res_id001;
   h_res_type := res_type;
   --trace_printf("*** h_res_id: %s, h_res_type: %s ***\n",h_res_id,h_res_type);
   
   OPEN RES_ASSIGN;
   
   h_element_type_bits := 0;
   h_table_type := PMO_CNST.SC_TABLE_WBS;
   --h_element_type_bits = 0;
   LOOP
      FETCH RES_ASSIGN INTO h_type_id, h_table_type;
      IF RES_ASSIGN%FOUND THEN
         PMO_DB2M.SC_STATE := 0;
      ELSE
         PMO_DB2M.SC_STATE := 100;
      END IF;
      
      If NOT PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
         EXIT;
      End If;
      
      h_element_type_bits := Coalesce(h_element_type_bits, 0) + FC_BITS_VALUE(h_type_id);
   END LOOP;
   
   BEGIN
      CLOSE RES_ASSIGN ;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_REPLACE_RES_ASSIGN', 71+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_REPLACE_RES_ASSIGN(72) : wbs_ext.sql(9798) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("h_res_type: %s, h_element_type_bits: %d, h_table_type: %d\n",h_res_type,h_element_type_bits,h_table_type);
   
   If (Coalesce(h_element_type_bits, 0) = 0) AND (Coalesce(
             h_table_type, 0) = PMO_CNST.SC_TABLE_WBS) Then
      BEGIN
         DELETE FROM PROJECT_ASSIGNMENTS
         WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
         IF SQL%FOUND = TRUE THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_REPLACE_RES_ASSIGN', 92+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_REPLACE_RES_ASSIGN(93) : wbs_ext.sql(9819) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   Else
      BEGIN
         SELECT PARTICIPANT, SECURITY_ID
         INTO h_participant, h_security_id
         FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID = h_project_id
         AND ((RESOURCE_ID = h_res_id AND RESOURCE_TYPE = '0')
         OR (PROFILE_ID = h_res_id AND RESOURCE_TYPE = '1'));
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_REPLACE_RES_ASSIGN', 110+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_REPLACE_RES_ASSIGN(111) : wbs_ext.sql(9837) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
      --trace_printf("1__SC_STATE: %d, h_participant: %d, h_security_id: %s\n",SC_STATE,h_participant,h_security_id);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         h_participant := 0;
         h_security_id := NULL;
      End If;
      --trace_printf("2__SC_STATE: %d, h_participant: %d, h_security_id: %s\n",SC_STATE,h_participant,h_security_id);
      
      If (BITAND(Coalesce(h_participant, 0), PMO_CNST.SC_TEAMMEMBER)) = PMO_CNST.SC_TEAMMEMBER Then
         BEGIN
            UPDATE PROJECT_ASSIGNMENTS
            SET PARTICIPANT = h_participant,
            SECURITY_ID = h_security_id,
            ELEMENT_TYPE_BITS = h_element_type_bits,
            ROLLUP_BITS = PMO_CNST.SC_ASSIGNMENT_BIT,
            RESOURCE_TYPE = h_res_type
            WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_REPLACE_RES_ASSIGN', 141+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_REPLACE_RES_ASSIGN(142) : wbs_ext.sql(9868) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      Else
         BEGIN
            UPDATE PROJECT_ASSIGNMENTS
            SET PARTICIPANT = h_participant,
            SECURITY_ID = h_security_id,
            ELEMENT_TYPE_BITS = h_element_type_bits,
            ROLLUP_BITS = PMO_CNST.SC_ASSIGNMENT_BIT,
            RESOURCE_TYPE = h_res_type
            WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_REPLACE_RES_ASSIGN', 164+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_REPLACE_RES_ASSIGN(165) : wbs_ext.sql(9891) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
      End If;
      --trace_printf("UPDATE_* SC_STATE: %d, h_participant: %d\n",SC_STATE,h_participant);
      
      If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
         BEGIN
            INSERT INTO PROJECT_ASSIGNMENTS
            (PROJECT_ID, RESOURCE_ID, PARTICIPANT, SECURITY_ID, RESOURCE_TYPE, ELEMENT_TYPE_BITS,ROLLUP_BITS)
            VALUES(h_project_id, h_res_id, h_participant, h_security_id,
            h_res_type, h_element_type_bits, PMO_CNST.SC_ASSIGNMENT_BIT);
            IF SQL%FOUND = TRUE THEN
               PMO_DB2M.SC_STATE := 0;
            ELSE
               PMO_DB2M.SC_STATE := 100;
            END IF;
         EXCEPTION
            WHEN OTHERS THEN
            BEGIN
               PMO_DB2M.SC_STATE := SQLCODE;
               IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_AFTER_REPLACE_RES_ASSIGN', 187+1) THEN 
                  LFILE.FPUT('AllTrace', '           EXCEPTION: FC_AFTER_REPLACE_RES_ASSIGN(188) : wbs_ext.sql(9914) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
               END IF; 
            END;
         END;
         --trace_printf("INSERT_* SC_STATE: %d, h_security_id: %s\n",SC_STATE,h_security_id);
      End If;
   End If;
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_AFTER_REPLACE_RES_ASSIGN', 195+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_AFTER_REPLACE_RES_ASSIGN(196) : wbs_ext.sql(9922) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_AFTER_REPLACE_RES_ASSIGN;
ALTER FUNCTION FC_AFTER_REPLACE_RES_ASSIGN COMPILE DEBUG;

/***********************************************************************************
    Call this function *BEFORE* deleting a wbs's element in resource_assignments table
************************************************************************************/

Prompt == FUNCTION FC_U_PROJ_ASSIGN_BEFORE_D_WBS ==
CREATE OR REPLACE FUNCTION FC_U_PROJ_ASSIGN_BEFORE_D_WBS
(
     h_element_id IN OUT NOCOPY VARCHAR2
) RETURN PLS_INTEGER
AS
   h_id VARCHAR2(32);
   h_project_id VARCHAR2(32);
   h_rank VARCHAR2(200);
   h_rank2 VARCHAR2(200);
   h_res_id VARCHAR2(32);
   h_element_type_bits PLS_INTEGER := 0;
   h_type_id PLS_INTEGER := 0;
   h_cri_count PLS_INTEGER := 0;
-- Declare Cursors
      CURSOR C_D_WBS IS
         SELECT DISTINCT PROJECT_ID, CASE WHEN RESOURCE_TYPE = '0' THEN RESOURCE_ID ELSE PROFILE_ID END, ELEMENT_TYPE
         FROM RESOURCE_ASSIGNMENTS
         WHERE ELEMENT_ID IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank);

BEGIN
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_PARAMS('FC_U_PROJ_ASSIGN_BEFORE_D_WBS') THEN 
      LFILE.FPUT_PARAMS('AllTrace', ALLTRACES.LINES_BEFORE_PARAMS('FC_U_PROJ_ASSIGN_BEFORE_D_WBS'), '-- ' || SYSTIMESTAMP, ':r := FC_U_PROJ_ASSIGN_BEFORE_D_WBS(' || 
       '''' || h_element_id || '''' || ');');
   END IF; 

   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJ_ASSIGN_BEFORE_D_WBS', 26+1) THEN 
      LFILE.FPUT('AllTrace', '               ENTER: FC_U_PROJ_ASSIGN_BEFORE_D_WBS(27) : wbs_ext.sql(9961) : ' || SYSTIMESTAMP);
   END IF; 

   -- Declare host variables
   
   -- Validate id
   h_id := h_element_id;
   
   BEGIN
      SELECT CRI_COUNT, RANK INTO h_cri_count, h_rank2 FROM TMT_WBS WHERE ELEMENT_ID = h_id;
      PMO_DB2M.SC_STATE := SQLCODE;
   EXCEPTION
      WHEN OTHERS THEN
      BEGIN
         PMO_DB2M.SC_STATE := SQLCODE;
         IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJ_ASSIGN_BEFORE_D_WBS', 42+1) THEN 
            LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJ_ASSIGN_BEFORE_D_WBS(43) : wbs_ext.sql(9977) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
         END IF; 
      END;
   END;
   --trace_printf("1_* SC_STATE: %d, h_id: %s, h_cri_count: %d, h_rank2: %s\n",SC_STATE,h_id,h_cri_count,h_rank);
   
   h_rank := h_rank2;
   h_rank := h_rank || '%';
   
   If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_SUCCESS Then
      OPEN C_D_WBS;
      
      LOOP
         FETCH C_D_WBS INTO h_project_id, h_res_id, h_type_id;
         IF C_D_WBS%FOUND THEN
            PMO_DB2M.SC_STATE := 0;
         ELSE
            PMO_DB2M.SC_STATE := 100;
         END IF;
         If PMO_DB2M.SC_STATE <> PMO_DB2M.SC_SQL_SUCCESS Then
            EXIT;
         End If;
         
         h_element_type_bits := FC_BITS_VALUE(h_type_id);
         If Coalesce(h_element_type_bits, 0) <> 0 Then
            PMODEFINES.PMO_PMO_VERIFY_RANK(h_rank, 1);
            BEGIN
               DELETE FROM PROJECT_ASSIGNMENTS P
               WHERE P.PROJECT_ID = h_project_id AND P.RESOURCE_ID = h_res_id
               AND NOT EXISTS (SELECT RES_ASSIGNMENT_ID FROM RESOURCE_ASSIGNMENTS R, TMT_WBS W
               WHERE R.PROJECT_ID = h_project_id AND (R.RESOURCE_ID = h_res_id OR R.PROFILE_ID = h_res_id)
               AND R.ELEMENT_ID = W.ELEMENT_ID AND R.PROJECT_ID = W.PROJECT_ID
               AND (W.RANK NOT LIKE h_rank
               OR (W.TRANSFER_FLAG IS NOT Null
               AND
               (W.TYPE_ID IN (PMO_CNST.SC_DELIVERABLE,PMO_CNST.SC_DELIVERABLE_TYPE1,PMO_CNST.SC_DELIVERABLE_TYPE2,PMO_CNST.SC_DELIVERABLE_TYPE3,PMO_CNST.SC_WORK_PRODUCT,PMO_CNST.SC_SUMMARY_TASK,PMO_CNST.SC_WBS_CHANGE_REQUEST,PMO_CNST.SC_WBS_RISK,PMO_CNST.SC_WBS_ISSUE,PMO_CNST.SC_WBS_REQUIREMENT,PMO_CNST.SC_WBS_DEFECT,PMO_CNST.SC_WBS_SERVICE_REQUEST,PMO_CNST.SC_WBS_ACTION_ITEM) OR W.ACTUAL_START IS Null))));
               IF SQL%FOUND = TRUE THEN
                  PMO_DB2M.SC_STATE := 0;
               ELSE
                  PMO_DB2M.SC_STATE := 100;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN
               BEGIN
                  PMO_DB2M.SC_STATE := SQLCODE;
                  IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJ_ASSIGN_BEFORE_D_WBS', 88+1) THEN 
                     LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJ_ASSIGN_BEFORE_D_WBS(89) : wbs_ext.sql(10023) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                  END IF; 
               END;
            END;
            
            If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
               h_element_type_bits := PMO_CNST.SC_ELEMENT_TYPE_BIT - Coalesce(h_element_type_bits, 0);
               
               BEGIN
                  UPDATE PROJECT_ASSIGNMENTS
                  SET ELEMENT_TYPE_BITS = BITAND(ELEMENT_TYPE_BITS, h_element_type_bits),
                  ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT)
                  WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id
                  AND NOT EXISTS(SELECT RES_ASSIGNMENT_ID FROM RESOURCE_ASSIGNMENTS
                  WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id
                  AND ELEMENT_ID NOT IN (SELECT ELEMENT_ID FROM TMT_WBS WHERE RANK LIKE h_rank)
                  AND ELEMENT_TYPE = h_type_id);
                  IF SQL%FOUND = TRUE THEN
                     PMO_DB2M.SC_STATE := 0;
                  ELSE
                     PMO_DB2M.SC_STATE := 100;
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                  BEGIN
                     PMO_DB2M.SC_STATE := SQLCODE;
                     IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJ_ASSIGN_BEFORE_D_WBS', 115+1) THEN 
                        LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJ_ASSIGN_BEFORE_D_WBS(116) : wbs_ext.sql(10050) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                     END IF; 
                  END;
               END;
               
               --The following code is for making sure that the project assignments will be considered for Roll-Up
               If PMO_DB2M.SC_STATE = PMO_DB2M.SC_SQL_NO_DATA Then
                  BEGIN
                     UPDATE PROJECT_ASSIGNMENTS
                     SET ROLLUP_BITS = PMO_STPU.BIT_OR(ROLLUP_BITS, PMO_CNST.SC_ASSIGNMENT_BIT)
                     WHERE PROJECT_ID = h_project_id AND RESOURCE_ID = h_res_id;
                     IF SQL%FOUND = TRUE THEN
                        PMO_DB2M.SC_STATE := 0;
                     ELSE
                        PMO_DB2M.SC_STATE := 100;
                     END IF;
                  EXCEPTION
                     WHEN OTHERS THEN
                     BEGIN
                        PMO_DB2M.SC_STATE := SQLCODE;
                        IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJ_ASSIGN_BEFORE_D_WBS', 136+1) THEN 
                           LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJ_ASSIGN_BEFORE_D_WBS(137) : wbs_ext.sql(10071) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
                        END IF; 
                     END;
                  END;
               End If;
            End If;
         End If;
      END LOOP;
      
      BEGIN
         CLOSE C_D_WBS ;
         PMO_DB2M.SC_STATE := SQLCODE;
      EXCEPTION
         WHEN OTHERS THEN
         BEGIN
            PMO_DB2M.SC_STATE := SQLCODE;
            IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(16, 'FC_U_PROJ_ASSIGN_BEFORE_D_WBS', 153+1) THEN 
               LFILE.FPUT('AllTrace', '           EXCEPTION: FC_U_PROJ_ASSIGN_BEFORE_D_WBS(154) : wbs_ext.sql(10088) : ' || SYSTIMESTAMP || ' ' || 'SQLCODE: ' || SQLCODE || ' SQLERR: ' || SubStr(SQLERRM, 1, 500));
            END IF; 
         END;
      END;
   End If;
   
   IF ALLTRACES.TRACE_ENABLED AND ALLTRACES.CHECK_TRACE(1, 'FC_U_PROJ_ASSIGN_BEFORE_D_WBS', 160+1) THEN 
      LFILE.FPUT('AllTrace', '                EXIT: FC_U_PROJ_ASSIGN_BEFORE_D_WBS(161) : wbs_ext.sql(10095) : ' || SYSTIMESTAMP || ' ' || 'STATE: ' || PMO_DB2M.SC_STATE);
   END IF; 
   RETURN PMO_DB2M.SC_STATE;
END;
/
SHOW ERRORS FUNCTION FC_U_PROJ_ASSIGN_BEFORE_D_WBS;
ALTER FUNCTION FC_U_PROJ_ASSIGN_BEFORE_D_WBS COMPILE DEBUG;

