
CREATE TABLE PROJECT_ASSIGNMENTS (
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_TYPE VARCHAR2(1) DEFAULT '0' NOT NULL,
	RESOURCE_ID VARCHAR2(32) NOT NULL,
	PARTICIPANT NUMBER(10) DEFAULT 0 NOT NULL,
	SECURITY_ID CHAR(32),
	ELEMENT_TYPE_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	SD NUMBER(5),
	FD NUMBER(5),
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATION_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_START TIMESTAMP,
	BASELINE_FINISH TIMESTAMP,
	BASELINE_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PLANNED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PLANNED_WORK NUMBER(19) DEFAULT 0 NOT NULL,
	PLANNED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_WORK NUMBER(19) DEFAULT 0 NOT NULL,
	PROPOSED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	SCHED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_WORK NUMBER(19) DEFAULT 0 NOT NULL,
	SCHED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	FORECAST_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	FORECAST_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	REGULAR_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	SPECIAL_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	BILLABLE_REGULAR_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	BILLABLE_SPECIAL_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	BILLABLE_WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ACTUAL_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	CONTOUR_STRING VARCHAR2(2048),
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATION_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DESCRIPTION VARCHAR2(255),
	REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_SCHED_START TIMESTAMP,
	ESTIMATED_SCHED_FINISH TIMESTAMP,
	ESTIMATED_SCHED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_SCHED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_SCHED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PLANNED_START TIMESTAMP,
	ESTIMATED_PLANNED_FINISH TIMESTAMP,
	ESTIMATED_PLANNED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_PLANNED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PLANNED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE1_START TIMESTAMP,
	ESTIMATED_BASELINE1_FINISH TIMESTAMP,
	ESTIMATED_BASELINE1_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE1_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE1_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2_START TIMESTAMP,
	ESTIMATED_BASELINE2_FINISH TIMESTAMP,
	ESTIMATED_BASELINE2_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE2_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3_START TIMESTAMP,
	ESTIMATED_BASELINE3_FINISH TIMESTAMP,
	ESTIMATED_BASELINE3_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE3_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEVEL_PLANNED_START TIMESTAMP,
	LEVEL_PLANNED_FINISH TIMESTAMP,
	LEVEL_SCHED_START TIMESTAMP,
	LEVEL_SCHED_FINISH TIMESTAMP
);

CREATE TABLE TMT_PORTFOLIOS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	PARENT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	RESOURCE_ID VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT '0' NOT NULL,
	RANK VARCHAR2(192) NOT NULL
);

CREATE TABLE TMT_GLOBAL_SECURITY (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	PARENT_ID VARCHAR2(32),
	ELEMENT_ID CHAR(32),
	ELEMENT_NAME VARCHAR2(50),
	INT_1 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_2 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_3 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_4 NUMBER(10) DEFAULT 0 NOT NULL,
	NOTI_1 NUMBER(10) DEFAULT 0 NOT NULL,
	NOTI_2 NUMBER(10) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32) DEFAULT 'PMO_SUPERVISOR' NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	INT_5 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_6 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_7 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_8 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_9 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_10 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_11 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_12 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_13 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_14 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_15 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_16 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_17 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_18 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_19 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_20 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_21 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_22 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_23 NUMBER(10) DEFAULT 0 NOT NULL,
	INT_24 NUMBER(10) DEFAULT 0 NOT NULL,
	SECURITY_GROUP NUMBER(10) DEFAULT 0 NOT NULL
);

CREATE TABLE CALENDAR_DAY_OF_YEAR (
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	DAY_YEAR DATE DEFAULT SYSDATE NOT NULL,
	DAY_WEEK NUMBER(5) DEFAULT 0 NOT NULL,
	AVAILABLE_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	BIT_SCHED RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	WEEK_OF NUMBER(5) DEFAULT 0 NOT NULL,
	MONTH_OF NUMBER(5) DEFAULT 0 NOT NULL,
	YEAR_OF NUMBER(10) DEFAULT 0 NOT NULL
);

CREATE TABLE CALENDAR_EXCEPTIONS (
	ELEMENT_TYPE NUMBER(10),
	DAY_STATUS VARCHAR2(1),
	DEFAULT_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	EXCEPTION_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	EXCEPTION_DATE DATE,
	EXCEPTION_ID VARCHAR2(32),
	CALENDAR_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	EXCEPTION_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	EXCEPTION_NAME VARCHAR2(50),
	CALENDAR_RANK VARCHAR2(128),
	EXCEPTION_DESCRIPTION VARCHAR2(255)
);

CREATE TABLE RESOURCES (
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	FULL_NAME VARCHAR2(100),
	FIRST_NAME VARCHAR2(35),
	MIDDLE_NAME VARCHAR2(35),
	LAST_NAME VARCHAR2(35),
	E_MAIL_ADDRESS VARCHAR2(255),
	LOGON_NAME VARCHAR2(100),
	LOGON_PASSWORD RAW(128),
	KEY_HISTORY RAW(255),
	LOGON_REMINDER VARCHAR2(64),
	CLEARANCE_LEVEL_1 NUMBER(10) DEFAULT 1275905024 NOT NULL,
	CLEARANCE_LEVEL_2 NUMBER(10) DEFAULT 1280101580 NOT NULL,
	CLEARANCE_LEVEL_3 NUMBER(10) DEFAULT 4 NOT NULL,
	CLEARANCE_LEVEL_4 NUMBER(10) DEFAULT 0 NOT NULL,
	CLEARANCE_LEVEL_5 NUMBER(10) DEFAULT 0 NOT NULL,
	MULTIPLE_LOGINS VARCHAR2(1),
	PASSWORD_EXPIRES DATE,
	WEBSITE VARCHAR2(100),
	PRIMARY_ROLE VARCHAR2(32),
	TITLE VARCHAR2(50),
	ADDRESS1 VARCHAR2(50),
	ADDRESS2 VARCHAR2(50),
	ZIP_AREA_CODE VARCHAR2(16),
	CITIZENSHIP NUMBER(10),
	CALENDAR_ID VARCHAR2(32),
	ACTIVE VARCHAR2(1),
	EFFECTIVE_DATE DATE,
	DISCONTINUE_DATE DATE,
	STATUS1_ID NUMBER(10) DEFAULT 309,
	STATUS2_ID NUMBER(10) DEFAULT 316,
	CREATED_DATE TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	CREATED_BY VARCHAR2(32),
	CHARGE_CODE VARCHAR2(32),
	MAXDAYHRS NUMBER(5),
	MINDAYHRS NUMBER(5),
	PERCENT_TO_ASSIGN NUMBER(6,2),
	RATE_ID VARCHAR2(32),
	HOME_OFFICE VARCHAR2(50),
	WORK_LOCATION NUMBER(10) DEFAULT 1,
	WORK_PHONE VARCHAR2(50),
	ALTERNATE_PHONE VARCHAR2(50),
	FAX_NUMBER VARCHAR2(21),
	CELL_NUMBER VARCHAR2(21),
	PAGER_NUMBER VARCHAR2(32),
	ICQ_MESSAGING VARCHAR2(16),
	NOTES_MAIL_ID VARCHAR2(100),
	NOTES_ID VARCHAR2(100),
	ASSIGN_STATUS VARCHAR2(32),
	EXPERIENCE_ID NUMBER(10) DEFAULT 2771,
	ALIAS VARCHAR2(80),
	LAST_USED DATE,
	EXEC_LEVEL VARCHAR2(50),
	VERIFIED_1 VARCHAR2(32),
	VERIFIED_2 VARCHAR2(32),
	WILLING_RELOC VARCHAR2(1) DEFAULT '0',
	RELOC_DURATION VARCHAR2(16),
	WORK_RELOC_1 VARCHAR2(32),
	WORK_RELOC_2 VARCHAR2(32),
	WORK_RELOC_3 VARCHAR2(32),
	WILLING_TRAVEL VARCHAR2(1) DEFAULT '0',
	TRAVEL_DURATION VARCHAR2(16),
	TRAVEL_DEST_1 VARCHAR2(32),
	TRAVEL_DEST_2 VARCHAR2(32),
	TRAVEL_DEST_3 VARCHAR2(32),
	PASPORT_VALID VARCHAR2(1) DEFAULT '0',
	PASPORT_EXPIRATION DATE,
	COUNTRY_VISA_1 VARCHAR2(32),
	VISA_EXPIRES_1 DATE,
	COUNTRY_VISA_2 VARCHAR2(32),
	VISA_EXPIRES_2 DATE,
	COUNTRY_VISA_3 VARCHAR2(32),
	VISA_EXPIRES_3 DATE,
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 4747,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	LAST_LOGIN TIMESTAMP,
	LANGUAGE_ISO_CODE VARCHAR2(2) DEFAULT 'US',
	FS_CODE VARCHAR2(50),
	FS_LABOR_CODE VARCHAR2(50) DEFAULT 'PMOFFICE',
	EXPERIENCE_TXT VARCHAR2(512),
	ACHIVEMENTS VARCHAR2(512),
	PASSIONS VARCHAR2(512),
	SUMMARY_SKILLS VARCHAR2(512),
	MISCELLANEOUS VARCHAR2(512),
	MAX_PASSWORD_FAILURE NUMBER(5) DEFAULT 0 NOT NULL,
	NICK_NAME VARCHAR2(100),
	PORTAL_PAGE VARCHAR2(2048),
	DASHBOARD VARCHAR2(2048),
	OVERWRITEFILE VARCHAR2(1) DEFAULT 'Y',
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	EXECUTIVE_SECURITY CHAR(32),
	MY_PORTAL_URL_1 VARCHAR2(512),
	MY_PORTAL_URL_2 VARCHAR2(512),
	MY_PORTAL_URL_3 VARCHAR2(512),
	MY_PORTAL_URL_4 VARCHAR2(512),
	MY_PORTAL_URL_5 VARCHAR2(512),
	USER_GROUP_ID VARCHAR2(32) DEFAULT 'DEFAULT_SECURITY_ROLE' NOT NULL,
	COUNTRY_CODE VARCHAR2(10),
	COMPANY_CODE VARCHAR2(10),
	EMPLOYEE_CODE VARCHAR2(10),
	CUSTOM_01 VARCHAR2(50),
	CUSTOM_02 VARCHAR2(50),
	CUSTOM_03 VARCHAR2(50),
	CUSTOM_04 VARCHAR2(50),
	CUSTOM_05 VARCHAR2(50),
	DIVISION_CODE VARCHAR2(10),
	DEPARTMENT_CODE VARCHAR2(10),
	RES_BLOB BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE HISTORY_RESOURCES (
	HISTORY_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	FULL_NAME VARCHAR2(100),
	FIRST_NAME VARCHAR2(35),
	MIDDLE_NAME VARCHAR2(35),
	LAST_NAME VARCHAR2(35),
	E_MAIL_ADDRESS VARCHAR2(255),
	LOGON_NAME VARCHAR2(100),
	LOGON_PASSWORD RAW(128),
	KEY_HISTORY RAW(255),
	LOGON_REMINDER VARCHAR2(64),
	CLEARANCE_LEVEL_1 NUMBER(10) DEFAULT 1275905024 NOT NULL,
	CLEARANCE_LEVEL_2 NUMBER(10) DEFAULT 1280101580 NOT NULL,
	CLEARANCE_LEVEL_3 NUMBER(10) DEFAULT 4 NOT NULL,
	CLEARANCE_LEVEL_4 NUMBER(10) DEFAULT 0 NOT NULL,
	CLEARANCE_LEVEL_5 NUMBER(10) DEFAULT 0 NOT NULL,
	MULTIPLE_LOGINS VARCHAR2(1),
	PASSWORD_EXPIRES DATE,
	WEBSITE VARCHAR2(100),
	PRIMARY_ROLE VARCHAR2(32),
	TITLE VARCHAR2(50),
	ADDRESS1 VARCHAR2(50),
	ADDRESS2 VARCHAR2(50),
	ZIP_AREA_CODE VARCHAR2(16),
	CITIZENSHIP NUMBER(10),
	CALENDAR_ID VARCHAR2(32),
	ACTIVE VARCHAR2(1),
	EFFECTIVE_DATE DATE,
	DISCONTINUE_DATE DATE,
	STATUS1_ID NUMBER(10) DEFAULT 309,
	STATUS2_ID NUMBER(10) DEFAULT 316,
	CREATED_DATE TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	CREATED_BY VARCHAR2(32),
	CHARGE_CODE VARCHAR2(32),
	MAXDAYHRS NUMBER(5),
	MINDAYHRS NUMBER(5),
	PERCENT_TO_ASSIGN NUMBER(6,2),
	RATE_ID VARCHAR2(32),
	HOME_OFFICE VARCHAR2(50),
	WORK_LOCATION NUMBER(10) DEFAULT 1,
	WORK_PHONE VARCHAR2(50),
	ALTERNATE_PHONE VARCHAR2(50),
	FAX_NUMBER VARCHAR2(21),
	CELL_NUMBER VARCHAR2(21),
	PAGER_NUMBER VARCHAR2(32),
	ICQ_MESSAGING VARCHAR2(16),
	NOTES_MAIL_ID VARCHAR2(100),
	NOTES_ID VARCHAR2(100),
	ASSIGN_STATUS VARCHAR2(32),
	EXPERIENCE_ID NUMBER(10) DEFAULT 2771,
	ALIAS VARCHAR2(80),
	LAST_USED DATE,
	EXEC_LEVEL VARCHAR2(50),
	VERIFIED_1 VARCHAR2(32),
	VERIFIED_2 VARCHAR2(32),
	WILLING_RELOC VARCHAR2(1) DEFAULT '0',
	RELOC_DURATION VARCHAR2(16),
	WORK_RELOC_1 VARCHAR2(32),
	WORK_RELOC_2 VARCHAR2(32),
	WORK_RELOC_3 VARCHAR2(32),
	WILLING_TRAVEL VARCHAR2(1) DEFAULT '0',
	TRAVEL_DURATION VARCHAR2(16),
	TRAVEL_DEST_1 VARCHAR2(32),
	TRAVEL_DEST_2 VARCHAR2(32),
	TRAVEL_DEST_3 VARCHAR2(32),
	PASPORT_VALID VARCHAR2(1) DEFAULT '0',
	PASPORT_EXPIRATION DATE,
	COUNTRY_VISA_1 VARCHAR2(32),
	VISA_EXPIRES_1 DATE,
	COUNTRY_VISA_2 VARCHAR2(32),
	VISA_EXPIRES_2 DATE,
	COUNTRY_VISA_3 VARCHAR2(32),
	VISA_EXPIRES_3 DATE,
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 4747,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	LAST_LOGIN TIMESTAMP,
	LANGUAGE_ISO_CODE VARCHAR2(2) DEFAULT 'US',
	FS_CODE VARCHAR2(50),
	FS_LABOR_CODE VARCHAR2(50) DEFAULT 'PMOFFICE',
	EXPERIENCE_TXT VARCHAR2(512),
	ACHIVEMENTS VARCHAR2(512),
	PASSIONS VARCHAR2(512),
	SUMMARY_SKILLS VARCHAR2(512),
	MISCELLANEOUS VARCHAR2(512),
	MAX_PASSWORD_FAILURE NUMBER(5) DEFAULT 0 NOT NULL,
	NICK_NAME VARCHAR2(100),
	PORTAL_PAGE VARCHAR2(2048),
	DASHBOARD VARCHAR2(2048),
	OVERWRITEFILE VARCHAR2(1) DEFAULT 'Y',
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	EXECUTIVE_SECURITY CHAR(32),
	MY_PORTAL_URL_1 VARCHAR2(512),
	MY_PORTAL_URL_2 VARCHAR2(512),
	MY_PORTAL_URL_3 VARCHAR2(512),
	MY_PORTAL_URL_4 VARCHAR2(512),
	MY_PORTAL_URL_5 VARCHAR2(512),
	USER_GROUP_ID VARCHAR2(32) DEFAULT 'DEFAULT_SECURITY_ROLE' NOT NULL,
	COUNTRY_CODE VARCHAR2(10),
	COMPANY_CODE VARCHAR2(10),
	EMPLOYEE_CODE VARCHAR2(10),
	CUSTOM_01 VARCHAR2(50),
	CUSTOM_02 VARCHAR2(50),
	CUSTOM_03 VARCHAR2(50),
	CUSTOM_04 VARCHAR2(50),
	CUSTOM_05 VARCHAR2(50),
	DIVISION_CODE VARCHAR2(10),
	DEPARTMENT_CODE VARCHAR2(10),
	RES_BLOB BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE TMT_WBS (
	RANK VARCHAR2(192) NOT NULL,
	WBS_CODE VARCHAR2(255),
	PROJECT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	REF_CODE VARCHAR2(50),
	PRIORITY NUMBER(5) DEFAULT 500,
	PUBLISHED VARCHAR2(1) DEFAULT '0' NOT NULL,
	PUBLISHED_BY VARCHAR2(32),
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	CONSTRAINT_DT TIMESTAMP,
	OPPORTUNITY_NAME VARCHAR2(50),
	PURSUIT_START DATE,
	PURSUIT_FINISH DATE,
	FORECAST_CLOSED DATE,
	EXPECTED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_MARGIN NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	CALENDAR_ID VARCHAR2(32),
	MINUTE_PER_DAY NUMBER(5) DEFAULT 480,
	MINUTE_PER_WEEK NUMBER(5) DEFAULT 2400,
	METHOD NUMBER(10) DEFAULT 0,
	BUFFER_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	START_FINISH_FLAG VARCHAR2(1) DEFAULT '0',
	START_FINISH_DATE DATE,
	SD NUMBER(5) DEFAULT 11 NOT NULL,
	FD NUMBER(5) DEFAULT 12 NOT NULL,
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE3_START TIMESTAMP,
	BASELINE3_FINISH TIMESTAMP,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0,
	DURATION NUMBER(10) DEFAULT 0,
	PLANNED_DURATION NUMBER(10) DEFAULT 0,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0,
	SCHED_DURATION NUMBER(10) DEFAULT 0,
	FORECAST_DURATION NUMBER(10) DEFAULT 0,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0,
	BASELINE3_DURATION NUMBER(10) DEFAULT 0,
	VARIANCE NUMBER(10) DEFAULT 0,
	FORECAST_VARIANCE NUMBER(10) DEFAULT 0,
	ACTUAL_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE1_VARIANCE NUMBER(10) DEFAULT 0,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	PROPOSED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	SCHED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	FORECAST_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	ACTUAL_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE1_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE2_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE3_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	CREATED_DT TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	PROBABILITY NUMBER(10) DEFAULT 100,
	STAGE_ID NUMBER(10) DEFAULT 740,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	CLOSED_BY VARCHAR2(32),
	TOOLTIP_DESCR VARCHAR2(255) DEFAULT NULL,
	TOTAL_SLACK NUMBER(10),
	FREE_SLACK NUMBER(10),
	CRITICAL VARCHAR2(1),
	ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DEPENDENCIES CLOB DEFAULT EMPTY_CLOB(),
	ROLLUP_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	EV_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	CRI_COUNT NUMBER(10) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	MSP_ID NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ASSIGN_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	RTF_BITS NUMBER(10) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TRANSFER_FLAG VARCHAR2(1),
	EFFORT_DRIVEN NUMBER(5) DEFAULT 1 NOT NULL,
	BUBBLE_COLOR NUMBER(5) DEFAULT 0 NOT NULL,
	BUBBLE_PUBLISHED_DT TIMESTAMP,
	A_CRI_COUNT NUMBER(5) DEFAULT 0,
	TASK_TYPE NUMBER(5) DEFAULT 10 NOT NULL,
	FS_CODE VARCHAR2(50),
	FS_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	FS_LABOR_CODE VARCHAR2(50),
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_FLAGS NUMBER(10) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	EARLY_START TIMESTAMP,
	LATE_START TIMESTAMP,
	EARLY_FINISH TIMESTAMP,
	LATE_FINISH TIMESTAMP,
	LEVEL_INDEX NUMBER(10) DEFAULT 0,
	CALC_PRIORITY NUMBER(5) DEFAULT 500,
	LEVEL_CONFLICT VARCHAR2(4000),
	LEVEL_START TIMESTAMP,
	LEVEL_FINISH TIMESTAMP,
	LEVEL_DURATION NUMBER(10) DEFAULT 0,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	FINISH_START_DATE DATE,
	TOTAL_DURATION NUMBER(19) DEFAULT 0 NOT NULL,
	PREVIOUS_WKF_STEP VARCHAR2(150),
	DEPEND_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	START_FINISH_DURATION NUMBER(10) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE1_START DATE,
	ESTIMATED_BASELINE1_FINISH DATE,
	ESTIMATED_BASELINE2_START DATE,
	ESTIMATED_BASELINE2_FINISH DATE,
	ESTIMATED_BASELINE3_START DATE,
	ESTIMATED_BASELINE3_FINISH DATE,
	ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_EST_DT TIMESTAMP,
	BASELINE2_EST_DT TIMESTAMP,
	BASELINE3_EST_DT TIMESTAMP,
	BASELINE1_SCH_DT TIMESTAMP,
	BASELINE2_SCH_DT TIMESTAMP,
	BASELINE3_SCH_DT TIMESTAMP,
	EXPECTED_PAYBACK_PERIOD NUMBER(10) DEFAULT 0,
	EXPECTED_PAYBACK_MONTH NUMBER(10) DEFAULT 0,
	CUSTOM_INT_1 NUMBER(10) DEFAULT 0,
	SUBPROJECT_COUNT NUMBER(10) DEFAULT 0,
	ESTIMATED_BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE3_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	RISK_EXPOSURE NUMBER(10) DEFAULT 0 NOT NULL,
	CONSEQUENSE_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EV_ETC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEVEL_STATE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_DT VARCHAR2(26),
	WORK_PERCENT NUMBER(5) DEFAULT 0,
	MP_STATUS_DT TIMESTAMP,
	REFERENCE_NUMBER NUMBER(19),
	ASSET_ID VARCHAR2(32),
	ASSET_NAME VARCHAR2(50),
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 6501,
	POOL_ID VARCHAR2(32),
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	BASELINE3_START_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE3_FINISH_VARIANCE NUMBER(10) DEFAULT 0,
	ELEMENT_FLAG NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE HISTORY_WBS (
	HISTORY_ID VARCHAR2(32),
	RANK VARCHAR2(192) NOT NULL,
	WBS_CODE VARCHAR2(255),
	PROJECT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	REF_CODE VARCHAR2(50),
	PRIORITY NUMBER(5) DEFAULT 500,
	PUBLISHED VARCHAR2(1) DEFAULT '0' NOT NULL,
	PUBLISHED_BY VARCHAR2(32),
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	CONSTRAINT_DT TIMESTAMP,
	OPPORTUNITY_NAME VARCHAR2(50),
	PURSUIT_START DATE,
	PURSUIT_FINISH DATE,
	FORECAST_CLOSED DATE,
	EXPECTED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_MARGIN NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENCY_ID NUMBER(10) DEFAULT 0,
	CALENDAR_ID VARCHAR2(32),
	MINUTE_PER_DAY NUMBER(5) DEFAULT 480,
	MINUTE_PER_WEEK NUMBER(5) DEFAULT 2400,
	METHOD NUMBER(10) DEFAULT 0,
	BUFFER_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	START_FINISH_FLAG VARCHAR2(1) DEFAULT '0',
	START_FINISH_DATE DATE,
	SD NUMBER(5) DEFAULT 11 NOT NULL,
	FD NUMBER(5) DEFAULT 12 NOT NULL,
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE3_START TIMESTAMP,
	BASELINE3_FINISH TIMESTAMP,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0,
	DURATION NUMBER(10) DEFAULT 0,
	PLANNED_DURATION NUMBER(10) DEFAULT 0,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0,
	SCHED_DURATION NUMBER(10) DEFAULT 0,
	FORECAST_DURATION NUMBER(10) DEFAULT 0,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0,
	BASELINE3_DURATION NUMBER(10) DEFAULT 0,
	VARIANCE NUMBER(10) DEFAULT 0,
	FORECAST_VARIANCE NUMBER(10) DEFAULT 0,
	ACTUAL_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE1_VARIANCE NUMBER(10) DEFAULT 0,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	PROPOSED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	SCHED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	FORECAST_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	ACTUAL_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE1_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE2_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE3_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	CREATED_DT TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	PROBABILITY NUMBER(10) DEFAULT 100,
	STAGE_ID NUMBER(10) DEFAULT 740,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	CLOSED_BY VARCHAR2(32),
	TOOLTIP_DESCR VARCHAR2(255) DEFAULT NULL,
	TOTAL_SLACK NUMBER(10),
	FREE_SLACK NUMBER(10),
	CRITICAL VARCHAR2(1),
	ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DEPENDENCIES CLOB DEFAULT EMPTY_CLOB(),
	ROLLUP_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	EV_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	CRI_COUNT NUMBER(10) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	MSP_ID NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ASSIGN_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	RTF_BITS NUMBER(10) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TRANSFER_FLAG VARCHAR2(1),
	EFFORT_DRIVEN NUMBER(5) DEFAULT 1 NOT NULL,
	BUBBLE_COLOR NUMBER(5) DEFAULT 0 NOT NULL,
	BUBBLE_PUBLISHED_DT TIMESTAMP,
	A_CRI_COUNT NUMBER(5) DEFAULT 0,
	TASK_TYPE NUMBER(5) DEFAULT 10 NOT NULL,
	FS_CODE VARCHAR2(50),
	FS_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	FS_LABOR_CODE VARCHAR2(50),
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_FLAGS NUMBER(10) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	EARLY_START TIMESTAMP,
	LATE_START TIMESTAMP,
	EARLY_FINISH TIMESTAMP,
	LATE_FINISH TIMESTAMP,
	LEVEL_INDEX NUMBER(10) DEFAULT 0,
	CALC_PRIORITY NUMBER(5) DEFAULT 500,
	LEVEL_CONFLICT VARCHAR2(4000),
	LEVEL_START TIMESTAMP,
	LEVEL_FINISH TIMESTAMP,
	LEVEL_DURATION NUMBER(10) DEFAULT 0,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	FINISH_START_DATE DATE,
	TOTAL_DURATION NUMBER(19) DEFAULT 0 NOT NULL,
	PREVIOUS_WKF_STEP VARCHAR2(150),
	DEPEND_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	START_FINISH_DURATION NUMBER(10) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE1_START DATE,
	ESTIMATED_BASELINE1_FINISH DATE,
	ESTIMATED_BASELINE2_START DATE,
	ESTIMATED_BASELINE2_FINISH DATE,
	ESTIMATED_BASELINE3_START DATE,
	ESTIMATED_BASELINE3_FINISH DATE,
	ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_EST_DT TIMESTAMP,
	BASELINE2_EST_DT TIMESTAMP,
	BASELINE3_EST_DT TIMESTAMP,
	BASELINE1_SCH_DT TIMESTAMP,
	BASELINE2_SCH_DT TIMESTAMP,
	BASELINE3_SCH_DT TIMESTAMP,
	EXPECTED_PAYBACK_PERIOD NUMBER(10) DEFAULT 0,
	EXPECTED_PAYBACK_MONTH NUMBER(10) DEFAULT 0,
	CUSTOM_INT_1 NUMBER(10) DEFAULT 0,
	SUBPROJECT_COUNT NUMBER(10) DEFAULT 0,
	ESTIMATED_BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATED_BASELINE3_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	RISK_EXPOSURE NUMBER(10) DEFAULT 0 NOT NULL,
	CONSEQUENSE_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EV_ETC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEVEL_STATE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_TYPE NUMBER(10) DEFAULT 0,
	LEVEL_CONSTRAINT_DT VARCHAR2(26),
	WORK_PERCENT NUMBER(5) DEFAULT 0,
	MP_STATUS_DT TIMESTAMP,
	REFERENCE_NUMBER NUMBER(19),
	ASSET_ID VARCHAR2(32),
	ASSET_NAME VARCHAR2(50),
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 6501,
	POOL_ID VARCHAR2(32),
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	BASELINE3_START_VARIANCE NUMBER(10) DEFAULT 0,
	BASELINE3_FINISH_VARIANCE NUMBER(10) DEFAULT 0,
	ELEMENT_FLAG NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE RESOURCE_ASSIGNMENTS (
	RES_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	ELEMENT_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	PROFILE_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32),
	RESOURCE_TYPE VARCHAR2(1) DEFAULT '0' NOT NULL,
	WORK_LOCATION NUMBER(10) DEFAULT 265,
	PARTICIPANT NUMBER(10) DEFAULT 0 NOT NULL,
	SECURITY_ID CHAR(32),
	ASSIGN_STATUS NUMBER(10) DEFAULT 0 NOT NULL,
	TIMECODE_ID VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	TABLE_TYPE NUMBER(5),
	CRI_SECURITY_ID CHAR(32)
);

CREATE TABLE RESOURCE_ASSIGN_ROLES (
	RES_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	ROLE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROFICIENCY_LEVEL_ID NUMBER(10) DEFAULT 256,
	PREFERENCE_LEVEL_ID NUMBER(10) DEFAULT 2759,
	EXPERIENCE_ID NUMBER(10) DEFAULT 338,
	LAST_USED_DATETIME DATE,
	PRIMARY_ROLE VARCHAR2(1) DEFAULT '0' NOT NULL
);

CREATE TABLE RESOURCE_ASSIGN_SKILLS (
	RES_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	SKILL_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROFICIENCY_LEVEL_ID NUMBER(10) DEFAULT 256,
	EXPERIENCE_ID NUMBER(10) DEFAULT 338,
	PREFERENCE_LEVEL_ID NUMBER(10) DEFAULT 2759,
	LAST_USED_DATETIME DATE,
	PRIMARY_SKILL VARCHAR2(1) DEFAULT '0' NOT NULL
);

CREATE TABLE RESOURCE_EDUCATION (
	EDUCATION_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	DEGREE VARCHAR2(50),
	GRADUATION VARCHAR2(1),
	GRADUATION_DATE DATE,
	APPOINTED VARCHAR2(1),
	APPOINTED_DATE DATE,
	SPECIALIZATION VARCHAR2(100),
	ORGANIZATION VARCHAR2(100),
	HONORS_AWARDS VARCHAR2(2048)
);

CREATE TABLE RESOURCE_EMPLOYMENT_HISTORY (
	EMPLOYMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	COMPANY_ID VARCHAR2(50) DEFAULT ' ' NOT NULL,
	SALARY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	START_DATE DATE,
	END_DATE DATE,
	LOCATION VARCHAR2(50),
	TITLE VARCHAR2(50),
	DESCRIPTION VARCHAR2(255),
	RESPONSIBILITIES VARCHAR2(2048)
);

CREATE TABLE RESOURCE_INDUSTRY_EXPERIENCE (
	EXPERIENCE_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	CLASSIFICATION VARCHAR2(32) DEFAULT ' ',
	INDUSTRY_ID NUMBER(10) DEFAULT 695,
	PROF_LEVEL NUMBER(10) DEFAULT 256
);

CREATE TABLE RESOURCE_READINESS (
	READINESS_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	LANGUAGE_ID NUMBER(10) DEFAULT 467,
	READ_LEVEL NUMBER(10),
	SPEAK_LEVEL NUMBER(10),
	WRITE_LEVEL NUMBER(10),
	DEFAULT_LANGUAGE VARCHAR2(1) DEFAULT 'N' NOT NULL
);

CREATE TABLE TASK_ASSIGNMENTS (
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RES_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	TASK_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32),
	RESOURCE_TYPE VARCHAR2(1) DEFAULT '0' NOT NULL,
	ACCEPTED_DATE DATE,
	ESTIMATE NUMBER(10) DEFAULT 0 NOT NULL,
	BEST NUMBER(10) DEFAULT 0 NOT NULL,
	BIT_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	ASSIGN_STRING VARCHAR2(4000),
	SD NUMBER(5),
	FD NUMBER(5),
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_START TIMESTAMP,
	BASELINE3_FINISH TIMESTAMP,
	BASELINE3_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	B_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PLANNED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PLANNED_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	PLANNED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	SCHED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	FORECAST_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	FORECAST_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	REGULAR_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	SPECIAL_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE NUMBER(5) DEFAULT 1 NOT NULL,
	BILLABLE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE_REGULAR_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE_SPECIAL_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	LAST_SUBMITTED DATE,
	BASELINE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTIVITY_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	T_UNIT NUMBER(5) DEFAULT 0 NOT NULL,
	C_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	C_UNIT NUMBER(5) DEFAULT 0 NOT NULL,
	C_OCCURRENCE NUMBER(5) DEFAULT 0 NOT NULL,
	C_CONTOUR NUMBER(10) DEFAULT 0 NOT NULL,
	CONTOUR_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	UNITS_MSP NUMBER(10) DEFAULT 10000 NOT NULL,
	BAK_START_DT TIMESTAMP,
	BAK_FINISH_DT TIMESTAMP,
	BAK_WORK NUMBER(10) DEFAULT 0 NOT NULL,
	BAK_ASSIGN_STRING VARCHAR2(4000),
	TIMECODE2_ID VARCHAR2(32),
	PROJECT_ASSIGNMENT_ID VARCHAR2(32),
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TABLE_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 1052679 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ESTIMATION_LABOR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_LABOR_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCHED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PLANNED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROPOSED_LABOR_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LEVEL_START TIMESTAMP,
	LEVEL_FINISH TIMESTAMP,
	LEVEL_EFFORT NUMBER(19) DEFAULT 0,
	CONSIDER NUMBER(5) DEFAULT 0 NOT NULL,
	LEVEL_ASSIGN_STRING VARCHAR2(4000),
	CAPITAL_EXPENSE NUMBER(5) DEFAULT 0,
	BASELINE3_SCH_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	RATES_EDITED NUMBER(5) DEFAULT 0,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	EAC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EV_ETC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ASSIGNMENT_DELAY NUMBER(19) DEFAULT 0,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	ASSIGN_UNITS NUMBER(10) DEFAULT 0 NOT NULL,
	LAST_SCHED_MIN NUMBER(10) DEFAULT 0 NOT NULL,
	RATE_ADJUSTMENT NUMBER(10) DEFAULT 10000,
	REC_STATUS VARCHAR2(1),
	REC_USER VARCHAR2(32)
);

CREATE TABLE TASK_DAY_OF_YEAR (
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	DAY_YEAR DATE DEFAULT SYSDATE NOT NULL,
	BIT_FLAG VARCHAR2(1),
	ACTUAL_MIN NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_MIN NUMBER(10) DEFAULT 0 NOT NULL,
	PARENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	BIT_SCHED RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	ACTUAL_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	TASK_ID VARCHAR2(32)
);

CREATE TABLE COST_APPROVAL (
	RESOURCE_ID VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

CREATE TABLE TMT_CALENDARS (
	MONDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	TUESDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	WEDNESDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	THURSDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	FRIDAY_STATUS VARCHAR2(1) DEFAULT '1' NOT NULL,
	SATURDAY_STATUS VARCHAR2(1) DEFAULT '0' NOT NULL,
	SUNDAY_STATUS VARCHAR2(1) DEFAULT '0' NOT NULL,
	MONDAY_DEFAULT_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	TUESDAY_DEFAULT_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	WEDNESDAY_DEFAULT_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	THURSDAY_DEFAULT_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	FRIDAY_DEFAULT_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	SATURDAY_DEFAULT_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	SUNDAY_DEFAULT_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	WEEKLY_DEFAULT_MIN NUMBER(5) DEFAULT 2400 NOT NULL,
	MONDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	TUESDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	WEDNESDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	THURSDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	FRIDAY_MIN NUMBER(5) DEFAULT 480 NOT NULL,
	SATURDAY_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	SUNDAY_MIN NUMBER(5) DEFAULT 0 NOT NULL,
	WEEKLY_MIN NUMBER(5) DEFAULT 2400 NOT NULL,
	MINUTES_PER_DAY NUMBER(5) DEFAULT 480 NOT NULL,
	MINUTES_PER_WEEK NUMBER(5) DEFAULT 2400 NOT NULL,
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	MONDAY_DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	TUESDAY_DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	WEDNESDAY_DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	THURSDAY_DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	FRIDAY_DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	SATURDAY_DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	SUNDAY_DEFAULT_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	MONDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	TUESDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	WEDNESDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	THURSDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	FRIDAY_BIT RAW(36) DEFAULT '000000000000000000000000FFFFFFFFFFFF000FFFFFFFFFFFF000000000000000000000' NOT NULL,
	SATURDAY_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	SUNDAY_BIT RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	ELEMENT_NAME VARCHAR2(50),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(2048)
);

CREATE TABLE TMT_CHARGECODES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	BILLABLE NUMBER(5) DEFAULT 0,
	RANK VARCHAR2(128) NOT NULL,
	CAPITAL_EXPENSE NUMBER(5) DEFAULT 0,
	ASSOCIATE_CHARGECODE_ID VARCHAR2(32),
	DESCRIPTION VARCHAR2(2048),
	CAPITAL_EXPENSE_ID VARCHAR2(32)
);

CREATE TABLE TMT_CONTACTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	PRIVATE_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(2048),
	ASSIGN_NAMES VARCHAR2(2048)
);

CREATE TABLE TMT_COMPETENCIES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32),
	PROFICIENCY_LEVEL_ID NUMBER(10) DEFAULT 256,
	EXPERIENCE_ID NUMBER(10) DEFAULT 2771,
	PREFERENCE_LEVEL_ID NUMBER(10) DEFAULT 2759,
	RATE_ID VARCHAR2(32),
	LAST_USED_DATETIME DATE,
	CREATED_BY VARCHAR2(32),
	CREATED_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	DEFAULT_FLAG VARCHAR2(1) DEFAULT '0',
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	LAST_USED_LOCATION VARCHAR2(255),
	DESCRIPTION VARCHAR2(2048),
	STRATEGIC_FLAG VARCHAR2(1) DEFAULT '0',
	TARGET_ATTAINMENT_DATE DATE,
	ACQUIRED_ON DATE,
	MANDATORY VARCHAR2(1) DEFAULT '0',
	MANDATORY_DETAILS VARCHAR2(2048)
);

CREATE TABLE TMT_CRI (
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	PROJECT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	TRANSFERRED VARCHAR2(1),
	STAGE_ID NUMBER(10) DEFAULT 786,
	CREATED_BY VARCHAR2(32),
	CREATED_DATETIME TIMESTAMP,
	REFERENCE_NUMBER NUMBER(19),
	EXTERNAL_REFERENCE VARCHAR2(32),
	PRIORITY_ID NUMBER(5) DEFAULT 500,
	PROPOSED_BY VARCHAR2(32),
	PROPOSED_DATETIME TIMESTAMP,
	IMPACT_LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	SD NUMBER(5) DEFAULT 11 NOT NULL,
	FD NUMBER(5) DEFAULT 12 NOT NULL,
	START_DATETIME TIMESTAMP,
	FINISH_DATETIME TIMESTAMP,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	PLANNED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_START TIMESTAMP,
	ESTIMATED_FINISH TIMESTAMP,
	MITIGATION_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 0,
	SCHEDULE_RANK_ID NUMBER(5) DEFAULT 0,
	COST_RANK_ID NUMBER(5) DEFAULT 0,
	QUALITY_RANK_ID NUMBER(5) DEFAULT 0,
	PROBABILITY_RANK_ID NUMBER(5) DEFAULT 0,
	PRECISION_RANK_ID NUMBER(5) DEFAULT 0,
	EXPOSURE_ID NUMBER(10),
	CONSEQUENSE_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROBABILITY_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_DATETIME TIMESTAMP,
	APPROVED_START TIMESTAMP,
	APPROVED_FINISH TIMESTAMP,
	APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CLOSED_BY VARCHAR2(32),
	CLOSED_DATETIME TIMESTAMP,
	PLANNING_UNIT VARCHAR2(1),
	PLANNING_TYPE NUMBER(10),
	ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_DATETIME TIMESTAMP,
	BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_DATETIME TIMESTAMP,
	BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_DATETIME TIMESTAMP,
	S_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_DATETIME TIMESTAMP,
	S_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE2_DATETIME TIMESTAMP,
	S_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE3_DATETIME TIMESTAMP,
	R_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(32),
	LAST_WF_DATETIME TIMESTAMP,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137 NOT NULL,
	REVISION_TYPE NUMBER(10) DEFAULT 4726 NOT NULL,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	TOOLTIP_DESCRIPTION VARCHAR2(255) DEFAULT NULL,
	STATUS_ID NUMBER(10) DEFAULT 316,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	SHARED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	IMPACT_RANK_ID NUMBER(5) DEFAULT 1,
	ASSIGN_NAMES VARCHAR2(2048),
	ASSIGN_COUNT NUMBER(5) DEFAULT 0,
	REC_USER VARCHAR2(32),
	RTF_BITS NUMBER(5) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	LAST_TRANSFER_DT TIMESTAMP,
	WBS_ID VARCHAR2(32),
	STAGE_LAST_DT TIMESTAMP DEFAULT SYSTIMESTAMP,
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	SCORECARD_ID VARCHAR2(32),
	PUBLISHED_DT TIMESTAMP,
	PRIORITY NUMBER(5) DEFAULT 500,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0,
	PERCENT_COMPLETE NUMBER(5) DEFAULT 0,
	REC_FLAGS NUMBER(10) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	WBS_ASSIGNED NUMBER(10) DEFAULT 0 NOT NULL,
	DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	SCHED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	FORECAST_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	CONSTRAINT_DT TIMESTAMP,
	CONSTRAINT_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	S_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	CLIENT_ID VARCHAR2(32),
	CLIENT_NAME VARCHAR2(50),
	REASSIGN_COUNT NUMBER(5) DEFAULT 0,
	DUPLICATE_REF_ID VARCHAR2(50),
	OCCURED_DATETIME TIMESTAMP,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	PROPOSED_BY_NAME VARCHAR2(100),
	CLOSED_BY_NAME VARCHAR2(100),
	ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	HIGH_ESTIMATED_START TIMESTAMP,
	HIGH_ESTIMATED_FINISH TIMESTAMP,
	HIGH_ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	HIGH_ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	LOW_ESTIMATED_START TIMESTAMP,
	LOW_ESTIMATED_FINISH TIMESTAMP,
	LOW_ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	LOW_ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	APPROVED_EFFORT NUMBER(19) DEFAULT 0,
	APPROVED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_BY VARCHAR2(32),
	APPROVED_BY_NAME VARCHAR2(100),
	R_APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_REVENUE NUMBER(18,2) DEFAULT 0.00,
	EXPECTED_MARGIN NUMBER(18,2) DEFAULT 0.00,
	PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	EXPECTED_COST NUMBER(18,2) DEFAULT 0.00,
	S_APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	CHANGE_TO_TASK NUMBER(5) DEFAULT 0,
	APPROVED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TARGET_DATE DATE,
	ESTIMATED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_DURATION NUMBER(19) DEFAULT 0 NOT NULL,
	DUPLICATE_KEY NUMBER(10),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	APPROVED_IMPACT_LEVEL_ID NUMBER(10) DEFAULT 0,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_PAYBACK_PERIOD NUMBER(10) DEFAULT 0,
	EXPECTED_PAYBACK_MONTH NUMBER(10) DEFAULT 0,
	ASSET_ID VARCHAR2(32),
	ASSET_NAME VARCHAR2(50),
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 6501,
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	DEFAULT_COL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	TEMPLATED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	ELEMENT_FLAG NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE HISTORY_CRI (
	HISTORY_ID VARCHAR2(32),
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	PROJECT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_NAME VARCHAR2(255),
	TRANSFERRED VARCHAR2(1),
	STAGE_ID NUMBER(10) DEFAULT 786,
	CREATED_BY VARCHAR2(32),
	CREATED_DATETIME TIMESTAMP,
	REFERENCE_NUMBER NUMBER(19),
	EXTERNAL_REFERENCE VARCHAR2(32),
	PRIORITY_ID NUMBER(5) DEFAULT 500,
	PROPOSED_BY VARCHAR2(32),
	PROPOSED_DATETIME TIMESTAMP,
	IMPACT_LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	SD NUMBER(5) DEFAULT 11 NOT NULL,
	FD NUMBER(5) DEFAULT 12 NOT NULL,
	START_DATETIME TIMESTAMP,
	FINISH_DATETIME TIMESTAMP,
	PLANNED_START TIMESTAMP,
	PLANNED_FINISH TIMESTAMP,
	PLANNED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	PLANNED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_START TIMESTAMP,
	ESTIMATED_FINISH TIMESTAMP,
	MITIGATION_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 0,
	SCHEDULE_RANK_ID NUMBER(5) DEFAULT 0,
	COST_RANK_ID NUMBER(5) DEFAULT 0,
	QUALITY_RANK_ID NUMBER(5) DEFAULT 0,
	PROBABILITY_RANK_ID NUMBER(5) DEFAULT 0,
	PRECISION_RANK_ID NUMBER(5) DEFAULT 0,
	EXPOSURE_ID NUMBER(10),
	CONSEQUENSE_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROBABILITY_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_DATETIME TIMESTAMP,
	APPROVED_START TIMESTAMP,
	APPROVED_FINISH TIMESTAMP,
	APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CLOSED_BY VARCHAR2(32),
	CLOSED_DATETIME TIMESTAMP,
	PLANNING_UNIT VARCHAR2(1),
	PLANNING_TYPE NUMBER(10),
	ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_DATETIME TIMESTAMP,
	BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_DATETIME TIMESTAMP,
	BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_DATETIME TIMESTAMP,
	S_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE1_DATETIME TIMESTAMP,
	S_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE2_DATETIME TIMESTAMP,
	S_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_BASELINE3_DATETIME TIMESTAMP,
	R_ESTIMATION_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_CURRENT_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_FORECAST_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE1_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE2_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_BASELINE3_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(32),
	LAST_WF_DATETIME TIMESTAMP,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137 NOT NULL,
	REVISION_TYPE NUMBER(10) DEFAULT 4726 NOT NULL,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	TOOLTIP_DESCRIPTION VARCHAR2(255) DEFAULT NULL,
	STATUS_ID NUMBER(10) DEFAULT 316,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	SHARED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	IMPACT_RANK_ID NUMBER(5) DEFAULT 1,
	ASSIGN_NAMES VARCHAR2(2048),
	ASSIGN_COUNT NUMBER(5) DEFAULT 0,
	REC_USER VARCHAR2(32),
	RTF_BITS NUMBER(5) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	LAST_TRANSFER_DT TIMESTAMP,
	WBS_ID VARCHAR2(32),
	STAGE_LAST_DT TIMESTAMP DEFAULT SYSTIMESTAMP,
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	SCORECARD_ID VARCHAR2(32),
	PUBLISHED_DT TIMESTAMP,
	PRIORITY NUMBER(5) DEFAULT 500,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0,
	PERCENT_COMPLETE NUMBER(5) DEFAULT 0,
	REC_FLAGS NUMBER(10) DEFAULT 0 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	WBS_ASSIGNED NUMBER(10) DEFAULT 0 NOT NULL,
	DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_START TIMESTAMP,
	ACTUAL_FINISH TIMESTAMP,
	ACTUAL_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_START TIMESTAMP,
	SCHED_FINISH TIMESTAMP,
	SCHED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_START TIMESTAMP,
	PROPOSED_FINISH TIMESTAMP,
	PROPOSED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_START TIMESTAMP,
	FORECAST_FINISH TIMESTAMP,
	FORECAST_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_START TIMESTAMP,
	BASELINE1_FINISH TIMESTAMP,
	BASELINE1_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	UNRESOLVED_START TIMESTAMP,
	UNRESOLVED_FINISH TIMESTAMP,
	UNRESOLVED_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	CONSTRAINT_DT TIMESTAMP,
	CONSTRAINT_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	S_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ACTUAL_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATION_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	PROPOSED_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	ACTUAL_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	FORECAST_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_VARIANCE NUMBER(10) DEFAULT 0 NOT NULL,
	CLIENT_ID VARCHAR2(32),
	CLIENT_NAME VARCHAR2(50),
	REASSIGN_COUNT NUMBER(5) DEFAULT 0,
	DUPLICATE_REF_ID VARCHAR2(50),
	OCCURED_DATETIME TIMESTAMP,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	PROPOSED_BY_NAME VARCHAR2(100),
	CLOSED_BY_NAME VARCHAR2(100),
	ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	HIGH_ESTIMATED_START TIMESTAMP,
	HIGH_ESTIMATED_FINISH TIMESTAMP,
	HIGH_ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	HIGH_ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	LOW_ESTIMATED_START TIMESTAMP,
	LOW_ESTIMATED_FINISH TIMESTAMP,
	LOW_ESTIMATED_DURATION NUMBER(10) DEFAULT 0,
	LOW_ESTIMATED_EFFORT NUMBER(19) DEFAULT 0,
	APPROVED_EFFORT NUMBER(19) DEFAULT 0,
	APPROVED_DURATION NUMBER(10) DEFAULT 0,
	ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_HIGH_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_LOW_ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_BY VARCHAR2(32),
	APPROVED_BY_NAME VARCHAR2(100),
	R_APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_REVENUE NUMBER(18,2) DEFAULT 0.00,
	EXPECTED_MARGIN NUMBER(18,2) DEFAULT 0.00,
	PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PLANNED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	R_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	S_PROPOSED_BUDGET NUMBER(18,2) DEFAULT 0.00,
	EXPECTED_COST NUMBER(18,2) DEFAULT 0.00,
	S_APPROVED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	BASELINE2_START TIMESTAMP,
	BASELINE2_FINISH TIMESTAMP,
	BASELINE2_DURATION NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_EFFORT NUMBER(10) DEFAULT 0 NOT NULL,
	CHANGE_TO_TASK NUMBER(5) DEFAULT 0,
	APPROVED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	APPROVED_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TARGET_DATE DATE,
	ESTIMATED_REVENUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_SAVING NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_DURATION NUMBER(19) DEFAULT 0 NOT NULL,
	DUPLICATE_KEY NUMBER(10),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	APPROVED_IMPACT_LEVEL_ID NUMBER(10) DEFAULT 0,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	S_ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_ACTUAL_HOURS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	R_ESTIMATED_HOURS_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPECTED_PAYBACK_PERIOD NUMBER(10) DEFAULT 0,
	EXPECTED_PAYBACK_MONTH NUMBER(10) DEFAULT 0,
	ASSET_ID VARCHAR2(32),
	ASSET_NAME VARCHAR2(50),
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 6501,
	ASSET_FLAG NUMBER(10) DEFAULT 0,
	DEFAULT_COL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	TEMPLATED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	ELEMENT_FLAG NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE TMT_DATAFIELDS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	POSITION NUMBER(10),
	ELEMENT_ID NUMBER(10),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID NUMBER(10),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(2048)
) CACHE;

CREATE TABLE TMT_DOCUMENT_ATTRIBUTES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	MULTI_SELECT VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	WEIGHT NUMBER(5) DEFAULT 0,
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PARENT_NAME VARCHAR2(500),
	INPUT_TYPE NUMBER(5) DEFAULT 3
);

CREATE TABLE TMT_DOCUMENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024) DEFAULT 'CREATED',
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 729,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL,
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192)
);

CREATE TABLE HISTORY_DOCUMENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024),
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 729,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	ATTACHEMENT VARCHAR2(512),
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL,
	T_PARENT_ID VARCHAR2(32),
	T_RANK VARCHAR2(192),
	BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE TMT_GEOGRAPHIES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(2048)
);

CREATE TABLE TMT_ORGANIZATIONS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	FS_CODE VARCHAR2(50),
	DESCRIPTION VARCHAR2(2048)
);

CREATE TABLE TMT_POOL_ATTRIBUTES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	MULTI_SELECT VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	WEIGHT NUMBER(5) DEFAULT 0,
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PARENT_NAME VARCHAR2(500),
	INPUT_TYPE NUMBER(5) DEFAULT 3
);

CREATE TABLE TMT_SETTINGS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	SETTING_VALUE NUMBER(10),
	DESCRIPTION VARCHAR2(2048)
) CACHE;

CREATE TABLE TMT_TIMECODES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	FS_CODE VARCHAR2(50),
	DESCRIPTION VARCHAR2(2048)
);

CREATE TABLE TMT_WORKFLOWS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	WKF_DEF_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	REQUEST_ID NUMBER(10),
	REVISION VARCHAR2(16),
	WKF_PRIORITY NUMBER(5),
	CREATED_DATE TIMESTAMP,
	AUTHOR_ID VARCHAR2(32),
	EMAIL_ADDRESS VARCHAR2(128),
	CLOSED_DATE TIMESTAMP,
	OUTCOME_ID NUMBER(10),
	WKF_STATUS NUMBER(10) DEFAULT 0 NOT NULL,
	END_CYCLE VARCHAR2(1) DEFAULT '0' NOT NULL,
	EXPIRES_DATE TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	CHECKLIST VARCHAR2(2048),
	SUBJECT VARCHAR2(255),
	DESCRIPTION CLOB DEFAULT EMPTY_CLOB(),
	PROJECT_NAME VARCHAR2(255),
	ATTACHED_NAME VARCHAR2(255),
	STAGE_ID NUMBER(10) DEFAULT 0,
	OUTCOME_NAME VARCHAR2(50)
);

CREATE TABLE WORKFLOW_REPLIES (
	WKF_REPLY_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	GROUP_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32),
	REPLY_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	REPLY_STATUS NUMBER(10) DEFAULT 0 NOT NULL,
	REPLY_DATE TIMESTAMP,
	COMPLETED VARCHAR2(1) DEFAULT '0' NOT NULL,
	NOTIFIED_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	MARKED_READ VARCHAR2(1) DEFAULT '0' NOT NULL,
	EMAIL_ADDRESS VARCHAR2(128),
	DESCRIPTION VARCHAR2(4000),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

CREATE TABLE USER_SESSIONS (
	SESSION_ID VARCHAR2(32) NOT NULL,
	RESOURCE_ID VARCHAR2(32) NOT NULL,
	SESSION_START TIMESTAMP,
	SESSION_TIMEOUT TIMESTAMP
);

CREATE TABLE TMT_WORKFLOW_CYCLES (
	ELEMENT_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	TYPE_ID NUMBER(10) DEFAULT 0,
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	START_WITH NUMBER(10) DEFAULT 0 NOT NULL,
	REQUEST_ID NUMBER(10),
	OUTCOME_ID NUMBER(10),
	NEXT_STATE_ID NUMBER(10),
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	PARTICIPANTS VARCHAR2(2048),
	CHECKLIST VARCHAR2(2048),
	NEXT_PROCESS_ID VARCHAR2(32),
	NEXT_STAGE_ID NUMBER(10),
	MUST_OBEY NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE RATES (
	RATE_ID VARCHAR2(32) NOT NULL,
	REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REGULAR_SALE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SPECIAL_SALE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	ELEMENT_ID VARCHAR2(32)
);

CREATE TABLE TMT_DOMAINS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(2048)
);

CREATE TABLE TMT_POOLS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(100),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	NUMBER_POOLS NUMBER(10),
	NUMBER_CLIENTS NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	CREATED_BY VARCHAR2(32),
	ASSIGN_NAMES VARCHAR2(2048),
	CLEARANCE_LEVEL_1 NUMBER(10) DEFAULT 1275905024 NOT NULL,
	CLEARANCE_LEVEL_2 NUMBER(10) DEFAULT 1280101580 NOT NULL,
	CLEARANCE_LEVEL_3 NUMBER(10) DEFAULT 4 NOT NULL,
	CLEARANCE_LEVEL_4 NUMBER(10) DEFAULT 0 NOT NULL,
	CLEARANCE_LEVEL_5 NUMBER(10) DEFAULT 0 NOT NULL,
	USER_GROUP_ID VARCHAR2(32) DEFAULT 'DEFAULT_SECURITY_ROLE' NOT NULL,
	MASK_EMPLOYEE_INFO NUMBER(5) DEFAULT 1
);

CREATE TABLE HISTORY_POOLS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(100),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	NUMBER_POOLS NUMBER(10),
	NUMBER_CLIENTS NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255),
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0,
	CREATED_BY VARCHAR2(32),
	ASSIGN_NAMES VARCHAR2(2048),
	CLEARANCE_LEVEL_1 NUMBER(10) DEFAULT 1275905024 NOT NULL,
	CLEARANCE_LEVEL_2 NUMBER(10) DEFAULT 1280101580 NOT NULL,
	CLEARANCE_LEVEL_3 NUMBER(10) DEFAULT 4 NOT NULL,
	CLEARANCE_LEVEL_4 NUMBER(10) DEFAULT 0 NOT NULL,
	CLEARANCE_LEVEL_5 NUMBER(10) DEFAULT 0 NOT NULL,
	USER_GROUP_ID VARCHAR2(32) DEFAULT 'DEFAULT_SECURITY_ROLE' NOT NULL,
	MASK_EMPLOYEE_INFO NUMBER(5) DEFAULT 1
);

CREATE TABLE POOL_REFERENCES (
	ELEMENT_ID VARCHAR2(32),
	POOL_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	COMPANY_SIZE VARCHAR2(50),
	CONTACT_NAME VARCHAR2(50),
	CONTACT_PHONE VARCHAR2(25),
	CONTACT_FAX VARCHAR2(25),
	CONTACT_EMAIL VARCHAR2(50),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE DEPENDENCIES (
	DEPEND_ID VARCHAR2(32),
	PRED_ID VARCHAR2(32),
	PRED_PROJECT_ID VARCHAR2(32),
	PRED_OBJECT_TYPE NUMBER(10),
	SUCC_ID VARCHAR2(32),
	SUCC_PROJECT_ID VARCHAR2(32),
	SUCC_OBJECT_TYPE NUMBER(10),
	DEP_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	LEAD_OR_LAG_TYPE NUMBER(10) DEFAULT 1 NOT NULL,
	AMOUNT NUMBER(10) DEFAULT 0 NOT NULL,
	LAG_DISPLAY_UNIT NUMBER(10) DEFAULT 0 NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	PRED_START_DT TIMESTAMP,
	PRED_FINISH_DT TIMESTAMP,
	SUCC_START_DT TIMESTAMP,
	SUCC_FINISH_DT TIMESTAMP,
	PRED_UPDATED NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE CRIDEPENDENCIES (
	DEPEND_ID VARCHAR2(32),
	PRED_ID VARCHAR2(32),
	PRED_PROJECT_ID VARCHAR2(32),
	PRED_OBJECT_TYPE NUMBER(10),
	SUCC_ID VARCHAR2(32),
	SUCC_PROJECT_ID VARCHAR2(32),
	SUCC_OBJECT_TYPE NUMBER(10),
	DEP_TYPE NUMBER(10) DEFAULT 0 NOT NULL,
	LEAD_OR_LAG_TYPE NUMBER(10) DEFAULT 1 NOT NULL,
	AMOUNT NUMBER(10) DEFAULT 0 NOT NULL,
	LAG_DISPLAY_UNIT NUMBER(10) DEFAULT 0 NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

CREATE TABLE BUDGETS (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	CHARGECODE_ID VARCHAR2(32) NOT NULL,
	BUDGET_ID VARCHAR2(32) NOT NULL,
	ASSOCIATE_BUDGET_ID VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	TOTAL_ESTIMATION_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_BUDGET_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROB_PERCENT NUMBER(10) DEFAULT 10000,
	PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE1 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE2 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET_BASELINE3 NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PAID_TODATE NUMBER(18,2) DEFAULT 0.00,
	AUTO_FLAG NUMBER(5) DEFAULT 1 NOT NULL,
	ACTUAL_EDITED NUMBER(5) DEFAULT 1 NOT NULL,
	ROLLUP_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	TIMEPHASED_BITS NUMBER(10) DEFAULT 0 NOT NULL,
	TIMEPHASED_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	DATAFIELD_1 NUMBER(10),
	DATAFIELD_2 NUMBER(10),
	TXT_FIELD_01 VARCHAR2(1024),
	TXT_FIELD_02 VARCHAR2(1024),
	TXT_FIELD_03 VARCHAR2(1024),
	TXT_FIELD_04 VARCHAR2(1024),
	TXT_FIELD_05 VARCHAR2(1024),
	TXT_FIELD_06 VARCHAR2(1024),
	TXT_FIELD_07 VARCHAR2(1024),
	TXT_FIELD_08 VARCHAR2(1024),
	TXT_FIELD_09 VARCHAR2(1024),
	TXT_FIELD_10 VARCHAR2(1024),
	TOLERANCE NUMBER(10) DEFAULT 10000,
	ESTIMATED_ACTUAL_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ETC_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PAID_TODATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PAID_TODATE_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CONTINGENCY_ETC_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PROB_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PROB_AMOUNT_TOTAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_SCH_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	BASELINE3_EST_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	DATAFIELD_3 NUMBER(10),
	DATAFIELD_4 NUMBER(10),
	ACTUAL_TIMEPHASED_FLAG NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE PROJECT_BUDGET_BREAKDOWN (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	CHARGECODE_ID VARCHAR2(32) NOT NULL,
	BUDGET_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	BUDGET_YEAR NUMBER(5) DEFAULT 0 NOT NULL,
	MONTH_01_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_02_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_03_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_04_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_05_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_06_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_07_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_08_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_09_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_10_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_11_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_12_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROCESS_FLAG VARCHAR2(1) DEFAULT 'I'
);

CREATE TABLE DOCUMENT_BLOBS (
	ELEMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	ATTACHEMENT VARCHAR2(512),
	BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE TMT_COSTS (
	LEVEL_ID NUMBER(10) DEFAULT 0 NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	CURRENCY_ID NUMBER(10) DEFAULT 0 NOT NULL,
	STATUS_ID NUMBER(10),
	RANK VARCHAR2(128) NOT NULL,
	PROJECT_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32) NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	BILLABLE VARCHAR2(1) DEFAULT '0',
	TAXABLE VARCHAR2(1) DEFAULT '1',
	REIMBURSE VARCHAR2(1) DEFAULT '1',
	EXCHANGE_RATE NUMBER(18,3) DEFAULT 1.00,
	QUANTITY NUMBER(18,2) DEFAULT 0.00,
	UNIT_PRICE NUMBER(18,2) DEFAULT 0.00,
	TAX1_AMOUNT NUMBER(18,2) DEFAULT 0.00,
	TAX2_AMOUNT NUMBER(18,2) DEFAULT 0.00,
	ACTUAL_AMOUNT NUMBER(18,2) DEFAULT 0.00,
	FORECAST_AMOUNT NUMBER(18,2) DEFAULT 0.00,
	BUDGET_AMOUNT NUMBER(18,2) DEFAULT 0.00,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	CHARGECODE_ID VARCHAR2(32),
	BUDGET_ID VARCHAR2(32),
	PAYMENT_TYPE_ID NUMBER(10),
	INVOICE_NUMBER VARCHAR2(20),
	INVOICE_DATETIME TIMESTAMP,
	TRACKING_NUMBER VARCHAR2(20),
	VENDOR VARCHAR2(50),
	LOCATION VARCHAR2(50),
	DESCRIPTION VARCHAR2(255),
	PDA_FLAG VARCHAR2(1) DEFAULT 'P',
	FS_CODE VARCHAR2(32)
);

CREATE TABLE TMT_FACTORS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	MITIGATION_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	PARENT_RANK VARCHAR2(192),
	PRIORITY NUMBER(5) DEFAULT 500
);

CREATE TABLE CHANGE_LOG (
	BROKER_TYPE NUMBER(10) NOT NULL,
	MODIF_DATE_TIME TIMESTAMP NOT NULL
);

CREATE TABLE FAVORITE_ACTIVITIES (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_NAME VARCHAR2(50),
	BILLABLE VARCHAR2(1) DEFAULT '0',
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	PROJECT_ID VARCHAR2(32) NOT NULL,
	RESOURCE_ID VARCHAR2(32) NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

CREATE TABLE ACTIVITIES (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_NAME VARCHAR2(50),
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_1_NAME VARCHAR2(50),
	TIMECODE_2_ID VARCHAR2(32),
	TIMECODE_2_NAME VARCHAR2(50),
	TSK_ASSIGNMENT_ID VARCHAR2(32) NOT NULL,
	BILLABLE NUMBER(5) DEFAULT 0,
	EFFORT_ASSIGNMENT NUMBER(19) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(19) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	MILESTONE_PERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	EDPERCENT NUMBER(5) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	ETC_MODIFIED VARCHAR2(1) DEFAULT 'N' NOT NULL
);

CREATE TABLE DETAIL_TIMESHEETS (
	ACTIVITY_ID VARCHAR2(32) NOT NULL,
	WEEK_OF DATE NOT NULL,
	MONDAY_REGULAR NUMBER(5) DEFAULT 0 NOT NULL,
	MONDAY_SPECIAL NUMBER(5) DEFAULT 0 NOT NULL,
	TUESDAY_REGULAR NUMBER(5) DEFAULT 0 NOT NULL,
	TUESDAY_SPECIAL NUMBER(5) DEFAULT 0 NOT NULL,
	WEDNESDAY_REGULAR NUMBER(5) DEFAULT 0 NOT NULL,
	WEDNESDAY_SPECIAL NUMBER(5) DEFAULT 0 NOT NULL,
	THURSDAY_REGULAR NUMBER(5) DEFAULT 0 NOT NULL,
	THURSDAY_SPECIAL NUMBER(5) DEFAULT 0 NOT NULL,
	FRIDAY_REGULAR NUMBER(5) DEFAULT 0 NOT NULL,
	FRIDAY_SPECIAL NUMBER(5) DEFAULT 0 NOT NULL,
	SATURDAY_REGULAR NUMBER(5) DEFAULT 0 NOT NULL,
	SATURDAY_SPECIAL NUMBER(5) DEFAULT 0 NOT NULL,
	SUNDAY_REGULAR NUMBER(5) DEFAULT 0 NOT NULL,
	SUNDAY_SPECIAL NUMBER(5) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	NOTES VARCHAR2(255),
	PDA_FLAG VARCHAR2(1) DEFAULT 'P',
	BILLABLE NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE SUMMARY_TIMESHEETS (
	PROJECT_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32),
	TSK_ASSIGNMENT_ID VARCHAR2(32) NOT NULL,
	WEEK_OF DATE,
	MONDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	MONDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	TUESDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	TUESDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEDNESDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	WEDNESDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	THURSDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	THURSDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	FRIDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	FRIDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	SATURDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	SATURDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	SUNDAY_REGULAR NUMBER(10) DEFAULT 0 NOT NULL,
	SUNDAY_SPECIAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_REGULAR_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_SPECIAL_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_BILLABLE_REGULAR_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	WEEKLY_BILLABLE_SPECIAL_TOTAL NUMBER(10) DEFAULT 0 NOT NULL,
	TOTAL_SCHED_EFFORT NUMBER(19) DEFAULT 0 NOT NULL,
	BASELINE_EFFORT_WEEK NUMBER(19) DEFAULT 0 NOT NULL,
	WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BILLABLE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	ETC NUMBER(19) DEFAULT 0 NOT NULL,
	MILESTONE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE_REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_REGULAR_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_SPECIAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_REGULAR_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_SPECIAL_RATE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	SYSTEM_EXCHANGE_RATE NUMBER(18,3) DEFAULT 1.000 NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	TIMECODE_1_ID VARCHAR2(32),
	TIMECODE_2_ID VARCHAR2(32),
	ACTIVITY_ID VARCHAR2(32),
	NOTES VARCHAR2(255),
	BASELINE_WORK_TODATE NUMBER(10) DEFAULT 0 NOT NULL,
	BAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EAC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWS NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BCWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACWP NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PDA_FLAG VARCHAR2(1) DEFAULT 'P',
	EV_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH1_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH1_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH1_B_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH1_B_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_B_REGULAR_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	MONTH2_B_SPECIAL_HRS NUMBER(10) DEFAULT 0 NOT NULL,
	EAC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EV_ETC_FORECAST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DEPARTMENT_ID VARCHAR2(32)
);

CREATE TABLE ALERTS (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	ALERT_ID VARCHAR2(32) NOT NULL,
	PARENT_TABLE VARCHAR2(100),
	VALUE_LIST CLOB DEFAULT EMPTY_CLOB(),
	VARIANCE NUMBER(10),
	FLAG VARCHAR2(1),
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	PROJECT_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32)
);

CREATE TABLE PROJECT_ALERTS (
	PROJECT_ALERT_ID VARCHAR2(32) NOT NULL,
	PROJECT_ID VARCHAR2(32) NOT NULL,
	ALERT_ID VARCHAR2(32) NOT NULL,
	VARIANCE NUMBER(10),
	REC_USER VARCHAR2(32)
);

CREATE TABLE ALERT_MESSAGES (
	ALERT_ID VARCHAR2(32) NOT NULL,
	ALERT_NAME VARCHAR2(100) NOT NULL,
	ALERT_BIT NUMBER(10) DEFAULT 1 NOT NULL,
	LANGUAGE_CODE VARCHAR2(2) NOT NULL,
	ALERT_TYPE NUMBER(10) DEFAULT 1 NOT NULL,
	REC_USER VARCHAR2(32),
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	ALERT_MESSAGE VARCHAR2(1000),
	CLIENT_MESSAGE_PATTERN VARCHAR2(1000)
);

CREATE TABLE PROFILES (
	PROFILE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	ROLE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	PROF_NUMBER NUMBER(10) DEFAULT 0 NOT NULL,
	TEMPLATE VARCHAR2(1) DEFAULT '0',
	PROFILE_NAME VARCHAR2(120),
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	ORG_ID VARCHAR2(32),
	GEO_ID VARCHAR2(32),
	POOL_ID VARCHAR2(32),
	STAFFING_STATE NUMBER(5) DEFAULT 0
);

CREATE TABLE RESOURCE_PROJECT_HISTORY (
	RES_PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	CLIENT VARCHAR2(100) DEFAULT ' ',
	CLASSIFICATION VARCHAR2(32) DEFAULT ' ',
	INDUSTRY_ID NUMBER(10) DEFAULT 695,
	START_DATE DATE,
	END_DATE DATE,
	PROJECT_NAME VARCHAR2(100),
	PROJECT_LENGTH VARCHAR2(100),
	TIME_SPENT VARCHAR2(50),
	ROLE VARCHAR2(50),
	DESCRIPTION VARCHAR2(1024),
	RESPONSIBILITIES VARCHAR2(1024)
);

CREATE TABLE WBS_RTF (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(10) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE HISTORY_WBS_RTF (
	HISTORY_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(10) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE CRI_RTF (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE HISTORY_CRI_RTF (
	HISTORY_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE PDA_LOOKUP (
	RESOURCE_ID VARCHAR2(32),
	PDA_ELEMENT_ID NUMBER(19),
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_TYPE NUMBER(10),
	REC_STATUS VARCHAR2(1),
	ELEMENT_NAME VARCHAR2(255),
	NOTES VARCHAR2(255)
);

CREATE TABLE HISTORY_DOCUMENT_SCORECARDS (
	SCORECARD_ID VARCHAR2(32),
	QUESTION_ID VARCHAR2(32),
	ANSWER_ID VARCHAR2(32),
	ANSWER_ORIGIN_ID VARCHAR2(32),
	ANSWER_NAME VARCHAR2(255),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	PUBLISHED_DT TIMESTAMP,
	DESCRIPTION VARCHAR2(255)
);

CREATE TABLE PROC_LOG (
	PROC_NAME VARCHAR2(100),
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE FS_XML_MONITOR (
	MESSAGE_ID NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	MSG_TYPE NUMBER(5),
	DESTINATION_QUEUE VARCHAR2(50),
	STATE VARCHAR2(1),
	MSG_BODY CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE TMT_NAB (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(100),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	HOST_NAME VARCHAR2(100),
	PORT NUMBER(10),
	CHANNEL VARCHAR2(100),
	FLAG VARCHAR2(1),
	ADMIN_NAME VARCHAR2(100),
	ADMIN_PHONE VARCHAR2(21),
	ADMIN_E_MAIL VARCHAR2(100),
	DESCRIPTION VARCHAR2(100),
	RESERVED VARCHAR2(100),
	WEB_SERVER_PATH VARCHAR2(512),
	USER_NOTES VARCHAR2(2048)
);

CREATE TABLE PENDING_MONITOR (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	SOURCE VARCHAR2(1) NOT NULL
);

CREATE TABLE TMT_REPORT_SECURITY (
	RANK VARCHAR2(128) NOT NULL,
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(100),
	PARENT_ID VARCHAR2(32),
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	URL VARCHAR2(520),
	ELEMENT_TYPE NUMBER(10),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	REC_USER VARCHAR2(32)
);

CREATE TABLE EFFORT_WEEK (
	RESOURCE_ID VARCHAR2(32) NOT NULL,
	PROJECT_ID VARCHAR2(32) NOT NULL,
	TASK_ID VARCHAR2(32) NOT NULL,
	TSK_ASSIGNMENT_ID VARCHAR2(32) NOT NULL,
	WEEK_OF DATE NOT NULL,
	SCHED_EFFORT_WEEK NUMBER(19) DEFAULT 0 NOT NULL
);

CREATE TABLE TIMESHEET_APPROVAL_STATUS (
	RESOURCE_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	WEEK_OF DATE,
	CURRENT_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	MANAGER_ID VARCHAR2(32),
	REC_DATETIME TIMESTAMP,
	NOTE VARCHAR2(1024)
);

CREATE TABLE COST_APPROVAL_STATUS (
	RESOURCE_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	TYPE_ID NUMBER(10),
	CURRENT_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	CURRENT_PM_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	CURRENT_RM_COUNT NUMBER(5) DEFAULT 0 NOT NULL,
	PM1_ID VARCHAR2(32),
	PM1_DT TIMESTAMP,
	PM1_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	PM2_ID VARCHAR2(32),
	RM1_ID VARCHAR2(32),
	RM1_DT TIMESTAMP,
	RM1_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	RM2_ID VARCHAR2(32),
	PM2_DT TIMESTAMP,
	PM2_STATE NUMBER(5) DEFAULT 0 NOT NULL,
	RM2_DT TIMESTAMP,
	RM2_STATE NUMBER(5) DEFAULT 0 NOT NULL
);

CREATE TABLE TMT_ASSETS (
	RANK VARCHAR2(128) NOT NULL,
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	DOC_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 5252,
	REVISION_TYPE NUMBER(10) DEFAULT 5352,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	CATEGORY_ID NUMBER(10) DEFAULT 5152 NOT NULL,
	STATUS_ID NUMBER(10) DEFAULT 4971 NOT NULL,
	MAKE VARCHAR2(50),
	MODEL VARCHAR2(50),
	MODEL_NUMBER VARCHAR2(50),
	SERIAL_NUMBER VARCHAR2(50),
	BARCODE_NUMBER VARCHAR2(30),
	DATE_ACQUIRED DATE,
	DATE_SOLD DATE,
	PURCHASE_PRICE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_VALUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_DEPRECIATION NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_MAINTENANCE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DEPRECIATION_METHOD NUMBER(5) DEFAULT 1 NOT NULL,
	QUANTITY NUMBER(10) DEFAULT 0 NOT NULL,
	QUANTITY_USED NUMBER(10) DEFAULT 0 NOT NULL,
	DEPRECIABLE_LIFE NUMBER(10) DEFAULT 0 NOT NULL,
	SALVAGE_VALUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_VALUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	NEXT_SCHED_MAINT DATE,
	DESCRIPTION CLOB DEFAULT EMPTY_CLOB(),
	RTF_BITS NUMBER(5) DEFAULT 0,
	LICENCE_EXPIRY_DATE DATE,
	WARRANTY_EXPIRY_DATE DATE,
	CONTACTOR VARCHAR2(255),
	CONTACTOR_PHONE VARCHAR2(50),
	CONTACTOR_EMAIL VARCHAR2(255),
	DEPRECIATION_START DATE,
	DEPRECIATION_FINISH DATE,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	EXPENSE_ACTUAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_SCHED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_COST_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_ACTUAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_SCHED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_COST_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_ACTUAL_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	EXPENSE_SCHED_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	EXPENSE_HOURS_ETC NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_ACTUAL_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_SCHED_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_HOURS_ETC NUMBER(10) DEFAULT 0 NOT NULL,
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 0 NOT NULL,
	ACTIVITY_START DATE,
	ACTIVITY_FINISH DATE,
	SD NUMBER(10) DEFAULT 0 NOT NULL,
	FD NUMBER(10) DEFAULT 0 NOT NULL,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	TRACKED_FLAG VARCHAR2(1) DEFAULT 'N' NOT NULL,
	TOTAL_EST_MAINTENANCE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CROSS_CHARGE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_CROSS_CHARGE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CREATED_BY VARCHAR2(32),
	CREATED_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

CREATE TABLE HISTORY_ASSETS (
	HISTORY_ID VARCHAR2(32),
	RANK VARCHAR2(128) NOT NULL,
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	DOC_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 5252,
	REVISION_TYPE NUMBER(10) DEFAULT 5352,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	CATEGORY_ID NUMBER(10) DEFAULT 5152 NOT NULL,
	STATUS_ID NUMBER(10) DEFAULT 4971 NOT NULL,
	MAKE VARCHAR2(50),
	MODEL VARCHAR2(50),
	MODEL_NUMBER VARCHAR2(50),
	SERIAL_NUMBER VARCHAR2(50),
	BARCODE_NUMBER VARCHAR2(30),
	DATE_ACQUIRED DATE,
	DATE_SOLD DATE,
	PURCHASE_PRICE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_VALUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_DEPRECIATION NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_MAINTENANCE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	DEPRECIATION_METHOD NUMBER(5) DEFAULT 1 NOT NULL,
	QUANTITY NUMBER(10),
	QUANTITY_USED NUMBER(10),
	DEPRECIABLE_LIFE NUMBER(10),
	SALVAGE_VALUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CURRENT_VALUE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	NEXT_SCHED_MAINT DATE,
	DESCRIPTION CLOB DEFAULT EMPTY_CLOB(),
	RTF_BITS NUMBER(5) DEFAULT 0,
	LICENCE_EXPIRY_DATE DATE,
	WARRANTY_EXPIRY_DATE DATE,
	CONTACTOR VARCHAR2(255),
	CONTACTOR_PHONE VARCHAR2(50),
	CONTACTOR_EMAIL VARCHAR2(255),
	DEPRECIATION_START DATE,
	DEPRECIATION_FINISH DATE,
	SCORECARD_COUNT NUMBER(10) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	EXPENSE_ACTUAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_SCHED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_COST_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_ACTUAL_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_SCHED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_COST_ETC NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_ACTUAL_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	EXPENSE_SCHED_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	EXPENSE_HOURS_ETC NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_ACTUAL_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_SCHED_HOURS NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_HOURS_ETC NUMBER(10) DEFAULT 0 NOT NULL,
	FINANCIAL_CATEGORY NUMBER(10) DEFAULT 0 NOT NULL,
	ACTIVITY_START DATE,
	ACTIVITY_FINISH DATE,
	SD NUMBER(10) DEFAULT 0 NOT NULL,
	FD NUMBER(10) DEFAULT 0 NOT NULL,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	TRACKED_FLAG VARCHAR2(1) DEFAULT 'N' NOT NULL,
	TOTAL_EST_MAINTENANCE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_CROSS_CHARGE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ACTUAL_CROSS_CHARGE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CREATED_BY VARCHAR2(32),
	CREATED_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

CREATE TABLE TMT_ASSET_ATTRIBUTES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	MULTI_SELECT VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	WEIGHT NUMBER(5) DEFAULT 0,
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PARENT_NAME VARCHAR2(500),
	INPUT_TYPE NUMBER(5) DEFAULT 3
);

CREATE TABLE ASSET_REFERENCES (
	ELEMENT_ID VARCHAR2(32),
	ASSET_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	COMPANY_SIZE VARCHAR2(50),
	CONTACT_NAME VARCHAR2(50),
	CONTACT_PHONE VARCHAR2(25),
	CONTACT_FAX VARCHAR2(25),
	CONTACT_EMAIL VARCHAR2(50),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE ASSET_MAINTENANCE (
	ELEMENT_ID VARCHAR2(32),
	ASSET_ID VARCHAR2(32),
	MAINTENANCE_DATE DATE,
	DESCRIPTION VARCHAR2(255),
	PERFORMED_BY VARCHAR2(255),
	COST NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32),
	ESTIMATED_COST NUMBER(18,2) DEFAULT 0.00 NOT NULL
);

CREATE TABLE ASSET_DEPRECIATION (
	ELEMENT_ID VARCHAR2(32),
	ASSET_ID VARCHAR2(32),
	DEPRECIATION_DATE DATE,
	DEPRECIATION_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE ASSET_RESOURCES (
	ASSET_RES_ID VARCHAR2(32),
	RESOURCE_ID VARCHAR2(32),
	ASSET_ID VARCHAR2(32),
	DESCRIPTION VARCHAR2(255),
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE ASSET_ORGANIZATIONS (
	ASSET_ORG_ID VARCHAR2(32),
	ORGANIZATION_ID VARCHAR2(32),
	ASSET_ID VARCHAR2(32),
	DESCRIPTION VARCHAR2(255),
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE ASSET_DEPENDENCIES (
	DEPEND_ID VARCHAR2(32),
	PRED_ID VARCHAR2(32),
	SUCC_ID VARCHAR2(32),
	ASSIGN_DATE DATE,
	DESCRIPTION VARCHAR2(255),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL
);

CREATE TABLE TMT_VENDORS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	DOC_COUNT NUMBER(10) DEFAULT 0
);

CREATE TABLE HISTORY_VENDORS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255),
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	DOC_COUNT NUMBER(10) DEFAULT 0
);

CREATE TABLE TMT_VENDOR_ATTRIBUTES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	MULTI_SELECT VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	WEIGHT NUMBER(5) DEFAULT 0,
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PARENT_NAME VARCHAR2(500),
	INPUT_TYPE NUMBER(5) DEFAULT 3
);

CREATE TABLE VENDOR_REFERENCES (
	ELEMENT_ID VARCHAR2(32),
	VENDOR_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	COMPANY_SIZE VARCHAR2(50),
	CONTACT_NAME VARCHAR2(50),
	CONTACT_PHONE VARCHAR2(25),
	CONTACT_FAX VARCHAR2(25),
	CONTACT_EMAIL VARCHAR2(50),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE TMT_CLIENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	RTF_BITS NUMBER(5) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0
);

CREATE TABLE HISTORY_CLIENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LABEL VARCHAR2(50),
	DESCRIPTION VARCHAR2(4000),
	DEFAULT_FLAG VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DOMAIN_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	CONTACT_NAME VARCHAR2(50),
	OTHER_LOCATION VARCHAR2(255),
	YEAR_IN_BUSINESS NUMBER(10),
	CLIENT_MORE_100_EMPLOYEES NUMBER(10),
	CLIENT_MORE_1000_EMPLOYEES NUMBER(10),
	CLIENT_MORE_10000_EMPLOYEES NUMBER(10),
	NUMBER_EMPLOYEES NUMBER(10),
	ANNUAL_REVENUES NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BILLING_ADDRESS VARCHAR2(255),
	BILLING_PHONE VARCHAR2(25),
	BILLING_FAX VARCHAR2(25),
	BILLING_EMAIL VARCHAR2(50),
	EQUAL_OPPORTUNITY VARCHAR2(1),
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 920,
	REVISION_HISTORY VARCHAR2(255),
	PUBLIC_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	COMPANY_BACKGROUND VARCHAR2(3000),
	OWNERSHIP VARCHAR2(3000),
	SERVICES_OFFERED VARCHAR2(3000),
	SERVICES_SPECIALIZED VARCHAR2(3000),
	INDUSTRIES_SERVED VARCHAR2(3000),
	HIGHLIGHT VARCHAR2(3000),
	LOCATION_SERVED VARCHAR2(3000),
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	RTF_BITS NUMBER(5) DEFAULT 0,
	DOC_COUNT NUMBER(10) DEFAULT 0
);

CREATE TABLE TMT_CLIENT_ATTRIBUTES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	MULTI_SELECT VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	WEIGHT NUMBER(5) DEFAULT 0,
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PARENT_NAME VARCHAR2(500),
	INPUT_TYPE NUMBER(5) DEFAULT 3
);

CREATE TABLE CLIENT_REFERENCES (
	ELEMENT_ID VARCHAR2(32),
	CLIENT_ID VARCHAR2(32),
	COMPANY_NAME VARCHAR2(50),
	ADDRESS VARCHAR2(255),
	PHONE VARCHAR2(25),
	FAX VARCHAR2(25),
	WEBSITE VARCHAR2(255),
	COMPANY_SIZE VARCHAR2(50),
	CONTACT_NAME VARCHAR2(50),
	CONTACT_PHONE VARCHAR2(25),
	CONTACT_FAX VARCHAR2(25),
	CONTACT_EMAIL VARCHAR2(50),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE DOC_RTF (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE HISTORY_DOC_RTF (
	HISTORY_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE PROJECT_STATE_DEF (
	PROJECT_ID VARCHAR2(32),
	ELEMENT_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	STAGE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	ASSIGN_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	GROUP_IDS VARCHAR2(1024),
	GROUP_NAMES VARCHAR2(2048),
	PARTICIPANT_IDS VARCHAR2(2048),
	PARTICIPANT_NAMES VARCHAR2(4000),
	SUBJECT VARCHAR2(255),
	MESSAGE VARCHAR2(2048),
	SECURITY_IDS VARCHAR2(1024),
	SECURITY_NAMES VARCHAR2(1024),
	VARIANCE NUMBER(10)
);

CREATE TABLE PROJECT_STATE_TRG (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	TABLE_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	ELEMENT_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	STAGE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	NOTIFIED_FLAG VARCHAR2(1) DEFAULT '0' NOT NULL,
	REC_USER VARCHAR2(32),
	MESSAGE VARCHAR2(2048)
);

CREATE TABLE LEVEL_TASK_DAY_OF_YEAR (
	PROJECT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	RESOURCE_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	TSK_ASSIGNMENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	DAY_YEAR DATE DEFAULT SYSDATE NOT NULL,
	BIT_FLAG VARCHAR2(1),
	ACTUAL_MIN NUMBER(10) DEFAULT 0 NOT NULL,
	SCHED_MIN NUMBER(10) DEFAULT 0 NOT NULL,
	PARENT_ID VARCHAR2(32) DEFAULT ' ' NOT NULL,
	BIT_SCHED RAW(36) DEFAULT '000000000000000000000000000000000000000000000000000000000000000000000000' NOT NULL,
	ACTUAL_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	TASK_ID VARCHAR2(32)
);

CREATE TABLE PROJECT_DISCOUNT (
	ELEMENT_ID VARCHAR2(32),
	PROJECT_ID VARCHAR2(32),
	DISCOUNT_DATE DATE,
	DISCOUNT_PERCENT NUMBER(17,3) DEFAULT 0.000 NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	REC_USER VARCHAR2(32)
);

CREATE TABLE TMT_RESOURCE_DOCUMENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024) DEFAULT 'CREATED',
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 0,
	STAGE_ID NUMBER(10) DEFAULT 4852,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL
);

CREATE TABLE HISTORY_RESOURCE_DOCUMENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024),
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 0,
	STAGE_ID NUMBER(10) DEFAULT 48524852,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHEMENT VARCHAR2(512),
	BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE TMT_SCORECARDS_DEF_WBS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(1000),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(1000),
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	DEFAULT_ANSWER VARCHAR2(1) DEFAULT '0' NOT NULL,
	ANSWER_DESCRIPTION VARCHAR2(4000),
	PROBABILITY_TYPE NUMBER(5) DEFAULT 0,
	PROBABILITY_TYPE_CHANGED NUMBER(5) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE TMT_SCORECARDS_DEF_CRI (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(1000),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(1000),
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	DEFAULT_ANSWER VARCHAR2(1) DEFAULT '0' NOT NULL,
	ANSWER_DESCRIPTION VARCHAR2(4000),
	PROBABILITY_TYPE NUMBER(5) DEFAULT 0,
	PROBABILITY_TYPE_CHANGED NUMBER(5) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE TMT_ASSIGNED_SCORECARDS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	PROJECT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	RANK VARCHAR2(128) NOT NULL,
	PARENT_RANK VARCHAR2(192),
	PARENT_TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 4874,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	DESCRIPTION VARCHAR2(255),
	ORIGINAL_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	CREATION_DATE DATE DEFAULT SYSDATE,
	PUBLISHED_DT TIMESTAMP,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	STAGE_ID NUMBER(10) DEFAULT 5531,
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	ASSIGN_NAMES VARCHAR2(2048),
	SCOPE_SCORE NUMBER(19) DEFAULT 0,
	SCOPE_WEIGHT NUMBER(19) DEFAULT 0,
	SCHEDULE_SCORE NUMBER(19) DEFAULT 0,
	SCHEDULE_WEIGHT NUMBER(19) DEFAULT 0,
	QUALITY_SCORE NUMBER(19) DEFAULT 0,
	QUALITY_WEIGHT NUMBER(19) DEFAULT 0,
	COST_SCORE NUMBER(19) DEFAULT 0,
	COST_WEIGHT NUMBER(19) DEFAULT 0,
	BENEFIT_SCORE NUMBER(19) DEFAULT 0,
	BENEFIT_WEIGHT NUMBER(19) DEFAULT 0,
	ROLLUP_BITS NUMBER(10) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE HISTORY_ASSIGNED_SCORECARDS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	PROJECT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	RANK VARCHAR2(128) NOT NULL,
	PARENT_RANK VARCHAR2(192),
	PARENT_TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_TYPE NUMBER(10) DEFAULT 4874,
	REVISION_HISTORY VARCHAR2(255) DEFAULT 'CREATED',
	DESCRIPTION VARCHAR2(255),
	ORIGINAL_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	LAST_CHECKIN TIMESTAMP,
	CREATION_DATE DATE DEFAULT SYSDATE,
	PUBLISHED_DT TIMESTAMP,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	STAGE_ID NUMBER(10) DEFAULT 5531,
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	ASSIGN_NAMES VARCHAR2(2048),
	SCOPE_SCORE NUMBER(19) DEFAULT 0,
	SCOPE_WEIGHT NUMBER(19) DEFAULT 0,
	SCHEDULE_SCORE NUMBER(19) DEFAULT 0,
	SCHEDULE_WEIGHT NUMBER(19) DEFAULT 0,
	QUALITY_SCORE NUMBER(19) DEFAULT 0,
	QUALITY_WEIGHT NUMBER(19) DEFAULT 0,
	COST_SCORE NUMBER(19) DEFAULT 0,
	COST_WEIGHT NUMBER(19) DEFAULT 0,
	BENEFIT_SCORE NUMBER(19) DEFAULT 0,
	BENEFIT_WEIGHT NUMBER(19) DEFAULT 0,
	ROLLUP_BITS NUMBER(10) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE TMT_PUBLISHED_SCORECARDS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	PROJECT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(1000),
	PARENT_ID VARCHAR2(32),
	CREATED_BY VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	PARENT_RANK VARCHAR2(192),
	DESCRIPTION VARCHAR2(1000),
	ORIGINAL_ID VARCHAR2(32),
	SCORECARD_ID VARCHAR2(32),
	CATEGORY_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	SELECTED_ANSWER VARCHAR2(1) DEFAULT 'N',
	PUBLISHED_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	ANSWER_DESCRIPTION VARCHAR2(4000),
	SCOPE_SCORE NUMBER(19) DEFAULT 0,
	SCOPE_WEIGHT NUMBER(19) DEFAULT 0,
	SCHEDULE_SCORE NUMBER(19) DEFAULT 0,
	SCHEDULE_WEIGHT NUMBER(19) DEFAULT 0,
	QUALITY_SCORE NUMBER(19) DEFAULT 0,
	QUALITY_WEIGHT NUMBER(19) DEFAULT 0,
	COST_SCORE NUMBER(19) DEFAULT 0,
	COST_WEIGHT NUMBER(19) DEFAULT 0,
	BENEFIT_SCORE NUMBER(19) DEFAULT 0,
	BENEFIT_WEIGHT NUMBER(19) DEFAULT 0,
	PROBABILITY_TYPE NUMBER(5) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE HISTORY_PUBLISHED_SCORECARDS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	PROJECT_ID VARCHAR2(32),
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(1000),
	PARENT_ID VARCHAR2(32),
	CREATED_BY VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'U' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	PARENT_RANK VARCHAR2(192),
	DESCRIPTION VARCHAR2(1000),
	ORIGINAL_ID VARCHAR2(32),
	SCORECARD_ID VARCHAR2(32),
	CATEGORY_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	SELECTED_ANSWER VARCHAR2(1) DEFAULT 'N',
	PUBLISHED_DT TIMESTAMP,
	MAJOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	ANSWER_DESCRIPTION VARCHAR2(4000),
	SCOPE_SCORE NUMBER(19) DEFAULT 0,
	SCOPE_WEIGHT NUMBER(19) DEFAULT 0,
	SCHEDULE_SCORE NUMBER(19) DEFAULT 0,
	SCHEDULE_WEIGHT NUMBER(19) DEFAULT 0,
	QUALITY_SCORE NUMBER(19) DEFAULT 0,
	QUALITY_WEIGHT NUMBER(19) DEFAULT 0,
	COST_SCORE NUMBER(19) DEFAULT 0,
	COST_WEIGHT NUMBER(19) DEFAULT 0,
	BENEFIT_SCORE NUMBER(19) DEFAULT 0,
	BENEFIT_WEIGHT NUMBER(19) DEFAULT 0,
	PROBABILITY_TYPE NUMBER(5) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE CLIENT_RTF (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE HISTORY_CLIENT_RTF (
	HISTORY_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE ASSET_RTF (
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE HISTORY_ASSET_RTF (
	HISTORY_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	BIT_FLAG NUMBER(5) NOT NULL,
	PARENT_ID VARCHAR2(32),
	CLOB_DATA CLOB DEFAULT EMPTY_CLOB()
);

CREATE TABLE TMT_ASSET_DOCUMENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024) DEFAULT 'CREATED',
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL
);

CREATE TABLE HISTORY_ASSET_DOCUMENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024),
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHEMENT VARCHAR2(512),
	BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE TMT_CLIENT_DOCUMENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024) DEFAULT 'CREATED',
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL
);

CREATE TABLE HISTORY_CLIENT_DOCUMENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024),
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHEMENT VARCHAR2(512),
	BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE TMT_VENDOR_DOCUMENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024) DEFAULT 'CREATED',
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL
);

CREATE TABLE HISTORY_VENDOR_DOCUMENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024),
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHEMENT VARCHAR2(512),
	BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE TMT_POOL_DOCUMENTS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024) DEFAULT 'CREATED',
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL
);

CREATE TABLE HISTORY_POOL_DOCUMENTS (
	HISTORY_ID VARCHAR2(32),
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(19) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	ELEMENT_NUMBER NUMBER(19),
	PROJECT_ID VARCHAR2(32),
	BLOB_ID VARCHAR2(32),
	PARENT_ID VARCHAR2(32),
	PARENT_TYPE_ID NUMBER(5) DEFAULT 0 NOT NULL,
	AUTHOR_ID VARCHAR2(32),
	CREATION_DATE DATE DEFAULT SYSDATE,
	APPROVED_DATE DATE,
	REF_NUMBER VARCHAR2(50),
	AUTHOR_CHECKOUT VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	PUBLISHED_DT TIMESTAMP,
	MINOR_REVISION NUMBER(5) DEFAULT 1 NOT NULL,
	MAJOR_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REVISION NUMBER(5) DEFAULT 0 NOT NULL,
	MAX_REV_REACHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHED_ID VARCHAR2(32),
	LAST_WF_TYPE VARCHAR2(110),
	LAST_WF_BY VARCHAR2(50),
	LAST_WF_DT TIMESTAMP,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(192),
	PARENT_RANK VARCHAR2(192),
	KEYWORDS VARCHAR2(255),
	LAST_CHECKIN TIMESTAMP,
	REVISION_TYPE NUMBER(10) DEFAULT 4768,
	REVISION_IMPACT NUMBER(10) DEFAULT 137,
	REVISION_HISTORY VARCHAR2(1024),
	SCORECARD_ID VARCHAR2(32),
	SCORE NUMBER(5) DEFAULT 0,
	WEIGHT NUMBER(5) DEFAULT 1,
	CONVERTED_SCORE NUMBER(19) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 1,
	ACTIVE VARCHAR2(1) DEFAULT '1' NOT NULL,
	LOCAL_FOLDER VARCHAR2(550),
	RTF_BITS NUMBER(5) DEFAULT 0,
	PRIORITY NUMBER(5) DEFAULT 500,
	SCOPE_RANK_ID NUMBER(5) DEFAULT 5427,
	STAGE_ID NUMBER(10) DEFAULT 4953,
	TEMP_FOLDER VARCHAR2(550),
	LOCAL_MACHINE VARCHAR2(550),
	DOCUMENT_SIZE NUMBER(10) DEFAULT 0,
	COMPRESSED_SIZE NUMBER(10) DEFAULT 0,
	PUBLISHED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ASSIGN_NAMES VARCHAR2(2048),
	SUMMARY VARCHAR2(1024),
	PREVIOUS_WKF_STEP VARCHAR2(150),
	PRIVATE VARCHAR2(1) DEFAULT 'N',
	VISIBLE_AT_PARENT VARCHAR2(1) DEFAULT 'Y',
	LINK_DOC VARCHAR2(1) DEFAULT 'N' NOT NULL,
	ATTACHEMENT VARCHAR2(512),
	BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);

CREATE TABLE PROJECT_DETAILS (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	PROJECT_RTF_BITS NUMBER(10) DEFAULT -1,
	DELIVERABLE_RTF_BITS NUMBER(10) DEFAULT -1,
	WORK_PRODUCT_RTF_BITS NUMBER(10) DEFAULT -1,
	SUMMARY_TASK_RTF_BITS NUMBER(10) DEFAULT -1,
	MILESTONE_RTF_BITS NUMBER(10) DEFAULT -1,
	TASK_RTF_BITS NUMBER(10) DEFAULT -1,
	REQUIREMENT_RTF_BITS NUMBER(10) DEFAULT -1,
	CHANGE_REQUEST_RTF_BITS NUMBER(10) DEFAULT -1,
	SERVICE_REQUEST_RTF_BITS NUMBER(10) DEFAULT -1,
	DEFECT_RTF_BITS NUMBER(10) DEFAULT -1,
	ISSUE_RTF_BITS NUMBER(10) DEFAULT -1,
	RISK_RTF_BITS NUMBER(10) DEFAULT -1,
	CRI_DELIVERABLE_RTF_BITS NUMBER(10) DEFAULT -1,
	CRI_SUMMARY_TASK_RTF_BITS NUMBER(10) DEFAULT -1,
	CRI_MILESTONE_RTF_BITS NUMBER(10) DEFAULT -1,
	CRI_TASK_RTF_BITS NUMBER(10) DEFAULT -1,
	DOCUMENT_RTF_BITS NUMBER(10) DEFAULT -1,
	ACTIONITEM_RTF_BITS NUMBER(10) DEFAULT -1,
	URL_1 VARCHAR2(512),
	URL_2 VARCHAR2(512),
	URL_3 VARCHAR2(512),
	URL_4 VARCHAR2(512),
	URL_5 VARCHAR2(512),
	BUDGET_SETTING_BITS NUMBER(10) DEFAULT 2,
	TIMEPHASE_PROJECT_ASSIGNMENT VARCHAR2(1) DEFAULT 'N',
	NOTEMIN_RTF_BITS NUMBER(10) DEFAULT -1,
	SCORECARD_RTF_BITS NUMBER(10) DEFAULT -1,
	LEVEL_MOVE_PROJ NUMBER(10) DEFAULT 0,
	LEVEL_START_FINISH_DATE DATE,
	ENABLE_EV_CALCULATION NUMBER(10) DEFAULT 0,
	CHARGEBACK_FORMULA NUMBER(5) DEFAULT 0,
	ROLLUP_PROJECT_ESTIMATED NUMBER(5) DEFAULT 0,
	ROLLUP_DELIVERABLE_ESTIMATED NUMBER(5) DEFAULT 0,
	NOTIFY_TM_REJECTED VARCHAR2(1) DEFAULT 'N',
	NOTIFY_TM_ACCEPTED VARCHAR2(1) DEFAULT 'N',
	NOTIFY_PM_SUBMITTED VARCHAR2(1) DEFAULT 'N',
	NOTIFY_RM_SUBMITTED VARCHAR2(1) DEFAULT 'N',
	ASSIGNMENT_BILLABLE_FLAG NUMBER(5) DEFAULT 0,
	NOTIFY_RM_ACCEPTED VARCHAR2(1) DEFAULT 'N' NOT NULL,
	SCOPE_SCORE NUMBER(19) DEFAULT 0,
	SCOPE_WEIGHT NUMBER(19) DEFAULT 0,
	SCHEDULE_SCORE NUMBER(19) DEFAULT 0,
	SCHEDULE_WEIGHT NUMBER(19) DEFAULT 0,
	QUALITY_SCORE NUMBER(19) DEFAULT 0,
	QUALITY_WEIGHT NUMBER(19) DEFAULT 0,
	BENEFIT_SCORE NUMBER(19) DEFAULT 0,
	BENEFIT_WEIGHT NUMBER(19) DEFAULT 0,
	COST_SCORE NUMBER(19) DEFAULT 0,
	COST_WEIGHT NUMBER(19) DEFAULT 0,
	LEVEL_LOCK NUMBER(10) DEFAULT 0,
	CALCULATE_FLAG NUMBER(5) DEFAULT 0,
	ROLLUP_FLAG NUMBER(5) DEFAULT 0,
	COPY_CRI_CONSIDER_ASSIGNMENTS VARCHAR2(1) DEFAULT 'Y' NOT NULL,
	COPY_CRI_ADOPT_PARTICIPANTS VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PROJECT_RTF_BITS2 NUMBER(10) DEFAULT -1
);

CREATE TABLE TIMEPHASED_DELTA (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	CHARGECODE_ID VARCHAR2(32) NOT NULL,
	BUDGET_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	BUDGET_YEAR NUMBER(5) DEFAULT 0 NOT NULL,
	MONTH_01_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_02_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_03_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_04_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_05_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_06_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_07_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_08_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_09_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_10_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_11_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_12_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	PROCESS_FLAG VARCHAR2(1) DEFAULT 'I'
);

CREATE TABLE TIMEPHASED_PROJECT (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	FLAG VARCHAR2(1) DEFAULT 'I' NOT NULL
);

CREATE TABLE TMT_COST_CENTERS (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(50),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(2048)
);

CREATE TABLE PROJECT_COSTBACK (
	COSTBACK_ID VARCHAR2(32) NOT NULL,
	PROJECT_ID VARCHAR2(32) NOT NULL,
	COST_CENTER_ID VARCHAR2(32) NOT NULL,
	LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	LABOR_FLAG NUMBER(5) DEFAULT 0,
	EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	EXPENSE_FLAG NUMBER(5) DEFAULT 0,
	CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CAPITAL_FLAG NUMBER(5) DEFAULT 0,
	BASELINE1_LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE1_CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_LABOR_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_LABOR_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_EXPENSE_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_EXPENSE_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_CAPITAL_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_CAPITAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	CREATED_BY VARCHAR2(32) NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP
);

CREATE TABLE PROJECT_CHARGEBACK (
	CHARGEBACK_ID VARCHAR2(32) NOT NULL,
	PROJECT_ID VARCHAR2(32) NOT NULL,
	CLIENT_ID VARCHAR2(32) NOT NULL,
	BENEFIT_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BENEFIT_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BENEFIT_FLAG NUMBER(5) DEFAULT 0,
	BASELINE1_BENEFIT_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE1_BENEFIT_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE2_BENEFIT_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE2_BENEFIT_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	BASELINE3_BENEFIT_PERCENT NUMBER(10) DEFAULT 0 NOT NULL,
	BASELINE3_BENEFIT_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TIMEPHASED_FLAG NUMBER(5) DEFAULT 0 NOT NULL,
	CREATED_BY VARCHAR2(32) NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP,
	PAID_TODATE NUMBER(18,2) DEFAULT 0.00 NOT NULL
);

CREATE TABLE PROJECT_CHARGEBACK_BREAKDOWN (
	CHARGEBACK_ID VARCHAR2(32) NOT NULL,
	PROJECT_ID VARCHAR2(32) NOT NULL,
	CLIENT_ID VARCHAR2(32) NOT NULL,
	ENTRY_TYPE NUMBER(5) DEFAULT 0 NOT NULL,
	ENTRY_YEAR NUMBER(5) DEFAULT 0 NOT NULL,
	MONTH_01_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_02_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_03_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_04_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_05_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_06_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_07_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_08_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_09_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_10_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_11_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	MONTH_12_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	TOTAL_AMOUNT NUMBER(18,2) DEFAULT 0.00 NOT NULL
);

CREATE TABLE TMT_WBS_ATTRIBUTES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	MULTI_SELECT VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	WEIGHT NUMBER(5) DEFAULT 0,
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PARENT_NAME VARCHAR2(500),
	INPUT_TYPE NUMBER(5) DEFAULT 3
);

CREATE TABLE TMT_CRI_ATTRIBUTES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(255),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	MULTI_SELECT VARCHAR2(1),
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(255),
	WEIGHT NUMBER(5) DEFAULT 0,
	LOCAL VARCHAR2(1) DEFAULT 'N' NOT NULL,
	PARENT_NAME VARCHAR2(500),
	INPUT_TYPE NUMBER(5) DEFAULT 3
);

CREATE TABLE FISCAL_CALENDAR (
	FISCAL_YEAR NUMBER(5),
	FISCAL_MONTH NUMBER(5),
	START_DATE DATE,
	FINISH_DATE DATE
);

CREATE TABLE RM_ASSIGNMENTS (
	PROJECT_ID VARCHAR2(32),
	PROFILE_ID VARCHAR2(32),
	MANAGER_ID VARCHAR2(32),
	SECURITY_ID CHAR(32),
	RESOURCE_ID VARCHAR2(32),
	ACCEPTED VARCHAR2(1) DEFAULT '0' NOT NULL,
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT '0' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	START_DT TIMESTAMP,
	FINISH_DT TIMESTAMP,
	EFFORT NUMBER(10) DEFAULT 0,
	WORK NUMBER(10) DEFAULT 0,
	BITFLAG NUMBER(5) DEFAULT 0,
	T_UNIT NUMBER(5) DEFAULT 0,
	C_UNIT NUMBER(5) DEFAULT 0,
	C_OCCURRENCE NUMBER(5) DEFAULT 0,
	C_CONTOUR NUMBER(5) DEFAULT 0,
	ROLE_IDS VARCHAR2(4000),
	SKILL_IDS VARCHAR2(4000),
	CONSIDER NUMBER(5) DEFAULT 7 NOT NULL
);

CREATE TABLE TMT_SCORECARDS_DEF_RES (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(1000),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(1000),
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	DEFAULT_ANSWER VARCHAR2(1) DEFAULT '0' NOT NULL,
	ANSWER_DESCRIPTION VARCHAR2(4000),
	PROBABILITY_TYPE NUMBER(5) DEFAULT 0,
	PROBABILITY_TYPE_CHANGED NUMBER(5) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE ALERT_MSG_PREDEF_COLUMN (
	ALERT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_NAME VARCHAR2(50),
	TABLE_NAME VARCHAR2(50),
	COLUMN_NAME VARCHAR2(50),
	COLUMN_TYPE VARCHAR2(50),
	FORMAT VARCHAR2(10),
	COLUMN_LOCATION NUMBER(5) DEFAULT 0,
	TYPE_ID NUMBER(10),
	REC_USER VARCHAR2(32),
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP
);

CREATE TABLE TMT_SCORECARDS_DEF_AST (
	LEVEL_ID NUMBER(10) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	MAX_RANK NUMBER(10) DEFAULT 0 NOT NULL,
	CHILD_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	DELETED_COUNT NUMBER(10) DEFAULT 0 NOT NULL,
	ELEMENT_ID VARCHAR2(32),
	ELEMENT_NAME VARCHAR2(1000),
	PARENT_ID VARCHAR2(32),
	REC_USER VARCHAR2(32),
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP NOT NULL,
	RANK VARCHAR2(128) NOT NULL,
	DESCRIPTION VARCHAR2(1000),
	WEIGHT NUMBER(5) DEFAULT 0,
	CONVERTED_WEIGHT NUMBER(19) DEFAULT 0,
	DEFAULT_ANSWER VARCHAR2(1) DEFAULT '0' NOT NULL,
	ANSWER_DESCRIPTION VARCHAR2(4000),
	PROBABILITY_TYPE NUMBER(5) DEFAULT 0,
	PROBABILITY_TYPE_CHANGED NUMBER(5) DEFAULT 0,
	REPORT_FLAG NUMBER(5) DEFAULT 0
);

CREATE TABLE ASSET_CROSS_CHARGE (
	CROSS_CHARGE_ID VARCHAR2(32) NOT NULL,
	ASSET_ID VARCHAR2(32) NOT NULL,
	PROJECT_CLIENT_ID VARCHAR2(32) NOT NULL,
	QUANTITY NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ASSET_CHARGE_TYPE NUMBER(10) DEFAULT 6601 NOT NULL,
	START_DATE DATE,
	FINISH_DATE DATE,
	UNIT_PRICE NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_BUDGET NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_ACTUAL NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	ESTIMATED_PAID NUMBER(18,2) DEFAULT 0.00 NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'O' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP
);

CREATE TABLE PMO_DEFAULTS (
	PROJECT_ID VARCHAR2(32) NOT NULL,
	ELEMENT_ID VARCHAR2(32) NOT NULL,
	TYPE_ID NUMBER(10) DEFAULT 0 NOT NULL,
	REC_USER VARCHAR2(32) NOT NULL,
	REC_STATUS VARCHAR2(1) DEFAULT 'I' NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT SYSTIMESTAMP
);

CREATE TABLE TRACE_PROCS (
	PROC_NAME VARCHAR2(128),
	TRACE_FLAGS NUMBER(10) DEFAULT 0 NOT NULL
);
-- 135 Tables Translated.

CREATE TABLE EmptyLOB
(
   CLOB_DATA CLOB DEFAULT EMPTY_CLOB(),
   BLOB_DATA BLOB DEFAULT EMPTY_BLOB()
);
